/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(Q){for(var e=[],v=0,R=Q.length;v<R;v++)e[v]=pe[Q[v]];return e};define(pe[49],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(pe[68],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(s){const I=[];for(let a in s)v.call(s,a)&&I.push(s[a]);return I}e.values=R;function k(s,I){for(let a in s)if(v.call(s,a)&&I({key:a,value:s[a]},function(){delete s[a]})===!1)return}e.forEach=k;function y(s,I){const a=Object.create(null);for(const g of s){const c=I(g);let h=a[c];h||(h=a[c]=[]),h.push(g)}return a}e.groupBy=y;function A(s){const I=Object.create(null);return s&&s.forEach((a,g)=>{I[g]=a}),I}e.fromMap=A;function C(s,I){const a=[],g=[];for(let c of s)I.has(c)||a.push(c);for(let c of I)s.has(c)||g.push(c);return{removed:a,added:g}}e.diffSets=C;function D(s,I){const a=[],g=[];for(let[c,h]of s)I.has(c)||a.push(h);for(let[c,h]of I)s.has(c)||g.push(h);return{removed:a,added:g}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(I,a){let g=this.map.get(I);g||(g=new Set,this.map.set(I,g)),g.add(a)}delete(I,a){const g=this.map.get(I);!g||(g.delete(a),g.size===0&&this.map.delete(I))}forEach(I,a){const g=this.map.get(I);!g||g.forEach(a)}}e.SetMap=P}),define(pe[50],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(A){return(C,D,P)=>{let s=null,I=null;if(typeof P.value=="function"?(s="value",I=P.value):typeof P.get=="function"&&(s="get",I=P.get),!I)throw new Error("not supported");P[s]=A(I,D)}}e.createDecorator=v;function R(A,C,D){let P=null,s=null;if(typeof D.value=="function"?(P="value",s=D.value,s.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",s=D.get),!s)throw new Error("not supported");const I=`$memoize$${C}`;D[P]=function(...a){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:s.apply(this,a)}),this[I]}}e.memoize=R;function k(A,C,D){return v((P,s)=>{const I=`$debounce$${s}`,a=`$debounce$result$${s}`;return function(...g){this[a]||(this[a]=D?D():void 0),clearTimeout(this[I]),C&&(this[a]=C(this[a],...g),g=[this[a]]),this[I]=setTimeout(()=>{P.apply(this,g),this[a]=D?D():void 0},A)}})}e.debounce=k;function y(A,C,D){return v((P,s)=>{const I=`$throttle$timer$${s}`,a=`$throttle$result$${s}`,g=`$throttle$lastRun$${s}`,c=`$throttle$pending$${s}`;return function(...h){if(this[a]||(this[a]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[a]=C(this[a],...h)),this[c])return;const S=this[g]+A;S<=Date.now()?(this[g]=Date.now(),P.apply(this,[this[a]]),this[a]=D?D():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[g]=Date.now(),P.apply(this,[this[a]]),this[a]=D?D():void 0},S-Date.now()))}})}e.throttle=y}),define(pe[16],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function k(f){D(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=k;function y(f){D(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=y;function A(f){if(f instanceof Error){let{name:t,message:n}=f;const i=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:i}}return f}e.transformErrorForSerialization=A;const C="Canceled";function D(f){return f instanceof Error&&f.name===C&&f.message===C}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function s(){const f=new Error(C);return f.name=f.message,f}e.canceled=s;function I(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=I;function a(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=a;function g(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function c(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function h(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=h;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function u(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function d(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=d}),define(pe[17],ve([0,1,16]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,F=0){return N[N.length-(1+F)]}e.tail=R;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function y(N,F,M=(U,x)=>U===x){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let U=0,x=N.length;U<x;U++)if(!M(N[U],F[U]))return!1;return!0}e.equals=y;function A(N,F,M){let U=0,x=N.length-1;for(;U<=x;){const K=(U+x)/2|0,se=M(N[K],F);if(se<0)U=K+1;else if(se>0)x=K-1;else return K}return-(U+1)}e.binarySearch=A;function C(N,F){let M=0,U=N.length;if(U===0)return 0;for(;M<U;){const x=Math.floor((M+U)/2);F(N[x])?U=x:M=x+1}return M}e.findFirstInSorted=C;function D(N,F,M){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let U=F[Math.floor(F.length*Math.random())],x=[],K=[],se=[];for(let be of F){const Te=M(be,U);Te<0?x.push(be):Te>0?K.push(be):se.push(be)}return N<x.length?D(N,x,M):N<x.length+se.length?se[0]:D(N-(x.length+se.length),K,M)}e.quickSelect=D;function P(N,F){const M=[];let U;for(const x of N.slice(0).sort(F))!U||F(U[0],x)!==0?(U=[x],M.push(U)):U.push(x);return M}e.groupBy=P;function s(N,F,M){const U=[];function x(be,Te,Ce){if(Te===0&&Ce.length===0)return;const Fe=U[U.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Te,Fe.toInsert.push(...Ce)):U.push({start:be,deleteCount:Te,toInsert:Ce})}let K=0,se=0;for(;;){if(K===N.length){x(K,0,F.slice(se));break}if(se===F.length){x(K,N.length-K,[]);break}const be=N[K],Te=F[se],Ce=M(be,Te);Ce===0?(K+=1,se+=1):Ce<0?(x(K,1,[]),K+=1):Ce>0&&(x(K,0,[Te]),se+=1)}return U}e.sortedDiff=s;function I(N,F,M){const U=s(N,F,M),x=[],K=[];for(const se of U)x.push(...N.slice(se.start,se.start+se.deleteCount)),K.push(...se.toInsert);return{removed:x,added:K}}e.delta=I;function a(N,F,M){if(M===0)return[];const U=N.slice(0,M).sort(F);return c(N,F,U,M,N.length),U}e.top=a;function g(N,F,M,U,x){return M===0?Promise.resolve([]):new Promise((K,se)=>{(async()=>{const be=N.length,Te=N.slice(0,M).sort(F);for(let Ce=M,Fe=Math.min(M+U,be);Ce<be;Ce=Fe,Fe=Math.min(Fe+U,be)){if(Ce>M&&await new Promise(qe=>setTimeout(qe)),x&&x.isCancellationRequested)throw v.canceled();c(N,F,Te,Ce,Fe)}return Te})().then(K,se)})}e.topAsync=g;function c(N,F,M,U,x){for(const K=M.length;U<x;U++){const se=N[U];if(F(se,M[K-1])<0){M.pop();const be=C(M,Te=>F(se,Te)<0);M.splice(be,0,se)}}}function h(N){return N.filter(F=>!!F)}e.coalesce=h;function S(N){let F=0;for(let M=0;M<N.length;M++)N[M]&&(N[F]=N[M],F+=1);N.length=F}e.coalesceInPlace=S;function w(N,F,M){N.splice(M,0,N.splice(F,1)[0])}e.move=w;function _(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=_;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function d(N,F){if(!F)return N.filter((U,x)=>N.indexOf(U)===x);const M=Object.create(null);return N.filter(U=>{const x=F(U);return M[x]?!1:(M[x]=!0,!0)})}e.distinct=d;function f(N){const F=new Set;return N.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=f;function t(N){const F=Object.create(null);return M=>{const U=N(M);return F[U]?!1:(F[U]=!0,!0)}}e.uniqueFilter=t;function n(N,F){for(let M=N.length-1;M>=0;M--){const U=N[M];if(F(U))return M}return-1}e.lastIndex=n;function i(N,F){return N.length>0?N[0]:F}e.firstOrDefault=i;function r(N,F,M=(U,x)=>U===x){let U=0;for(let x=0,K=Math.min(N.length,F.length);x<K&&M(N[x],F[x]);x++)U++;return U}e.commonPrefixLength=r;function o(N){return[].concat(...N)}e.flatten=o;function m(N,F){let M=typeof F=="number"?N:0;typeof F=="number"?M=N:(M=0,F=N);const U=[];if(M<=F)for(let x=M;x<F;x++)U.push(x);else for(let x=M;x>F;x--)U.push(x);return U}e.range=m;function p(N,F,M){return N.reduce((U,x)=>(U[F(x)]=M?M(x):x,U),Object.create(null))}e.index=p;function E(N,F){return N.push(F),()=>b(N,F)}e.insert=E;function b(N,F){const M=N.indexOf(F);if(M>-1)return N.splice(M,1),F}e.remove=b;function l(N,F,M){const U=N.slice(0,F),x=N.slice(F);return U.concat(M,x)}e.arrayInsert=l;function L(N,F){let M;if(typeof F=="number"){let U=F;M=()=>{const x=Math.sin(U++)*179426549;return x-Math.floor(x)}}else M=Math.random;for(let U=N.length-1;U>0;U-=1){const x=Math.floor(M()*(U+1)),K=N[U];N[U]=N[x],N[x]=K}}e.shuffle=L;function O(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.unshift(F))}e.pushToStart=O;function W(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.push(F))}e.pushToEnd=W;function Z(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=Z;function oe(N){return Array.isArray(N)?N:[N]}e.asArray=oe;function V(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=V;function $(N,F){for(const M of N){const U=F(M);if(U!==void 0)return U}}e.mapFind=$;function j(N,F){let M=Number.MAX_SAFE_INTEGER,U=0;return N.forEach((x,K)=>{const se=F(x);se<M&&(M=se,U=K)}),U}e.minIndex=j;function T(N,F){let M=Number.MIN_SAFE_INTEGER,U=0;return N.forEach((x,K)=>{const se=F(x);se>M&&(M=se,U=K)}),U}e.maxIndex=T}),define(pe[69],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const k=this;let y=!1,A;return function(){return y||(y=!0,A=R.apply(k,arguments)),A}}e.once=v}),define(pe[70],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(pe[71],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=k;const y=Object.freeze([]);function A(){return y}R.empty=A;function*C(f){yield f}R.single=C;function D(f){return f||y}R.from=D;function P(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=P;function s(f){return f[Symbol.iterator]().next().value}R.first=s;function I(f,t){for(const n of f)if(t(n))return!0;return!1}R.some=I;function a(f,t){for(const n of f)if(t(n))return n}R.find=a;function*g(f,t){for(const n of f)t(n)&&(yield n)}R.filter=g;function*c(f,t){let n=0;for(const i of f)yield t(i,n++)}R.map=c;function*h(...f){for(const t of f)for(const n of t)yield n}R.concat=h;function*S(f){for(const t of f)for(const n of t)yield n}R.concatNested=S;function w(f,t,n){let i=n;for(const r of f)i=t(i,r);return i}R.reduce=w;function*_(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}R.slice=_;function u(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const i=f[Symbol.iterator]();for(let r=0;r<t;r++){const o=i.next();if(o.done)return[n,R.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return i}}]}R.consume=u;function d(f,t,n=(i,r)=>i===r){const i=f[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const o=i.next(),m=r.next();if(o.done!==m.done)return!1;if(o.done)return!0;if(!n(o.value,m.value))return!1}}R.equals=d})(v=e.Iterable||(e.Iterable={}))}),define(pe[51],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function A(t,n=!1){let i=0,r=t.length,o="",m=0,p=16,E=0;function b(V){let $=0,j=0;for(;$<V;){const T=t.charCodeAt(i);if(T>=48&&T<=57)j=j*16+T-48;else if(T>=65&&T<=70)j=j*16+T-65+10;else if(T>=97&&T<=102)j=j*16+T-97+10;else break;i++,$++}return $<V&&(j=-1),j}function l(V){i=V,o="",m=0,p=16,E=0}function L(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&P(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&P(t.charCodeAt(i)))for(i++;i<t.length&&P(t.charCodeAt(i));)i++;else return E=3,t.substring(V,i);let $=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&P(t.charCodeAt(i))){for(i++;i<t.length&&P(t.charCodeAt(i));)i++;$=i}else E=3;return t.substring(V,$)}function O(){let V="",$=i;for(;;){if(i>=r){V+=t.substring($,i),E=2;break}const j=t.charCodeAt(i);if(j===34){V+=t.substring($,i),i++;break}if(j===92){if(V+=t.substring($,i),i++,i>=r){E=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const N=b(4);N>=0?V+=String.fromCharCode(N):E=4;break;default:E=5}$=i;continue}if(j>=0&&j<=31)if(D(j)){V+=t.substring($,i),E=2;break}else E=6;i++}return V}function W(){if(o="",E=0,m=i,i>=r)return m=r,p=17;let V=t.charCodeAt(i);if(C(V)){do i++,o+=String.fromCharCode(V),V=t.charCodeAt(i);while(C(V));return p=15}if(D(V))return i++,o+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),p=14;switch(V){case 123:return i++,p=1;case 125:return i++,p=2;case 91:return i++,p=3;case 93:return i++,p=4;case 58:return i++,p=6;case 44:return i++,p=5;case 34:return i++,o=O(),p=10;case 47:const $=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!D(t.charCodeAt(i));)i++;return o=t.substring($,i),p=12}if(t.charCodeAt(i+1)===42){i+=2;const j=r-1;let T=!1;for(;i<j;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,T=!0;break}i++}return T||(i++,E=1),o=t.substring($,i),p=13}return o+=String.fromCharCode(V),i++,p=16;case 45:if(o+=String.fromCharCode(V),i++,i===r||!P(t.charCodeAt(i)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),p=11;default:for(;i<r&&Z(V);)i++,V=t.charCodeAt(i);if(m!==i){switch(o=t.substring(m,i),o){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return o+=String.fromCharCode(V),i++,p=16}}function Z(V){if(C(V)||D(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let V;do V=W();while(V>=12&&V<=15);return V}return{setPosition:l,getPosition:()=>i,scan:n?oe:W,getToken:()=>p,getTokenValue:()=>o,getTokenOffset:()=>m,getTokenLength:()=>i-m,getTokenError:()=>E}}e.createScanner=A;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function I(t,n){const i=[],r=new Object;let o;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function E(b,l,L,O){m.value=b,m.offset=l,m.length=L,m.type=O,m.colonOffset=void 0,o=m}try{u(t,{onObjectBegin:(b,l)=>{if(n<=b)throw r;o=void 0,p=n>b,i.push("")},onObjectProperty:(b,l,L)=>{if(n<l||(E(b,l,L,"property"),i[i.length-1]=b,n<=l+L))throw r},onObjectEnd:(b,l)=>{if(n<=b)throw r;o=void 0,i.pop()},onArrayBegin:(b,l)=>{if(n<=b)throw r;o=void 0,i.push(0)},onArrayEnd:(b,l)=>{if(n<=b)throw r;o=void 0,i.pop()},onLiteralValue:(b,l,L)=>{if(n<l||(E(b,l,L,f(b)),n<=l+L))throw r},onSeparator:(b,l,L)=>{if(n<=l)throw r;if(b===":"&&o&&o.type==="property")o.colonOffset=l,p=!1,o=void 0;else if(b===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(p=!0,i[i.length-1]=""),o=void 0}}})}catch(b){if(b!==r)throw b}return{path:i,previousNode:o,isAtPropertyKey:p,matches:b=>{let l=0;for(let L=0;l<b.length&&L<i.length;L++)if(b[l]===i[L]||b[l]==="*")l++;else if(b[l]!=="**")return!1;return l===b.length}}}e.getLocation=I;function a(t,n=[],i=y.DEFAULT){let r=null,o=[];const m=[];function p(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}return u(t,{onObjectBegin:()=>{const b={};p(b),m.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=m.pop()},onArrayBegin:()=>{const b=[];p(b),m.push(o),o=b,r=null},onArrayEnd:()=>{o=m.pop()},onLiteralValue:p,onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},i),o[0]}e.parse=a;function g(t,n=[],i=y.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function m(b){return r.children.push(b),b}u(t,{onObjectBegin:b=>{r=m({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,l,L)=>{r=m({type:"property",offset:l,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:l,length:L,parent:r})},onObjectEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onArrayBegin:(b,l)=>{r=m({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,l)=>{r.length=b+l-r.offset,r=r.parent,o(b+l)},onLiteralValue:(b,l,L)=>{m({type:f(b),offset:l,length:L,parent:r,value:b}),o(l+L)},onSeparator:(b,l,L)=>{r.type==="property"&&(b===":"?r.colonOffset=l:b===","&&o(l))},onError:(b,l,L)=>{n.push({error:b,offset:l,length:L})}},i);const E=r.children[0];return E&&delete E.parent,E}e.parseTree=g;function c(t,n){if(!t)return;let i=t;for(let r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const m of i.children)if(Array.isArray(m.children)&&m.children[0].value===r){i=m.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=c;function h(t){if(!t.parent||!t.parent.children)return[];const n=h(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=h;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const n=Object.create(null);for(let i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=S(r))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=w;function _(t,n,i=!1){if(w(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const m=_(r[o],n,i);if(m)return m}return t}}e.findNodeAtOffset=_;function u(t,n,i=y.DEFAULT){const r=A(t,!1);function o(se){return se?()=>se(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(se){return se?be=>se(be,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=o(n.onObjectBegin),E=m(n.onObjectProperty),b=o(n.onObjectEnd),l=o(n.onArrayBegin),L=o(n.onArrayEnd),O=m(n.onLiteralValue),W=m(n.onSeparator),Z=o(n.onComment),oe=m(n.onError),V=i&&i.disallowComments,$=i&&i.allowTrailingComma;function j(){for(;;){const se=r.scan();switch(r.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:V||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(se){case 12:case 13:V?T(10):Z();break;case 16:T(1);break;case 15:case 14:break;default:return se}}}function T(se,be=[],Te=[]){if(oe(se),be.length+Te.length>0){let Ce=r.getToken();for(;Ce!==17;){if(be.indexOf(Ce)!==-1){j();break}else if(Te.indexOf(Ce)!==-1)break;Ce=j()}}}function N(se){const be=r.getTokenValue();return se?O(be):E(be),j(),!0}function F(){switch(r.getToken()){case 11:let se=0;try{se=JSON.parse(r.getTokenValue()),typeof se!="number"&&(T(2),se=0)}catch(be){T(2)}O(se);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return j(),!0}function M(){return r.getToken()!==10?(T(3,[],[2,5]),!1):(N(!1),r.getToken()===6?(W(":"),j(),K()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function U(){p(),j();let se=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(se||T(4,[],[]),W(","),j(),r.getToken()===2&&$)break}else se&&T(6,[],[]);M()||T(4,[],[2,5]),se=!0}return b(),r.getToken()!==2?T(7,[2],[]):j(),!0}function x(){l(),j();let se=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(se||T(4,[],[]),W(","),j(),r.getToken()===4&&$)break}else se&&T(6,[],[]);K()||T(4,[],[4,5]),se=!0}return L(),r.getToken()!==4?T(8,[4],[]):j(),!0}function K(){switch(r.getToken()){case 3:return x();case 1:return U();case 10:return N(!0);default:return F()}}return j(),r.getToken()===17?i.allowEmptyContent?!0:(T(4,[],[]),!1):K()?(r.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function d(t,n){let i=A(t),r=[],o,m=0,p;do switch(p=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:m!==p&&r.push(t.substring(m,p)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),m=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=d;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(pe[131],ve([0,1,51]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,P,s){let I,a,g,c,h;if(P){for(c=P.offset,h=c+P.length,g=c;g>0&&!C(D,g-1);)g--;let m=h;for(;m<D.length&&!C(D,m);)m++;a=D.substring(g,m),I=y(a,s)}else a=D,I=0,g=0,c=0,h=D.length;const S=A(s,D);let w=!1,_=0,u;s.insertSpaces?u=k(" ",s.tabSize||4):u="	";const d=v.createScanner(a,!1);let f=!1;function t(){return S+k(u,I+_)}function n(){let m=d.scan();for(w=!1;m===15||m===14;)w=w||m===14,m=d.scan();return f=m===16||d.getTokenError()!==0,m}const i=[];function r(m,p,E){!f&&p<h&&E>c&&D.substring(p,E)!==m&&i.push({offset:p,length:E-p,content:m})}let o=n();if(o!==17){const m=d.getTokenOffset()+g,p=k(u,I);r(p,g,m)}for(;o!==17;){let m=d.getTokenOffset()+d.getTokenLength()+g,p=n(),E="";for(;!w&&(p===12||p===13);){const l=d.getTokenOffset()+g;r(" ",m,l),m=d.getTokenOffset()+d.getTokenLength()+g,E=p===12?t():"",p=n()}if(p===2)o!==1&&(_--,E=t());else if(p===4)o!==3&&(_--,E=t());else{switch(o){case 3:case 1:_++,E=t();break;case 5:case 12:E=t();break;case 13:w?E=t():E=" ";break;case 6:E=" ";break;case 10:if(p===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?E=" ":p!==5&&p!==17&&(f=!0);break;case 16:f=!0;break}w&&(p===12||p===13)&&(E=t())}const b=d.getTokenOffset()+g;r(E,m,b),o=p}return i}e.format=R;function k(D,P){let s="";for(let I=0;I<P;I++)s+=D;return s}function y(D,P){let s=0,I=0;const a=P.tabSize||4;for(;s<D.length;){const g=D.charAt(s);if(g===" ")I++;else if(g==="	")I+=a;else break;s++}return Math.floor(I/a)}function A(D,P){for(let s=0;s<P.length;s++){const I=P.charAt(s);if(I==="\r")return s+1<P.length&&P.charAt(s+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=A;function C(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=C}),define(pe[132],ve([0,1,51,131]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,s,I){return y(P,s,void 0,I)}e.removeProperty=k;function y(P,s,I,a,g){const c=s.slice(),h=[],S=v.parseTree(P,h);let w,_;for(;c.length>0&&(_=c.pop(),w=v.findNodeAtLocation(S,c),w===void 0&&I!==void 0);)typeof _=="string"?I={[_]:I}:I=[I];if(w)if(w.type==="object"&&typeof _=="string"&&Array.isArray(w.children)){const u=v.findNodeAtLocation(w,[_]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const d=w.children.indexOf(u.parent);let f,t=u.parent.offset+u.parent.length;if(d>0){const n=w.children[d-1];f=n.offset+n.length}else f=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(P,{offset:f,length:t-f,content:""},a)}else return A(P,{offset:u.offset,length:u.length,content:JSON.stringify(I)},a);else{if(I===void 0)return[];const d=`${JSON.stringify(_)}: ${JSON.stringify(I)}`,f=g?g(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(f>0){const n=w.children[f-1];t={offset:n.offset+n.length,length:0,content:","+d}}else w.children.length===0?t={offset:w.offset+1,length:0,content:d}:t={offset:w.offset+1,length:0,content:d+","};return A(P,t,a)}}else if(w.type==="array"&&typeof _=="number"&&Array.isArray(w.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let d;if(w.children.length===0||_===0)d={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const f=_===-1||_>w.children.length?w.children.length:_,t=w.children[f-1];d={offset:t.offset+t.length,length:0,content:","+u}}return A(P,d,a)}else{const u=_,d=w.children[u];let f;if(w.children.length===1)f={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],n=t.offset+t.length,i=w.offset+w.length;f={offset:n,length:i-2-n,content:""}}else f={offset:d.offset,length:w.children[u+1].offset-d.offset,content:""};return A(P,f,a)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},a)}}e.setProperty=y;function A(P,s,I){let a=C(P,s),g=s.offset,c=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;g>0&&!R.isEOL(a,g-1);)g--;for(;c<a.length&&!R.isEOL(a,c);)c++}const h=R.format(a,{offset:g,length:c-g},I);for(let w=h.length-1;w>=0;w--){const _=h[w];a=C(a,_),g=Math.min(g,_.offset),c=Math.max(c,_.offset+_.length),c+=_.content.length-_.length}const S=P.length-(a.length-c)-g;return[{offset:g,length:S,content:a.substring(g,c)}]}e.withFormatting=A;function C(P,s){return P.substring(0,s.offset)+s.content+P.substring(s.offset+s.length)}e.applyEdit=C;function D(P,s){let I=s.slice(0).sort((g,c)=>{const h=g.offset-c.offset;return h===0?g.length-c.length:h}),a=P.length;for(let g=I.length-1;g>=0;g--){let c=I[g];if(c.offset+c.length<=a)P=C(P,c);else throw new Error("Overlapping edit");a=c.offset}return P}e.applyEdits=D}),define(pe[133],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(pe[6],ve([0,1,69,71]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let y=null;function A(u){y=u}if(e.setDisposableTracker=A,k){const u="__is_disposable_tracked__";y=new class{trackDisposable(d){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[u]||console.log(f)},3e3)}markTracked(d){if(d&&d!==h.None)try{d[u]=!0}catch(f){}}}}function C(u){!y||y.markTracked(u)}function D(u){return y&&y.trackDisposable(u),u}e.trackDisposable=D;class P extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=P;function s(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=s;function I(u){if(R.Iterable.is(u)){let d=[];for(const f of u)if(f){C(f);try{f.dispose()}catch(t){d.push(t)}}if(d.length===1)throw d[0];if(d.length>1)throw new P(d);return Array.isArray(u)?[]:u}else if(u)return C(u),u.dispose(),u}e.dispose=I;function a(...u){return u.forEach(C),g(()=>I(u))}e.combinedDisposable=a;function g(u){const d=D({dispose:()=>{C(d),u()}});return d}e.toDisposable=g;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return C(d),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new c,D(this)}dispose(){C(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var f;this._isDisposed||d===this._value||((f=this._value)===null||f===void 0||f.dispose(),d&&C(d),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,C(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(d,...f){let t=this.references.get(d);t||(t={counter:0,object:this.createReferencedObject(d,...f)},this.references.set(d,t));const{object:n}=t,i=v.once(()=>{--t.counter==0&&(this.destroyReferencedObject(d,t.object),this.references.delete(d))});return t.counter++,{object:n,dispose:i}}}e.ReferenceCollection=w;class _{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=_}),define(pe[72],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(y){this.element=y,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let y=this._first;for(;y!==v.Undefined;){const A=y.next;y.prev=v.Undefined,y.next=v.Undefined,y=A}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,A){const C=new v(y);if(this._first===v.Undefined)this._first=C,this._last=C;else if(A){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==v.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==v.Undefined&&y.next!==v.Undefined){const A=y.prev;A.next=y.next,y.next.prev=A}else y.prev===v.Undefined&&y.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):y.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):y.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==v.Undefined;)yield y.element,y=y.next}}e.LinkedList=R}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(De,ye){for(var ke=0;ke<ye.length;ke++){var le=ye[ke];le.enumerable=le.enumerable||!1,le.configurable=!0,"value"in le&&(le.writable=!0),Object.defineProperty(De,le.key,le)}}function e(De,ye,ke){return ye&&Q(De.prototype,ye),ke&&Q(De,ke),De}function v(De,ye){if(!!De){if(typeof De=="string")return R(De,ye);var ke=Object.prototype.toString.call(De).slice(8,-1);if(ke==="Object"&&De.constructor&&(ke=De.constructor.name),ke==="Map"||ke==="Set")return Array.from(De);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(De,ye)}}function R(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var ke=0,le=new Array(ye);ke<ye;ke++)le[ke]=De[ke];return le}function k(De,ye){var ke;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(ke=v(De))||ye&&De&&typeof De.length=="number"){ke&&(De=ke);var le=0;return function(){return le>=De.length?{done:!0}:{done:!1,value:De[le++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=De[Symbol.iterator](),ke.next.bind(ke)}function y(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var A=y(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(le){De.exports.defaults=le}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:ke}}),C=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(ye){return I[ye]};function g(De,ye){if(ye){if(C.test(De))return De.replace(D,a)}else if(P.test(De))return De.replace(s,a);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(De){return De.replace(c,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(De,ye){De=De.source||De,ye=ye||"";var ke={replace:function(he,H){return H=H.source||H,H=H.replace(S,"$1"),De=De.replace(he,H),ke},getRegex:function(){return new RegExp(De,ye)}};return ke}var _=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(De,ye,ke){if(De){var le;try{le=decodeURIComponent(h(ke)).replace(_,"").toLowerCase()}catch(he){return null}if(le.indexOf("javascript:")===0||le.indexOf("vbscript:")===0||le.indexOf("data:")===0)return null}ye&&!u.test(ke)&&(ke=r(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(he){return null}return ke}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(De,ye){f[" "+De]||(t.test(De)?f[" "+De]=De+"/":f[" "+De]=E(De,"/",!0)),De=f[" "+De];var ke=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?ke?ye:De.replace(i,"$1")+ye:De+ye}var o={exec:function(){}};function m(De){for(var ye=1,ke,le;ye<arguments.length;ye++){ke=arguments[ye];for(le in ke)Object.prototype.hasOwnProperty.call(ke,le)&&(De[le]=ke[le])}return De}function p(De,ye){var ke=De.replace(/\|/g,function(H,ee,ue){for(var Pe=!1,Ie=ee;--Ie>=0&&ue[Ie]==="\\";)Pe=!Pe;return Pe?"|":" |"}),le=ke.split(/ \|/),he=0;if(le.length>ye)le.splice(ye);else for(;le.length<ye;)le.push("");for(;he<le.length;he++)le[he]=le[he].trim().replace(/\\\|/g,"|");return le}function E(De,ye,ke){var le=De.length;if(le===0)return"";for(var he=0;he<le;){var H=De.charAt(le-he-1);if(H===ye&&!ke)he++;else if(H!==ye&&ke)he++;else break}return De.substr(0,le-he)}function b(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var ke=De.length,le=0,he=0;he<ke;he++)if(De[he]==="\\")he++;else if(De[he]===ye[0])le++;else if(De[he]===ye[1]&&(le--,le<0))return he;return-1}function l(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(De,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=De),ye>>=1,De+=De;return ke+De}var O={escape:g,unescape:h,edit:w,cleanUrl:d,resolveUrl:r,noopTest:o,merge:m,splitCells:p,rtrim:E,findClosingBracket:b,checkSanitizeDeprecation:l,repeatString:L},W=A.defaults,Z=O.rtrim,oe=O.splitCells,V=O.escape,$=O.findClosingBracket;function j(De,ye,ke){var le=ye.href,he=ye.title?V(ye.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:ke,href:le,title:he,text:H}:{type:"image",raw:ke,href:le,title:he,text:V(H)}}function T(De,ye){var ke=De.match(/^(\s+)(?:```)/);if(ke===null)return ye;var le=ke[1];return ye.split(`
`).map(function(he){var H=he.match(/^\s+/);if(H===null)return he;var ee=H[0];return ee.length>=le.length?he.slice(le.length):he}).join(`
`)}var N=function(){function De(ke){this.options=ke||W}var ye=De.prototype;return ye.space=function(le){var he=this.rules.block.newline.exec(le);if(he)return he[0].length>1?{type:"space",raw:he[0]}:{raw:`
`}},ye.code=function(le){var he=this.rules.block.code.exec(le);if(he){var H=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?H:Z(H,`
`)}}},ye.fences=function(le){var he=this.rules.block.fences.exec(le);if(he){var H=he[0],ee=T(H,he[3]||"");return{type:"code",raw:H,lang:he[2]?he[2].trim():he[2],text:ee}}},ye.heading=function(le){var he=this.rules.block.heading.exec(le);if(he){var H=he[2].trim();if(/#$/.test(H)){var ee=Z(H,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(H=ee.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:H}}},ye.nptable=function(le){var he=this.rules.block.nptable.exec(le);if(he){var H={type:"table",header:oe(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[],raw:he[0]};if(H.header.length===H.align.length){var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=oe(H.cells[ue],H.header.length);return H}}},ye.hr=function(le){var he=this.rules.block.hr.exec(le);if(he)return{type:"hr",raw:he[0]}},ye.blockquote=function(le){var he=this.rules.block.blockquote.exec(le);if(he){var H=he[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:he[0],text:H}}},ye.list=function(le){var he=this.rules.block.list.exec(le);if(he){var H=he[0],ee=he[2],ue=ee.length>1,Pe={type:"list",raw:H,ordered:ue,start:ue?+ee.slice(0,-1):"",loose:!1,items:[]},Ie=he[0].match(this.rules.block.item),Ue=!1,xe,Qe,rt,tt,Ye,ot,Et,bt,_e=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var fe=0;fe<_e;fe++){if(xe=Ie[fe],H=xe,fe!==_e-1){if(tt=this.rules.block.listItemStart.exec(Ie[fe+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ie.splice(fe,2,Ie[fe]+`
`+Ie[fe+1]),fe--,_e--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==ee[ee.length-1]:ue===(tt[2].length===1))&&(Ye=Ie.slice(fe+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Ye.length),fe=_e-1);rt=tt}Qe=xe.length,xe=xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~xe.indexOf(`
 `)&&(Qe-=xe.length,xe=this.options.pedantic?xe.replace(/^ {1,4}/gm,""):xe.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=Ue||/\n\n(?!\s*$)/.test(xe),fe!==_e-1&&(Ue=xe.charAt(xe.length-1)===`
`,ot||(ot=Ue)),ot&&(Pe.loose=!0),this.options.gfm&&(Et=/^\[[ xX]\] /.test(xe),bt=void 0,Et&&(bt=xe[1]!==" ",xe=xe.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:H,task:Et,checked:bt,loose:ot,text:xe})}return Pe}},ye.html=function(le){var he=this.rules.block.html.exec(le);if(he)return{type:this.options.sanitize?"paragraph":"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):V(he[0]):he[0]}},ye.def=function(le){var he=this.rules.block.def.exec(le);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var H=he[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:he[0],href:he[2],title:he[3]}}},ye.table=function(le){var he=this.rules.block.table.exec(le);if(he){var H={type:"table",header:oe(he[1].replace(/^ *| *\| *$/g,"")),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:he[3]?he[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=he[0];var ee=H.align.length,ue;for(ue=0;ue<ee;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(ee=H.cells.length,ue=0;ue<ee;ue++)H.cells[ue]=oe(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(le){var he=this.rules.block.lheading.exec(le);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1]}},ye.paragraph=function(le){var he=this.rules.block.paragraph.exec(le);if(he)return{type:"paragraph",raw:he[0],text:he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1]}},ye.text=function(le){var he=this.rules.block.text.exec(le);if(he)return{type:"text",raw:he[0],text:he[0]}},ye.escape=function(le){var he=this.rules.inline.escape.exec(le);if(he)return{type:"escape",raw:he[0],text:V(he[1])}},ye.tag=function(le,he,H){var ee=this.rules.inline.tag.exec(le);if(ee)return!he&&/^<a /i.test(ee[0])?he=!0:he&&/^<\/a>/i.test(ee[0])&&(he=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:he,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):V(ee[0]):ee[0]}},ye.link=function(le){var he=this.rules.inline.link.exec(le);if(he){var H=he[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var ee=Z(H.slice(0,-1),"\\");if((H.length-ee.length)%2==0)return}else{var ue=$(he[2],"()");if(ue>-1){var Pe=he[0].indexOf("!")===0?5:4,Ie=Pe+he[1].length+ue;he[2]=he[2].substring(0,ue),he[0]=he[0].substring(0,Ie).trim(),he[3]=""}}var Ue=he[2],xe="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Qe&&(Ue=Qe[1],xe=Qe[3])}else xe=he[3]?he[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(H)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),j(he,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},he[0])}},ye.reflink=function(le,he){var H;if((H=this.rules.inline.reflink.exec(le))||(H=this.rules.inline.nolink.exec(le))){var ee=(H[2]||H[1]).replace(/\s+/g," ");if(ee=he[ee.toLowerCase()],!ee||!ee.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return j(H,ee,H[0])}},ye.emStrong=function(le,he,H){H===void 0&&(H="");var ee=this.rules.inline.emStrong.lDelim.exec(le);if(!!ee&&!(ee[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=ee[1]||ee[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Pe=ee[0].length-1,Ie,Ue,xe=Pe,Qe=0,rt=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,he=he.slice(-1*le.length+Pe);(ee=rt.exec(he))!=null;)if(Ie=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Ie){if(Ue=Ie.length,ee[3]||ee[4]){xe+=Ue;continue}else if((ee[5]||ee[6])&&Pe%3&&!((Pe+Ue)%3)){Qe+=Ue;continue}if(xe-=Ue,!(xe>0)){if(xe+Qe-Ue<=0&&!he.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+xe+Qe)),Math.min(Pe,Ue)%2)return{type:"em",raw:le.slice(0,Pe+ee.index+Ue+1),text:le.slice(1,Pe+ee.index+Ue)};if(Math.min(Pe,Ue)%2==0)return{type:"strong",raw:le.slice(0,Pe+ee.index+Ue+1),text:le.slice(2,Pe+ee.index+Ue-1)}}}}}},ye.codespan=function(le){var he=this.rules.inline.code.exec(le);if(he){var H=he[2].replace(/\n/g," "),ee=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return ee&&ue&&(H=H.substring(1,H.length-1)),H=V(H,!0),{type:"codespan",raw:he[0],text:H}}},ye.br=function(le){var he=this.rules.inline.br.exec(le);if(he)return{type:"br",raw:he[0]}},ye.del=function(le){var he=this.rules.inline.del.exec(le);if(he)return{type:"del",raw:he[0],text:he[2]}},ye.autolink=function(le,he){var H=this.rules.inline.autolink.exec(le);if(H){var ee,ue;return H[2]==="@"?(ee=V(this.options.mangle?he(H[1]):H[1]),ue="mailto:"+ee):(ee=V(H[1]),ue=ee),{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},ye.url=function(le,he){var H;if(H=this.rules.inline.url.exec(le)){var ee,ue;if(H[2]==="@")ee=V(this.options.mangle?he(H[0]):H[0]),ue="mailto:"+ee;else{var Pe;do Pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Pe!==H[0]);ee=V(H[0]),H[1]==="www."?ue="http://"+ee:ue=ee}return{type:"link",raw:H[0],text:ee,href:ue,tokens:[{type:"text",raw:ee,text:ee}]}}},ye.inlineText=function(le,he,H){var ee=this.rules.inline.text.exec(le);if(ee){var ue;return he?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):V(ee[0]):ee[0]:ue=V(this.options.smartypants?H(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ue}}},De}(),F=O.noopTest,M=O.edit,U=O.merge,x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=M(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,x.item=M(x.item,"gm").replace(/bull/g,x.bullet).getRegex(),x.listItemStart=M(/^( *)(bull)/).replace("bull",x.bullet).getRegex(),x.list=M(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=M(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=M(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.blockquote=M(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=U({},x),x.gfm=U({},x.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.nptable=M(x.gfm.nptable).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.gfm.table=M(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",x._tag).getRegex(),x.pedantic=U({},x.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=M(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=M(x._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=M(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=M(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=M(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=M(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=M(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=M(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=M(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=M(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=U({},K),K.pedantic=U({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=U({},K.normal,{escape:M(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=M(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=U({},K.gfm,{br:M(K.br).replace("{2,}","*").getRegex(),text:M(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var se={block:x,inline:K},be=A.defaults,Te=se.block,Ce=se.inline,Fe=O.repeatString;function qe(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var ye="",ke,le,he=De.length;for(ke=0;ke<he;ke++)le=De.charCodeAt(ke),Math.random()>.5&&(le="x"+le.toString(16)),ye+="&#"+le+";";return ye}var Ge=function(){function De(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||be,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var le={block:Te.normal,inline:Ce.normal};this.options.pedantic?(le.block=Te.pedantic,le.inline=Ce.pedantic):this.options.gfm&&(le.block=Te.gfm,this.options.breaks?le.inline=Ce.breaks:le.inline=Ce.gfm),this.tokenizer.rules=le}De.lex=function(le,he){var H=new De(he);return H.lex(le)},De.lexInline=function(le,he){var H=new De(he);return H.inlineTokens(le)};var ye=De.prototype;return ye.lex=function(le){return le=le.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(le,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(le,he,H){he===void 0&&(he=[]),H===void 0&&(H=!0),this.options.pedantic&&(le=le.replace(/^ +$/gm,""));for(var ee,ue,Pe,Ie;le;){if(ee=this.tokenizer.space(le)){le=le.substring(ee.raw.length),ee.type&&he.push(ee);continue}if(ee=this.tokenizer.code(le)){le=le.substring(ee.raw.length),Ie=he[he.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+ee.raw,Ie.text+=`
`+ee.text):he.push(ee);continue}if(ee=this.tokenizer.fences(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.heading(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.nptable(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.hr(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.blockquote(le)){le=le.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],H),he.push(ee);continue}if(ee=this.tokenizer.list(le)){for(le=le.substring(ee.raw.length),Pe=ee.items.length,ue=0;ue<Pe;ue++)ee.items[ue].tokens=this.blockTokens(ee.items[ue].text,[],!1);he.push(ee);continue}if(ee=this.tokenizer.html(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(H&&(ee=this.tokenizer.def(le))){le=le.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.lheading(le)){le=le.substring(ee.raw.length),he.push(ee);continue}if(H&&(ee=this.tokenizer.paragraph(le))){le=le.substring(ee.raw.length),he.push(ee);continue}if(ee=this.tokenizer.text(le)){le=le.substring(ee.raw.length),Ie=he[he.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+ee.raw,Ie.text+=`
`+ee.text):he.push(ee);continue}if(le){var Ue="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return he},ye.inline=function(le){var he,H,ee,ue,Pe,Ie,Ue=le.length;for(he=0;he<Ue;he++)switch(Ie=le[he],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},ue=Ie.header.length,H=0;H<ue;H++)Ie.tokens.header[H]=[],this.inlineTokens(Ie.header[H],Ie.tokens.header[H]);for(ue=Ie.cells.length,H=0;H<ue;H++)for(Pe=Ie.cells[H],Ie.tokens.cells[H]=[],ee=0;ee<Pe.length;ee++)Ie.tokens.cells[H][ee]=[],this.inlineTokens(Pe[ee],Ie.tokens.cells[H][ee]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(ue=Ie.items.length,H=0;H<ue;H++)this.inline(Ie.items[H].tokens);break}}return le},ye.inlineTokens=function(le,he,H,ee){he===void 0&&(he=[]),H===void 0&&(H=!1),ee===void 0&&(ee=!1);var ue,Pe,Ie=le,Ue,xe,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ue.index)+"["+Fe("a",Ue[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ue.index)+"["+Fe("a",Ue[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ue.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;le;){if(xe||(Qe=""),xe=!1,ue=this.tokenizer.escape(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.tag(le,H,ee)){le=le.substring(ue.raw.length),H=ue.inLink,ee=ue.inRawBlock;var tt=he[he.length-1];tt&&ue.type==="text"&&tt.type==="text"?(tt.raw+=ue.raw,tt.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.link(le)){le=le.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,ee)),he.push(ue);continue}if(ue=this.tokenizer.reflink(le,this.tokens.links)){le=le.substring(ue.raw.length);var Ye=he[he.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,ee),he.push(ue)):Ye&&ue.type==="text"&&Ye.type==="text"?(Ye.raw+=ue.raw,Ye.text+=ue.text):he.push(ue);continue}if(ue=this.tokenizer.emStrong(le,Ie,Qe)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),he.push(ue);continue}if(ue=this.tokenizer.codespan(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.br(le)){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.del(le)){le=le.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,ee),he.push(ue);continue}if(ue=this.tokenizer.autolink(le,ze)){le=le.substring(ue.raw.length),he.push(ue);continue}if(!H&&(ue=this.tokenizer.url(le,ze))){le=le.substring(ue.raw.length),he.push(ue);continue}if(ue=this.tokenizer.inlineText(le,ee,qe)){le=le.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Qe=ue.raw.slice(-1)),xe=!0,Pe=he[he.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ue.raw,Pe.text+=ue.text):he.push(ue);continue}if(le){var ot="Infinite loop on byte: "+le.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return he},e(De,null,[{key:"rules",get:function(){return{block:Te,inline:Ce}}}]),De}(),q=A.defaults,J=O.cleanUrl,re=O.escape,ae=function(){function De(ke){this.options=ke||q}var ye=De.prototype;return ye.code=function(le,he,H){var ee=(he||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(le,ee);ue!=null&&ue!==le&&(H=!0,le=ue)}return le=le.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+re(ee,!0)+'">'+(H?le:re(le,!0))+`</code></pre>
`:"<pre><code>"+(H?le:re(le,!0))+`</code></pre>
`},ye.blockquote=function(le){return`<blockquote>
`+le+`</blockquote>
`},ye.html=function(le){return le},ye.heading=function(le,he,H,ee){return this.options.headerIds?"<h"+he+' id="'+this.options.headerPrefix+ee.slug(H)+'">'+le+"</h"+he+`>
`:"<h"+he+">"+le+"</h"+he+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(le,he,H){var ee=he?"ol":"ul",ue=he&&H!==1?' start="'+H+'"':"";return"<"+ee+ue+`>
`+le+"</"+ee+`>
`},ye.listitem=function(le){return"<li>"+le+`</li>
`},ye.checkbox=function(le){return"<input "+(le?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(le){return"<p>"+le+`</p>
`},ye.table=function(le,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+le+`</thead>
`+he+`</table>
`},ye.tablerow=function(le){return`<tr>
`+le+`</tr>
`},ye.tablecell=function(le,he){var H=he.header?"th":"td",ee=he.align?"<"+H+' align="'+he.align+'">':"<"+H+">";return ee+le+"</"+H+`>
`},ye.strong=function(le){return"<strong>"+le+"</strong>"},ye.em=function(le){return"<em>"+le+"</em>"},ye.codespan=function(le){return"<code>"+le+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(le){return"<del>"+le+"</del>"},ye.link=function(le,he,H){if(le=J(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var ee='<a href="'+re(le)+'"';return he&&(ee+=' title="'+he+'"'),ee+=">"+H+"</a>",ee},ye.image=function(le,he,H){if(le=J(this.options.sanitize,this.options.baseUrl,le),le===null)return H;var ee='<img src="'+le+'" alt="'+H+'"';return he&&(ee+=' title="'+he+'"'),ee+=this.options.xhtml?"/>":">",ee},ye.text=function(le){return le},De}(),Y=function(){function De(){}var ye=De.prototype;return ye.strong=function(le){return le},ye.em=function(le){return le},ye.codespan=function(le){return le},ye.del=function(le){return le},ye.html=function(le){return le},ye.text=function(le){return le},ye.link=function(le,he,H){return""+H},ye.image=function(le,he,H){return""+H},ye.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(le){return le.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(le,he){var H=le,ee=0;if(this.seen.hasOwnProperty(H)){ee=this.seen[le];do ee++,H=le+"-"+ee;while(this.seen.hasOwnProperty(H))}return he||(this.seen[le]=ee,this.seen[H]=0),H},ye.slug=function(le,he){he===void 0&&(he={});var H=this.serialize(le);return this.getNextSafeSlug(H,he.dryrun)},De}(),ge=A.defaults,Re=O.unescape,we=function(){function De(ke){this.options=ke||ge,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new ce}De.parse=function(le,he){var H=new De(he);return H.parse(le)},De.parseInline=function(le,he){var H=new De(he);return H.parseInline(le)};var ye=De.prototype;return ye.parse=function(le,he){he===void 0&&(he=!0);var H="",ee,ue,Pe,Ie,Ue,xe,Qe,rt,tt,Ye,ot,Et,bt,_e,fe,de,X,Oe,Le=le.length;for(ee=0;ee<Le;ee++)switch(Ye=le[ee],Ye.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Ye.tokens),Ye.depth,Re(this.parseInline(Ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Ye.text,Ye.lang,Ye.escaped);continue}case"table":{for(rt="",Qe="",Ie=Ye.header.length,ue=0;ue<Ie;ue++)Qe+=this.renderer.tablecell(this.parseInline(Ye.tokens.header[ue]),{header:!0,align:Ye.align[ue]});for(rt+=this.renderer.tablerow(Qe),tt="",Ie=Ye.cells.length,ue=0;ue<Ie;ue++){for(xe=Ye.tokens.cells[ue],Qe="",Ue=xe.length,Pe=0;Pe<Ue;Pe++)Qe+=this.renderer.tablecell(this.parseInline(xe[Pe]),{header:!1,align:Ye.align[Pe]});tt+=this.renderer.tablerow(Qe)}H+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Ye.tokens),H+=this.renderer.blockquote(tt);continue}case"list":{for(ot=Ye.ordered,Et=Ye.start,bt=Ye.loose,Ie=Ye.items.length,tt="",ue=0;ue<Ie;ue++)fe=Ye.items[ue],de=fe.checked,X=fe.task,_e="",fe.task&&(Oe=this.renderer.checkbox(de),bt?fe.tokens.length>0&&fe.tokens[0].type==="text"?(fe.tokens[0].text=Oe+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Oe+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Oe}):_e+=Oe),_e+=this.parse(fe.tokens,bt),tt+=this.renderer.listitem(_e,X,de);H+=this.renderer.list(tt,ot,Et);continue}case"html":{H+=this.renderer.html(Ye.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Ye.tokens));continue}case"text":{for(tt=Ye.tokens?this.parseInline(Ye.tokens):Ye.text;ee+1<Le&&le[ee+1].type==="text";)Ye=le[++ee],tt+=`
`+(Ye.tokens?this.parseInline(Ye.tokens):Ye.text);H+=he?this.renderer.paragraph(tt):tt;continue}default:{var Ze='Token with "'+Ye.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return H},ye.parseInline=function(le,he){he=he||this.renderer;var H="",ee,ue,Pe=le.length;for(ee=0;ee<Pe;ee++)switch(ue=le[ee],ue.type){case"escape":{H+=he.text(ue.text);break}case"html":{H+=he.html(ue.text);break}case"link":{H+=he.link(ue.href,ue.title,this.parseInline(ue.tokens,he));break}case"image":{H+=he.image(ue.href,ue.title,ue.text);break}case"strong":{H+=he.strong(this.parseInline(ue.tokens,he));break}case"em":{H+=he.em(this.parseInline(ue.tokens,he));break}case"codespan":{H+=he.codespan(ue.text);break}case"br":{H+=he.br();break}case"del":{H+=he.del(this.parseInline(ue.tokens,he));break}case"text":{H+=he.text(ue.text);break}default:{var Ie='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return H},De}(),je=O.merge,G=O.checkSanitizeDeprecation,ie=O.escape,Ee=A.getDefaults,Ne=A.changeDefaults,$e=A.defaults;function We(De,ye,ke){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=je({},We.defaults,ye||{}),G(ye),ke){var le=ye.highlight,he;try{he=Ge.lex(De,ye)}catch(Pe){return ke(Pe)}var H=function(Ie){var Ue;if(!Ie)try{Ue=we.parse(he,ye)}catch(xe){Ie=xe}return ye.highlight=le,Ie?ke(Ie):ke(null,Ue)};if(!le||le.length<3||(delete ye.highlight,!he.length))return H();var ee=0;We.walkTokens(he,function(Pe){Pe.type==="code"&&(ee++,setTimeout(function(){le(Pe.text,Pe.lang,function(Ie,Ue){if(Ie)return H(Ie);Ue!=null&&Ue!==Pe.text&&(Pe.text=Ue,Pe.escaped=!0),ee--,ee===0&&H()})},0))}),ee===0&&H();return}try{var ue=Ge.lex(De,ye);return ye.walkTokens&&We.walkTokens(ue,ye.walkTokens),we.parse(ue,ye)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ie(Pe.message+"",!0)+"</pre>";throw Pe}}We.options=We.setOptions=function(De){return je(We.defaults,De),Ne(We.defaults),We},We.getDefaults=Ee,We.defaults=$e,We.use=function(De){var ye=je({},De);if(De.renderer&&function(){var le=We.defaults.renderer||new ae,he=function(ue){var Pe=le[ue];le[ue]=function(){for(var Ie=arguments.length,Ue=new Array(Ie),xe=0;xe<Ie;xe++)Ue[xe]=arguments[xe];var Qe=De.renderer[ue].apply(le,Ue);return Qe===!1&&(Qe=Pe.apply(le,Ue)),Qe}};for(var H in De.renderer)he(H);ye.renderer=le}(),De.tokenizer&&function(){var le=We.defaults.tokenizer||new N,he=function(ue){var Pe=le[ue];le[ue]=function(){for(var Ie=arguments.length,Ue=new Array(Ie),xe=0;xe<Ie;xe++)Ue[xe]=arguments[xe];var Qe=De.tokenizer[ue].apply(le,Ue);return Qe===!1&&(Qe=Pe.apply(le,Ue)),Qe}};for(var H in De.tokenizer)he(H);ye.tokenizer=le}(),De.walkTokens){var ke=We.defaults.walkTokens;ye.walkTokens=function(le){De.walkTokens(le),ke&&ke(le)}}We.setOptions(ye)},We.walkTokens=function(De,ye){for(var ke=k(De),le;!(le=ke()).done;){var he=le.value;switch(ye(he),he.type){case"table":{for(var H=k(he.tokens.header),ee;!(ee=H()).done;){var ue=ee.value;We.walkTokens(ue,ye)}for(var Pe=k(he.tokens.cells),Ie;!(Ie=Pe()).done;)for(var Ue=Ie.value,xe=k(Ue),Qe;!(Qe=xe()).done;){var rt=Qe.value;We.walkTokens(rt,ye)}break}case"list":{We.walkTokens(he.items,ye);break}default:he.tokens&&We.walkTokens(he.tokens,ye)}}},We.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=je({},We.defaults,ye||{}),G(ye);try{var ke=Ge.lexInline(De,ye);return ye.walkTokens&&We.walkTokens(ke,ye.walkTokens),we.parseInline(ke,ye)}catch(le){if(le.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ie(le.message+"",!0)+"</pre>";throw le}},We.Parser=we,We.parser=we.parse,We.Renderer=ae,We.TextRenderer=Y,We.Lexer=Ge,We.lexer=Ge.lex,We.Tokenizer=N,We.Slugger=ce,We.parse=We;var Xe=We;return Xe}),define(pe[73],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(A,C,D){return Math.min(Math.max(A,C),D)}e.clamp=v;function R(A,C){return(C+A%C)%C}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class y{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=y}),function(){function Q(k){const y=[];typeof k=="number"&&y.push("code/timeOrigin",k);function A(D){y.push(D,Date.now())}function C(){const D=[];for(let P=0;P<y.length;P+=2)D.push({name:y[P],startTime:y[P+1]});return D}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))y.push({name:A.name,startTime:Math.round(k+A.startTime)});return y}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(pe[11],ve([0,1]),function(Q,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,y=!1,A=!1,C=!1,D=!1,P=!1,s=!1,I,a=R,g,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const S=typeof((v=h==null?void 0:h.versions)===null||v===void 0?void 0:v.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=S&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const r=h==null?void 0:h.env.VSCODE_BROWSER_CODE_LOADING;if(typeof r=="string")return r==="none"||r==="code"||r==="bypassHeatCheck"||r==="bypassHeatCheckAndEagerCompile"?r:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)c=navigator.userAgent,k=c.indexOf("Windows")>=0,y=c.indexOf("Macintosh")>=0,s=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,P=!0,I=navigator.language,a=I;else if(typeof h=="object"){k=h.platform==="win32",y=h.platform==="darwin",A=h.platform==="linux",C=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=R,a=R;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const o=JSON.parse(r),m=o.availableLanguages["*"];I=o.locale,a=m||R,g=o._translationsConfigFile}catch(o){}D=!0}else console.error("Unable to resolve platform.");var w;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let u=0;y?u=1:k?u=3:A&&(u=2),e.isWindows=k,e.isMacintosh=y,e.isLinux=A,e.isLinuxSnap=C,e.isNative=D,e.isWeb=P,e.isIOS=s,e.platform=u,e.userAgent=c,e.language=a;var d;(function(r){function o(){return e.language}r.value=o;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=m;function p(){return e.language==="en"}r.isDefault=p})(d=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let m=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let b=0,l=m.length;b<l;b++){const L=m[b];if(L.id===E.data.vscodeSetImmediateId){m.splice(b,1),L.callback();return}}});let p=0;return E=>{const b=++p;m.push({id:b,callback:E}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const o=Promise.resolve();return m=>o.then(m)}();var f;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||s?2:k?1:3;let t=!0,n=!1;function i(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,t=new Uint16Array(r.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=i}),define(pe[37],ve([0,1,11]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(y){return v.setImmediate(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return v.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(pe[9],ve([0,1,37]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,y=90,A=122,C=46,D=47,P=92,s=58,I=63;class a extends Error{constructor(d,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const i=d.indexOf(".")!==-1?"property":"argument";let r=`The "${d}" ${i} ${n} of type ${f}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function g(u,d){if(typeof u!="string")throw new a(d,"string",u)}function c(u){return u===D||u===P}function h(u){return u===D}function S(u){return u>=R&&u<=y||u>=k&&u<=A}function w(u,d,f,t){let n="",i=0,r=-1,o=0,m=0;for(let p=0;p<=u.length;++p){if(p<u.length)m=u.charCodeAt(p);else{if(t(m))break;m=D}if(t(m)){if(!(r===p-1||o===1))if(o===2){if(n.length<2||i!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const E=n.lastIndexOf(f);E===-1?(n="",i=0):(n=n.slice(0,E),i=n.length-1-n.lastIndexOf(f)),r=p,o=0;continue}else if(n.length!==0){n="",i=0,r=p,o=0;continue}}d&&(n+=n.length>0?`${f}..`:"..",i=2)}else n.length>0?n+=`${f}${u.slice(r+1,p)}`:n=u.slice(r+1,p),i=p-r-1;r=p,o=0}else m===C&&o!==-1?++o:o=-1}return n}function _(u,d){if(d===null||typeof d!="object")throw new a("pathObject","Object",d);const f=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return f?f===d.root?`${f}${t}`:`${f}${u}${t}`:t}e.win32={resolve(...u){let d="",f="",t=!1;for(let n=u.length-1;n>=-1;n--){let i;if(n>=0){if(i=u[n],g(i,"path"),i.length===0)continue}else d.length===0?i=v.cwd():(i=v.env[`=${d}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==d.toLowerCase()&&i.charCodeAt(2)===P)&&(i=`${d}\\`));const r=i.length;let o=0,m="",p=!1;const E=i.charCodeAt(0);if(r===1)c(E)&&(o=1,p=!0);else if(c(E))if(p=!0,c(i.charCodeAt(1))){let b=2,l=b;for(;b<r&&!c(i.charCodeAt(b));)b++;if(b<r&&b!==l){const L=i.slice(l,b);for(l=b;b<r&&c(i.charCodeAt(b));)b++;if(b<r&&b!==l){for(l=b;b<r&&!c(i.charCodeAt(b));)b++;(b===r||b!==l)&&(m=`\\\\${L}\\${i.slice(l,b)}`,o=b)}}}else o=1;else S(E)&&i.charCodeAt(1)===s&&(m=i.slice(0,2),o=2,r>2&&c(i.charCodeAt(2))&&(p=!0,o=3));if(m.length>0)if(d.length>0){if(m.toLowerCase()!==d.toLowerCase())continue}else d=m;if(t){if(d.length>0)break}else if(f=`${i.slice(o)}\\${f}`,t=p,p&&d.length>0)break}return f=w(f,!t,"\\",c),t?`${d}\\${f}`:`${d}${f}`||"."},normalize(u){g(u,"path");const d=u.length;if(d===0)return".";let f=0,t,n=!1;const i=u.charCodeAt(0);if(d===1)return h(i)?"\\":u;if(c(i))if(n=!0,c(u.charCodeAt(1))){let o=2,m=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==m){const p=u.slice(m,o);for(m=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==m){for(m=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return`\\\\${p}\\${u.slice(m)}\\`;o!==m&&(t=`\\\\${p}\\${u.slice(m,o)}`,f=o)}}}else f=1;else S(i)&&u.charCodeAt(1)===s&&(t=u.slice(0,2),f=2,d>2&&c(u.charCodeAt(2))&&(n=!0,f=3));let r=f<d?w(u.slice(f),!n,"\\",c):"";return r.length===0&&!n&&(r="."),r.length>0&&c(u.charCodeAt(d-1))&&(r+="\\"),t===void 0?n?`\\${r}`:r:n?`${t}\\${r}`:`${t}${r}`},isAbsolute(u){g(u,"path");const d=u.length;if(d===0)return!1;const f=u.charCodeAt(0);return c(f)||d>2&&S(f)&&u.charCodeAt(1)===s&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,f;for(let i=0;i<u.length;++i){const r=u[i];g(r,"path"),r.length>0&&(d===void 0?d=f=r:d+=`\\${r}`)}if(d===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&c(f.charCodeAt(0))){++n;const i=f.length;i>1&&c(f.charCodeAt(1))&&(++n,i>2&&(c(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<d.length&&c(d.charCodeAt(n));)n++;n>=2&&(d=`\\${d.slice(n)}`)}return e.win32.normalize(d)},relative(u,d){if(g(u,"from"),g(d,"to"),u===d)return"";const f=e.win32.resolve(u),t=e.win32.resolve(d);if(f===t||(u=f.toLowerCase(),d=t.toLowerCase(),u===d))return"";let n=0;for(;n<u.length&&u.charCodeAt(n)===P;)n++;let i=u.length;for(;i-1>n&&u.charCodeAt(i-1)===P;)i--;const r=i-n;let o=0;for(;o<d.length&&d.charCodeAt(o)===P;)o++;let m=d.length;for(;m-1>o&&d.charCodeAt(m-1)===P;)m--;const p=m-o,E=r<p?r:p;let b=-1,l=0;for(;l<E;l++){const O=u.charCodeAt(n+l);if(O!==d.charCodeAt(o+l))break;O===P&&(b=l)}if(l!==E){if(b===-1)return t}else{if(p>E){if(d.charCodeAt(o+l)===P)return t.slice(o+l+1);if(l===2)return t.slice(o+l)}r>E&&(u.charCodeAt(n+l)===P?b=l:l===2&&(b=3)),b===-1&&(b=0)}let L="";for(l=n+b+1;l<=i;++l)(l===i||u.charCodeAt(l)===P)&&(L+=L.length===0?"..":"\\..");return o+=b,L.length>0?`${L}${t.slice(o,m)}`:(t.charCodeAt(o)===P&&++o,t.slice(o,m))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===P){if(d.charCodeAt(1)===P){const f=d.charCodeAt(2);if(f!==I&&f!==C)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(S(d.charCodeAt(0))&&d.charCodeAt(1)===s&&d.charCodeAt(2)===P)return`\\\\?\\${d}`;return u},dirname(u){g(u,"path");const d=u.length;if(d===0)return".";let f=-1,t=0;const n=u.charCodeAt(0);if(d===1)return c(n)?u:".";if(c(n)){if(f=t=1,c(u.charCodeAt(1))){let o=2,m=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==m){for(m=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==m){for(m=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return u;o!==m&&(f=t=o+1)}}}}else S(n)&&u.charCodeAt(1)===s&&(f=d>2&&c(u.charCodeAt(2))?3:2,t=f);let i=-1,r=!0;for(let o=d-1;o>=t;--o)if(c(u.charCodeAt(o))){if(!r){i=o;break}}else r=!1;if(i===-1){if(f===-1)return".";i=f}return u.slice(0,i)},basename(u,d){d!==void 0&&g(d,"ext"),g(u,"path");let f=0,t=-1,n=!0,i;if(u.length>=2&&S(u.charCodeAt(0))&&u.charCodeAt(1)===s&&(f=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let r=d.length-1,o=-1;for(i=u.length-1;i>=f;--i){const m=u.charCodeAt(i);if(c(m)){if(!n){f=i+1;break}}else o===-1&&(n=!1,o=i+1),r>=0&&(m===d.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=o))}return f===t?t=o:t===-1&&(t=u.length),u.slice(f,t)}for(i=u.length-1;i>=f;--i)if(c(u.charCodeAt(i))){if(!n){f=i+1;break}}else t===-1&&(n=!1,t=i+1);return t===-1?"":u.slice(f,t)},extname(u){g(u,"path");let d=0,f=-1,t=0,n=-1,i=!0,r=0;u.length>=2&&u.charCodeAt(1)===s&&S(u.charCodeAt(0))&&(d=t=2);for(let o=u.length-1;o>=d;--o){const m=u.charCodeAt(o);if(c(m)){if(!i){t=o+1;break}continue}n===-1&&(i=!1,n=o+1),m===C?f===-1?f=o:r!==1&&(r=1):f!==-1&&(r=-1)}return f===-1||n===-1||r===0||r===1&&f===n-1&&f===t+1?"":u.slice(f,n)},format:_.bind(null,"\\"),parse(u){g(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const f=u.length;let t=0,n=u.charCodeAt(0);if(f===1)return c(n)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(c(n)){if(t=1,c(u.charCodeAt(1))){let b=2,l=b;for(;b<f&&!c(u.charCodeAt(b));)b++;if(b<f&&b!==l){for(l=b;b<f&&c(u.charCodeAt(b));)b++;if(b<f&&b!==l){for(l=b;b<f&&!c(u.charCodeAt(b));)b++;b===f?t=b:b!==l&&(t=b+1)}}}}else if(S(n)&&u.charCodeAt(1)===s){if(f<=2)return d.root=d.dir=u,d;if(t=2,c(u.charCodeAt(2))){if(f===3)return d.root=d.dir=u,d;t=3}}t>0&&(d.root=u.slice(0,t));let i=-1,r=t,o=-1,m=!0,p=u.length-1,E=0;for(;p>=t;--p){if(n=u.charCodeAt(p),c(n)){if(!m){r=p+1;break}continue}o===-1&&(m=!1,o=p+1),n===C?i===-1?i=p:E!==1&&(E=1):i!==-1&&(E=-1)}return o!==-1&&(i===-1||E===0||E===1&&i===o-1&&i===r+1?d.base=d.name=u.slice(r,o):(d.name=u.slice(r,i),d.base=u.slice(r,o),d.ext=u.slice(i,o))),r>0&&r!==t?d.dir=u.slice(0,r-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",f=!1;for(let t=u.length-1;t>=-1&&!f;t--){const n=t>=0?u[t]:v.cwd();g(n,"path"),n.length!==0&&(d=`${n}/${d}`,f=n.charCodeAt(0)===D)}return d=w(d,!f,"/",h),f?`/${d}`:d.length>0?d:"."},normalize(u){if(g(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===D,f=u.charCodeAt(u.length-1)===D;return u=w(u,!d,"/",h),u.length===0?d?"/":f?"./":".":(f&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return g(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let d;for(let f=0;f<u.length;++f){const t=u[f];g(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(g(u,"from"),g(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const f=1,t=u.length,n=t-f,i=1,r=d.length-i,o=n<r?n:r;let m=-1,p=0;for(;p<o;p++){const b=u.charCodeAt(f+p);if(b!==d.charCodeAt(i+p))break;b===D&&(m=p)}if(p===o)if(r>o){if(d.charCodeAt(i+p)===D)return d.slice(i+p+1);if(p===0)return d.slice(i+p)}else n>o&&(u.charCodeAt(f+p)===D?m=p:p===0&&(m=0));let E="";for(p=f+m+1;p<=t;++p)(p===t||u.charCodeAt(p)===D)&&(E+=E.length===0?"..":"/..");return`${E}${d.slice(i+m)}`},toNamespacedPath(u){return u},dirname(u){if(g(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===D;let f=-1,t=!0;for(let n=u.length-1;n>=1;--n)if(u.charCodeAt(n)===D){if(!t){f=n;break}}else t=!1;return f===-1?d?"/":".":d&&f===1?"//":u.slice(0,f)},basename(u,d){d!==void 0&&g(d,"ext"),g(u,"path");let f=0,t=-1,n=!0,i;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let r=d.length-1,o=-1;for(i=u.length-1;i>=0;--i){const m=u.charCodeAt(i);if(m===D){if(!n){f=i+1;break}}else o===-1&&(n=!1,o=i+1),r>=0&&(m===d.charCodeAt(r)?--r==-1&&(t=i):(r=-1,t=o))}return f===t?t=o:t===-1&&(t=u.length),u.slice(f,t)}for(i=u.length-1;i>=0;--i)if(u.charCodeAt(i)===D){if(!n){f=i+1;break}}else t===-1&&(n=!1,t=i+1);return t===-1?"":u.slice(f,t)},extname(u){g(u,"path");let d=-1,f=0,t=-1,n=!0,i=0;for(let r=u.length-1;r>=0;--r){const o=u.charCodeAt(r);if(o===D){if(!n){f=r+1;break}continue}t===-1&&(n=!1,t=r+1),o===C?d===-1?d=r:i!==1&&(i=1):d!==-1&&(i=-1)}return d===-1||t===-1||i===0||i===1&&d===t-1&&d===f+1?"":u.slice(d,t)},format:_.bind(null,"/"),parse(u){g(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const f=u.charCodeAt(0)===D;let t;f?(d.root="/",t=1):t=0;let n=-1,i=0,r=-1,o=!0,m=u.length-1,p=0;for(;m>=t;--m){const E=u.charCodeAt(m);if(E===D){if(!o){i=m+1;break}continue}r===-1&&(o=!1,r=m+1),E===C?n===-1?n=m:p!==1&&(p=1):n!==-1&&(p=-1)}if(r!==-1){const E=i===0&&f?1:i;n===-1||p===0||p===1&&n===r-1&&n===i+1?d.base=d.name=u.slice(E,r):(d.name=u.slice(E,n),d.base=u.slice(E,r),d.ext=u.slice(n,r))}return i>0?d.dir=u.slice(0,i-1):f&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[134],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...A){const C=A.reduce((s,I)=>(s[I]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(s=>!C[s]).forEach(s=>{for(let I=0;I<D.length;I++)if(s.search(D[I])!==-1){delete y[s];break}})}e.sanitizeProcessEnvironment=k}),define(pe[43],ve([0,1,11]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(pe[3],ve([0,1,16,69,6,72,43]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(w){w.None=()=>k.Disposable.None;function _(V){return($,j=null,T)=>{let N=!1,F;return F=V(M=>{if(!N)return F?F.dispose():N=!0,$.call(j,M)},null,T),N&&F.dispose(),F}}w.once=_;function u(V,$){return r((j,T=null,N)=>V(F=>j.call(T,$(F)),null,N))}w.map=u;function d(V,$){return r((j,T=null,N)=>V(F=>{$(F),j.call(T,F)},null,N))}w.forEach=d;function f(V,$){return r((j,T=null,N)=>V(F=>$(F)&&j.call(T,F),null,N))}w.filter=f;function t(V){return V}w.signal=t;function n(...V){return($,j=null,T)=>k.combinedDisposable(...V.map(N=>N(F=>$.call(j,F),null,T)))}w.any=n;function i(V,$,j){let T=j;return u(V,N=>(T=$(T,N),T))}w.reduce=i;function r(V){let $;const j=new a({onFirstListenerAdd(){$=V(j.fire,j)},onLastListenerRemove(){$.dispose()}});return j.event}w.snapshot=r;function o(V,$,j=100,T=!1,N){let F,M,U,x=0;const K=new a({leakWarningThreshold:N,onFirstListenerAdd(){F=V(se=>{x++,M=$(M,se),T&&!U&&(K.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const be=M;M=void 0,U=void 0,(!T||x>1)&&K.fire(be),x=0},j)})},onLastListenerRemove(){F.dispose()}});return K.event}w.debounce=o;function m(V){const $=new Date().getTime();return u(_(V),j=>new Date().getTime()-$)}w.stopwatch=m;function p(V,$=(j,T)=>j===T){let j=!0,T;return f(V,N=>{const F=j||!$(N,T);return j=!1,T=N,F})}w.latch=p;function E(V,$){return[w.filter(V,$),w.filter(V,j=>!$(j))]}w.split=E;function b(V,$=!1,j=[]){let T=j.slice(),N=V(U=>{T?T.push(U):M.fire(U)});const F=()=>{T&&T.forEach(U=>M.fire(U)),T=null},M=new a({onFirstListenerAdd(){N||(N=V(U=>M.fire(U)))},onFirstListenerDidAdd(){T&&($?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}w.buffer=b;class l{constructor($){this.event=$}map($){return new l(u(this.event,$))}forEach($){return new l(d(this.event,$))}filter($){return new l(f(this.event,$))}reduce($,j){return new l(i(this.event,$,j))}latch(){return new l(p(this.event))}debounce($,j=100,T=!1,N){return new l(o(this.event,$,j,T,N))}on($,j,T){return this.event($,j,T)}once($,j,T){return _(this.event)($,j,T)}}function L(V){return new l(V)}w.chain=L;function O(V,$,j=T=>T){const T=(...U)=>M.fire(j(...U)),N=()=>V.on($,T),F=()=>V.removeListener($,T),M=new a({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function W(V,$,j=T=>T){const T=(...U)=>M.fire(j(...U)),N=()=>V.addEventListener($,T),F=()=>V.removeEventListener($,T),M=new a({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=W;function Z(V){const $=new a;let j=!1;return V.then(void 0,()=>null).then(()=>{j?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),j=!0,$.event}w.fromPromise=Z;function oe(V){return new Promise($=>_(V)($))}w.toPromise=oe})(C=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new A.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function s(w){const _=P;return P=w,{dispose(){P=_}}}e.setGlobalLeakWarningThreshold=s;class I{constructor(_,u=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let u=P;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||_<u)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(d)||0;if(this._stacks.set(d,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,n=0;for(const[i,r]of this._stacks)(!t||n<r)&&(t=i,n=r);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}class a{constructor(_){var u;this._disposed=!1,this._options=_,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,u,d)=>{var f;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(u?[_,u]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,u);const i=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let r;return r={dispose:()=>{i&&i(),r.dispose=a._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof k.DisposableStore?d.add(r):Array.isArray(d)&&d.push(r),r}),this._event}fire(_){var u,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,_]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){v.onUnexpectedError(n)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var _,u,d,f,t;this._disposed||(this._disposed=!0,(_=this._listeners)===null||_===void 0||_.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(f=(d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)===null||f===void 0||f.call(d),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=a,a._noop=function(){};class g extends a{constructor(_){super(_);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=g;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new a({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const u={event:_,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const d=()=>{this.hasListeners&&this.unhook(u);const f=this.events.indexOf(u);this.events.splice(f,1)};return k.toDisposable(R.once(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(u=>this.emitter.fire(u))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class h{constructor(){this.buffers=[]}wrapEvent(_){return(u,d,f)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>u.call(d,t)):u.call(d,t)},void 0,f)}bufferEvents(_){const u=[];this.buffers.push(u);const d=_();return this.buffers.pop(),u.forEach(f=>f()),d}}e.EventBufferer=h;class S{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new a({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(pe[21],ve([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(C,D){const P=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(P)}}});var k;(function(C){function D(P){return P===C.None||P===C.Cancelled||P instanceof y?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=k.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(pe[91],ve([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const a=this._icons.get(I.id);a?I.description?a.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function y(s,I){return new C(s,I)}e.registerCodicon=y;function A(s){return s?s.replace(/\$\((.*?)\)/g,(I,a)=>` ${a} `).trim():""}e.getCodiconAriaLabel=A;class C{constructor(I,a,g){this.id=I,this.definition=a,this.description=g,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(s,I){const a=["codicon","codicon-"+s];return I&&a.push("codicon-modifier-"+I),a}e.getClassNamesArray=D;var P;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function a(h){if(h instanceof C)return["codicon","codicon-"+h.id];const S=I.exec(h.id);if(!S)return a(C.error);let[,w,_]=S;const u=["codicon","codicon-"+w];return _&&u.push("codicon-modifier-"+_.substr(1)),u}s.asClassNameArray=a;function g(h){return a(h).join(" ")}s.asClassName=g;function c(h){return"."+a(h).join(".")}s.asCSSSelector=c})(P=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.inspect=new s("inspect",{fontCharacter:"\\ebd1"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(pe[92],ve([0,1,16,6]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=k;function y(u){const d=u;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(u,d){return new C(u,d)}e.newWriteableStream=A;class C{constructor(d,f){this.reducer=d,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(f=>f(d))}emitError(d){this.listeners.error.length===0?v.onUnexpectedError(d):this.listeners.error.slice(0).forEach(f=>f(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,f){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(d,f){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,d){const f=[];let t;for(;(t=u.read())!==null;)f.push(t);return d(f)}e.consumeReadable=D;function P(u,d,f){const t=[];let n;for(;(n=u.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return u.read()}}}e.peekReadable=P;function s(u,d){return new Promise((f,t)=>{const n=[];I(u,{onData:i=>{d&&n.push(i)},onError:i=>{d?t(i):f(void 0)},onEnd:()=>{f(d?d(n):void 0)}})})}e.consumeStream=s;function I(u,d){u.on("error",f=>d.onError(f)),u.on("end",()=>d.onEnd()),u.on("data",f=>d.onData(f))}e.listenStream=I;function a(u,d){return new Promise((f,t)=>{const n=new R.DisposableStore,i=[],r=p=>{if(i.push(p),i.length>d)return n.dispose(),u.pause(),f({stream:u,buffer:i,ended:!1})},o=p=>t(p),m=()=>f({stream:u,buffer:i,ended:!0});n.add(R.toDisposable(()=>u.removeListener("error",o))),u.on("error",o),n.add(R.toDisposable(()=>u.removeListener("end",m))),u.on("end",m),n.add(R.toDisposable(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=a;function g(u,d){const f=A(d);return f.end(u),f}e.toStream=g;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function h(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=h;function S(u,d,f){const t=A(f);return I(u,{onData:n=>t.write(d.data(n)),onError:n=>t.error(d.error?d.error(n):n),onEnd:()=>t.end()}),t}e.transform=S;function w(u,d,f){let t=!1;return{read:()=>{const n=d.read();return t?n:(t=!0,n!==null?f([u,n]):u)}}}e.prefixedReadable=w;function _(u,d,f){let t=!1;const n=A(f);return I(d,{onData:i=>t?n.write(i):(t=!0,n.write(f([u,i]))),onError:i=>n.error(i),onEnd:()=>{t||(t=!0,n.write(u)),n.end()}}),n}e.prefixedStream=_}),define(pe[8],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function k(H,...ee){return ee.length===0?H:H.replace(R,function(ue,Pe){const Ie=parseInt(Pe,10);return isNaN(Ie)||Ie<0||Ie>=ee.length?ue:ee[Ie]})}e.format=k;function y(H){return H.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=y;function A(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function C(H,ee){let ue=0;const Pe=ee.charCodeAt(0);for(let Ie=H.length-1;Ie>=0;Ie--)H.charCodeAt(Ie)===Pe&&ue++;return ue}e.count=C;function D(H,ee,ue="\u2026"){return H.length<=ee?H:`${H.substr(0,ee)}${ue}`}e.truncate=D;function P(H,ee=" "){const ue=s(H,ee);return I(ue,ee)}e.trim=P;function s(H,ee){if(!H||!ee)return H;const ue=ee.length;if(ue===0||H.length===0)return H;let Pe=0;for(;H.indexOf(ee,Pe)===Pe;)Pe=Pe+ue;return H.substring(Pe)}e.ltrim=s;function I(H,ee){if(!H||!ee)return H;const ue=ee.length,Pe=H.length;if(ue===0||Pe===0)return H;let Ie=Pe,Ue=-1;for(;Ue=H.lastIndexOf(ee,Ie-1),!(Ue===-1||Ue+ue!==Ie);){if(Ue===0)return"";Ie=Ue}return H.substring(0,Ie)}e.rtrim=I;function a(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=a;function g(H){return H.replace(/\*/g,"")}e.stripWildcards=g;function c(H,ee,ue={}){if(!H)throw new Error("Cannot create regex from empty string");ee||(H=A(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Pe="";return ue.global&&(Pe+="g"),ue.matchCase||(Pe+="i"),ue.multiline&&(Pe+="m"),ue.unicode&&(Pe+="u"),new RegExp(H,Pe)}e.createRegExp=c;function h(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function S(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function _(H){return H.split(/\r\n|\r|\n/)}e.splitLines=_;function u(H){for(let ee=0,ue=H.length;ee<ue;ee++){const Pe=H.charCodeAt(ee);if(Pe!==32&&Pe!==9)return ee}return-1}e.firstNonWhitespaceIndex=u;function d(H,ee=0,ue=H.length){for(let Pe=ee;Pe<ue;Pe++){const Ie=H.charCodeAt(Pe);if(Ie!==32&&Ie!==9)return H.substring(ee,Pe)}return H.substring(ee,ue)}e.getLeadingWhitespace=d;function f(H,ee=H.length-1){for(let ue=ee;ue>=0;ue--){const Pe=H.charCodeAt(ue);if(Pe!==32&&Pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=f;function t(H,ee){return H<ee?-1:H>ee?1:0}e.compare=t;function n(H,ee,ue=0,Pe=H.length,Ie=0,Ue=ee.length){for(;ue<Pe&&Ie<Ue;ue++,Ie++){let rt=H.charCodeAt(ue),tt=ee.charCodeAt(Ie);if(rt<tt)return-1;if(rt>tt)return 1}const xe=Pe-ue,Qe=Ue-Ie;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstring=n;function i(H,ee){return r(H,ee,0,H.length,0,ee.length)}e.compareIgnoreCase=i;function r(H,ee,ue=0,Pe=H.length,Ie=0,Ue=ee.length){for(;ue<Pe&&Ie<Ue;ue++,Ie++){let rt=H.charCodeAt(ue),tt=ee.charCodeAt(Ie);if(rt===tt)continue;const Ye=rt-tt;if(!(Ye===32&&m(tt))&&!(Ye===-32&&m(rt)))return o(rt)&&o(tt)?Ye:n(H.toLowerCase(),ee.toLowerCase(),ue,Pe,Ie,Ue)}const xe=Pe-ue,Qe=Ue-Ie;return xe<Qe?-1:xe>Qe?1:0}e.compareSubstringIgnoreCase=r;function o(H){return H>=97&&H<=122}e.isLowerAsciiLetter=o;function m(H){return H>=65&&H<=90}e.isUpperAsciiLetter=m;function p(H){return o(H)||m(H)}function E(H,ee){return H.length===ee.length&&b(H,ee)}e.equalsIgnoreCase=E;function b(H,ee,ue=H.length){for(let Pe=0;Pe<ue;Pe++){const Ie=H.charCodeAt(Pe),Ue=ee.charCodeAt(Pe);if(Ie!==Ue){if(p(Ie)&&p(Ue)){const xe=Math.abs(Ie-Ue);if(xe!==0&&xe!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function l(H,ee){const ue=ee.length;return ee.length>H.length?!1:b(H,ee,ue)}e.startsWithIgnoreCase=l;function L(H,ee){let ue,Pe=Math.min(H.length,ee.length);for(ue=0;ue<Pe;ue++)if(H.charCodeAt(ue)!==ee.charCodeAt(ue))return ue;return Pe}e.commonPrefixLength=L;function O(H,ee){let ue,Pe=Math.min(H.length,ee.length);const Ie=H.length-1,Ue=ee.length-1;for(ue=0;ue<Pe;ue++)if(H.charCodeAt(Ie-ue)!==ee.charCodeAt(Ue-ue))return ue;return Pe}e.commonSuffixLength=O;function W(H){return 55296<=H&&H<=56319}e.isHighSurrogate=W;function Z(H){return 56320<=H&&H<=57343}e.isLowSurrogate=Z;function oe(H,ee){return(H-55296<<10)+(ee-56320)+65536}e.computeCodePoint=oe;function V(H,ee,ue){const Pe=H.charCodeAt(ue);if(W(Pe)&&ue+1<ee){const Ie=H.charCodeAt(ue+1);if(Z(Ie))return oe(Pe,Ie)}return Pe}e.getNextCodePoint=V;function $(H,ee){const ue=H.charCodeAt(ee-1);if(Z(ue)&&ee>1){const Pe=H.charCodeAt(ee-2);if(W(Pe))return oe(Pe,ue)}return ue}function j(H,ee){const ue=We.getInstance(),Pe=ee,Ie=H.length,Ue=V(H,Ie,ee);ee+=Ue>=65536?2:1;let xe=ue.getGraphemeBreakType(Ue);for(;ee<Ie;){const Qe=V(H,Ie,ee),rt=ue.getGraphemeBreakType(Qe);if(Ne(xe,rt))break;ee+=Qe>=65536?2:1,xe=rt}return ee-Pe}e.nextCharLength=j;function T(H,ee){const ue=We.getInstance(),Pe=ee,Ie=$(H,ee);ee-=Ie>=65536?2:1;let Ue=ue.getGraphemeBreakType(Ie);for(;ee>0;){const xe=$(H,ee),Qe=ue.getGraphemeBreakType(xe);if(Ne(Qe,Ue))break;ee-=xe>=65536?2:1,Ue=Qe}return Pe-ee}e.prevCharLength=T;function N(H,ee){const ue=We.getInstance(),Pe=H.length,Ie=ee,Ue=V(H,Pe,ee),xe=ue.getGraphemeBreakType(Ue);ee+=Ue>=65536?2:1;let Qe=xe;for(;ee<Pe;){const tt=V(H,Pe,ee),Ye=ue.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;ee+=tt>=65536?2:1,Qe=Ye}const rt=ee;for(ee=Ie,Qe=xe;ee>0;){const tt=$(H,ee),Ye=ue.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;ee-=tt>=65536?2:1,Qe=Ye}return[ee,rt]}function F(H,ee){return ee>0&&Z(H.charCodeAt(ee))?N(H,ee-1):N(H,ee)}e.getCharContainingOffset=F;function M(H){const ee=H.length;let ue=0,Pe=0;for(;Pe<ee;){const xe=V(H,ee,Pe);Pe+=xe>=65536?2:1,xe<128?ue+=1:xe<2048?ue+=2:xe<65536?ue+=3:ue+=4}const Ie=new Uint8Array(ue);Pe=0;let Ue=0;for(;Pe<ee;){const xe=V(H,ee,Pe);Pe+=xe>=65536?2:1,xe<128?Ie[Ue++]=xe:xe<2048?(Ie[Ue++]=192|(xe&1984)>>>6,Ie[Ue++]=128|(xe&63)>>>0):xe<65536?(Ie[Ue++]=224|(xe&61440)>>>12,Ie[Ue++]=128|(xe&4032)>>>6,Ie[Ue++]=128|(xe&63)>>>0):(Ie[Ue++]=240|(xe&1835008)>>>18,Ie[Ue++]=128|(xe&258048)>>>12,Ie[Ue++]=128|(xe&4032)>>>6,Ie[Ue++]=128|(xe&63)>>>0)}return Ie}e.encodeUTF8=M;function U(H){const ee=H.byteLength,ue=[];let Pe=0;for(;Pe<ee;){const Ie=H[Pe];let Ue;if(Ie>=240&&Pe+3<ee?Ue=(H[Pe++]&7)<<18>>>0|(H[Pe++]&63)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ie>=224&&Pe+2<ee?Ue=(H[Pe++]&15)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ie>=192&&Pe+1<ee?Ue=(H[Pe++]&31)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ue=H[Pe++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)ue.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const xe=Ue-65536,Qe=55296+((xe&1047552)>>>10),rt=56320+((xe&1023)>>>0);ue.push(String.fromCharCode(Qe)),ue.push(String.fromCharCode(rt))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=U;const x=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return x.test(H)}e.containsRTL=K;const se=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function be(H){return se.test(H)}e.containsEmoji=be;const Te=/^[\t\n\r\x20-\x7E]*$/;function Ce(H){return Te.test(H)}e.isBasicASCII=Ce,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Fe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Fe;function qe(H){for(let ee=0,ue=H.length;ee<ue;ee++)if(ze(H.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=qe;function ze(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=ze;function Ge(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=Ge;function q(H,ee){if(H.length<ee)return H;const ue=/\b/g;let Pe=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<ee);)Pe=ue.lastIndex,ue.lastIndex+=1;return H.substring(Pe).replace(/^\s/,"")}e.lcut=q;const J=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,ae=/\x1b\[0?m/g;function Y(H){return H&&(H=H.replace(J,""),H=H.replace(re,""),H=H.replace(ae,"")),H}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ge(H){return ce(H)?H.substr(1):H}e.stripUTF8BOM=ge;function Re(H,ee){if(!H||!ee||H.length<ee.length)return!1;const ue=ee.length,Pe=H.toLowerCase();let Ie=0,Ue=-1;for(;Ie<ue;){const xe=Pe.indexOf(ee[Ie],Ue+1);if(xe<0)return!1;Ue=xe,Ie++}return!0}e.fuzzyContains=Re;function we(H,ee=!1){return H?(ee&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=we;function je(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=je;function G(H,ee=1){if(ee===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),ee--;while(ee>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=G;function ie(H){const ee=90-65+1;return H=H%(2*ee),H<ee?String.fromCharCode(97+H):String.fromCharCode(65+H-ee)}e.singleLetterHash=ie;function Ee(H){return We.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Ee;function Ne(H,ee){return H===0?ee!==5&&ee!==7:H===2&&ee===3?!1:H===4||H===2||H===3||ee===4||ee===2||ee===3?!0:!(H===8&&(ee===8||ee===9||ee===11||ee===12)||(H===11||H===9)&&(ee===9||ee===10)||(H===12||H===10)&&ee===10||ee===5||ee===13||ee===7||H===1||H===13&&ee===14||H===6&&ee===6)}e.breakBetweenGraphemeBreakType=Ne;var $e;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{constructor(){this._data=Xe()}static getInstance(){return We._INSTANCE||(We._INSTANCE=new We),We._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const ue=this._data,Pe=ue.length/3;let Ie=1;for(;Ie<=Pe;)if(ee<ue[3*Ie])Ie=2*Ie;else if(ee>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}We._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,ee){if(H===0)return 0;const ue=ye(H,ee);if(ue!==void 0)return ue;const Pe=$(ee,H);return H-=ke(Pe),H}e.getLeftDeleteOffset=De;function ye(H,ee){let ue=$(ee,H);for(H-=ke(ue);le(ue)||ue===65039||ue===8419;){if(H===0)return;ue=$(ee,H),H-=ke(ue)}if(!!Ge(ue)){if(H>=0){const Pe=$(ee,H);Pe===8205&&(H-=ke(Pe))}return H}}function ke(H){return H>=65536?2:1}function le(H){return 127995<=H&&H<=127999}var he;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(he||(he={}))}),define(pe[22],ve([0,1,8,92]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let C,D;class P{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return k?new P(Buffer.allocUnsafe(p)):new P(new Uint8Array(p))}static wrap(p){return k&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new P(p)}static fromString(p,E){return!((E==null?void 0:E.dontUseNodeBuffer)||!1)&&k?new P(Buffer.from(p)):y?(C||(C=new TextEncoder),new P(C.encode(p))):new P(v.encodeUTF8(p))}static concat(p,E){if(typeof E=="undefined"){E=0;for(let L=0,O=p.length;L<O;L++)E+=p[L].byteLength}const b=P.alloc(E);let l=0;for(let L=0,O=p.length;L<O;L++){const W=p[L];b.set(W,l),l+=W.byteLength}return b}toString(){return k?this.buffer.toString():A?(D||(D=new TextDecoder),D.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(p,E){return new P(this.buffer.subarray(p,E))}set(p,E){p instanceof P?this.buffer.set(p.buffer,E):this.buffer.set(p,E)}readUInt32BE(p){return a(this.buffer,p)}writeUInt32BE(p,E){g(this.buffer,p,E)}readUInt32LE(p){return c(this.buffer,p)}writeUInt32LE(p,E){h(this.buffer,p,E)}readUInt8(p){return S(this.buffer,p)}writeUInt8(p,E){w(this.buffer,p,E)}}e.VSBuffer=P;function s(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0}e.readUInt16LE=s;function I(m,p,E){m[E+0]=p&255,p=p>>>8,m[E+1]=p&255}e.writeUInt16LE=I;function a(m,p){return m[p]*2**24+m[p+1]*2**16+m[p+2]*2**8+m[p+3]}e.readUInt32BE=a;function g(m,p,E){m[E+3]=p,p=p>>>8,m[E+2]=p,p=p>>>8,m[E+1]=p,p=p>>>8,m[E]=p}e.writeUInt32BE=g;function c(m,p){return m[p+0]<<0>>>0|m[p+1]<<8>>>0|m[p+2]<<16>>>0|m[p+3]<<24>>>0}e.readUInt32LE=c;function h(m,p,E){m[E+0]=p&255,p=p>>>8,m[E+1]=p&255,p=p>>>8,m[E+2]=p&255,p=p>>>8,m[E+3]=p&255}e.writeUInt32LE=h;function S(m,p){return m[p]}e.readUInt8=S;function w(m,p,E){m[E]=p}e.writeUInt8=w;function _(m){return R.consumeReadable(m,p=>P.concat(p))}e.readableToBuffer=_;function u(m){return R.toReadable(m)}e.bufferToReadable=u;function d(m){return R.consumeStream(m,p=>P.concat(p))}e.streamToBuffer=d;async function f(m){return m.ended?P.concat(m.buffer):P.concat([...m.buffer,await d(m.stream)])}e.bufferedStreamToBuffer=f;function t(m){return R.toStream(m,p=>P.concat(p))}e.bufferToStream=t;function n(m){return R.transform(m,{data:p=>typeof p=="string"?P.fromString(p):P.wrap(p)},p=>P.concat(p))}e.streamToBufferReadableStream=n;function i(m){return R.newWriteableStream(p=>P.concat(p),m)}e.newWriteableBufferStream=i;function r(m,p){return R.prefixedReadable(m,p,E=>P.concat(E))}e.prefixedBufferReadable=r;function o(m,p){return R.prefixedStream(m,p,E=>P.concat(E))}e.prefixedBufferStream=o}),define(pe[74],ve([0,1,8]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,_){switch(typeof w){case"object":return w===null?y(349,_):Array.isArray(w)?D(w,_):P(w,_);case"string":return C(w,_);case"boolean":return A(w,_);case"number":return y(w,_);case"undefined":return y(937,_);default:return y(617,_)}}e.doHash=k;function y(w,_){return(_<<5)-_+w|0}function A(w,_){return y(w?433:863,_)}function C(w,_){_=y(149417,_);for(let u=0,d=w.length;u<d;u++)_=y(w.charCodeAt(u),_);return _}e.stringHash=C;function D(w,_){return _=y(104579,_),w.reduce((u,d)=>k(d,u),_)}function P(w,_){return _=y(181387,_),Object.keys(w).sort().reduce((u,d)=>(u=C(d,u),k(w[d],u)),_)}class s{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=k(_,this._value),this._value}}e.Hasher=s;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function a(w,_,u=32){const d=u-_,f=~((1<<d)-1);return(w<<_|(f&w)>>>d)>>>0}function g(w,_=0,u=w.byteLength,d=0){for(let f=0;f<u;f++)w[_+f]=d}function c(w,_,u="0"){for(;w.length<_;)w=u+w;return w}function h(w,_=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),_/4)}e.toHexString=h;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const u=_.length;if(u===0)return;const d=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,i;for(t!==0?(n=t,i=-1,t=0):(n=_.charCodeAt(0),i=0);;){let r=n;if(v.isHighSurrogate(n))if(i+1<u){const o=_.charCodeAt(i+1);v.isLowSurrogate(o)?(i++,r=v.computeCodePoint(n,o)):r=65533}else{t=n;break}else v.isLowSurrogate(n)&&(r=65533);if(f=this._push(d,f,r),i++,i<u)n=_.charCodeAt(i);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(_,u,d){return d<128?_[u++]=d:d<2048?(_[u++]=192|(d&1984)>>>6,_[u++]=128|(d&63)>>>0):d<65536?(_[u++]=224|(d&61440)>>>12,_[u++]=128|(d&4032)>>>6,_[u++]=128|(d&63)>>>0):(_[u++]=240|(d&1835008)>>>18,_[u++]=128|(d&258048)>>>12,_[u++]=128|(d&4032)>>>6,_[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=S._bigBlock32,u=this._buffDV;for(let p=0;p<64;p+=4)_.setUint32(p,u.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)_.setUint32(p,a(_.getUint32(p-12,!1)^_.getUint32(p-32,!1)^_.getUint32(p-56,!1)^_.getUint32(p-64,!1),1),!1);let d=this._h0,f=this._h1,t=this._h2,n=this._h3,i=this._h4,r,o,m;for(let p=0;p<80;p++)p<20?(r=f&t|~f&n,o=1518500249):p<40?(r=f^t^n,o=1859775393):p<60?(r=f&t|f&n|t&n,o=2400959708):(r=f^t^n,o=3395469782),m=a(d,5)+r+i+o+_.getUint32(p*4,!1)&4294967295,i=n,n=t,t=a(f,30),f=d,d=m;this._h0=this._h0+d&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[52],ve([0,1,8]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const y="error",A="warning",C="warn",D="info",P="ignore";function s(a){return a?v.equalsIgnoreCase(y,a)?k.Error:v.equalsIgnoreCase(A,a)||v.equalsIgnoreCase(C,a)?k.Warning:v.equalsIgnoreCase(D,a)?k.Info:k.Ignore:k.Ignore}k.fromValue=s;function I(a){switch(a){case k.Error:return y;case k.Warning:return A;case k.Info:return D;default:return P}}k.toString=I}(R||(R={})),e.default=R}),define(pe[13],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(p){return Array.isArray(p)}e.isArray=v;function R(p){return typeof p=="string"}e.isString=R;function k(p){return Array.isArray(p)&&p.every(E=>R(E))}e.isStringArray=k;function y(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=y;function A(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=A;function C(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=C;function D(p){return p===!0||p===!1}e.isBoolean=D;function P(p){return typeof p=="undefined"}e.isUndefined=P;function s(p){return!I(p)}e.isDefined=s;function I(p){return P(p)||p===null}e.isUndefinedOrNull=I;function a(p,E){if(!p)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=a;function g(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=g;function c(...p){const E=[];for(let b=0;b<p.length;b++){const l=p[b];if(I(l))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);E.push(l)}return E}e.assertAllDefined=c;const h=Object.prototype.hasOwnProperty;function S(p){if(!y(p))return!1;for(let E in p)if(h.call(p,E))return!1;return!0}e.isEmptyObject=S;function w(p){return typeof p=="function"}e.isFunction=w;function _(...p){return p.length>0&&p.every(w)}e.areFunctions=_;function u(p,E){const b=Math.min(p.length,E.length);for(let l=0;l<b;l++)d(p[l],E[l])}e.validateConstraints=u;function d(p,E){if(R(E)){if(typeof p!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(w(E)){try{if(p instanceof E)return}catch(b){}if(!I(p)&&p.constructor===E||E.length===1&&E.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function f(p){let E=[],b=Object.getPrototypeOf(p);for(;Object.prototype!==b;)E=E.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return E}e.getAllPropertyNames=f;function t(p){const E=[];for(const b of f(p))typeof p[b]=="function"&&E.push(b);return E}e.getAllMethodNames=t;function n(p,E){const b=L=>function(){const O=Array.prototype.slice.call(arguments,0);return E(L,O)};let l={};for(const L of p)l[L]=b(L);return l}e.createProxyObject=n;function i(p){return p===null?void 0:p}e.withNullAsUndefined=i;function r(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=r;function o(p){return class{constructor(){return new Proxy({},{get(E,b){if(E[b])return E[b];throw new Error(`Not Implemented: ${p}->${String(b)}`)}})}}}e.NotImplementedProxy=o;function m(p){throw new Error("Unreachable")}e.assertNever=m}),define(pe[29],ve([0,1,11,8,9,13]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(i){return i===47||i===92}e.isPathSeparator=A;function C(i){return i.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=C;function D(i){return i.indexOf("/")===-1&&(i=C(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=D;function P(i,r=k.posix.sep){if(!i)return"";const o=i.length,m=i.charCodeAt(0);if(A(m)){if(A(i.charCodeAt(1))&&!A(i.charCodeAt(2))){let E=3;const b=E;for(;E<o&&!A(i.charCodeAt(E));E++);if(b!==E&&!A(i.charCodeAt(E+1))){for(E+=1;E<o;E++)if(A(i.charCodeAt(E)))return i.slice(0,E+1).replace(/[\\/]/g,r)}}return r}else if(w(m)&&i.charCodeAt(1)===58)return A(i.charCodeAt(2))?i.slice(0,2)+r:i.slice(0,2);let p=i.indexOf("://");if(p!==-1){for(p+=3;p<o;p++)if(A(i.charCodeAt(p)))return i.slice(0,p+1)}return""}e.getRoot=P;function s(i){if(!v.isWindows||!i||i.length<5)return!1;let r=i.charCodeAt(0);if(r!==92||(r=i.charCodeAt(1),r!==92))return!1;let o=2;const m=o;for(;o<i.length&&(r=i.charCodeAt(o),r!==92);o++);return!(m===o||(r=i.charCodeAt(o+1),isNaN(r)||r===92))}e.isUNC=s;const I=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(i,r=v.isWindows){const o=r?I:a;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||r&&g.test(i)||i==="."||i===".."||r&&i[i.length-1]==="."||r&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=c;function h(i,r,o){const m=i===r;return!o||m?m:!i||!r?!1:R.equalsIgnoreCase(i,r)}e.isEqual=h;function S(i,r,o,m=k.sep){if(i===r)return!0;if(!i||!r||r.length>i.length)return!1;if(o){if(!R.startsWithIgnoreCase(i,r))return!1;if(r.length===i.length)return!0;let E=r.length;return r.charAt(r.length-1)===m&&E--,i.charAt(E)===m}return r.charAt(r.length-1)!==m&&(r+=m),i.indexOf(r)===0}e.isEqualOrParent=S;function w(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=w;function _(i,r){return v.isWindows&&i.endsWith(":")&&(i+=k.sep),k.isAbsolute(i)||(i=k.join(r,i)),i=k.normalize(i),v.isWindows?(i=R.rtrim(i,k.sep),i.endsWith(":")&&(i+=k.sep)):(i=R.rtrim(i,k.sep),i||(i=k.sep)),i}e.sanitizeFilePath=_;function u(i){const r=k.normalize(i);return v.isWindows?i.length>3?!1:d(r)&&(i.length===2||r.charCodeAt(2)===92):r===k.posix.sep}e.isRootOrDriveLetter=u;function d(i){return v.isWindows?w(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function f(i){return d(i)?i[0]:void 0}e.getDriveLetter=f;function t(i,r,o){return r.length>i.length?-1:i===r?0:(o&&(i=i.toLowerCase(),r=r.toLowerCase()),i.indexOf(r))}e.indexOfPath=t;function n(i){const r=i.split(":");let o,m,p;if(r.forEach(E=>{const b=Number(E);y.isNumber(b)?m===void 0?m=b:p===void 0&&(p=b):o=o?[o,E].join(":"):E}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(pe[25],ve([0,1,13]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const S=Array.isArray(h)?[]:{};return Object.keys(h).forEach(w=>{h[w]&&typeof h[w]=="object"?S[w]=R(h[w]):S[w]=h[w]}),S}e.deepClone=R;function k(h){if(!h||typeof h!="object")return h;const S=[h];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const _ in w)if(y.call(w,_)){const u=w[_];typeof u=="object"&&!Object.isFrozen(u)&&S.push(u)}}return h}e.deepFreeze=k;const y=Object.prototype.hasOwnProperty;function A(h,S){return C(h,S,new Set)}e.cloneAndChange=A;function C(h,S,w){if(v.isUndefinedOrNull(h))return h;const _=S(h);if(typeof _!="undefined")return _;if(v.isArray(h)){const u=[];for(const d of h)u.push(C(d,S,w));return u}if(v.isObject(h)){if(w.has(h))throw new Error("Cannot clone recursive data-structure");w.add(h);const u={};for(let d in h)y.call(h,d)&&(u[d]=C(h[d],S,w));return w.delete(h),u}return h}function D(h,S,w=!0){return v.isObject(h)?(v.isObject(S)&&Object.keys(S).forEach(_=>{_ in h?w&&(v.isObject(h[_])&&v.isObject(S[_])?D(h[_],S[_],w):h[_]=S[_]):h[_]=S[_]}),h):S}e.mixin=D;function P(h,S){if(h===S)return!0;if(h==null||S===null||S===void 0||typeof h!=typeof S||typeof h!="object"||Array.isArray(h)!==Array.isArray(S))return!1;let w,_;if(Array.isArray(h)){if(h.length!==S.length)return!1;for(w=0;w<h.length;w++)if(!P(h[w],S[w]))return!1}else{const u=[];for(_ in h)u.push(_);u.sort();const d=[];for(_ in S)d.push(_);if(d.sort(),!P(u,d))return!1;for(w=0;w<u.length;w++)if(!P(h[u[w]],S[u[w]]))return!1}return!0}e.equals=P;function s(h){const S=new Set;return JSON.stringify(h,(w,_)=>{if(v.isObject(_)||Array.isArray(_)){if(S.has(_))return"[Circular]";S.add(_)}return _})}e.safeStringify=s;function I(h,S,w){const _=S(h);return typeof _=="undefined"?w:_}e.getOrDefault=I;function a(h,S){const w=Object.create(null);return!h||!S||Object.keys(S).forEach(u=>{const d=h[u],f=S[u];P(d,f)||(w[u]=f)}),w}e.distinct=a;function g(h,S){const w=S.toLowerCase(),_=Object.keys(h).find(u=>u.toLowerCase()===w);return _?h[_]:h[S]}e.getCaseInsensitive=g;function c(h,S){const w=Object.create(null);for(const _ of Object.keys(h))S(_,h[_])&&(w[_]=h[_]);return w}e.filter=c}),define(pe[93],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(y){y[y.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",y[y.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",y[y.MAX_UINT_8=255]="MAX_UINT_8",y[y.MAX_UINT_16=65535]="MAX_UINT_16",y[y.MAX_UINT_32=4294967295]="MAX_UINT_32",y[y.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(y){return y<0?0:y>255?255:y|0}e.toUint8=R;function k(y){return y<0?0:y>4294967295?4294967295:y|0}e.toUint32=k}),define(pe[2],ve([0,1,11,9]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,y=/^\//,A=/^\/\//;function C(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!y.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(i,r){return!i&&!r?"file":i}function P(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const s="",I="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(r,o,m,p,E,b=!1){typeof r=="object"?(this.scheme=r.scheme||s,this.authority=r.authority||s,this.path=r.path||s,this.query=r.query||s,this.fragment=r.fragment||s):(this.scheme=D(r,b),this.authority=o||s,this.path=P(this.scheme,m||s),this.query=p||s,this.fragment=E||s,C(this,b))}static isUri(r){return r instanceof g?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:m,path:p,query:E,fragment:b}=r;return o===void 0?o=this.scheme:o===null&&(o=s),m===void 0?m=this.authority:m===null&&(m=s),p===void 0?p=this.path:p===null&&(p=s),E===void 0?E=this.query:E===null&&(E=s),b===void 0?b=this.fragment:b===null&&(b=s),o===this.scheme&&m===this.authority&&p===this.path&&E===this.query&&b===this.fragment?this:new h(o,m,p,E,b)}static parse(r,o=!1){const m=a.exec(r);return m?new h(m[2]||s,n(m[4]||s),n(m[5]||s),n(m[7]||s),n(m[9]||s),o):new h(s,s,s,s,s)}static file(r){let o=s;if(v.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const m=r.indexOf(I,2);m===-1?(o=r.substring(2),r=I):(o=r.substring(2,m),r=r.substring(m)||I)}return new h("file",o,r,s,s)}static from(r){const o=new h(r.scheme,r.authority,r.path,r.query,r.fragment);return C(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return v.isWindows&&r.scheme==="file"?m=g.file(R.win32.join(u(r,!0),...o)).path:m=R.posix.join(r.path,...o),r.with({path:m})}toString(r=!1){return d(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof g)return r;{const o=new h(r);return o._formatted=r.external,o._fsPath=r._sep===c?r.fsPath:null,o}}else return r}}e.URI=g;const c=v.isWindows?1:void 0;class h extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=c),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(i,r){let o,m=-1;for(let p=0;p<i.length;p++){const E=i.charCodeAt(p);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||r&&E===47)m!==-1&&(o+=encodeURIComponent(i.substring(m,p)),m=-1),o!==void 0&&(o+=i.charAt(p));else{o===void 0&&(o=i.substr(0,p));const b=S[E];b!==void 0?(m!==-1&&(o+=encodeURIComponent(i.substring(m,p)),m=-1),o+=b):m===-1&&(m=p)}}return m!==-1&&(o+=encodeURIComponent(i.substring(m))),o!==void 0?o:i}function _(i){let r;for(let o=0;o<i.length;o++){const m=i.charCodeAt(o);m===35||m===63?(r===void 0&&(r=i.substr(0,o)),r+=S[m]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function u(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,v.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function d(i,r){const o=r?_:w;let m="",{scheme:p,authority:E,path:b,query:l,fragment:L}=i;if(p&&(m+=p,m+=":"),(E||p==="file")&&(m+=I,m+=I),E){let O=E.indexOf("@");if(O!==-1){const W=E.substr(0,O);E=E.substr(O+1),O=W.indexOf(":"),O===-1?m+=o(W,!1):(m+=o(W.substr(0,O),!1),m+=":",m+=o(W.substr(O+1),!1)),m+="@"}E=E.toLowerCase(),O=E.indexOf(":"),O===-1?m+=o(E,!1):(m+=o(E.substr(0,O),!1),m+=E.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}m+=o(b,!0)}return l&&(m+="?",m+=o(l,!1)),L&&(m+="#",m+=r?L:w(L,!1)),m}function f(i){try{return decodeURIComponent(i)}catch(r){return i.length>3?i.substr(0,3)+f(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(i){return i.match(t)?i.replace(t,r=>f(r)):i}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[23],ve([0,1,2,8]),function(Q,e,v,R){"use strict";var k,y,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,i){let r=t.get(n);return r===void 0&&(r=i,t.set(n,r)),r}e.getOrSet=C;function D(t){const n=[];return t.forEach((i,r)=>{n.push(`${r} => ${i}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function P(t){const n=[];return t.forEach(i=>{n.push(i)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=P;class s{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const i=n.charCodeAt(0),r=this._value.charCodeAt(this._pos);return i-r}value(){return this._value[this._pos]}}e.StringIterator=s;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?R.compareSubstring(n,this._value,0,n.length,this._from,this._to):R.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class a{constructor(n=!0,i=!0){this._splitOnBackslash=n,this._caseSensitive=i}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?R.compareSubstring(n,this._value,0,n.length,this._from,this._to):R.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=a;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class c{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(n,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return R.compare(n,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class h{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new c(n))}static forPaths(){return new S(new a)}static forStrings(){return new S(new s)}static forConfigKeys(){return new S(new I)}clear(){this._root=void 0}set(n,i){const r=this._iter.reset(n);let o;for(this._root||(this._root=new h,this._root.segment=r.value()),o=this._root;;){const p=r.cmp(o.segment);if(p>0)o.left||(o.left=new h,o.left.segment=r.value()),o=o.left;else if(p<0)o.right||(o.right=new h,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new h,o.mid.segment=r.value()),o=o.mid;else break}const m=o.value;return o.value=i,o.key=n,m}get(n){var i;return(i=this._getNode(n))===null||i===void 0?void 0:i.value}_getNode(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const o=i.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else break}return r}has(n){const i=this._getNode(n);return!((i==null?void 0:i.value)===void 0&&(i==null?void 0:i.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,i){const r=this._iter.reset(n),o=[];let m=this._root;for(;m;){const p=r.cmp(m.segment);if(p>0)o.push([1,m]),m=m.left;else if(p<0)o.push([-1,m]),m=m.right;else if(r.hasNext())r.next(),o.push([0,m]),m=m.mid;else{for(i?(m.left=void 0,m.mid=void 0,m.right=void 0):m.value=void 0;o.length>0&&m.isEmpty();){let[E,b]=o.pop();switch(E){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}m=b}break}}}findSubstr(n){const i=this._iter.reset(n);let r=this._root,o;for(;r;){const m=i.cmp(r.segment);if(m>0)r=r.left;else if(m<0)r=r.right;else if(i.hasNext())i.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(n){const i=this._iter.reset(n);let r=this._root;for(;r;){const o=i.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(i.hasNext())i.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(n){for(const[i,r]of this)n(r,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n,i=0){if(i>5e3){console.log("potential CYCLE detected",new Error().stack);return}n&&(yield*this._entries(n.left,i++),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid,i++),yield*this._entries(n.right,i++))}}e.TernarySearchTree=S;class w{constructor(n,i){this[k]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=i??w.defaultToKey):(this.map=new Map,this.toKey=n??w.defaultToKey)}set(n,i){return this.map.set(this.toKey(n),i),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,i){typeof i!="undefined"&&(n=n.bind(i));for(let[r,o]of this.map)n(o,v.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield v.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[v.URI.parse(n[0]),n[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[v.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,i=0){const r=this._map.get(n);if(!!r)return i!==0&&this.touch(r,i),r.value}set(n,i,r=0){let o=this._map.get(n);if(o)o.value=i,r!==0&&this.touch(o,r);else{switch(o={key:n,value:i,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this._map.get(n);if(!!i)return this._map.delete(n),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,i){const r=this._state;let o=this._head;for(;o;){if(i?n.bind(i)(o.value,o.key,this):n(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.key,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}values(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:r.value,done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}entries(){const n=this,i=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==i)throw new Error("LinkedMap got modified during iteration.");if(r){const m={value:[r.key,r.value],done:!1};return r=r.next,m}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this._head,r=this.size;for(;i&&r>n;)this._map.delete(i.key),i=i.next,r--;this._head=i,this._size=r,i&&(i.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const i=n.next,r=n.previous;if(!i||!r)throw new Error("Invalid list");i.previous=r,r.next=i}n.next=void 0,n.previous=void 0,this._state++}touch(n,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(n===this._head)return;const r=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(i===2){if(n===this._tail)return;const r=n.next,o=n.previous;n===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((i,r)=>{n.push([r,i])}),n}fromJSON(n){this.clear();for(const[i,r]of n)this.set(i,r)}}e.LinkedMap=u;class d extends u{constructor(n,i=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,i=2){return super.get(n,i)}peek(n){return super.get(n,0)}set(n,i){return super.set(n,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class f{constructor(n){A.set(this,void 0),nt(this,A,n,"f")}get size(){return Be(this,A,"f").size}forEach(n,i){Be(this,A,"f").forEach(n,i)}get(n){return Be(this,A,"f").get(n)}has(n){return Be(this,A,"f").has(n)}entries(){return Be(this,A,"f").entries()}keys(){return Be(this,A,"f").keys()}values(){return Be(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Be(this,A,"f").entries()}}e.ReadonlyMapView=f}),define(pe[94],ve([0,1,23,8]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(ce,ge){for(let Re=0,we=Y.length;Re<we;Re++){const je=Y[Re](ce,ge);if(je)return je}return null}}e.or=k,e.matchesStrictPrefix=y.bind(void 0,!1),e.matchesPrefix=y.bind(void 0,!0);function y(Y,ce,ge){if(!ge||ge.length<ce.length)return null;let Re;return Y?Re=R.startsWithIgnoreCase(ge,ce):Re=ge.indexOf(ce)===0,Re?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(Y,ce){const ge=ce.toLowerCase().indexOf(Y.toLowerCase());return ge===-1?null:[{start:ge,end:ge+Y.length}]}e.matchesContiguousSubString=A;function C(Y,ce){return D(Y.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(Y,ce,ge,Re){if(ge===Y.length)return[];if(Re===ce.length)return null;if(Y[ge]===ce[Re]){let we=null;return(we=D(Y,ce,ge+1,Re+1))?w({start:Re,end:Re+1},we):null}return D(Y,ce,ge,Re+1)}function P(Y){return 97<=Y&&Y<=122}function s(Y){return 65<=Y&&Y<=90}e.isUpper=s;function I(Y){return 48<=Y&&Y<=57}function a(Y){return Y===32||Y===9||Y===10||Y===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>g.add(Y.charCodeAt(0)));function c(Y){return a(Y)||g.has(Y)}function h(Y,ce){return Y===ce||c(Y)&&c(ce)}function S(Y){return P(Y)||s(Y)||I(Y)}function w(Y,ce){return ce.length===0?ce=[Y]:Y.end===ce[0].start?ce[0].start=Y.start:ce.unshift(Y),ce}function _(Y,ce){for(let ge=ce;ge<Y.length;ge++){const Re=Y.charCodeAt(ge);if(s(Re)||I(Re)||ge>0&&!S(Y.charCodeAt(ge-1)))return ge}return Y.length}function u(Y,ce,ge,Re){if(ge===Y.length)return[];if(Re===ce.length)return null;if(Y[ge]!==ce[Re].toLowerCase())return null;{let we=null,je=Re+1;for(we=u(Y,ce,ge+1,Re+1);!we&&(je=_(ce,je))<ce.length;)we=u(Y,ce,ge+1,je),je++;return we===null?null:w({start:Re,end:Re+1},we)}}function d(Y){let ce=0,ge=0,Re=0,we=0,je=0;for(let $e=0;$e<Y.length;$e++)je=Y.charCodeAt($e),s(je)&&ce++,P(je)&&ge++,S(je)&&Re++,I(je)&&we++;const G=ce/Y.length,ie=ge/Y.length,Ee=Re/Y.length,Ne=we/Y.length;return{upperPercent:G,lowerPercent:ie,alphaPercent:Ee,numericPercent:Ne}}function f(Y){const{upperPercent:ce,lowerPercent:ge}=Y;return ge===0&&ce>.6}function t(Y){const{upperPercent:ce,lowerPercent:ge,alphaPercent:Re,numericPercent:we}=Y;return ge>.2&&ce<.8&&Re>.6&&we<.2}function n(Y){let ce=0,ge=0,Re=0,we=0;for(let je=0;je<Y.length;je++)Re=Y.charCodeAt(je),s(Re)&&ce++,P(Re)&&ge++,a(Re)&&we++;return(ce===0||ge===0)&&we===0?Y.length<=30:ce<=5}function i(Y,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!n(Y)||ce.length>60)return null;const ge=d(ce);if(!t(ge)){if(!f(ge))return null;ce=ce.toLowerCase()}let Re=null,we=0;for(Y=Y.toLowerCase();we<ce.length&&(Re=u(Y,ce,0,we))===null;)we=_(ce,we+1);return Re}e.matchesCamelCase=i;function r(Y,ce,ge=!1){if(!ce||ce.length===0)return null;let Re=null,we=0;for(Y=Y.toLowerCase(),ce=ce.toLowerCase();we<ce.length&&(Re=o(Y,ce,0,we,ge))===null;)we=m(ce,we+1);return Re}e.matchesWords=r;function o(Y,ce,ge,Re,we){if(ge===Y.length)return[];if(Re===ce.length)return null;if(h(Y.charCodeAt(ge),ce.charCodeAt(Re))){let je=null,G=Re+1;if(je=o(Y,ce,ge+1,Re+1,we),!we)for(;!je&&(G=m(ce,G))<ce.length;)je=o(Y,ce,ge+1,G,we),G++;return je===null?null:w({start:Re,end:Re+1},je)}else return null}function m(Y,ce){for(let ge=ce;ge<Y.length;ge++)if(c(Y.charCodeAt(ge))||ge>0&&c(Y.charCodeAt(ge-1)))return ge;return Y.length}const p=k(e.matchesPrefix,i,A),E=k(e.matchesPrefix,i,C),b=new v.LRUCache(1e4);function l(Y,ce,ge=!1){if(typeof Y!="string"||typeof ce!="string")return null;let Re=b.get(Y);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),b.set(Y,Re));const we=Re.exec(ce);return we?[{start:we.index,end:we.index+we[0].length}]:ge?E(Y,ce):p(Y,ce)}e.matchesFuzzy=l;function L(Y,ce){const ge=qe(Y,Y.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return ge?W(ge):null}e.matchesFuzzy2=L;function O(Y,ce,ge,Re,we,je){const G=Math.min(13,Y.length);for(;ge<G;ge++){const ie=qe(Y,ce,ge,Re,we,je,!1);if(ie)return ie}return[0,je]}e.anyScore=O;function W(Y){if(typeof Y=="undefined")return[];const ce=[],ge=Y[1];for(let Re=Y.length-1;Re>1;Re--){const we=Y[Re]+ge,je=ce[ce.length-1];je&&je.end===we?je.end=we+1:ce.push({start:we,end:we+1})}return ce}e.createMatches=W;const Z=128;function oe(){const Y=[],ce=[];for(let ge=0;ge<=Z;ge++)ce[ge]=0;for(let ge=0;ge<=Z;ge++)Y.push(ce.slice(0));return Y}function V(Y){const ce=[];for(let ge=0;ge<=Y;ge++)ce[ge]=0;return ce}const $=V(2*Z),j=V(2*Z),T=oe(),N=oe(),F=oe(),M=!1;function U(Y,ce,ge,Re,we){function je(ie,Ee,Ne=" "){for(;ie.length<Ee;)ie=Ne+ie;return ie}let G=` |   |${Re.split("").map(ie=>je(ie,3)).join("|")}
`;for(let ie=0;ie<=ge;ie++)ie===0?G+=" |":G+=`${ce[ie-1]}|`,G+=Y[ie].slice(0,we+1).map(Ee=>je(Ee.toString(),3)).join("|")+`
`;return G}function x(Y,ce,ge,Re){Y=Y.substr(ce),ge=ge.substr(Re),console.log(U(N,Y,Y.length,ge,ge.length)),console.log(U(F,Y,Y.length,ge,ge.length)),console.log(U(T,Y,Y.length,ge,ge.length))}function K(Y,ce){if(ce<0||ce>=Y.length)return!1;const ge=Y.codePointAt(ce);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ge)}}function se(Y,ce){if(ce<0||ce>=Y.length)return!1;switch(Y.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function be(Y,ce,ge){return ce[Y]!==ge[Y]}function Te(Y,ce,ge,Re,we,je,G=!1){for(;ce<ge&&we<je;)Y[ce]===Re[we]&&(G&&($[ce]=we),ce+=1),we+=1;return ce===ge}e.isPatternInWord=Te;var Ce;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Fe;(function(Y){Y.Default=[-100,0];function ce(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}Y.isDefault=ce})(Fe=e.FuzzyScore||(e.FuzzyScore={}));function qe(Y,ce,ge,Re,we,je,G){const ie=Y.length>Z?Z:Y.length,Ee=Re.length>Z?Z:Re.length;if(ge>=ie||je>=Ee||ie-ge>Ee-je||!Te(ce,ge,ie,we,je,Ee,!0))return;ze(ie,Ee,ge,je,ce,we);let Ne=1,$e=1,We=ge,Xe=je;const De=[!1];for(Ne=1,We=ge;We<ie;Ne++,We++){const H=$[We],ee=j[We],ue=We+1<ie?j[We+1]:Ee;for($e=H-je+1,Xe=H;Xe<ue;$e++,Xe++){let Pe=Number.MIN_SAFE_INTEGER,Ie=!1;Xe<=ee&&(Pe=Ge(Y,ce,We,ge,Re,we,Xe,Ee,je,T[Ne-1][$e-1]===0,De));let Ue=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ue=Pe+N[Ne-1][$e-1]);const xe=Xe>H,Qe=xe?N[Ne][$e-1]+(T[Ne][$e-1]>0?-5:0):0,rt=Xe>H+1&&T[Ne][$e-1]>0,tt=rt?N[Ne][$e-2]+(T[Ne][$e-2]>0?-5:0):0;if(rt&&(!xe||tt>=Qe)&&(!Ie||tt>=Ue))N[Ne][$e]=tt,F[Ne][$e]=3,T[Ne][$e]=0;else if(xe&&(!Ie||Qe>=Ue))N[Ne][$e]=Qe,F[Ne][$e]=2,T[Ne][$e]=0;else if(Ie)N[Ne][$e]=Ue,F[Ne][$e]=1,T[Ne][$e]=T[Ne-1][$e-1]+1;else throw new Error("not possible")}}if(M&&x(Y,ge,Re,je),!De[0]&&!G)return;Ne--,$e--;const ye=[N[Ne][$e],je];let ke=0,le=0;for(;Ne>=1;){let H=$e;do{const ee=F[Ne][H];if(ee===3)H=H-2;else if(ee===2)H=H-1;else break}while(H>=1);ke>1&&ce[ge+Ne-1]===we[je+$e-1]&&!be(H+je-1,Re,we)&&ke+1>T[Ne][H]&&(H=$e),H===$e?ke++:ke=1,le||(le=H),Ne--,$e=H-1,ye.push($e)}Ee===ie&&(ye[0]+=2);const he=le-ie;return ye[0]-=he,ye}e.fuzzyScore=qe;function ze(Y,ce,ge,Re,we,je){let G=Y-1,ie=ce-1;for(;G>=ge&&ie>=Re;)we[G]===je[ie]&&(j[G]=ie,G--),ie--}function Ge(Y,ce,ge,Re,we,je,G,ie,Ee,Ne,$e){if(ce[ge]!==je[G])return Number.MIN_SAFE_INTEGER;let We=1,Xe=!1;return G===ge-Re?We=Y[ge]===we[G]?7:5:be(G,we,je)&&(G===0||!be(G-1,we,je))?(We=Y[ge]===we[G]?7:5,Xe=!0):K(je,G)&&(G===0||!K(je,G-1))?We=5:(K(je,G-1)||se(je,G-1))&&(We=5,Xe=!0),We>1&&ge===Re&&($e[0]=!0),Xe||(Xe=be(G,we,je)||K(je,G-1)||se(je,G-1)),ge===Re?G>Ee&&(We-=Xe?3:5):Ne?We+=Xe?2:0:We+=Xe?0:1,G+1===ie&&(We-=Xe?3:5),We}function q(Y,ce,ge,Re,we,je,G){return re(Y,ce,ge,Re,we,je,!0,G)}e.fuzzyScoreGracefulAggressive=q;function J(Y,ce,ge,Re,we,je,G){return re(Y,ce,ge,Re,we,je,!1,G)}e.fuzzyScoreGraceful=J;function re(Y,ce,ge,Re,we,je,G,ie){let Ee=qe(Y,ce,ge,Re,we,je,ie);if(Ee&&!G)return Ee;if(Y.length>=3){const Ne=Math.min(7,Y.length-1);for(let $e=ge+1;$e<Ne;$e++){const We=ae(Y,$e);if(We){const Xe=qe(We,We.toLowerCase(),ge,Re,we,je,ie);Xe&&(Xe[0]-=3,(!Ee||Xe[0]>Ee[0])&&(Ee=Xe))}}}return Ee}function ae(Y,ce){if(ce+1>=Y.length)return;const ge=Y[ce],Re=Y[ce+1];if(ge!==Re)return Y.slice(0,ce)+Re+ge+Y.slice(ce+2)}}),define(pe[135],ve([0,1,91,94,8]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const y=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${y.source}`,"g");function C(h){return h.replace(A,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${y.source}`,"g");function P(h){return h.replace(D,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=P;const s=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function I(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(s,(S,w,_,u)=>_?S:w||u||"")}e.stripIcons=I;function a(h){const S=h.indexOf(e.iconStartMarker);return S===-1?{text:h}:g(h,S)}e.parseLabelWithIcons=a;function g(h,S){const w=[];let _="";function u(m){if(m){_+=m;for(const p of m)w.push(t)}}let d=-1,f="",t=0,n,i,r=S;const o=h.length;for(u(h.substr(0,S));r<o;)n=h[r],i=h[r+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(d=r,u(f),f=e.iconStartMarker,r++):n===")"&&d!==-1?(t+=r-d+1,d=-1,f=""):d!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(u(f),d=-1,f=""):u(n),r++;return u(f),{text:_,iconOffsets:w}}function c(h,S,w=!1){const{text:_,iconOffsets:u}=S;if(!u||u.length===0)return R.matchesFuzzy(h,_,w);const d=k.ltrim(_," "),f=_.length-d.length,t=R.matchesFuzzy(h,d,w);if(t)for(const n of t){const i=u[n.start+f]+f;n.start+=i,n.end+=i}return t}e.matchesFuzzyIconAware=c}),define(pe[95],ve([0,1,135,16]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(g="",c=!1){var h,S;if(this.value=g,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(h=c.isTrusted)!==null&&h!==void 0?h:void 0,this.supportThemeIcons=(S=c.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(g,c=0){return this.value+=P(this.supportThemeIcons?v.escapeIcons(g):g).replace(/([ \t]+)/g,(h,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,c){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=y;function A(a){return C(a)?!a.value:Array.isArray(a)?a.every(A):!0}e.isEmptyMarkdownString=A;function C(a){return a instanceof y?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function D(a,g){return a===g?!0:!a||!g?!1:a.value===g.value&&a.isTrusted===g.isTrusted&&a.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=D;function P(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function s(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=s;function I(a){const g=[],c=a.split("|").map(S=>S.trim());a=c[0];const h=c[1];if(h){const S=/height=(\d+)/.exec(h),w=/width=(\d+)/.exec(h),_=S?S[1]:"",u=w?w[1]:"",d=isFinite(parseInt(u)),f=isFinite(parseInt(_));d&&g.push(`width="${u}"`),f&&g.push(`height="${_}"`)}return{href:a,dimensions:g}}e.parseHrefAndDimensions=I}),define(pe[53],ve([0,1,22,8,2]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(P){return JSON.stringify(P,C)}e.stringify=y;function A(P){let s=JSON.parse(P);return s=D(s),s}e.parse=A;function C(P,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:R.regExpFlags(s)}:s}function D(P,s=0){if(!P||s>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof v.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=D(P[I],s+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=D(P[I],s+1))}return P}e.revive=D}),define(pe[10],ve([0,1,2,11]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,s){this._hosts[D]=P,this._ports[D]=s}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let s=this._hosts[P];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const I=this._ports[P],a=this._connectionTokens[P];let g=`path=${encodeURIComponent(D.path)}`;return typeof a=="string"&&(g+=`&tkn=${encodeURIComponent(a)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${s}:${I}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new y;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,s){const I=this.toUri(D,P);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):R.isNative&&(s||R.isPreferringBrowserCodeLoad)&&I.scheme===k.file?I.with({scheme:k.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,P){const s=this.toUri(D,P);return s.scheme===k.vscodeFileResource?s.with({scheme:k.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,P){return v.URI.isUri(D)?D:v.URI.parse(P.toUrl(D))}}e.FileAccess=new A}),define(pe[75],ve([0,1,23]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function k(P){return D(P,"NFC",R)}e.normalizeNFC=k;const y=new v.LRUCache(1e4);function A(P){return D(P,"NFD",y)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function D(P,s,I){if(!e.canNormalize||!P)return P;const a=I.get(P);if(a)return a;let g;return C.test(P)?g=P.normalize(s):g=P,I.set(P,g),g}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(s){return A(s).replace(P,"")}}else return function(P){return P}}()}),define(pe[24],ve([0,1,29,9,2,8,10,11]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return k.uriToFsPath(g,!0)}e.originalFSPath=D;class P{constructor(c){this._ignorePathCasing=c}compare(c,h,S=!1){return c===h?0:y.compare(this.getComparisonKey(c,S),this.getComparisonKey(h,S))}isEqual(c,h,S=!1){return c===h?!0:!c||!h?!1:this.getComparisonKey(c,S)===this.getComparisonKey(h,S)}getComparisonKey(c,h=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,h,S=!1){if(c.scheme===h.scheme){if(c.scheme===A.Schemas.file)return v.isEqualOrParent(D(c),D(h),this._ignorePathCasing(c))&&c.query===h.query&&(S||c.fragment===h.fragment);if(e.isEqualAuthority(c.authority,h.authority))return v.isEqualOrParent(c.path,h.path,this._ignorePathCasing(c),"/")&&c.query===h.query&&(S||c.fragment===h.fragment)}return!1}joinPath(c,...h){return k.URI.joinPath(c,...h)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let h;return c.scheme===A.Schemas.file?h=k.URI.file(R.dirname(D(c))).path:(h=R.posix.dirname(c.path),c.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),h="/")),c.with({path:h})}normalizePath(c){if(!c.path.length)return c;let h;return c.scheme===A.Schemas.file?h=k.URI.file(R.normalize(D(c))).path:h=R.posix.normalize(c.path),c.with({path:h})}relativePath(c,h){if(c.scheme!==h.scheme||!e.isEqualAuthority(c.authority,h.authority))return;if(c.scheme===A.Schemas.file){const _=R.relative(D(c),D(h));return C.isWindows?v.toSlashes(_):_}let S=c.path||"/",w=h.path||"/";if(this._ignorePathCasing(c)){let _=0;for(const u=Math.min(S.length,w.length);_<u&&!(S.charCodeAt(_)!==w.charCodeAt(_)&&S.charAt(_).toLowerCase()!==w.charAt(_).toLowerCase());_++);S=w.substr(0,_)+S.substr(_)}return R.posix.relative(S,w)}resolvePath(c,h){if(c.scheme===A.Schemas.file){const S=k.URI.file(R.resolve(D(c),h));return c.with({authority:S.authority,path:S.path})}return h=v.toPosixPath(h),c.with({path:R.posix.resolve(c.path,h)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,h){return c===h||y.equalsIgnoreCase(c,h)}hasTrailingPathSeparator(c,h=R.sep){if(c.scheme===A.Schemas.file){const S=D(c);return S.length>v.getRoot(S).length&&S[S.length-1]===h}else{const S=c.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,h=R.sep){return e.hasTrailingPathSeparator(c,h)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,h=R.sep){let S=!1;if(c.scheme===A.Schemas.file){const w=D(c);S=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===h}else{h="/";const w=c.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(c,h)?c.with({path:c.path+"/"}):c}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(g=>g.scheme===A.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(g,c){const h=[];for(let S=0;S<g.length;S++){const w=c(g[S]);g.some((_,u)=>u===S?!1:e.isEqualOrParent(w,c(_)))||h.push(g[S])}return h}e.distinctParents=s;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function c(h){const S=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,f]=u.split(":");d&&f&&S.set(d,f)});const _=h.path.substring(0,h.path.indexOf(";"));return _&&S.set(g.META_DATA_MIME,_),S}g.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function a(g,c,h){if(c){let S=g.path;return S&&S[0]!==R.posix.sep&&(S=R.posix.sep+S),g.with({scheme:h,authority:c,path:S})}return g.with({scheme:h})}e.toLocalResource=a}),define(pe[14],ve([0,1,21,16,3,6,72,24]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function P(N){const F=new v.CancellationTokenSource,M=N(F.token),U=new Promise((x,K)=>{F.token.onCancellationRequested(()=>{K(R.canceled())}),Promise.resolve(M).then(se=>{F.dispose(),x(se)},se=>{F.dispose(),K(se)})});return new class{cancel(){F.cancel()}then(x,K){return U.then(x,K)}catch(x){return this.then(void 0,x)}finally(x){return U.finally(x)}}}e.createCancelablePromise=P;function s(N,F,M){return Promise.race([N,new Promise(U=>F.onCancellationRequested(()=>U(M)))])}e.raceCancellation=s;async function I(N){let F=-1;const M=N.map((x,K)=>x.then(se=>(F=K,se))),U=await Promise.race(M);return N.forEach((x,K)=>{K!==F&&x.cancel()}),U}e.raceCancellablePromises=I;function a(N,F,M){let U;const x=setTimeout(()=>{U==null||U(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(x)),new Promise(K=>U=K)])}e.raceTimeout=a;function g(N){return new Promise((F,M)=>{const U=N();D(U)?U.then(F,M):F(U)})}e.asPromise=g;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(M,M).then(U)})}return new Promise((M,U)=>{this.queuedPromise.then(M,U)})}return this.activePromise=F(),new Promise((M,U)=>{this.activePromise.then(x=>{this.activePromise=null,M(x)},x=>{this.activePromise=null,U(x)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=h;class S{constructor(){this.promiseMap=new Map}queue(F,M){var U;const K=((U=this.promiseMap.get(F))!==null&&U!==void 0?U:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===K&&this.promiseMap.delete(F)});return this.promiseMap.set(F,K),K}}e.SequencerByKey=S;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,x)=>{this.doResolve=U,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class _{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function f(N,F){return F?new Promise((M,U)=>{const x=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(x),U(R.canceled())})}):P(M=>f(N,M))}e.timeout=f;function t(N,F=0){const M=setTimeout(N,F);return y.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function n(N){return N.then(void 0,F=>{})}e.ignoreErrors=n;function i(N){const F=[];let M=0;const U=N.length;function x(){return M<U?N[M++]():null}function K(se){se!=null&&F.push(se);const be=x();return be?be.then(K):Promise.resolve(F)}return Promise.resolve(null).then(K)}e.sequence=i;function r(N,F=U=>!!U,M=null){let U=0;const x=N.length,K=()=>{if(U>=x)return Promise.resolve(M);const se=N[U++];return Promise.resolve(se()).then(Te=>F(Te)?Promise.resolve(Te):K())};return K()}e.first=r;function o(N,F=U=>!!U,M=null){if(N.length===0)return Promise.resolve(M);let U=N.length;const x=()=>{var K,se;U=-1;for(const be of N)(se=(K=be).cancel)===null||se===void 0||se.call(K)};return new Promise((K,se)=>{for(const be of N)be.then(Te=>{--U>=0&&F(Te)?(x(),K(Te)):U===0&&K(M)}).catch(Te=>{--U>=0&&(x(),se(Te))})})}e.firstParallel=o;class m{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,U)=>{this.outstandingPromises.push({factory:F,c:M,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class p extends m{constructor(){super(1)}}e.Queue=p;class E{constructor(){this.queues=new Map}queueFor(F,M=C.extUri){const U=M.getComparisonKey(F);let x=this.queues.get(U);return x||(x=new p,k.Event.once(x.onFinished)(()=>{x==null||x.dispose(),this.queues.delete(U)}),this.queues.set(U,x)),x}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=E;class b{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=b;class l{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=l;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let U=!1;return{dispose(){U||(U=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function Z(N,F,M){let U;for(let x=0;x<M;x++)try{return await N()}catch(K){U=K,await f(F)}throw U}e.retry=Z;class oe{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,U){return this._pending={taskId:F,cancel:()=>U==null?void 0:U(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,U;const x=new Promise((K,se)=>{M=K,U=se});this._next={run:F,promise:x,promiseResolve:M,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=oe;class V{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=$;class j extends k.Emitter{async fireAsync(F,M,U){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const x of this._listeners)this._asyncDeliveryQueue.push([x,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[x,K]=this._asyncDeliveryQueue.shift(),se=[],be=Object.assign(Object.assign({},K),{waitUntil:Te=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");U&&(Te=U(Te,typeof x=="function"?x:x[0])),se.push(Te)}});try{typeof x=="function"?x.call(void 0,be):x[0].call(x[1],be)}catch(Te){R.onUnexpectedError(Te);continue}Object.freeze(se),await T.settled(se).catch(Te=>R.onUnexpectedError(Te))}}}}e.AsyncEmitter=j;var T;(function(N){async function F(K){return typeof Promise.allSettled=="function"?M(K):U(K)}N.allSettled=F;async function M(K){return Promise.allSettled(K)}async function U(K){return Promise.all(K.map(se=>se.then(be=>({status:"fulfilled",value:be}),be=>({status:"rejected",reason:be}))))}async function x(K){let se;const be=await Promise.all(K.map(Te=>Te.then(Ce=>Ce,Ce=>{se||(se=Ce)})));if(typeof se!="undefined")throw se;return be}N.settled=x})(T=e.Promises||(e.Promises={}))}),define(pe[96],ve([0,1,9,14]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const b=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:b,collatorIsNumeric:b.resolvedOptions().numeric}}),y=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(b,l,L=!1){const O=b||"",W=l||"",Z=k.value.collator.compare(O,W);return k.value.collatorIsNumeric&&Z===0&&O!==W?O<W?-1:1:Z}e.compareFileNames=C;function D(b,l){const L=y.value.collator;return b=b||"",l=l||"",f(L,b,l)}e.compareFileNamesDefault=D;function P(b,l){const L=y.value.collator;return b=b||"",l=l||"",r(b,l)||f(L,b,l)}e.compareFileNamesUpper=P;function s(b,l){const L=y.value.collator;return b=b||"",l=l||"",i(b,l)||f(L,b,l)}e.compareFileNamesLower=s;function I(b,l){return b=b||"",l=l||"",b===l?0:b<l?-1:1}e.compareFileNamesUnicode=I;function a(b,l,L=!1){L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase());const[O,W]=u(b),[Z,oe]=u(l);return O!==Z?O<Z?-1:1:W===oe?0:W<oe?-1:1}e.noIntlCompareFileNames=a;function g(b,l){const[L,O]=u(b),[W,Z]=u(l);let oe=k.value.collator.compare(O,Z);if(oe===0){if(k.value.collatorIsNumeric&&O!==Z)return O<Z?-1:1;if(oe=k.value.collator.compare(L,W),k.value.collatorIsNumeric&&oe===0&&L!==W)return L<W?-1:1}return oe}e.compareFileExtensions=g;function c(b,l){b=b||"",l=l||"";const L=d(b),O=d(l),W=y.value.collator,Z=A.value.collator;return f(Z,L,O)||f(W,b,l)}e.compareFileExtensionsDefault=c;function h(b,l){b=b||"",l=l||"";const L=d(b),O=d(l),W=y.value.collator,Z=A.value.collator;return f(Z,L,O)||r(b,l)||f(W,b,l)}e.compareFileExtensionsUpper=h;function S(b,l){b=b||"",l=l||"";const L=d(b),O=d(l),W=y.value.collator,Z=A.value.collator;return f(Z,L,O)||i(b,l)||f(W,b,l)}e.compareFileExtensionsLower=S;function w(b,l){b=b||"",l=l||"";const L=d(b).toLowerCase(),O=d(l).toLowerCase();return L!==O?L<O?-1:1:b!==l?b<l?-1:1:0}e.compareFileExtensionsUnicode=w;const _=/^(.*?)(\.([^.]*))?$/;function u(b,l=!1){const L=b?_.exec(b):[];let O=[L&&L[1]||"",L&&L[3]||""];return l&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function d(b){const l=b?_.exec(b):[];return l&&l[1]&&l[1].charAt(0)!=="."&&l[3]||""}function f(b,l,L){let O=b.compare(l,L);return O!==0?O:l.length!==L.length?l.length<L.length?-1:1:0}function t(b){const l=b.charAt(0);return l.toLocaleUpperCase()!==l}function n(b){const l=b.charAt(0);return l.toLocaleLowerCase()!==l}function i(b,l){return t(b)&&n(l)?-1:n(b)&&t(l)?1:0}function r(b,l){return n(b)&&t(l)?-1:t(b)&&n(l)?1:0}function o(b,l,L=!1){return L||(b=b&&b.toLowerCase(),l=l&&l.toLowerCase()),b===l?0:b<l?-1:1}function m(b,l,L=!1){const O=b.split(v.sep),W=l.split(v.sep),Z=O.length-1,oe=W.length-1;let V,$;for(let j=0;;j++){if(V=Z===j,$=oe===j,V&&$)return C(O[j],W[j],L);if(V)return-1;if($)return 1;const T=o(O[j],W[j],L);if(T!==0)return T}}e.comparePaths=m;function p(b,l,L){const O=b.toLowerCase(),W=l.toLowerCase(),Z=E(b,l,L);if(Z)return Z;const oe=O.endsWith(L),V=W.endsWith(L);if(oe!==V)return oe?-1:1;const $=C(O,W);return $!==0?$:O.localeCompare(W)}e.compareAnything=p;function E(b,l,L){const O=b.toLowerCase(),W=l.toLowerCase(),Z=O.startsWith(L),oe=W.startsWith(L);if(Z!==oe)return Z?-1:1;if(Z&&oe){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=E}),define(pe[97],ve([0,1,96,94,9,11,8]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,D=[C,[]];function P(V,$,j,T){if(!V||!$)return D;const N=V.length,F=$.length;if(N<F)return D;const M=V.toLowerCase();return!T&&!M.includes(j)?D:s($,j,F,V,M,N)}e.scoreFuzzy=P;function s(V,$,j,T,N,F){const M=[],U=[];for(let be=0;be<j;be++){const Te=be*F,Ce=Te-F,Fe=be>0,qe=V[be],ze=$[be];for(let Ge=0;Ge<F;Ge++){const q=Ge>0,J=Te+Ge,re=J-1,ae=Ce+Ge-1,Y=q?M[re]:0,ce=Fe&&q?M[ae]:0,ge=Fe&&q?U[ae]:0;let Re;!ce&&Fe?Re=0:Re=I(qe,ze,T,N,Ge,ge),Re&&ce+Re>=Y?(U[J]=ge+1,M[J]=ce+Re):(U[J]=C,M[J]=Y)}}const x=[];let K=j-1,se=F-1;for(;K>=0&&se>=0;){const be=K*F+se;U[be]===C||(x.push(se),K--),se--}return[M[j*F-1],x.reverse()]}function I(V,$,j,T,N,F){let M=0;if(!a($,T[N]))return M;if(M+=1,F>0&&(M+=F*5),V===j[N]&&(M+=1),N===0)M+=8;else{const U=g(j.charCodeAt(N-1));U?M+=U:R.isUpper(j.charCodeAt(N))&&(M+=2)}return M}function a(V,$){return V===$?!0:V==="/"||V==="\\"?$==="/"||$==="\\":!1}function g(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function h(V,$,j=0,T=0){const N=$;return N.values&&N.values.length>1?S(V,N.values,j,T):w(V,$,j,T)}e.scoreFuzzy2=h;function S(V,$,j,T){let N=0;const F=[];for(const M of $){const[U,x]=w(V,M,j,T);if(typeof U!="number")return c;N+=U,F.push(...x)}return[N,m(F)]}function w(V,$,j,T){const N=R.fuzzyScore($.original,$.originalLowercase,j,V,V.toLowerCase(),T,!0);return N?[N[0],R.createMatches(N)]:c}const _=Object.freeze({score:0}),u=1<<18,d=1<<17,f=1<<16;function t(V,$,j,T,N){if(!V||!$.normalized)return _;const F=T.getItemLabel(V);if(!F)return _;const M=T.getItemDescription(V);let U;M?U=`${F}${M}${$.normalized}${Array.isArray($.values)?$.values.length:""}${j}`:U=`${F}${$.normalized}${Array.isArray($.values)?$.values.length:""}${j}`;const x=N[U];if(x)return x;const K=n(F,M,T.getItemPath(V),$,j);return N[U]=K,K}e.scoreItemFuzzy=t;function n(V,$,j,T,N){const F=!j||!T.containsPathSeparator;return j&&(y.isLinux?T.pathNormalized===j:A.equalsIgnoreCase(T.pathNormalized,j))?{score:u,labelMatch:[{start:0,end:V.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:T.values&&T.values.length>1?i(V,$,j,T.values,F,N):r(V,$,j,T,F,N)}function i(V,$,j,T,N,F){let M=0;const U=[],x=[];for(const K of T){const{score:se,labelMatch:be,descriptionMatch:Te}=r(V,$,j,K,N,F);if(se===C)return _;M+=se,be&&U.push(...be),Te&&x.push(...Te)}return{score:M,labelMatch:m(U),descriptionMatch:m(x)}}function r(V,$,j,T,N,F){if(N||!$){const[M,U]=P(V,T.normalized,T.normalizedLowercase,F);if(M){const x=R.matchesPrefix(T.normalized,V);let K;return x?(K=d,K+=Math.round(T.normalized.length/V.length*100)):K=f,{score:K+M,labelMatch:x||o(U)}}}if($){let M=$;j&&(M=`${$}${k.sep}`);const U=M.length,x=`${M}${V}`,[K,se]=P(x,T.normalized,T.normalizedLowercase,F);if(K){const be=o(se),Te=[],Ce=[];return be.forEach(Fe=>{Fe.start<U&&Fe.end>U?(Te.push({start:0,end:Fe.end-U}),Ce.push({start:Fe.start,end:U})):Fe.start>=U?Te.push({start:Fe.start-U,end:Fe.end-U}):Ce.push(Fe)}),{score:K,labelMatch:Te,descriptionMatch:Ce}}}return _}function o(V){const $=[];if(!V)return $;let j;for(const T of V)j&&j.end===T?j.end+=1:(j={start:T,end:T+1},$.push(j));return $}function m(V){const $=V.sort((N,F)=>N.start-F.start),j=[];let T;for(const N of $)!T||!p(T,N)?(T=N,j.push(N)):(T.start=Math.min(T.start,N.start),T.end=Math.max(T.end,N.end));return j}function p(V,$){return!(V.end<$.start||$.end<V.start)}function E(V,$,j,T,N,F){const M=t(V,j,T,N,F),U=t($,j,T,N,F),x=M.score,K=U.score;if((x===u||K===u)&&x!==K)return x===u?-1:1;if(x>f||K>f){if(x!==K)return x>K?-1:1;if(x<d&&K<d){const ze=l(M.labelMatch,U.labelMatch);if(ze!==0)return ze}const Fe=N.getItemLabel(V)||"",qe=N.getItemLabel($)||"";if(Fe.length!==qe.length)return Fe.length-qe.length}if(x!==K)return x>K?-1:1;const se=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,be=Array.isArray(U.labelMatch)&&U.labelMatch.length>0;if(se&&!be)return-1;if(be&&!se)return 1;const Te=b(V,M,N),Ce=b($,U,N);return Te&&Ce&&Te!==Ce?Ce>Te?-1:1:L(V,$,j,N)}e.compareItemsByFuzzyScore=E;function b(V,$,j){let T=-1,N=-1;if($.descriptionMatch&&$.descriptionMatch.length?T=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(T=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(N=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const F=j.getItemDescription(V);F&&(N+=F.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(N=$.descriptionMatch[$.descriptionMatch.length-1].end);return N-T}function l(V,$){if(!V&&!$||(!V||!V.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!V||!V.length)return 1;const j=V[0].start,N=V[V.length-1].end-j,F=$[0].start,U=$[$.length-1].end-F;return N===U?0:U<N?1:-1}function L(V,$,j,T){const N=T.getItemLabel(V)||"",F=T.getItemLabel($)||"",M=T.getItemDescription(V),U=T.getItemDescription($),x=N.length+(M?M.length:0),K=F.length+(U?U.length:0);if(x!==K)return x-K;const se=T.getItemPath(V),be=T.getItemPath($);return se&&be&&se.length!==be.length?se.length-be.length:N!==F?v.compareAnything(N,F,j.normalized):M&&U&&M!==U?v.compareAnything(M,U,j.normalized):se&&be&&se!==be?v.compareAnything(se,be,j.normalized):0}const O=" ";function W(V){typeof V!="string"&&(V="");const $=V.toLowerCase(),{pathNormalized:j,normalized:T,normalizedLowercase:N}=Z(V),F=j.indexOf(k.sep)>=0;let M;const U=V.split(O);if(U.length>1)for(const x of U){const{pathNormalized:K,normalized:se,normalizedLowercase:be}=Z(x);se&&(M||(M=[]),M.push({original:x,originalLowercase:x.toLowerCase(),pathNormalized:K,normalized:se,normalizedLowercase:be}))}return{original:V,originalLowercase:$,pathNormalized:j,normalized:T,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=W;function Z(V){let $;y.isWindows?$=V.replace(/\//g,k.sep):$=V.replace(/\\/g,k.sep);const j=A.stripWildcards($).replace(/\s/g,"");return{pathNormalized:$,normalized:j,normalizedLowercase:j.toLowerCase()}}function oe(V){return Array.isArray(V)?W(V.map($=>$.original).join(O)):W(V.original)}e.pieceToQuery=oe}),define(pe[30],ve([0,1,8,29,9,23,14]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",P="/",s="[/\\\\]",I="[^/\\\\]",a=/\//g;function g(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${s}|${I}+${s}|${s}${I}+)*?`}}function c(M,U){if(!M)return[];const x=[];let K=!1,se=!1,be="";for(const Te of M){switch(Te){case U:if(!K&&!se){x.push(be),be="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":se=!0;break;case"]":se=!1;break}be+=Te}return be&&x.push(be),x}e.splitGlobAware=c;function h(M){if(!M)return"";let U="";const x=c(M,P);if(x.every(K=>K===D))U=".*";else{let K=!1;x.forEach((se,be)=>{if(se===D){K||(U+=g(2),K=!0);return}let Te=!1,Ce="",Fe=!1,qe="";for(const ze of se){if(ze!=="}"&&Te){Ce+=ze;continue}if(Fe&&(ze!=="]"||!qe)){let Ge;ze==="-"?Ge=ze:(ze==="^"||ze==="!")&&!qe?Ge="^":ze===P?Ge="":Ge=v.escapeRegExpCharacters(ze),qe+=Ge;continue}switch(ze){case"{":Te=!0;continue;case"[":Fe=!0;continue;case"}":U+=`(?:${c(Ce,",").map(J=>h(J)).join("|")})`,Te=!1,Ce="";break;case"]":U+="["+qe+"]",Fe=!1,qe="";break;case"?":U+=I;continue;case"*":U+=g(1);continue;default:U+=v.escapeRegExpCharacters(ze)}}be<x.length-1&&(x[be+1]!==D||be+2<x.length)&&(U+=s),K=!1})}return U}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),n=function(){return!1},i=function(){return null};function r(M,U){if(!M)return i;let x;typeof M!="string"?x=M.pattern:x=M,x=x.trim();const K=`${x}_${!!U.trimForExclusions}`;let se=t.get(K);if(se)return o(se,M);let be;if(S.test(x)){const Te=x.substr(4);se=function(Ce,Fe){return typeof Ce=="string"&&Ce.endsWith(Te)?x:null}}else(be=w.exec(m(x,U)))?se=p(be[1],x):(U.trimForExclusions?u:_).test(x)?se=E(x,U):(be=d.exec(m(x,U)))?se=b(be[1].substr(1),x,!0):(be=f.exec(m(x,U)))?se=b(be[1],x,!1):se=l(x);return t.set(K,se),o(se,M)}function o(M,U){return typeof U=="string"?M:function(x,K){return R.isEqualOrParent(x,U.base)?M(k.relative(U.base,x),K):null}}function m(M,U){return U.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function p(M,U){const x=`/${M}`,K=`\\${M}`,se=function(Te,Ce){return typeof Te!="string"?null:Ce?Ce===M?U:null:Te===M||Te.endsWith(x)||Te.endsWith(K)?U:null},be=[M];return se.basenames=be,se.patterns=[U],se.allBasenames=be,se}function E(M,U){const x=F(M.slice(1,-1).split(",").map(Ce=>r(Ce,U)).filter(Ce=>Ce!==i),M),K=x.length;if(!K)return i;if(K===1)return x[0];const se=function(Ce,Fe){for(let qe=0,ze=x.length;qe<ze;qe++)if(x[qe](Ce,Fe))return M;return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Te=x.reduce((Ce,Fe)=>Fe.allPaths?Ce.concat(Fe.allPaths):Ce,[]);return Te.length&&(se.allPaths=Te),se}function b(M,U,x){const K=k.sep===k.posix.sep,se=K?M:M.replace(a,k.sep),be=k.sep+se,Te=k.posix.sep+M,Ce=x?function(Fe,qe){return typeof Fe=="string"&&(Fe===se||Fe.endsWith(be)||!K&&(Fe===M||Fe.endsWith(Te)))?U:null}:function(Fe,qe){return typeof Fe=="string"&&(Fe===se||!K&&Fe===M)?U:null};return Ce.allPaths=[(x?"*/":"./")+M],Ce}function l(M){try{const U=new RegExp(`^${h(M)}$`);return function(x){return U.lastIndex=0,typeof x=="string"&&U.test(x)?M:null}}catch(U){return i}}function L(M,U,x){return!M||typeof U!="string"?!1:O(M)(U,void 0,x)}e.match=L;function O(M,U={}){if(!M)return n;if(typeof M=="string"||V(M)){const x=r(M,U);if(x===i)return n;const K=function(se,be){return!!x(se,be)};return x.allBasenames&&(K.allBasenames=x.allBasenames),x.allPaths&&(K.allPaths=x.allPaths),K}return T(M,U)}e.parse=O;function W(M){if(!M)return;let U;return x=>(U||(U=(M()||Promise.resolve([])).then(K=>K?oe(K):{})),U.then(K=>!!K[x]))}e.hasSiblingPromiseFn=W;function Z(M){if(!M)return;let U;return x=>{if(!U){const K=M();U=K?oe(K):{}}return!!U[x]}}e.hasSiblingFn=Z;function oe(M){const U={};for(const x of M)U[x]=!0;return U}function V(M){const U=M;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=V;function $(M){return M.allBasenames||[]}e.getBasenameTerms=$;function j(M){return M.allPaths||[]}e.getPathTerms=j;function T(M,U){const x=F(Object.getOwnPropertyNames(M).map(Ce=>N(Ce,M[Ce],U)).filter(Ce=>Ce!==i)),K=x.length;if(!K)return i;if(!x.some(Ce=>!!Ce.requiresSiblings)){if(K===1)return x[0];const Ce=function(ze,Ge){for(let q=0,J=x.length;q<J;q++){const re=x[q](ze,Ge);if(re)return re}return null},Fe=x.find(ze=>!!ze.allBasenames);Fe&&(Ce.allBasenames=Fe.allBasenames);const qe=x.reduce((ze,Ge)=>Ge.allPaths?ze.concat(Ge.allPaths):ze,[]);return qe.length&&(Ce.allPaths=qe),Ce}const se=function(Ce,Fe,qe){let ze;for(let Ge=0,q=x.length;Ge<q;Ge++){const J=x[Ge];J.requiresSiblings&&qe&&(Fe||(Fe=k.basename(Ce)),ze||(ze=Fe.substr(0,Fe.length-k.extname(Ce).length)));const re=J(Ce,Fe,ze,qe);if(re)return re}return null},be=x.find(Ce=>!!Ce.allBasenames);be&&(se.allBasenames=be.allBasenames);const Te=x.reduce((Ce,Fe)=>Fe.allPaths?Ce.concat(Fe.allPaths):Ce,[]);return Te.length&&(se.allPaths=Te),se}function N(M,U,x){if(U===!1)return i;const K=r(M,x);if(K===i)return i;if(typeof U=="boolean")return K;if(U){const se=U.when;if(typeof se=="string"){const be=(Te,Ce,Fe,qe)=>{if(!qe||!K(Te,Ce))return null;const ze=se.replace("$(basename)",Fe),Ge=qe(ze);return A.isThenable(Ge)?Ge.then(q=>q?M:null):Ge?M:null};return be.requiresSiblings=!0,be}}return K}function F(M,U){const x=M.filter(Ce=>!!Ce.basenames);if(x.length<2)return M;const K=x.reduce((Ce,Fe)=>{const qe=Fe.basenames;return qe?Ce.concat(qe):Ce},[]);let se;if(U){se=[];for(let Ce=0,Fe=K.length;Ce<Fe;Ce++)se.push(U)}else se=x.reduce((Ce,Fe)=>{const qe=Fe.patterns;return qe?Ce.concat(qe):Ce},[]);const be=function(Ce,Fe){if(typeof Ce!="string")return null;if(!Fe){let ze;for(ze=Ce.length;ze>0;ze--){const Ge=Ce.charCodeAt(ze-1);if(Ge===47||Ge===92)break}Fe=Ce.substr(ze)}const qe=K.indexOf(Fe);return qe!==-1?se[qe]:null};be.basenames=K,be.patterns=se,be.allBasenames=K;const Te=M.filter(Ce=>!Ce.basenames);return Te.push(be),Te}}),define(pe[76],ve([0,1,2,9,8,10,11,24,29]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(r,o,m){if(typeof r=="string"&&(r=v.URI.file(r)),m){const E=m.getWorkspaceFolder(r);if(E){const b=m.getWorkspace().folders.length>1;let l;if(C.isEqual(E.uri,r)?l="":l=C.relativePath(E.uri,r),b){const L=E.name?E.name:C.basename(E.uri);l=l?L+" \u2022 "+l:L}return l}}if(r.scheme!==y.Schemas.file&&r.scheme!==y.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if(D.hasDriveLetter(r.fsPath))return R.normalize(I(r.fsPath));let p=R.normalize(r.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(p=g(p,o.userHome.fsPath)),p}e.getPathLabel=P;function s(r){if(!r)return;typeof r=="string"&&(r=v.URI.file(r));const o=C.basename(r)||(r.scheme===y.Schemas.file?r.fsPath:r.path);return A.isWindows&&D.isRootOrDriveLetter(o)?I(o):o}e.getBaseLabel=s;function I(r){return D.hasDriveLetter(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let a=Object.create(null);function g(r,o){if(A.isWindows||!r||!o)return r;let m=a.original===o?a.normalized:void 0;return m||(m=`${k.rtrim(o,R.posix.sep)}${R.posix.sep}`,a={original:o,normalized:m}),(A.isLinux?r.startsWith(m):k.startsWithIgnoreCase(r,m))&&(r=`~/${r.substr(m.length)}`),r}e.tildify=g;function c(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const h="\u2026",S="\\\\",w="~";function _(r,o=R.sep){const m=new Array(r.length);let p=!1;for(let E=0;E<r.length;E++){let b=r[E];if(b===""){m[E]=`.${o}`;continue}if(!b){m[E]=b;continue}p=!0;let l="";b.indexOf(S)===0?(l=b.substr(0,b.indexOf(S)+S.length),b=b.substr(b.indexOf(S)+S.length)):b.indexOf(o)===0?(l=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length)):b.indexOf(w)===0&&(l=b.substr(0,b.indexOf(w)+w.length),b=b.substr(b.indexOf(w)+w.length));const L=b.split(o);for(let O=1;p&&O<=L.length;O++)for(let W=L.length-O;p&&W>=0;W--){p=!1;let Z=L.slice(W,W+O).join(o);for(let oe=0;!p&&oe<r.length;oe++)if(oe!==E&&r[oe]&&r[oe].indexOf(Z)>-1){const V=W+O===L.length,$=W>0&&r[oe].indexOf(o)>-1?o+Z:Z,j=r[oe].endsWith($);p=!V||j}if(!p){let oe="";(L[0].endsWith(":")||l!=="")&&(W===1&&(W=0,O++,Z=L[0]+o+Z),W>0&&(oe=L[0]+o),oe=l+oe),W>0&&(oe=oe+h+o),oe=oe+Z,W+O<L.length&&(oe=oe+o+h),m[E]=oe}}p&&(m[E]=b)}return m}e.shorten=_;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function d(r,o=Object.create(null)){const m=[];let p=!1,E="";for(const b of r)if(b==="$"||p&&b==="{")E&&m.push({value:E,type:u.TEXT}),E="",p=!0;else if(b==="}"&&p){const l=o[E];if(typeof l=="string")l.length&&m.push({value:l,type:u.VARIABLE});else if(l){const L=m[m.length-1];(!L||L.type!==u.SEPARATOR)&&m.push({value:l.label,type:u.SEPARATOR})}E="",p=!1}else E+=b;return E&&!p&&m.push({value:E,type:u.TEXT}),m.filter((b,l)=>{if(b.type===u.SEPARATOR){const L=m[l-1],O=m[l+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(b=>b.value).join("")}e.template=d;function f(r,o){return A.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(r,o){return A.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function i(r){const o=r.indexOf("/")!==-1?R.posix:R.win32,m=o.basename(r),p=o.dirname(r);return m.length?{name:m,parentPath:p}:{name:p,parentPath:""}}e.splitName=i}),define(pe[136],ve([0,1,9,8,30,10,24]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let C=[],D=[],P=[];function s(t,n=!1){const i=I(t);C.push(i),i.userConfigured?P.push(i):D.push(i),n&&!i.userConfigured&&C.forEach(r=>{r.mime===i.mime||r.userConfigured||(i.extension&&r.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&r.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&r.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&r.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=s;function I(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(v.posix.sep)>=0:!1}}function a(t){t?(C=C.filter(n=>!n.userConfigured),P=[]):(C=[],D=[],P=[])}e.clearTextMimes=a;function g(t,n){let i;if(t)switch(t.scheme){case y.Schemas.file:i=t.fsPath;break;case y.Schemas.data:i=A.DataUri.parseMetaData(t).get(A.DataUri.META_DATA_LABEL);break;default:i=t.path}if(!i)return[e.MIME_UNKNOWN];i=i.toLowerCase();const r=v.basename(i),o=c(i,r,P);if(o)return[o,e.MIME_TEXT];const m=c(i,r,D);if(m)return[m,e.MIME_TEXT];if(n){const p=h(n);if(p)return[p,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=g;function c(t,n,i){let r=null,o=null,m=null;for(let p=i.length-1;p>=0;p--){const E=i[p];if(n===E.filenameLowercase){r=E;break}if(E.filepattern&&(!o||E.filepattern.length>o.filepattern.length)){const b=E.filepatternOnPath?t:n;k.match(E.filepatternLowercase,b)&&(o=E)}E.extension&&(!m||E.extension.length>m.extension.length)&&n.endsWith(E.extensionLowercase)&&(m=E)}return r?r.mime:o?o.mime:m?m.mime:null}function h(t){if(R.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let n=C.length-1;n>=0;n--){const i=C[n];if(!i.firstline)continue;const r=t.match(i.firstline);if(r&&r.length>0)return i.mime}return null}function S(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&S(t[0]):!0}e.isUnspecific=S;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function _(t){const n=v.extname(t);return w[n.toLowerCase()]}e.getMediaMime=_;function u(t){for(const n in w)if(w[n]===t)return n}e.getExtensionForMimeType=u;const d=/^(.+)\/(.+?)(;.+)?$/;function f(t,n){var i;const r=d.exec(t);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${(i=r[3])!==null&&i!==void 0?i:""}`:n?void 0:t}e.normalizeMimeType=f}),define(pe[98],ve([0,1,2]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(s){return s.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const a=this._uriTransformer.transformIncoming(I);return a===I?I:R(v.URI.from(a))}transformOutgoing(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:R(v.URI.from(a))}transformOutgoingURI(I){const a=this._uriTransformer.transformOutgoing(I);return a===I?I:v.URI.from(a)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function y(s,I,a){if(!s||a>200)return null;if(typeof s=="object"){if(s instanceof v.URI)return I.transformOutgoing(s);for(let g in s)if(Object.hasOwnProperty.call(s,g)){const c=y(s[g],I,a+1);c!==null&&(s[g]=c)}}return null}function A(s,I){const a=y(s,I,0);return a===null?s:a}e.transformOutgoingURIs=A;function C(s,I,a,g){if(!s||g>200)return null;if(typeof s=="object"){if(s.$mid===1)return a?v.URI.revive(I.transformIncoming(s)):I.transformIncoming(s);for(let c in s)if(Object.hasOwnProperty.call(s,c)){const h=C(s[c],I,a,g+1);h!==null&&(s[c]=h)}}return null}function D(s,I){const a=C(s,I,!1,0);return a===null?s:a}e.transformIncomingURIs=D;function P(s,I){const a=C(s,I,!0,0);return a===null?s:a}e.transformAndReviveIncomingURIs=P}),define(pe[32],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return v.test(D)}e.isUUID=R;const k=new Uint8Array(16),y=[];for(let D=0;D<256;D++)y.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function C(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let D=0,P="";return P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+="-",P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P+=y[k[D++]],P}e.generateUuid=C}),define(pe[137],ve([0,1,99]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new v.StringDecoder(y),this.remaining=null}write(y){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(C.length<1)return A;let D=0,P,s=D;for(;s<C.length;)if(P=C.charCodeAt(s),P===13||P===10){if(A.push(C.substring(D,s)),s++,s<C.length){const I=P;P=C.charCodeAt(s),(I===13&&P===10||I===10&&P===13)&&s++}D=s}else s++;return this.remaining=D<C.length?C.substr(D):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(pe[28],ve([0,1,54,100,272,9,14,11,29,32,75,24,2]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function c(T,N=g.UNLINK){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");return N===g.UNLINK?S(T):h(T)}e.rimraf=c;async function h(T){try{const N=y.join(R.tmpdir(),P.generateUuid());try{await j.rename(T,N)}catch(F){return S(T)}S(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function S(T){return j.rmdir(T,{recursive:!0,maxRetries:3})}function w(T){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=w;async function _(T,N){return f(await(N?u(T):j.readdir(T)))}e.readdir=_;async function u(T){try{return await j.readdir(T,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const N=[],F=await _(T);for(const M of F){let U=!1,x=!1,K=!1;try{const se=await j.lstat(y.join(T,M));U=se.isFile(),x=se.isDirectory(),K=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}N.push({name:M,isFile:()=>U,isDirectory:()=>x,isSymbolicLink:()=>K})}return N}function d(T){return f(v.readdirSync(T))}e.readdirSync=d;function f(T){return T.map(N=>typeof N=="string"?C.isMacintosh?s.normalizeNFC(N):N:(N.name=C.isMacintosh?s.normalizeNFC(N.name):N.name,N))}async function t(T){const N=await _(T),F=[];for(const M of N)await i.existsDirectory(y.join(T,M))&&F.push(M);return F}e.readDirsInDir=t;function n(T,N=1e3){return new Promise(F=>{let M=!1;const U=setInterval(()=>{M||(M=!0,v.access(T,x=>{M=!1,x&&(clearInterval(U),F(void 0))}))},N)})}e.whenDeleted=n;var i;(function(T){async function N(U){let x;try{if(x=await j.lstat(U),!x.isSymbolicLink())return{stat:x}}catch(K){}try{return{stat:await j.stat(U),symbolicLink:(x==null?void 0:x.isSymbolicLink())?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await j.stat(await j.readlink(U)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw se}throw K}}T.stat=N;async function F(U){try{const{stat:x,symbolicLink:K}=await T.stat(U);return x.isFile()&&(K==null?void 0:K.dangling)!==!0}catch(x){}return!1}T.existsFile=F;async function M(U){try{const{stat:x,symbolicLink:K}=await T.stat(U);return x.isDirectory()&&(K==null?void 0:K.dangling)!==!0}catch(x){}return!1}T.existsDirectory=M})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new A.ResourceQueue;function o(T,N,F){return r.queueFor(a.URI.file(T),I.extUriBiasedIgnorePathCase).queue(()=>{const M=b(F);return new Promise((U,x)=>p(T,N,M,K=>K?x(K):U()))})}e.writeFile=o;let m=!0;function p(T,N,F,M){if(!m)return v.writeFile(T,N,{mode:F.mode,flag:F.flag},M);v.open(T,F.flag,F.mode,(U,x)=>{if(U)return M(U);v.writeFile(x,N,K=>{if(K)return v.close(x,()=>M(K));v.fdatasync(x,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),m=!1),v.close(x,be=>M(be))))})})}function E(T,N,F){const M=b(F);if(!m)return v.writeFileSync(T,N,{mode:M.mode,flag:M.flag});const U=v.openSync(T,M.flag,M.mode);try{v.writeFileSync(U,N);try{v.fdatasyncSync(U)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),m=!1}}finally{v.closeSync(U)}}e.writeFileSync=E;function b(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function l(T,N){if(T===N)return;async function F(M){try{const U=await j.lstat(M);if(U.isDirectory()||U.isSymbolicLink())return;await j.utimes(M,U.atime,new Date)}catch(U){}}try{await j.rename(T,N),await F(N)}catch(M){if(T.toLowerCase()!==N.toLowerCase()&&M.code==="EXDEV"||T.endsWith("."))await L(T,N,{preserveSymlinks:!1}),await c(T,g.MOVE),await F(N);else throw M}}e.move=l;async function L(T,N,F){return W(T,N,{root:{source:T,target:N},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(T,N,F){if(F.handledSourcePaths.has(T))return;F.handledSourcePaths.add(T);const{stat:M,symbolicLink:U}=await i.stat(T);if(U){if(F.options.preserveSymlinks)try{return await V(T,N,F)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(U.dangling)return}return M.isDirectory()?Z(T,N,M.mode&O,F):oe(T,N,M.mode&O)}async function Z(T,N,F,M){await j.mkdir(N,{recursive:!0,mode:F});const U=await _(T);for(const x of U)await W(y.join(T,x),y.join(N,x),M)}async function oe(T,N,F){await j.copyFile(T,N),await j.chmod(N,F)}async function V(T,N,F){let M=await j.readlink(T);D.isEqualOrParent(M,F.root.source,!C.isLinux)&&(M=y.join(F.root.target,M.substr(F.root.source.length+1))),await j.symlink(M,N)}async function $(T){try{return await j.access(T),!0}catch(N){return!1}}e.exists=$;var j;(function(T){T.access=k.promisify(v.access),T.stat=k.promisify(v.stat),T.lstat=k.promisify(v.lstat),T.utimes=k.promisify(v.utimes),T.read=k.promisify(v.read),T.readFile=k.promisify(v.readFile),T.write=k.promisify(v.write),T.writeFile=k.promisify(v.writeFile),T.appendFile=k.promisify(v.appendFile),T.fdatasync=k.promisify(v.fdatasync),T.truncate=k.promisify(v.truncate),T.rename=k.promisify(v.rename),T.copyFile=k.promisify(v.copyFile),T.open=k.promisify(v.open),T.close=k.promisify(v.close),T.symlink=k.promisify(v.symlink),T.readlink=k.promisify(v.readlink),T.chmod=k.promisify(v.chmod),T.readdir=k.promisify(v.readdir),T.mkdir=k.promisify(v.mkdir),T.unlink=k.promisify(v.unlink),T.rmdir=k.promisify(v.rmdir),T.realpath=k.promisify(v.realpath)})(j=e.Promises||(e.Promises={}))}),define(pe[101],ve([0,1,54,8,9,28]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(s){const I=k.dirname(s);if(s===I)return s;const a=(k.basename(s)||s).toLowerCase();try{const c=y.readdirSync(I).filter(h=>h.toLowerCase()===a);if(c.length===1){const h=A(I);if(h)return k.join(h,c[0])}else if(c.length>1){const h=c.indexOf(a);if(h>=0){const S=A(I);if(S)return k.join(S,c[h])}}}catch(g){}return null}e.realcaseSync=A;async function C(s){try{return await y.Promises.realpath(s)}catch(I){const a=P(s);return await y.Promises.access(a,v.constants.R_OK),a}}e.realpath=C;function D(s){try{return v.realpathSync(s)}catch(I){const a=P(s);return v.accessSync(a,v.constants.R_OK),a}}e.realpathSync=D;function P(s){return R.rtrim(k.normalize(s),k.sep)}});var Ve=this&&this.__decorate||function(Q,e,v,R){var k=arguments.length,y=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(Q,e,v,R);else for(var C=Q.length-1;C>=0;C--)(A=Q[C])&&(y=(k<3?A(y):k>3?A(e,v,y):A(e,v))||y);return k>3&&y&&Object.defineProperty(e,v,y),y};define(pe[102],ve([0,1,3,6,14,21,16,22,17,13,53,8,50]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function c(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function S(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class _{constructor(M){this.buffer=M,this.pos=0}read(M){const U=this.buffer.slice(this.pos,this.pos+M);return this.pos+=U.byteLength,U}}class u{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function f(F){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function n(F){const M=C.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const i={Undefined:n(d.Undefined),String:n(d.String),Buffer:n(d.Buffer),VSBuffer:n(d.VSBuffer),Array:n(d.Array),Object:n(d.Object)},r=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(i.Undefined);else if(typeof M=="string"){const U=C.VSBuffer.fromString(M);F.write(i.String),F.write(f(U.byteLength)),F.write(U)}else if(r&&Buffer.isBuffer(M)){const U=C.VSBuffer.wrap(M);F.write(i.Buffer),F.write(f(U.byteLength)),F.write(U)}else if(M instanceof C.VSBuffer)F.write(i.VSBuffer),F.write(f(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(i.Array),F.write(f(M.length));for(const U of M)o(F,U)}else{const U=C.VSBuffer.fromString(JSON.stringify(M));F.write(i.Object),F.write(f(U.byteLength)),F.write(U)}}function m(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(t(F)).toString();case d.Buffer:return F.read(t(F)).buffer;case d.VSBuffer:return F.read(t(F));case d.Array:{const U=t(F),x=[];for(let K=0;K<U;K++)x.push(m(F));return x}case d.Object:return JSON.parse(F.read(t(F)).toString())}}class p{constructor(M,U,x=null,K=1e3){this.protocol=M,this.ctx=U,this.logger=x,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(se=>this.onRawMessage(se)),this.sendResponse({type:200})}registerChannel(M,U){this.channels.set(M,U),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const U=this.send([M.type]);this.logger&&this.logger.logOutgoing(U,0,1,S(M.type));return}case 201:case 202:case 204:case 203:{const U=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(U,M.id,1,S(M.type),M.data);return}}}send(M,U=void 0){const x=new u;return o(x,M),o(x,U),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onRawMessage(M){const U=new _(M),x=m(U),K=m(U),se=x[0];switch(se){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${c(se)}: ${x[2]}.${x[3]}`,K),this.onPromise({type:se,id:x[1],channelName:x[2],name:x[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${c(se)}: ${x[2]}.${x[3]}`,K),this.onEventListen({type:se,id:x[1],channelName:x[2],name:x[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${c(se)}`),this.disposeActiveRequest({type:se,id:x[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],1,`${c(se)}`),this.disposeActiveRequest({type:se,id:x[1]})}}onPromise(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const x=new y.CancellationTokenSource;let K;try{K=U.call(this.ctx,M.name,M.arg,x.token)}catch(Te){K=Promise.reject(Te)}const se=M.id;K.then(Te=>{this.sendResponse({id:se,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:se,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:se,data:Te,type:203}),this.activeRequests.delete(M.id)});const be=R.toDisposable(()=>x.cancel());this.activeRequests.set(M.id,be)}onEventListen(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const x=M.id,se=U.listen(this.ctx,M.name,M.arg)(be=>this.sendResponse({id:x,data:be,type:204}));this.activeRequests.set(M.id,se)}disposeActiveRequest(M){const U=this.activeRequests.get(M.id);U&&(U.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let U=this.pendingRequests.get(M.channelName);U||(U=[],this.pendingRequests.set(M.channelName,U));const x=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:M,timeoutTimer:x})}flushPendingRequests(M){const U=this.pendingRequests.get(M);if(U){for(const x of U)switch(clearTimeout(x.timeoutTimer),x.request.type){case 100:this.onPromise(x.request);break;case 102:this.onEventListen(x.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var E;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(M,U=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(x=>this.onBuffer(x)),this.logger=U}getChannel(M){const U=this;return{call(x,K,se){return U.isDisposed?Promise.reject(A.canceled()):U.requestPromise(M,x,K,se)},listen(x,K){return U.isDisposed?Promise.reject(A.canceled()):U.requestEvent(M,x,K)}}}requestPromise(M,U,x,K=y.CancellationToken.None){const se=this.lastRequestId++,Te={id:se,type:100,channelName:M,name:U,arg:x};if(K.isCancellationRequested)return Promise.reject(A.canceled());let Ce;return new Promise((qe,ze)=>{if(K.isCancellationRequested)return ze(A.canceled());const Ge=()=>{const ae=Y=>{switch(Y.type){case 201:this.handlers.delete(se),qe(Y.data);break;case 202:this.handlers.delete(se);const ce=new Error(Y.data.message);ce.stack=Y.data.stack,ce.name=Y.data.name,ze(ce);break;case 203:this.handlers.delete(se),ze(Y.data);break}};this.handlers.set(se,ae),this.sendRequest(Te)};let q=null;this.state===w.Idle?Ge():(q=k.createCancelablePromise(ae=>this.whenInitialized()),q.then(()=>{q=null,Ge()}));const J=()=>{q?(q.cancel(),q=null):this.sendRequest({id:se,type:101}),ze(A.canceled())},re=K.onCancellationRequested(J);Ce=R.combinedDisposable(R.toDisposable(J),re),this.activeRequests.add(Ce)}).finally(()=>{this.activeRequests.delete(Ce)})}requestEvent(M,U,x){const K=this.lastRequestId++,be={id:K,type:102,channelName:M,name:U,arg:x};let Te=null;const Ce=new v.Emitter({onFirstListenerAdd:()=>{Te=k.createCancelablePromise(qe=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(Ce),this.sendRequest(be)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(Ce),this.sendRequest({id:K,type:103}))}}),Fe=qe=>Ce.fire(qe.data);return this.handlers.set(K,Fe),Ce.event}sendRequest(M){switch(M.type){case 100:case 102:{const U=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(U,M.id,0,`${c(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const U=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(U,M.id,0,c(M.type));return}}}send(M,U=void 0){const x=new u;return o(x,M),o(x,U),this.sendBuffer(x.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onBuffer(M){const U=new _(M),x=m(U),K=m(U),se=x[0];switch(se){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,S(se)),this.onResponse({type:x[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,x[1],0,S(se),K),this.onResponse({type:x[0],id:x[1],data:K})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(M.id);U&&U(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([a.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class l{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:U,onDidClientDisconnect:x})=>{v.Event.once(U.onMessage)(se=>{const be=new _(se),Te=m(be),Ce=new p(U,Te),Fe=new b(U);this.channels.forEach((ze,Ge)=>Ce.registerChannel(Ge,ze));const qe={channelServer:Ce,channelClient:Fe,ctx:Te};this._connections.add(qe),this._onDidAddConnection.fire(qe),x(()=>{Ce.dispose(),Fe.dispose(),this._connections.delete(qe),this._onDidRemoveConnection.fire(qe)})})})}get connections(){const M=[];return this._connections.forEach(U=>M.push(U)),M}getChannel(M,U){const x=this;return{call(K,se,be){let Te;if(P.isFunction(U)){let Fe=D.getRandomElement(x.connections.filter(U));Te=Fe?Promise.resolve(Fe):v.Event.toPromise(v.Event.filter(x.onDidAddConnection,U))}else Te=U.routeCall(x,K,se);const Ce=Te.then(Fe=>Fe.channelClient.getChannel(M));return O(Ce).call(K,se,be)},listen(K,se){if(P.isFunction(U))return x.getMulticastEvent(M,U,K,se);const be=U.routeEvent(x,K,se).then(Te=>Te.channelClient.getChannel(M));return O(be).listen(K,se)}}}getMulticastEvent(M,U,x,K){const se=this;let be=new R.DisposableStore;const Te=new v.Emitter({onFirstListenerAdd:()=>{be=new R.DisposableStore;const Ce=new v.EventMultiplexer,Fe=new Map,qe=Ge=>{const J=Ge.channelClient.getChannel(M).listen(x,K),re=Ce.add(J);Fe.set(Ge,re)},ze=Ge=>{const q=Fe.get(Ge);!q||(q.dispose(),Fe.delete(Ge))};se.connections.filter(U).forEach(qe),v.Event.filter(se.onDidAddConnection,U)(qe,void 0,be),se.onDidRemoveConnection(ze,void 0,be),Ce.event(Te.fire,Te,be),be.add(Ce)},onLastListenerRemove:()=>{be.dispose()}});return Te.event}registerChannel(M,U){this.channels.set(M,U),this._connections.forEach(x=>{x.channelServer.registerChannel(M,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=l;class L{constructor(M,U,x=null){const K=new u;o(K,U),M.send(K.buffer),this.channelClient=new b(M,x),this.channelServer=new p(M,U,x)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,U){this.channelServer.registerChannel(M,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,U,x){return F.then(K=>K.call(M,U,x))},listen(M,U){const x=new v.Relay;return F.then(K=>x.input=K.listen(M,U)),x.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call(U,x,K){return M?F.call(U,x,K):k.timeout(0).then(()=>M=!0).then(()=>F.call(U,x,K))},listen(U,x){if(M)return F.listen(U,x);const K=new v.Relay;return k.timeout(0).then(()=>M=!0).then(()=>K.input=F.listen(U,x)),K.event}}}e.getNextTickChannel=W;class Z{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const U of M.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=Z;var oe;(function(F){function M(K,se){const be=K,Te=se&&se.disableMarshalling,Ce=new Map;for(const Fe in be)x(Fe)&&Ce.set(Fe,v.Event.buffer(be[Fe],!0));return new class{listen(Fe,qe){const ze=Ce.get(qe);if(ze)return ze;throw new Error(`Event not found: ${qe}`)}call(Fe,qe,ze){const Ge=be[qe];if(typeof Ge=="function"){if(!Te&&Array.isArray(ze))for(let q=0;q<ze.length;q++)ze[q]=s.revive(ze[q]);return Ge.apply(be,ze)}throw new Error(`Method not found: ${qe}`)}}}F.fromService=M;function U(K,se){const be=se&&se.disableMarshalling;return new Proxy({},{get(Te,Ce){var Fe;if(typeof Ce=="string")return((Fe=se==null?void 0:se.properties)===null||Fe===void 0?void 0:Fe.has(Ce))?se.properties.get(Ce):x(Ce)?K.listen(Ce):async function(...qe){let ze;se&&!P.isUndefinedOrNull(se.context)?ze=[se.context,...qe]:ze=qe;const Ge=await K.call(Ce,ze);return be?Ge:s.revive(Ge)};throw new Error(`Property not found: ${String(Ce)}`)}})}F.toService=U;function x(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function j(F){return Array.isArray(F)?F.map($):$(F)}function T(F,M,U,x,K,se,be){be=j(be);const Te=V[K],Ce=Te[x%Te.length];let Fe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${Ce}`];/\($/.test(se)?(Fe=Fe.concat(be),Fe.push(")")):Fe.push(be),console.log.apply(console,Fe)}e.logWithColors=T;class N{constructor(M,U){this._outgoingPrefix=M,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,U,x,K,se){this._totalOutgoing+=M,T(this._outgoingPrefix,this._totalOutgoing,M,U,x,K,se)}logIncoming(M,U,x,K,se){this._totalIncoming+=M,T(this._incomingPrefix,this._totalIncoming,M,U,x,K,se)}}e.IPCLogger=N}),define(pe[103],ve([0,1,3,102,6,22,11,37]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=y.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,r){if(i===0)return P();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const E=this._chunks[0];return r&&(this._chunks.shift(),this._totalLength-=i),E}if(this._chunks[0].byteLength>i){const E=this._chunks[0].slice(0,i);return r&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),E}let o=y.VSBuffer.alloc(i),m=0,p=0;for(;i>0;){const E=this._chunks[p];if(E.byteLength>i){const b=E.slice(0,i);o.set(b,m),m+=i,r&&(this._chunks[p]=E.slice(i),this._totalLength-=i),i-=i}else o.set(E,m),m+=E.byteLength,r?(this._chunks.shift(),this._totalLength-=E.byteLength):p++,i-=E.byteLength}return o}}e.ChunkStream=s;var I;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var a;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(a=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(i,r,o,m){this.type=i,this.id=r,this.ack=o,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends k.Disposable{constructor(i){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const r=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=r.readUInt32BE(9),this._state.messageType=r.readUInt8(0),this._state.id=r.readUInt32BE(1),this._state.ack=r.readUInt32BE(5);else{const o=this._state.messageType,m=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(o,m,p,r)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=y.VSBuffer.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this._writeSoon(r,i.data)}_bufferAdd(i,r){const o=this._totalLength===0;return this._data.push(i,r),this._totalLength+=i.byteLength+r.byteLength,o}_bufferTake(){const i=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,r){this._bufferAdd(i,r)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends k.Disposable{constructor(i){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(r=>{r.type===1&&this._onMessage.fire(r.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new g(1,0,0,i))}}e.Protocol=S;class w extends R.IPCClient{constructor(i,r,o=null){super(i,r,o);this.protocol=i}static fromSocket(i,r){return new w(new S(i),r)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=w;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class u{constructor(i){this.data=i,this.next=null}}class d{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],r=0,o=this._first;for(;o;)i[r++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const r=new u(i);if(!this._first){this._first=r,this._last=r;return}this._last.next=r,this._last=r}}class f{constructor(){this.lastRuns=[];const i=Date.now();for(let r=0;r<f._HISTORY_LENGTH;r++)this.lastRuns[r]=i-1e3*r;setInterval(()=>{for(let r=f._HISTORY_LENGTH;r>=1;r--)this.lastRuns[r]=this.lastRuns[r-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const i=Date.now(),r=(1+f._HISTORY_LENGTH)*1e3;let o=0;for(let m=0;m<f._HISTORY_LENGTH;m++)i-this.lastRuns[m]<=r&&o++;return 1-o/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class t{constructor(i,r=null){this._loadEstimator=f.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new d,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),r&&this._socketReader.acceptChunk(r),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new g(5,0,0,P());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const r=new g(4,0,0,P());this._socketWriter.write(r),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,r){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(r)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let r=0,o=i.length;r<o;r++)this._socketWriter.write(i[r]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const r=this._outgoingUnackMsg.peek();if(r&&r.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const r=Date.now();r-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=r,this._socketWriter.write(new g(6,0,0,P())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const r=this._outgoingUnackMsg.toArray();for(let o=0,m=r.length;o<m;o++)this._socketWriter.write(r[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const r=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new g(1,r,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const r=new g(2,0,0,i);this._socketWriter.write(r)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const i=this._outgoingUnackMsg.peek(),r=Date.now()-i.writtenTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-r,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new g(3,0,this._incomingAckId,P());this._socketWriter.write(i)}}e.PersistentProtocol=t}),define(pe[104],ve([0,1,93]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(C){let D=v.toUint8(C);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=C;return D}set(C,D){let P=v.toUint8(D);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class y{constructor(){this._actual=new R(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=y}),define(pe[138],ve([0,1,104]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends v.CharacterClassifier{constructor(C){super(0);for(let D=0,P=C.length;D<P;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function y(A){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=A(D)),C[D])}e.getMapForWordSeparators=y(A=>new k(A))}),define(pe[44],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(k,y){this.lineNumber=k,this.column=y}with(k=this.lineNumber,y=this.column){return k===this.lineNumber&&y===this.column?this:new v(k,y)}delta(k=0,y=0){return this.with(this.lineNumber+k,this.column+y)}equals(k){return v.equals(this,k)}static equals(k,y){return!k&&!y?!0:!!k&&!!y&&k.lineNumber===y.lineNumber&&k.column===y.column}isBefore(k){return v.isBefore(this,k)}static isBefore(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<y.column}isBeforeOrEqual(k){return v.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,y){return k.lineNumber<y.lineNumber?!0:y.lineNumber<k.lineNumber?!1:k.column<=y.column}static compare(k,y){let A=k.lineNumber|0,C=y.lineNumber|0;if(A===C){let D=k.column|0,P=y.column|0;return D-P}return A-C}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new v(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=v}),define(pe[41],ve([0,1,44]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(y,A,C,D){y>C||y===C&&A>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=y,this.endColumn=A):(this.startLineNumber=y,this.startColumn=A,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(y){return y.startLineNumber===y.endLineNumber&&y.startColumn===y.endColumn}containsPosition(y){return R.containsPosition(this,y)}static containsPosition(y,A){return!(A.lineNumber<y.startLineNumber||A.lineNumber>y.endLineNumber||A.lineNumber===y.startLineNumber&&A.column<y.startColumn||A.lineNumber===y.endLineNumber&&A.column>y.endColumn)}containsRange(y){return R.containsRange(this,y)}static containsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>y.endColumn)}strictContainsRange(y){return R.strictContainsRange(this,y)}static strictContainsRange(y,A){return!(A.startLineNumber<y.startLineNumber||A.endLineNumber<y.startLineNumber||A.startLineNumber>y.endLineNumber||A.endLineNumber>y.endLineNumber||A.startLineNumber===y.startLineNumber&&A.startColumn<=y.startColumn||A.endLineNumber===y.endLineNumber&&A.endColumn>=y.endColumn)}plusRange(y){return R.plusRange(this,y)}static plusRange(y,A){let C,D,P,s;return A.startLineNumber<y.startLineNumber?(C=A.startLineNumber,D=A.startColumn):A.startLineNumber===y.startLineNumber?(C=A.startLineNumber,D=Math.min(A.startColumn,y.startColumn)):(C=y.startLineNumber,D=y.startColumn),A.endLineNumber>y.endLineNumber?(P=A.endLineNumber,s=A.endColumn):A.endLineNumber===y.endLineNumber?(P=A.endLineNumber,s=Math.max(A.endColumn,y.endColumn)):(P=y.endLineNumber,s=y.endColumn),new R(C,D,P,s)}intersectRanges(y){return R.intersectRanges(this,y)}static intersectRanges(y,A){let C=y.startLineNumber,D=y.startColumn,P=y.endLineNumber,s=y.endColumn,I=A.startLineNumber,a=A.startColumn,g=A.endLineNumber,c=A.endColumn;return C<I?(C=I,D=a):C===I&&(D=Math.max(D,a)),P>g?(P=g,s=c):P===g&&(s=Math.min(s,c)),C>P||C===P&&D>s?null:new R(C,D,P,s)}equalsRange(y){return R.equalsRange(this,y)}static equalsRange(y,A){return!!y&&!!A&&y.startLineNumber===A.startLineNumber&&y.startColumn===A.startColumn&&y.endLineNumber===A.endLineNumber&&y.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(y){return new v.Position(y.endLineNumber,y.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(y){return new v.Position(y.startLineNumber,y.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(y,A){return new R(this.startLineNumber,this.startColumn,y,A)}setStartPosition(y,A){return new R(y,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(y){return new R(y.startLineNumber,y.startColumn,y.startLineNumber,y.startColumn)}static fromPositions(y,A=y){return new R(y.lineNumber,y.column,A.lineNumber,A.column)}static lift(y){return y?new R(y.startLineNumber,y.startColumn,y.endLineNumber,y.endColumn):null}static isIRange(y){return y&&typeof y.startLineNumber=="number"&&typeof y.startColumn=="number"&&typeof y.endLineNumber=="number"&&typeof y.endColumn=="number"}static areIntersectingOrTouching(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<y.startColumn)}static areIntersecting(y,A){return!(y.endLineNumber<A.startLineNumber||y.endLineNumber===A.startLineNumber&&y.endColumn<=A.startColumn||A.endLineNumber<y.startLineNumber||A.endLineNumber===y.startLineNumber&&A.endColumn<=y.startColumn)}static compareRangesUsingStarts(y,A){if(y&&A){const P=y.startLineNumber|0,s=A.startLineNumber|0;if(P===s){const I=y.startColumn|0,a=A.startColumn|0;if(I===a){const g=y.endLineNumber|0,c=A.endLineNumber|0;if(g===c){const h=y.endColumn|0,S=A.endColumn|0;return h-S}return g-c}return I-a}return P-s}return(y?1:0)-(A?1:0)}static compareRangesUsingEnds(y,A){return y.endLineNumber===A.endLineNumber?y.endColumn===A.endColumn?y.startLineNumber===A.startLineNumber?y.startColumn-A.startColumn:y.startLineNumber-A.startLineNumber:y.endColumn-A.endColumn:y.endLineNumber-A.endLineNumber}static spansMultipleLines(y){return y.endLineNumber>y.startLineNumber}}e.Range=R}),define(pe[139],ve([0,1,44,41]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class y extends R.Range{constructor(C,D,P,s){super(C,D,P,s);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return y.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new y(this.startLineNumber,this.startColumn,C,D):new y(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new y(C,D,this.endLineNumber,this.endColumn):new y(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new y(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new y(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let P=0,s=C.length;P<s;P++)if(!this.selectionsEqual(C[P],D[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,P,s,I){return I===0?new y(C,D,P,s):new y(P,s,C,D)}}e.Selection=y}),define(pe[105],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var y;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(y=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(h){this.tabSize=Math.max(1,h.tabSize|0),this.indentSize=h.tabSize|0,this.insertSpaces=Boolean(h.insertSpaces),this.defaultEOL=h.defaultEOL|0,this.trimAutoWhitespace=Boolean(h.trimAutoWhitespace)}equals(h){return this.tabSize===h.tabSize&&this.indentSize===h.indentSize&&this.insertSpaces===h.insertSpaces&&this.defaultEOL===h.defaultEOL&&this.trimAutoWhitespace===h.trimAutoWhitespace}createChangeEvent(h){return{tabSize:this.tabSize!==h.tabSize,indentSize:this.indentSize!==h.indentSize,insertSpaces:this.insertSpaces!==h.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==h.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(h,S){this.range=h,this.matches=S}}e.FindMatch=D;var P;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(s=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class a{constructor(h,S,w,_,u,d){this.identifier=h,this.range=S,this.text=w,this.forceMoveMarkers=_,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=a;class g{constructor(h,S,w){this.reverseEdits=h,this.changes=S,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=g}),define(pe[140],ve([0,1,8,138,44,41,105]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(u,d,f,t){this.searchString=u,this.isRegex=d,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let d=null;try{d=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let f=!this.isRegex&&!u;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new s(d,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=D;function P(_){if(!_||_.length===0)return!1;for(let u=0,d=_.length;u<d;u++)if(_.charCodeAt(u)===92){if(u++,u>=d)break;const t=_.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class s{constructor(u,d,f){this.regex=u,this.wordSeparators=d,this.simpleSearch=f}}e.SearchData=s;function I(_,u,d){if(!d)return new A.FindMatch(_,null);let f=[];for(let t=0,n=u.length;t<n;t++)f[t]=u[t];return new A.FindMatch(_,f)}e.createFindMatch=I;class a{constructor(u){let d=[],f=0;for(let t=0,n=u.length;t<n;t++)u.charCodeAt(t)===10&&(d[f++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(u){const d=this._lineFeedsOffsets;let f=0,t=d.length-1;if(t===-1||u<=d[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);d[n]>=u?t=n-1:d[n+1]>=u?(f=n,t=n):f=n+1}return f+1}}class g{static findMatches(u,d,f,t,n){const i=d.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(u,f,new w(i.wordSeparators,i.regex),t,n):this._doFindMatchesLineByLine(u,f,i,t,n):[]}static _getMultilineMatchRange(u,d,f,t,n,i){let r,o=0;t?(o=t.findLineFeedCountBeforeOffset(n),r=d+n+o):r=d+n;let m;if(t){let l=t.findLineFeedCountBeforeOffset(n+i.length)-o;m=r+i.length+l}else m=r+i.length;const p=u.getPositionAt(r),E=u.getPositionAt(m);return new y.Range(p.lineNumber,p.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(u,d,f,t,n){const i=u.getOffsetAt(d.getStartPosition()),r=u.getValueInRange(d,1),o=u.getEOL()===`\r
`?new a(r):null,m=[];let p=0,E;for(f.reset(0);E=f.next(r);)if(m[p++]=I(this._getMultilineMatchRange(u,i,r,o,E.index,E[0]),E,t),p>=n)return m;return m}static _doFindMatchesLineByLine(u,d,f,t,n){const i=[];let r=0;if(d.startLineNumber===d.endLineNumber){const m=u.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return r=this._findMatchesInLine(f,m,d.startLineNumber,d.startColumn-1,r,i,t,n),i}const o=u.getLineContent(d.startLineNumber).substring(d.startColumn-1);r=this._findMatchesInLine(f,o,d.startLineNumber,d.startColumn-1,r,i,t,n);for(let m=d.startLineNumber+1;m<d.endLineNumber&&r<n;m++)r=this._findMatchesInLine(f,u.getLineContent(m),m,0,r,i,t,n);if(r<n){const m=u.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);r=this._findMatchesInLine(f,m,d.endLineNumber,0,r,i,t,n)}return i}static _findMatchesInLine(u,d,f,t,n,i,r,o){const m=u.wordSeparators;if(!r&&u.simpleSearch){const b=u.simpleSearch,l=b.length,L=d.length;let O=-l;for(;(O=d.indexOf(b,O+l))!==-1;)if((!m||S(m,d,L,O,l))&&(i[n++]=new A.FindMatch(new y.Range(f,O+1+t,f,O+1+l+t),null),n>=o))return n;return n}const p=new w(u.wordSeparators,u.regex);let E;p.reset(0);do if(E=p.next(d),E&&(i[n++]=I(new y.Range(f,E.index+1+t,f,E.index+1+E[0].length+t),E,r),n>=o))return n;while(E);return n}static findNextMatch(u,d,f,t){const n=d.parseSearchRequest();if(!n)return null;const i=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(u,f,i,t):this._doFindNextMatchLineByLine(u,f,i,t)}static _doFindNextMatchMultiline(u,d,f,t){const n=new k.Position(d.lineNumber,1),i=u.getOffsetAt(n),r=u.getLineCount(),o=u.getValueInRange(new y.Range(n.lineNumber,n.column,r,u.getLineMaxColumn(r)),1),m=u.getEOL()===`\r
`?new a(o):null;f.reset(d.column-1);let p=f.next(o);return p?I(this._getMultilineMatchRange(u,i,o,m,p.index,p[0]),p,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(u,new k.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(u,d,f,t){const n=u.getLineCount(),i=d.lineNumber,r=u.getLineContent(i),o=this._findFirstMatchInLine(f,r,i,d.column,t);if(o)return o;for(let m=1;m<=n;m++){const p=(i+m-1)%n,E=u.getLineContent(p+1),b=this._findFirstMatchInLine(f,E,p+1,1,t);if(b)return b}return null}static _findFirstMatchInLine(u,d,f,t,n){u.reset(t-1);const i=u.next(d);return i?I(new y.Range(f,i.index+1,f,i.index+1+i[0].length),i,n):null}static findPreviousMatch(u,d,f,t){const n=d.parseSearchRequest();if(!n)return null;const i=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(u,f,i,t):this._doFindPreviousMatchLineByLine(u,f,i,t)}static _doFindPreviousMatchMultiline(u,d,f,t){const n=this._doFindMatchesMultiline(u,new y.Range(1,1,d.lineNumber,d.column),f,t,10*C);if(n.length>0)return n[n.length-1];const i=u.getLineCount();return d.lineNumber!==i||d.column!==u.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(u,new k.Position(i,u.getLineMaxColumn(i)),f,t):null}static _doFindPreviousMatchLineByLine(u,d,f,t){const n=u.getLineCount(),i=d.lineNumber,r=u.getLineContent(i).substring(0,d.column-1),o=this._findLastMatchInLine(f,r,i,t);if(o)return o;for(let m=1;m<=n;m++){const p=(n+i-m-1)%n,E=u.getLineContent(p+1),b=this._findLastMatchInLine(f,E,p+1,t);if(b)return b}return null}static _findLastMatchInLine(u,d,f,t){let n=null,i;for(u.reset(0);i=u.next(d);)n=I(new y.Range(f,i.index+1,f,i.index+1+i[0].length),i,t);return n}}e.TextModelSearch=g;function c(_,u,d,f,t){if(f===0)return!0;const n=u.charCodeAt(f-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const i=u.charCodeAt(f);if(_.get(i)!==0)return!0}return!1}function h(_,u,d,f,t){if(f+t===d)return!0;const n=u.charCodeAt(f+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const i=u.charCodeAt(f+t-1);if(_.get(i)!==0)return!0}return!1}function S(_,u,d,f,t){return c(_,u,d,f,t)&&h(_,u,d,f,t)}e.isValidMatch=S;class w{constructor(u,d){this._wordSeparators=u,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const d=u.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(f=this._searchRegex.exec(u),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){v.getNextCodePoint(u,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||S(this._wordSeparators,u,d,t,n))return f}while(f);return null}}e.Searcher=w}),define(pe[106],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=v();function R(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),D=new RegExp(C.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function y(C,D,P,s,I=k){if(P.length>I.maxLen){let S=C-I.maxLen/2;return S<0?S=0:s+=S,P=P.substring(S,C+I.maxLen/2),y(C,D,P,s,I)}const a=Date.now(),g=C-1-s;let c=-1,h=null;for(let S=1;!(Date.now()-a>=I.timeBudget);S++){const w=g-I.windowSize*S;D.lastIndex=Math.max(0,w);const _=A(D,P,g,c);if(!_&&h||(h=_,w<=0))break;c=w}if(h){let S={word:h[0],startColumn:s+1+h.index,endColumn:s+1+h.index+h[0].length};return D.lastIndex=0,S}return null}e.getWordAtText=y;function A(C,D,P,s){let I;for(;I=C.exec(D);){const a=I.index||0;if(a<=P&&C.lastIndex>=P)return I;if(s>0&&a>s)return null}return null}}),define(pe[141],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,P=C.notIn.length;D<P;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)y(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),y(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),y(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),y(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&y(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=k;function y(A,C,D){A.has(C)?A.get(C).push(D):A.set(C,[D])}}),define(pe[77],ve([0,1,30,9]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(y,A,C,D){if(Array.isArray(y)){let P=0;for(const s of y){const I=k(s,A,C,D);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof y=="string")return D?y==="*"?5:y===C?10:0:0;if(y){const{language:P,pattern:s,scheme:I,hasAccessToAllModels:a}=y;if(!D&&!a)return 0;let g=0;if(I)if(I===A.scheme)g=10;else if(I==="*")g=5;else return 0;if(P)if(P===C)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(s){let c;if(typeof s=="string"?c=s:c=Object.assign(Object.assign({},s),{base:R.normalize(s.base)}),c===A.fsPath||v.match(c,A.fsPath))g=10;else return 0}return g}else return 0}}e.score=k}),define(pe[142],ve([0,1,104]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(c,h,S){const w=new Uint8Array(c*h);for(let _=0,u=c*h;_<u;_++)w[_]=S;this._data=w,this.rows=c,this.cols=h}get(c,h){return this._data[c*this.cols+h]}set(c,h,S){this._data[c*this.cols+h]=S}}e.Uint8Matrix=k;class y{constructor(c){let h=0,S=0;for(let _=0,u=c.length;_<u;_++){let[d,f,t]=c[_];f>h&&(h=f),d>S&&(S=d),t>S&&(S=t)}h++,S++;let w=new k(S,h,0);for(let _=0,u=c.length;_<u;_++){let[d,f,t]=c[_];w.set(d,f,t)}this._states=w,this._maxCharCode=h}nextState(c,h){return h<0||h>=this._maxCharCode?0:this._states.get(c,h)}}e.StateMachine=y;let A=null;function C(){return A===null&&(A=new y([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function s(){if(P===null){P=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<g.length;h++)P.set(g.charCodeAt(h),1);const c=".,;";for(let h=0;h<c.length;h++)P.set(c.charCodeAt(h),2)}return P}class I{static _createLink(c,h,S,w,_){let u=_-1;do{const d=h.charCodeAt(u);if(c.get(d)!==2)break;u--}while(u>w);if(w>0){const d=h.charCodeAt(w-1),f=h.charCodeAt(u);(d===40&&f===41||d===91&&f===93||d===123&&f===125)&&u--}return{range:{startLineNumber:S,startColumn:w+1,endLineNumber:S,endColumn:u+2},url:h.substring(w,u+1)}}static computeLinks(c,h=C()){const S=s();let w=[];for(let _=1,u=c.getLineCount();_<=u;_++){const d=c.getLineContent(_),f=d.length;let t=0,n=0,i=0,r=1,o=!1,m=!1,p=!1,E=!1;for(;t<f;){let b=!1;const l=d.charCodeAt(t);if(r===13){let L;switch(l){case 40:o=!0,L=0;break;case 41:L=o?0:1;break;case 91:p=!0,m=!0,L=0;break;case 93:p=!1,L=m?0:1;break;case 123:E=!0,L=0;break;case 125:L=E?0:1;break;case 39:L=i===34||i===96?0:1;break;case 34:L=i===39||i===96?0:1;break;case 96:L=i===39||i===34?0:1;break;case 42:L=i===42?1:0;break;case 124:L=i===124?1:0;break;case 32:L=p?0:1;break;default:L=S.get(l)}L===1&&(w.push(I._createLink(S,d,_,n,t)),b=!0)}else if(r===12){let L;l===91?(m=!0,L=0):L=S.get(l),L===1?b=!0:r=13}else r=h.nextState(r,l),r===0&&(b=!0);b&&(r=1,o=!1,m=!1,E=!1,n=t+1,i=l),t++}r===13&&w.push(I._createLink(S,d,_,n,f))}return w}}e.LinkComputer=I;function a(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:I.computeLinks(g)}e.computeLinks=a}),define(pe[143],ve([0,1,3,6]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,C){return this._map.set(A,C),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===C&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,C){let D=null,P=!1;return this._promises.set(A,C.then(s=>{this._promises.delete(A),!(P||!s)&&(D=this.register(A,s))})),R.toDisposable(()=>{P=!0,D&&D.dispose()})}getPromise(A){const C=this.get(A);if(C)return Promise.resolve(C);const D=this._promises.get(A);return D?D.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(pe[107],ve([0,1,22,11]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function y(I){for(let a=0,g=I.length;a<g;a+=4){const c=I[a+0],h=I[a+1],S=I[a+2],w=I[a+3];I[a+0]=w,I[a+1]=S,I[a+2]=h,I[a+3]=c}}function A(I){const a=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||y(a),v.VSBuffer.wrap(a)}function C(I){const a=I.buffer;if(R.isLittleEndian()||y(a),a.byteOffset%4==0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const g=new Uint8Array(a.byteLength);return g.set(a),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(I){const a=new Uint32Array(P(I));let g=0;if(a[g++]=I.id,I.type==="full")a[g++]=1,a[g++]=I.data.length,a.set(I.data,g),g+=I.data.length;else{a[g++]=2,a[g++]=I.deltas.length;for(const c of I.deltas)a[g++]=c.start,a[g++]=c.deleteCount,c.data?(a[g++]=c.data.length,a.set(c.data,g),g+=c.data.length):a[g++]=0}return A(a)}e.encodeSemanticTokensDto=D;function P(I){let a=0;if(a+=1+1,I.type==="full")a+=1+I.data.length;else{a+=1,a+=(1+1+1)*I.deltas.length;for(const g of I.deltas)g.data&&(a+=g.data.length)}return a}function s(I){const a=C(I);let g=0;const c=a[g++];if(a[g++]===1){const _=a[g++],u=a.subarray(g,g+_);return g+=_,{id:c,type:"full",data:u}}const S=a[g++];let w=[];for(let _=0;_<S;_++){const u=a[g++],d=a[g++],f=a[g++];let t;f>0&&(t=a.subarray(g,g+f),g+=f),w[_]={start:u,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=s}),define(pe[108],ve([0,1,93]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,C){this.index=A,this.remainder=C}}e.PrefixSumIndexOfResult=R;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,C){A=v.toUint32(A);const D=this.values,P=this.prefixSum,s=C.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A),A+s),this.values.set(C,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,C){return A=v.toUint32(A),C=v.toUint32(C),this.values[A]===C?!1:(this.values[A]=C,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,C){A=v.toUint32(A),C=v.toUint32(C);const D=this.values,P=this.prefixSum;if(A>=D.length)return!1;let s=D.length-A;return C>=s&&(C=s),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A+C),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(A){return A<0?0:(A=v.toUint32(A),this._getAccumulatedValue(A))}_getAccumulatedValue(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),A>=this.values.length&&(A=this.values.length-1);for(let D=C;D<=A;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalValue();let C=0,D=this.values.length-1,P=0,s=0,I=0;for(;C<=D;)if(P=C+(D-C)/2|0,s=this.prefixSum[P],I=s-this.values[P],A<I)D=P-1;else if(A>=s)C=P+1;else break;return new R(P,A-I)}}e.PrefixSumComputer=k}),define(pe[144],ve([0,1,8,44,108]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class y{constructor(C,D,P,s){this._uri=C,this._lines=D,this._eol=P,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new R.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let s=0;s<D;s++)P[s]=this._lines[s].length+C;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length===0)return;let P=v.splitLines(D);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let s=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),s[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,s)}}e.MirrorTextModel=y}),define(pe[145],ve([19,20]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(pe[146],ve([0,1,145]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,y=k*24,A=y*7,C=y*30,D=y*365;function P(I,a){typeof I!="number"&&(I=I.getTime());const g=Math.round((new Date().getTime()-I)/1e3);if(g<-30)return v.localize(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return v.localize(1,null);let c;return g<R?(c=g,a?c===1?v.localize(2,null,c):v.localize(3,null,c):c===1?v.localize(4,null,c):v.localize(5,null,c)):g<k?(c=Math.floor(g/R),a?c===1?v.localize(6,null,c):v.localize(7,null,c):c===1?v.localize(8,null,c):v.localize(9,null,c)):g<y?(c=Math.floor(g/k),a?c===1?v.localize(10,null,c):v.localize(11,null,c):c===1?v.localize(12,null,c):v.localize(13,null,c)):g<A?(c=Math.floor(g/y),a?c===1?v.localize(14,null,c):v.localize(15,null,c):c===1?v.localize(16,null,c):v.localize(17,null,c)):g<C?(c=Math.floor(g/A),a?c===1?v.localize(18,null,c):v.localize(19,null,c):c===1?v.localize(20,null,c):v.localize(21,null,c)):g<D?(c=Math.floor(g/C),a?c===1?v.localize(22,null,c):v.localize(23,null,c):c===1?v.localize(24,null,c):v.localize(25,null,c)):(c=Math.floor(g/D),a?c===1?v.localize(26,null,c):v.localize(27,null,c):c===1?v.localize(28,null,c):v.localize(29,null,c))}e.fromNow=P;function s(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(pe[147],ve([19,20]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(pe[55],ve([0,1,147,13,17]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(P,s){return s&&(P.stack||P.stacktrace)?v.localize(0,null,C(P),A(P.stack)||A(P.stacktrace)):C(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?v.localize(1,null,P.message):P.message||v.localize(2,null)}function D(P=null,s=!1){if(!P)return v.localize(3,null);if(Array.isArray(P)){const I=k.coalesce(P),a=D(I[0],s);return I.length>1?v.localize(4,null,a,I.length):a}if(R.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return y(I.error,s);if(I.exception)return y(I.exception,s)}return P.stack?y(P,s):P.message?P.message:v.localize(5,null)}e.toErrorMessage=D}),define(pe[148],ve([19,20]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(pe[109],ve([0,1,9,28,38,148,37,13,25,29,11,137,10]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,f){if(s.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};f&&(t.cwd=f);const n=k.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(i=>{n.once("error",r=>{i({success:!1,error:r})}),n.once("exit",(r,o)=>{i(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(s.isLinux||s.isMacintosh)try{const t=a.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(n=>{k.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(i,r,o)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function h(d=A.env){return d.comspec||"cmd.exe"}e.getWindowsShell=h;class S{constructor(f,t,n,i){if(t!==void 0&&n!==void 0&&i!==void 0)this.cmd=f,this.args=t,this.shell=n,this.options=i;else{const r=f;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(A.env).forEach(o=>{r[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{r[o]=this.options.env[o]}),this.options.env=r}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const t=f.lastIndexOf(v.sep);return t!==-1&&(f=f.substring(t+1)),S.WellKnowCommands[f]?f:"other"}start(f){return s.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(A.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(t=>{let n,i;const r=new Promise((o,m)=>{n=o,i=m});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=k.exec(o,this.options,(m,p,E)=>{this.childProcess=null;const b=m;b&&b.killed?i({killed:this.terminateRequested,stdout:p.toString(),stderr:E.toString()}):this.handleExec(n,f,m,p,E)})}else{let o=null;const m=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,n,f,i);const E={terminated:this.terminateRequested};C.isNumber(p)&&(E.cmdCode=p),n(E)};if(this.shell&&s.isWindows){const p=D.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let E=!1,b=!1;const l=[];let L=this.ensureQuotes(this.cmd);l.push(L.value),E=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),l.push(L.value),b=b&&L.quoted});const O=["/s","/c"];E?b?O.push('"'+l.join(" ")+'"'):l.length>1?O.push('"'+l[0]+'" '+l.slice(1).join(" ")):O.push('"'+l[0]+'"'):O.push(l.join(" ")),o=k.spawn(h(),O,p)}else this.cmd&&(o=k.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(C.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",p=>{this.childProcess=null,i({terminated:this.terminateRequested,error:p})}),o.pid&&(this.childProcess.on("close",m),this.handleSpawn(o,n,f,i,!0)))}return r})}handleClose(f,t,n,i){}ensureQuotes(f){return S.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,c(f,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!s.isWindows)return f(!1);const t=k.spawn(h(),["/s","/c"]);t.on("error",n=>f(!0)),t.on("exit",n=>f(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(f,t,n,i){super(f,t,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,t,n,i,r){[i,r].forEach((o,m)=>{const p=new I.LineDecoder;p.write(o).forEach(l=>{t({line:l,source:m===0?0:1})});const b=p.end();b&&t({line:b,source:m===0?0:1})}),f({terminated:this.terminateRequested,error:n})}handleSpawn(f,t,n,i,r){const o=new I.LineDecoder,m=new I.LineDecoder;f.stdout.on("data",p=>{o.write(p).forEach(b=>n({line:b,source:0}))}),f.stderr.on("data",p=>{m.write(p).forEach(b=>n({line:b,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=m}handleClose(f,t,n,i){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&n({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&n({line:o,source:1})}}e.LineProcess=w;function _(d){let f=[],t=!1;const n=function(i){if(t){f.push(i);return}(!d.send(i,o=>{if(o&&console.error(o),t=!1,f.length>0){const m=f.slice(0);f=[],m.forEach(p=>n(p))}})||s.isWindows)&&(t=!0)};return{send:n}}e.createQueuedSender=_;var u;(function(d){async function f(t,n,i){if(v.isAbsolute(t))return t;if(n===void 0&&(n=A.cwd()),v.dirname(t)!=="."||(i===void 0&&C.isString(A.env.PATH)&&(i=A.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(n,t);async function o(m){return await R.exists(m)?!(await R.Promises.stat(m)).isDirectory():!1}for(let m of i){let p;if(v.isAbsolute(m)?p=v.join(m,t):p=v.join(n,m,t),await o(p))return p;let E=p+".com";if(await o(E)||(E=p+".exe",await o(E)))return E}return v.join(n,t)}d.findExecutable=f})(u=e.win32||(e.win32={}))}),define(pe[149],ve([19,20]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(pe[150],ve([0,1,149,11,106]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=A;class C{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,Ee){this._values[ie]=Ee}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(ie,Ee,Ne,$e){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=$e}compute(ie,Ee,Ne){return Ne}}class s{constructor(ie,Ee=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ie){return this.defaultValue}}class I{constructor(ie,Ee,Ne,$e){this.id=ie,this.name=Ee,this.defaultValue=Ne,this.schema=$e}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,Ee,Ne){return Ne}}function a(G,ie){return typeof G=="undefined"?ie:G==="false"?!1:Boolean(G)}e.boolean=a;class g extends I{constructor(ie,Ee,Ne,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Ne),super(ie,Ee,Ne,$e)}validate(ie){return a(ie,this.defaultValue)}}class c extends I{constructor(ie,Ee,Ne,$e,We,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Ne,Xe.minimum=$e,Xe.maximum=We),super(ie,Ee,Ne,Xe),this.minimum=$e,this.maximum=We}static clampedInt(ie,Ee,Ne,$e){if(typeof ie=="undefined")return Ee;let We=parseInt(ie,10);return isNaN(We)?Ee:(We=Math.max(Ne,We),We=Math.min($e,We),We|0)}validate(ie){return c.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class h extends I{constructor(ie,Ee,Ne,$e,We){typeof We!="undefined"&&(We.type="number",We.default=Ne),super(ie,Ee,Ne,We),this.validationFn=$e}static clamp(ie,Ee,Ne){return ie<Ee?Ee:ie>Ne?Ne:ie}static float(ie,Ee){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return Ee;const Ne=parseFloat(ie);return isNaN(Ne)?Ee:Ne}validate(ie){return this.validationFn(h.float(ie,this.defaultValue))}}class S extends I{static string(ie,Ee){return typeof ie!="string"?Ee:ie}constructor(ie,Ee,Ne,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Ne),super(ie,Ee,Ne,$e)}validate(ie){return S.string(ie,this.defaultValue)}}function w(G,ie,Ee){return typeof G!="string"||Ee.indexOf(G)===-1?ie:G}e.stringSet=w;class _ extends I{constructor(ie,Ee,Ne,$e,We=void 0){typeof We!="undefined"&&(We.type="string",We.enum=$e,We.default=Ne),super(ie,Ee,Ne,We),this._allowedValues=$e}validate(ie){return w(ie,this.defaultValue,this._allowedValues)}}class u extends P{constructor(ie,Ee,Ne,$e,We,Xe,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=We,De.default=$e),super(ie,Ee,Ne,De),this._allowedValues=We,this._convert=Xe}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function d(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,Ee,Ne){return Ne===0?ie.accessibilitySupport:Ne}}class t extends P{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:v.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertSpace:a(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var r;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(r=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(G){switch(G){case r.Line:return"line";case r.Block:return"block";case r.Underline:return"underline";case r.LineThin:return"line-thin";case r.BlockOutline:return"block-outline";case r.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function m(G){switch(G){case"line":return r.Line;case"block":return r.Block;case"underline":return r.Underline;case"line-thin":return r.LineThin;case"block-outline":return r.BlockOutline;case"underline-thin":return r.UnderlineThin}}class p extends s{constructor(){super(124,[62,31])}compute(ie,Ee,Ne){const $e=["monaco-editor"];return Ee.get(31)&&$e.push(Ee.get(31)),ie.extraEditorClassName&&$e.push(ie.extraEditorClassName),Ee.get(62)==="default"?$e.push("mouse-default"):Ee.get(62)==="copy"&&$e.push("mouse-copy"),Ee.get(97)&&$e.push("showUnused"),Ee.get(122)&&$e.push("showDeprecated"),$e.join(" ")}}class E extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(ie,Ee,Ne){return Ne&&ie.emptySelectionClipboard}}class b extends P{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ie.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:v.localize(15,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{cursorMoveOnType:a(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:a(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":w(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(Ee.loop,this.defaultValue.loop)}}}class l extends P{constructor(){super(41,"fontLigatures",l.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?l.OFF:ie==="true"?l.ON:ie:Boolean(ie)?l.ON:l.OFF}}e.EditorFontLigatures=l,l.OFF='"liga" off, "calt" off',l.ON='"liga" on, "calt" on';class L extends s{constructor(){super(40)}compute(ie,Ee,Ne){return ie.fontInfo}}class O extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(ie){let Ee=h.float(ie,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ee,6,100)}compute(ie,Ee,Ne){return ie.fontInfo.fontSize}}class W extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(c.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class Z extends P{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},Ee),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},Ee),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},Ee),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},Ee),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},Ee),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Ne,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Ne,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Ne,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Ne,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Ne,description:v.localize(35,null)}})}validate(ie){var Ee,Ne,$e,We,Xe;if(!ie||typeof ie!="object")return this.defaultValue;const De=ie;return{multiple:w(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(Ee=De.multipleDefinitions)!==null&&Ee!==void 0?Ee:w(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=De.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:w(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:($e=De.multipleDeclarations)!==null&&$e!==void 0?$e:w(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(We=De.multipleImplementations)!==null&&We!==void 0?We:w(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=De.multipleReferences)!==null&&Xe!==void 0?Xe:w(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class oe extends P{constructor(){const ie={enabled:!0,delay:300,sticky:!0};super(50,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:v.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:a(Ee.sticky,this.defaultValue.sticky)}}}var V;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class $ extends s{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(ie,Ee,Ne){return $.computeLayout(Ee,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const Ee=ie.height/ie.lineHeight,Ne=ie.scrollBeyondLastLine?Ee-1:0,$e=(ie.viewLineCount+Ne)/(ie.pixelRatio*ie.height),We=Math.floor(ie.viewLineCount/$e);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Ne,desiredRatio:$e,minimapLineCount:We}}static _computeMinimapLayout(ie,Ee){const Ne=ie.outerWidth,$e=ie.outerHeight,We=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(We*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Xe=Ee.stableMinimapLayoutInput,De=Xe&&ie.outerHeight===Xe.outerHeight&&ie.lineHeight===Xe.lineHeight&&ie.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Xe.pixelRatio&&ie.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ie.minimap.enabled===Xe.minimap.enabled&&ie.minimap.side===Xe.minimap.side&&ie.minimap.size===Xe.minimap.size&&ie.minimap.showSlider===Xe.minimap.showSlider&&ie.minimap.renderCharacters===Xe.minimap.renderCharacters&&ie.minimap.maxColumn===Xe.minimap.maxColumn&&ie.minimap.scale===Xe.minimap.scale&&ie.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ie.isViewportWrapping===Xe.isViewportWrapping,ye=ie.lineHeight,ke=ie.typicalHalfwidthCharacterWidth,le=ie.scrollBeyondLastLine,he=ie.minimap.renderCharacters;let H=We>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const ee=ie.minimap.maxColumn,ue=ie.minimap.size,Pe=ie.minimap.side,Ie=ie.verticalScrollbarWidth,Ue=ie.viewLineCount,xe=ie.remainingWidth,Qe=ie.isViewportWrapping,rt=he?2:3;let tt=Math.floor(We*$e);const Ye=tt/We;let ot=!1,Et=!1,bt=rt*H,_e=H/We,fe=1;if(ue==="fill"||ue==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:ct,desiredRatio:it,minimapLineCount:vt}=$.computeContainedMinimapLineCount({viewLineCount:Ue,scrollBeyondLastLine:le,height:$e,lineHeight:ye,pixelRatio:We});if(Ue/vt>1)ot=!0,Et=!0,H=1,bt=1,_e=H/We;else{let lt=!1,mt=H+1;if(ue==="fit"){const It=Math.ceil((Ue+ct)*bt);Qe&&De&&xe<=Ee.stableFitRemainingWidth?(lt=!0,mt=Ee.stableFitMaxMinimapScale):(lt=It>tt,Qe&&lt?(Ee.stableMinimapLayoutInput=ie,Ee.stableFitRemainingWidth=xe):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0))}if(ue==="fill"||lt){ot=!0;const It=H;bt=Math.min(ye*We,Math.max(1,Math.floor(1/it))),H=Math.min(mt,Math.max(1,Math.floor(bt/rt))),H>It&&(fe=Math.min(2,H/It)),_e=H/We/fe,tt=Math.ceil(Math.max(ft,Ue+ct)*bt),Qe&&lt&&(Ee.stableFitMaxMinimapScale=H)}}}const de=Math.floor(ee*_e),X=Math.min(de,Math.max(0,Math.floor((xe-Ie-2)*_e/(ke+_e)))+e.MINIMAP_GUTTER_WIDTH);let Oe=Math.floor(We*X);const Le=Oe/We;Oe=Math.floor(Oe*fe);const Ze=he?1:2,et=Pe==="left"?0:Ne-X-Ie;return{renderMinimap:Ze,minimapLeft:et,minimapWidth:X,minimapHeightIsEditorHeight:ot,minimapIsSampling:Et,minimapScale:H,minimapLineHeight:bt,minimapCanvasInnerWidth:Oe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ye}}static computeLayout(ie,Ee){const Ne=Ee.outerWidth|0,$e=Ee.outerHeight|0,We=Ee.lineHeight|0,Xe=Ee.lineNumbersDigitCount|0,De=Ee.typicalHalfwidthCharacterWidth,ye=Ee.maxDigitWidth,ke=Ee.pixelRatio,le=Ee.viewLineCount,he=ie.get(119),H=he==="inherit"?ie.get(118):he,ee=H==="inherit"?ie.get(114):H,ue=ie.get(117),Pe=ie.get(2),Ie=Ee.isDominatedByLongLines,Ue=ie.get(46),xe=ie.get(56).renderType!==0,Qe=ie.get(57),rt=ie.get(91),tt=ie.get(61),Ye=ie.get(89),ot=Ye.verticalScrollbarSize,Et=Ye.verticalHasArrows,bt=Ye.arrowSize,_e=Ye.horizontalScrollbarSize,fe=ie.get(54),de=ie.get(35);let X;if(typeof fe=="string"&&/^\d+(\.\d+)?ch$/.test(fe)){const Rt=parseFloat(fe.substr(0,fe.length-2));X=c.clampedInt(Rt*De,0,0,1e3)}else X=c.clampedInt(fe,0,0,1e3);de&&(X+=16);let Oe=0;if(xe){const Rt=Math.max(Xe,Qe);Oe=Math.round(Rt*ye)}let Le=0;Ue&&(Le=We);let Ze=0,et=Ze+Le,ft=et+Oe,ct=ft+X;const it=Ne-Le-Oe-X;let vt=!1,ht=!1,lt=-1;Pe!==2&&(H==="inherit"&&Ie?(vt=!0,ht=!0):ee==="on"||ee==="bounded"?ht=!0:ee==="wordWrapColumn"&&(lt=ue));const mt=$._computeMinimapLayout({outerWidth:Ne,outerHeight:$e,lineHeight:We,typicalHalfwidthCharacterWidth:De,pixelRatio:ke,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:ot,viewLineCount:le,remainingWidth:it,isViewportWrapping:ht},Ee.memory||new D);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ze+=mt.minimapWidth,et+=mt.minimapWidth,ft+=mt.minimapWidth,ct+=mt.minimapWidth);const It=it-mt.minimapWidth,Ct=Math.max(1,Math.floor((It-ot-2)/De)),At=Et?bt:0;return ht&&(lt=Math.max(1,Ct),ee==="bounded"&&(lt=Math.min(lt,ue))),{width:Ne,height:$e,glyphMarginLeft:Ze,glyphMarginWidth:Le,lineNumbersLeft:et,lineNumbersWidth:Oe,decorationsLeft:ft,decorationsWidth:X,contentLeft:ct,contentWidth:It,minimap:mt,viewportColumn:Ct,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:lt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:_e,overviewRuler:{top:At,width:ot,height:$e-2*At,right:0}}}}e.EditorLayoutInfoComputer=$;class j extends P{constructor(){const ie={enabled:!0};super(53,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:v.localize(39,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:a(ie.enabled,this.defaultValue.enabled)}}}class T extends P{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,description:v.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class N extends c{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(ie,Ee,Ne){return ie.fontInfo.lineHeight}}class F extends P{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:ie.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:v.localize(53,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),size:w(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ee.side,this.defaultValue.side,["right","left"]),showSlider:w(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(G){return G==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class U extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class x extends P{constructor(){const ie={enabled:!0,cycle:!1};super(72,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:v.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{enabled:a(Ee.enabled,this.defaultValue.enabled),cycle:a(Ee.cycle,this.defaultValue.cycle)}}}class K extends s{constructor(){super(125)}compute(ie,Ee,Ne){return ie.pixelRatio}}class se extends P{constructor(){const ie={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:v.localize(58,null)},comments:{type:"boolean",default:ie.comments,description:v.localize(59,null)},other:{type:"boolean",default:ie.other,description:v.localize(60,null)}}}],default:ie,description:v.localize(61,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const Ee=ie,Ne={other:a(Ee.other,this.defaultValue.other),comments:a(Ee.comments,this.defaultValue.comments),strings:a(Ee.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var be;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(ie){let Ee=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(Ee=4,Ne=ie):ie==="interval"?Ee=3:ie==="relative"?Ee=2:ie==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Ne}}}function Ce(G){const ie=G.get(84);return ie==="editable"?G.get(77):ie!=="on"}e.filterValidationDecorations=Ce;class Fe extends P{constructor(){const ie=[],Ee={type:"number",description:v.localize(67,null)};super(88,"rulers",ie,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:ie,description:v.localize(69,null)})}validate(ie){if(Array.isArray(ie)){let Ee=[];for(let Ne of ie)if(typeof Ne=="number")Ee.push({column:c.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const $e=Ne;Ee.push({column:c.clampedInt($e.column,0,0,1e4),color:$e.color})}return Ee.sort((Ne,$e)=>Ne.column-$e.column),Ee}return this.defaultValue}}function qe(G,ie){if(typeof G!="string")return ie;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie,Ne=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:qe(Ee.vertical,this.defaultValue.vertical),horizontal:qe(Ee.horizontal,this.defaultValue.horizontal),useShadows:a(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,$e,0,1e3),scrollByPage:a(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends P{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,ghostTextExpanded:!0,showInlineCompletions:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(70,null),v.localize(71,null)],default:ie.insertMode,description:v.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:v.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:v.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:v.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:v.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:v.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:v.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:ie.showSuggestionPreview,description:v.localize(79,null)},"editor.suggest.showInlineCompletions":{type:"boolean",default:ie.showInlineCompletions,description:v.localize(80,null)},"editor.suggest.ghostTextExpanded":{type:"boolean",default:ie.ghostTextExpanded,description:v.localize(81,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:v.localize(82,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(83,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(84,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(113,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const Ee=ie;return{insertMode:w(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:a(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:a(Ee.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:a(Ee.showSuggestionPreview,this.defaultValue.showSuggestionPreview),ghostTextExpanded:a(Ee.ghostTextExpanded,this.defaultValue.ghostTextExpanded),showInlineCompletions:a(Ee.showInlineCompletions,this.defaultValue.showInlineCompletions),showInlineDetails:a(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(Ee.showMethods,this.defaultValue.showMethods),showFunctions:a(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:a(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:a(Ee.showFields,this.defaultValue.showFields),showVariables:a(Ee.showVariables,this.defaultValue.showVariables),showClasses:a(Ee.showClasses,this.defaultValue.showClasses),showStructs:a(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:a(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:a(Ee.showModules,this.defaultValue.showModules),showProperties:a(Ee.showProperties,this.defaultValue.showProperties),showEvents:a(Ee.showEvents,this.defaultValue.showEvents),showOperators:a(Ee.showOperators,this.defaultValue.showOperators),showUnits:a(Ee.showUnits,this.defaultValue.showUnits),showValues:a(Ee.showValues,this.defaultValue.showValues),showConstants:a(Ee.showConstants,this.defaultValue.showConstants),showEnums:a(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:a(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(Ee.showKeywords,this.defaultValue.showKeywords),showWords:a(Ee.showWords,this.defaultValue.showWords),showColors:a(Ee.showColors,this.defaultValue.showColors),showFiles:a(Ee.showFiles,this.defaultValue.showFiles),showReferences:a(Ee.showReferences,this.defaultValue.showReferences),showFolders:a(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:a(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:a(Ee.showUsers,this.defaultValue.showUsers),showIssues:a(Ee.showIssues,this.defaultValue.showIssues)}}}class q extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(114,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class J extends s{constructor(){super(126,[77])}compute(ie,Ee,Ne){return Ee.get(77)?!0:ie.tabFocusMode}}var re;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function ae(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Y extends s{constructor(){super(128,[127])}compute(ie,Ee,Ne){const $e=Ee.get(127);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const ce="Consolas, 'Courier New', monospace",ge="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?ge:R.isLinux?Re:ce,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(G){return e.editorOptionsRegistry[G.id]=G,G}var je;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.codeLens=12]="codeLens",G[G.codeLensFontFamily=13]="codeLensFontFamily",G[G.codeLensFontSize=14]="codeLensFontSize",G[G.colorDecorators=15]="colorDecorators",G[G.columnSelection=16]="columnSelection",G[G.comments=17]="comments",G[G.contextmenu=18]="contextmenu",G[G.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",G[G.cursorBlinking=20]="cursorBlinking",G[G.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",G[G.cursorStyle=22]="cursorStyle",G[G.cursorSurroundingLines=23]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",G[G.cursorWidth=25]="cursorWidth",G[G.disableLayerHinting=26]="disableLayerHinting",G[G.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",G[G.domReadOnly=28]="domReadOnly",G[G.dragAndDrop=29]="dragAndDrop",G[G.emptySelectionClipboard=30]="emptySelectionClipboard",G[G.extraEditorClassName=31]="extraEditorClassName",G[G.fastScrollSensitivity=32]="fastScrollSensitivity",G[G.find=33]="find",G[G.fixedOverflowWidgets=34]="fixedOverflowWidgets",G[G.folding=35]="folding",G[G.foldingStrategy=36]="foldingStrategy",G[G.foldingHighlight=37]="foldingHighlight",G[G.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=39]="fontFamily",G[G.fontInfo=40]="fontInfo",G[G.fontLigatures=41]="fontLigatures",G[G.fontSize=42]="fontSize",G[G.fontWeight=43]="fontWeight",G[G.formatOnPaste=44]="formatOnPaste",G[G.formatOnType=45]="formatOnType",G[G.glyphMargin=46]="glyphMargin",G[G.gotoLocation=47]="gotoLocation",G[G.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",G[G.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",G[G.hover=50]="hover",G[G.inDiffEditor=51]="inDiffEditor",G[G.letterSpacing=52]="letterSpacing",G[G.lightbulb=53]="lightbulb",G[G.lineDecorationsWidth=54]="lineDecorationsWidth",G[G.lineHeight=55]="lineHeight",G[G.lineNumbers=56]="lineNumbers",G[G.lineNumbersMinChars=57]="lineNumbersMinChars",G[G.linkedEditing=58]="linkedEditing",G[G.links=59]="links",G[G.matchBrackets=60]="matchBrackets",G[G.minimap=61]="minimap",G[G.mouseStyle=62]="mouseStyle",G[G.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=64]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",G[G.multiCursorModifier=66]="multiCursorModifier",G[G.multiCursorPaste=67]="multiCursorPaste",G[G.occurrencesHighlight=68]="occurrencesHighlight",G[G.overviewRulerBorder=69]="overviewRulerBorder",G[G.overviewRulerLanes=70]="overviewRulerLanes",G[G.padding=71]="padding",G[G.parameterHints=72]="parameterHints",G[G.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",G[G.quickSuggestions=75]="quickSuggestions",G[G.quickSuggestionsDelay=76]="quickSuggestionsDelay",G[G.readOnly=77]="readOnly",G[G.renameOnType=78]="renameOnType",G[G.renderControlCharacters=79]="renderControlCharacters",G[G.renderIndentGuides=80]="renderIndentGuides",G[G.renderFinalNewline=81]="renderFinalNewline",G[G.renderLineHighlight=82]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=84]="renderValidationDecorations",G[G.renderWhitespace=85]="renderWhitespace",G[G.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",G[G.roundedSelection=87]="roundedSelection",G[G.rulers=88]="rulers",G[G.scrollbar=89]="scrollbar",G[G.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=91]="scrollBeyondLastLine",G[G.scrollPredominantAxis=92]="scrollPredominantAxis",G[G.selectionClipboard=93]="selectionClipboard",G[G.selectionHighlight=94]="selectionHighlight",G[G.selectOnLineNumbers=95]="selectOnLineNumbers",G[G.showFoldingControls=96]="showFoldingControls",G[G.showUnused=97]="showUnused",G[G.snippetSuggestions=98]="snippetSuggestions",G[G.smartSelect=99]="smartSelect",G[G.smoothScrolling=100]="smoothScrolling",G[G.stickyTabStops=101]="stickyTabStops",G[G.stopRenderingLineAfter=102]="stopRenderingLineAfter",G[G.suggest=103]="suggest",G[G.suggestFontSize=104]="suggestFontSize",G[G.suggestLineHeight=105]="suggestLineHeight",G[G.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",G[G.suggestSelection=107]="suggestSelection",G[G.tabCompletion=108]="tabCompletion",G[G.tabIndex=109]="tabIndex",G[G.unusualLineTerminators=110]="unusualLineTerminators",G[G.useShadowDOM=111]="useShadowDOM",G[G.useTabStops=112]="useTabStops",G[G.wordSeparators=113]="wordSeparators",G[G.wordWrap=114]="wordWrap",G[G.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=117]="wordWrapColumn",G[G.wordWrapOverride1=118]="wordWrapOverride1",G[G.wordWrapOverride2=119]="wordWrapOverride2",G[G.wrappingIndent=120]="wrappingIndent",G[G.wrappingStrategy=121]="wrappingStrategy",G[G.showDeprecated=122]="showDeprecated",G[G.inlayHints=123]="inlayHints",G[G.editorClassName=124]="editorClassName",G[G.pixelRatio=125]="pixelRatio",G[G.tabFocusMode=126]="tabFocusMode",G[G.layoutInfo=127]="layoutInfo",G[G.wrappingInfo=128]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(115,null)})),acceptSuggestionOnEnter:we(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(116,null),""],markdownDescription:v.localize(117,null)})),accessibilitySupport:we(new f),accessibilityPageSize:we(new c(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(118,null)})),ariaLabel:we(new S(4,"ariaLabel",v.localize(119,null))),autoClosingBrackets:we(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(120,null),v.localize(121,null),""],description:v.localize(122,null)})),autoClosingDelete:we(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(123,null),""],description:v.localize(124,null)})),autoClosingOvertype:we(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(125,null),""],description:v.localize(126,null)})),autoClosingQuotes:we(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(127,null),v.localize(128,null),""],description:v.localize(129,null)})),autoIndent:we(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null),v.localize(134,null)],description:v.localize(135,null)})),automaticLayout:we(new g(10,"automaticLayout",!1)),autoSurround:we(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(136,null),v.localize(137,null),v.localize(138,null),""],description:v.localize(139,null)})),stickyTabStops:we(new g(101,"stickyTabStops",!1,{description:v.localize(140,null)})),codeLens:we(new g(12,"codeLens",!0,{description:v.localize(141,null)})),codeLensFontFamily:we(new S(13,"codeLensFontFamily","",{description:v.localize(142,null)})),codeLensFontSize:we(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(143,null)})),colorDecorators:we(new g(15,"colorDecorators",!0,{description:v.localize(144,null)})),columnSelection:we(new g(16,"columnSelection",!1,{description:v.localize(145,null)})),comments:we(new t),contextmenu:we(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(146,null)})),cursorBlinking:we(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:v.localize(147,null)})),cursorSmoothCaretAnimation:we(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(148,null)})),cursorStyle:we(new u(22,"cursorStyle",r.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],m,{description:v.localize(149,null)})),cursorSurroundingLines:we(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(150,null)})),cursorSurroundingLinesStyle:we(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(151,null),v.localize(152,null)],description:v.localize(153,null)})),cursorWidth:we(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(154,null)})),disableLayerHinting:we(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new g(28,"domReadOnly",!1)),dragAndDrop:we(new g(29,"dragAndDrop",!0,{description:v.localize(155,null)})),emptySelectionClipboard:we(new E),extraEditorClassName:we(new S(31,"extraEditorClassName","")),fastScrollSensitivity:we(new h(32,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:v.localize(156,null)})),find:we(new b),fixedOverflowWidgets:we(new g(34,"fixedOverflowWidgets",!1)),folding:we(new g(35,"folding",!0,{description:v.localize(157,null)})),foldingStrategy:we(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(158,null),v.localize(159,null)],description:v.localize(160,null)})),foldingHighlight:we(new g(37,"foldingHighlight",!0,{description:v.localize(161,null)})),unfoldOnClickAfterEndOfLine:we(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(162,null)})),fontFamily:we(new S(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(163,null)})),fontInfo:we(new L),fontLigatures2:we(new l),fontSize:we(new O),fontWeight:we(new W),formatOnPaste:we(new g(44,"formatOnPaste",!1,{description:v.localize(164,null)})),formatOnType:we(new g(45,"formatOnType",!1,{description:v.localize(165,null)})),glyphMargin:we(new g(46,"glyphMargin",!0,{description:v.localize(166,null)})),gotoLocation:we(new Z),hideCursorInOverviewRuler:we(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(167,null)})),highlightActiveIndentGuide:we(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(168,null)})),hover:we(new oe),inDiffEditor:we(new g(51,"inDiffEditor",!1)),letterSpacing:we(new h(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>h.clamp(G,-5,20),{description:v.localize(169,null)})),lightbulb:we(new j),lineDecorationsWidth:we(new I(54,"lineDecorationsWidth",10)),lineHeight:we(new N),lineNumbers:we(new Te),lineNumbersMinChars:we(new c(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new g(58,"linkedEditing",!1,{description:v.localize(170,null)})),links:we(new g(59,"links",!0,{description:v.localize(171,null)})),matchBrackets:we(new _(60,"matchBrackets","always",["always","near","never"],{description:v.localize(172,null)})),minimap:we(new F),mouseStyle:we(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new h(63,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:v.localize(173,null)})),mouseWheelZoom:we(new g(64,"mouseWheelZoom",!1,{markdownDescription:v.localize(174,null)})),multiCursorMergeOverlapping:we(new g(65,"multiCursorMergeOverlapping",!0,{description:v.localize(175,null)})),multiCursorModifier:we(new u(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(176,null),v.localize(177,null)],markdownDescription:v.localize(178,null)})),multiCursorPaste:we(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(179,null),v.localize(180,null)],markdownDescription:v.localize(181,null)})),occurrencesHighlight:we(new g(68,"occurrencesHighlight",!0,{description:v.localize(182,null)})),overviewRulerBorder:we(new g(69,"overviewRulerBorder",!0,{description:v.localize(183,null)})),overviewRulerLanes:we(new c(70,"overviewRulerLanes",3,0,3)),padding:we(new U),parameterHints:we(new x),peekWidgetDefaultFocus:we(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(184,null),v.localize(185,null)],description:v.localize(186,null)})),definitionLinkOpensInPeek:we(new g(74,"definitionLinkOpensInPeek",!1,{description:v.localize(187,null)})),quickSuggestions:we(new se),quickSuggestionsDelay:we(new c(76,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(188,null)})),readOnly:we(new g(77,"readOnly",!1)),renameOnType:we(new g(78,"renameOnType",!1,{description:v.localize(189,null),markdownDeprecationMessage:v.localize(190,null)})),renderControlCharacters:we(new g(79,"renderControlCharacters",!1,{description:v.localize(191,null)})),renderIndentGuides:we(new g(80,"renderIndentGuides",!0,{description:v.localize(192,null)})),renderFinalNewline:we(new g(81,"renderFinalNewline",!0,{description:v.localize(193,null)})),renderLineHighlight:we(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(194,null)],description:v.localize(195,null)})),renderLineHighlightOnlyWhenFocus:we(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(196,null)})),renderValidationDecorations:we(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(197,null),v.localize(198,null),v.localize(199,null),""],description:v.localize(200,null)})),revealHorizontalRightPadding:we(new c(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new g(87,"roundedSelection",!0,{description:v.localize(201,null)})),rulers:we(new Fe),scrollbar:we(new ze),scrollBeyondLastColumn:we(new c(90,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(202,null)})),scrollBeyondLastLine:we(new g(91,"scrollBeyondLastLine",!0,{description:v.localize(203,null)})),scrollPredominantAxis:we(new g(92,"scrollPredominantAxis",!0,{description:v.localize(204,null)})),selectionClipboard:we(new g(93,"selectionClipboard",!0,{description:v.localize(205,null),included:R.isLinux})),selectionHighlight:we(new g(94,"selectionHighlight",!0,{description:v.localize(206,null)})),selectOnLineNumbers:we(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(207,null),v.localize(208,null)],description:v.localize(209,null)})),showUnused:we(new g(97,"showUnused",!0,{description:v.localize(210,null)})),showDeprecated:we(new g(122,"showDeprecated",!0,{description:v.localize(211,null)})),inlayHints:we(new T),snippetSuggestions:we(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(212,null),v.localize(213,null),v.localize(214,null),v.localize(215,null)],description:v.localize(216,null)})),smartSelect:we(new q),smoothScrolling:we(new g(100,"smoothScrolling",!1,{description:v.localize(217,null)})),stopRenderingLineAfter:we(new c(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new Ge),suggestFontSize:we(new c(104,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestLineHeight:we(new c(105,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(219,null)})),suggestOnTriggerCharacters:we(new g(106,"suggestOnTriggerCharacters",!0,{description:v.localize(220,null)})),suggestSelection:we(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null)],description:v.localize(224,null)})),tabCompletion:we(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(225,null),v.localize(226,null),v.localize(227,null)],description:v.localize(228,null)})),tabIndex:we(new c(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(229,null),v.localize(230,null),v.localize(231,null)],description:v.localize(232,null)})),useShadowDOM:we(new g(111,"useShadowDOM",!0)),useTabStops:we(new g(112,"useTabStops",!0,{description:v.localize(233,null)})),wordSeparators:we(new S(113,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:v.localize(234,null)})),wordWrap:we(new _(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(235,null),v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),wordWrapBreakAfterCharacters:we(new S(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new S(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new c(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(240,null)})),wordWrapOverride1:we(new _(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new _(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new u(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ae,{enumDescriptions:[v.localize(241,null),v.localize(242,null),v.localize(243,null),v.localize(244,null)],description:v.localize(245,null)})),wrappingStrategy:we(new _(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(246,null),v.localize(247,null)],description:v.localize(248,null)})),editorClassName:we(new p),pixelRatio:we(new K),tabFocusMode:we(new J),layoutInfo:we(new $),wrappingInfo:we(new Y)}}),define(pe[151],ve([19,20]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[152],ve([19,20]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[153],ve([19,20]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[154],ve([19,20]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[155],ve([19,20]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(pe[156],ve([19,20]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(pe[157],ve([19,20]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[158],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[159],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[160],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[161],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[162],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[163],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[164],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[165],ve([19,20]),function(Q,e){return Q.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[166],ve([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[167],ve([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[168],ve([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[169],ve([19,20]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[170],ve([19,20]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[171],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var y;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(y=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[172],ve([0,1,153]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||R.test(a)}e.isValidVersionStr=y;function A(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=a.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function C(a){if(!a)return null;let g=a.majorBase,c=a.majorMustEqual,h=a.minorBase,S=a.minorMustEqual,w=a.patchBase,_=a.patchMustEqual;a.hasCaret&&(g===0||(S=!1),_=!1);let u=0;if(a.preRelease){const d=k.exec(a.preRelease);if(d){const[,f,t,n]=d;u=Date.UTC(Number(f),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:c,minorBase:h,minorMustEqual:S,patchBase:w,patchMustEqual:_,isMinimum:a.hasGreaterEquals,notBefore:u}}e.normalizeVersion=C;function D(a,g,c){let h;typeof a=="string"?h=C(A(a)):h=a;let S;g instanceof Date?S=g.getTime():typeof g=="string"&&(S=new Date(g).getTime());let w;if(typeof c=="string"?w=C(A(c)):w=c,!h||!w)return!1;let _=h.majorBase,u=h.minorBase,d=h.patchBase,f=w.majorBase,t=w.minorBase,n=w.patchBase,i=w.notBefore,r=w.majorMustEqual,o=w.minorMustEqual,m=w.patchMustEqual;return w.isMinimum?_>f?!0:_<f?!1:u>t?!0:u<t||S&&S<i?!1:d>=n:(_===1&&f===0&&(!r||!o||!m)&&(f=1,t=0,n=0,r=!0,o=!1,m=!1),_<f?!1:_>f?!r:u<t?!1:u>t?!o:d<n?!1:d>n?!m:!(S&&S<i))}e.isValidVersion=D;function P(a,g,c,h){return c.isBuiltin||typeof c.main=="undefined"?!0:I(a,g,c.engines.vscode,h)}e.isValidExtensionVersion=P;function s(a,g,c){return a==="*"||I(g,c,a)}e.isEngineValid=s;function I(a,g,c,h=[]){let S=C(A(c));if(!S)return h.push(v.localize(0,null,c)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return h.push(v.localize(1,null,c)),!1}else if(!S.majorMustEqual)return h.push(v.localize(2,null,c)),!1;return D(a,g,S)?!0:(h.push(v.localize(3,null,a,c)),!1)}}),define(pe[110],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(y,A=[],C=!1){this.ctor=y,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=v;const R=(k,...y)=>new v(k,y);e.createSyncDescriptor=R}),define(pe[78],ve([0,1,110]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(A,C,D){C instanceof v.SyncDescriptor||(C=new v.SyncDescriptor(C,[],D)),R.push([A,C])}e.registerSingleton=k;function y(){return R}e.getSingletonServiceDescriptors=y}),define(pe[173],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=v;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let A of this._nodes.values())A.outgoing.size===0&&y.push(A);return y}insertEdge(y,A){const C=this.lookupOrInsertNode(y),D=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(y),C)}removeNode(y){const A=this._hashFn(y);this._nodes.delete(A);for(let C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(y){const A=this._hashFn(y);let C=this._nodes.get(A);return C||(C=new v(y),this._nodes.set(A,C)),C}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[A,C]of this._nodes)y.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,A]of this._nodes){const C=new Set([y]),D=this._findCycle(A,C);if(D)return D}}_findCycle(y,A){for(let[C,D]of y.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const P=this._findCycle(D,A);if(P)return P;A.delete(C)}}}e.Graph=R}),define(pe[4],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(C,D,P,s){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:C,index:P,optional:s}):(D[v.DI_DEPENDENCIES]=[{id:C,index:P,optional:s}],D[v.DI_TARGET]=D)}function k(C){if(v.serviceIds.has(C))return v.serviceIds.get(C);const D=function(P,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,P,I,!1)};return D.toString=()=>C,v.serviceIds.set(C,D),D}e.createDecorator=k;function y(C){return C}e.refineServiceDecorator=y;function A(C){return function(D,P,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(C,D,s,!0)}}e.optional=A}),define(pe[174],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=v.createDecorator("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(pe[175],ve([0,1,3,74,6,23,73,77,174]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(a){return typeof a=="string"?!1:Array.isArray(a)?a.every(P):!!a.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,c){let h={selector:g,provider:c,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(h){let S=this._entries.indexOf(h);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const c=[];for(let h of this._entries)h._score>0&&c.push(h.provider);return c}ordered(g){const c=[];return this._orderedForEach(g,h=>c.push(h.provider)),c}orderedGroups(g){const c=[];let h,S;return this._orderedForEach(g,w=>{h&&S===w._score?h.push(w.provider):(S=w._score,h=[w.provider],c.push(h))}),c}_orderedForEach(g,c){if(!!g){this._updateScores(g);for(const h of this._entries)h._score>0&&c(h)}}_updateScores(g){let c={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let h of this._entries)if(h._score=C.score(h.selector,g.uri,g.getLanguageIdentifier().language,D.shouldSynchronizeModel(g)),P(h.selector)&&h._score>0){for(let S of this._entries)S._score=0;h._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(g,c){return g._score<c._score?1:g._score>c._score?-1:g._time<c._time?1:g._time>c._time?-1:0}}e.LanguageFeatureRegistry=s;class I{constructor(g,c,h=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=c,this.max=h,this._cache=new y.LRUCache(50,.7)}_key(g){return g.id+R.hash(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const c=this._key(g),h=this._cache.get(c);return this._clamp(h==null?void 0:h.value)}update(g,c){const h=this._key(g);let S=this._cache.get(h);return S||(S=new A.MovingAverage,this._cache.set(h,S)),S.update(c),this.get(g)}}e.LanguageFeatureRequestDelays=I}),define(pe[79],ve([0,1,2,41,175,143,91]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(l){l[l.Null=0]="Null",l[l.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var P;(function(l){l[l.NotSet=-1]="NotSet",l[l.None=0]="None",l[l.Italic=1]="Italic",l[l.Bold=2]="Bold",l[l.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var s;(function(l){l[l.None=0]="None",l[l.DefaultForeground=1]="DefaultForeground",l[l.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var I;(function(l){l[l.Other=0]="Other",l[l.Comment=1]="Comment",l[l.String=2]="String",l[l.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var a;(function(l){l[l.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",l[l.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",l[l.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",l[l.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",l[l.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",l[l.ITALIC_MASK=2048]="ITALIC_MASK",l[l.BOLD_MASK=4096]="BOLD_MASK",l[l.UNDERLINE_MASK=8192]="UNDERLINE_MASK",l[l.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",l[l.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",l[l.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",l[l.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",l[l.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",l[l.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",l[l.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",l[l.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",l[l.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",l[l.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(a=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,Z=this.getFontStyle(L);return Z&1&&(W+=" mtki"),Z&2&&(W+=" mtkb"),Z&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),Z=this.getFontStyle(L);let oe=`color: ${O[W]};`;return Z&1&&(oe+="font-style: italic;"),Z&2&&(oe+="font-weight: bold;"),Z&4&&(oe+="text-decoration: underline;"),oe}}e.TokenMetadata=g;var c;(function(l){l[l.Method=0]="Method",l[l.Function=1]="Function",l[l.Constructor=2]="Constructor",l[l.Field=3]="Field",l[l.Variable=4]="Variable",l[l.Class=5]="Class",l[l.Struct=6]="Struct",l[l.Interface=7]="Interface",l[l.Module=8]="Module",l[l.Property=9]="Property",l[l.Event=10]="Event",l[l.Operator=11]="Operator",l[l.Unit=12]="Unit",l[l.Value=13]="Value",l[l.Constant=14]="Constant",l[l.Enum=15]="Enum",l[l.EnumMember=16]="EnumMember",l[l.Keyword=17]="Keyword",l[l.Text=18]="Text",l[l.Color=19]="Color",l[l.File=20]="File",l[l.Reference=21]="Reference",l[l.Customcolor=22]="Customcolor",l[l.Folder=23]="Folder",l[l.TypeParameter=24]="TypeParameter",l[l.User=25]="User",l[l.Issue=26]="Issue",l[l.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let l=Object.create(null);return l[0]="symbol-method",l[1]="symbol-function",l[2]="symbol-constructor",l[3]="symbol-field",l[4]="symbol-variable",l[5]="symbol-class",l[6]="symbol-struct",l[7]="symbol-interface",l[8]="symbol-module",l[9]="symbol-property",l[10]="symbol-event",l[11]="symbol-operator",l[12]="symbol-unit",l[13]="symbol-value",l[14]="symbol-constant",l[15]="symbol-enum",l[16]="symbol-enum-member",l[17]="symbol-keyword",l[27]="symbol-snippet",l[18]="symbol-text",l[19]="symbol-color",l[20]="symbol-file",l[21]="symbol-reference",l[22]="symbol-customcolor",l[23]="symbol-folder",l[24]="symbol-type-parameter",l[25]="account",l[26]="issues",function(L){const O=l[L];let W=O&&A.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=A.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let l=Object.create(null);return l.method=0,l.function=1,l.constructor=2,l.field=3,l.variable=4,l.class=5,l.struct=6,l.interface=7,l.module=8,l.property=9,l.event=10,l.operator=11,l.unit=12,l.value=13,l.constant=14,l.enum=15,l["enum-member"]=16,l.enumMember=16,l.keyword=17,l.snippet=27,l.text=18,l.color=19,l.file=20,l.reference=21,l.customcolor=22,l.folder=23,l["type-parameter"]=24,l.typeParameter=24,l.account=25,l.issue=26,function(L,O){let W=l[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var h;(function(l){l[l.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(l){l[l.KeepWhitespace=1]="KeepWhitespace",l[l.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(l){l[l.Invoke=0]="Invoke",l[l.TriggerCharacter=1]="TriggerCharacter",l[l.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(l){l[l.Automatic=0]="Automatic",l[l.Explicit=1]="Explicit"})(_=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(l){l[l.Invoke=1]="Invoke",l[l.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(l){l[l.Invoke=1]="Invoke",l[l.TriggerCharacter=2]="TriggerCharacter",l[l.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(l){l[l.Text=0]="Text",l[l.Read=1]="Read",l[l.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(l){return l&&v.URI.isUri(l.uri)&&R.Range.isIRange(l.range)&&(R.Range.isIRange(l.originSelectionRange)||R.Range.isIRange(l.targetSelectionRange))}e.isLocationLink=t;var n;(function(l){l[l.File=0]="File",l[l.Module=1]="Module",l[l.Namespace=2]="Namespace",l[l.Package=3]="Package",l[l.Class=4]="Class",l[l.Method=5]="Method",l[l.Property=6]="Property",l[l.Field=7]="Field",l[l.Constructor=8]="Constructor",l[l.Enum=9]="Enum",l[l.Interface=10]="Interface",l[l.Function=11]="Function",l[l.Variable=12]="Variable",l[l.Constant=13]="Constant",l[l.String=14]="String",l[l.Number=15]="Number",l[l.Boolean=16]="Boolean",l[l.Array=17]="Array",l[l.Object=18]="Object",l[l.Key=19]="Key",l[l.Null=20]="Null",l[l.EnumMember=21]="EnumMember",l[l.Struct=22]="Struct",l[l.Event=23]="Event",l[l.Operator=24]="Operator",l[l.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var i;(function(l){l[l.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var r;(function(l){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(V){return L.get(V)}l.fromString=W;function Z(V){return O.get(V)}l.toString=Z;function oe(V,$){const j=O.get(V);let T=j&&A.iconRegistry.get("symbol-"+j);return T||(console.info("No codicon found for SymbolKind "+V),T=A.Codicon.symbolProperty),`${$?"inline":"block"} ${T.classNames}`}l.toCssClassName=oe})(r=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(L){this.value=L}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var m;(function(l){l[l.Collapsed=0]="Collapsed",l[l.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var p;(function(l){l[l.Editing=0]="Editing",l[l.Preview=1]="Preview"})(p=e.CommentMode||(e.CommentMode={}));var E;(function(l){l[l.Other=0]="Other",l[l.Type=1]="Type",l[l.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new y.TokenizationRegistryImpl;var b;(function(l){l[l.None=0]="None",l[l.Option=1]="Option",l[l.Default=2]="Default",l[l.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[111],ve([0,1,8,4,11]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let y=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",y.indexOf("Edg/")>=0),A.set("isFirefox",y.indexOf("Firefox")>=0),A.set("isChrome",y.indexOf("Chrome")>=0),A.set("isSafari",y.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return a.INSTANCE}static has(l){return g.create(l)}static equals(l,L){return c.create(l,L)}static notEquals(l,L){return w.create(l,L)}static regex(l,L){return n.create(l,L)}static in(l,L){return h.create(l,L)}static not(l){return _.create(l)}static and(...l){return r.create(l)}static or(...l){return o.create(l)}static greater(l,L){return u.create(l,L)}static less(l,L){return f.create(l,L)}static deserialize(l,L=!1){if(!!l)return this._deserializeOrExpression(l,L)}static _deserializeOrExpression(l,L){let O=l.split("||");return o.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(l,L){let O=l.split("&&");return r.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(l,L){if(l=l.trim(),l.indexOf("!=")>=0){let O=l.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("==")>=0){let O=l.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],L))}if(l.indexOf("=~")>=0){let O=l.split("=~");return n.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(l.indexOf(" in ")>=0){let O=l.split(" in ");return h.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(l)){const O=l.split(">=");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(l)){const O=l.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(l)){const O=l.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(l)){const O=l.split("<");return f.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(l)?_.create(l.substr(1).trim()):g.create(l)}static _deserializeValue(l,L){if(l=l.trim(),l==="true")return!0;if(l==="false")return!1;let O=/^'([^']*)'$/.exec(l);return O?O[1].trim():l}static _deserializeRegexValue(l,L){if(v.isFalsyOrWhitespace(l)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=l.indexOf("/"),W=l.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${l}', missing /-enclosure`);return console.warn(`bad regexp-value '${l}', missing /-enclosure`),null}let Z=l.slice(O+1,W),oe=l[W+1]==="i"?"i":"";try{return new RegExp(Z,oe)}catch(V){if(L)throw new Error(`bad regexp-value '${l}', parse error: ${V}`);return console.warn(`bad regexp-value '${l}', parse error: ${V}`),null}}}e.ContextKeyExpr=P;function s(b,l){return b.cmp(l)}class I{constructor(){this.type=0}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!1}serialize(){return"false"}keys(){return[]}map(l){return this}negate(){return a.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class a{constructor(){this.type=1}cmp(l){return this.type-l.type}equals(l){return l.type===this.type}evaluate(l){return!0}serialize(){return"true"}keys(){return[]}map(l){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=a,a.INSTANCE=new a;class g{constructor(l){this.key=l,this.type=2}static create(l){const L=A.get(l);return typeof L=="boolean"?L?a.INSTANCE:I.INSTANCE:new g(l)}cmp(l){return l.type!==this.type?this.type-l.type:p(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!!l.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(l){return l.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=g;class c{constructor(l,L){this.key=l,this.value=L,this.type=4}static create(l,L){if(typeof L=="boolean")return L?g.create(l):_.create(l);const O=A.get(l);return typeof O=="boolean"?L===(O?"true":"false")?a.INSTANCE:I.INSTANCE:new c(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(l){return l.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class h{constructor(l,L){this.key=l,this.valueKey=L,this.type=10}static create(l,L){return new h(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.valueKey,l.key,l.valueKey)}equals(l){return l.type===this.type?this.key===l.key&&this.valueKey===l.valueKey:!1}evaluate(l){const L=l.getValue(this.valueKey),O=l.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?C.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(l){return l.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=h;class S{constructor(l){this._actual=l,this.type=11}static create(l){return new S(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new S(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(l,L){this.key=l,this.value=L,this.type=5}static create(l,L){if(typeof L=="boolean")return L?_.create(l):g.create(l);const O=A.get(l);return typeof O=="boolean"?L===(O?"true":"false")?I.INSTANCE:a.INSTANCE:new w(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return l.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(l){return l.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class _{constructor(l){this.key=l,this.type=3}static create(l){const L=A.get(l);return typeof L=="boolean"?L?I.INSTANCE:a.INSTANCE:new _(l)}cmp(l){return l.type!==this.type?this.type-l.type:p(this.key,l.key)}equals(l){return l.type===this.type?this.key===l.key:!1}evaluate(l){return!l.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(l){return l.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=_;class u{constructor(l,L){this.key=l,this.value=L,this.type=12}static create(l,L){return new u(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class d{constructor(l,L){this.key=l,this.value=L,this.type=13}static create(l,L){return new d(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(l){return l.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class f{constructor(l,L){this.key=l,this.value=L,this.type=14}static create(l,L){return new f(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(l,L){this.key=l,this.value=L,this.type=15}static create(l,L){return new t(l,L)}cmp(l){return l.type!==this.type?this.type-l.type:E(this.key,this.value,l.key,l.value)}equals(l){return l.type===this.type?this.key===l.key&&this.value===l.value:!1}evaluate(l){return parseFloat(l.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(l){return l.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(l,L){this.key=l,this.regexp=L,this.type=7}static create(l,L){return new n(l,L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.key<l.key)return-1;if(this.key>l.key)return 1;const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return L<O?-1:L>O?1:0}equals(l){if(l.type===this.type){const L=this.regexp?this.regexp.source:"",O=l.regexp?l.regexp.source:"";return this.key===l.key&&L===O}return!1}evaluate(l){let L=l.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const l=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${l}`}keys(){return[this.key]}map(l){return l.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=n;class i{constructor(l){this._actual=l,this.type=8}static create(l){return new i(l)}cmp(l){return l.type!==this.type?this.type-l.type:this._actual.cmp(l._actual)}equals(l){return l.type===this.type?this._actual.equals(l._actual):!1}evaluate(l){return!this._actual.evaluate(l)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(l){return new i(this._actual.map(l))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class r{constructor(l){this.expr=l,this.type=6}static create(l){return r._normalizeArr(l)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(l))return!1;return!0}static _normalizeArr(l){const L=[];let O=!1;for(const W of l)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return I.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return a.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(s);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const Z=L.pop(),oe=o.create(W.expr.map(V=>r.create([V,Z])));oe&&(L.push(oe),L.sort(s))}return L.length===1?L[0]:new r(L)}}serialize(){return this.expr.map(l=>l.serialize()).join(" && ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new r(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let L of this.expr)l.push(L.negate());return o.create(l)}}e.ContextKeyAndExpr=r;class o{constructor(l){this.expr=l,this.type=9}static create(l){const L=o._normalizeArr(l);if(L.length!==0)return L.length===1?L[0]:new o(L)}cmp(l){if(l.type!==this.type)return this.type-l.type;if(this.expr.length<l.expr.length)return-1;if(this.expr.length>l.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],l.expr[L]);if(W!==0)return W}return 0}equals(l){if(l.type===this.type){if(this.expr.length!==l.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(l.expr[L]))return!1;return!0}return!1}evaluate(l){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(l))return!0;return!1}static _normalizeArr(l){let L=[],O=!1;if(l){for(let W=0,Z=l.length;W<Z;W++){const oe=l[W];if(!!oe){if(oe.type===0){O=!0;continue}if(oe.type===1)return[a.INSTANCE];if(oe.type===9){L=L.concat(oe.expr);continue}L.push(oe)}}if(L.length===0&&O)return[I.INSTANCE];L.sort(s)}return L}serialize(){return this.expr.map(l=>l.serialize()).join(" || ")}keys(){const l=[];for(let L of this.expr)l.push(...L.keys());return l}map(l){return new o(this.expr.map(L=>L.map(l)))}negate(){let l=[];for(let O of this.expr)l.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;l.length>1;){const O=l.shift(),W=l.shift(),Z=[];for(const oe of L(O))for(const V of L(W))Z.push(P.and(oe,V));l.unshift(P.or(...Z))}return l[0]}}e.ContextKeyOrExpr=o;class m extends g{constructor(l,L,O){super(l);this._defaultValue=L,typeof O=="object"?m._info.push(Object.assign(Object.assign({},O),{key:l})):O!==!0&&m._info.push({key:l,description:O,type:L!=null?typeof L:void 0})}static all(){return m._info.values()}bindTo(l){return l.createKey(this.key,this._defaultValue)}getValue(l){return l.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(l){return P.equals(this.key,l)}notEqualsTo(l){return P.notEquals(this.key,l)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(b,l){return b<l?-1:b>l?1:0}function E(b,l,L,O){return b<L?-1:b>L?1:l<O?-1:l>O?1:0}}),define(pe[176],ve([0,1,152,4,10]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=y;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var D;(function(I){I.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(a,g){super(a);this.code=g}}e.ExtensionManagementError=s,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(pe[26],ve([0,1,8,4]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkpaceSupportTypeMessage=k;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,a){if(typeof I=="undefined"||I===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof I=="string"||typeof a=="string"){let g=typeof I=="string"?I:I.value,c=typeof a=="string"?a:a.value;return v.equalsIgnoreCase(g,c)}return I._lower===a._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function D(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(pe[177],ve([0,1,8,26]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(g,c){return g.uuid&&c.uuid?g.uuid===c.uuid:g.id===c.id?!0:v.compareIgnoreCase(g.id,c.id)===0}e.areSameExtensions=k;class y{constructor(c,h){this.version=h,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof y?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=y;function A(g,c){return`${g}.${c}`}e.getExtensionId=A;function C(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(g,c){return C(A(g,c))}e.getGalleryExtensionId=D;function P(g,c){const h=[],S=w=>{for(const _ of h)if(_.some(u=>k(c(u),c(w))))return _;return null};for(const w of g){const _=S(w);_?_.push(w):h.push([w])}return h}e.groupByExtension=P;function s(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function I(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function a(g){const c=new Set;for(const h of g)h.malicious&&c.add(h.id.id);return c}e.getMaliciousExtensionsSet=a}),define(pe[178],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(pe[42],ve([0,1,155,9,2,4,8,13,23]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=y.createDecorator("fileService");function P($){return $.create===!0}e.isFileOpenForWriteOptions=P;var s;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var I;(function($){$[$.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var a;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock"})(a=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g($){return!!($.capabilities&2)}e.hasReadWriteCapability=g;function c($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=c;function h($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function S($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class _ extends Error{constructor(j,T){super(j);this.code=T}}e.FileSystemProviderError=_;function u($,j){const T=new _($.toString(),j);return f(T,j),T}e.createFileSystemProviderError=u;function d($){return $||u(v.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function f($,j){return $.name=j?`${j} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=f;function t($){if(!$)return w.Unknown;if($ instanceof _)return $.code;const j=/^(.+) \(FileSystemError\)$/.exec($.name);if(!j)return w.Unknown;switch(j[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function n($){if($ instanceof E)return $.fileOperationResult;switch(t($)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var i;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(j,T,N){this.resource=j,this.operation=T,this.target=N}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var o;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class m{constructor(j,T){this.ignorePathCasing=T,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=j;for(const N of j)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(j,...T){return this.doContains(j,{includeChildren:!1},...T)}affects(j,...T){return this.doContains(j,{includeChildren:!0},...T)}doContains(j,T,...N){var F,M,U,x,K,se;if(!j)return!1;const be=N.length>0;return!!((!be||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(j))||T.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(j)))||(!be||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(j))||T.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(j)))||(!be||N.includes(2))&&(((K=this.deleted)===null||K===void 0?void 0:K.findSubstr(j))||T.includeChildren&&((se=this.deleted)===null||se===void 0?void 0:se.findSuperstr(j))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(j){const T=[],N=j===1?this.added:j===0?this.updated:this.deleted;if(N)for(const[,F]of N)T.push(F);return T}filter(j){return new m(this.changes.filter(T=>j(T)),this.ignorePathCasing)}}e.FileChangesEvent=m;function p($,j,T){return!$||!j||$===j||j.length>$.length?!1:(j.charAt(j.length-1)!==R.sep&&(j+=R.sep),T?A.startsWithIgnoreCase($,j):$.indexOf(j)===0)}e.isParent=p;class E extends Error{constructor(j,T,N){super(j);this.fileOperationResult=T,this.options=N}}e.FileOperationError=E;class b extends E{constructor(j,T,N){super(j,2,N);this.stat=T}}e.NotModifiedSinceFileOperationError=b;var l;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(l=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=O;async function W($,j){if(!j.canHandleResource(k.URI.from({scheme:$.scheme})))return new Promise(T=>{const N=j.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===$.scheme&&F.added&&(N.dispose(),T())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize(j){return C.isNumber(j)||(j=0),j<Z.KB?v.localize(1,null,j.toFixed(0)):j<Z.MB?v.localize(2,null,(j/Z.KB).toFixed(2)):j<Z.GB?v.localize(3,null,(j/Z.MB).toFixed(2)):j<Z.TB?v.localize(4,null,(j/Z.GB).toFixed(2)):v.localize(5,null,(j/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var oe;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function V($){return{maxFileSize:$===0?300*Z.MB:16*Z.GB,maxHeapSize:$===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=V}),define(pe[80],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[y,A]of k)this.set(y,A)}set(k,y){const A=this._entries.get(k);return this._entries.set(k,y),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(pe[179],ve([0,1,16,173,110,4,80,14]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(c){var h;super("cyclic dependency between services");this.message=(h=c.findCycleSlow())!==null&&h!==void 0?h:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class s{constructor(c=new A.ServiceCollection,h=!1,S){this._activeInstantiations=new Set,this._services=c,this._strict=h,this._parent=S,this._services.set(y.IInstantiationService,this)}createChild(c){return new s(c,this._strict,this)}invokeFunction(c,...h){let S=a.traceInvocation(c),w=!1;try{return c({get:(u,d)=>{if(w)throw v.illegalState("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,S);if(!f&&d!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...h)}finally{w=!0,S.stop()}}createInstance(c,...h){let S,w;return c instanceof k.SyncDescriptor?(S=a.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(h),S)):(S=a.traceCreation(c),w=this._createInstance(c,h,S)),S.stop(),w}_createInstance(c,h=[],S){let w=y._util.getServiceDependencies(c).sort((d,f)=>d.index-f.index),_=[];for(const d of w){let f=this._getOrCreateServiceInstance(d.id,S);if(!f&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);_.push(f)}let u=w.length>0?w[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${h.length} static arguments`);let d=u-h.length;d>0?h=h.concat(new Array(d)):h=h.slice(0,u)}return new c(...[...h,..._])}_setServiceInstance(c,h){if(this._services.get(c)instanceof k.SyncDescriptor)this._services.set(c,h);else if(this._parent)this._parent._setServiceInstance(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let h=this._services.get(c);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):h}_getOrCreateServiceInstance(c,h){let S=this._getServiceInstanceOrDescriptor(c);return S instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,S,h.branch(c,!0)):(h.branch(c,!1),S)}_safeCreateAndCacheServiceInstance(c,h,S){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,h,S)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,h,S){const w=new R.Graph(d=>d.id.toString());let _=0;const u=[{id:c,desc:h,_trace:S}];for(;u.length;){const d=u.pop();if(w.lookupOrInsertNode(d),_++>1e3)throw new P(w);for(let f of y._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${c} depends on ${f.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const n={id:f.id,desc:t,_trace:d._trace.branch(f.id,!0)};w.insertEdge(d,n),u.push(n)}}}for(;;){const d=w.roots();if(d.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:f}of d){if(this._getServiceInstanceOrDescriptor(f.id)instanceof k.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}w.removeNode(f)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,h,S=[],w,_){if(this._services.get(c)instanceof k.SyncDescriptor)return this._createServiceInstance(h,S,w,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,h,S,w,_);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(c,h=[],S,w){if(S){const _=new C.IdleValue(()=>this._createInstance(c,h,w));return new Proxy(Object.create(null),{get(u,d){if(d in u)return u[d];let f=_.value,t=f[d];return typeof t!="function"||(t=t.bind(f),u[d]=t),t},set(u,d,f){return _.value[d]=f,!0}})}else return this._createInstance(c,h,w)}}e.InstantiationService=s;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class a{constructor(c,h){this.type=c,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return D?new a(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):a._None}static traceCreation(c){return D?new a(0,c.name):a._None}branch(c,h){let S=new a(2,c.toString());return this._dep.push([c,h,S]),S}stop(){let c=Date.now()-this._start;a._totals+=c;let h=!1;function S(_,u){let d=[],f=new Array(_+1).join("	");for(const[t,n,i]of u._dep)if(n&&i){h=!0,d.push(`${f}CREATES -> ${t}`);let r=S(_+1,i);r&&d.push(r)}else d.push(`${f}uses -> ${t}`);return d.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${a._totals.toFixed(2)}ms)`];(c>2||h)&&console.log(w.join(`
`))}}a._None=new class extends a{constructor(){super(-1,null)}stop(){}branch(){return this}},a._totals=0}),define(pe[15],ve([0,1,4,6,11,3,55]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function C(){return new Date().toISOString()}var D;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class s extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(D.Error,this.format(i))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let i=0;i<t.length;i++){let r=t[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch(o){}n+=(i>0?" ":"")+r}return n}}e.AbstractMessageLogger=s;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class a extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=a;class g extends P{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class c extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const i of this.logServices)i.trace(t,...n)}debug(t,...n){for(const i of this.logServices)i.debug(t,...n)}info(t,...n){for(const i of this.logServices)i.info(t,...n)}warn(t,...n){for(const i of this.logServices)i.warn(t,...n)}error(t,...n){for(const i of this.logServices)i.error(t,...n)}critical(t,...n){for(const i of this.logServices)i.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class h extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=h;class S extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(i))}))}createLogger(t,n){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),i),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function _(f){if(f.verbose)return D.Trace;if(typeof f.logLevel=="string"){const t=u(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function u(f){switch(f){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function d(f){switch(f){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=d}),define(pe[112],ve([0,1,15,42]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(D,P,s,I){try{const a=await new Promise((g,c)=>{Q(["spdlog"],g,c)});return a.setFlushOn(v.LogLevel.Info),a.createAsyncRotatingLogger(D,P,s,I)}catch(a){console.error(a)}return null}function y(D,P,s,I){const a=Q.__$__nodeRequire("spdlog");return a.setFlushOn(v.LogLevel.Info),a.createRotatingLogger(D,P,s,I)}e.createRotatingLogger=y;function A(D,P,s){switch(P){case v.LogLevel.Trace:D.trace(s);break;case v.LogLevel.Debug:D.debug(s);break;case v.LogLevel.Info:D.info(s);break;case v.LogLevel.Warning:D.warn(s);break;case v.LogLevel.Error:D.error(s);break;case v.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class C extends v.AbstractMessageLogger{constructor(P,s,I,a){super();this.name=P,this.filepath=s,this.rotating=I,this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const P=this.rotating?6:1,s=30/P*R.ByteSize.MB;return k(this.name,this.filepath,s,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:a,message:g}of this.buffer)A(this._logger,a,g);this.buffer=[]}})}log(P,s){this._logger?A(this._logger,P,s):this.getLevel()<=P&&this.buffer.push({level:P,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(pe[113],ve([0,1,4,156,52]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var y;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(y=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(c,h){return h-c}D.compare=P;const s=Object.create(null);s[D.Error]=R.localize(0,null),s[D.Warning]=R.localize(1,null),s[D.Info]=R.localize(2,null);function I(c){return s[c]||""}D.toString=I;function a(c){switch(c){case k.default.Error:return D.Error;case k.default.Warning:return D.Warning;case k.default.Info:return D.Info;case k.default.Ignore:return D.Hint}}D.fromSeverity=a;function g(c){switch(c){case D.Error:return k.default.Error;case D.Warning:return k.default.Warning;case D.Info:return k.default.Info;case D.Hint:return k.default.Ignore}}D.toSeverity=g}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const P="";function s(a){return I(a,!0)}D.makeKey=s;function I(a,g){let c=[P];return a.source?c.push(a.source.replace("\xA6","\\\xA6")):c.push(P),a.code?typeof a.code=="string"?c.push(a.code.replace("\xA6","\\\xA6")):c.push(a.code.value.replace("\xA6","\\\xA6")):c.push(P),a.severity!==void 0&&a.severity!==null?c.push(A.toString(a.severity)):c.push(P),a.message&&g?c.push(a.message.replace("\xA6","\\\xA6")):c.push(P),a.startLineNumber!==void 0&&a.startLineNumber!==null?c.push(a.startLineNumber.toString()):c.push(P),a.startColumn!==void 0&&a.startColumn!==null?c.push(a.startColumn.toString()):c.push(P),a.endLineNumber!==void 0&&a.endLineNumber!==null?c.push(a.endLineNumber.toString()):c.push(P),a.endColumn!==void 0&&a.endColumn!==null?c.push(a.endColumn.toString()):c.push(P),c.push(P),c.join("\xA6")}D.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=v.createDecorator("markerService")}),define(pe[180],ve([0,1,52,4,3]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=R.createDecorator("notificationService");var y;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(y=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(pe[181],ve([0,1,6,8,2,4]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=y.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function A(C,D){return k.URI.isUri(C)?R.equalsIgnoreCase(C.scheme,D):R.startsWithIgnoreCase(C,D+":")}e.matchesScheme=A}),define(pe[182],ve([0,1,10,11,37,24]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const C=R.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(Q==null?void 0:Q.__$__nodeRequire)=="function"){const C=y.dirname(v.FileAccess.asFileUri("",Q));A=Q.__$__nodeRequire(y.joinPath(C,"product.json").fsPath);const D=Q.__$__nodeRequire(y.joinPath(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:D.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=A});var He=this&&this.__param||function(Q,e){return function(v,R){e(v,R,Q)}};define(pe[114],ve([0,1,4,21,6,14]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=v.createDecorator("progressService");var A;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends k.Disposable{constructor(I,a){super();this.deferred=new y.DeferredPromise,a.withProgress(I,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const a=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{a===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>g.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:a,token:g.token,stop:()=>this.doStop(a),isCurrent:()=>this.currentOperationId===a}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=v.createDecorator("editorProgressService")}),define(pe[56],ve([0,1,13,49]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,C){R.ok(v.isString(A)),R.ok(v.isObject(C)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(pe[183],ve([0,1,56,3]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[k(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new y;v.Registry.add(e.Extensions.JSONContribution,A)}),define(pe[81],ve([0,1,151,3,56,13,183]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=k.Registry.as(A.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,_=!0){this.registerConfigurations([w],_)}registerConfigurations(w,_=!0){const u=[];w.forEach(d=>{u.push(...this.validateAndRegisterProperties(d,_,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const _=[],u=d=>{if(d.properties)for(const f in d.properties)_.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,d.properties[f]);d.allOf&&d.allOf.forEach(f=>u(f))};for(const d of w){u(d);const f=this.configurationContributors.indexOf(d);f!==-1&&this.configurationContributors.splice(f,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(w){const _=[],u=[];for(const d of w)for(const f in d)if(_.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),d[f]);const t={type:"object",default:this.defaultValues[f],description:v.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=d[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(w){const _=[];for(const u of w)for(const d in u)if(_.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const f=this.configurationProperties[d];f&&(this.updatePropertyDefaultValue(d,f),this.updateSchema(d,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const _ of w)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,_=!0,u,d=3){var f;d=y.isUndefinedOrNull(w.scope)?d:w.scope;let t=[],n=w.properties;if(n)for(let r in n){if(_&&c(r)){delete n[r];continue}const o=n[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:(o.scope=y.isUndefinedOrNull(o.scope)?d:o.scope,o.restricted=y.isUndefinedOrNull(o.restricted)?!!((f=u==null?void 0:u.restrictedConfigurations)===null||f===void 0?void 0:f.includes(r)):o.restricted),n[r].hasOwnProperty("included")&&!n[r].included){this.excludedConfigurationProperties[r]=n[r],delete n[r];continue}else this.configurationProperties[r]=n[r];!n[r].deprecationMessage&&n[r].markdownDeprecationMessage&&(n[r].deprecationMessage=n[r].markdownDeprecationMessage),t.push(r)}let i=w.allOf;if(i)for(let r of i)t.push(...this.validateAndRegisterProperties(r,_,u,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const _=u=>{let d=u.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let f=u.allOf;f&&f.forEach(_)};_(w)}updateSchema(w,_){switch(e.allSettings.properties[w]=_,_.scope){case 1:e.applicationSettings.properties[w]=_;break;case 2:e.machineSettings.properties[w]=_;break;case 6:e.machineOverridableSettings.properties[w]=_;break;case 3:e.windowSettings.properties[w]=_;break;case 4:e.resourceSettings.properties[w]=_;break;case 5:e.resourceSettings.properties[w]=_,this.resourceLanguageSettingsSchema.properties[w]=_;break}}removeFromSchema(w,_){switch(delete e.allSettings.properties[w],_.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const _=`[${w}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,u),e.allSettings.properties[_]=u,e.applicationSettings.properties[_]=u,e.machineSettings.properties[_]=u,e.machineOverridableSettings.properties[_]=u,e.windowSettings.properties[_]=u,e.resourceSettings.properties[_]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,_){let u=this.defaultValues[w];y.isUndefined(u)&&(u=_.default),y.isUndefined(u)&&(u=a(_.type)),_.default=u}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function I(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=I;function a(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const g=new P;k.Registry.add(e.Extensions.Configuration,g);function c(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?v.localize(5,null,S):g.getConfigurationProperties()[S]!==void 0?v.localize(6,null,S):null:v.localize(4,null)}e.validateProperty=c;function h(){const S=[],w=g.getConfigurationProperties();for(const _ of Object.keys(w))S.push([_,w[_].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=h}),define(pe[82],ve([0,1,25,13,2,56,4,81]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof k.URI)}e.isConfigurationOverrides=D;var P;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function I(n,i){const r=i?n?i.keys.filter(L=>n.keys.indexOf(L)===-1):[...i.keys]:[],o=n?i?n.keys.filter(L=>i.keys.indexOf(L)===-1):[...n.keys]:[],m=[];if(i&&n){for(const L of n.keys)if(i.keys.indexOf(L)!==-1){const O=w(n.contents,L),W=w(i.contents,L);v.equals(O,W)||m.push(L)}}const p=[],E=L=>{const O={};for(const W of L)for(const Z of W.identifiers)O[f(Z)]=W;return O},b=i?E(i.overrides):{},l=n?E(n.overrides):{};if(Object.keys(b).length)for(const L of r){const O=b[L];O&&p.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(l).length)for(const L of o){const O=l[L];O&&p.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(b).length&&Object.keys(l).length)for(const L of m){const O=l[L],W=b[L];if(O&&W){const Z=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});p.push([C.overrideIdentifierFromKey(L),[...Z.added,...Z.removed,...Z.updated]])}}return{added:r,removed:o,updated:m,overrides:p}}e.compare=I;function a(n,i){const r=[];for(const o of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(o)){const m={};for(const p in n[o])m[p]=n[o][p];r.push({identifiers:[C.overrideIdentifierFromKey(o).trim()],keys:Object.keys(m),contents:g(m,i)})}return r}e.toOverrides=a;function g(n,i){const r=Object.create(null);for(let o in n)c(r,o,n[o],i);return r}e.toValuesTree=g;function c(n,i,r,o){const m=i.split("."),p=m.pop();let E=n;for(let b=0;b<m.length;b++){let l=m[b],L=E[l];switch(typeof L){case"undefined":L=E[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${m.slice(0,b+1).join(".")} is ${JSON.stringify(L)}`);return}E=L}if(typeof E=="object"&&E!==null)try{E[p]=r}catch(b){o(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(E)}`)}else o(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=c;function h(n,i){const r=i.split(".");S(n,r)}e.removeFromValueTree=h;function S(n,i){const r=i.shift();if(i.length===0){delete n[r];return}if(Object.keys(n).indexOf(r)!==-1){const o=n[r];typeof o=="object"&&!Array.isArray(o)&&(S(o,i),Object.keys(o).length===0&&delete n[r])}}function w(n,i,r){function o(E,b){let l=E;for(const L of b){if(typeof l!="object"||l===null)return;l=l[L]}return l}const m=i.split("."),p=o(n,m);return typeof p=="undefined"?r:p}e.getConfigurationValue=w;function _(n,i,r){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in n?R.isObject(n[o])&&R.isObject(i[o])?_(n[o],i[o],r):r&&(n[o]=i[o]):n[o]=i[o])})}e.merge=_;function u(){const n=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=u;function d(){const n=Object.create(null),i=y.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let r in i){let o=i[r].default;c(n,r,o,m=>console.error(`Conflict in default settings: ${m}`))}return n}e.getDefaultValues=d;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,i,r){const o=n.inspect(i),m=n.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:o.defaultValue}e.getMigratedSettingValue=t}),define(pe[184],ve([0,1,51,23,17,13,25,2,81,82,56,6,3]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],i=[]){this._contents=t,this._keys=n,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?P.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,n){const i=this.getContentsForOverrideIdentifer(n);return i?t?P.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let i={};for(const r of k.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r],m=n[r];m&&(typeof o=="object"&&typeof m=="object"?(o=A.deepClone(o),this.mergeContents(o,m)):o=m),i[r]=o}return new g(i,this.keys,this.overrides)}merge(...t){const n=A.deepClone(this.contents),i=A.deepClone(this.overrides),r=[...this.keys];for(const o of t){this.mergeContents(n,o.contents);for(const m of o.overrides){const[p]=i.filter(E=>k.equals(E.identifiers,m.identifiers));p?this.mergeContents(p.contents,m.contents):i.push(A.deepClone(m))}for(const m of o.keys)r.indexOf(m)===-1&&r.push(m)}return new g(n,r,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const i of Object.keys(n)){if(i in t&&y.isObject(t[i])&&y.isObject(n[i])){this.mergeContents(t[i],n[i]);continue}t[i]=A.deepClone(n[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),P.addToValueTree(this.contents,t,n,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&P.removeFromValueTree(this.contents,t)}addKey(t){let n=this.keys.length;for(let i=0;i<n;i++)t.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class c extends g{constructor(){const t=P.getDefaultValues(),n=P.getConfigurationKeys(),i=[];for(const r of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(r)&&i.push({identifiers:[D.overrideIdentifierFromKey(r).trim()],keys:Object.keys(t[r]),contents:P.toValuesTree(t[r],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,n,i)}}e.DefaultConfigurationModel=c;class h{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!y.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:i,keys:r,overrides:o,restricted:m}=this.doParseRaw(t,n);this._configurationModel=new g(i,r,o),this._restrictedConfigurations=m||[]}doParseContent(t){let n={},i=null,r=[],o=[],m=[];function p(b){Array.isArray(r)?r.push(b):i&&(r[i]=b)}let E={onObjectBegin:()=>{let b={};p(b),o.push(r),r=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let b=[];p(b),o.push(r),r=b,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:p,onError:(b,l,L)=>{m.push({error:b,offset:l,length:L})}};if(t)try{v.visit(t,E),n=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return n}doParseRaw(t,n){const i=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,i,!0,n);t=r.raw;const o=P.toValuesTree(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),m=Object.keys(t),p=P.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:m,overrides:p,restricted:r.restricted}}filter(t,n,i,r){if(!(r==null?void 0:r.scopes)&&!(r==null?void 0:r.skipRestricted))return{raw:t,restricted:[]};const o={},m=[];for(let p in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(p)&&i){const E=this.filter(t[p],n,!1,r);o[p]=E.raw,m.push(...E.restricted)}else{const E=n[p],b=E?typeof E.scope!="undefined"?E.scope:3:void 0;(E==null?void 0:E.restricted)&&m.push(p),(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.skipRestricted&&(E==null?void 0:E.restricted)||(o[p]=t[p]))}return{raw:o,restricted:m}}}e.ConfigurationModelParser=h;class S extends I.Disposable{constructor(t,n,i,r){super();this.userSettingsResource=t,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new a.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(a.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,n,i=new g,r=new g,o=new R.ResourceMap,m=new g,p=new R.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=i,this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=m,this._memoryConfigurationByResource=p,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,i){return this.getConsolidateConfigurationModel(n,i).getValue(t)}updateValue(t,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new g,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(t):r.setValue(t,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,i){const r=this.getConsolidateConfigurationModel(n,i),o=this.getFolderConfigurationModelForResource(n.resource,i),m=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),l=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,W=n.overrideIdentifier?m.override(n.overrideIdentifier).getValue(t):m.getValue(t),Z=r.getValue(t),oe=k.distinct(k.flatten(r.overrides.map(V=>V.identifiers))).filter(V=>r.getOverrideValue(t,V)!==void 0);return{defaultValue:p,userValue:E,userLocalValue:b,userRemoteValue:l,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:Z,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:l!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:n.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:m.getValue(t),override:n.overrideIdentifier?m.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const i=n.filter(r=>D.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const o=D.overrideIdentifierFromKey(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(o),p=t.getKeysForOverrideIdentifier(o),E=[...p.filter(b=>m.indexOf(b)===-1),...m.filter(b=>p.indexOf(b)===-1),...m.filter(b=>!A.equals(this._defaultConfiguration.override(o).getValue(b),t.override(o).getValue(b)))];return[o,E]});return this.updateDefaultConfiguration(t),{keys:n,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=P.compare(this.localUserConfiguration,t),m=[...n,...i,...r];return m.length&&this.updateLocalUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=P.compare(this.remoteUserConfiguration,t);let m=[...n,...i,...r];return m.length&&this.updateRemoteUserConfiguration(t),{keys:m,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:i,removed:r,overrides:o}=P.compare(this.workspaceConfiguration,t);let m=[...n,...i,...r];return m.length&&this.updateWorkspaceConfiguration(t),{keys:m,overrides:o}}compareAndUpdateFolderConfiguration(t,n){const i=this.folderConfigurations.get(t),{added:r,updated:o,removed:m,overrides:p}=P.compare(i,n);let E=[...r,...o,...m];return(E.length||!i)&&this.updateFolderConfiguration(t,n),{keys:E,overrides:p}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:r,removed:o,overrides:m}=P.compare(n,void 0);return{keys:[...i,...r,...o],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let i=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const r=n.getFolder(t);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const o=this._memoryConfigurationByResource.get(t);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=i}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const i=n.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:i,overrides:r,keys:o}=this._folderConfigurations.get(n);return t.push([n,{contents:i,overrides:r,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((m,p)=>(m.set(C.URI.revive(p[0]),this.parseConfigurationModel(p[1])),m),new R.ResourceMap);return new w(n,i,new g,r,o,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function _(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const r of f)r.keys.forEach(o=>t.add(o)),r.overrides.forEach(([o,m])=>{const p=R.getOrSet(n,o,new Set);m.forEach(E=>p.add(E))});const i=[];return n.forEach((r,o)=>i.push([o,[...r.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=_;class u{constructor(t,n,i,r){this.change=t,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(p=>o.add(p)),t.overrides.forEach(([,p])=>p.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const m=new g;this.affectedKeys.forEach(p=>m.setValue(p,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var i;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(i=this.previous)===null||i===void 0?void 0:i.workspace):void 0,o=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!A.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let i=P.toValuesTree({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(t=t[r],!t)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=u;class d extends u{constructor(t,n,i,r){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=d}),define(pe[185],ve([0,1,38,9,109,154,28,11,178,82,4,10,134]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const g=y.localize(0,null);class c{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let h=class zt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,k.getWindowsShell(),t)}spawnTerminal(t,n,i,r){const o=n.terminal.external,m=(o==null?void 0:o.windowsExec)||zt.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const p=R.basename(m).toLowerCase();if(p==="cmder"||p==="cmder.exe")return t.spawn(m,r?[r]:void 0),Promise.resolve(void 0);const E=["/c","start","/wait"];return m.indexOf(" ")>=0&&E.push('""'),E.push(m),(p==="wt"||p==="wt.exe")&&E.push("-d ."),new Promise((b,l)=>{const L=_(process),O=t.spawn(i,E,{cwd:r,env:L});O.on("error",l),O.on("exit",()=>b())})}runInTerminal(t,n,i,r,o){const m="windowsExec"in o&&o.windowsExec?o.windowsExec:zt.getDefaultTerminalWindows();return new Promise((p,E)=>{const b=`"${n} - ${g}"`,l=`""${i.join('" "')}" & pause"`,L=["/c","start",b,"/wait",m,"/c",l],O=Object.assign({},_(process),r);Object.keys(O).filter(oe=>O[oe]===null).forEach(oe=>delete O[oe]);const W={cwd:n,env:O,windowsVerbatimArguments:!0};v.spawn(zt.CMD,L,W).on("error",oe=>{E(u(oe))}),p(void 0)})}static getDefaultTerminalWindows(){if(!zt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");zt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return zt._DEFAULT_TERMINAL_WINDOWS}};h.CMD="cmd.exe",h=Ve([He(0,s.optional(P.IConfigurationService))],h),e.WindowsExternalTerminalService=h;let S=class Nn extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,i,r,o){const m=o.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((p,E)=>{if(m===D.DEFAULT_TERMINAL_OSX||m==="iTerm.app"){const b=m===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[I.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${b}.scpt`,Q).fsPath,"-t",t||g,"-w",n];for(let Z of i)L.push("-a"),L.push(Z);if(r)for(let Z in r){const oe=r[Z];oe===null?(L.push("-u"),L.push(Z)):(L.push("-e"),L.push(`${Z}=${oe}`))}let O="";const W=v.spawn(Nn.OSASCRIPT,L);W.on("error",Z=>{E(u(Z))}),W.stderr.on("data",Z=>{O+=Z.toString()}),W.on("exit",Z=>{if(Z===0)p(void 0);else if(O){const oe=O.split(`
`,1);E(new Error(oe[0]))}else E(new Error(y.localize(1,null,b,Z)))})}else E(new Error(y.localize(2,null,m)))})}spawnTerminal(t,n,i){const r=n.terminal.external,o=(r==null?void 0:r.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((m,p)=>{const E=["-a",o];i&&E.push(i);const b=t.spawn("/usr/bin/open",E);b.on("error",p),b.on("exit",()=>m())})}};S.OSASCRIPT="/usr/bin/osascript",S=Ve([He(0,s.optional(P.IConfigurationService))],S),e.MacExternalTerminalService=S;let w=class Vt extends c{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(v,n,t)}runInTerminal(t,n,i,r,o){const m=o.linuxExec?Promise.resolve(o.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((p,E)=>{let b=[];m.then(l=>{l.indexOf("gnome-terminal")>=0?b.push("-x"):b.push("-e"),b.push("bash"),b.push("-c");const L=`${d(i)}; echo; read -p "${Vt.WAIT_MESSAGE}" -n1;`;b.push(`''${L}''`);const O=Object.assign({},process.env,r);Object.keys(O).filter(V=>O[V]===null).forEach(V=>delete O[V]);const W={cwd:n,env:O};let Z="";const oe=v.spawn(l,b,W);oe.on("error",V=>{E(u(V))}),oe.stderr.on("data",V=>{Z+=V.toString()}),oe.on("exit",V=>{if(V===0)p(void 0);else if(Z){const $=Z.split(`
`,1);E(new Error($[0]))}else E(new Error(y.localize(4,null,l,V)))})})})}static async getDefaultTerminalLinuxReady(){return Vt._DEFAULT_TERMINAL_LINUX_READY||(Vt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{C.isLinux?await A.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Vt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,i){const r=n.terminal.external,o=(r==null?void 0:r.linuxExec)?Promise.resolve(r.linuxExec):Vt.getDefaultTerminalLinuxReady();return new Promise((m,p)=>{o.then(E=>{const b=_(process),l=t.spawn(E,[],{cwd:i,env:b});l.on("error",p),l.on("exit",()=>m())})})}};w.WAIT_MESSAGE=y.localize(3,null),w=Ve([He(0,s.optional(P.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function _(f){const t=f.env;return a.sanitizeProcessEnvironment(t),t}function u(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(y.localize(5,null,f.path)):f}function d(f){let t="";for(let n of f)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(pe[115],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var R;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,C=R.Unknown,D){super(A);this._message=A,this._code=C,this._detail=D,this.isHandled=C===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(pe[116],ve([0,1,10]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(P){return P.scheme===v.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=R;function k(P){if(!P)return;const s=P.indexOf("+");return s<0?P:P.substr(0,s)}e.getRemoteName=k;function y(P){return P.scheme!==v.Schemas.file&&P.scheme!==v.Schemas.vscodeRemote}function A(P){if(P.folders.length)return P.folders.every(s=>y(s.uri))?P.folders[0].uri:void 0;if(P.configuration&&y(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function C(P){var s;return(s=A(P))===null||s===void 0?void 0:s.scheme}e.getVirtualWorkspaceScheme=C;function D(P){return A(P)!==void 0}e.isVirtualWorkspace=D}),define(pe[186],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,y)=>Q(["vsda"],k,y))}async sign(k){try{const y=await this.vsda(),A=new y.signer;if(A)return A.sign(k)}catch(y){}return k}}e.SignService=v}),define(pe[187],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,y,A=5){let C;return C=y(D=>{const P=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(k);if(s){s.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(k),A);s={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),C.dispose()}},this._terminalBufferMap.set(k,s)}),C}stopBuffering(k){const y=this._terminalBufferMap.get(k);y&&y.dispose()}flushBuffer(k){const y=this._terminalBufferMap.get(k);y&&(this._terminalBufferMap.delete(k),this._callback(k,y.data.join("")))}}e.TerminalDataBufferer=v}),define(pe[57],ve([0,1,2,24,4,23]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function C(a){const g=a;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=C;function D(a){const g=a;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(g,c,h,S){this._id=g,this._configuration=h,this._ignorePathCasing=S,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class s{constructor(g,c){this.raw=c,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return R.joinPath(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function I(a){return new s({uri:a,index:0,name:R.basenameOrAuthority(a)},{uri:a.toString()})}e.toWorkspaceFolder=I}),define(pe[188],ve([0,1,4,157,57,2,11,9,24,132,51,10,76,29,116]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S($){return(typeof $=="string"?C.extname($):D.extname($))===h}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=v.createDecorator("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function u($){return $.hasOwnProperty("fileUri")}e.isRecentFile=u;function d($){const j=$;return typeof(j==null?void 0:j.id)=="string"&&y.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=d;function f($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=f;function t($){const j=$;return typeof(j==null?void 0:j.id)=="string"&&y.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function n($){const j=$;if(j==null?void 0:j.uri)return{id:j.id,uri:y.URI.revive(j.uri)};const T=$;if(T==null?void 0:T.configPath)return{id:T.id,configPath:y.URI.revive(T.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function i($,j){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,j.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function r($){return o($)||m($)}e.isStoredWorkspaceFolder=r;function o($){const j=$;return typeof(j==null?void 0:j.path)=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=o;function m($){const j=$;return typeof(j==null?void 0:j.uri)=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=m;function p($,j,T,N,F=!A.isWindows,M){if($.scheme!==N.scheme)return{name:T,uri:$.toString(!0)};let U=j?void 0:M.relativePath(N,$);if(U!==void 0)U.length===0?U=".":A.isWindows&&$.scheme===I.Schemas.file&&!F&&(U=U.replace(/\//g,"\\"));else if($.scheme===I.Schemas.file)U=$.fsPath,A.isWindows&&(U=a.normalizeDriveLetter(U),F&&(U=g.toSlashes(U)));else{if(!M.isEqualAuthority($.authority,N.authority))return{name:T,uri:$.toString(!0)};U=$.path}return{name:T,path:U}}e.getStoredWorkspaceFolder=p;function E($,j,T){let N=[],F=new Set;const M=T.dirname(j);for(let U of $){let x;if(o(U))U.path&&(x=T.resolvePath(M,U.path));else if(m(U))try{x=y.URI.parse(U.uri),x.path[0]!=="/"&&(x=x.with({path:"/"+x.path}))}catch(K){console.warn(K)}if(x){let K=T.getComparisonKey(x);if(!F.has(K)){F.add(K);const se=U.name||T.basenameOrAuthority(x);N.push(new k.WorkspaceFolder({uri:x,name:se,index:N.length},U))}}}return N}e.toWorkspaceFolders=E;function b($,j,T,N,F){let M=l(j,$);const U=F.dirname(j),x=F.dirname(N),K=[],se=L(M.folders);for(const Fe of M.folders){const qe=o(Fe)?F.resolvePath(U,Fe.path):y.URI.parse(Fe.uri);let ze;T?ze=!1:ze=!o(Fe)||C.isAbsolute(Fe.path),K.push(p(qe,ze,Fe.name,x,se,F))}const be={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Te=P.setProperty($,["folders"],K,be);let Ce=P.applyEdits($,Te);return M.remoteAuthority===c.getRemoteAuthority(N)&&(Ce=P.applyEdits(Ce,P.removeProperty(Ce,["remoteAuthority"],be))),Ce}e.rewriteWorkspaceFileForNewLocation=b;function l($,j){let T=s.parse(j);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>r(N));else throw new Error(`${$} looks like an invalid workspace file.`);return T}function L($){return A.isWindows?$.some(j=>o(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function W($){return typeof $.folderUri=="string"}function Z($){return typeof $.fileUri=="string"}function oe($,j){const T={workspaces:[],files:[]};if($){const N=function(M,U){for(let x=0;x<M.length;x++)try{U(M[x],x)}catch(K){j.warn(`Error restoring recent entry ${JSON.stringify(M[x])}: ${K.toString()}. Skip entry.`)}},F=$;if(Array.isArray(F.entries))N(F.entries,M=>{const U=M.label,x=M.remoteAuthority;O(M)?T.workspaces.push({label:U,remoteAuthority:x,workspace:{id:M.workspace.id,configPath:y.URI.parse(M.workspace.configPath)}}):W(M)?T.workspaces.push({label:U,remoteAuthority:x,folderUri:y.URI.parse(M.folderUri)}):Z(M)&&T.files.push({label:U,remoteAuthority:x,fileUri:y.URI.parse(M.fileUri)})});else{const M=$;Array.isArray(M.workspaces3)&&N(M.workspaces3,(U,x)=>{const K=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[x]||void 0;typeof U=="object"&&typeof U.id=="string"&&typeof U.configURIPath=="string"?T.workspaces.push({label:K,workspace:{id:U.id,configPath:y.URI.parse(U.configURIPath)}}):typeof U=="string"&&T.workspaces.push({label:K,folderUri:y.URI.parse(U)})}),Array.isArray(M.files2)&&N(M.files2,(U,x)=>{const K=Array.isArray(M.fileLabels)&&M.fileLabels[x]||void 0;typeof U=="string"&&T.files.push({label:K,fileUri:y.URI.parse(U)})})}}return T}e.restoreRecentlyOpened=oe;function V($){const j={entries:[]};for(const T of $.workspaces)_(T)?j.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):j.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of $.files)j.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return j}e.toStoreData=V}),define(pe[83],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const y=this._idPool++;return this._data.set(y,k),this.logDebugInfo(),y}get(k,y){return this._data.has(k)?this._data.get(k)[y]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(pe[45],ve([0,1,2,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class y{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(D=>({name:D.name,group:D.group,resource:v.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=y}),define(pe[58],ve([0,1,10,4]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A):this._providerInfo.set(A,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(pe[27],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=v.createDecorator("IExtHostInitDataService")}),define(pe[189],ve([0,1,14]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,C,D){this._deferredPromises=new Map,this._id=A,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of P.values())s.complete()}catch(s){for(const I of P.values())I.error(s)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(A,C){let D=this._value[A];return typeof D=="undefined"&&(D=C),D}update(A,C){this._value[A]=C;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const P=new v.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(A,C){super(A.identifier.value,!0,C);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(pe[12],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=v.createDecorator("IExtHostRpcService");class R{constructor(y){this.getProxy=y.getProxy.bind(y),this.set=y.set.bind(y),this.assertRegistered=y.assertRegistered.bind(y),this.drain=y.drain.bind(y)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[190],ve([0,1,26,3]),function(Q,e,v,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class y{constructor(C,D){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(C.identifier),nt(this,k,D,"f"),Be(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return Be(this,k,"f").get(this._id,C)}store(C,D){return Be(this,k,"f").store(this._id,C,D)}delete(C){return Be(this,k,"f").delete(this._id,C)}}e.ExtensionSecrets=y,k=new WeakMap}),define(pe[117],ve([0,1,4,3]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=v.createDecorator("IExtHostTelemetry")}),define(pe[84],ve([0,1,3]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,y=A=>{let C=k.get(A);return C||(C={children:new Map,bus:new v.Emitter},k.set(A,C)),C};e.getPrivateApiFor=y}),define(pe[46],ve([0,1,4,3,12]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var y;(function(C){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}C.fromApiTunnel=D;function P(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}C.fromServiceTunnel=P})(y=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=v.createDecorator("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,s,I,a){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([He(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var v={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(v[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(Q);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[k])&&(v[R[k]]=Q[R[k]]);return v};define(pe[7],ve([0,1,17,16,95,23,136,13,2,32,42,115,84]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";var g,c,h,S,w,_,u,d,f,t,n,i,r,o,m,p,E,b;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function l(z){function B(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(B,z),Object.setPrototypeOf(B.prototype,z.prototype),B}let L=w=class{constructor(B){g.set(this,void 0),nt(this,g,B,"f")}static from(...B){let ne=B;return new w(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}dispose(){typeof Be(this,g,"f")=="function"&&(Be(this,g,"f").call(this),nt(this,g,void 0,"f"))}};g=new WeakMap,L=w=Ve([l],L),e.Disposable=L;let O=_=class{constructor(B,ne){if(B<0)throw R.illegalArgument("line must be non-negative");if(ne<0)throw R.illegalArgument("character must be non-negative");this._line=B,this._character=ne}static Min(...B){if(B.length===0)throw new TypeError;let ne=B[0];for(let Se=1;Se<B.length;Se++){const Ke=B[Se];Ke.isBefore(ne)&&(ne=Ke)}return ne}static Max(...B){if(B.length===0)throw new TypeError;let ne=B[0];for(let Se=1;Se<B.length;Se++){const Ke=B[Se];Ke.isAfter(ne)&&(ne=Ke)}return ne}static isPosition(B){if(!B)return!1;if(B instanceof _)return!0;let{line:ne,character:Se}=B;return typeof ne=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,ne=0){if(B===null||ne===null)throw R.illegalArgument();let Se;return typeof B=="undefined"?Se=0:typeof B=="number"?Se=B:(Se=typeof B.lineDelta=="number"?B.lineDelta:0,ne=typeof B.characterDelta=="number"?B.characterDelta:0),Se===0&&ne===0?this:new _(this.line+Se,this.character+ne)}with(B,ne=this.character){if(B===null||ne===null)throw R.illegalArgument();let Se;return typeof B=="undefined"?Se=this.line:typeof B=="number"?Se=B:(Se=typeof B.line=="number"?B.line:this.line,ne=typeof B.character=="number"?B.character:this.character),Se===this.line&&ne===this.character?this:new _(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};O=_=Ve([l],O),e.Position=O;let W=u=class{constructor(B,ne,Se,Ke){let Je,at;if(typeof B=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(Je=new O(B,ne),at=new O(Se,Ke)):B instanceof O&&ne instanceof O&&(Je=B,at=ne),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this._start=Je,this._end=at):(this._start=at,this._end=Je)}static isRange(B){return B instanceof u?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const ne=O.Max(B.start,this._start),Se=O.Min(B.end,this._end);if(!ne.isAfter(Se))return new u(ne,Se)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const ne=O.Min(B.start,this._start),Se=O.Max(B.end,this.end);return new u(ne,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,ne=this.end){if(B===null||ne===null)throw R.illegalArgument();let Se;return B?O.isPosition(B)?Se=B:(Se=B.start||this.start,ne=B.end||this.end):Se=this.start,Se.isEqual(this._start)&&ne.isEqual(this.end)?this:new u(Se,ne)}toJSON(){return[this.start,this.end]}};W=u=Ve([l],W),e.Range=W;let Z=d=class extends W{constructor(B,ne,Se,Ke){let Je,at;if(typeof B=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"?(Je=new O(B,ne),at=new O(Se,Ke)):B instanceof O&&ne instanceof O&&(Je=B,at=ne),!Je||!at)throw new Error("Invalid arguments");super(Je,at);this._anchor=Je,this._active=at}static isSelection(B){return B instanceof d?!0:B?W.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=d=Ve([l],Z),e.Selection=Z;class oe{constructor(B,ne,Se){if(typeof B!="string"||B.length===0)throw R.illegalArgument("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw R.illegalArgument("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw R.illegalArgument("connectionToken");this.host=B,this.port=Math.round(ne),this.connectionToken=Se}}e.ResolvedAuthority=oe;class V extends Error{constructor(B,ne=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(B);this._message=B,this._code=ne,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(B,ne){return new V(B,I.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(B){return new V(B,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var $;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var j;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=f=class{constructor(B,ne){this._range=B,this._newText=ne}static isTextEdit(B){return B instanceof f?!0:B?W.isRange(B)&&typeof B.newText=="string":!1}static replace(B,ne){return new f(B,ne)}static insert(B,ne){return f.replace(new W(B,B),ne)}static delete(B){return f.replace(B,"")}static setEndOfLine(B){const ne=new f(new W(new O(0,0),new O(0,0)),"");return ne.newEol=B,ne}get range(){return this._range}set range(B){if(B&&!W.isRange(B))throw R.illegalArgument("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw R.illegalArgument("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw R.illegalArgument("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=f=Ve([l],T),e.TextEdit=T;var N;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(N=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,ne,Se,Ke){this._edits.push({_type:1,from:B,to:ne,options:Se,metadata:Ke})}createFile(B,ne,Se){this._edits.push({_type:1,from:void 0,to:B,options:ne,metadata:Se})}deleteFile(B,ne,Se){this._edits.push({_type:1,from:B,to:void 0,options:ne,metadata:Se})}replaceNotebookMetadata(B,ne,Se){this._edits.push({_type:3,metadata:Se,uri:B,edit:{editType:5,metadata:ne},notebookMetadata:ne})}replaceNotebookCells(B,ne,Se,Ke,Je){let at,dt,yt=[],kt;if($t.isNotebookRange(ne)&&Me.isNotebookCellDataArray(Se)&&!Me.isNotebookCellDataArray(Ke)?(at=ne.start,dt=ne.end,yt=Se,kt=Ke):typeof ne=="number"&&typeof Se=="number"&&Me.isNotebookCellDataArray(Ke)&&(at=ne,dt=Se,yt=Ke,kt=Je),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||yt.length>0)&&this._edits.push({_type:5,uri:B,index:at,count:dt-at,cells:yt,metadata:kt})}replaceNotebookCellMetadata(B,ne,Se,Ke){this._edits.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:ne,metadata:Se}})}replace(B,ne,Se,Ke){this._edits.push({_type:2,uri:B,edit:new T(ne,Se),metadata:Ke})}insert(B,ne,Se,Ke){this.replace(B,new W(ne,ne),Se,Ke)}delete(B,ne,Se){this.replace(B,ne,"",Se)}has(B){return this._edits.some(ne=>ne._type===2&&ne.uri.toString()===B.toString())}set(B,ne){if(ne)for(const Se of ne)Se&&this._edits.push({_type:2,uri:B,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ke=this._edits[Se];Ke._type===2&&Ke.uri.toString()===B.toString()&&(this._edits[Se]=void 0)}v.coalesceInPlace(this._edits)}}get(B){const ne=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===B.toString()&&ne.push(Se.edit);return ne}entries(){const B=new y.ResourceMap;for(let ne of this._edits)if(ne._type===2){let Se=B.get(ne.uri);Se||(Se=[ne.uri,[]],B.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([l],F),e.WorkspaceEdit=F;let M=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,ne=this._tabstop++){if(typeof B=="function"){const Se=new t;Se._tabstop=this._tabstop,B(Se),this._tabstop=Se._tabstop,B=Se.value}else B=t._escape(B);return this.value+="${",this.value+=ne,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,ne=this._tabstop++){const Se=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(B,ne){if(typeof ne=="function"){const Se=new t;Se._tabstop=this._tabstop,ne(Se),this._tabstop=Se._tabstop,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};M=t=Ve([l],M),e.SnippetString=M;var U;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=n=class{constructor(B,ne){if(this.uri=B,ne)if(ne instanceof W)this.range=ne;else if(ne instanceof O)this.range=new W(ne,ne);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof n?!0:B?W.isRange(B.range)&&D.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=n=Ve([l],K),e.Location=K;let se=class{constructor(B,ne){this.location=B,this.message=ne}static is(B){return B?typeof B.message=="string"&&B.location&&W.isRange(B.location.range)&&D.URI.isUri(B.location.uri):!1}static isEqual(B,ne){return B===ne?!0:!B||!ne?!1:B.message===ne.message&&B.location.range.isEqual(ne.location.range)&&B.location.uri.toString()===ne.location.uri.toString()}};se=Ve([l],se),e.DiagnosticRelatedInformation=se;let be=class{constructor(B,ne,Se=x.Error){if(!W.isRange(B))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=B,this.message=ne,this.severity=Se}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,ne){return B===ne?!0:!B||!ne?!1:B.message===ne.message&&B.severity===ne.severity&&B.code===ne.code&&B.severity===ne.severity&&B.source===ne.source&&B.range.isEqual(ne.range)&&v.equals(B.tags,ne.tags)&&v.equals(B.relatedInformation,ne.relatedInformation,se.isEqual)}};be=Ve([l],be),e.Diagnostic=be;let Te=class{constructor(B,ne){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:k.isMarkdownString(B)?this.contents=[B]:this.contents=[B],this.range=ne}};Te=Ve([l],Te),e.Hover=Te;var Ce;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(Ce=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Fe=class{constructor(B,ne=Ce.Text){this.range=B,this.kind=ne}toJSON(){return{range:this.range,kind:Ce[this.kind]}}};Fe=Ve([l],Fe),e.DocumentHighlight=Fe;var qe;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(qe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let Ge=i=class{constructor(B,ne,Se,Ke,Je){this.name=B,this.kind=ne,this.containerName=Je,typeof Se=="string"&&(this.containerName=Se),Ke instanceof K?this.location=Ke:Se instanceof W&&(this.location=new K(Ke,Se)),i.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:qe[this.kind],location:this.location,containerName:this.containerName}}};Ge=i=Ve([l],Ge),e.SymbolInformation=Ge;let q=r=class{constructor(B,ne,Se,Ke,Je){this.name=B,this.detail=ne,this.kind=Se,this.range=Ke,this.selectionRange=Je,this.children=[],r.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(r.validate)}};q=r=Ve([l],q),e.DocumentSymbol=q;var J;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let re=class{constructor(B,ne){this.title=B,this.kind=ne}};re=Ve([l],re),e.CodeAction=re;let ae=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};ae.sep=".",ae=o=Ve([l],ae),e.CodeActionKind=ae,ae.Empty=new ae(""),ae.QuickFix=ae.Empty.append("quickfix"),ae.Refactor=ae.Empty.append("refactor"),ae.RefactorExtract=ae.Refactor.append("extract"),ae.RefactorInline=ae.Refactor.append("inline"),ae.RefactorRewrite=ae.Refactor.append("rewrite"),ae.Source=ae.Empty.append("source"),ae.SourceOrganizeImports=ae.Source.append("organizeImports"),ae.SourceFixAll=ae.Source.append("fixAll");let Y=class{constructor(B,ne){if(this.range=B,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([l],Y),e.SelectionRange=Y;class ce{constructor(B,ne,Se,Ke,Je,at){this.kind=B,this.name=ne,this.detail=Se,this.uri=Ke,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=ce;class ge{constructor(B,ne){this.fromRanges=ne,this.from=B}}e.CallHierarchyIncomingCall=ge;class Re{constructor(B,ne){this.fromRanges=ne,this.to=B}}e.CallHierarchyOutgoingCall=Re;let we=class{constructor(B,ne){this.range=B,this.command=ne}get isResolved(){return!!this.command}};we=Ve([l],we),e.CodeLens=we;let je=m=class{constructor(B,ne=!1){c.set(this,void 0),nt(this,c,new k.MarkdownString(B,{supportThemeIcons:ne}),"f")}static isMarkdownString(B){return B instanceof m?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return Be(this,c,"f").value}set value(B){Be(this,c,"f").value=B}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(B){Be(this,c,"f").isTrusted=B}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}appendText(B){return Be(this,c,"f").appendText(B),this}appendMarkdown(B){return Be(this,c,"f").appendMarkdown(B),this}appendCodeblock(B,ne){return Be(this,c,"f").appendCodeblock(ne??"",B),this}};c=new WeakMap,je=m=Ve([l],je),e.MarkdownString=je;let G=class{constructor(B,ne){this.label=B,this.documentation=ne}};G=Ve([l],G),e.ParameterInformation=G;let ie=class{constructor(B,ne){this.label=B,this.documentation=ne,this.parameters=[]}};ie=Ve([l],ie),e.SignatureInformation=ie;let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ee=Ve([l],Ee),e.SignatureHelp=Ee;var Ne;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let We=class{constructor(B,ne,Se){this.text=B,this.position=ne,this.kind=Se}};We=Ve([l],We),e.InlayHint=We;var Xe;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(z){z[z.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor(B,ne){this.label=B,this.kind=ne}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=Ve([l],ke),e.CompletionItem=ke;let le=class{constructor(B=[],ne=!1){this.items=B,this.isIncomplete=ne}};le=Ve([l],le),e.CompletionList=le;let he=class{constructor(B,ne,Se){this.text=B,this.range=ne,this.command=Se}};he=Ve([l],he),e.InlineSuggestion=he;let H=class{constructor(B){this.items=B}};H=Ve([l],H),e.InlineSuggestions=H;var ee;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var ue;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ie;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ie=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var xe;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function B(ne){switch(ne){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=B}(xe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(B,ne){if(ne&&!D.URI.isUri(ne))throw R.illegalArgument("target");if(!W.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.target=ne}};rt=Ve([l],rt),e.DocumentLink=rt;let tt=class{constructor(B,ne,Se,Ke){this.red=B,this.green=ne,this.blue=Se,this.alpha=Ke}};tt=Ve([l],tt),e.Color=tt;let Ye=class{constructor(B,ne){if(ne&&!(ne instanceof tt))throw R.illegalArgument("color");if(!W.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.color=ne}};Ye=Ve([l],Ye),e.ColorInformation=Ye;let ot=class{constructor(B){if(!B||typeof B!="string")throw R.illegalArgument("label");this.label=B}};ot=Ve([l],ot),e.ColorPresentation=ot;var Et;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Et=e.ColorFormat||(e.ColorFormat={}));var bt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var fe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(fe=e.TaskPanelKind||(e.TaskPanelKind={}));let de=p=class{constructor(B,ne){if(typeof B!="string"||typeof ne!="string")throw R.illegalArgument("name");this._id=B}static from(B){switch(B){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};de.Clean=new p("clean","Clean"),de.Build=new p("build","Build"),de.Rebuild=new p("rebuild","Rebuild"),de.Test=new p("test","Test"),de=p=Ve([l],de),e.TaskGroup=de;function X(z){let B="";for(let ne=0;ne<z.length;ne++)B+=z[ne].replace(/,/g,",,")+",";return B}let Oe=class{constructor(B,ne,Se){if(typeof B!="string")throw R.illegalArgument("process");this._args=[],this._process=B,ne!==void 0&&(Array.isArray(ne)?(this._args=ne,this._options=Se):this._options=ne)}get process(){return this._process}set process(B){if(typeof B!="string")throw R.illegalArgument("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let ne of this._args)B.push(ne);return X(B)}};Oe=Ve([l],Oe),e.ProcessExecution=Oe;let Le=class{constructor(B,ne,Se){if(this._args=[],Array.isArray(ne)){if(!B)throw R.illegalArgument("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B,this._args=ne,this._options=Se}else{if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B,this._options=ne}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ne of this._args)B.push(typeof ne=="string"?ne:ne.value);return X(B)}};Le=Ve([l],Le),e.ShellExecution=Le;var Ze;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(et=e.TaskScope||(e.TaskScope={}));class ft{constructor(B){this._callback=B}computeId(){return"customExecution"+P.generateUuid()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=ft;let ct=E=class{constructor(B,ne,Se,Ke,Je,at){this.__deprecated=!1,this._definition=this.definition=B;let dt;typeof ne=="string"?(this._name=this.name=ne,this._source=this.source=Se,this.execution=Ke,dt=Je,this.__deprecated=!0):ne===et.Global||ne===et.Workspace?(this.target=ne,this._name=this.name=Se,this._source=this.source=Ke,this.execution=Je,dt=at):(this.target=ne,this._name=this.name=Se,this._source=this.source=Ke,this.execution=Je,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Oe?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof Le?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:P.generateUuid()}}get definition(){return this._definition}set definition(B){if(B==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw R.illegalArgument("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const ne=this._definition.type;(E.EmptyType===ne||E.ProcessType===ne||E.ShellType===ne||E.ExtensionCallbackType===ne)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=E=Ve([l],ct),e.Task=ct;var it;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(B,ne=ht.None){this.collapsibleState=ne,D.URI.isUri(B)?this.resourceUri=B:this.label=B}};vt=Ve([l],vt),e.TreeItem=vt;var ht;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let lt=class{constructor(B,ne){this.id=B,this.color=ne}};lt=Ve([l],lt),e.ThemeIcon=lt,lt.File=new lt("file"),lt.Folder=new lt("folder");let mt=class{constructor(B){this.id=B}};mt=Ve([l],mt),e.ThemeColor=mt;var It;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(It=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(B,ne){if(typeof B!="string"&&(!B||!D.URI.isUri(B)&&!D.URI.isUri(B.uri)))throw R.illegalArgument("base");if(typeof ne!="string")throw R.illegalArgument("pattern");typeof B=="string"?(this.baseFolder=D.URI.file(B),this.base=B):D.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=ne}};Ct=Ve([l],Ct),e.RelativePattern=Ct;let At=class{constructor(B,ne,Se,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=P.generateUuid()),this._id}};At=Ve([l],At),e.Breakpoint=At;let Rt=class extends At{constructor(B,ne,Se,Ke,Je){super(ne,Se,Ke,Je);if(B===null)throw R.illegalArgument("location");this.location=B}};Rt=Ve([l],Rt),e.SourceBreakpoint=Rt;let St=class extends At{constructor(B,ne,Se,Ke,Je){super(ne,Se,Ke,Je);this.functionName=B}};St=Ve([l],St),e.FunctionBreakpoint=St;let Xt=class extends At{constructor(B,ne,Se,Ke,Je,at,dt){super(Ke,Je,at,dt);if(!ne)throw R.illegalArgument("dataId");this.label=B,this.dataId=ne,this.canPersist=Se}};Xt=Ve([l],Xt),e.DataBreakpoint=Xt;let Yt=class{constructor(B,ne,Se){this.command=B,this.args=ne||[],this.options=Se}};Yt=Ve([l],Yt),e.DebugAdapterExecutable=Yt;let pt=class{constructor(B,ne){this.port=B,this.host=ne}};pt=Ve([l],pt),e.DebugAdapterServer=pt;let Jt=class{constructor(B){this.path=B}};Jt=Ve([l],Jt),e.DebugAdapterNamedPipeServer=Jt;let Zt=class{constructor(B){this.implementation=B}};Zt=Ve([l],Zt),e.DebugAdapterInlineImplementation=Zt;let Dt=class{constructor(B,ne){this.range=B,this.expression=ne}};Dt=Ve([l],Dt),e.EvaluatableExpression=Dt;var hn;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(hn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let en=class{constructor(B,ne){this.range=B,this.text=ne}};en=Ve([l],en),e.InlineValueText=en;let xt=class{constructor(B,ne,Se=!0){this.range=B,this.variableName=ne,this.caseSensitiveLookup=Se}};xt=Ve([l],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor(B,ne){this.range=B,this.expression=ne}};ut=Ve([l],ut),e.InlineValueEvaluatableExpression=ut;let tn=class{constructor(B,ne){this.frameId=B,this.stoppedLocation=ne}};tn=Ve([l],tn),e.InlineValueContext=tn;var Ft;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=b=class extends Error{constructor(B,ne=s.FileSystemProviderErrorCode.Unknown,Se){var Ke;super(D.URI.isUri(B)?B.toString(!0):B);this.code=(Ke=Se==null?void 0:Se.name)!==null&&Ke!==void 0?Ke:"Unknown",s.markAsFileSystemProviderError(this,ne),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(B){return new b(B,s.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(B){return new b(B,s.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(B){return new b(B,s.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(B){return new b(B,s.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(B){return new b(B,s.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(B){return new b(B,s.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}};Mt=b=Ve([l],Mt),e.FileSystemError=Mt;let qt=class{constructor(B,ne,Se){this.start=B,this.end=ne,this.kind=Se}};qt=Ve([l],qt),e.FoldingRange=qt;var En;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(fn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class mn{constructor(B,ne=[]){this.tokenTypes=B,this.tokenModifiers=ne}}e.SemanticTokensLegend=mn;function Bt(z){return typeof z=="undefined"||C.isStringArray(z)}class nn{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let ne=0,Se=B.tokenTypes.length;ne<Se;ne++)this._tokenTypeStrToInt.set(B.tokenTypes[ne],ne);for(let ne=0,Se=B.tokenModifiers.length;ne<Se;ne++)this._tokenModifierStrToInt.set(B.tokenModifiers[ne],ne)}}push(B,ne,Se,Ke,Je){if(typeof B=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je=="undefined"))return typeof Je=="undefined"&&(Je=0),this._pushEncoded(B,ne,Se,Ke,Je);if(W.isRange(B)&&typeof ne=="string"&&Bt(Se))return this._push(B,ne,Se);throw R.illegalArgument()}_push(B,ne,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ne))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,Je=B.start.character,at=B.end.character-B.start.character,dt=this._tokenTypeStrToInt.get(ne);let yt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);yt|=1<<Tt>>>0}this._pushEncoded(Ke,Je,at,dt,yt)}_pushEncoded(B,ne,Se,Ke,Je){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&ne<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,Tt=0;for(let Lt=0;Lt<yt;Lt++){let Nt=this._data[5*Lt],un=this._data[5*Lt+1];Nt===0?(Nt=kt,un+=Tt):Nt+=kt,this._data[5*Lt]=Nt,this._data[5*Lt+1]=un,kt=Nt,Tt=un}}let at=B,dt=ne;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=Je,this._prevLine=B,this._prevChar=ne}static _sortAndDeltaEncode(B){let ne=[];const Se=B.length/5|0;for(let dt=0;dt<Se;dt++)ne[dt]=dt;ne.sort((dt,yt)=>{const kt=B[5*dt],Tt=B[5*yt];if(kt===Tt){const Lt=B[5*dt+1],Nt=B[5*yt+1];return Lt-Nt}return kt-Tt});const Ke=new Uint32Array(B.length);let Je=0,at=0;for(let dt=0;dt<Se;dt++){const yt=5*ne[dt],kt=B[yt+0],Tt=B[yt+1],Lt=B[yt+2],Nt=B[yt+3],un=B[yt+4],On=kt-Je,zn=On===0?Tt-at:Tt,dn=5*dt;Ke[dn+0]=On,Ke[dn+1]=zn,Ke[dn+2]=Lt,Ke[dn+3]=Nt,Ke[dn+4]=un,Je=kt,at=Tt}return Ke}build(B){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),B):new Ht(nn._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=nn;class Ht{constructor(B,ne){this.resultId=ne,this.data=B}}e.SemanticTokens=Ht;class rn{constructor(B,ne,Se){this.start=B,this.deleteCount=ne,this.data=Se}}e.SemanticTokensEdit=rn;class Sn{constructor(B,ne){this.resultId=ne,this.edits=B}}e.SemanticTokensEdits=Sn;var yn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new lt("arrow-left")},Gt=Ve([l],Gt),e.QuickInputButtons=Gt;var Dn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class Cn{constructor(B,ne,Se){this.badge=B,this.tooltip=ne,this.color=Se}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Cn;let sn=class{constructor(B){this.kind=B}};sn=Ve([l],sn),e.ColorTheme=sn;var on;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(on=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(B,ne){if(B<0)throw R.illegalArgument("start must be positive");if(ne<0)throw R.illegalArgument("end must be positive");B<=ne?(this._start=B,this._end=ne):(this._start=ne,this._end=B)}static isNotebookRange(B){return B instanceof $t?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let ne=this._start,Se=this._end;return B.start!==void 0&&(ne=B.start),B.end!==void 0&&(Se=B.end),ne===this._start&&Se===this._end?this:new $t(ne,Se)}}e.NotebookRange=$t;class Kt{constructor(B,ne){typeof B=="object"?Object.assign(this,B):(this.inputCollapsed=B,this.outputCollapsed=ne)}with(B){let{inputCollapsed:ne,outputCollapsed:Se}=B,Ke=Qt(B,["inputCollapsed","outputCollapsed"]);return ne===void 0?ne=this.inputCollapsed:ne===null&&(ne=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ne===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ke).length===0?this:new Kt(Object.assign({inputCollapsed:ne,outputCollapsed:Se},Ke))}}e.NotebookCellMetadata=Kt;class Wt{constructor(B={}){Object.assign(this,B)}with(B){return new Wt(B)}}e.NotebookDocumentMetadata=Wt;class Me{constructor(B,ne,Se,Ke,Je,at){this.kind=B,this.value=ne,this.languageId=Se,this.outputs=Ke??[],this.metadata=Je,this.executionSummary=at,Me.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(ne=>Me.isNotebookCellData(ne))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Me;class an{constructor(B,ne){this.cells=B,this.metadata=ne??new Wt}}e.NotebookData=an;class Pt{constructor(B,ne,Se){this.data=B,this.mime=ne,this.metadata=Se;const Ke=A.normalizeMimeType(ne,!0);if(!Ke)throw new Error("INVALID mime type, must not be empty or falsy: "+ne);this.mime=Ke}static isNotebookCellOutputItem(B){return B instanceof Pt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B,ne){const Se={name:B.name,message:B.message,stack:B.stack};return Pt.json(Se,"application/vnd.code.notebook.error",ne)}static stdout(B,ne){return Pt.text(B,"application/vnd.code.notebook.stdout",ne)}static stderr(B,ne){return Pt.text(B,"application/vnd.code.notebook.stderr",ne)}static bytes(B,ne="application/octet-stream",Se){return new Pt(B,ne,Se)}static text(B,ne="text/plain",Se){const Ke=Be(Pt,h,"f",S).encode(String(B));return new Pt(Ke,ne,Se)}static json(B,ne="application/json",Se){const Ke=JSON.stringify(B,void 0,"	");return Pt.text(Ke,ne,Se)}}e.NotebookCellOutputItem=Pt,h=Pt,S={value:new TextEncoder};class gt{constructor(B,ne,Se){this.items=gt.ensureUniqueMimeTypes(B,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=P.generateUuid(),this.metadata=ne??Se)}static isNotebookCellOutput(B){return B instanceof gt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&C.isArray(B.items)}static ensureUniqueMimeTypes(B,ne=!1){const Se=new Set,Ke=new Set;for(let Je=0;Je<B.length;Je++){const at=B[Je],dt=A.normalizeMimeType(at.mime);if(!Se.has(dt)){Se.add(dt);continue}Ke.add(Je),ne&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?B:B.filter((Je,at)=>!Ke.has(at))}get outputs(){return this.items}set outputs(B){this.items=B}}e.NotebookCellOutput=gt;var kn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(kn=e.NotebookCellKind||(e.NotebookCellKind={}));var Pn;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Pn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ln{constructor(B,ne,Se,Ke,Je,at){this.text=B,this.alignment=ne,this.command=Se,this.tooltip=Ke,this.priority=Je,this.accessibilityInformation=at}}e.NotebookCellStatusBarItem=ln;var In;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(In=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(B,ne=[]){this.uri=B,this.provides=v.asArray(ne)}}e.NotebookRendererScript=An;let cn=class{constructor(B,ne){this.label=B,this.timestamp=ne}};cn=Ve([l],cn),e.TimelineItem=cn;var vn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var Tn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(Tn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Rn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(Rn=e.StandardTokenType||(e.StandardTokenType={}));class Ln{constructor(B,ne){this.ranges=B,this.wordPattern=ne}}e.LinkedEditingRanges=Ln;class Fn{constructor(B,ne){this._port=B,this._autoForwardAction=ne}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fn;var wn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(wn=e.TestResultState||(e.TestResultState={}));var te;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(te=e.TestMessageSeverity||(e.TestMessageSeverity={}));var me;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(me=e.TestItemStatus||(e.TestItemStatus={}));const Ae=(z,B,ne,Se)=>{let Ke=ne;return{enumerable:!0,configurable:!1,get(){return Ke},set(Je){Se(Ke,Je)||(Ke=Je,z.bus.fire([3,B,Je]))}}},st=(z,B)=>z===B,wt=(z,B)=>z===B?!0:!z||!B?!1:z.isEqual(B);class _t{constructor(B,ne,Se,Ke){this.label=ne,this.data=Ke;const Je=a.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Je.parent},children:{value:new y.ReadonlyMapView(Je.children),enumerable:!0,writable:!1},range:Ae(Je,"range",void 0,wt),description:Ae(Je,"description",void 0,st),runnable:Ae(Je,"runnable",!0,st),debuggable:Ae(Je,"debuggable",!1,st),status:Ae(Je,"status",me.Resolved,st),error:Ae(Je,"error",void 0,st)})}invalidate(){a.getPrivateApiFor(this).bus.fire([2])}dispose(){const B=a.getPrivateApiFor(this);B.parent&&a.getPrivateApiFor(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof _t))throw new Error("Test child must be created through vscode.test.createTestItem()");const ne=a.getPrivateApiFor(this);if(ne.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);ne.children.set(B.id,B),ne.bus.fire([0,B])}}e.TestItemImpl=_t;class Mn{constructor(B){this.message=B,this.severity=te.Error}static diff(B,ne,Se){const Ke=new Mn(B);return Ke.expectedOutput=ne,Ke.actualOutput=Se,Ke}}e.TestMessage=Mn;var $n;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})($n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Wn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Wn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(Hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(pe[118],ve([0,1,49,10,8,144,106,7,17]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function s(c,h){h?P.set(c,h):P.delete(c)}e.setWordDefinitionFor=s;function I(c){return P.get(c)}e.getWordDefinitionFor=I;class a extends y.MirrorTextModel{constructor(h,S,w,_,u,d,f,t){super(S,w,_,u);this._proxy=h,this._languageId=d,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){v.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return D.equals(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===R.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(S){return S?h._getTextInRange(S):h.getText()},get eol(){return h._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(S){return h._lineAt(S)},offsetAt(S){return h._offsetAt(S)},positionAt(S){return h._positionAt(S)},validateRange(S){return h._validateRange(S)},validatePosition(S){return h._validatePosition(S)},getWordRangeAtPosition(S,w){return h._getWordRangeAtPosition(S,w)}}}return Object.freeze(this._document)}_acceptLanguageId(h){v.ok(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){v.ok(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const S=this._validateRange(h);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const w=this._eol,_=S.start.line,u=S.end.line,d=[];d.push(this._lines[_].substring(S.start.character));for(let f=_+1;f<u;f++)d.push(this._lines[f]);return d.push(this._lines[u].substring(0,S.end.character)),d.join(w)}_lineAt(h){let S;if(h instanceof C.Position?S=h.line:typeof h=="number"&&(S=h),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new g(S,this._lines[S],S===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(h),w=this._lines[S.index].length;return new C.Position(S.index,Math.min(S.remainder,w))}_validateRange(h){if(!(h instanceof C.Range))throw new Error("Invalid argument");const S=this._validatePosition(h.start),w=this._validatePosition(h.end);return S===h.start&&w===h.end?h:new C.Range(S.line,S.character,w.line,w.character)}_validatePosition(h){if(!(h instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:S,character:w}=h,_=!1;if(S<0)S=0,w=0,_=!0;else if(S>=this._lines.length)S=this._lines.length-1,w=this._lines[S].length,_=!0;else{const u=this._lines[S].length;w<0?(w=0,_=!0):w>u&&(w=u,_=!0)}return _?new C.Position(S,w):h}_getWordRangeAtPosition(h,S){const w=this._validatePosition(h);if(!S)S=I(this._languageId);else if(k.regExpLeadsToEndlessLoop(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const _=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(S),this._lines[w.line],0);if(_)return new C.Range(w.line,_.startColumn-1,w.line,_.endColumn-1)}}e.ExtHostDocumentData=a;class g{constructor(h,S,w){this._line=h,this._text=S,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(pe[191],ve([0,1,7,3,108,6,77,23,2,32]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(a,g,c,h){this._notebook=c,this._selector=h,this._disposables=new y.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:P.generateUuid()}),this._init(),this._disposables.add(g.onDidChangeDocument(w=>{const _=this._cellUris.get(w.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(a.onDidChangeNotebookCells(w=>S(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const a=[],g=[];for(const c of this._notebook.getCells())c.kind===v.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),a.push(c.document.getText().length+1),g.push(c.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(a)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(a){var g,c;if(!a){let u="";for(const d of this._cells)u+=d.document.getText()+`
`;return u=u.slice(0,-1),u}if(a.isEmpty)return"";const h=this.locationAt(a.start),S=this.locationAt(a.end),w=this._cells[(g=this._cellUris.get(h.uri))!==null&&g!==void 0?g:-1],_=this._cells[(c=this._cellUris.get(S.uri))!==null&&c!==void 0?c:-1];if(!w||!_)return"";if(w===_)return w.document.getText(new v.Range(h.range.start,S.range.end));{const u=w.document.getText(new v.Range(h.range.start,new v.Position(w.document.lineCount,0))),d=_.document.getText(new v.Range(new v.Position(0,0),S.range.end));return u+`
`+d}}offsetAt(a){const g=this._cellLines.getIndexOf(a.line),c=this._cellLengths.getAccumulatedValue(g.index-1),h=this._cells[g.index].document.offsetAt(a.with(g.remainder));return c+h}positionAt(a){if(typeof a=="number"){const c=this._cellLengths.getIndexOf(a),h=this._cellLines.getAccumulatedValue(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(h)}const g=this._cellUris.get(a.uri);if(g!==void 0){const c=this._cellLines.getAccumulatedValue(g-1);return new v.Position(c+a.range.start.line,a.range.start.character)}return new v.Position(0,0)}locationAt(a){v.Range.isRange(a)||(a=new v.Range(a,a));const g=this._cellLines.getIndexOf(a.start.line);let c=g;a.isEmpty||(c=this._cellLines.getIndexOf(a.end.line));const h=new v.Position(g.remainder,a.start.character),S=new v.Position(c.remainder,a.end.character),w=new v.Range(h,S),_=this._cells[g.index];return new v.Location(_.document.uri,_.document.validateRange(w))}contains(a){return this._cellUris.has(a)}validateRange(a){const g=this.validatePosition(a.start),c=this.validatePosition(a.end);return a.with(g,c)}validatePosition(a){const g=this._cellLines.getIndexOf(a.line),c=new v.Position(g.remainder,a.character),h=this._cells[g.index].document.validatePosition(c),S=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(S+h.line,h.character)}}e.ExtHostNotebookConcatDocument=s}),define(pe[192],ve([0,1,7,12,3]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let y=class{constructor(C){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?v.ColorThemeKind.Light:C==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};y=Ve([He(0,R.IExtHostRpcService)],y),e.ExtHostTheming=y}),define(pe[59],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=v.createDecorator("IURITransformerService");class R{constructor(y){y?(this.transformIncoming=y.transformIncoming.bind(y),this.transformOutgoing=y.transformOutgoing.bind(y),this.transformOutgoingURI=y.transformOutgoingURI.bind(y),this.transformOutgoingScheme=y.transformOutgoingScheme.bind(y)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(pe[193],ve([0,1,22]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function k(C,D){if(D.serializeBuffersForPostMessage){const P=new R,s=(g,c)=>{if(c instanceof ArrayBuffer){const h=P.add(c);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(c)){const h=y(c);if(h){const S=P.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:h,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(C,s),a=P.buffers.map(g=>{const c=new Uint8Array(g);return v.VSBuffer.wrap(c)});return{message:I,buffers:a}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=k;function y(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(C,D){const P=D.map(a=>{const g=new ArrayBuffer(a.byteLength);return new Uint8Array(g).set(a.buffer),g}),s=D.length?(a,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const c=g,{index:h}=c,S=P[h];if(c.view)switch(c.view.type){case 1:return new Int8Array(S,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return g}:void 0;return{message:JSON.parse(C,s),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(pe[85],ve([0,1,10,2]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(y,A){return y.scheme===v.Schemas.http||y.scheme===v.Schemas.https?y:(A&&A.authority&&A.isRemote&&y.scheme===v.Schemas.file&&(y=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:A.authority,path:y.path})),R.URI.from({scheme:v.Schemas.https,authority:`${y.scheme}+${y.authority}.${e.webviewRootResourceAuthority}`,path:y.path,fragment:y.fragment,query:y.query}))}e.asWebviewUri=k}),define(pe[194],ve([0,1,3,6,85]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(C,D,P){this._proxy=C,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const s=D.getVisibleTextEditors();for(const I of this._insets.values())s.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,D,P,s,I){let a;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===C){a=u;break}if(!a)throw new Error("not a visible editor");const g=this,c=this._handlePool++,h=new v.Emitter,S=new v.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return k.asWebviewUri(u,g._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(u){this._options=u,g._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,g._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(u){return g._proxy.$postMessage(c,u)}},_=new class{constructor(){this.editor=C,this.line=D,this.height=P,this.webview=w,this.onDidDispose=S.event}dispose(){g._insets.has(c)&&(g._insets.delete(c),g._proxy.$disposeEditorInset(c),S.fire(),S.dispose(),h.dispose())}};return this._proxy.$createEditorInset(c,a.id,a.value.document.uri,D+1,P,s||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:C,inset:_,onDidReceiveMessage:h}),_}$onDidDispose(C){const D=this._insets.get(C);D&&D.inset.dispose()}$onDidReceiveMessage(C,D){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=y}),define(pe[119],ve([0,1,3,14,166]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class y{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,P,s){const I={command:C};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof s=="number"){const a=setTimeout(()=>{clearTimeout(a);const g=this.pendingRequests.get(I.seq);if(g){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:k.localize(0,null,s,C)};g(c)}},s)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await R.timeout(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,P)=>C.set(P,D)),await R.timeout(500),C.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=y}),define(pe[195],ve([0,1,8,2,9,25,10]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(n,i,r){return n.replace(C,function(o,m){return i&&m.length>0&&m[0]!=="_"?o:r&&r.hasOwnProperty(m)?r[m]:o})}e.formatPII=D;function P(n){const i={};for(const r of Object.keys(n))r.startsWith("!")||(i[r]=n[r]);return i}e.filterExceptionsFromTelemetry=P;function s(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=s;function I(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),v.equalsIgnoreCase(i,"extensionhost")||v.equalsIgnoreCase(i,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function a(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=a;function g(n,i,r){let o,m=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=p.exec(n);){let b=E.index+1,l=b+E[0].length;if(b<=i&&l>=r){o=E[0],m=b;break}}if(o){let b=/\w+/g,l=null;for(;(l=b.exec(o))&&!(l.index+1+m+l[0].length>=r););l&&(o=o.substring(0,b.lastIndex))}return o?{start:m,end:m+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(c))}e.isUri=h;function S(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return R.URI.parse(n.path);if(k.isAbsolute(n.path))return R.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const i=R.URI.revive(n.path);if(i)return i.scheme===A.Schemas.file?i.fsPath:i.toString()}return n.path}function _(n,i){const r=i?S:w,o=y.deepClone(n);return d(o,(m,p)=>{m&&p&&(p.path=r(p))}),o}e.convertToDAPaths=_;function u(n,i){const r=i?S:w,o=y.deepClone(n);return d(o,(m,p)=>{!m&&p&&(p.path=r(p))}),o}e.convertToVSCPaths=u;function d(n,i){switch(n.type){case"event":const r=n;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break;case"request":const o=n;switch(o.command){case"setBreakpoints":i(!0,o.arguments.source);break;case"breakpointLocations":i(!0,o.arguments.source);break;case"source":i(!0,o.arguments.source);break;case"gotoTargets":i(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(p=>i(!1,p));break;default:break}break;case"response":const m=n;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(p=>i(!1,p.source));break;case"loadedSources":m.body.sources.forEach(p=>i(!1,p));break;case"scopes":m.body.scopes.forEach(p=>i(!1,p.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(p=>i(!1,p.source));break;case"setBreakpoints":m.body.breakpoints.forEach(p=>i(!1,p.source));break;default:break}break}}function f(n){return n.filter(i=>{var r;return!((r=i.presentation)===null||r===void 0?void 0:r.hidden)}).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):t(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:t(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}}),define(pe[196],ve([0,1,28,38,167,120,9,8,25,11,176,119]),function(Q,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class a extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",d=>this.handleData(d))}sendMessage(_){if(this.outputStream){const u=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${a.TWO_CRLF}${u}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+u))}continue}}else{const u=this.rawData.indexOf(a.TWO_CRLF);if(u!==-1){const f=this.rawData.toString("utf8",0,u).split(a.HEADER_LINESEPARATOR);for(const t of f){const n=t.split(a.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(u+a.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=a,a.TWO_CRLF=`\r
\r
`,a.HEADER_LINESEPARATOR=/\r?\n/,a.HEADER_FIELDSEPARATOR=/: */;class g extends a{startSession(){return new Promise((_,u)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",f=>{d?this._onError.fire(f):u(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class c extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return y.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=c;class h extends g{constructor(_){super();this.adapterServer=_}createConnection(_){return y.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=h;class S extends a{constructor(_,u,d){super();this.adapterExecutable=_,this.debugType=u,this.outputService=d}async startSession(){const _=this.adapterExecutable.command,u=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(_)if(A.isAbsolute(_)){if(!await v.exists(_))throw new Error(k.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let f=process.env;if(d.env&&Object.keys(d.env).length>0&&(f=D.mixin(D.deepClone(process.env),d.env)),_==="node")if(Array.isArray(u)&&u.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:f,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(i.cwd=d.cwd);const r=R.fork(u[0],u.slice(1),i);if(!r.pid)throw new Error(k.localize(2,null,u[0]));this.serverProcess=r}else throw new Error(k.localize(3,null));else{const n={env:f};d.cwd&&(n.cwd=d.cwd),this.serverProcess=R.spawn(_,u,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,i)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const r=t.getChannel(s.ExtensionsChannelId);r&&r.append(n(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((_,u)=>{const d=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,t,n){if(f)return u(f)});d.on("exit",_),d.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,u){if(!_)return;const d=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?d.runtime=A.join(u,_.runtime):d.runtime=_.runtime),_.runtimeArgs&&(d.runtimeArgs=_.runtimeArgs),_.program&&(A.isAbsolute(_.program)?d.program=_.program:d.program=A.join(u,_.program)),_.args&&(d.args=_.args);const f=_;return f.win&&(d.win=S.extract(f.win,u)),f.winx86&&(d.winx86=S.extract(f.winx86,u)),f.windows&&(d.windows=S.extract(f.windows,u)),f.osx&&(d.osx=S.extract(f.osx,u)),f.linux&&(d.linux=S.extract(f.linux,u)),d}static platformAdapterExecutable(_,u){let d=Object.create(null);u=u.toLowerCase();for(const o of _)if(o.contributes){const m=o.contributes.debuggers;m&&m.length>0&&m.filter(p=>typeof p.type=="string"&&C.equalsIgnoreCase(p.type,u)).forEach(p=>{const E=S.extract(p,o.extensionLocation.fsPath);d=D.mixin(d,E,o.isBuiltin)})}let f;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=d.winx86||d.win||d.windows:P.isWindows?f=d.win||d.windows:P.isMacintosh?f=d.osx:P.isLinux&&(f=d.linux),f=f||d;let t=f.program||d.program;const n=f.args||d.args;let i=f.runtime||d.runtime;const r=f.runtimeArgs||d.runtimeArgs;if(i)return{type:"executable",command:i,args:(r||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=S}),define(pe[197],ve([0,1,38,11,29,185]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(a,g){return new Promise((c,h)=>{let S="";const w=v.spawn(a,g);w.pid&&w.stdout.on("data",_=>{S+=_.toString()}),w.on("error",_=>{h(_)}),w.on("close",_=>{c(S)})})}let C;function D(a,g){if(!C)if(R.isWindows)C=new y.WindowsExternalTerminalService(void 0);else if(R.isMacintosh)C=new y.MacExternalTerminalService(void 0);else if(R.isLinux)C=new y.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const c=g.getConfiguration("terminal");return C.runInTerminal(a.title,a.cwd,a.args,a.env||{},c.external||{})}e.runInExternalTerminal=D;function P(a){return a?R.isWindows?new Promise(async g=>{(await new Promise((h,S)=>{Q(["windows-process-tree"],h,S)})).getProcessTree(a,h=>{g(h.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(a)]).then(g=>{const c=g.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var s;(function(a){a[a.cmd=0]="cmd",a[a.powershell=1]="powershell",a[a.bash=2]="bash"})(s||(s={}));function I(a,g,c,h){a=a.trim().toLowerCase();let S;a.indexOf("powershell")>=0||a.indexOf("pwsh")>=0?S=1:a.indexOf("cmd.exe")>=0?S=0:a.indexOf("bash")>=0?S=2:R.isWindows?S=0:S=2;let w,_=" ";switch(S){case 1:if(w=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=k.getDriveLetter(c);d&&(_+=`${d}:; `),_+=`cd ${w(c)}; `}if(h)for(let d in h){const f=h[d];f===null?_+=`Remove-Item env:${d}; `:_+=`\${env:${d}}='${f}'; `}if(g.length>0){const d=w(g.shift());_+=d[0]==="'"?`& ${d} `:`${d} `;for(let f of g)_+=`${w(f)} `}break;case 0:if(w=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=k.getDriveLetter(c);d&&(_+=`${d}: && `),_+=`cd ${w(c)} && `}if(h){_+='cmd /C "';for(let d in h){let f=h[d];f===null?_+=`set "${d}=" && `:(f=f.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${d}=${f}" && `)}}for(let d of g)_+=`${w(d)} `;h&&(_+='"');break;case 2:w=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(_+=`cd ${w(c)} ; `),h){_+="/usr/bin/env";for(let d in h){const f=h[d];f===null?_+=` -u ${u(d)}`:_+=` ${u(`${d}=${f}`)}`}_+=" "}for(let d of g)_+=`${w(d)} `;break}return _}e.prepareCommand=I}),define(pe[60],ve([0,1,30,10,9,11,111]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(b){b[b.Markup=1]="Markup",b[b.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(b){b[b.Running=1]="Running",b[b.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(b){b[b.Pending=2]="Pending",b[b.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(b){b[b.WithHardKernelDependency=0]="WithHardKernelDependency",b[b.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",b[b.Pure=2]="Pure",b[b.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(b){b[b.ModelChange=1]="ModelChange",b[b.Move=2]="Move",b[b.CellClearOutput=3]="CellClearOutput",b[b.CellsClearOutput=4]="CellsClearOutput",b[b.ChangeLanguage=5]="ChangeLanguage",b[b.Initialize=6]="Initialize",b[b.ChangeCellMetadata=7]="ChangeCellMetadata",b[b.Output=8]="Output",b[b.OutputItem=9]="OutputItem",b[b.ChangeCellContent=10]="ChangeCellContent",b[b.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",b[b.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",b[b.Unknown=100]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(b){b[b.Handle=0]="Handle",b[b.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(b){b[b.Replace=1]="Replace",b[b.Output=2]="Output",b[b.Metadata=3]="Metadata",b[b.CellLanguage=4]="CellLanguage",b[b.DocumentMetadata=5]="DocumentMetadata",b[b.Move=6]="Move",b[b.OutputItems=7]="OutputItems",b[b.PartialMetadata=8]="PartialMetadata",b[b.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));function c(b,l){if(l)return b.toString();const L=h.parse(b);return L?L.notebook.toString():b.toString()}e.getCellUndoRedoComparisonKey=c;var h;(function(b){b.scheme=R.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function L(V,$){return V.with({scheme:b.scheme,fragment:`ch${$.toString().padStart(7,"0")}${V.scheme!==R.Schemas.file?V.scheme:""}`})}b.generate=L;function O(V){if(V.scheme!==b.scheme)return;const $=l.exec(V.fragment);return $?{handle:Number($[1]),notebook:V.with({scheme:V.fragment.substr($[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parse=O;function W(V){if(V.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const $=l.exec(V.fragment);return $?{handle:Number($[1]),notebook:V.with({scheme:V.fragment.substr($[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellMetadataUri=W;function Z(V,$,j){return V.with({scheme:j,fragment:`ch${$.toString().padStart(7,"0")}${V.scheme!==R.Schemas.file?V.scheme:""}`})}b.generateCellUri=Z;function oe(V,$){if(V.scheme!==$)return;const j=l.exec(V.fragment);return j?{handle:Number(j[1]),notebook:V.with({scheme:V.fragment.substr(j[0].length)||R.Schemas.file,fragment:null})}:void 0}b.parseCellUri=oe})(h=e.CellUri||(e.CellUri={}));const S=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(b){var l,L;return(L=(l=S.get(b))===null||l===void 0?void 0:l.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=w;function _(b){var l,L;return(L=(l=S.get(b))===null||l===void 0?void 0:l.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=_;function u(b){var l,L;return(L=(l=S.get(b))===null||l===void 0?void 0:l.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=u;function d(b,l){return y.isWindows&&(b=b.replace(/\//g,"\\"),l=l.replace(/\//g,"\\")),v.match(b,l)}function f(b,l,L){let O=0;for(let W=0;W<l.length;W++){if(d(l[W],b))return O;O++}for(let W=0;W<L.length;W++){if(d(L[W],b))return O;O++}return O}function t(b,l,L){return b.sort((O,W)=>f(O,l,L)-f(W,l,L))}e.sortMimeTypes=t;function n(b,l,L,O=(W,Z)=>W===Z){const W=[];function Z($,j,T){if(j===0&&T.length===0)return;const N=W[W.length-1];N&&N.start+N.deleteCount===$?(N.deleteCount+=j,N.toInsert.push(...T)):W.push({start:$,deleteCount:j,toInsert:T})}let oe=0,V=0;for(;;){if(oe===b.length){Z(oe,0,l.slice(V));break}if(V===l.length){Z(oe,b.length-oe,[]);break}const $=b[oe],j=l[V];if(O($,j)){oe+=1,V+=1;continue}L(j)?(Z(oe,1,[]),oe+=1):(Z(oe,0,[j]),V+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new A.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(b){b.default="default",b.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(b){const l=b;return!!((typeof l.include=="string"||v.isRelativePattern(l.include))&&(typeof l.exclude=="string"||v.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=r;function o(b,l,L){if(Array.isArray(b.viewType)&&b.viewType.indexOf(l)>=0||b.viewType===l)return!0;if(b.filenamePattern){let O=r(b.filenamePattern)?b.filenamePattern.include:b.filenamePattern,W=r(b.filenamePattern)?b.filenamePattern.exclude:void 0;if(v.match(O,k.basename(L.fsPath).toLowerCase()))return!(W&&v.match(W,k.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class m{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)l[L]=this.textModel.cells[L].getHashValue();return l}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var p;(function(b){b[b.Left=1]="Left",b[b.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class E{static create(l){return`${E._prefix}${l}`}static parse(l){if(l.startsWith(E._prefix))return l.substr(E._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=E,E._prefix="notebook/"}),define(pe[198],ve([0,1,169,4,111]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[199],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=v;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(pe[121],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=R;var k;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const y=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=y;class A{add(P){}update(P){}remove(P,s){}complete(){}}e.IncrementalChangeCollector=A;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const s=this.createChangeCollector();for(const I of P)switch(I[0]){case 0:{const a=I[1];if(a.parent){if(this.items.has(a.parent)){const g=this.items.get(a.parent);g.children.add(a.item.extId);const c=this.createItem(a,g);this.items.set(a.item.extId,c),s.add(c)}}else{this.roots.add(a.item.extId);const g=this.createItem(a);this.items.set(a.item.extId,g),s.add(g)}a.expand===2&&this.busyControllerCount++;break}case 1:{const a=I[1],g=this.items.get(a.extId);if(!g)break;a.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,a.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(g,a),s.update(g);break}case 2:{const a=this.items.get(I[1]);if(!a)break;a.parent?this.items.get(a.parent).children.delete(a.item.extId):this.roots.delete(a.item.extId);const g=[[I[1]]];for(;g.length;)for(const c of g.pop()){const h=this.items.get(c);h&&(g.push(h.children),this.items.delete(c),s.remove(h,h!==a),h.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}s.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=C}),define(pe[200],ve([0,1,9,37,13,25,11,76,170]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,a,g){this._contributedVariables=new Map,this._context=I,this._labelService=a,g&&(this._envVariablesPromise=g.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const a=Object.create(null);return Object.keys(I).forEach(g=>{a[g.toLowerCase()]=I[g]}),a}return I}resolveWithEnvironment(I,a,g){return this.recursiveResolve(this.prepareEnv(I),a?a.uri:void 0,g)}async resolveAsync(I,a){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a)}async resolveAnyBase(I,a,g,c){const h=y.deepClone(a);return A.isWindows&&h.windows?Object.keys(h.windows).forEach(S=>h[S]=h.windows[S]):A.isMacintosh&&h.osx?Object.keys(h.osx).forEach(S=>h[S]=h.osx[S]):A.isLinux&&h.linux&&Object.keys(h.linux).forEach(S=>h[S]=h.linux[S]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,h,g,c)}async resolveAnyAsync(I,a,g){return this.resolveAnyBase(I,a,g)}async resolveAnyMap(I,a,g){const c=new Map;return{newConfig:await this.resolveAnyBase(I,a,g,c),resolvedVariables:c}}resolveWithInteractionReplace(I,a,g,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,a,g,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,a){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,a)}recursiveResolve(I,a,g,c,h){if(k.isString(g))return this.resolveString(I,a,g,c,h);if(k.isArray(g))return g.map(S=>this.recursiveResolve(I,a,S,c,h));if(k.isObject(g)){let S=Object.create(null);return Object.keys(g).forEach(w=>{const _=this.resolveString(I,a,w,c,h);S[_]=this.recursiveResolve(I,a,g[w],c,h)}),S}return g}resolveString(I,a,g,c,h){return g.replace(P.VARIABLE_REGEXP,(w,_)=>{if(_.includes(P.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(I,w,_,a,c);return h&&h.set(_,u),u!==w&&k.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(I,a,u,c,h)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,a,g,c,h){let S;const w=g.split(":");w.length>1&&(g=w[0],S=w[1]);const _=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error(D.localize(0,null,a))},u=()=>{const f=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(D.localize(1,null,a,v.basename(f)))},d=()=>{if(S){const f=this._context.getFolderUri(S);if(f)return f;throw new Error(D.localize(2,null,a,S))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(D.localize(3,null,a)):new Error(D.localize(4,null,a))};switch(g){case"env":if(S){if(I){const f=I[A.isWindows?S.toLowerCase():S];if(k.isString(f))return f}return""}throw new Error(D.localize(5,null,a));case"config":if(S){const f=this._context.getConfigurationValue(c,S);if(k.isUndefinedOrNull(f))throw new Error(D.localize(6,null,a,S));if(k.isObject(f))throw new Error(D.localize(7,null,a,S));return f}throw new Error(D.localize(8,null,a));case"command":return this.resolveFromMap(a,S,h,"command");case"input":return this.resolveFromMap(a,S,h,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return C.normalizeDriveLetter(this.fsPath(d()));case"cwd":return c||S?C.normalizeDriveLetter(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(d()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error(D.localize(9,null,a));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(D.localize(10,null,a));case"file":return _();case"fileWorkspaceFolder":return u();case"relativeFile":return c||S?v.relative(this.fsPath(d()),_()):_();case"relativeFileDirname":const n=v.dirname(_());if(c||S){const m=v.relative(this.fsPath(d()),n);return m.length===0?".":m}return n;case"fileDirname":return v.dirname(_());case"fileExtname":return v.extname(_());case"fileBasename":return v.basename(_());case"fileBasenameNoExtension":const i=v.basename(_());return i.slice(0,i.length-v.extname(i).length);case"fileDirnameBasename":return v.basename(v.dirname(_()));case"execPath":const r=this._context.getExecPath();return r||a;case"execInstallFolder":const o=this._context.getAppRoot();return o||a;case"pathSeparator":return v.sep;default:try{const m=S?`${g}:${S}`:g;return this.resolveFromMap(a,m,h,void 0)}catch(m){return a}}}}resolveFromMap(I,a,g,c){if(a&&g){const h=c===void 0?g[a]:g[c+":"+a];if(typeof h=="string")return h;throw new Error(D.localize(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[201],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=v.createDecorator("editorGroupsService");var R;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var k;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(a){a[a.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",a[a.EVEN=1]="EVEN",a[a.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(a){a[a.GROUP_ACTIVE=0]="GROUP_ACTIVE",a[a.GROUP_INDEX=1]="GROUP_INDEX",a[a.EDITOR_OPEN=2]="EDITOR_OPEN",a[a.EDITOR_CLOSE=3]="EDITOR_CLOSE",a[a.EDITOR_MOVE=4]="EDITOR_MOVE",a[a.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",a[a.EDITOR_LABEL=6]="EDITOR_LABEL",a[a.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",a[a.EDITOR_PIN=8]="EDITOR_PIN",a[a.EDITOR_STICKY=9]="EDITOR_STICKY",a[a.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function I(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(pe[202],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=v.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(pe[18],ve([0,1,17,95,273,53,25,13,2,41,79,171,113,60,202,7]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(_e){function fe(X){const{selectionStartLineNumber:Oe,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:et}=X,ft=new h.Position(Oe-1,Le-1),ct=new h.Position(Ze-1,et-1);return new h.Selection(ft,ct)}_e.to=fe;function de(X){const{anchor:Oe,active:Le}=X;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}_e.from=de})(S=e.Selection||(e.Selection={}));var w;(function(_e){function fe(X){if(!X)return;const{start:Oe,end:Le}=X;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}_e.from=fe;function de(X){if(!X)return;const{startLineNumber:Oe,startColumn:Le,endLineNumber:Ze,endColumn:et}=X;return new h.Range(Oe-1,Le-1,Ze-1,et-1)}_e.to=de})(w=e.Range||(e.Range={}));var _;(function(_e){function fe(de){switch(de){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 4:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}_e.to=fe})(_=e.TokenType||(e.TokenType={}));var u;(function(_e){function fe(X){return new h.Position(X.lineNumber-1,X.column-1)}_e.to=fe;function de(X){return{lineNumber:X.line+1,column:X.character+1}}_e.from=de})(u=e.Position||(e.Position={}));var d;(function(_e){function fe(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}_e.from=fe;function de(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}_e.to=de})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(_e){function fe(X){let Oe;return X.code&&(C.isString(X.code)||C.isNumber(X.code)?Oe=String(X.code):Oe={value:String(X.code.value),target:X.code.target}),Object.assign(Object.assign({},w.from(X.range)),{message:X.message,source:X.source,code:Oe,severity:n.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(t.from),tags:Array.isArray(X.tags)?v.coalesce(X.tags.map(d.from)):void 0})}_e.from=fe;function de(X){var Oe;const Le=new h.Diagnostic(w.to(X),X.message,n.to(X.severity));return Le.source=X.source,Le.code=C.isString(X.code)?X.code:(Oe=X.code)===null||Oe===void 0?void 0:Oe.value,Le.relatedInformation=X.relatedInformation&&X.relatedInformation.map(t.to),Le.tags=X.tags&&v.coalesce(X.tags.map(d.to)),Le}_e.to=de})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function fe(X){return Object.assign(Object.assign({},w.from(X.location.range)),{message:X.message,resource:X.location.uri})}_e.from=fe;function de(X){return new h.DiagnosticRelatedInformation(new h.Location(X.resource,w.to(X)),X.message)}_e.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(_e){function fe(X){switch(X){case h.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error}_e.from=fe;function de(X){switch(X){case a.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}_e.to=de})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var i;(function(_e){function fe(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}_e.from=fe;function de(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=de})(i=e.ViewColumn||(e.ViewColumn={}));function r(_e){return typeof _e.range!="undefined"}function o(_e){return _e.length===0?!0:!!r(_e[0])}e.isDecorationOptionsArr=o;var m;(function(_e){function fe(et){return et.map(_e.from)}_e.fromMany=fe;function de(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function X(et){let ft;if(de(et)){const{language:ht,value:lt}=et;ft={value:"```"+ht+`
`+lt+"\n```\n"}}else h.MarkdownString.isMarkdownString(et)?ft={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ft={value:et}:ft={value:""};const ct=Object.create(null);ft.uris=ct;const it=ht=>{try{let lt=D.URI.parse(ht,!0);lt=lt.with({query:Oe(lt.query,ct)}),ct[ht]=lt}catch(lt){}return""},vt=new k.Renderer;return vt.link=it,vt.image=ht=>it(R.parseHrefAndDimensions(ht).href),k(ft.value,{renderer:vt}),ft}_e.from=X;function Oe(et,ft){if(!et)return et;let ct;try{ct=y.parse(et)}catch(vt){}if(!ct)return et;let it=!1;return ct=A.cloneAndChange(ct,vt=>{if(D.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ht]=vt,it=!0,ht}else return}),it?JSON.stringify(ct):et}function Le(et){const ft=new h.MarkdownString(et.value,et.supportThemeIcons);return ft.isTrusted=et.isTrusted,ft}_e.to=Le;function Ze(et){if(!!et)return typeof et=="string"?et:_e.from(et)}_e.fromStrict=Ze})(m=e.MarkdownString||(e.MarkdownString={}));function p(_e){return o(_e)?_e.map(fe=>({range:w.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?m.fromMany(fe.hoverMessage):fe.hoverMessage?m.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):_e.map(fe=>({range:w.from(fe)}))}e.fromRangeOrRangeWithMessage=p;function E(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?D.URI.file(_e):_e}e.pathOrURIToURI=E;var b;(function(_e){function fe(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?E(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}_e.from=fe})(b=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var l;(function(_e){function fe(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(l=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(_e){function fe(de){if(typeof de=="undefined")return de;switch(de){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=fe})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(_e){function fe(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?l.from(de.light):void 0,dark:de.dark?l.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?E(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?b.from(de.before):void 0,after:de.after?b.from(de.after):void 0}}_e.from=fe})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(_e){function fe(X){return{text:X.newText,eol:X.newEol&&ie.from(X.newEol),range:w.from(X.range)}}_e.from=fe;function de(X){const Oe=new h.TextEdit(w.to(X.range),X.text);return Oe.newEol=typeof X.eol=="undefined"?void 0:ie.to(X.eol),Oe}_e.to=de})(W=e.TextEdit||(e.TextEdit={}));var Z;(function(_e){function fe(X,Oe,Le){var Ze,et,ft;const ct={edits:[]};if(X instanceof h.WorkspaceEdit)for(let it of X._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const vt=Oe==null?void 0:Oe.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:vt==null?void 0:vt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ze=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(Ie.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(et=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(ue.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ft=it.newOutputItems)===null||ft===void 0?void 0:ft.map(Pe.from))||[],append:it.append}});return ct}_e.from=fe;function de(X){const Oe=new h.WorkspaceEdit;for(const Le of X.edits)Le.edit?Oe.replace(D.URI.revive(Le.resource),w.to(Le.edit.range),Le.edit.text):Oe.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Oe}_e.to=de})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var oe;(function(_e){const fe=Object.create(null);fe[h.SymbolKind.File]=0,fe[h.SymbolKind.Module]=1,fe[h.SymbolKind.Namespace]=2,fe[h.SymbolKind.Package]=3,fe[h.SymbolKind.Class]=4,fe[h.SymbolKind.Method]=5,fe[h.SymbolKind.Property]=6,fe[h.SymbolKind.Field]=7,fe[h.SymbolKind.Constructor]=8,fe[h.SymbolKind.Enum]=9,fe[h.SymbolKind.Interface]=10,fe[h.SymbolKind.Function]=11,fe[h.SymbolKind.Variable]=12,fe[h.SymbolKind.Constant]=13,fe[h.SymbolKind.String]=14,fe[h.SymbolKind.Number]=15,fe[h.SymbolKind.Boolean]=16,fe[h.SymbolKind.Array]=17,fe[h.SymbolKind.Object]=18,fe[h.SymbolKind.Key]=19,fe[h.SymbolKind.Null]=20,fe[h.SymbolKind.EnumMember]=21,fe[h.SymbolKind.Struct]=22,fe[h.SymbolKind.Event]=23,fe[h.SymbolKind.Operator]=24,fe[h.SymbolKind.TypeParameter]=25;function de(Oe){return typeof fe[Oe]=="number"?fe[Oe]:6}_e.from=de;function X(Oe){for(const Le in fe)if(fe[Le]===Oe)return Number(Le);return h.SymbolKind.Property}_e.to=X})(oe=e.SymbolKind||(e.SymbolKind={}));var V;(function(_e){function fe(X){switch(X){case h.SymbolTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.SymbolTag.Deprecated}}_e.to=de})(V=e.SymbolTag||(e.SymbolTag={}));var $;(function(_e){function fe(X){return{name:X.name,kind:oe.from(X.kind),tags:X.tags&&X.tags.map(V.from),containerName:X.containerName,location:M.from(X.location)}}_e.from=fe;function de(X){const Oe=new h.SymbolInformation(X.name,oe.to(X.kind),X.containerName,M.to(X.location));return Oe.tags=X.tags&&X.tags.map(V.to),Oe}_e.to=de})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(_e){function fe(X){var Oe,Le;const Ze={name:X.name||"!!MISSING: name!!",detail:X.detail,range:w.from(X.range),selectionRange:w.from(X.selectionRange),kind:oe.from(X.kind),tags:(Le=(Oe=X.tags)===null||Oe===void 0?void 0:Oe.map(V.from))!==null&&Le!==void 0?Le:[]};return X.children&&(Ze.children=X.children.map(fe)),Ze}_e.from=fe;function de(X){const Oe=new h.DocumentSymbol(X.name,X.detail,oe.to(X.kind),w.to(X.range),w.to(X.selectionRange));return v.isNonEmptyArray(X.tags)&&(Oe.tags=X.tags.map(V.to)),X.children&&(Oe.children=X.children.map(de)),Oe}_e.to=de})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var T;(function(_e){function fe(de){const X=new h.CallHierarchyItem(oe.to(de.kind),de.name,de.detail||"",D.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return X._sessionId=de._sessionId,X._itemId=de._itemId,X}_e.to=fe})(T=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(_e){function fe(de){return new h.CallHierarchyIncomingCall(T.to(de.from),de.fromRanges.map(X=>w.to(X)))}_e.to=fe})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(_e){function fe(de){return new h.CallHierarchyOutgoingCall(T.to(de.to),de.fromRanges.map(X=>w.to(X)))}_e.to=fe})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(_e){function fe(X){return{range:X.range&&w.from(X.range),uri:X.uri}}_e.from=fe;function de(X){return new h.Location(D.URI.revive(X.uri),w.to(X.range))}_e.to=de})(M=e.location||(e.location={}));var U;(function(_e){function fe(X){const Oe=X,Le=X;return{originSelectionRange:Oe.originSelectionRange?w.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Le.uri,range:w.from(Oe.targetRange?Oe.targetRange:Le.range),targetSelectionRange:Oe.targetSelectionRange?w.from(Oe.targetSelectionRange):void 0}}_e.from=fe;function de(X){return{targetUri:D.URI.revive(X.uri),targetRange:w.to(X.range),targetSelectionRange:X.targetSelectionRange?w.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?w.to(X.originSelectionRange):void 0}}_e.to=de})(U=e.DefinitionLink||(e.DefinitionLink={}));var x;(function(_e){function fe(X){return{range:w.from(X.range),contents:m.fromMany(X.contents)}}_e.from=fe;function de(X){return new h.Hover(X.contents.map(m.to),w.to(X.range))}_e.to=de})(x=e.Hover||(e.Hover={}));var K;(function(_e){function fe(X){return{range:w.from(X.range),expression:X.expression}}_e.from=fe;function de(X){return new h.EvaluatableExpression(w.to(X.range),X.expression)}_e.to=de})(K=e.EvaluatableExpression||(e.EvaluatableExpression={}));var se;(function(_e){function fe(X){if(X instanceof h.InlineValueText)return{type:"text",range:w.from(X.range),text:X.text};if(X instanceof h.InlineValueVariableLookup)return{type:"variable",range:w.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=fe;function de(X){switch(X.type){case"text":return{range:w.to(X.range),text:X.text};case"variable":return{range:w.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:w.to(X.range),expression:X.expression}}}_e.to=de})(se=e.InlineValue||(e.InlineValue={}));var be;(function(_e){function fe(X){return{frameId:X.frameId,stoppedLocation:w.from(X.stoppedLocation)}}_e.from=fe;function de(X){return new h.InlineValueContext(X.frameId,w.to(X.stoppedLocation))}_e.to=de})(be=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(_e){function fe(X){return{range:w.from(X.range),kind:X.kind}}_e.from=fe;function de(X){return new h.DocumentHighlight(w.to(X.range),X.kind)}_e.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function fe(de){switch(de){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}_e.to=fe})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Fe;(function(_e){function fe(de){return{triggerKind:Ce.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}_e.to=fe})(Fe=e.CompletionContext||(e.CompletionContext={}));var qe;(function(_e){function fe(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}_e.from=fe;function de(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}_e.to=de})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(_e){const fe=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function de(Le){var Ze;return(Ze=fe.get(Le))!==null&&Ze!==void 0?Ze:9}_e.from=de;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Oe(Le){var Ze;return(Ze=X.get(Le))!==null&&Ze!==void 0?Ze:h.CompletionItemKind.Property}_e.to=Oe})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(_e){function fe(de,X){var Oe;const Le=new h.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Le.label2=de.label),Le.insertText=de.insertText,Le.kind=ze.to(de.kind),Le.tags=(Oe=de.tags)===null||Oe===void 0?void 0:Oe.map(qe.to),Le.detail=de.detail,Le.documentation=R.isMarkdownString(de.documentation)?m.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,P.Range.isIRange(de.range)?Le.range=w.to(de.range):typeof de.range=="object"&&(Le.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Le.insertText=new h.SnippetString(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof h.Range?new h.TextEdit(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ze=>W.to(Ze))),Le.command=X&&de.command?X.fromInternal(de.command):void 0,Le}_e.to=fe})(Ge=e.CompletionItem||(e.CompletionItem={}));var q;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?m.fromStrict(X.documentation):void 0}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?m.to(X.documentation):X.documentation}}_e.to=de})(q=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(_e){function fe(X){return{label:X.label,documentation:X.documentation?m.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(q.from):[],activeParameter:X.activeParameter}}_e.from=fe;function de(X){return{label:X.label,documentation:R.isMarkdownString(X.documentation)?m.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(q.to):[],activeParameter:X.activeParameter}}_e.to=de})(J=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function fe(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.from):[]}}_e.from=fe;function de(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.to):[]}}_e.to=de})(re=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(_e){function fe(X){var Oe;return{text:X.text,position:u.from(X.position),kind:Y.from((Oe=X.kind)!==null&&Oe!==void 0?Oe:h.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}_e.from=fe;function de(X){const Oe=new h.InlayHint(X.text,u.to(X.position),Y.to(X.kind));return Oe.whitespaceAfter=X.whitespaceAfter,Oe.whitespaceBefore=X.whitespaceBefore,Oe}_e.to=de})(ae=e.InlayHint||(e.InlayHint={}));var Y;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return X}_e.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(_e){function fe(X){return{range:w.from(X.range),url:X.target,tooltip:X.tooltip}}_e.from=fe;function de(X){let Oe;if(X.url)try{Oe=typeof X.url=="string"?D.URI.parse(X.url,!0):D.URI.revive(X.url)}catch(Le){}return new h.DocumentLink(w.to(X.range),Oe)}_e.to=de})(ce=e.DocumentLink||(e.DocumentLink={}));var ge;(function(_e){function fe(X){const Oe=new h.ColorPresentation(X.label);return X.textEdit&&(Oe.textEdit=W.to(X.textEdit)),X.additionalTextEdits&&(Oe.additionalTextEdits=X.additionalTextEdits.map(Le=>W.to(Le))),Oe}_e.to=fe;function de(X){return{label:X.label,textEdit:X.textEdit?W.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Oe=>W.from(Oe)):void 0}}_e.from=de})(ge=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(_e){function fe(X){return new h.Color(X[0],X[1],X[2],X[3])}_e.to=fe;function de(X){return[X.red,X.green,X.blue,X.alpha]}_e.from=de})(Re=e.Color||(e.Color={}));var we;(function(_e){function fe(X){return{range:w.from(X.range)}}_e.from=fe;function de(X){return new h.SelectionRange(w.to(X.range))}_e.to=de})(we=e.SelectionRange||(e.SelectionRange={}));var je;(function(_e){function fe(de){switch(de){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}_e.to=fe})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var G;(function(_e){function fe(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=fe;function de(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}_e.to=de})(G=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ie;(function(_e){function fe(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}_e.from=fe;function de(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}_e.to=de})(ie=e.EndOfLine||(e.EndOfLine={}));var Ee;(function(_e){function fe(de){if(typeof de=="object")return de.viewId;switch(de){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=fe})(Ee=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(_e){function fe(de){const X={start:de.start+1,end:de.end+1};return de.kind&&(X.kind=$e.from(de.kind)),X}_e.from=fe})(Ne=e.FoldingRange||(e.FoldingRange={}));var $e;(function(_e){function fe(de){if(de)switch(de){case h.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case h.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case h.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}_e.from=fe})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var We;(function(_e){function fe(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?I.EditorOverride.DISABLED:void 0}}_e.from=fe})(We=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(_e){function fe(X){return X instanceof h.RelativePattern||typeof X=="string"?X:de(X)?new h.RelativePattern(X.base,X.pattern):X}_e.from=fe;function de(X){const Oe=X;return Oe&&typeof Oe.base=="string"&&typeof Oe.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var De;(function(_e){function fe(de){if(de){if(Array.isArray(de))return de.map(fe);if(typeof de=="string")return de;{const X=de;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:Xe.from(X.pattern),exclusive:X.exclusive}}}else return}_e.from=fe})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(_e){function fe(X){return{start:X.start,end:X.end}}_e.from=fe;function de(X){return new h.NotebookRange(X.start,X.end)}_e.to=de})(ye=e.NotebookRange||(e.NotebookRange={}));var ke;(function(_e){function fe(de){return new h.NotebookCellMetadata().with(Object.assign(Object.assign({},de),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}_e.to=fe})(ke=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var le;(function(_e){function fe(X){return X}_e.from=fe;function de(X){return new h.NotebookDocumentMetadata().with(X)}_e.to=de})(le=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var he;(function(_e){function fe(X){return{startTime:X.runStartTime,endTime:X.runEndTime,executionOrder:X.executionOrder,success:X.lastRunSuccess}}_e.to=fe;function de(X){return{lastRunSuccess:X.success,runStartTime:X.startTime,runEndTime:X.endTime,executionOrder:X.executionOrder}}_e.from=de})(he=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var H;(function(_e){function fe(X){switch(X){case h.NotebookCellKind.Markup:return g.CellKind.Markup;case h.NotebookCellKind.Code:default:return g.CellKind.Code}}_e.from=fe;function de(X){switch(X){case g.CellKind.Markup:return h.NotebookCellKind.Markup;case g.CellKind.Code:default:return h.NotebookCellKind.Code}}_e.to=de})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var ee;(function(_e){function fe(X){const Oe={metadata:le.from(X.metadata),cells:[]};for(let Le of X.cells)h.NotebookCellData.validate(Le),Oe.cells.push(ue.from(Le));return Oe}_e.from=fe;function de(X){return{metadata:le.to(X.metadata),cells:X.cells.map(ue.to)}}_e.to=de})(ee=e.NotebookData||(e.NotebookData={}));var ue;(function(_e){function fe(X){var Oe;return{cellKind:H.from(X.kind),language:X.languageId,source:X.value,metadata:X.metadata,internalMetadata:he.from((Oe=X.executionSummary)!==null&&Oe!==void 0?Oe:{}),outputs:X.outputs?X.outputs.map(Ie.from):[]}}_e.from=fe;function de(X){return new h.NotebookCellData(H.to(X.cellKind),X.source,X.language,X.outputs?X.outputs.map(Ie.to):void 0,X.metadata?ke.to(X.metadata):void 0,X.internalMetadata?he.to(X.internalMetadata):void 0)}_e.to=de})(ue=e.NotebookCellData||(e.NotebookCellData={}));var Pe;(function(_e){function fe(X){return{metadata:X.metadata,mime:X.mime,valueBytes:Array.from(X.data)}}_e.from=fe;function de(X){return new h.NotebookCellOutputItem(new Uint8Array(X.valueBytes),X.mime,X.metadata)}_e.to=de})(Pe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(_e){function fe(X){return{outputId:X.id,outputs:X.items.map(Pe.from),metadata:X.metadata}}_e.from=fe;function de(X){const Oe=X.outputs.map(Pe.to);return new h.NotebookCellOutput(Oe,X.outputId,X.metadata)}_e.to=de})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ue;(function(_e){function fe(Le){if(Le!=null){if(Le instanceof h.RelativePattern||typeof Le=="string")return Le;if(Oe(Le))return new h.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:Xe.from(Le.include)||void 0,exclude:Xe.from(Le.exclude)||void 0}}}_e.from=fe;function de(Le){return typeof Le=="string"?Le:Oe(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}_e.to=de;function X(Le){const Ze=Le,et=Xe.from(Ze.include);if(!(et&&et instanceof h.RelativePattern||typeof et=="string"))return!1;const ft=Xe.from(Ze.exclude);return!!(ft&&ft instanceof h.RelativePattern||typeof ft=="string")}function Oe(Le){const Ze=Le;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ue=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var xe;(function(_e){function fe(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?b.from(de.top):void 0}}_e.from=fe})(xe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Qe;(function(_e){function fe(de,X,Oe){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,Oe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}_e.from=fe})(Qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(_e){function fe(de){var X,Oe,Le;return{transientOutputs:(X=de==null?void 0:de.transientOutputs)!==null&&X!==void 0?X:!1,transientCellMetadata:(Oe=de==null?void 0:de.transientCellMetadata)!==null&&Oe!==void 0?Oe:{},transientDocumentMetadata:(Le=de==null?void 0:de.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}_e.from=fe})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(_e){function fe(X){return{uri:X.uri,provides:X.provides}}_e.from=fe;function de(X){return new h.NotebookRendererScript(D.URI.revive(X.uri),X.provides)}_e.to=de})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ye;(function(_e){function fe(X){return{message:m.fromStrict(X.message)||"",severity:X.severity,expectedOutput:X.expectedOutput,actualOutput:X.actualOutput,location:X.location?M.from(X.location):void 0}}_e.from=fe;function de(X){const Oe=new h.TestMessage(typeof X.message=="string"?X.message:m.to(X.message));return Oe.severity=X.severity,Oe.actualOutput=X.actualOutput,Oe.expectedOutput=X.expectedOutput,Oe}_e.to=de})(Ye=e.TestMessage||(e.TestMessage={}));var ot;(function(_e){function fe(Le){var Ze,et;return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:(Ze=Le.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Le.description||null,runnable:(et=Le.runnable)!==null&&et!==void 0?et:!0,error:Le.error&&m.fromStrict(Le.error)||null}}_e.from=fe;function de(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}_e.fromResultSnapshot=de;function X(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:w.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:h.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}_e.toPlain=X;function Oe(Le){const Ze=new h.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Ze.range=w.to(Le.range||void 0),Ze.debuggable=Le.debuggable,Ze.description=Le.description||void 0,Ze.runnable=Le.runnable,Ze}_e.to=Oe})(ot=e.TestItem||(e.TestItem={}));var Et;(function(_e){const fe=(X,Oe)=>Object.assign(Object.assign({},ot.toPlain(X.item)),{taskStates:X.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(Ye.to)})),children:X.children.map(Le=>Oe.get(Le)).filter(C.isDefined).map(Le=>fe(Le,Oe))});function de(X){const Oe=[],Le=new Map;for(const Ze of X.items)Le.set(Ze.item.extId,Ze),Ze.direct&&Oe.push(Ze);return{completedAt:X.completedAt,results:Oe.map(Ze=>fe(Ze,Le))}}_e.to=de})(Et=e.TestResults||(e.TestResults={}));var bt;(function(_e){function fe(de){switch(de){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}_e.to=fe})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(pe[203],ve([0,1,2,16,7,18,72]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,s,I,a={timeout:1500,errors:3}){this._logService=P,this._documents=s,this._mainThreadBulkEdits=I,this._thresholds=a,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(s,I,a)=>{const c={dispose:this._callbacks.push([s,I,P])};return Array.isArray(a)&&a.push(c),c}}async $participateInSave(P,s){const I=v.URI.revive(P);let a=!1;const g=setTimeout(()=>a=!0,this._thresholds.timeout),c=[];try{for(let h of[...this._callbacks]){if(a)break;const S=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(h,{document:S,reason:y.TextDocumentSaveReason.to(s)});c.push(w)}}finally{clearTimeout(g)}return c}_deliverEventAsyncAndBlameBadListeners([P,s,I],a){const g=this._badListeners.get(P);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,s,a).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const h=this._badListeners.get(P);this._badListeners.set(P,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,s,I,a){const g=[],c=Date.now(),{document:h,reason:S}=a,{version:w}=h,_=Object.freeze({document:h,reason:S,waitUntil(u){if(Object.isFrozen(g))throw R.illegalState("waitUntil can not be called async");g.push(Promise.resolve(u))}});try{s.apply(I,[_])}catch(u){return Promise.reject(u)}return Object.freeze(g),new Promise((u,d)=>{const f=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(f),u(t)}).catch(t=>{clearTimeout(f),d(t)})}).then(u=>{const d={edits:[]};for(const f of u)if(Array.isArray(f)&&f.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:n,range:i}of f)d.edits.push({_type:2,resource:h.uri,edit:{range:i&&y.Range.from(i),text:t,eol:n&&y.EndOfLine.from(n)}});if(d.edits.length!==0)return w===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(pe[204],ve([0,1,3,14,30,2,18,7]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,a,g,c,h){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),c&&(this._config+=2),h&&(this._config+=4);const S=k.parse(a),w=I(_=>{if(!g)for(let u of _.created){const d=y.URI.revive(u);S(d.fsPath)&&this._onDidCreate.fire(d)}if(!c)for(let u of _.changed){const d=y.URI.revive(u);S(d.fsPath)&&this._onDidChange.fire(d)}if(!h)for(let u of _.deleted){const d=y.URI.revive(u);S(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,a,g){this._logService=a,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,a,g,c){return new D(this._onFileSystemEvent.event,I,a,g,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,a){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:a.map(g=>({oldUri:y.URI.revive(g.source),newUri:y.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:a.map(g=>y.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:a.map(g=>y.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,a){return(g,c,h)=>{const S=function(_){g.call(c,_)};return S.extension=I,a.event(S,void 0,h)}}async $onWillRunFileOperation(I,a,g,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:a.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},g,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:a.map(h=>y.URI.revive(h.target))},g,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:a.map(h=>y.URI.revive(h.target))},g,c)}}async _fireWillEvent(I,a,g,c){const h=new Set,S=[];if(await I.fireAsync(a,c,async(_,u)=>{var d;const f=Date.now(),t=await Promise.resolve(_);t instanceof C.WorkspaceEdit&&(S.push(t),h.add((d=u.extension.displayName)!==null&&d!==void 0?d:u.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||S.length===0)return;const w={edits:[]};for(let _ of S){let{edits:u}=A.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=P}),define(pe[205],ve([0,1,10,25,2,18,7,60]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(a,g,c,h){this.start=a,this.deletedCount=g,this.deletedItems=c,this.items=h}static asApiEvents(a){return a.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(c=>c.apiCell)}))}}class P{constructor(a,g,c){var h,S,w;this.notebook=a,this._extHostDocument=g,this._cellData=c,this.handle=c.handle,this.uri=k.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(y.NotebookCellOutput.to),this._internalMetadata=(h=c.internalMetadata)!==null&&h!==void 0?h:{},this._metadata=y.NotebookCellMetadata.to((S=c.metadata)!==null&&S!==void 0?S:{}),this._previousResult=y.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(a,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:a}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const a=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return a.notebook.getCellIndex(a)},notebook:a.notebook.apiNotebook,kind:y.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return a._outputs.slice(0)},get metadata(){return a._metadata},get executionSummary(){return a._previousResult}})}return this._apiCell}setOutputs(a){this._outputs=a.map(y.NotebookCellOutput.to)}setOutputItems(a,g,c){const h=c.map(y.NotebookCellOutputItem.to),S=this._outputs.find(w=>w.id===a);S&&(g||(S.items.length=0),S.items.push(...h))}setMetadata(a){this._metadata=y.NotebookCellMetadata.to(a)}setInternalMetadata(a){this._internalMetadata=a,this._previousResult=y.NotebookCellExecutionSummary.to(a)}}e.ExtHostCell=P;class s{constructor(a,g,c,h,S,w,_){this._proxy=a,this._textDocumentsAndEditors=g,this._textDocuments=c,this._emitter=h,this._notebookType=S,this._metadata=w,this.uri=_,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const a=this;this._notebook={get uri(){return a.uri},get version(){return a._versionId},get viewType(){return a._notebookType},get notebookType(){return a._notebookType},get isDirty(){return a._isDirty},get isUntitled(){return a.uri.scheme===v.Schemas.untitled},get isClosed(){return a._disposed},get metadata(){return a._metadata},get cellCount(){return a._cells.length},cellAt(g){return g=a._validateIndex(g),a._cells[g].apiCell},getCells(g){return(g?a._getCells(g):a._cells).map(h=>h.apiCell)},save(){return a._save()}}}return this._notebook}updateBackup(a){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=a}disposeBackup(){var a;(a=this._backup)===null||a===void 0||a.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(a){a.metadata&&(this._metadata=this._metadata.with(a.metadata))}acceptModelChanged(a,g){this._versionId=a.versionId,this._isDirty=g;for(const c of a.rawEvents)c.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(c.changes,!0),c.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===C.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(a){return a=a|0,a<0?0:a>=this._cells.length?this._cells.length-1:a}_validateRange(a){let g=a.start|0,c=a.end|0;return g<0&&(g=0),c>this._cells.length&&(c=this._cells.length),a.with({start:g,end:c})}_getCells(a){a=this._validateRange(a);const g=[];for(let c=a.start;c<a.end;c++)g.push(this._cells[c]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(a,g){if(this._disposed)return;const c=[],h=[],S=[];a.reverse().forEach(w=>{const u=w[2].map(t=>{const n=new P(this,this._textDocumentsAndEditors,t);return g||h.push(P.asModelAddData(this.apiNotebook,t)),n}),d=new D(w[0],w[1],[],u),f=this._cells.splice(w[0],w[1],...u);for(const t of f)S.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:S}),g||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(c)}))}_moveCell(a,g){const c=this._cells.splice(a,1);this._cells.splice(g,0,...c);const h=[new D(a,1,c.map(S=>S.apiCell),[]),new D(g,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(a,g){const c=this._cells[a];c.setOutputs(g),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(a,g,c,h){const S=this._cells[a];S.setOutputItems(g,c,h),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(a,g){const c=this._cells[a];c.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(c.uri,g)}_changeCellMetadata(a,g){const c=this._cells[a],h=c.apiCell.metadata;c.setMetadata(g);const S=c.apiCell.metadata;R.equals(h,S)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(a,g){var c;const h=this._cells[a],S=h.internalMetadata;if(h.setInternalMetadata(g),S.runState!==g.runState){const w=(c=g.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:h.apiCell,state:w}))}}getCellFromApiCell(a){return this._cells.find(g=>g.apiCell===a)}getCellFromIndex(a){return this._cells[a]}getCell(a){return this._cells.find(g=>g.handle===a)}getCellIndex(a){return this._cells.indexOf(a)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(pe[122],ve([0,1,7,18]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,P){this._throwIfFinalized(),!(C===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:P.map(R.NotebookCellData.from)})}}class y{constructor(C,D,P,s,I,a){this.id=C,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=s,this._viewColumn=a}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,P){C._proxy.$tryRevealRange(C.id,R.NotebookRange.from(D),P??v.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const P=new k(this.document.version);return D(P),C._applyEdit(P.finalize())},setDecorations(D,P){return C.setDecorations(D,P)}},y.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let s=0;s<C.cellEdits.length;s++){if(P<0){D.push(C.cellEdits[s]),P++;continue}const a=D[P],g=C.cellEdits[s];if(a.editType===1&&g.editType===1&&a.index===g.index){a.cells.push(...C.cellEdits[s].cells),a.count+=C.cellEdits[s].count;continue}D.push(C.cellEdits[s]),P++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=y,y.apiEditorsToExtHost=new WeakMap}),define(pe[206],ve([0,1,18,114,160,21,50]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,a,g){const c=this._handles++,{title:h,location:S,cancellable:w}=a,_={label:k.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:v.ProgressLocation.from(S),title:h,source:_,cancellable:w},I),this._withProgress(c,g,!!w)}_withProgress(I,a,g){let c;g&&(c=new y.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const h=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let S;try{S=a(new P(this._proxy,I),g&&c?c.token:y.CancellationToken.None)}catch(w){throw h(I),w}return S.then(w=>h(I),w=>h(I)),S}$acceptProgressCanceled(I){const a=this._mapHandleToCancellationSource.get(I);a&&(a.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function D(s,I){return s.message=I.message,typeof I.increment=="number"&&(typeof s.increment=="number"?s.increment+=I.increment:s.increment=I.increment),s}class P extends R.Progress{constructor(I,a){super(g=>this.throttledReport(g));this._proxy=I,this._handle=a}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([A.throttle(100,(s,I)=>D(s,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(pe[123],ve([0,1,49,16,70,18,7]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(a,g,c){const h=C._Keys.nextId();a.$registerTextEditorDecorationType(g.identifier,h,y.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:h,dispose(){a.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=C,C._Keys=new k.IdGenerator("TextEditorDecorationType");class D{constructor(a,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=a,this._documentVersionId=a.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(a,g){this._throwIfFinalized();let c=null;if(a instanceof A.Position)c=new A.Range(a,a);else if(a instanceof A.Range)c=a;else throw new Error("Unrecognized location");this._pushEdit(c,g,!1)}insert(a,g){this._throwIfFinalized(),this._pushEdit(new A.Range(a,a),g,!0)}delete(a){this._throwIfFinalized();let g=null;if(a instanceof A.Range)g=a;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(a,g,c){const h=this._document.validateRange(a);this._collectedEdits.push({range:h,text:g,forceMoveMarkers:c})}setEndOfLine(a){if(this._throwIfFinalized(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=a}}e.TextEditorEdit=D;class P{constructor(a,g,c,h){this._proxy=a,this._id=g,this._accept(c),this._logService=h;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(w){S._setTabSize(w)},get insertSpaces(){return S._insertSpaces},set insertSpaces(w){S._setInsertSpaces(w)},get cursorStyle(){return S._cursorStyle},set cursorStyle(w){S._setCursorStyle(w)},get lineNumbers(){return S._lineNumbers},set lineNumbers(w){S._setLineNumbers(w)}}}_accept(a){this._tabSize=a.tabSize,this._insertSpaces=a.insertSpaces,this._cursorStyle=a.cursorStyle,this._lineNumbers=y.TextEditorLineNumbersStyle.to(a.lineNumbers)}_validateTabSize(a){if(a==="auto")return"auto";if(typeof a=="number"){const g=Math.floor(a);return g>0?g:null}if(typeof a=="string"){const g=parseInt(a,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(a){const g=this._validateTabSize(a);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(a){return a==="auto"?"auto":a==="false"?!1:Boolean(a)}_setInsertSpaces(a){const g=this._validateInsertSpaces(a);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(a){this._cursorStyle!==a&&(this._cursorStyle=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:a})))}_setLineNumbers(a){this._lineNumbers!==a&&(this._lineNumbers=a,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:y.TextEditorLineNumbersStyle.from(a)})))}assign(a){const g={};let c=!1;if(typeof a.tabSize!="undefined"){const h=this._validateTabSize(a.tabSize);h==="auto"?(c=!0,g.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,c=!0,g.tabSize=h)}if(typeof a.insertSpaces!="undefined"){const h=this._validateInsertSpaces(a.insertSpaces);h==="auto"?(c=!0,g.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,c=!0,g.insertSpaces=h)}typeof a.cursorStyle!="undefined"&&this._cursorStyle!==a.cursorStyle&&(this._cursorStyle=a.cursorStyle,c=!0,g.cursorStyle=a.cursorStyle),typeof a.lineNumbers!="undefined"&&this._lineNumbers!==a.lineNumbers&&(this._lineNumbers=a.lineNumbers,c=!0,g.lineNumbers=y.TextEditorLineNumbersStyle.from(a.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(a){a.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=P;class s{constructor(a,g,c,h,S,w,_,u){this.id=a,this._proxy=g,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new P(this._proxy,this.id,w,c),this._visibleRanges=_,this._viewColumn=u;const d=this;this.value=Object.freeze({get document(){return h.getValue()},set document(f){throw R.readonly("document")},get selection(){return d._selections&&d._selections[0]},set selection(f){if(!(f instanceof A.Selection))throw R.illegalArgument("selection");d._selections=[f],d._trySetSelection()},get selections(){return d._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");d._selections=f,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(f){throw R.readonly("visibleRanges")},get options(){return d._options.value},set options(f){d._disposed||d._options.assign(f)},get viewColumn(){return d._viewColumn},set viewColumn(f){throw R.readonly("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(h.getValue(),t);return f(n),d._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=d._selections.map(r=>y.Range.from(r));else if(t instanceof A.Position){const{lineNumber:r,column:o}=y.Position.from(t);i=[{startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o}]}else if(t instanceof A.Range)i=[y.Range.from(t)];else{i=[];for(const r of t)if(r instanceof A.Range)i.push(y.Range.from(r));else{const{lineNumber:o,column:m}=y.Position.from(r);i.push({startLineNumber:o,startColumn:m,endLineNumber:o,endColumn:m})}}return g.$tryInsertSnippet(a,f.value,i,n)},setDecorations(f,t){const n=t.length===0;n&&!d._hasDecorationsForKey.has(f.key)||(n?d._hasDecorationsForKey.delete(f.key):d._hasDecorationsForKey.add(f.key),d._runOnProxy(()=>{if(y.isDecorationOptionsArr(t))return g.$trySetDecorations(a,f.key,y.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let r=0,o=t.length;r<o;r++){const m=t[r];i[4*r]=m.start.line+1,i[4*r+1]=m.start.character+1,i[4*r+2]=m.end.line+1,i[4*r+3]=m.end.character+1}return g.$trySetDecorationsFast(a,f.key,i)}}))},revealRange(f,t){d._runOnProxy(()=>g.$tryRevealRange(a,y.Range.from(f),t||A.TextEditorRevealType.Default))},show(f){g.$tryShowEditor(a,y.ViewColumn.from(f))},hide(){g.$tryHideEditor(a)}})}dispose(){v.ok(!this._disposed),this._disposed=!0}_acceptOptions(a){v.ok(!this._disposed),this._options._accept(a)}_acceptVisibleRanges(a){v.ok(!this._disposed),this._visibleRanges=a}_acceptViewColumn(a){v.ok(!this._disposed),this._viewColumn=a}_acceptSelections(a){v.ok(!this._disposed),this._selections=a}async _trySetSelection(){const a=this._selections.map(y.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,a)),this.value}_applyEdit(a){const g=a.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const c=g.edits.map(S=>S.range);c.sort((S,w)=>S.end.line===w.end.line?S.end.character===w.end.character?S.start.line===w.start.line?S.start.character-w.start.character:S.start.line-w.start.line:S.end.character-w.end.character:S.end.line-w.end.line);for(let S=0,w=c.length-1;S<w;S++){const _=c[S].end;if(c[S+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=g.edits.map(S=>({range:y.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,h,{setEndOfLine:typeof g.setEndOfLine=="number"?y.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(a){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=s}),define(pe[207],ve([0,1,163,24,2,3,6,14,7,13,17,18,21]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(S,w){if(P.isString(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let _;return Array.isArray(S.highlights)&&(_=S.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),_=_.length?_:void 0),{label:S.label,highlights:_}}}class c{constructor(w,_,u){this._proxy=w,this.commands=_,this.logService=u,this.treeViews=new Map;function d(f){return f&&f.$treeViewId&&f.$treeItemHandle}_.registerArgumentProcessor({processArgument:f=>d(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>d(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(w,_,u){const d=this.createTreeView(w,{treeDataProvider:_},u);return{dispose:()=>d.dispose()}}createTreeView(w,_,u){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=_.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(w,_,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,i)=>t.reveal(n,i),dispose:async()=>{await f,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,_){const u=this.treeViews.get(w);return u?u.getChildren(_):Promise.reject(new Error(v.localize(0,null,w)))}$onDrop(w,_,u){const d=this.treeViews.get(w);return d?d.onDrop(_,u):Promise.reject(new Error(v.localize(1,null,w)))}async $hasResolve(w){const _=this.treeViews.get(w);if(!_)throw new Error(v.localize(2,null,w));return _.hasResolve}$resolve(w,_,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(3,null,w));return d.resolveTreeItem(_,u)}$setExpanded(w,_,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(4,null,w));d.setExpanded(_,u)}$setSelection(w,_){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(5,null,w));u.setSelection(_)}$setVisible(w,_){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(6,null,w));u.setVisible(_)}createExtHostTreeView(w,_,u){const d=new h(w,_,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,d),d}convertArgument(w){const _=this.treeViews.get(w.$treeViewId);return _?_.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class h extends A.Disposable{constructor(w,_,u,d,f,t){super();if(this.viewId=w,this.proxy=u,this.commands=d,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new a.CancellationTokenSource,t.contributes&&t.contributes.views)for(const r in t.contributes.views)for(const o of t.contributes.views[r])o.id===w&&(this._title=o.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,i;this._register(y.Event.debounce(this._onDidChangeData.event,(r,o)=>(r||(r={message:!1,elements:[]}),o.element!==!1&&(n||(n=new Promise(m=>i=m),this.refreshPromise=this.refreshPromise.then(()=>n)),r.elements.push(o.element)),o.message&&(r.message=!0),r),200,!0)(({message:r,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=i;return n=null,this.refresh(o).then(()=>m())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!P.isUndefinedOrNull(w))}getChildren(w){const _=w?this.getExtensionElement(w):void 0;if(w&&!_)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(_)).then(d=>d.map(f=>f.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,_){_=_||{select:!0,focus:!1};const u=P.isUndefinedOrNull(_.select)?!0:_.select,d=P.isUndefinedOrNull(_.focus)?!1:_.focus,f=P.isUndefinedOrNull(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(i=>i.item)},{select:u,focus:d,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:d,expand:f})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,_){const u=this.getExtensionElement(w);u&&(_?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){s.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,_){const u=w.map(f=>this.getExtensionElement(f)).filter(f=>!P.isUndefinedOrNull(f)),d=this.getExtensionElement(_);return u&&d?C.asPromise(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(u,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,_){var u;if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(w);if(d){const f=this.nodes.get(d);if(f){const t=(u=await this.dataProvider.resolveTreeItem(f.extensionItem,d,_))!==null&&u!==void 0?u:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(_=>_?this.resolveUnknownParentChain(_).then(u=>this.resolveTreeNode(_,u[u.length-1]).then(d=>(u.push(d),u))):Promise.resolve([]))}resolveParent(w){const _=this.nodes.get(w);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):C.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,_){const u=this.nodes.get(w);return u?Promise.resolve(u):C.asPromise(()=>this.dataProvider.getTreeItem(w)).then(d=>this.createHandle(w,d,_,!0)).then(d=>this.getChildren(_?_.item.handle:void 0).then(()=>{const f=this.getExtensionElement(d);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(w){if(w){let _;if(typeof w=="string"){const u=this.getExtensionElement(w);_=u?this.nodes.get(u):void 0}else _=w;return _&&_.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const _=new a.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,d=await this.dataProvider.getChildren(w);if(_.token.isCancellationRequested)return[];const f=await Promise.all(s.coalesce(d||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,u):null}));return _.token.isCancellationRequested?[]:s.coalesce(f)}finally{_.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new a.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const _=new Set,u=w.map(f=>this.nodes.get(f));for(const f of u)if(f&&!_.has(f.item.handle)){let t=f;for(;t&&t.parent&&u.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(f.item.handle)}const d=[];return _.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&d.push(f)}}),d}refreshHandles(w){const _={};return Promise.all(w.map(u=>this.refreshNode(u).then(d=>{d&&(_[u]=d.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(w){const _=this.getExtensionElement(w);if(_){const u=this.nodes.get(_);if(u)return this.clearChildren(_),C.asPromise(()=>this.dataProvider.getTreeItem(_)).then(d=>{if(d){const f=this.createTreeNode(_,d,u.parent);return this.updateNodeCache(_,f,u,u.parent),u.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,_,u){const d=this.createTreeNode(w,_,u);if(_.id&&this.elements.has(d.item.handle))throw new Error(v.localize(7,null,_.id));return this.addNodeToCache(w,d),this.addNodeToParentCache(d,u),d}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,_){return _?this.commands.toInternal(_,w):void 0}createTreeNode(w,_,u){const d=new A.DisposableStore,f=this.createHandle(w,_,u),t=this.getLightIconPath(_);return{item:{handle:f,parentHandle:u?u.item.handle:void 0,label:g(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(d,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:P.isUndefinedOrNull(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:u,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:_,label:u,resourceUri:d},f,t){if(_)return`${h.ID_HANDLE_PREFIX}/${_}`;const n=g(u,this.extension),i=f?f.item.handle:h.LABEL_HANDLE_PREFIX;let r=n?n.label:d?R.basename(d):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const o=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,m=this.getChildrenNodes(f)||[];let p,E=0;do{if(p=`${i}/${E}:${r}`,t||!this.elements.has(p)||o===p)break;E++}while(E<=m.length);return p}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,_){this.elements.set(_.item.handle,w),this.nodes.set(w,_)}updateNodeCache(w,_,u,d){this.elements.delete(_.item.handle),this.nodes.delete(w),_.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,_);const f=this.getChildrenNodes(d)||[],t=f.filter(n=>n.item.handle===u.item.handle)[0];t&&f.splice(f.indexOf(t),1,_)}addNodeToParentCache(w,_){_?(_.children||(_.children=[]),_.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const _=this.nodes.get(w);if(_){if(_.children)for(const u of _.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}_.children=void 0}}else this.clearAll()}clear(w){const _=this.nodes.get(w);if(_){if(_.children)for(const u of _.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}this.nodes.delete(w),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(pe[208],ve([0,1,17,14,21,13,84,18,7,121]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(S,w){if(w!==void 0){const _=this.testIdsToInternal.get(w),u=_==null?void 0:_.get(S);if(u)return[_,u]}return v.mapFind(this.testIdsToInternal.values(),_=>{const u=_.get(S);return u&&[_,u]})}createForHierarchy(S=()=>{}){return new c(this.createIdMap(a++),S)}createIdMap(S){const w=new g(S);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=s;var I;(function(h){h[h.Disconnected=0]="Disconnected",h[h.IsChild=1]="IsChild",h[h.IsParent=2]="IsParent",h[h.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let a=0;class g{constructor(S){this.id=S,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(S){if(this.map.has(S.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${S.item.extId}`);this.map.set(S.item.extId,S),S.parent||this._roots.add(S)}has(S){return this.map.has(S)}delete(S){const w=this.map.get(S);return w?(this.map.delete(S),this._roots.delete(w),!0):!1}get(S){return this.map.get(S)}comparePositions(S,w){const _=typeof S=="string"?this.map.get(S):S,u=typeof w=="string"?this.map.get(w):w;if(!_||!u)return 0;if(_===u)return 3;for(let d=this.map.get(u.parent);d;d=this.map.get(d.parent))if(d===_)return 1;for(let d=this.map.get(_.parent);d;d=this.map.get(d.parent))if(d===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class c{constructor(S,w){this.testIdToInternal=S,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(S,w){this.addItem(S,w,null)}getTestByReference(S){return this.testItemToInternal.get(S)}collectDiff(){const S=this.diff;return this.diff=[],S}pushDiff(S){const w=this.diff[this.diff.length-1];if(w&&S[0]===1){if(w[0]===1&&w[1].extId===S[1].extId){P.applyTestItemUpdate(w[1],S[1]);return}if(w[0]===0&&w[1].item.extId===S[1].extId){P.applyTestItemUpdate(w[1],S[1]);return}}this.diff.push(S),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(S,w){var _;const u=this.testIdToInternal.object.get(S);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const d=this.refreshChildren(u);return d.isSettled?this.expandChildren(u,w-1):d.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((_=u.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var S;for(const w of this.testItemToInternal.values())(S=w.discoverCts)===null||S===void 0||S.dispose(!0),A.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(S,w){const _=S==null?void 0:S.actual.id;switch(w[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(S);break;case 0:this.addItem(w[1],S.src.controller,S);break;case 3:const[u,d,f]=w;switch(d){case"status":this.updateExpandability(S);break;case"range":this.pushDiff([1,{extId:_,item:{range:C.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:C.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[d]:f??null}}]);break}break;default:y.assertNever(w[0])}}addItem(S,w,_){if(!(S instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${S.id} did not`);if(this.testItemToInternal.has(S))throw new Error(`Attempted to add a single TestItem ${S.id} multiple times to the tree`);if(this.testIdToInternal.object.has(S.id))throw new Error(`Attempted to insert a duplicate test item ID ${S.id}`);const u=_?_.item.extId:null,d=S.resolveHandler?1:0,f=_?_.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:S,parent:u,item:C.TestItem.from(S),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(S,n),this.pushDiff([0,{parent:u,src:t,expand:d,item:n.item}]);const i=A.getPrivateApiFor(S);i.parent=_==null?void 0:_.actual,i.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const r of i.children.values())this.testItemToInternal.has(r)||this.addItem(r,w,n)}updateExpandability(S){var w;let _;S.actual.resolveHandler?S.actual.status===D.TestItemStatus.Pending?_=S.discoverCts?2:1:((w=S.initialExpand)===null||w===void 0||w.complete(),_=3):_=0,_!==S.expand&&(S.expand=_,this.pushDiff([1,{extId:S.actual.id,expand:_}]),_===1&&S.expandLevels!==void 0&&this.refreshChildren(S))}expandChildren(S,w){if(w<0)return;const _=[...S.actual.children.values()].map(u=>this.expand(u.id,w)).filter(R.isThenable);if(_.length)return Promise.all(_).then(()=>{})}refreshChildren(S){if(S.discoverCts&&S.discoverCts.dispose(!0),!S.actual.resolveHandler){const w=new R.DeferredPromise;return w.complete(),w}return S.expand=2,S.discoverCts=new k.CancellationTokenSource,this.pushExpandStateUpdate(S),S.initialExpand=new R.DeferredPromise,S.actual.resolveHandler(S.discoverCts.token),S.initialExpand}pushExpandStateUpdate(S){this.pushDiff([1,{extId:S.actual.id,expand:S.expand}])}removeItem(S){var w;this.pushDiff([2,S.actual.id]);const _=[S];for(;_.length;){const u=_.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const d of u.actual.children.values())_.push(this.testIdToInternal.object.get(d.id))}}}flushDiff(){const S=this.collectDiff();S.length&&this.publishDiff(S)}}e.SingleUseTestCollection=c}),define(pe[209],ve([0,1,26,3,9]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class y{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=y;class A{constructor(s){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let I of s.activationEvents)I==="onUri"&&(I=`onUri:${v.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(s)}}keepOnly(s){const I=new Set;s.forEach(a=>I.add(v.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>I.has(v.ExtensionIdentifier.toKey(a.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,I){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const a=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(a.map(g=>g.identifier)),I.length>0){const g=new Set;I.forEach(c=>g.add(v.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!g.has(v.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new y(a)}static _findLoopingExtensions(s){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,w){this.addNode(S),this.addNode(w),this._arcs.has(S)?this._arcs.get(S).push(w):this._arcs.set(S,[w])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,w){const _=I.getArcs(S);for(let u=0;u<_.length;u++)if(!w.has(_[u]))return!1;return!0}getNodes(){return this._nodesArr}};let a=new Map;for(let S of s){const w=v.ExtensionIdentifier.toKey(S.identifier);if(a.set(w,S),S.extensionDependencies)for(let _ of S.extensionDependencies){const u=v.ExtensionIdentifier.toKey(_);I.addArc(w,u)}}let g=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>g.add(S));let c=I.getNodes().filter(S=>!g.has(S)),h;do{h=!1;for(let S=0;S<c.length;S++){const w=c[S];I.hasOnlyGoodArcs(w,g)&&(c.splice(S,1),S--,g.add(w),h=!0)}}while(h);return c.map(S=>a.get(S))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const I=this._activationMap.get(s);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const I=this._extensionsMap.get(v.ExtensionIdentifier.toKey(s));return I||void 0}}e.ExtensionDescriptionRegistry=A;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function D(P,s){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,a=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(I!==a)return I-a;const g=k.posix.basename(P.extensionLocation.path),c=k.posix.basename(s.extensionLocation.path);return g<c?-1:g>c?1:0}}),define(pe[210],ve([0,1,22]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function y(C){const D=v.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=y;function A(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(pe[35],ve([0,1,3,2,4,26,177]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new y.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class C{constructor(_){this.dependency=_}}e.MissingExtensionDependency=C;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(_,u,d,f){this.codeLoadingTime=_,this.activateCallTime=u,this.activateResolvedTime=d,this.activationReason=f}}e.ActivationTimes=P;class s{constructor(_,u){this.description=_,this.value=u}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function a(w){w.enableProposedApi||g(w)}e.checkProposedApiEnabled=a;function g(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=g;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function h(w){return Object.assign(Object.assign({identifier:new y.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=h;class S{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,u){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,u,d,f,t){}_onDidActivateExtensionError(_,u){}_onExtensionRuntimeError(_,u){}_onExtensionHostExit(_){}}e.NullExtensionService=S}),define(pe[211],ve([0,1,26,35,15]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const y=Promise.resolve(void 0);class A{constructor(c,h,S,w){this.startup=c,this.codeLoadingTime=h,this.activateCallTime=S,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,h){return c===-1||h===-1?-1:h-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(c,h,S,w,_,u){this.activationFailed=c,this.activationFailedError=h,this.activationTimes=S,this.module=w,this.exports=_,this.subscriptions=u}}e.ActivatedExtension=D;class P extends D{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class s extends D{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=s;class I extends D{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let a=class{constructor(c,h,S,w,_){this._logService=_,this._registry=c,this._resolvedExtensionsSet=new Set,h.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,S.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const h=v.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(h)}getActivatedExtension(c){const h=v.ExtensionIdentifier.toKey(c),S=this._activatedExtensions.get(h);if(!S)throw new Error("Extension `"+c.value+"` is not known or not activated");return S}activateByEvent(c,h){if(this._alreadyActivatedEvents[c])return y;const S=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(S.map(w=>({id:w.identifier,reason:{startup:h,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,h){const S=this._registry.getExtensionDescription(c);if(!S)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:S.identifier,reason:h}])}_handleActivateRequest(c,h,S){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(c.id))){h[v.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(c.id),new I(d));return}const _=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let d=0,f=_.length;d<f;d++){const t=_[d];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const m=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),E=p&&p.displayName||t,b=new Error(`Cannot activate the '${m}' extension because its dependency '${E}' failed to activate`);b.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,b,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(b));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,h[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const i=this._registry.getExtensionDescription(t);if(i){u=!1,h[v.ExtensionIdentifier.toKey(t)]={id:i.identifier,reason:c.reason};continue}const r=w.displayName||w.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(o));return}u?h[v.ExtensionIdentifier.toKey(w.identifier)]=c:S.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(_=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(_.id))),c.length===0))return Promise.resolve(void 0);const h=Object.create(null),S=[];for(let _=0,u=c.length;_<u;_++)this._handleActivateRequest(c[_],h,S);for(let _=0,u=S.length;_<u;_++){const d=v.ExtensionIdentifier.toKey(S[_].id);h[d]&&delete h[d]}const w=Object.keys(h).map(_=>h[_]);return S.length===0?Promise.all(w.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(w).then(_=>this._activateExtensions(S))}_activateExtension(c,h){const S=v.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const w=this._activatingExtensions.get(S);if(w)return w;const _=this._host.actualActivateExtension(c,h).then(void 0,u=>{const d=new Error;return u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${c.value}' failed: ${u.message}.`:d.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(S,u),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,_),_}};a=Ve([He(4,k.ILogService)],a),e.ExtensionsActivator=a}),define(pe[212],ve([0,1,15,35,27,10,112]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends v.LogService{constructor(P){if(P.logFile.scheme!==y.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=Ve([He(0,k.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(pe[213],ve([0,1,16]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):v.onUnexpectedError(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=R}),define(pe[124],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function k(C){const D=new v(!0,C);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=k;function y(C){const D=new v(!1,C);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=y;function A(C){return R[C].sid}e.getStringIdentifierForProxy=A}),define(pe[5],ve([0,1,53,2,124]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var y;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var s;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(s=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var a;(function(u){u.name="$ident";function d(t,n){return Object.defineProperty(t,u.name,{value:n,enumerable:!0}),t}u.mixin=d;function f(t){return t[u.name]}u.of=f})(a=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(d){return d._id=g._n++,d}}e.IdObject=g,g._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const d of u.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=v.revive(d.metadata));return u}e.reviveWorkspaceEditDto=w;var _;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(pe[86],ve([0,1,5,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class y{constructor(C){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,P){return this._proxy.$setPassword(C,D,P)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=y,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(pe[61],ve([0,1,4,15,5,12]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=v.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(k.MainContext.MainThreadTelemetry)}report(D,P,s){const I=this.getUsageKey(D,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};A=Ve([He(0,y.IExtHostRpcService),He(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,P){}})}),define(pe[214],ve([0,1,3,5,7,26]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,s,I={}){const a=y.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(a)||[],c=[...s].sort().join(" ");let h=g.find(S=>S.scopes===c);if(h)return h.result;{const S=this._getSession(D,a,P,s,I);h={scopes:c,result:S},g.push(h),this._inFlightRequests.set(a,g);try{await S}finally{const w=g.findIndex(_=>_.scopes===c);w>-1&&(g.splice(w),this._inFlightRequests.set(a,g))}return S}}async _getSession(D,P,s,I,a={}){await this._proxy.$ensureProvider(s);const g=D.displayName||D.name;return this._proxy.$getSession(s,I,P,g,a)}async removeSession(D,P){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,s,I){var a;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:s,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===D)||this._providers.push({id:D,label:P});const g=s.onDidChangeSessions(c=>{var h,S,w;this._proxy.$sendDidChangeSessions(D,{added:(h=c.added)!==null&&h!==void 0?h:[],changed:(S=c.changed)!==null&&S!==void 0?S:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(a=I==null?void 0:I.supportsMultipleAccounts)!==null&&a!==void 0?a:!1),new k.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const c=this._providers.findIndex(h=>h.id===D);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(s=>{this._providers.some(I=>I.id===s.id)||this._providers.push(s)}),P.forEach(s=>{const I=this._providers.findIndex(a=>a.id===s.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(pe[215],ve([0,1,5,12,18]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=k.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};y=Ve([He(0,R.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(pe[216],ve([0,1,5]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(y){const A=y.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(C){return A.$writeText(C)}})}}e.ExtHostClipboard=R}),define(pe[47],ve([0,1,13,7,18,25,5,17,15,53,41,44,2,6,4,12]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,i=>{const r=this._apiCommands.get(i);return(r==null?void 0:r.result)===u.Void?r:void 0},n),this._argumentProcessors=[{processArgument(i){return P.revive(i)}},{processArgument(i){return y.cloneAndChange(i,function(r){if(s.Range.isIRange(r))return k.Range.to(r);if(I.Position.isIPosition(r))return k.Position.to(r);if(s.Range.isIRange(r.range)&&a.URI.isUri(r.uri))return k.location.to(r);if(!Array.isArray(r))return r})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...i)=>{const r=t.args.map((m,p)=>{if(!m.validate(i[p]))throw new Error(`Invalid argument '${m.name}' when running '${t.id}', received: ${i[p]}`);return m.convert(i[p])}),o=await this.executeCommand(t.internalId,...r);return t.result.convert(o,i,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,i,r,o){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:i,thisArg:r,description:o}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,i){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const r=y.cloneAndChange(n,function(o){if(o instanceof R.Position)return k.Position.from(o);if(o instanceof R.Range)return k.Range.from(o);if(o instanceof R.Location)return k.location.from(o);if(R.NotebookRange.isNotebookRange(o))return k.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,r,i);return P.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw o}}}async _executeContributedCommand(t,n){const i=this._commands.get(t);if(!i)throw new Error("Unknown command");let{callback:r,thisArg:o,description:m}=i;if(m)for(let p=0;p<m.args.length;p++)try{v.validateConstraint(n[p],m.args[p].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${m.args[p].name}' - ${m.args[p].description}`)}try{return await r.apply(o,n)}catch(p){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...n);E&&(t=E.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(i=>this._argumentProcessors.reduce((r,o)=>o.processArgument(r),i)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(i=>i[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,i]of this._commands){let{description:r}=i;r&&(t[n]=r)}return Promise.resolve(t)}};S=Ve([He(0,h.IExtHostRpcService),He(1,D.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,n,i){this._commands=t,this._lookupApiCommand=n,this._logService=i,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const i={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return i;const r=this._lookupApiCommand(t.command);if(r)i.id=r.internalId,i.arguments=r.args.map((o,m)=>o.convert(t.arguments&&t.arguments[m]));else if(C.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),n.add(g.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),i.$ident=o,i.id=this.delegatingCommandId,i.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return i}fromInternal(t){const n=A.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class _{constructor(t,n,i,r){this.name=t,this.description=n,this.validate=i,this.convert=r}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",f=>a.URI.isUri(f),f=>f),_.Position=new _("position","A position in a text document",f=>R.Position.isPosition(f),k.Position.from),_.Range=new _("range","A range in a text document",f=>R.Range.isRange(f),k.Range.from),_.Selection=new _("selection","A selection in a text document",f=>R.Selection.isSelection(f),k.Selection.from),_.Number=new _("number","",f=>typeof f=="number",f=>f),_.String=new _("string","",f=>typeof f=="string",f=>f),_.CallHierarchyItem=new _("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class u{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class d{constructor(t,n,i,r,o){this.id=t,this.internalId=n,this.description=i,this.args=r,this.result=o}}e.ApiCommand=d}),define(pe[217],ve([0,1,18,7,79,47,17,107]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",s(v.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,g)=>{if(A.isFalsyOrEmpty(a))return;class c extends R.SymbolInformation{static to(S){const w=new c(S.name,v.SymbolKind.to(S.kind),S.containerName||"",new R.Location(g[0],v.Range.to(S.range)));return w.detail=S.detail,w.range=w.location.range,w.selectionRange=v.Range.to(S.selectionRange),w.children=S.children?S.children.map(c.to):[],w}}return a.map(c.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new y.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",s(v.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",s(v.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(g=>R.Position.isPosition(g)),a=>a.map(v.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(g=>{let c;for(const h of g.reverse())c=new R.SelectionRange(v.Range.to(h),c);return c}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>{const g=[];if(Array.isArray(a))for(let c of a)g.push(...c[1].map(v.WorkspaceSymbol.to));return g})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(v.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(v.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",a=>a.map(v.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return v.WorkspaceEdit.to(a)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(v.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=C.decodeSemanticTokensDto(a);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new R.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const g=C.decodeSemanticTokensDto(a);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,g,c)=>{if(!a)return new R.CompletionList([]);const h=a.suggestions.map(S=>v.CompletionItem.to(S,c));return new R.CompletionList(h,a.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return v.SignatureHelp.to(a)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,g,c)=>s(h=>new R.CodeLens(v.Range.to(h.range),h.command&&c.fromInternal(h.command)))(a))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>R.Range.isRange(a),a=>R.Selection.isSelection(a)?v.Selection.from(a):v.Range.from(a)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,g,c)=>s(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(h.command)}else{const S=new R.CodeAction(h.title,h.kind?new R.CodeActionKind(h.kind):void 0);return h.edit&&(S.edit=v.WorkspaceEdit.to(h.edit)),h.command&&(S.command=c.fromInternal(h.command)),S.isPreferred=h.isPreferred,S}})(a))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(g=>new R.ColorInformation(v.Range.to(g.range),v.Color.to(g.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",a=>a instanceof R.Color,v.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:v.Range.from(a.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(v.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",a=>a.map(v.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",s(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(g=>v.NotebookExclusiveDocumentPattern.to(g))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(v.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[v.ViewColumn.from(a.viewColumn),v.TextEditorOpenOptions.from(a)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[a,void 0]:[v.ViewColumn.from(a.viewColumn),v.TextEditorOpenOptions.from(a)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[v.ViewColumn.from(a.viewColumn),v.TextEditorOpenOptions.from(a)]).optional()],y.ApiCommandResult.Void)];class P{static register(g){D.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=P;function s(a){return g=>{if(Array.isArray(g))return g.map(a)}}function I(a){if(!Array.isArray(a))return;const g=[];for(const c of a)k.isLocationLink(c)?g.push(v.DefinitionLink.to(c)):g.push(v.location.to(c));return g}}),define(pe[218],ve([0,1,14,50,3,6,2,79,26,18,7,5]),function(Q,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class a{constructor(d,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const i=this._commentControllers.get(n.handle);return i||n}else if(n&&n.$mid===7){const i=this._commentControllers.get(n.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.commentThreadHandle);return r||n}else if(n&&n.$mid===8){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);return r?{thread:r,text:n.text}:n}else if(n&&n.$mid===9){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.commentUniqueId,m=r.getCommentByUniqueId(o);return m||n}else if(n&&n.$mid===10){const i=this._commentControllers.get(n.thread.commentControlHandle);if(!i)return n;const r=i.getCommentThread(n.thread.commentThreadHandle);if(!r)return n;let o=n.text,m=n.commentUniqueId,p=r.getCommentByUniqueId(m);return p?(p.body=o,p):n}return n}})}createCommentController(d,f,t){const n=a.handlePool++,i=new c(d,n,this._proxy,f,t);this._commentControllers.set(i.handle,i);const r=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(d.identifier))||[];return r.push(i),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(d.identifier),r),i}$createCommentThreadTemplate(d,f,t){const n=this._commentControllers.get(d);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(d,f,t){const n=this._commentControllers.get(d);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(d,f){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(d,f,t){const n=this._commentControllers.get(d);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const i=this._documents.getDocument(A.URI.revive(f));return v.asPromise(()=>n.commentingRangeProvider.provideCommentingRanges(i,t)).then(r=>r?r.map(o=>P.Range.from(o)):void 0)}$toggleReaction(d,f,t,n,i){const r=this._commentControllers.get(d);return!r||!r.reactionHandler?Promise.resolve(void 0):v.asPromise(()=>{const o=r.getCommentThread(f);if(o){const m=o.getCommentByUniqueId(n.uniqueIdInThread);if(r!==void 0&&m&&r.reactionHandler)return r.reactionHandler(m,w(i))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=a,a.handlePool=0;class g{constructor(d,f,t,n,i,r,o){this._proxy=d,this._commentController=f,this._id=t,this._uri=n,this._range=i,this._comments=r,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputDisposables.value=new y.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=r}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new y.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};d("range")&&(f.range=P.Range.from(this._range)),d("label")&&(f.label=this.label),d("contextValue")&&(f.contextValue=this.contextValue),d("comments")&&(f.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(f.collapseState=_(this._collapseState)),d("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(d){for(let f of this._commentsMap){let t=f[0],n=f[1];if(d===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,Ve([R.debounce(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class c{constructor(d,f,t,n,i){this._extension=d,this._handle=f,this._proxy=t,this._id=n,this._label=i,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,i)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,f,t,n){if(typeof d=="string"){const i=new g(this._proxy,this,d,f,t,n,this._extension.identifier);return this._threads.set(i.handle,i),i}else{const i=new g(this._proxy,this,void 0,d,f,t,this._extension.identifier);return this._threads.set(i.handle,i),i}}$createCommentThreadTemplate(d,f){const t=new g(this._proxy,this,void 0,A.URI.revive(d),P.Range.to(f),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,f){let t=this._threads.get(d);t&&(t.range=P.Range.to(f))}$deleteCommentThread(d){let f=this._threads.get(d);f&&f.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(u,d,f,t){let n=t.get(f);n||(n=++u.commentHandle,t.set(f,n));const i=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:P.MarkdownString.from(f.body),userName:f.author.name,userIconPath:i,label:f.label,commentReactions:f.reactions?f.reactions.map(r=>S(r)):void 0}}function S(u){return{label:u.label,iconPath:u.iconPath?P.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function _(u){if(u!==void 0)switch(u){case s.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(pe[125],ve([0,1,2,5,7,4,12,15,17,8,9]),function(Q,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(g,c){this._logService=c,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,c){const h=bn._handlePool++;this._provider.set(h,{provider:g,extensionId:c}),this._proxy.$registerDecorationProvider(h,c.value);const S=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(h,null);return}let _=D.asArray(w);if(_.length<=bn._maxEventSize){this._proxy.$onDidChange(h,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,_.length);const u=_.map(t=>({uri:t,rank:P.count(t.path,"/")})),d=D.groupBy(u,(t,n)=>t.rank-n.rank||P.compare(t.uri.path,n.uri.path));let f=[];e:for(let t of d){let n;for(let i of t){let r=s.dirname(i.uri.path);if(n!==r&&(n=r,f.push(i.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(h,f)});return new k.Disposable(()=>{S==null||S.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(g,c,h){if(!this._provider.has(g))return Object.create(null);const S=Object.create(null),{provider:w,extensionId:_}=this._provider.get(g);return await Promise.all(c.map(async u=>{try{const{uri:d,id:f}=u,t=await Promise.resolve(w.provideFileDecoration(v.URI.revive(d),h));if(!t)return;try{k.FileDecoration.validate(t),S[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(d){this._logService.error(d)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([He(0,A.IExtHostRpcService),He(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=y.createDecorator("IExtHostDecorations")}),define(pe[219],ve([0,1,158,113,2,5,7,18,3,15,23]),function(Q,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,h,S,w,_){this._name=c,this._owner=h,this._maxDiagnosticsPerFile=S,this._proxy=w,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,h){if(!c){this.clear();return}this._checkDisposed();let S=[];if(k.URI.isUri(c)){if(!h){this.delete(c);return}this._data.set(c,h.slice()),S=[c]}else if(Array.isArray(c)){S=[];let _;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[d,f]=u;if((!_||d.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=d,S.push(d),this._data.set(d,[])),f){const t=this._data.get(d);t&&t.push(...f)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(S),!this._proxy)return;const w=[];for(let _ of S){let u=[];const d=this._data.get(_);if(d)if(d.length>this._maxDiagnosticsPerFile){u=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of d)if(n.severity===f[t]&&u.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:v.localize(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=d.map(f=>C.Diagnostic.from(f));w.push([_,u])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,h){this._checkDisposed();for(let S of this._data.keys())c.apply(h,[S,this.get(S),this])}get(c){this._checkDisposed();const h=this._data.get(c);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,h){return c[0].toString()<h[0].toString()?-1:c[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=I;let a=class jt{constructor(c,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=c.getProxy(y.MainContext.MainThreadDiagnostics)}static _debouncer(c,h){return c?c.concat(h):h}static _mapper(c){const h=new s.ResourceMap;for(const S of c)h.set(S,S);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(c,h){const{_collections:S,_proxy:w,_onDidChangeDiagnostics:_,_logService:u}=this,d=new class{$changeMany(n,i){w.$changeMany(n,i),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,n,i.length===0?"CLEARING":i)}$clear(n){w.$clear(n),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,n)}dispose(){w.dispose()}};let f;if(!h)h="_generated_diagnostic_collection_name_#"+jt._idPool++,f=h;else if(!S.has(h))f=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do f=h+jt._idPool++;while(S.has(f))}return new class extends I{constructor(){super(h,f,jt._maxDiagnosticsPerFile,d,_);S.set(f,this)}dispose(){super.dispose(),S.delete(f)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const h=new Map,S=[];for(const w of this._collections.values())w.forEach((_,u)=>{let d=h.get(_.toString());typeof d=="undefined"&&(d=S.length,h.set(_.toString(),d),S.push([_,[]])),S[d][1]=S[d][1].concat(...u)});return S}}_getDiagnostics(c){let h=[];for(let S of this._collections.values())S.has(c)&&(h=h.concat(S.get(c)));return h}$acceptMarkersChange(c){if(!this._mirrorCollection){const h="_generated_mirror",S=new I(h,h,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,S),this._mirrorCollection=S}for(const[h,S]of c)this._mirrorCollection.set(k.URI.revive(h),S.map(C.Diagnostic.to))}};a._idPool=0,a._maxDiagnosticsPerFile=1e3,a=Ve([He(1,P.ILogService)],a),e.ExtHostDiagnostics=a}),define(pe[220],ve([0,1,2,5]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(C=>C?C.map(D=>v.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(C=>C?v.URI.revive(C):void 0)}}e.ExtHostDialogs=k}),define(pe[221],ve([0,1,16,2,7,5,10,21,8]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,a,g){this._documentsAndEditors=a,this._logService=g,this._documentContentProviders=new Map,this._proxy=I.getProxy(y.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,a){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const g=P._handlePool++;this._documentContentProviders.set(g,a),this._proxy.$registerTextContentProvider(g,I);let c;return typeof a.onDidChange=="function"&&(c=a.onDidChange(h=>{if(h.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(g,h).then(S=>{if(!S&&typeof S!="string")return;const w=this._documentsAndEditors.getDocument(h);if(!w)return;const _=D.splitLines(S);if(!w.equalLines(_))return this._proxy.$onVirtualDocumentChange(h,S)},v.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,a){const g=this._documentContentProviders.get(I);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(a),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(pe[222],ve([0,1,3,6,2,5,118,18,13,25]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(a,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(a){if(!a)return;const g=this._documentsAndEditors.getDocument(a);if(g)return g}getDocument(a){const g=this.getDocumentData(a);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${a}'`);return g.document}ensureDocumentData(a){const g=this._documentsAndEditors.getDocument(a);if(g)return Promise.resolve(g);let c=this._documentLoader.get(a.toString());return c||(c=this._proxy.$tryOpenDocument(a).then(h=>{this._documentLoader.delete(a.toString());const S=k.URI.revive(h);return D.assertIsDefined(this._documentsAndEditors.getDocument(S))},h=>(this._documentLoader.delete(a.toString()),Promise.reject(h))),this._documentLoader.set(a.toString(),c)),c}createDocumentData(a){return this._proxy.$tryCreateDocument(a).then(g=>k.URI.revive(g))}$acceptModelModeChanged(a,g){const c=k.URI.revive(a),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(g),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(a){const g=k.URI.revive(a),c=this._documentsAndEditors.getDocument(g);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(a,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(a,g){const c=k.URI.revive(a),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(g),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(a,g,c){const h=k.URI.revive(a),S=this._documentsAndEditors.getDocument(h);if(!S)throw new Error("unknown document");S._acceptIsDirty(c),S.onEvents(g),this._onDidChangeDocument.fire(P.deepFreeze({document:S.document,contentChanges:g.changes.map(w=>({range:C.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(a,g){A.setWordDefinitionFor(a,g)}}e.ExtHostDocuments=s}),define(pe[39],ve([0,1,49,3,6,2,4,5,118,12,123,18,15,23,10,71,133]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(d,f){this._extHostRpc=d,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const f=[],t=[],n=[];if(d.removedDocuments)for(const i of d.removedDocuments){const r=y.URI.revive(i),o=this._documents.get(r);(o==null?void 0:o.unref())&&(this._documents.delete(r),f.push(o.value))}if(d.addedDocuments)for(const i of d.addedDocuments){const r=y.URI.revive(i.uri);let o=this._documents.get(r);if(o&&r.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${r} already exists!'`);o||(o=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),r,i.lines,i.EOL,i.versionId,i.modeId,i.isDirty,i.notebook)),this._documents.set(r,o),t.push(o.value)),o.ref()}if(d.removedEditors)for(const i of d.removedEditors){const r=this._editors.get(i);this._editors.delete(i),r&&n.push(r)}if(d.addedEditors)for(const i of d.addedEditors){const r=y.URI.revive(i.documentUri);v.ok(this._documents.has(r),`document '${r}' does not exist`),v.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const o=this._documents.get(r).value,m=new s.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>o.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(p=>I.Range.to(p)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,m)}d.newActiveEditor!==void 0&&(v.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),k.dispose(f),k.dispose(n),d.removedDocuments&&this._onDidRemoveDocuments.fire(f),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var f;return(f=this._documents.get(d))===null||f===void 0?void 0:f.value}allDocuments(){return h.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return d?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};_=Ve([He(0,P.IExtHostRpcService),He(1,a.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(pe[223],ve([0,1,2,5,6,7,18,142,8,22]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const c=this._schemes.indexOf(g);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),c=[];let h,S,w=14,_=14;for(const u of g){let d=h?D.commonPrefixLength(h,u):0;for(d===0?S=1:S=_;d<u.length;d++)d+1===u.length?(w=_,_=9):_+=1,c.push([S,u.toUpperCase().charCodeAt(d),_]),c.push([S,u.toLowerCase().charCodeAt(d),_]),S=_;h=u,_=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new C.StateMachine(c)}}provideDocumentLinks(g){this._initStateMachine();const c=[],h=C.LinkComputer.computeLinks({getLineContent(S){return g.lineAt(S-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const S of h){const w=A.DocumentLink.to(S);w.target&&c.push(w)}return c}}class I{constructor(g,c){this._extHostLanguageFeatures=c,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,c,h,S={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const _=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(_,h),this._enableProposedApi.set(_,w??!1);let u=2;S.isCaseSensitive&&(u+=1024),S.isReadonly&&(u+=2048),typeof h.copy=="function"&&(u+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(_,c,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${c}`),console.error(f)});const d=h.onDidChangeFile(f=>{const t=[];for(const n of f){let{uri:i,type:r}=n;if(i.scheme!==c)continue;let o;switch(r){case y.FileChangeType.Changed:o=0;break;case y.FileChangeType.Created:o=1;break;case y.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:o})}this._proxy.$onFileSystemChange(_,t)});return k.toDisposable(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(_),this._enableProposedApi.delete(_),this._proxy.$unregisterProvider(_)})}static _asIStat(g,c){const{type:h,ctime:S,mtime:w,size:_,permissions:u}=g;return c?{type:h,ctime:S,mtime:w,size:_,permissions:u}:{type:h,ctime:S,mtime:w,size:_}}$stat(g,c){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(c))).then(h=>{var S;return I._asIStat(h,(S=this._enableProposedApi.get(g))!==null&&S!==void 0?S:!1)})}$readdir(g,c){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(c)))}$readFile(g,c){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(c))).then(h=>P.VSBuffer.wrap(h))}$writeFile(g,c,h,S){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(c),h.buffer,S))}$delete(g,c,h){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(c),h))}$rename(g,c,h,S){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(c),v.URI.revive(h),S))}$copy(g,c,h,S){const w=this._getFsProvider(g);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(v.URI.revive(c),v.URI.revive(h),S))}$mkdir(g,c){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(c)))}$watch(g,c,h,S){const w=this._getFsProvider(g).watch(v.URI.revive(h),S);this._watches.set(c,w)}$unwatch(g,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(g,c,h){const S=this._getFsProvider(g);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(v.URI.revive(c),h))}$close(g,c){const h=this._getFsProvider(g);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(g,c,h,S){const w=this._getFsProvider(g);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(S);return Promise.resolve(w.read(c,h,_.buffer,0,S)).then(u=>_.slice(0,u))}$write(g,c,h,S){const w=this._getFsProvider(g);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,h,S.buffer,0,S.byteLength))}_getFsProvider(g){const c=this._fsProvider.get(g);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=I}),define(pe[87],ve([0,1,5,42,7,22,4,12,58]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(I,a){const g=I.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return g.$stat(c).catch(Ut._handleError)},readDirectory(c){return g.$readdir(c).catch(Ut._handleError)},createDirectory(c){return g.$mkdir(c).catch(Ut._handleError)},async readFile(c){return g.$readFile(c).then(h=>h.buffer).catch(Ut._handleError)},writeFile(c,h){return g.$writeFile(c,y.VSBuffer.wrap(h)).catch(Ut._handleError)},delete(c,h){return g.$delete(c,Object.assign({recursive:!1,useTrash:!1},h)).catch(Ut._handleError)},rename(c,h,S){return g.$rename(c,h,Object.assign({overwrite:!1},S)).catch(Ut._handleError)},copy(c,h,S){return g.$copy(c,h,Object.assign({overwrite:!1},S)).catch(Ut._handleError)},isWritableFileSystem(c){const h=a.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};P=Ve([He(0,C.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(pe[224],ve([0,1,6,5]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,A),v.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=k}),define(pe[225],ve([0,1,2,25,18,7,14,5,8,41,17,13,139,6,107,70,83,43,16,3]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(q,J){this._documents=q,this._provider=J}provideDocumentSymbols(q,J){const re=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentSymbols(re,J)).then(ae=>{if(!s.isFalsyOrEmpty(ae))return ae[0]instanceof y.DocumentSymbol?ae.map(k.DocumentSymbol.from):d._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(q){var J;q=q.slice(0).sort((Y,ce)=>{let ge=Y.location.range.start.compareTo(ce.location.range.start);return ge===0&&(ge=ce.location.range.end.compareTo(Y.location.range.end)),ge});const re=[],ae=[];for(const Y of q){const ce={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:((J=Y.tags)===null||J===void 0?void 0:J.map(k.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(ae.length===0){ae.push(ce),re.push(ce);break}const ge=ae[ae.length-1];if(P.Range.containsRange(ge.range,ce.range)&&!P.Range.equalsRange(ge.range,ce.range)){ge.children&&ge.children.push(ce),ae.push(ce);break}ae.pop()}}return re}}class f{constructor(q,J,re){this._documents=q,this._commands=J,this._provider=re,this._cache=new S.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(q,J){const re=this._documents.getDocument(q),ae=await this._provider.provideCodeLenses(re,J);if(!ae||J.isCancellationRequested)return;const Y=this._cache.add(ae),ce=new g.DisposableStore;this._disposables.set(Y,ce);const ge={cacheId:Y,lenses:[]};for(let Re=0;Re<ae.length;Re++)ge.lenses.push({cacheId:[Y,Re],range:k.Range.from(ae[Re].range),command:this._commands.toInternal(ae[Re].command,ce)});return ge}async resolveCodeLens(q,J){var re;const ae=q.cacheId&&this._cache.get(...q.cacheId);if(!ae)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?Y=ae:Y=await this._provider.resolveCodeLens(ae,J),Y||(Y=ae),J.isCancellationRequested)return;const ce=q.cacheId&&this._disposables.get(q.cacheId[0]);if(!!ce)return q.command=this._commands.toInternal((re=Y.command)!==null&&re!==void 0?re:f._badCmd,ce),q}releaseCodeLenses(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ge){return Array.isArray(Ge)?Ge.map(k.DefinitionLink.from):Ge?[k.DefinitionLink.from(Ge)]:[]}class n{constructor(q,J){this._documents=q,this._provider=J}provideDefinition(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDefinition(ae,Y,re)).then(t)}}class i{constructor(q,J){this._documents=q,this._provider=J}provideDeclaration(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDeclaration(ae,Y,re)).then(t)}}class r{constructor(q,J){this._documents=q,this._provider=J}provideImplementation(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideImplementation(ae,Y,re)).then(t)}}class o{constructor(q,J){this._documents=q,this._provider=J}provideTypeDefinition(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideTypeDefinition(ae,Y,re)).then(t)}}class m{constructor(q,J){this._documents=q,this._provider=J}provideHover(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideHover(ae,Y,re)).then(ce=>{if(!(!ce||s.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=ae.getWordRangeAtPosition(Y)),ce.range||(ce.range=new y.Range(Y,Y)),k.Hover.from(ce)})}}class p{constructor(q,J){this._documents=q,this._provider=J}provideEvaluatableExpression(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideEvaluatableExpression(ae,Y,re)).then(ce=>{if(ce)return k.EvaluatableExpression.from(ce)})}}class E{constructor(q,J){this._documents=q,this._provider=J}provideInlineValues(q,J,re,ae){const Y=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideInlineValues(Y,k.Range.to(J),k.InlineValueContext.to(re),ae)).then(ce=>{if(Array.isArray(ce))return ce.map(ge=>k.InlineValue.from(ge))})}}class b{constructor(q,J){this._documents=q,this._provider=J}provideDocumentHighlights(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDocumentHighlights(ae,Y,re)).then(ce=>{if(Array.isArray(ce))return ce.map(k.DocumentHighlight.from)})}}class l{constructor(q,J){this._documents=q,this._provider=J}provideLinkedEditingRanges(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(ae,Y,re)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:s.coalesce(ce.ranges.map(k.Range.from)),wordPattern:ce.wordPattern}})}}class L{constructor(q,J){this._documents=q,this._provider=J}provideReferences(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Position.to(J);return A.asPromise(()=>this._provider.provideReferences(Y,ce,re,ae)).then(ge=>{if(Array.isArray(ge))return ge.map(k.location.from)})}}class O{constructor(q,J,re,ae,Y,ce,ge){this._documents=q,this._commands=J,this._diagnostics=re,this._provider=ae,this._logService=Y,this._extension=ce,this._apiDeprecation=ge,this._cache=new S.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(q,J,re,ae){const Y=this._documents.getDocument(q),ce=a.Selection.isISelection(J)?k.Selection.to(J):k.Range.to(J),ge=[];for(const we of this._diagnostics.getDiagnostics(q))if(ce.intersection(we.range)&&ge.push(we)>O._maxCodeActionsPerFile)break;const Re={diagnostics:ge,only:re.only?new y.CodeActionKind(re.only):void 0,triggerKind:k.CodeActionTriggerKind.to(re.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(Y,ce,Re,ae)).then(we=>{var je;if(!s.isNonEmptyArray(we)||ae.isCancellationRequested)return;const G=this._cache.add(we),ie=new g.DisposableStore;this._disposables.set(G,ie);const Ee=[];for(let Ne=0;Ne<we.length;Ne++){const $e=we[Ne];!$e||(O._isCommand($e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ee.push({_isSynthetic:!0,title:$e.title,command:this._commands.toInternal($e,ie)})):(Re.only&&($e.kind?Re.only.contains($e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${$e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ee.push({cacheId:[G,Ne],title:$e.title,command:$e.command&&this._commands.toInternal($e.command,ie),diagnostics:$e.diagnostics&&$e.diagnostics.map(k.Diagnostic.from),edit:$e.edit&&k.WorkspaceEdit.from($e.edit),kind:$e.kind&&$e.kind.value,isPreferred:$e.isPreferred,disabled:(je=$e.disabled)===null||je===void 0?void 0:je.reason})))}return{cacheId:G,actions:Ee}})}async resolveCodeAction(q,J){var re;const[ae,Y]=q,ce=this._cache.get(ae,Y);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const ge=(re=await this._provider.resolveCodeAction(ce,J))!==null&&re!==void 0?re:ce;return(ge==null?void 0:ge.edit)?k.WorkspaceEdit.from(ge.edit):void 0}releaseCodeActions(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}static _isCommand(q){return typeof q.command=="string"&&typeof q.title=="string"}}O._maxCodeActionsPerFile=1e3;class W{constructor(q,J){this._documents=q,this._provider=J}provideDocumentFormattingEdits(q,J,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(ae,J,re)).then(Y=>{if(Array.isArray(Y))return Y.map(k.TextEdit.from)})}}class Z{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeFormattingEdits(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Range.to(J);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(Y,ce,re,ae)).then(ge=>{if(Array.isArray(ge))return ge.map(k.TextEdit.from)})}}class oe{constructor(q,J){this._documents=q,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(q,J,re,ae,Y){const ce=this._documents.getDocument(q),ge=k.Position.to(J);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,ge,re,ae,Y)).then(Re=>{if(Array.isArray(Re))return Re.map(k.TextEdit.from)})}}class V{constructor(q,J){this._provider=q,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(q,J){const re=C.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(q,J)).then(ae=>{if(s.isNonEmptyArray(ae))for(const Y of ae){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ce=C.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(ce._id,Y),re.symbols.push(ce)}}).then(()=>(re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re))}async resolveWorkspaceSymbol(q,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return q;const re=this._symbolCache.get(q._id);if(re){const ae=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(re,J));return ae&&R.mixin(q,k.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(q){const J=this._resultCache.get(q);if(J){for(let[re,ae]=J;re<=ae;re++)this._symbolCache.delete(re);this._resultCache.delete(q)}}}class ${constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}static supportsResolving(q){return typeof q.prepareRename=="function"}provideRenameEdits(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Position.to(J);return A.asPromise(()=>this._provider.provideRenameEdits(Y,ce,re,ae)).then(ge=>{if(!!ge)return k.WorkspaceEdit.from(ge)},ge=>{const Re=$._asMessage(ge);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ge)})}resolveRenameLocation(q,J,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(q),Y=k.Position.to(J);return A.asPromise(()=>this._provider.prepareRename(ae,Y,re)).then(ce=>{let ge,Re;if(y.Range.isRange(ce)?(ge=ce,Re=ae.getText(ce)):I.isObject(ce)&&(ge=ce.range,Re=ce.placeholder),!!ge){if(ge.start.line>Y.line||ge.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(ge),text:Re}}},ce=>{const ge=$._asMessage(ce);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class j{constructor(q,J){this.resultId=q,this.tokens=J}}class T{constructor(q,J){this._documents=q,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(q,J,re){const ae=this._documents.getDocument(q),Y=J!==0?this._previousResults.get(J):null;return A.asPromise(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,Y.resultId,re):this._provider.provideDocumentSemanticTokens(ae,re)).then(ce=>(Y&&this._previousResults.delete(J),ce?(ce=T._fixProvidedSemanticTokens(ce),this._send(T._convertToEdits(Y,ce),ce)):null))}async releaseDocumentSemanticColoring(q){this._previousResults.delete(q)}static _fixProvidedSemanticTokens(q){return T._isSemanticTokens(q)?T._isCorrectSemanticTokens(q)?q:new y.SemanticTokens(new Uint32Array(q.data),q.resultId):T._isSemanticTokensEdits(q)?T._isCorrectSemanticTokensEdits(q)?q:new y.SemanticTokensEdits(q.edits.map(J=>new y.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),q.resultId):q}static _isSemanticTokens(q){return q&&!!q.data}static _isCorrectSemanticTokens(q){return q.data instanceof Uint32Array}static _isSemanticTokensEdits(q){return q&&Array.isArray(q.edits)}static _isCorrectSemanticTokensEdits(q){for(const J of q.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(q,J){if(!T._isSemanticTokens(J)||!q||!q.tokens)return J;const re=q.tokens,ae=re.length,Y=J.data,ce=Y.length;let ge=0;const Re=Math.min(ae,ce);for(;ge<Re&&re[ge]===Y[ge];)ge++;if(ge===ae&&ge===ce)return new y.SemanticTokensEdits([],J.resultId);let we=0;const je=Re-ge;for(;we<je&&re[ae-we-1]===Y[ce-we-1];)we++;return new y.SemanticTokensEdits([{start:ge,deleteCount:ae-ge-we,data:Y.subarray(ge,ce-we)}],J.resultId)}_send(q,J){if(T._isSemanticTokens(q)){const re=this._nextResultId++;return this._previousResults.set(re,new j(q.resultId,q.data)),c.encodeSemanticTokensDto({id:re,type:"full",data:q.data})}if(T._isSemanticTokensEdits(q)){const re=this._nextResultId++;return T._isSemanticTokens(J)?this._previousResults.set(re,new j(J.resultId,J.data)):this._previousResults.set(re,new j(q.resultId)),c.encodeSemanticTokensDto({id:re,type:"delta",deltas:(q.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=T;class N{constructor(q,J){this._documents=q,this._provider=J}provideDocumentRangeSemanticTokens(q,J,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(ae,k.Range.to(J),re)).then(Y=>Y?this._send(Y):null)}_send(q){return c.encodeSemanticTokensDto({id:0,type:"full",data:q.data})}}e.DocumentRangeSemanticTokensAdapter=N;class F{constructor(q,J,re,ae,Y){this._documents=q,this._commands=J,this._provider=re,this._apiDeprecation=ae,this._extension=Y,this._cache=new S.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}async provideCompletionItems(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Position.to(J),ge=Y.getWordRangeAtPosition(ce)||new y.Range(ce,ce),Re=ge.with({end:ce}),we=new w.StopWatch(!0),je=await A.asPromise(()=>this._provider.provideCompletionItems(Y,ce,ae,k.CompletionContext.to(re)));if(!je||ae.isCancellationRequested)return;const G=Array.isArray(je)?new y.CompletionList(je):je,ie=F.supportsResolving(this._provider)?this._cache.add(G.items):this._cache.add([]),Ee=new g.DisposableStore;this._disposables.set(ie,Ee);const Ne=[],$e={x:ie,b:Ne,a:{replace:k.Range.from(ge),insert:k.Range.from(Re)},c:G.isIncomplete||void 0,d:we.elapsed()};for(let We=0;We<G.items.length;We++){const Xe=G.items[We],De=this._convertCompletionItem(Xe,[ie,We],Re,ge);Ne.push(De)}return $e}async resolveCompletionItem(q,J){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...q);if(!re)return;const ae=await A.asPromise(()=>this._provider.resolveCompletionItem(re,J));if(!!ae)return this._convertCompletionItem(ae,q)}releaseCompletionItems(q){var J;(J=this._disposables.get(q))===null||J===void 0||J.dispose(),this._disposables.delete(q),this._cache.delete(q)}_convertCompletionItem(q,J,re,ae){var Y;const ce=this._disposables.get(J[0]);if(!ce)throw Error("DisposableStore is missing...");const ge={x:J,a:(Y=q.label)!==null&&Y!==void 0?Y:"",o:q.label2,b:q.kind!==void 0?k.CompletionItemKind.from(q.kind):void 0,n:q.tags&&q.tags.map(k.CompletionItemTag.from),c:q.detail,d:typeof q.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters,l:q.additionalTextEdits&&q.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(q.command,ce)};q.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ge.h=q.textEdit.newText):typeof q.insertText=="string"?ge.h=q.insertText:q.insertText instanceof y.SnippetString&&(ge.h=q.insertText.value,ge.i|=4);let Re;return q.textEdit?Re=q.textEdit.range:q.range&&(Re=q.range),y.Range.isRange(Re)?ge.j=k.Range.from(Re):Re&&(!(re==null?void 0:re.isEqual(Re.inserting))||!(ae==null?void 0:ae.isEqual(Re.replacing)))&&(ge.j={insert:k.Range.from(Re.inserting),replace:k.Range.from(Re.replacing)}),ge}}class M{constructor(q,J,re){this._documents=q,this._provider=J,this._commands=re,this._cache=new S.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Position.to(J),ge=await A.asPromise(()=>this._provider.provideInlineCompletionItems(Y,ce,re,ae));if(!ge||ae.isCancellationRequested)return;const Re=this._cache.add(ge.items);let we;return{pid:Re,items:ge.items.map((je,G)=>{let ie;return je.command&&(we||(we=new g.DisposableStore,this._disposables.set(Re,we)),ie=this._commands.toInternal(je.command,we)),{text:je.text,range:je.range?k.Range.from(je.range):void 0,command:ie,idx:G}})}}disposeCompletions(q){this._cache.delete(q);const J=this._disposables.get(q);J&&J.clear(),this._disposables.delete(q)}handleDidShowCompletionItem(q,J){const re=this._cache.get(q,J);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(q){let J=U.map.get(q);return J||(J=new U,U.map.set(q,J)),J}fireOnDidShowCompletionItem(q){this._onDidShowCompletionItemEmitter.fire(q)}}e.InlineCompletionController=U,U.map=new WeakMap;class x{constructor(q,J){this._documents=q,this._provider=J,this._cache=new S.Cache("SignatureHelp")}provideSignatureHelp(q,J,re,ae){const Y=this._documents.getDocument(q),ce=k.Position.to(J),ge=this.reviveContext(re);return A.asPromise(()=>this._provider.provideSignatureHelp(Y,ce,ae,ge)).then(Re=>{if(Re){const we=this._cache.add([Re]);return Object.assign(Object.assign({},k.SignatureHelp.from(Re)),{id:we})}})}reviveContext(q){let J;if(q.activeSignatureHelp){const re=k.SignatureHelp.to(q.activeSignatureHelp),ae=this._cache.get(q.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return Object.assign(Object.assign({},q),{activeSignatureHelp:J})}releaseSignatureHelp(q){this._cache.delete(q)}}class K{constructor(q,J){this._documents=q,this._provider=J}provideInlayHints(q,J,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideInlayHints(ae,k.Range.to(J),re)).then(Y=>Y?{hints:Y.map(k.InlayHint.from)}:void 0)}}class se{constructor(q,J){this._documents=q,this._provider=J,this._cache=new S.Cache("DocumentLink")}provideLinks(q,J){const re=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentLinks(re,J)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(k.DocumentLink.from)};{const Y=this._cache.add(ae),ce={links:[],id:Y};for(let ge=0;ge<ae.length;ge++){const Re=k.DocumentLink.from(ae[ge]);Re.cacheId=[Y,ge],ce.links.push(Re)}return ce}}})}resolveLink(q,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const re=this._cache.get(...q);return re?A.asPromise(()=>this._provider.resolveDocumentLink(re,J)).then(ae=>ae&&k.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(q){this._cache.delete(q)}}class be{constructor(q,J){this._documents=q,this._provider=J}provideColors(q,J){const re=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideDocumentColors(re,J)).then(ae=>Array.isArray(ae)?ae.map(ce=>({color:k.Color.from(ce.color),range:k.Range.from(ce.range)})):[])}provideColorPresentations(q,J,re){const ae=this._documents.getDocument(q),Y=k.Range.to(J.range),ce=k.Color.to(J.color);return A.asPromise(()=>this._provider.provideColorPresentations(ce,{document:ae,range:Y},re)).then(ge=>{if(!!Array.isArray(ge))return ge.map(k.ColorPresentation.from)})}}class Te{constructor(q,J){this._documents=q,this._provider=J}provideFoldingRanges(q,J,re){const ae=this._documents.getDocument(q);return A.asPromise(()=>this._provider.provideFoldingRanges(ae,J,re)).then(Y=>{if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)})}}class Ce{constructor(q,J,re){this._documents=q,this._provider=J,this._logService=re}provideSelectionRanges(q,J,re){const ae=this._documents.getDocument(q),Y=J.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(ae,Y,re)).then(ce=>{if(!s.isNonEmptyArray(ce))return[];if(ce.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Re=0;Re<Y.length;Re++){const we=[];ge.push(we);let je=Y[Re],G=ce[Re];for(;;){if(!G.range.contains(je))throw new Error("INVALID selection range, must contain the previous range");if(we.push(k.SelectionRange.from(G)),!G.parent)break;je=G.range,G=G.parent}}return ge})}}class Fe{constructor(q,J){this._documents=q,this._provider=J,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(q,J,re){const ae=this._documents.getDocument(q),Y=k.Position.to(J),ce=await this._provider.prepareCallHierarchy(ae,Y,re);if(!ce)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ce)?ce.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ce)]}async provideCallsTo(q,J,re){const ae=this._itemFromCache(q,J);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(ae,re);if(!!Y)return Y.map(ce=>({from:this._cacheAndConvertItem(q,ce.from),fromRanges:ce.fromRanges.map(ge=>k.Range.from(ge))}))}async provideCallsFrom(q,J,re){const ae=this._itemFromCache(q,J);if(!ae)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(ae,re);if(!!Y)return Y.map(ce=>({to:this._cacheAndConvertItem(q,ce.to),fromRanges:ce.fromRanges.map(ge=>k.Range.from(ge))}))}releaseSession(q){this._cache.delete(q)}_cacheAndConvertItem(q,J){var re;const ae=this._cache.get(q),Y={_sessionId:q,_itemId:ae.size.toString(36),name:J.name,detail:J.detail,kind:k.SymbolKind.from(J.kind),uri:J.uri,range:k.Range.from(J.range),selectionRange:k.Range.from(J.selectionRange),tags:(re=J.tags)===null||re===void 0?void 0:re.map(k.SymbolTag.from)};return ae.set(Y._itemId,J),Y}_itemFromCache(q,J){const re=this._cache.get(q);return re==null?void 0:re.get(J)}}class qe{constructor(q,J){this.adapter=q,this.extension=J}}class ze{constructor(q,J,re,ae,Y,ce,ge){this._adapter=new Map,this._uriTransformer=J,this._proxy=q.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ae,this._diagnostics=Y,this._logService=ce,this._apiDeprecation=ge}_transformDocumentSelector(q){return s.coalesce(s.asArray(q).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(q){if(typeof q=="string")return{$serialized:!0,language:q};if(q)return{$serialized:!0,language:q.language,scheme:this._transformScheme(q.scheme),pattern:typeof q.pattern=="undefined"?void 0:k.GlobPattern.from(q.pattern),exclusive:q.exclusive}}_transformScheme(q){return this._uriTransformer&&typeof q=="string"?this._uriTransformer.transformOutgoingScheme(q):q}_createDisposable(q){return new y.Disposable(()=>{this._adapter.delete(q),this._proxy.$unregister(q)})}_nextHandle(){return ze._handlePool++}_withAdapter(q,J,re,ae,Y=!1){const ce=this._adapter.get(q);if(!ce)return Promise.resolve(ae);if(ce.adapter instanceof J){let ge;ce.extension&&(ge=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.name}'`));const Re=re(ce.adapter,ce.extension),we=ce.extension;return we&&Promise.resolve(Re).then(()=>this._logService.trace(`[${we.identifier.value}] provider DONE after ${Date.now()-ge}ms`),je=>{Y&&je instanceof _.CancellationError||(this._logService.error(`[${we.identifier.value}] provider FAILED`),this._logService.error(je))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(q,J){const re=this._nextHandle();return this._adapter.set(re,new qe(q,J)),re}static _extLabel(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,J,re,ae){const Y=this._addNewAdapter(new d(this._documents,re),q),ce=ae&&ae.label||ze._extLabel(q);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(J),ce),this._createDisposable(Y)}$provideDocumentSymbols(q,J,re){return this._withAdapter(q,d,ae=>ae.provideDocumentSymbols(v.URI.revive(J),re),void 0)}registerCodeLensProvider(q,J,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new f(this._documents,this._commands.converter,re),q)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const ge=re.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(Y));ce=y.Disposable.from(ce,ge)}return ce}$provideCodeLenses(q,J,re){return this._withAdapter(q,f,ae=>ae.provideCodeLenses(v.URI.revive(J),re),void 0)}$resolveCodeLens(q,J,re){return this._withAdapter(q,f,ae=>ae.resolveCodeLens(J,re),void 0)}$releaseCodeLenses(q,J){this._withAdapter(q,f,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(q,J,re){const ae=this._addNewAdapter(new n(this._documents,re),q);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDefinition(q,J,re,ae){return this._withAdapter(q,n,Y=>Y.provideDefinition(v.URI.revive(J),re,ae),[])}registerDeclarationProvider(q,J,re){const ae=this._addNewAdapter(new i(this._documents,re),q);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDeclaration(q,J,re,ae){return this._withAdapter(q,i,Y=>Y.provideDeclaration(v.URI.revive(J),re,ae),[])}registerImplementationProvider(q,J,re){const ae=this._addNewAdapter(new r(this._documents,re),q);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideImplementation(q,J,re,ae){return this._withAdapter(q,r,Y=>Y.provideImplementation(v.URI.revive(J),re,ae),[])}registerTypeDefinitionProvider(q,J,re){const ae=this._addNewAdapter(new o(this._documents,re),q);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideTypeDefinition(q,J,re,ae){return this._withAdapter(q,o,Y=>Y.provideTypeDefinition(v.URI.revive(J),re,ae),[])}registerHoverProvider(q,J,re,ae){const Y=this._addNewAdapter(new m(this._documents,re),q);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideHover(q,J,re,ae){return this._withAdapter(q,m,Y=>Y.provideHover(v.URI.revive(J),re,ae),void 0)}registerEvaluatableExpressionProvider(q,J,re,ae){const Y=this._addNewAdapter(new p(this._documents,re),q);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideEvaluatableExpression(q,J,re,ae){return this._withAdapter(q,p,Y=>Y.provideEvaluatableExpression(v.URI.revive(J),re,ae),void 0)}registerInlineValuesProvider(q,J,re,ae){const Y=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new E(this._documents,re),q);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(J),Y);let ge=this._createDisposable(ce);if(Y!==void 0){const Re=re.onDidChangeInlineValues(we=>this._proxy.$emitInlineValuesEvent(Y));ge=y.Disposable.from(ge,Re)}return ge}$provideInlineValues(q,J,re,ae,Y){return this._withAdapter(q,E,ce=>ce.provideInlineValues(v.URI.revive(J),re,ae,Y),void 0)}registerDocumentHighlightProvider(q,J,re){const ae=this._addNewAdapter(new b(this._documents,re),q);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentHighlights(q,J,re,ae){return this._withAdapter(q,b,Y=>Y.provideDocumentHighlights(v.URI.revive(J),re,ae),void 0)}registerLinkedEditingRangeProvider(q,J,re){const ae=this._addNewAdapter(new l(this._documents,re),q);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideLinkedEditingRanges(q,J,re,ae){return this._withAdapter(q,l,async Y=>{const ce=await Y.provideLinkedEditingRanges(v.URI.revive(J),re,ae);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(q,J,re){const ae=this._addNewAdapter(new L(this._documents,re),q);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideReferences(q,J,re,ae,Y){return this._withAdapter(q,L,ce=>ce.provideReferences(v.URI.revive(J),re,ae,Y),void 0)}registerCodeActionProvider(q,J,re,ae){var Y,ce;const ge=new g.DisposableStore,Re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,re,this._logService,q,this._apiDeprecation),q);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(J),{providedKinds:(Y=ae==null?void 0:ae.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(we=>we.value),documentation:(ce=ae==null?void 0:ae.documentation)===null||ce===void 0?void 0:ce.map(we=>({kind:we.kind.value,command:this._commands.converter.toInternal(we.command,ge)}))},ze._extLabel(q),Boolean(re.resolveCodeAction)),ge.add(this._createDisposable(Re)),ge}$provideCodeActions(q,J,re,ae,Y){return this._withAdapter(q,O,ce=>ce.provideCodeActions(v.URI.revive(J),re,ae,Y),void 0)}$resolveCodeAction(q,J,re){return this._withAdapter(q,O,ae=>ae.resolveCodeAction(J,re),void 0)}$releaseCodeActions(q,J){this._withAdapter(q,O,re=>Promise.resolve(re.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(q,J,re){const ae=this._addNewAdapter(new W(this._documents,re),q);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(q,J,re,ae){return this._withAdapter(q,W,Y=>Y.provideDocumentFormattingEdits(v.URI.revive(J),re,ae),void 0)}registerDocumentRangeFormattingEditProvider(q,J,re){const ae=this._addNewAdapter(new Z(this._documents,re),q);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(J),q.identifier,q.displayName||q.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(q,J,re,ae,Y){return this._withAdapter(q,Z,ce=>ce.provideDocumentRangeFormattingEdits(v.URI.revive(J),re,ae,Y),void 0)}registerOnTypeFormattingEditProvider(q,J,re,ae){const Y=this._addNewAdapter(new oe(this._documents,re),q);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(J),ae,q.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(q,J,re,ae,Y,ce){return this._withAdapter(q,oe,ge=>ge.provideOnTypeFormattingEdits(v.URI.revive(J),re,ae,Y,ce),void 0)}registerWorkspaceSymbolProvider(q,J){const re=this._addNewAdapter(new V(J,this._logService),q);return this._proxy.$registerNavigateTypeSupport(re),this._createDisposable(re)}$provideWorkspaceSymbols(q,J,re){return this._withAdapter(q,V,ae=>ae.provideWorkspaceSymbols(J,re),{symbols:[]})}$resolveWorkspaceSymbol(q,J,re){return this._withAdapter(q,V,ae=>ae.resolveWorkspaceSymbol(J,re),void 0)}$releaseWorkspaceSymbols(q,J){this._withAdapter(q,V,re=>re.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(q,J,re){const ae=this._addNewAdapter(new $(this._documents,re,this._logService),q);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(J),$.supportsResolving(re)),this._createDisposable(ae)}$provideRenameEdits(q,J,re,ae,Y){return this._withAdapter(q,$,ce=>ce.provideRenameEdits(v.URI.revive(J),re,ae,Y),void 0)}$resolveRenameLocation(q,J,re,ae){return this._withAdapter(q,$,Y=>Y.resolveRenameLocation(v.URI.revive(J),re,ae),void 0)}registerDocumentSemanticTokensProvider(q,J,re,ae){const Y=this._nextHandle(),ce=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new qe(new T(this._documents,re),q)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(J),ae,ce);let ge=this._createDisposable(Y);if(ce){const Re=re.onDidChangeSemanticTokens(we=>this._proxy.$emitDocumentSemanticTokensEvent(ce));ge=y.Disposable.from(ge,Re)}return ge}$provideDocumentSemanticTokens(q,J,re,ae){return this._withAdapter(q,T,Y=>Y.provideDocumentSemanticTokens(v.URI.revive(J),re,ae),null,!0)}$releaseDocumentSemanticTokens(q,J){this._withAdapter(q,T,re=>re.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(q,J,re,ae){const Y=this._addNewAdapter(new N(this._documents,re),q);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(J),ae),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(q,J,re,ae){return this._withAdapter(q,N,Y=>Y.provideDocumentRangeSemanticTokens(v.URI.revive(J),re,ae),null,!0)}registerCompletionItemProvider(q,J,re,ae){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,re,this._apiDeprecation,q),q);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(J),ae,F.supportsResolving(re),`${q.identifier.value}(${ae.join("")})`),this._createDisposable(Y)}$provideCompletionItems(q,J,re,ae,Y){return this._withAdapter(q,F,ce=>ce.provideCompletionItems(v.URI.revive(J),re,ae,Y),void 0)}$resolveCompletionItem(q,J,re){return this._withAdapter(q,F,ae=>ae.resolveCompletionItem(J,re),void 0)}$releaseCompletionItems(q,J){this._withAdapter(q,F,re=>re.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(q,J,re){const ae=this._addNewAdapter(new M(this._documents,re,this._commands.converter),q);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideInlineCompletions(q,J,re,ae,Y){return this._withAdapter(q,M,ce=>ce.provideInlineCompletions(v.URI.revive(J),re,ae,Y),void 0)}$handleInlineCompletionDidShow(q,J,re){this._withAdapter(q,M,async ae=>{ae.handleDidShowCompletionItem(J,re)},void 0)}$freeInlineCompletionsList(q,J){this._withAdapter(q,M,async re=>{re.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(q,J,re,ae){const Y=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ce=this._addNewAdapter(new x(this._documents,re),q);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(J),Y),this._createDisposable(ce)}$provideSignatureHelp(q,J,re,ae,Y){return this._withAdapter(q,x,ce=>ce.provideSignatureHelp(v.URI.revive(J),re,ae,Y),void 0)}$releaseSignatureHelp(q,J){this._withAdapter(q,x,re=>re.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(q,J,re){const ae=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new K(this._documents,re),q);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(J),ae);let ce=this._createDisposable(Y);if(ae!==void 0){const ge=re.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(ae));ce=y.Disposable.from(ce,ge)}return ce}$provideInlayHints(q,J,re,ae){return this._withAdapter(q,K,Y=>Y.provideInlayHints(v.URI.revive(J),re,ae),void 0)}registerDocumentLinkProvider(q,J,re){const ae=this._addNewAdapter(new se(this._documents,re),q);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(J),typeof re.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(q,J,re){return this._withAdapter(q,se,ae=>ae.provideLinks(v.URI.revive(J),re),void 0)}$resolveDocumentLink(q,J,re){return this._withAdapter(q,se,ae=>ae.resolveLink(J,re),void 0)}$releaseDocumentLinks(q,J){this._withAdapter(q,se,re=>re.releaseLinks(J),void 0)}registerColorProvider(q,J,re){const ae=this._addNewAdapter(new be(this._documents,re),q);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideDocumentColors(q,J,re){return this._withAdapter(q,be,ae=>ae.provideColors(v.URI.revive(J),re),[])}$provideColorPresentations(q,J,re,ae){return this._withAdapter(q,be,Y=>Y.provideColorPresentations(v.URI.revive(J),re,ae),void 0)}registerFoldingRangeProvider(q,J,re){const ae=this._nextHandle(),Y=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new qe(new Te(this._documents,re),q)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(J),Y);let ce=this._createDisposable(ae);if(Y!==void 0){const ge=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ce=y.Disposable.from(ce,ge)}return ce}$provideFoldingRanges(q,J,re,ae){return this._withAdapter(q,Te,Y=>Y.provideFoldingRanges(v.URI.revive(J),re,ae),void 0)}registerSelectionRangeProvider(q,J,re){const ae=this._addNewAdapter(new Ce(this._documents,re,this._logService),q);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$provideSelectionRanges(q,J,re,ae){return this._withAdapter(q,Ce,Y=>Y.provideSelectionRanges(v.URI.revive(J),re,ae),[])}registerCallHierarchyProvider(q,J,re){const ae=this._addNewAdapter(new Fe(this._documents,re),q);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(J)),this._createDisposable(ae)}$prepareCallHierarchy(q,J,re,ae){return this._withAdapter(q,Fe,Y=>Promise.resolve(Y.prepareSession(v.URI.revive(J),re,ae)),void 0)}$provideCallHierarchyIncomingCalls(q,J,re,ae){return this._withAdapter(q,Fe,Y=>Y.provideCallsTo(J,re,ae),void 0)}$provideCallHierarchyOutgoingCalls(q,J,re,ae){return this._withAdapter(q,Fe,Y=>Y.provideCallsFrom(J,re,ae),void 0)}$releaseCallHierarchy(q,J){this._withAdapter(q,Fe,re=>Promise.resolve(re.releaseSession(J)),void 0)}static _serializeRegExp(q){return{pattern:q.source,flags:D.regExpFlags(q)}}static _serializeIndentationRule(q){return{decreaseIndentPattern:ze._serializeRegExp(q.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?ze._serializeRegExp(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?ze._serializeRegExp(q.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(q){return{beforeText:ze._serializeRegExp(q.beforeText),afterText:q.afterText?ze._serializeRegExp(q.afterText):void 0,previousLineText:q.previousLineText?ze._serializeRegExp(q.previousLineText):void 0,action:q.action}}static _serializeOnEnterRules(q){return q.map(ze._serializeOnEnterRule)}setLanguageConfiguration(q,J,re){let{wordPattern:ae}=re;if(ae&&D.regExpLeadsToEndlessLoop(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(J,ae):this._documents.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const Y=this._nextHandle(),ce={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?ze._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?ze._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?ze._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,J,ce),this._createDisposable(Y)}$setWordDefinitions(q){for(const J of q)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(pe[226],ve([0,1,5,18,7]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(C,D){this._proxy=C.getProxy(v.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const P=this._documents.getDocumentData(C);if(!P)throw new Error(`document '${C.toString}' NOT found`);return P.document}async tokenAtPosition(C,D){var P;const s=C.version,I=R.Position.from(D),a=await this._proxy.$tokensAtPosition(C.uri,I),g={type:k.StandardTokenType.Other,range:(P=C.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new k.Range(D.line,D.character,D.line,D.character)};if(!a)return g;const c={range:R.Range.to(a.range),type:R.TokenType.to(a.type)};return!c.range.contains(D)||s!==C.version?g:c}}e.ExtHostLanguages=y}),define(pe[227],ve([0,1,5,15,35]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function y(C){return C&&C.title}let A=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(v.MainContext.MainThreadMessageService)}showMessage(D,P,s,I,a){const g={extension:D};let c;typeof I=="string"||y(I)?c=[I,...a]:(g.modal=I&&I.modal,g.useCustom=I&&I.useCustom,c=a),g.useCustom&&k.checkProposedApiEnabled(D);const h=[];for(let S=0;S<c.length;S++){const w=c[S];if(typeof w=="string")h.push({title:w,handle:S,isCloseAffordance:!1});else if(typeof w=="object"){let{title:_,isCloseAffordance:u}=w;h.push({title:_,isCloseAffordance:!!u,handle:S})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,s,g,h).then(S=>{if(typeof S=="number")return c[S]})}};A=Ve([He(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(pe[228],ve([0,1,22,3,74,70,6,23,8,13,2,83,5,18,7,60,205,122]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(f,t){const n=_._Keys.nextId();f.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){f.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=_,_._Keys=new y.IdGenerator("NotebookEditorDecorationType");class u{constructor(f,t,n,i,r,o){this._textDocumentsAndEditors=n,this._textDocuments=i,this.logService=r,this._extensionStoragePaths=o,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(a.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(a.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(a.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:m=>{var p;if(m&&m.$mid===12){const E=(p=m.notebookEditor)===null||p===void 0?void 0:p.notebookUri,b=m.cell.handle,l=this._documents.get(E),L=l==null?void 0:l.getCell(b);if(L)return L.apiCell}return m}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,n]of this._editors)if(n.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const n=this._documents.get(f);if(!n&&!t)throw new Error(`NO notebook document for '${f}'`);return n}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,n,i,r){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:n});let o;return n.onDidChangeNotebookContentOptions&&(o=n.onDidChangeNotebookContentOptions(()=>{const m=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,m)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(i),u._convertNotebookRegistrationData(f,r)),new c.Disposable(()=>{o==null||o.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const n=t.filenamePattern.map(i=>g.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,n){const i=u._notebookStatusBarItemProviderHandlePool++,r=typeof n.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,r,t);let o;return r!==void 0&&(o=n.onDidChangeCellStatusBarItems(m=>this._notebookProxy.$emitCellStatusBarEvent(r))),new c.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,r),o&&o.dispose()})}createNotebookEditorDecorationType(f){return new _(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&g.NotebookData.from(f.content)});return s.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(f),i=this._documents.get(s.URI.revive(n));return P.assertIsDefined(i==null?void 0:i.apiNotebook)}async showNotebookDocument(f,t){var n;s.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let i;typeof t=="object"?i={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:i={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,i),o=r&&((n=this._editors.get(r))===null||n===void 0?void 0:n.apiEditor);if(o)return o;throw r?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,n,i){var r;const o=this._notebookStatusBarItemProviders.get(f),m=s.URI.revive(t),p=this._documents.get(m);if(!p||!o)return;const E=p.getCellFromIndex(n);if(!E)return;const b=await o.provideCellStatusBarItems(E.apiCell,i);if(!b)return;const l=new A.DisposableStore,L=this._statusBarCache.add([l]),O=(r=b&&b.map(W=>g.NotebookStatusBarItem.from(W,this._commandsConverter,l)))!==null&&r!==void 0?r:void 0;return{cacheId:L,items:O}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,n,i,r){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,n),this._notebookProxy.$registerNotebookSerializer(o,{id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(i),u._convertNotebookRegistrationData(f,r)),A.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(f,t,n){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const r=await i.deserializeNotebook(t.buffer,n);return g.NotebookData.from(r)}async $notebookToData(f,t,n){const i=this._notebookSerializer.get(f);if(!i)throw new Error("NO serializer found");const r=await i.serializeNotebook(g.NotebookData.to(t),n);return v.VSBuffer.wrap(r)}async $openNotebook(f,t,n,i,r){const{provider:o}=this._getProviderData(f),m=await o.openNotebook(s.URI.revive(t),{backupId:n,untitledDocumentData:i==null?void 0:i.buffer},r);return{metadata:g.NotebookDocumentMetadata.from(m.metadata),cells:m.cells.map(g.NotebookCellData.from)}}async $saveNotebook(f,t,n){const i=this.getNotebookDocument(s.URI.revive(t)),{provider:r}=this._getProviderData(f);return await r.saveNotebook(i.apiNotebook,n),!0}async $saveNotebookAs(f,t,n,i){const r=this.getNotebookDocument(s.URI.revive(t)),{provider:o}=this._getProviderData(f);return await o.saveNotebookAs(s.URI.revive(n),r.apiNotebook,i),!0}async $backupNotebook(f,t,n){var i;const r=this.getNotebookDocument(s.URI.revive(t)),o=this._getProviderData(f),m=(i=this._extensionStoragePaths.workspaceValue(o.extension))!==null&&i!==void 0?i:this._extensionStoragePaths.globalValue(o.extension),p=String(k.hash([r.uri.toString(),this._backupIdPool++])),E=s.URI.joinPath(m,p),b=await o.provider.backupNotebook(r.apiNotebook,{destination:E},n);return r.updateBackup(b),b.id}$acceptModelChanged(f,t,n){this.getNotebookDocument(s.URI.revive(f)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(f,t){const n=this.getNotebookDocument(s.URI.revive(f));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(s.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const n=this._editors.get(f);if(!n)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const n=this.getNotebookDocument(s.URI.revive(f));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(f,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const i=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,i)}$acceptDocumentAndEditorsDelta(f){var t,n,i;if(f.removedDocuments)for(const o of f.removedDocuments){const m=s.URI.revive(o),p=this._documents.get(m);p&&(p.dispose(),this._documents.delete(m),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const E of this._editors.values())E.notebookData.uri.toString()===m.toString()&&this._editors.delete(E.id)}if(f.addedDocuments){const o=[];for(const m of f.addedDocuments){const p=s.URI.revive(m.uri),E=m.viewType;if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const b=this,l=new S.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(L){b._onDidChangeNotebookCells.fire(L)},emitCellOutputsChange(L){b._onDidChangeCellOutputs.fire(L)},emitCellMetadataChange(L){b._onDidChangeCellMetadata.fire(L)},emitCellExecutionStateChange(L){b._onDidChangeCellExecutionState.fire(L)}},E,m.metadata?g.NotebookDocumentMetadata.to(m.metadata):new c.NotebookDocumentMetadata,p);l.acceptModelChanged({versionId:m.versionId,rawEvents:[{kind:h.NotebookCellsChangeType.Initialize,changes:[[0,0,m.cells]]}]},!1),o.push(...m.cells.map(L=>S.ExtHostCell.asModelAddData(l.apiNotebook,L))),(t=this._documents.get(p))===null||t===void 0||t.dispose(),this._documents.set(p,l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this._onDidOpenNotebookDocument.fire(l.apiNotebook)}}if(f.addedEditors)for(const o of f.addedEditors){if(this._editors.has(o.id))return;const m=s.URI.revive(o.documentUri),p=this._documents.get(m);p&&this._createExtHostEditor(p,o.id,o)}const r=[];if(f.removedEditors)for(const o of f.removedEditors){const m=this._editors.get(o);m&&(this._editors.delete(o),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===m.id&&(this._activeNotebookEditor=void 0),r.push(m))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(m=>this._editors.get(m)).filter(m=>!!m);const o=new Set;this._visibleNotebookEditors.forEach(m=>o.add(m.id));for(const m of this._editors.values()){const p=o.has(m.id);m._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(m=>m).filter(m=>m.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(pe[229],ve([0,1,3,6,5,26,2,18,85,23,14,60,21,17,15,7,35]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,n,i,r){this._mainContext=t,this._initData=n,this._extHostNotebook=i,this._logService=r,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,n,i,r,o,m){for(let F of this._kernelData.values())if(F.controller.id===n&&y.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const p=this._handlePool++,E=this;this._logService.trace(`NotebookController[${p}], CREATED by ${t.identifier.value}, ${n}`);const b=()=>console.warn(`NO execute handler from notebook controller '${Z.id}' of extension: '${t.identifier}'`);let l=!1;const L=new R.DisposableStore,O=new v.Emitter,W=new v.Emitter,Z={id:`${t.identifier.value}/${n}`,notebookType:i,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:r||t.identifier.value,preloads:m?m.map(C.NotebookRendererScript.from):[]};let oe=o??b,V;this._proxy.$addKernel(p,Z).catch(F=>{console.log(F),l=!0});let $=0;const j=()=>{if(l)return;const F=++$;Promise.resolve().then(()=>{F===$&&this._proxy.$updateKernel(p,Z)})},T=new P.ResourceMap,N={get id(){return n},get viewType(){return Z.notebookType},get notebookType(){return Z.notebookType},onDidChangeNotebookAssociation:O.event,get label(){return Z.label},set label(F){var M;Z.label=(M=F??t.displayName)!==null&&M!==void 0?M:t.name,j()},get detail(){var F;return(F=Z.detail)!==null&&F!==void 0?F:""},set detail(F){Z.detail=F,j()},get description(){var F;return(F=Z.description)!==null&&F!==void 0?F:""},set description(F){Z.description=F,j()},get supportedLanguages(){return Z.supportedLanguages},set supportedLanguages(F){Z.supportedLanguages=F,j()},get hasExecutionOrder(){var F;return(F=Z.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set hasExecutionOrder(F){Z.supportsExecutionOrder=F,j()},get supportsExecutionOrder(){var F;return(F=Z.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set supportsExecutionOrder(F){Z.supportsExecutionOrder=F,j()},get rendererScripts(){return Z.preloads?Z.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return oe},set executeHandler(F){oe=F??b},get interruptHandler(){return V},set interruptHandler(F){V=F,Z.supportsInterrupt=Boolean(F),j()},createNotebookCellExecution(F){if(l)throw new Error("notebook controller is DISPOSED");if(!T.has(F.notebook.uri))throw E._logService.trace(`NotebookController[${p}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return E._createNotebookCellExecution(F)},dispose:()=>{l||(this._logService.trace(`NotebookController[${p}], DISPOSED`),l=!0,this._kernelData.delete(p),L.dispose(),O.dispose(),W.dispose(),this._proxy.$removeKernel(p))},updateNotebookAffinity(F,M){E._proxy.$updateNotebookPriority(p,F.uri,M)},onDidReceiveMessage:W.event,postMessage(F,M){return S.checkProposedApiEnabled(t),E._proxy.$postMessage(p,M&&E._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return S.checkProposedApiEnabled(t),D.asWebviewUri(F,E._initData.remote)}};return this._kernelData.set(p,{extensionId:t.identifier,controller:N,onDidReceiveMessage:W,onDidChangeSelection:O,associatedNotebooks:T}),N}$acceptNotebookAssociation(t,n,i){const r=this._kernelData.get(t);if(r){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(n));i?r.associatedNotebooks.set(o.uri,!0):r.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),i),r.onDidChangeSelection.fire({selected:i,notebook:o.apiNotebook})}}async $executeCells(t,n,i){const r=this._kernelData.get(t);if(!r)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(n)),m=[];for(let p of i){const E=o.getCell(p);E&&m.push(E.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),m.length),await r.controller.executeHandler.call(r.controller,m,o.apiNotebook,r.controller)}catch(p){this._logService.error(`NotebookController[${t}] execute cells FAILED`,p),console.error(p)}}async $cancelCells(t,n,i){var r;const o=this._kernelData.get(t);if(!o)return;const m=this._extHostNotebook.getNotebookDocument(A.URI.revive(n));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,m.apiNotebook);else for(let p of i){const E=m.getCell(p);E&&((r=this._activeExecutions.get(E.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(t,n,i){const r=this._kernelData.get(t);if(!r)return;const o=this._extHostNotebook.getEditorById(n);if(!o)throw new Error(`send message for UNKNOWN editor: ${n}`);r.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:i}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const r=new u(i.notebook,i,this._mainContext.getProxy(k.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(i.uri,r);const o=r.onDidChangeState(()=>{r.state===_.Resolved&&(r.dispose(),o.dispose(),this._activeExecutions.delete(i.uri))});return r.asApiObject()}};w=Ve([He(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var _;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(_||(_={}));class u extends R.Disposable{constructor(t,n,i){super();this._document=t,this._cell=n,this._proxy=i,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=_.Init,this._tokenSource=this._register(new a.CancellationTokenSource),this._collector=new d(10,r=>this.applyEdits(r)),this._executionOrder=n.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyEdits(this._document.uri,t,!1)}verifyStateForOutput(){if(this._state===_.Init)throw new Error("Must call start before modifying cell output");if(this._state===_.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const n={editType:9,handle:this._cell.handle,internalMetadata:t};this.applyEdits([n])}cellIndexToHandle(t){let n=this._cell;if(typeof t=="number"?n=this._document.getCellFromIndex(t):t&&(n=this._document.getCellFromApiCell(t)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(t){return t.map(n=>{const i=h.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return i===n.items?C.NotebookCellOutput.from(n):C.NotebookCellOutput.from({items:i,id:n.id,metadata:n.metadata})})}async updateOutputs(t,n,i){const r=this.cellIndexToHandle(n),o=this.validateAndConvertOutputs(g.asArray(t));return this.applyEditSoon({editType:2,handle:r,append:i,outputs:o})}async updateOutputItems(t,n,i){return h.NotebookCellOutput.isNotebookCellOutput(n)&&(n=n.id),t=h.NotebookCellOutput.ensureUniqueMimeTypes(g.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(C.NotebookCellOutputItem.from),outputId:n,append:i})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(i){t._executionOrder=i,t.mixinMetadata({executionOrder:i})},start(i){var r;if(t._state===_.Resolved||t._state===_.Started)throw new Error("Cannot call start again");t._state=_.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:(r=i==null?void 0:i.startTime)!==null&&r!==void 0?r:null})},end(i){var r,o;if(t._state===_.Resolved)throw new Error("Cannot call resolve twice");t._state=_.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:(r=i==null?void 0:i.success)!==null&&r!==void 0?r:null,runEndTime:(o=i==null?void 0:i.endTime)!==null&&o!==void 0?o:null})},clearOutput(i){return t.verifyStateForOutput(),t.updateOutputs([],i,!1)},async appendOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!0)},async replaceOutput(i,r){return t.verifyStateForOutput(),t.updateOutputs(i,r,!1)},async appendOutputItems(i,r){t.verifyStateForOutput(),t.updateOutputItems(i,r,!0)},async replaceOutputItems(i,r){t.verifyStateForOutput(),t.updateOutputItems(i,r,!1)}})}}class d{constructor(t,n){this.delay=t,this.callback=n,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=s.timeout(this.delay).then(()=>{this.waitPromise=void 0;const n=this.batch;return this.batch=[],this.callback(n)})),this.waitPromise}}}),define(pe[230],ve([0,1,3,5,122]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class y{constructor(C,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,D,P){var s;const I=this._extHostNotebook.getEditorById(C);!I||(s=this._rendererMessageEmitters.get(D))===null||s===void 0||s.fire({editor:I.apiEditor,message:P})}createRendererMessaging(C){return{onDidReceiveMessage:(...P)=>this.getOrCreateEmitterFor(C).event(...P),postMessage:(P,s)=>{const I=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,C,s)}}}getOrCreateEmitterFor(C){let D=this._rendererMessageEmitters.get(C);return D||(D=new v.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,D),D)}}e.ExtHostNotebookRenderers=y}),define(pe[62],ve([0,1,5,3,6,22,4,12]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends k.Disposable{constructor(c,h,S,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,h,S),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?y.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(h=>this._proxy.$clear(h,c))}show(c,h){this.validate(),this._id.then(S=>this._proxy.$reveal(S,!!(typeof c=="boolean"?c:h)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(c,h){super(c,!1,void 0,h)}append(c){super.append(c),this._id.then(h=>this._proxy.$append(h,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class s extends D{constructor(c,h,S){super(c,!0,h,S)}append(c){throw new Error("Not supported")}}class I{constructor(c,h){this.name=c,this._channel=h}append(c){this._channel.then(h=>h.append(c))}appendLine(c){this._channel.then(h=>h.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,h){this._channel.then(S=>S.show(c,h))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let a=class{constructor(c){this._proxy=c.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new P(c,this._proxy)}createOutputChannelFromLogFile(c,h){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new s(c,h,this._proxy)}};a=Ve([He(0,C.IExtHostRpcService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(pe[231],ve([0,1,14,21,3,6,5,2,7,16,17,52]),function(Q,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function a(g,c,h){const S=g.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(r,o){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=o}showQuickPick(r,o,m,p=R.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(r),b=++this._instances,l=S.$show(b,{title:m==null?void 0:m.title,placeHolder:m==null?void 0:m.placeHolder,matchOnDescription:m==null?void 0:m.matchOnDescription,matchOnDetail:m==null?void 0:m.matchOnDetail,ignoreFocusLost:m==null?void 0:m.ignoreFocusOut,canPickMany:m==null?void 0:m.canPickMany},p),L={},O=l.then(()=>L);return Promise.race([O,E]).then(W=>{if(W!==L)return E.then(Z=>{const oe=[];for(let V=0;V<Z.length;V++){const $=Z[V];let j,T,N,F,M;typeof $=="string"?j=$:(j=$.label,T=$.description,N=$.detail,F=$.picked,M=$.alwaysShow),oe.push({label:j,description:T,handle:V,detail:N,picked:F,alwaysShow:M})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{m.onDidSelectItem(Z[V])}),S.$setItems(b,oe),l.then(V=>{if(typeof V=="number")return Z[V];if(Array.isArray(V))return V.map($=>Z[$])})})}).then(void 0,W=>{if(!P.isPromiseCanceledError(W))return S.$setError(b,W),Promise.reject(W)})}$onItemSelected(r){this._onDidSelectItem&&this._onDidSelectItem(r)}showInput(r,o=R.CancellationToken.None){return this._validateInput=r?r.validateInput:void 0,S.$input(r,typeof this._validateInput=="function",o).then(void 0,m=>{if(!P.isPromiseCanceledError(m))return Promise.reject(m)})}$validateInput(r){return this._validateInput?v.asPromise(()=>this._validateInput(r)):Promise.resolve(void 0)}async showWorkspaceFolderPick(r,o=R.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!m)return;const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(E=>E.uri.toString()===m.uri.toString())}createQuickPick(r,o){const m=new t(r,o,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(r){const o=new n(r,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(r,o){const m=this._sessions.get(r);m&&m._fireDidChangeValue(o)}$onDidAccept(r){const o=this._sessions.get(r);o&&o._fireDidAccept()}$onDidChangeActive(r,o){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeActive(o)}$onDidChangeSelection(r,o){const m=this._sessions.get(r);m instanceof t&&m._fireDidChangeSelection(o)}$onDidTriggerButton(r,o){const m=this._sessions.get(r);m&&m._fireDidTriggerButton(o)}$onDidHide(r){const o=this._sessions.get(r);o&&o._fireDidHide()}}class _{constructor(r,o){this._extensionId=r,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((o,m)=>{const p=o===D.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(p,o)}),this.update({buttons:r.map((o,m)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===D.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const o=this._handlesToButtons.get(r);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=y.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(r){if(!this._disposed){for(const o of Object.keys(r)){const m=r[o];this._pendingUpdate[o]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function u(i){if(i instanceof D.ThemeIcon)return{id:i.id};const r=f(i),o=d(i);return{dark:typeof r=="string"?C.URI.file(r):r,light:typeof o=="string"?C.URI.file(o):o}}function d(i){return typeof i=="object"&&"light"in i?i.light:i}function f(i){return typeof i=="object"&&"dark"in i?i.dark:i}class t extends _{constructor(r,o,m){super(r,m);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((o,m)=>{this._handlesToItems.set(m,o),this._itemsToHandles.set(o,m)}),this.update({items:r.map((o,m)=>({label:o.label,description:o.description,handle:m,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(r){const o=s.coalesce(r.map(m=>this._handlesToItems.get(m)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(r){const o=s.coalesce(r.map(m=>this._handlesToItems.get(m)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class n extends _{constructor(r,o){super(r,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,this.update({validationMessage:r,severity:r?I.default.Error:I.default.Ignore})}}return new w(c,h)}e.createExtHostQuickOpen=a}),define(pe[232],ve([0,1,2,3,50,6,14,5,17,96,15,26,35]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(r){if(r)return typeof r.iconPath=="string"?v.URI.file(r.iconPath):r.iconPath}function c(r,o){if(!r.iconPath&&!o.iconPath)return 0;if(r.iconPath){if(!o.iconPath)return 1}else return-1;const m=typeof r.iconPath=="string"?r.iconPath:r.iconPath.fsPath,p=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return P.comparePaths(m,p)}function h(r,o){let m=0;if(r.strikeThrough!==o.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==o.faded)return r.faded?1:-1;if(r.tooltip!==o.tooltip)return(r.tooltip||"").localeCompare(o.tooltip||"");if(m=c(r,o),m!==0)return m;if(r.light&&o.light)m=c(r.light,o.light);else{if(r.light)return 1;if(o.light)return-1}if(m!==0)return m;if(r.dark&&o.dark)m=c(r.dark,o.dark);else{if(r.dark)return 1;if(o.dark)return-1}return m}function S(r,o){if(r.command!==o.command)return r.command<o.command?-1:1;if(r.title!==o.title)return r.title<o.title?-1:1;if(r.tooltip!==o.tooltip){if(r.tooltip!==void 0&&o.tooltip!==void 0)return r.tooltip<o.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(r.arguments===o.arguments)return 0;if(r.arguments)if(o.arguments){if(r.arguments.length!==o.arguments.length)return r.arguments.length-o.arguments.length}else return 1;else return-1;for(let m=0;m<r.arguments.length;m++){const p=r.arguments[m],E=o.arguments[m];if(p!==E)return p<E?-1:1}return 0}function w(r,o){let m=P.comparePaths(r.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(m!==0)return m;if(r.command&&o.command)m=S(r.command,o.command);else{if(r.command)return 1;if(o.command)return-1}if(m!==0)return m;if(r.decorations&&o.decorations)m=h(r.decorations,o.decorations);else{if(r.decorations)return 1;if(o.decorations)return-1}return m}function _(r,o){for(let m=0;m<r.length;m++)if(r[m]!==o[m])return!1;return!0}function u(r,o){return r.command===o.command&&r.title===o.title&&r.tooltip===o.tooltip&&(r.arguments&&o.arguments?_(r.arguments,o.arguments):r.arguments===o.arguments)}function d(r,o){return D.equals(r,o,u)}class f{constructor(o,m,p){this._extension=o,this._proxy=m,this._sourceControlHandle=p,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return a.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(a.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){a.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,m){a.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,m)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=f;class t{constructor(o,m,p,E,b){this._proxy=o,this._commands=m,this._sourceControlHandle=p,this._id=E,this._label=b,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,m){const p=this._resourceStatesCommandsMap.get(o);return p?A.asPromise(()=>this._commands.executeCommand(p.command,...p.arguments||[],m)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const m=[...this._resourceStates].sort(w),E=D.sortedDiff(this._resourceSnapshot,m,w).map(L=>{const O=L.toInsert.map(W=>{const Z=this._resourceHandlePool++;this._resourceStatesMap.set(Z,W);const oe=W.resourceUri,V=g(W.decorations),$=W.decorations&&g(W.decorations.light)||V,j=W.decorations&&g(W.decorations.dark)||V,T=[];let N;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const se=new y.DisposableStore;N=this._commands.converter.toInternal(W.command,se),this._resourceStatesDisposablesMap.set(Z,se)}else this._resourceStatesCommandsMap.set(Z,W.command);$&&T.push($),j&&j.toString()!==($==null?void 0:$.toString())&&T.push(j);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,U=W.decorations&&!!W.decorations.faded,x=W.contextValue||"";return{rawResource:[Z,oe,T,F,M,U,x,N],handle:Z}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),b=E.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(Z=>Z.rawResource)]),l=E.reverse();for(const{start:L,deleteCount:O,toInsert:W}of l){const Z=W.map(V=>V.handle),oe=this._handlesSnapshot.splice(L,O,...Z);for(const V of oe)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),(o=this._resourceStatesDisposablesMap.get(V))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=m,b}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(o,m,p,E,b,l){this._proxy=m,this._commands=p,this._id=E,this._label=b,this._rootUri=l,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new y.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new y.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,b,l)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new y.DisposableStore,this._acceptInputCommand=o;const m=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:m})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&d(this._statusBarCommands,o))return;this._statusBarDisposables.value=new y.DisposableStore,this._statusBarCommands=o;const m=(o||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:m})}get selected(){return this._selected}createResourceGroup(o,m){const p=new t(this._proxy,this._commands,this.handle,o,m),E=R.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,E),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const o=[],m=[];for(const[p,E]of this.createdResourceGroups){E.dispose();const b=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});R.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),b.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),o.push([p.handle,p.id,p.label,p.features]);const l=p._takeResourceStateSnapshot();l.length>0&&m.push([p.handle,l]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,o,m),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(m=>{const p=m._takeResourceStateSnapshot();p.length!==0&&o.push([m.handle,p])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([k.debounce(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([k.debounce(100)],n.prototype,"eventuallyUpdateResourceStates",null);let i=class Un{constructor(o,m,p){this._commands=m,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(C.MainContext.MainThreadSCM),this._telemetry=o.getProxy(C.MainContext.MainThreadTelemetry),m.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const b=this._sourceControls.get(E.sourceControlHandle);if(!b)return E;const l=b.getResourceGroup(E.groupHandle);return l?l.getResourceState(E.handle):E}else if(E&&E.$mid===4){const b=this._sourceControls.get(E.sourceControlHandle);return b?b.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const b=this._sourceControls.get(E.handle);return b||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,m,p,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,m,p,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const b=Un._handlePool++,l=new n(o,this._proxy,this._commands,m,p,E);this._sourceControls.set(b,l);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return L.push(l),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),L),l}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const m=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),p=m&&m[m.length-1];return p&&p.inputBox}$provideOriginalResource(o,m,p){const E=v.URI.revive(m);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const b=this._sourceControls.get(o);return!b||!b.quickDiffProvider||!b.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>b.quickDiffProvider.provideOriginalResource(E,p)).then(l=>l||null)}$onInputBoxValueChange(o,m){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const p=this._sourceControls.get(o);return p&&p.inputBox.$onInputBoxValueChange(m),Promise.resolve(void 0)}$executeResourceCommand(o,m,p,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,m,p);const b=this._sourceControls.get(o);if(!b)return Promise.resolve(void 0);const l=b.getResourceGroup(m);return l?l.$executeResourceCommand(p,E):Promise.resolve(void 0)}$validateInput(o,m,p){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>E.inputBox.validateInput(m,p)).then(b=>b?Promise.resolve([b.message,b.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var m,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((m=this._sourceControls.get(o))===null||m===void 0||m.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};i._handlePool=0,i=Ve([He(2,s.ILogService)],i),e.ExtHostSCM=i});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[233],ve([0,1,7,5,161,6]),function(Q,e,v,R,k,y){"use strict";var A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(a,g,c,h,S=v.StatusBarAlignment.Left,w){A.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new y.DisposableStore,nt(this,A,a,"f"),nt(this,C,g,"f"),this._entryId=D.ID_GEN++,this._extension=c,this._id=h,this._alignment=S,this._priority=w}get id(){var a;return(a=this._id)!==null&&a!==void 0?a:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var a;return(a=this._command)===null||a===void 0?void 0:a.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!D.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Be(this,C,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Be(this,C,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,A,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var a;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let c;this._name?c=this._name:c=k.localize(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Be(this,A,"f").$setEntry(this._entryId,g,c,this._text,this._tooltip,(a=this._command)===null||a===void 0?void 0:a.internal,h,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,A=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const g={message:a};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const c=this._messages.indexOf(g);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(a,g){this._proxy=a.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new P(this)}createStatusBarEntry(a,g,c,h){return new D(this._proxy,this._commands,a,g,c,h)}setStatusBarMessage(a,g){const c=this._statusMessage.setMessage(a);let h;return typeof g=="number"?h=setTimeout(()=>c.dispose(),g):typeof g!="undefined"&&g.then(()=>c.dispose(),()=>c.dispose()),new v.Disposable(()=>{c.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=s}),define(pe[88],ve([0,1,5,3,4]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class y{constructor(C){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,P){return this._proxy.$getValue(C,D).then(s=>s||P)}setValue(C,D,P){return this._proxy.$setValue(C,D,P)}$acceptValue(C,D,P){this._onDidChangeStorage.fire({shared:C,key:D,value:P})}}e.ExtHostStorage=y,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(pe[89],ve([0,1,4,27,15,87,2]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=v.createDecorator("IExtensionStoragePaths");let C=class{constructor(P,s,I){var a;this._logService=s,this._extHostFileSystem=I,this._workspace=(a=P.workspace)!==null&&a!==void 0?a:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(a){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=A.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),I}catch(a){this._logService.error("[ExtHostStorage]",a);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};C=Ve([He(0,R.IExtHostInitDataService),He(1,k.ILogService),He(2,y.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(pe[33],ve([0,1,3,5,4,2,12,6,7,162,16,199,21,32,187,13]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class S{constructor(n,i,r,o){this._proxy=n,this._id=i,this._creationOptions=r,this._name=o,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(p=>this._pidPromiseComplete=p);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(p,E=!0){m._checkDisposed(),m._proxy.$sendText(m._id,p,E)},show(p){m._checkDisposed(),m._proxy.$show(m._id,p)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:h.withNullAsUndefined(n.shellPath),shellArgs:h.withNullAsUndefined(n.shellArgs),cwd:h.withNullAsUndefined(n.cwd),env:h.withNullAsUndefined(n.env),icon:h.withNullAsUndefined(n.iconPath),initialText:h.withNullAsUndefined(n.message),strictEnv:h.withNullAsUndefined(n.strictEnv),hideFromUser:h.withNullAsUndefined(n.hideFromUser),isFeatureTerminal:h.withNullAsUndefined(i==null?void 0:i.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:h.withNullAsUndefined(i==null?void 0:i.useShellEnvironment),isSplitTerminal:h.withNullAsUndefined(i==null?void 0:i.isSplitTerminal)})}async createExtensionTerminal(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:i,isSplitTerminal:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=S;class w{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,i){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let _=1,u=class extends C.Disposable{constructor(n,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[r,o]of this._terminalProcesses)o.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[]}createExtensionTerminal(n,i){const r=new S(this._proxy,g.generateUuid(),n,n.name),o=new w(n.pty);return r.createExtensionTerminal(i==null?void 0:i.isSplitTerminal,n.iconPath).then(m=>{const p=this._setupExtHostProcessListeners(m,o);this._terminalProcessDisposables[m]=p}),this._terminals.push(r),r.value}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const o=new w(i),m=this._setupExtHostProcessListeners(n,o);this._terminalProcessDisposables[n]=m}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const r=this._getTerminalById(n);r&&(this._activeTerminal=r,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const r=this._getTerminalById(n);r&&this._onDidWriteTerminalData.fire({terminal:r.value,data:i})}async $acceptTerminalDimensions(n,i,r){const o=this._getTerminalById(n);o&&o.setDimensions(i,r)&&this._onDidChangeTerminalDimensions.fire({terminal:o.value,dimensions:o.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,r){var o;(o=this._terminalProcesses.get(n))===null||o===void 0||o.resize(i,r)}async $acceptTerminalTitleChange(n,i){const r=this._getTerminalById(n);r&&(r.name=i)}async $acceptTerminalClosed(n,i){const r=this._getTerminalObjectIndexById(this._terminals,n);if(r!==null){const o=this._terminals.splice(r,1)[0];o.setExitCode(i),this._onDidCloseTerminal.fire(o.value)}}$acceptTerminalOpened(n,i,r,o){if(i){const E=this._getTerminalObjectIndexById(this._terminals,i);if(E!==null){this._terminals[E]._id=n,this._onDidOpenTerminal.fire(this.terminals[E]),this._terminals[E].isOpen=!0;return}}const m={name:o.name,shellPath:o.executable,shellArgs:o.args,cwd:typeof o.cwd=="string"?o.cwd:y.URI.revive(o.cwd),env:o.env,hideFromUser:o.hideFromUser},p=new S(this._proxy,n,m,r);this._terminals.push(p),this._onDidOpenTerminal.fire(p.value),p.isOpen=!0}async $acceptTerminalProcessId(n,i){const r=this._getTerminalById(n);r&&r._setProcessId(i)}async $startExtensionTerminal(n,i){const r=this._getTerminalById(n);if(!r)return{message:P.localize(0,null,n)};r.isOpen||await new Promise(m=>{const p=this.onDidOpenTerminal(async E=>{E===r.value&&(p.dispose(),m())})});const o=this._terminalProcesses.get(n);o?o.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const r=new C.DisposableStore;r.add(i.onProcessReady(m=>this._proxy.$sendProcessReady(n,m.pid,m.cwd))),r.add(i.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(n,m))),this._bufferer.startBuffering(n,i.onProcessData),r.add(i.onProcessExit(m=>this._onProcessExit(n,m))),i.onProcessOverrideDimensions&&r.add(i.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(n,m))),this._terminalProcesses.set(n,i);const o=this._extensionTerminalAwaitingStart[n];return o&&i instanceof w&&(i.startSendingEvents(o.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),r}$acceptProcessAckDataEvent(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.input(i)}$acceptProcessResize(n,i,r){var o;try{(o=this._terminalProcesses.get(n))===null||o===void 0||o.resize(i,r)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(n,i){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.shutdown(i)}$acceptProcessRequestInitialCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getInitialCwd().then(r=>this._proxy.$sendProcessInitialCwd(n,r))}$acceptProcessRequestCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getCwd().then(r=>this._proxy.$sendProcessCwd(n,r))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,i),this._proxy.$registerProfileProvider(n),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(n,i){var r;const o=new a.CancellationTokenSource().token,m=await((r=this._profileProviders.get(n))===null||r===void 0?void 0:r.provideProfileOptions(o));if(!o.isCancellationRequested){if(!m)throw new Error(`No terminal profile options provided for id "${n}"`);"pty"in m&&this.createExtensionTerminal(m,{isSplitTerminal:i}),this.createTerminalFromOptions(m,{isSplitTerminal:i})}}async $provideLinks(n,i){const r=this._getTerminalById(n);if(!r)return[];this._terminalLinkCache.delete(n);const o=this._terminalLinkCancellationSource.get(n);o&&o.dispose(!0);const m=new a.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,m);const p=[],E={terminal:r.value,line:i},b=[];for(const O of this._linkProviders)b.push(new Promise(async W=>{m.token.onCancellationRequested(()=>W({provider:O,links:[]}));const Z=await O.provideTerminalLinks(E,m.token)||[];m.token.isCancellationRequested||W({provider:O,links:Z})}));const l=await Promise.all(b);if(m.token.isCancellationRequested)return[];const L=new Map;for(const O of l)O&&O.links.length>0&&p.push(...O.links.map(W=>{const Z={id:_++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return L.set(Z.id,{provider:O.provider,link:W}),Z}));return this._terminalLinkCache.set(n,L),p}$activateLink(n,i){var r;const o=(r=this._terminalLinkCache.get(n))===null||r===void 0?void 0:r.get(i);!o||o.provider.handleTerminalLink(o.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const r=this._terminalProcessDisposables[n];r&&(r.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const r=this._getTerminalObjectIndexById(n,i);return r!==null?n[r]:null}_getTerminalObjectIndexById(n,i){let r=null;return n.some((o,m)=>o._id===i?(r=m,!0):!1),r}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new d,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const r=I.serializeEnvironmentVariableCollection(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,r.length===0?void 0:r)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const r=i[0],o=new d(i[1]);this._setEnvironmentVariableCollection(r,o)})}$acceptDefaultProfile(n,i){this._defaultProfile=n,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};u=Ve([He(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class d{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const r=this.map.get(n);(!r||r.value!==i.value||r.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((r,o)=>n.call(i,o,r,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let f=class extends u{constructor(n){super(!1,n)}createTerminal(n,i,r){throw new s.NotSupportedError}createTerminalFromOptions(n,i){throw new s.NotSupportedError}};f=Ve([He(0,A.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f}),define(pe[234],ve([0,1,3,17,5,123,18,7]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(a=>this._onDidChangeVisibleTextEditors.fire(a)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(a=>this._onDidChangeActiveTextEditor.fire(a))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const I=this._extHostDocumentsAndEditors.allEditors();return s?I:I.map(a=>a.value)}async showTextDocument(s,I,a){let g;typeof I=="number"?g={position:A.ViewColumn.from(I),preserveFocus:a}:typeof I=="object"?g={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:g={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(s.uri,g),h=c&&this._extHostDocumentsAndEditors.getEditor(c);if(h)return h.value;throw c?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s,I){return new y.TextEditorDecorationType(this._proxy,s,I).value}$acceptEditorPropertiesChanged(s,I){const a=this._extHostDocumentsAndEditors.getEditor(s);if(!a)throw new Error("unknown text editor");if(I.options&&a._acceptOptions(I.options),I.selections){const g=I.selections.selections.map(A.Selection.to);a._acceptSelections(g)}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));a._acceptVisibleRanges(g)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:a.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const g=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:a.value,selections:c,kind:g})}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:a.value,visibleRanges:g})}}$acceptEditorPositionData(s){for(const I in s){const a=this._extHostDocumentsAndEditors.getEditor(I);if(!a)throw new Error("Unknown text editor");const g=A.ViewColumn.to(s[I]);a.value.viewColumn!==g&&(a._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:a.value,viewColumn:g}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(Q,e){var v={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(v[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(Q);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[k])&&(v[R[k]]=Q[R[k]]);return v};define(pe[235],ve([0,1,2,4,5,6,7]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class C{constructor(s,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:a=>{var g,c;if(a&&a.$mid===11){const h=a.uri===void 0?void 0:v.URI.revive(a.uri);return(c=(g=this._itemsBySourceAndUriMap.get(a.source))===null||g===void 0?void 0:g.get(D(h)))===null||c===void 0?void 0:c.get(a.handle)}return a}})}async $getTimeline(s,I,a,g,c){const h=this._providers.get(s);return h==null?void 0:h.provideTimeline(v.URI.revive(I),a,g,c)}registerTimelineProvider(s,I,a,g){const c=new y.DisposableStore,h=this.convertTimelineItem(I.id,g,c).bind(this);let S;I.onDidChange&&(S=I.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:s,onDidChange:void 0,async provideTimeline(_,u,d,f){var t;(f==null?void 0:f.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(_,u,d);if(n==null)return;const i=h(_,f);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(i)})},dispose(){var _;for(const u of w.values())(_=u.get(I.id))===null||_===void 0||_.clear();S==null||S.dispose(),c.dispose()}}))}convertTimelineItem(s,I,a){return(g,c)=>{let h;if(c==null?void 0:c.cacheResults){let S=this._itemsBySourceAndUriMap.get(s);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(s,S));const w=D(g);h=S.get(w),h===void 0&&(h=new Map,S.set(w,h))}return S=>{var w,_;const{iconPath:u}=S,d=Qt(S,["iconPath"]),f=`${s}|${(w=S.id)!==null&&w!==void 0?w:S.timestamp}`;h==null||h.set(f,S);let t,n,i;return S.iconPath&&(u instanceof A.ThemeIcon?i={id:u.id}:v.URI.isUri(u)?(t=u,n=u):{light:t,dark:n}=u),Object.assign(Object.assign({},d),{id:(_=d.id)!==null&&_!==void 0?_:void 0,handle:f,source:s,command:S.command?I.toInternal(S.command,a):void 0,icon:t,iconDark:n,themeIcon:i,accessibilityInformation:S.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),y.toDisposable(()=>{var a;for(const g of this._itemsBySourceAndUriMap.values())(a=g.get(s.id))===null||a===void 0||a.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=C;function D(P){return P==null?void 0:P.toString()}}),define(pe[236],ve([0,1,6,10,2,5]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(y.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,s,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const a=I.schemes.find(g=>!A.supportedSchemes.has(g));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,s),this._proxy.$registerUriOpener(P,I.schemes,D,I.label),v.toDisposable(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const a=k.URI.revive(P);return I.canOpenExternalUri(a,s)}async $openUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},s)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(pe[237],ve([0,1,5,2,6,16,26]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(P,s){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(I,s),this._proxy.$registerUriHandler(I,P),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,s){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(s))}catch(a){y.onUnexpectedError(a)}return Promise.resolve(void 0)}async createAppUri(P){return R.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[63],ve([0,1,3,2,172,193,85,5]),function(Q,e,v,R,k,y,A,C){"use strict";var D,P,s,I,a,g,c,h,S,w,_,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(p,E,b,l,L,O,W){D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,void 0),a.set(this,void 0),g.set(this,void 0),c.set(this,""),h.set(this,void 0),S.set(this,!1),w.set(this,!1),_.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=Be(this,u,"f").event,nt(this,D,p,"f"),nt(this,P,E,"f"),nt(this,h,b,"f"),nt(this,I,l,"f"),nt(this,a,L,"f"),nt(this,g,O,"f"),nt(this,_,f(O),"f"),nt(this,s,W,"f")}dispose(){nt(this,S,!0,"f"),Be(this,u,"f").fire(),Be(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return nt(this,w,!0,"f"),A.asWebviewUri(p,Be(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(p){this.assertNotDisposed(),Be(this,c,"f")!==p&&(nt(this,c,p,"f"),!Be(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(nt(this,w,!0,"f"),Be(this,s,"f").report("Webview vscode-resource: uris",Be(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,P,"f").$setHtml(Be(this,D,"f"),p))}get options(){return this.assertNotDisposed(),Be(this,h,"f")}set options(p){this.assertNotDisposed(),Be(this,P,"f").$setOptions(Be(this,D,"f"),i(Be(this,g,"f"),Be(this,a,"f"),p)),nt(this,h,p,"f")}async postMessage(p){if(Be(this,S,"f"))return!1;const E=y.serializeWebviewMessage(p,{serializeBuffersForPostMessage:Be(this,_,"f")});return Be(this,P,"f").$postMessage(Be(this,D,"f"),E.message,...E.buffers)}assertNotDisposed(){if(Be(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,a=new WeakMap,g=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,_=new WeakMap,u=new WeakMap;function f(m){try{const p=k.normalizeVersion(k.parseVersion(m.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(p,E,b,l,L){this.initData=E,this.workspace=b,this._logService=l,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,E,...b){const l=this.getWebview(p);if(l){const{message:L}=y.deserializeWebviewMessage(E,b);l._onMessageEmitter.fire(L)}}$onMissingCsp(p,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,E,b){const l=new d(p,this._webviewProxy,r(E),this.initData,this.workspace,b,this._deprecationService);return this._webviews.set(p,l),l._onDidDispose(()=>{this._webviews.delete(p)}),l}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function n(m){return{id:m.identifier,location:m.extensionLocation}}e.toExtensionData=n;function i(m,p,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||o(m,p)}}e.serializeWebviewOptions=i;function r(m){var p;return{enableCommandUris:m.enableCommandUris,enableScripts:m.enableScripts,portMapping:m.portMapping,localResourceRoots:(p=m.localResourceRoots)===null||p===void 0?void 0:p.map(E=>R.URI.from(E))}}e.reviveOptions=r;function o(m,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(E=>E.uri),m.extensionLocation]}}),define(pe[238],ve([0,1,21,74,6,10,24,2,18,63,83,5,7]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class c{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,i){const r=this.key(t,n.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const o=new g(n,i);return this._documents.set(r,o),o}delete(t,n){const i=this.key(t,n.uri);this._documents.delete(i)}key(t,n){return`${t}@@@${n}`}}var h;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(h||(h={}));class S{constructor(){this._providers=new Map}addTextProvider(t,n,i){return this.add(0,t,n,i)}addCustomProvider(t,n,i){return this.add(1,t,n,i)}get(t){return this._providers.get(t)}add(t,n,i,r){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:i,provider:r}),new a.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,i,r,o){this._extHostDocuments=n,this._extensionStoragePaths=i,this._extHostWebview=r,this._extHostWebviewPanels=o,this._editorProviders=new S,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,i,r){const o=new k.DisposableStore;return _(i)?(o.add(this._editorProviders.addTextProvider(n,t,i)),this._proxy.$registerTextEditorProvider(P.toExtensionData(t),n,r.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},P.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(n,t,i)),this.supportEditing(i)&&o.add(i.onDidChangeCustomDocument(m=>{const p=this.getCustomDocumentEntry(n,m.document.uri);if(u(m)){const E=p.addEdit(m);this._proxy.$onDidEdit(m.document.uri,n,E,m.label)}else this._proxy.$onContentChange(m.document.uri,n)})),this._proxy.$registerCustomEditorProvider(P.toExtensionData(t),n,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,P.shouldSerializeBuffersForPostMessage(t))),a.Disposable.from(o,new a.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,i,r,o){var m;const p=this._editorProviders.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const E=C.URI.revive(t),b=await p.provider.openCustomDocument(E,{backupId:i,untitledDocumentData:r==null?void 0:r.buffer},o);let l;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(l=(m=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(n,b,l),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${n}'`);const r=C.URI.revive(t),{document:o}=this.getCustomDocumentEntry(n,r);this._documents.delete(n,o),o.dispose()}async $resolveWebviewEditor(t,n,i,r,o,m){const p=this._editorProviders.get(i);if(!p)throw new Error(`No provider found for '${i}'`);const E=D.ViewColumn.to(o),b=this._extHostWebview.createNewWebview(n,r.webviewOptions,p.extension),l=this._extHostWebviewPanels.createNewWebviewPanel(n,i,r.title,E,r.panelOptions,b),L=C.URI.revive(t);switch(p.type){case 1:{const{document:O}=this.getCustomDocumentEntry(i,L);return p.provider.resolveCustomEditor(O,l,m)}case 0:{const O=this._extHostDocuments.getDocument(L);return p.provider.resolveCustomTextEditor(O,l,m)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,i){this.getCustomDocumentEntry(n,t).disposeEdits(i)}async $onMoveCustomEditor(t,n,i){const r=this._editorProviders.get(i);if(!r)throw new Error(`No provider found for '${i}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const m=C.URI.revive(n),p=this._extHostDocuments.getDocument(m);await r.provider.moveCustomTextEditor(p,o,v.CancellationToken.None)}async $undo(t,n,i,r){return this.getCustomDocumentEntry(n,t).undo(i,r)}async $redo(t,n,i,r){return this.getCustomDocumentEntry(n,t).redo(i,r)}async $revert(t,n,i){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(r.document,i),r.disposeBackup()}async $onSave(t,n,i){const r=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(r.document,i),r.disposeBackup()}async $onSaveAs(t,n,i,r){const o=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(o.document,C.URI.revive(i),r)}async $backup(t,n,i){const r=this.getCustomDocumentEntry(n,t),m=await this.getCustomEditorProvider(n).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},i);return r.updateBackup(m),m.id}getCustomDocumentEntry(t,n){const i=this._documents.get(t,C.URI.revive(n));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const n=this._editorProviders.get(t),i=n==null?void 0:n.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function _(f){return typeof f.resolveCustomTextEditor=="function"}function u(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function d(f){const t=f.scheme===y.Schemas.file||f.scheme===y.Schemas.untitled?f.fsPath:f.toString();return R.hash(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[239],ve([0,1,3,6,2,32,18,63,5,7]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";var s,I,a,g,c,h,S,w,_,u,d,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(m,p,E,b,l,L,O){super();s.set(this,void 0),I.set(this,void 0),a.set(this,void 0),g.set(this,void 0),c.set(this,void 0),h.set(this,void 0),S.set(this,void 0),w.set(this,void 0),_.set(this,!0),u.set(this,!0),d.set(this,!1),f.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,f,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,nt(this,s,m,"f"),nt(this,I,p,"f"),nt(this,a,E,"f"),nt(this,c,L,"f"),nt(this,w,l,"f"),nt(this,h,b,"f"),nt(this,g,O,"f")}dispose(){Be(this,d,"f")||(nt(this,d,!0,"f"),Be(this,f,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,s,"f")),Be(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,g,"f")}get viewType(){return this.assertNotDisposed(),Be(this,a,"f")}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(m){this.assertNotDisposed(),Be(this,h,"f")!==m&&(nt(this,h,m,"f"),Be(this,I,"f").$setTitle(Be(this,s,"f"),m))}get iconPath(){return this.assertNotDisposed(),Be(this,S,"f")}set iconPath(m){this.assertNotDisposed(),Be(this,S,"f")!==m&&(nt(this,S,m,"f"),Be(this,I,"f").$setIconPath(Be(this,s,"f"),k.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,w,"f")=="number"&&Be(this,w,"f")<0))return Be(this,w,"f")}get active(){return this.assertNotDisposed(),Be(this,u,"f")}get visible(){return this.assertNotDisposed(),Be(this,_,"f")}_updateViewState(m){Be(this,d,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(nt(this,u,m.active,"f"),nt(this,_,m.visible,"f"),nt(this,w,m.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(m,p){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,s,"f"),{viewColumn:m?A.ViewColumn.from(m):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Be(this,d,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,I=new WeakMap,a=new WeakMap,g=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap,w=new WeakMap,_=new WeakMap,u=new WeakMap,d=new WeakMap,f=new WeakMap,t=new WeakMap;class i{constructor(m,p,E){this.webviews=p,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=m.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return y.generateUuid()}createWebviewPanel(m,p,E,b,l={}){const L=typeof b=="object"?b.viewColumn:b,O={viewColumn:A.ViewColumn.from(L),preserveFocus:typeof b=="object"&&!!b.preserveFocus},W=C.shouldSerializeBuffersForPostMessage(m),Z=i.newHandle();this._proxy.$createWebviewPanel(C.toExtensionData(m),Z,p,{title:E,panelOptions:r(l),webviewOptions:C.serializeWebviewOptions(m,this.workspace,l),serializeBuffersForPostMessage:W},O);const oe=this.webviews.createNewWebview(Z,l,m);return this.createNewWebviewPanel(Z,p,E,L,l,oe)}$onDidChangeWebviewPanelViewStates(m){const p=Object.keys(m);p.sort((E,b)=>{const l=m[E],L=m[b];return l.active?1:L.active?-1:+l.visible-+L.visible});for(const E of p){const b=this.getWebviewPanel(E);if(!b)continue;const l=m[E];b._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(m){const p=this.getWebviewPanel(m);p==null||p.dispose(),this._webviewPanels.delete(m),this.webviews.deleteWebview(m)}registerWebviewPanelSerializer(m,p,E){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:E,extension:m}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:C.shouldSerializeBuffersForPostMessage(m)}),new P.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(m,p,E,b){const l=this._serializers.get(p);if(!l)throw new Error(`No serializer found for '${p}'`);const{serializer:L,extension:O}=l,W=this.webviews.createNewWebview(m,E.webviewOptions,O),Z=this.createNewWebviewPanel(m,p,E.title,b,E.panelOptions,W);await L.deserializeWebviewPanel(Z,E.state)}createNewWebviewPanel(m,p,E,b,l,L){const O=new n(m,this._proxy,p,E,b,l,L);return this._webviewPanels.set(m,O),O}getWebviewPanel(m){return this._webviewPanels.get(m)}}e.ExtHostWebviewPanels=i;function r(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[240],ve([0,1,3,6,63,5,7]),function(Q,e,v,R,k,y,A){"use strict";var C,D,P,s,I,a,g,c,h,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(d,f,t,n,i,r){super();C.set(this,void 0),D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,!1),a.set(this,void 0),g.set(this,void 0),c.set(this,void 0),h.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=Be(this,h,"f").event,S.set(this,this._register(new v.Emitter)),this.onDidDispose=Be(this,S,"f").event,nt(this,P,t,"f"),nt(this,g,n,"f"),nt(this,C,d,"f"),nt(this,D,f,"f"),nt(this,s,i,"f"),nt(this,a,r,"f")}dispose(){Be(this,I,"f")||(nt(this,I,!0,"f"),Be(this,S,"f").fire(),Be(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,g,"f")}set title(d){this.assertNotDisposed(),Be(this,g,"f")!==d&&(nt(this,g,d,"f"),Be(this,D,"f").$setWebviewViewTitle(Be(this,C,"f"),d))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(d){this.assertNotDisposed(),Be(this,c,"f")!==d&&(nt(this,c,d,"f"),Be(this,D,"f").$setWebviewViewDescription(Be(this,C,"f"),d))}get visible(){return Be(this,a,"f")}get webview(){return Be(this,s,"f")}get viewType(){return Be(this,P,"f")}_setVisible(d){d===Be(this,a,"f")||Be(this,I,"f")||(nt(this,a,d,"f"),Be(this,h,"f").fire())}show(d){this.assertNotDisposed(),Be(this,D,"f").$show(Be(this,C,"f"),!!d)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,a=new WeakMap,g=new WeakMap,c=new WeakMap,h=new WeakMap,S=new WeakMap;class _{constructor(d,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(d),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(d,f,t,n,i){const r=this._viewProviders.get(f);if(!r)throw new Error(`No view provider found for '${f}'`);const{provider:o,extension:m}=r,p=this._extHostWebview.createNewWebview(d,{},m),E=new w(d,this._proxy,f,t,p,!0);this._webviewViews.set(d,E),await o.resolveWebviewView(E,{state:n},i)}async $onDidChangeWebviewViewVisibility(d,f){this.getWebviewView(d)._setVisible(f)}async $disposeWebviewView(d){const f=this.getWebviewView(d);this._webviewViews.delete(d),f.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const f=this._webviewViews.get(d);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=_}),define(pe[126],ve([0,1,3,5,2,10,8,4,12]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class xn{constructor(I){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(a=>this.$onDidChangeWindowFocus(a))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,a){let g;if(typeof I=="string"){g=I;try{I=k.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===y.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,g,a)}async asExternalUri(I,a){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(I,a);return k.URI.from(g)}};P.InitialState={focused:!0},P=Ve([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=C.createDecorator("IExtHostWindow")}),define(pe[241],ve([0,1,9,100,32,47,6,5,2,12]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends A.Disposable{constructor(a,g){super();const c=a.getProxy(C.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async h=>{const S=D.URI.file(v.join(R.tmpdir(),k.generateUuid()));return await c.$download(h,S),S})}};s=Ve([He(0,P.IExtHostRpcService),He(1,y.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(pe[242],ve([0,1,2,9,146,28,62,27,12,6,15,112,42]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class g{constructor(w,_,u){this.name=w,this.file=_,this.appender=u}static async create(w,_){const u=await I.createRotatingLogger(w,_,30*a.ByteSize.MB,1);return u.clearFormatters(),new g(w,_,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,_,u){super(w,!1,v.URI.file(_.file),u);this._appender=_}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,_){this._appender.flush(),super.show(w,_)}clear(){this._appender.flush(),super.clear()}}let h=class extends A.ExtHostOutputService{constructor(w,_,u){super(w);this.logService=_,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const _=this._channels.get(w);_&&(this._visibleChannelDisposable.value=_.onDidAppend(()=>_.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const _=this._doCreateOutChannel(w);return _.then(u=>u._id.then(d=>this._channels.set(d,u))),new A.LazyOutputChannel(w,_)}async _doCreateOutChannel(w){try{const _=R.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await y.SymlinkSupport.existsDirectory(_)||await y.Promises.mkdir(_,{recursive:!0});const d=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,f=v.URI.file(R.join(_,`${d}.log`)),t=await g.create(d,f.fsPath);return new c(w,t,this._proxy)}catch(_){return this.logService.error(_),new A.ExtHostPushOutputChannel(w,this._proxy)}}};h=Ve([He(0,D.IExtHostRpcService),He(1,s.ILogService),He(2,C.IExtHostInitDataService)],h),e.ExtHostOutputService2=h}),define(pe[243],ve([0,1,32,12,33]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let y=class extends k.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,D,P){return this.createTerminalFromOptions({name:C,shellPath:D,shellArgs:P})}createTerminalFromOptions(C,D){const P=new k.ExtHostTerminal(this._proxy,v.generateUuid(),C,C.name);return this._terminals.push(P),P.create(C,D),P.value}};y=Ve([He(0,R.IExtHostRpcService)],y),e.ExtHostTerminalService=y}),define(pe[244],ve([0,1,5,12,6,27,2,38,24,28,7,11,46,3,73,15]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class S{constructor(m,p,E){this.remoteAddress=m,this.localAddress=p,this._dispose=E,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(o){const m=o.trim().split(`
`),p=[];return m.forEach(b=>{const l=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(b);l&&l.length>=3&&p.push({pid:parseInt(l[1],10),socket:parseInt(l[2],10)})}),p.reduce((b,l)=>(b[l.socket]=l,b),{})}e.getSockets=w;function _(...o){const m=[].concat(...o.map(d));return[...new Map(m.filter(p=>p.st==="0A").map(p=>{const E=p.local_address.split(":");return{socket:parseInt(p.inode,10),ip:u(E[0]),port:parseInt(E[1],16)}}).map(p=>[p.ip+":"+p.port,p])).values()]}e.loadListeningPorts=_;function u(o){let m="";if(o.length===8)for(let p=o.length-2;p>=0;p-=2)m+=parseInt(o.substr(p,2),16),p!==0&&(m+=".");else for(let p=o.length-4;p>=0;p-=4)m+=parseInt(o.substr(p,4),16).toString(16),p!==0&&(m+=":");return m}e.parseIpAddress=u;function d(o){const m=o.trim().split(`
`),p=m.shift().trim().split(/\s+/).filter(b=>b!=="rx_queue"&&b!=="tm->when");return m.map(b=>b.trim().split(/\s+/).reduce((l,L,O)=>(l[p[O]||O]=L,l),{}))}e.loadConnectionTable=d;function f(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function t(o){const m=o.trim().split(`
`),p=[];return m.forEach(E=>{const b=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);b&&b.length>=4&&p.push({pid:parseInt(b[1],10),ppid:parseInt(b[2]),cmd:b[3]})}),p}e.getRootProcesses=t;async function n(o,m,p){const E=p.reduce((l,L)=>(l[L.pid]=L,l),{}),b=[];return o.forEach(({socket:l,ip:L,port:O})=>{var W;const Z=m[l]?m[l].pid:void 0,oe=Z?(W=E[Z])===null||W===void 0?void 0:W.cmd:void 0;Z&&oe&&!f(oe)&&b.push({host:L,port:O,detail:oe,pid:Z})}),b}e.findPorts=n;function i(o,m,p){const E=new Map,b=t(m);for(const l of o){const L=p.get(l.port);if(L){E.set(l.port,L);continue}const O=b.find(W=>W.cmd.includes(`${l.port}`));if(O){let W=O,Z;do Z=b.find(oe=>oe.ppid===W.pid),Z&&(W=Z);while(Z);E.set(l.port,{host:l.ip,port:l.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else E.set(l.port,{host:l.ip,port:l.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=i;let r=class extends k.Disposable{constructor(m,p,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(v.MainContext.MainThreadTunnelService),I.isLinux&&p.remote.isRemote&&p.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,p){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${p.remoteAddress.host}:${p.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(p,m.displayName);if(E){const b=new S(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(b),b}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,p){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:m,provider:p}),this._proxy.$registerPortsAttributesProvider(m,E),new s.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(m,p,E,b,l){const L=[];for(const W of m){const Z=this._portAttributesProviders.get(W);if(!Z)return[];L.push(...await Promise.all(p.map(async oe=>Z.provider.providePortAttributes(oe,E,b,l))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let p=new c.MovingAverage,E;for(;this._candidateFindingEnabled;){const b=new Date().getTime(),l=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${l.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-b;p.update(L),(!E||JSON.stringify(E)!==JSON.stringify(l))&&(E=l,await this._proxy.$onFoundNewCandidates(E)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(p.value)))}}async setTunnelExtensionFunctions(m){var p;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((p=m.tunnelFeatures)!==null&&p!==void 0?p:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,p){if(this._extensionTunnels.has(m.host)){const E=this._extensionTunnels.get(m.host);E.has(m.port)&&(p&&E.get(m.port).disposeListener.dispose(),await E.get(m.port).tunnel.dispose(),E.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,p){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(m,p);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const b=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const l=this._register(b.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(b.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:b,disposeListener:l}),a.TunnelDto.fromApiTunnel(b)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const p=await Promise.all(m.map(b=>{var l;return this._showCandidatePort(b.host,b.port,(l=b.detail)!==null&&l!==void 0?l:"")})),E=m.filter((b,l)=>p[l]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(b=>b.port).join(", ")} to ${E.map(b=>b.port).join(", ")}`),E}async findCandidatePorts(){let m="",p="";try{m=await P.Promises.readFile("/proc/net/tcp","utf8"),p=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch($){}const E=_(m,p),b=await new Promise($=>{C.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,T,N)=>{$(T)})}),l=w(b),L=await P.readdir("/proc"),O=[];for(let $ of L)try{const j=Number($),T=D.joinPath(A.URI.file("/proc"),$);if((await P.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(j)){const F=await P.Promises.readlink(D.joinPath(T,"cwd").fsPath),M=await P.Promises.readFile(D.joinPath(T,"cmdline").fsPath,"utf8");O.push({pid:j,cwd:F,cmd:M})}}catch(j){}const W=[],Z=E.filter($=>{const j=l[$.socket];return j||W.push($),j}),oe=n(Z,l,O);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const $=await new Promise(j=>{C.exec("ps -F -A -l | grep root",(T,N,F)=>{j(N)})});this._foundRootPorts=i(W,$,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return oe.then($=>V?$.concat(V):$)}};r=Ve([He(0,R.IExtHostRpcService),He(1,y.IExtHostInitDataService),He(2,h.ILogService)],r),e.ExtHostTunnelService=r}),define(pe[245],ve([0,1,14,21,16,3,6,98,213,124,22]),function(Q,e,v,R,k,y,A,C,D,P,s){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function a(r,o){try{return JSON.stringify(r,o)}catch(m){return"null"}}function g(r,o){return JSON.stringify(r,o)}function c(r){return r?(o,m)=>m&&m.$mid===1?r.transformOutgoing(m):m:null}var h;(function(r){r[r.LocalSide=0]="LocalSide",r[r.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(r){r[r.Responsive=0]="Responsive",r[r.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},_=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(o,m=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=m,this._uriTransformer=p,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,b=P.ProxyIdentifier.count;E<b;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?C.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:m,sid:p}=o;return this._proxies[m]||(this._proxies[m]=this._createProxy(m,p)),this._proxies[m]}_createProxy(o,m){let p={get:(E,b)=>(typeof b=="string"&&!E[b]&&b.charCodeAt(0)===36&&(E[b]=(...l)=>this._remoteCall(o,b,l)),b===u?m:E[b])};return new Proxy(Object.create(null),p)}set(o,m){return this._locals[o.nid]=m,m}assertRegistered(o){for(let m=0,p=o.length;m<p;m++){const E=o[m];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const m=o.byteLength,p=f.read(o,0),E=p.readUInt8(),b=p.readUInt32();switch(E){case 1:case 2:{let{rpcId:l,method:L,args:O}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(m,b,l,L,O,E===2);break}case 3:case 4:{let{rpcId:l,method:L,args:O}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(m,b,l,L,O,E===4);break}case 5:{this._logger&&this._logger.logIncoming(m,b,0,"ack"),this._onDidReceiveAcknowledge(b);break}case 6:{this._receiveCancel(m,b);break}case 7:{this._receiveReply(m,b,void 0);break}case 9:{let l=t.deserializeReplyOKJSON(p);this._uriTransformer&&(l=C.transformIncomingURIs(l,this._uriTransformer)),this._receiveReply(m,b,l);break}case 8:{let l=t.deserializeReplyOKVSBuffer(p);this._receiveReply(m,b,l);break}case 10:{let l=t.deserializeReplyErrError(p);this._uriTransformer&&(l=C.transformIncomingURIs(l,this._uriTransformer)),this._receiveReplyErr(m,b,l);break}case 11:{this._receiveReplyErr(m,b,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,m,p,E,b,l){this._logger&&this._logger.logIncoming(o,m,1,`receiveRequest ${P.getStringIdentifierForProxy(p)}.${E}(`,b);const L=String(m);let O,W;if(l){const oe=new R.CancellationTokenSource;b.push(oe.token),O=this._invokeHandler(p,E,b),W=()=>oe.cancel()}else O=this._invokeHandler(p,E,b),W=w;this._cancelInvokedHandlers[L]=W;const Z=t.serializeAcknowledged(m);this._logger&&this._logger.logOutgoing(Z.byteLength,m,1,"ack"),this._protocol.send(Z),O.then(oe=>{delete this._cancelInvokedHandlers[L];const V=t.serializeReplyOK(m,oe,this._uriReplacer);this._logger&&this._logger.logOutgoing(V.byteLength,m,1,"reply:",oe),this._protocol.send(V)},oe=>{delete this._cancelInvokedHandlers[L];const V=t.serializeReplyErr(m,oe);this._logger&&this._logger.logOutgoing(V.byteLength,m,1,"replyErr:",oe),this._protocol.send(V)})}_receiveCancel(o,m){this._logger&&this._logger.logIncoming(o,m,1,"receiveCancel");const p=String(m);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(o,m,p){this._logger&&this._logger.logIncoming(o,m,0,"receiveReply:",p);const E=String(m);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const b=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],b.resolveOk(p)}_receiveReplyErr(o,m,p){this._logger&&this._logger.logIncoming(o,m,0,"receiveReplyErr:",p);const E=String(m);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const b=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let l;p&&(p.$isError?(l=new Error,l.name=p.name,l.message=p.message,l.stack=p.stack):l=p),b.resolveErr(l)}_invokeHandler(o,m,p){try{return Promise.resolve(this._doInvokeHandler(o,m,p))}catch(E){return Promise.reject(E)}}_doInvokeHandler(o,m,p){const E=this._locals[o];if(!E)throw new Error("Unknown actor "+P.getStringIdentifierForProxy(o));let b=E[m];if(typeof b!="function")throw new Error("Unknown method "+m+" on actor "+P.getStringIdentifierForProxy(o));return b.apply(E,p)}_remoteCall(o,m,p){if(this._isDisposed)return Promise.reject(k.canceled());let E=null;if(p.length>0&&R.CancellationToken.isCancellationToken(p[p.length-1])&&(E=p.pop()),E&&E.isCancellationRequested)return Promise.reject(k.canceled());const b=t.serializeRequestArguments(p,this._uriReplacer),l=++this._lastMessageId,L=String(l),O=new D.LazyPromise;E&&E.onCancellationRequested(()=>{const Z=t.serializeCancel(l);this._logger&&this._logger.logOutgoing(Z.byteLength,l,0,"cancel"),this._protocol.send(t.serializeCancel(l))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(l);const W=t.serializeRequest(l,o,m,b,!!E);return this._logger&&this._logger.logOutgoing(W.byteLength,l,0,`request: ${P.getStringIdentifierForProxy(o)}.${m}(`,p),this._protocol.send(W),O}}e.RPCProtocol=d,I=_,d.UNRESPONSIVE_TIME=3*1e3;class f{constructor(o,m){this._buff=o,this._offset=m}static alloc(o,m,p){let E=new f(s.VSBuffer.alloc(p+1+4),0);return E.writeUInt8(o),E.writeUInt32(m),E}static read(o,m){return new f(o,m)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,p}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,p}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,m}static sizeMixedArray(o,m){let p=0;p+=1;for(let E=0,b=o.length;E<b;E++){const l=o[E],L=m[E];switch(p+=1,L){case 1:p+=this.sizeLongString(l);break;case 2:p+=this.sizeVSBuffer(l);break;case 3:break}}return p}writeMixedArray(o,m){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let p=0,E=o.length;p<E;p++){const b=o[p];switch(m[p]){case 1:this.writeUInt8(1),this.writeLongString(b);break;case 2:this.writeUInt8(2),this.writeVSBuffer(b);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let m=new Array(o);for(let p=0;p<o;p++)switch(this.readUInt8()){case 1:m[p]=this.readLongString();break;case 2:m[p]=this.readVSBuffer();break;case 3:m[p]=void 0;break}return m}}class t{static _arrayContainsBufferOrUndefined(o){for(let m=0,p=o.length;m<p;m++)if(o[m]instanceof s.VSBuffer||typeof o[m]=="undefined")return!0;return!1}static serializeRequestArguments(o,m){if(this._arrayContainsBufferOrUndefined(o)){let p=[],E=[];for(let b=0,l=o.length;b<l;b++){const L=o[b];L instanceof s.VSBuffer?(p[b]=L,E[b]=2):typeof L=="undefined"?(p[b]=s.VSBuffer.alloc(0),E[b]=3):(p[b]=s.VSBuffer.fromString(g(L,m)),E[b]=1)}return{type:"mixed",args:p,argsType:E}}return{type:"simple",args:g(o,m)}}static serializeRequest(o,m,p,E,b){return E.type==="mixed"?this._requestMixedArgs(o,m,p,E.args,E.argsType,b):this._requestJSONArgs(o,m,p,E.args,b)}static _requestJSONArgs(o,m,p,E,b){const l=s.VSBuffer.fromString(p),L=s.VSBuffer.fromString(E);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(l),O+=f.sizeLongString(L);let W=f.alloc(b?2:1,o,O);return W.writeUInt8(m),W.writeShortString(l),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(o){const m=o.readUInt8(),p=o.readShortString(),E=o.readLongString();return{rpcId:m,method:p,args:JSON.parse(E)}}static _requestMixedArgs(o,m,p,E,b,l){const L=s.VSBuffer.fromString(p);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(L),O+=f.sizeMixedArray(E,b);let W=f.alloc(l?4:3,o,O);return W.writeUInt8(m),W.writeShortString(L),W.writeMixedArray(E,b),W.buffer}static deserializeRequestMixedArgs(o){const m=o.readUInt8(),p=o.readShortString(),E=o.readMixedArray(),b=new Array(E.length);for(let l=0,L=E.length;l<L;l++){const O=E[l];typeof O=="string"?b[l]=JSON.parse(O):b[l]=O}return{rpcId:m,method:p,args:b}}static serializeAcknowledged(o){return f.alloc(5,o,0).buffer}static serializeCancel(o){return f.alloc(6,o,0).buffer}static serializeReplyOK(o,m,p){return typeof m=="undefined"?this._serializeReplyOKEmpty(o):m instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(o,m):this._serializeReplyOKJSON(o,a(m,p))}static _serializeReplyOKEmpty(o){return f.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,m){let p=0;p+=f.sizeVSBuffer(m);let E=f.alloc(8,o,p);return E.writeVSBuffer(m),E.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,m){const p=s.VSBuffer.fromString(m);let E=0;E+=f.sizeLongString(p);let b=f.alloc(9,o,E);return b.writeLongString(p),b.buffer}static deserializeReplyOKJSON(o){const m=o.readLongString();return JSON.parse(m)}static serializeReplyErr(o,m){return m?this._serializeReplyErrEror(o,m):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,m){const p=s.VSBuffer.fromString(a(k.transformErrorForSerialization(m),null));let E=0;E+=f.sizeLongString(p);let b=f.alloc(10,o,E);return b.writeLongString(p),b.buffer}static deserializeReplyErrError(o){const m=o.readLongString();return JSON.parse(m)}static _serializeReplyErrEmpty(o){return f.alloc(11,o,0).buffer}}var n;(function(r){r[r.RequestJSONArgs=1]="RequestJSONArgs",r[r.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",r[r.RequestMixedArgs=3]="RequestMixedArgs",r[r.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",r[r.Acknowledged=5]="Acknowledged",r[r.Cancel=6]="Cancel",r[r.ReplyOKEmpty=7]="ReplyOKEmpty",r[r.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",r[r.ReplyOKJSON=9]="ReplyOKJSON",r[r.ReplyErrError=10]="ReplyErrError",r[r.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var i;(function(r){r[r.String=1]="String",r[r.VSBuffer=2]="VSBuffer",r[r.Undefined=3]="Undefined"})(i||(i={}))}),define(pe[246],ve([0,1,4]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=v.createDecorator("remoteAgentService")}),define(pe[247],ve([0,1,10,9,11,2,4,246]),function(Q,e,v,R,k,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let D=class{constructor(s,I){this.localUserHome=s,this.remoteAgentService=I,this.resolveOS=(async()=>{const a=await this.remoteAgentService.getEnvironment();return(a==null?void 0:a.os)||k.OS})(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(a==null?void 0:a.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?R.win32:R.posix)}async fileURI(s){let I="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const g=s.indexOf("/",2);g===-1?(I=s.substring(2),s="/"):(I=s.substring(2,g),s=s.substring(g)||"/")}return y.URI.from({scheme:v.Schemas.file,authority:I,path:s,query:"",fragment:""})}};D=Ve([He(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(pe[64],ve([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(A,C){this.line=A,this.character=C}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,C){return new v(0,0)}with(A){return new v(0,0)}}e.Position=v;class R{constructor(A,C,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,C),this.end=new v(D,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(y){y[y.Information=1]="Information",y[y.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,17,30,25,29,8,4,9,16,64]),function(Q,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",a=" characters skipped \u27EB",g=(I.length+a.length+5)*2;e.ISearchService=C.createDecorator("searchService");var c;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function S(T){return!!T.preview}e.resultIsMatch=S;function w(T){return!!T.resource}e.isFileMatch=w;function _(T){return!!T.message}e.isProgressMessage=_;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=d;class f{constructor(N,F,M){this.ranges=F;const U=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(U)){N=A.getNLines(N,M.matchLines);let x="",K=0,se=0;const be=Math.floor(M.charsPerLine/5),Te=[];for(const Ce of U){const Fe=Math.max(Ce.startColumn-be,0),qe=Ce.startColumn+M.charsPerLine;if(Fe>se+be+g){const ze=I+(Fe-se)+a;x+=ze+N.slice(Fe,qe),K+=Fe-(se+ze.length)}else x+=N.slice(se,qe);Te.push(new i(0,Ce.startColumn-K,Ce.endColumn-K)),se=qe}this.preview={text:x,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const x=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:v.mapArrayOrNot(F,K=>new n(K.startLineNumber-x,K.startColumn,K.endLineNumber-x,K.endColumn))}}}}e.TextSearchMatch=f;function t(T){const N=T[0].startLineNumber;for(const F of T)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class n{constructor(N,F,M,U){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=U}}e.SearchRange=n;class i extends n{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=i;var r;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function o(T,N=!0){const F=T&&T.files&&T.files.exclude,M=N&&T&&T.search&&T.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let U=Object.create(null);return U=k.mixin(U,k.deepClone(F)),U=k.mixin(U,k.deepClone(M),!0),U}e.getExcludes=o;function m(T,N){return T.excludePattern&&R.match(T.excludePattern,N)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&R.match(T.includePattern,N)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(F=>{const M=F.folder.fsPath;if(y.isEqualOrParent(N,M)){const U=D.relative(M,N);return!F.includePattern||!!R.match(F.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=m;var p;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=E;function b(T){const N=T.message;if(P.isPromiseCanceledError(T))return new E(N,p.canceled);try{const F=JSON.parse(N);return new E(F.message,F.code)}catch(F){return new E(N,p.other)}}e.deserializeSearchError=b;function l(T){const N={message:T.message,code:T.code};return new Error(JSON.stringify(N))}e.serializeSearchError=l;function L(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=L;function O(T){return T.type==="success"}e.isSerializedSearchSuccess=O;function W(T){return!!T.path}e.isSerializedFileMatch=W;function Z(T,N){const F=T.searchPath?T.searchPath:T.relativePath;return A.fuzzyContains(F,N)}e.isFilePatternMatch=Z;class oe{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=oe;function V(T,N){const F=Object.assign(Object.assign({},T||{}),N||{});return Object.keys(F).filter(M=>{const U=F[M];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=V;class ${constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(x=>!!x).then(x=>x?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(K=>!!K):Promise.resolve(!0)).then(x=>x)}hasSiblingExcludeClauses(){return j(this._excludeExpression)}}e.QueryGlobTester=$;function j(T){for(const N in T)if(typeof T[N]!="boolean")return!0;return!1}}),define(pe[34],ve([0,1,17,14,21,3,23,10,73,24,8,13,2,164,4,15,180,57,58,27,12,7,31,5]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,O,W){return new P.ExtUri(Z=>p(Z,W)).isEqual(L,O)}function r(L,O,W){return i(L.uri,O.uri,W)?0:s.compare(L.uri.toString(),O.uri.toString())}function o(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:i(L.uri,O.uri,W)?s.compare(L.name,O.name):s.compare(L.uri.toString(),O.uri.toString())}function m(L,O,W,Z){const oe=L.slice(0).sort(($,j)=>W($,j,Z)),V=O.slice(0).sort(($,j)=>W($,j,Z));return v.delta(oe,V,($,j)=>W($,j,Z))}function p(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class E extends w.Workspace{constructor(O,W,Z,oe,V,$){super(O,Z.map(j=>new w.WorkspaceFolder(j)),oe,$);this._name=W,this._isUntitled=V,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris($),Z.forEach(j=>{this._workspaceFolders.push(j),this._structure.set(j.uri,j)})}static toExtHostWorkspace(O,W,Z,oe){if(!O)return{workspace:null,added:[],removed:[]};const{id:V,name:$,folders:j,configuration:T,isUntitled:N}=O,F=[],M=W;W?j.forEach((se,be)=>{const Te=a.URI.revive(se.uri),Ce=E._findFolder(Z||W,Te,oe);Ce?(Ce.name=se.name,Ce.index=se.index,F.push(Ce)):F.push({uri:Te,name:se.name,index:be})}):F.push(...j.map(({uri:se,name:be,index:Te})=>({uri:a.URI.revive(se),name:be,index:Te}))),F.sort((se,be)=>se.index<be.index?-1:1);const U=new E(V,$,F,T?a.URI.revive(T):null,!!N,se=>p(se,oe)),{added:x,removed:K}=m(M?M.workspaceFolders:[],U.workspaceFolders,r,oe);return{workspace:U,added:x,removed:K}}static _findFolder(O,W,Z){for(let oe=0;oe<O.folders.length;oe++){const V=O.workspaceFolders[oe];if(i(V.uri,W,Z))return V}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=P.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let b=class{constructor(O,W,Z,oe){this._onDidChangeWorkspace=new y.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new y.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=oe,this._extHostFileSystemInfo=Z,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(n.MainContext.MainThreadMessageService);const V=W.workspace;this._confirmedWorkspace=V?new E(V.id,V.name,[],V.configuration?a.URI.revive(V.configuration):null,!!V.isUntitled,$=>p($,Z)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?a.URI.from({scheme:C.Schemas.untitled,path:P.basename(P.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,Z,...oe){const V=[];if(Array.isArray(oe)&&oe.forEach(F=>{a.URI.isUri(F.uri)&&!V.some(M=>i(M.uri,F.uri,this._extHostFileSystemInfo))&&V.push({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[W,Z].some(F=>typeof F!="number"||F<0)||Z===0&&V.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+Z>$.length)return!1;const j=$.slice(0);j.splice(W,Z,...V.map(F=>({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<j.length;F++){const M=j[F];if(j.some((U,x)=>x!==F&&i(M.uri,U.uri,this._extHostFileSystemInfo)))return!1}j.forEach((F,M)=>F.index=M);const{added:T,removed:N}=m($,j,o,this._extHostFileSystemInfo);if(T.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,Z,V).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,g.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let Z,oe="";if(typeof O=="string"?(Z=a.URI.file(O),oe=O):typeof O!="undefined"&&(Z=O,oe=O.fsPath),!Z)return oe;const V=this.getWorkspaceFolder(Z,!0);if(!V)return oe;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let $=P.relativePath(V.uri,Z);return W&&V.name&&($=`${V.name}/${$}`),$}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:Z,removed:oe}=E.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Z,removed:oe}))}findFiles(O,W,Z,oe,V=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${oe.value}, entryPoint: findFiles`);let $;if(W===null?$=!1:W&&(typeof W=="string"?$=W:$=W.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:T}=l(O);return this._proxy.$startFileSearch(I.withUndefinedAsNull(j),I.withUndefinedAsNull(T),I.withUndefinedAsNull($),I.withUndefinedAsNull(Z),V).then(N=>Array.isArray(N)?N.map(F=>a.URI.revive(F)):[])}async findTextInFiles(O,W,Z,oe,V=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${oe.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),j=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:T,folder:N}=l(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:j,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:T,excludePattern:F},U=!1;if(this._activeSearchCallbacks[$]=x=>{if(U)return;const K=a.URI.revive(x.resource);x.results.forEach(se=>{t.resultIsMatch(se)?Z({uri:K,preview:{text:se.preview.text,matches:v.mapArrayOrNot(se.preview.matches,be=>new f.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:v.mapArrayOrNot(se.ranges,be=>new f.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):Z({uri:K,text:se.text,lineNumber:se.lineNumber})})},V.isCancellationRequested)return{};try{const x=await this._proxy.$startTextSearch(O,I.withUndefinedAsNull(N),M,$,V);return delete this._activeSearchCallbacks[$],x||{}}catch(x){throw delete this._activeSearchCallbacks[$],x}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};b=Ve([He(0,d.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,h.ILogService)],b),e.ExtHostWorkspace=b,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function l(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||a.URI.file(L.base))),{includePattern:O,folder:W}}}),define(pe[36],ve([0,1,25,3,34,5,7,184,81,13,14,4,12,15,2]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(n,i){if(i){const r=i.split(".");let o=n;for(let m=0;o&&m<r.length;m++)o=o[r[m]];return o}}function S(n){return n instanceof c.URI}function w(n){return n&&n.uri instanceof c.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function u(n){return n&&n.uri instanceof c.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function d(n){if(S(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(u(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(i,r,o){this._proxy=i.getProxy(y.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=o,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,r){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(i,r))}};f=Ve([He(0,a.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,g.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(i,r,o,m){this._onDidChangeConfiguration=new R.Emitter,this._proxy=i,this._logService=m,this._extHostWorkspace=r,this._configuration=C.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,r){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,o))}getConfiguration(i,r,o){const m=d(r)||{},p=this._toReadonlyValue(i?h(this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,m,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,m,o==null?void 0:o.identifier);function E(l){if(l==null)return null;if(typeof l=="boolean")return l?1:4;switch(l){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const b={has(l){return typeof h(p,l)!="undefined"},get:(l,L)=>{this._validateConfigurationAccess(i?`${i}.${l}`:l,m,o==null?void 0:o.identifier);let O=h(p,l);if(typeof O=="undefined")O=L;else{let W;const Z=(oe,V)=>{let $;const j=()=>{W=W||v.deepClone(p),$=$||h(W,V)};return P.isObject(oe)?new Proxy(oe,{get:(T,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return j(),()=>$;if(W)return $=$||h(W,V),$[N];const F=T[N];return typeof N=="string"?Z(F,`${V}.${N}`):F},set:(T,N,F)=>(j(),$&&($[N]=F),!0),deleteProperty:(T,N)=>(j(),$&&delete $[N],!0),defineProperty:(T,N,F)=>(j(),$&&Object.defineProperty($,N,F),!0)}):oe};O=Z(O,l)}return O},update:(l,L,O,W)=>{l=i?`${i}.${l}`:l;const Z=E(O);return L!==void 0?this._proxy.$updateConfigurationOption(Z,l,L,m,W):this._proxy.$removeConfigurationOption(Z,l,m,W)},inspect:l=>{var L,O,W,Z,oe,V,$,j;l=i?`${i}.${l}`:l;const T=v.deepClone(this._configuration.inspect(l,m,this._extHostWorkspace.workspace));if(T)return{key:l,defaultValue:(L=T.default)===null||L===void 0?void 0:L.value,globalValue:(O=T.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=T.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(Z=T.workspaceFolder)===null||Z===void 0?void 0:Z.value,defaultLanguageValue:(oe=T.default)===null||oe===void 0?void 0:oe.override,globalLanguageValue:(V=T.user)===null||V===void 0?void 0:V.override,workspaceLanguageValue:($=T.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(j=T.workspaceFolder)===null||j===void 0?void 0:j.override,languageIds:T.overrideIdentifiers}}};return typeof p=="object"&&v.mixin(b,p,!1),Object.freeze(b)}_toReadonlyValue(i){const r=o=>P.isObject(o)?new Proxy(o,{get:(m,p)=>r(m[p]),set:(m,p,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(m,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(m,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return r(i)}_validateConfigurationAccess(i,r,o){const m=D.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),p=o?`[${o.value}] `:"";if(m===4){typeof(r==null?void 0:r.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){(r==null?void 0:r.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,r){const o=new C.ConfigurationChangeEvent(i,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(m,p)=>o.affectsConfiguration(m,d(p))})}_toMap(i){return i.reduce((r,o)=>(r.set(o[0],o[1]),r),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[65],ve([0,1,2,14,3,5,7,34,39,36,21,33,12,27,4,10,11,15,61,198,16]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function $(j){if(j!=null)return j}oe.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function $(j){if(j!=null)return j}oe.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function $(j){if(j!=null)return j}oe.to=$})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(oe){function V(T){if(T){const N=T;return N&&!!N.process}else return!1}oe.is=V;function $(T){if(T==null)return;const N={process:T.process,args:T.args};return T.options&&(N.options=i.from(T.options)),N}oe.from=$;function j(T){if(T!=null)return new A.ProcessExecution(T.process,T.args,T.options)}oe.to=j})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(oe){function V(j){if(j!=null)return j}oe.from=V;function $(j){if(j!=null)return j}oe.to=$})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var m;(function(oe){function V(T){if(T){const N=T;return N&&(!!N.commandLine||!!N.command)}else return!1}oe.is=V;function $(T){if(T==null)return;const N={};return T.commandLine!==void 0?N.commandLine=T.commandLine:(N.command=T.command,N.args=T.args),T.options&&(N.options=o.from(T.options)),N}oe.from=$;function j(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.ShellExecution(T.commandLine,T.options):new A.ShellExecution(T.command,T.args?T.args:[],T.options)}oe.to=j})(m=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(oe){function V(T){if(T){let N=T;return N&&N.customExecution==="customExecution"}else return!1}oe.is=V;function $(T){return{customExecution:"customExecution"}}oe.from=$;function j(T,N){return N.get(T)}oe.to=j})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(oe){function V($,j){let T;return $.scope!==void 0&&typeof $.scope!="number"?T=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?T=j.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:T}}oe.from=V})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var b;(function(oe){function V(T,N){if(T==null)return[];const F=[];for(let M of T){const U=$(M,N);U&&F.push(U)}return F}oe.fromMany=V;function $(T,N){if(T==null)return;let F;T.execution instanceof A.ProcessExecution?F=r.from(T.execution):T.execution instanceof A.ShellExecution?F=m.from(T.execution):T.execution&&T.execution instanceof A.CustomExecution&&(F=p.from(T.execution));const M=t.from(T.definition);let U;if(T.scope?typeof T.scope=="number"?U=T.scope:U=T.scope.uri:U=A.TaskScope.Workspace,!M||!U)return;const x=T.group?T.group.id:void 0;return{_id:T._id,definition:M,name:T.name,source:{extensionId:N.identifier.value,label:T.source,scope:U},execution:F,isBackground:T.isBackground,group:x,presentationOptions:n.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}oe.from=$;async function j(T,N,F){if(T==null)return;let M;r.is(T.execution)?M=r.to(T.execution):m.is(T.execution)?M=m.to(T.execution):p.is(T.execution)&&(M=p.to(T._id,F));const U=t.to(T.definition);let x;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?x=T.source.scope:x=await N.resolveWorkspaceFolder(v.URI.revive(T.source.scope)):x=A.TaskScope.Workspace),!U||!x)return;const K=new A.Task(U,x,T.name,T.source.label,M,T.problemMatchers);return T.isBackground!==void 0&&(K.isBackground=T.isBackground),T.group!==void 0&&(K.group=A.TaskGroup.from(T.group)),T.presentationOptions&&(K.presentationOptions=n.to(T.presentationOptions)),T._id&&(K._id=T._id),T.detail&&(K.detail=T.detail),K}oe.to=j})(b=e.TaskDTO||(e.TaskDTO={}));var l;(function(oe){function V(j){return j}oe.from=V;function $(j){if(!!j)return Object.assign(Object.create(null),j)}oe.to=$})(l=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(V,$,j){this._id=$,this._task=j,f.set(this,void 0),nt(this,f,V,"f")}get task(){return this._task}terminate(){Be(this,f,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}f=new WeakMap;var O;(function(oe){function V($){return{id:$._id,task:void 0}}oe.from=V})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(V,$,j,T,N,F,M,U){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=V.getProxy(y.MainContext.MainThreadTask),this._workspaceProvider=j,this._editorService=T,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=U,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(V,$,j){if(!j)return new A.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:$,provider:j,extension:V}),this._proxy.$registerTaskProvider(T,$),new A.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(V,$){this._proxy.$registerTaskSystem(V,$)}fetchTasks(V){return this._proxy.$fetchTasks(l.from(V)).then(async $=>{const j=[];for(let T of $){const N=await b.to(T,this._workspaceProvider,this._providedCustomExecutions2);N&&j.push(N)}return j})}get taskExecutions(){const V=[];return this._taskExecutions.forEach($=>V.push($)),V}terminateTask(V){if(!(V instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(V._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(V,$,j){const T=this._providedCustomExecutions2.get(V.id);if(T){if(this._activeCustomExecutions2.get(V.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(V.id,T),this._terminalService.attachPtyToTerminal($,await T.callback(j))}this._lastStartedTask=V.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(V)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(V){const $=await this.getTaskExecution(V);this._taskExecutionPromises.delete(V.id),this._taskExecutions.delete(V.id),this.customExecutionComplete(V),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessStarted.fire({execution:$,processId:V.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(V){const $=await this.getTaskExecution(V.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:V.exitCode})}$provideTasks(V,$){const j=this._handlers.get(V);if(!j)return Promise.reject(new Error("no handler found"));const T=[],N=R.asPromise(()=>j.provider.provideTasks(s.CancellationToken.None)).then(F=>this.provideTasksInternal($,T,j,F));return new Promise(F=>{N.then(M=>{Promise.all(T).then(()=>{F(M)})})})}async $resolveTask(V,$){const j=this._handlers.get(V);if(!j)return Promise.reject(new Error("no handler found"));if($.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${j.type}].`);const T=await b.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const N=await j.provider.resolveTask(T,s.CancellationToken.None);if(!N)return;this.checkDeprecation(N,j);const F=b.from(N,j.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(V,$,j){const T=await this._proxy.$createTaskId(V);!j&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,$.execution)}async getTaskExecution(V,$){if(typeof V=="string"){const N=this._taskExecutionPromises.get(V);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let j=this._taskExecutionPromises.get(V.id);if(j)return j;const T=new Promise(async(N,F)=>{const M=$||await b.to(V.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new L(this,V.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(V.id,T),T.then(N=>(this._taskExecutions.set(V.id,N),N),N=>Promise.reject(N))}checkDeprecation(V,$){V._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(V){this._activeCustomExecutions2.get(V.id)&&this._activeCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.has(V.id)&&this._lastStartedTask!==V.id&&(this._providedCustomExecutions2.delete(V.id),this._notProvidedCustomExecutions.delete(V.id));let j=this._notProvidedCustomExecutions.values(),T=j.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=j.next()}};W=Ve([He(0,a.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let Z=class extends W{constructor(V,$,j,T,N,F,M,U){super(V,$,j,T,N,F,M,U);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(V,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const j=b.from($,V);if(j===void 0)throw new Error("Task is not valid");if(p.is(j.execution))await this.addCustomExecution(j,$,!1);else throw new d.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(j),$);return this._proxy.$executeTask(j).catch(N=>{throw new Error(N)}),T}provideTasksInternal(V,$,j,T){const N=[];if(T)for(let F of T){this.checkDeprecation(F,j),(!F.definition||!V[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=b.from(F,j.extension);M&&p.is(M.execution)?(N.push(M),$.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:j.extension}}async resolveTaskInternal(V){if(p.is(V.execution))return V;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(V,$){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,$,j){}};Z=Ve([He(0,a.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=c.createDecorator("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var v={};for(var R in Q)Object.prototype.hasOwnProperty.call(Q,R)&&e.indexOf(R)<0&&(v[R]=Q[R]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(Q);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(Q,R[k])&&(v[R[k]]=Q[R[k]]);return v};define(pe[248],ve([0,1,17,14,22,21,3,69,71,6,25,13,2,32,5,39,12,84,18,7,34,208,121]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d,f,t){"use strict";var n,i,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const m=(j,T)=>`${j}:${T.toString()}`;let p=class{constructor(T,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(c.MainContext.MainThreadTesting),this.runQueue=new E(this.proxy),this.workspaceObservers=new V(this.proxy),this.textDocumentObservers=new $(this.proxy,N)}registerTestController(T,N){const F=g.generateUuid();this.controllers.set(F,{instance:N,extensionId:T}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var U;for(const x of M)(U=this.testControllers.get(x))===null||U===void 0||U.subscribeFn(F,N)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,N=y.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(I.isDefined).map(U=>({src:U.src,testId:U.item.extId}));await this.proxy.$runTests({exclude:T.exclude?F(T.exclude).map(M=>M.testId):void 0,tests:F(T.tests),debug:T.debug},N)}createTestRun(T,N,F,M=!0){return this.runQueue.createTestRun(T,N,F,M)}$publishTestResults(T){this.results=Object.freeze(T.map(N=>s.deepFreeze(_.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,N){const F=a.URI.revive(N),M=m(T,F);if(this.testControllers.has(M))return;const U=new y.CancellationTokenSource;let x;if(T===1){let Ce=this.documents.getDocument(F);if(!Ce){const Fe=new P.DisposableStore;Ce=await new Promise(qe=>{Fe.add(R.disposableTimeout(()=>qe(void 0),5e3)),Fe.add(this.documents.onDidAddDocuments(ze=>{const Ge=ze.find(q=>q.document.uri.toString()===F.toString());Ge&&qe(Ge)}))}).finally(()=>Fe.dispose())}if(Ce){const Fe=await this.workspace.getWorkspaceFolder2(F,!1);x=qe=>qe.createDocumentTestRoot?qe.createDocumentTestRoot(Ce.document,U.token):e.createDefaultDocumentTestRoot(qe,Ce.document,Fe,U.token)}}else{const Ce=await this.workspace.getWorkspaceFolder2(F,!1);Ce&&(x=Fe=>Fe.createWorkspaceTestRoot(Ce,U.token))}if(!x)return;const K=async(Ce,Fe)=>{try{const qe=await x(Fe);qe&&be.addRoot(qe,Ce)}catch(qe){console.error(qe)}},se=new P.DisposableStore,be=se.add(this.ownedTests.createForHierarchy(Ce=>this.proxy.$publishDiff(T,N,Ce)));se.add(P.toDisposable(()=>U.dispose(!0)));const Te=[];for(const[Ce,Fe]of this.controllers)Te.push(K(Ce,Fe.instance));Promise.all(Te).then(()=>be.pushDiff([3,-1])),this.testControllers.set(M,{store:se,collection:be,subscribeFn:K})}async $expandTest(T,N){const F=v.mapFind(this.testControllers.values(),M=>M.collection.treeId===T.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(T.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,N){var F;const M=a.URI.revive(N),U=m(T,M);(F=this.testControllers.get(U))===null||F===void 0||F.store.dispose(),this.testControllers.delete(U)}$acceptDiff(T,N,F){T===1?this.textDocumentObservers.acceptDiff(a.URI.revive(N),F):this.workspaceObservers.acceptDiff(a.URI.revive(N),F)}async $runTestsForProvider(T,N){const F=this.controllers.get(T.tests[0].src.controller);if(!F)return;const M=T.tests.map(({testId:K,src:se})=>this.ownedTests.getTestById(K,se==null?void 0:se.tree)).filter(I.isDefined).map(([K,se])=>se),U=T.excludeExtIds.map(K=>this.ownedTests.getTestById(K)).filter(I.isDefined).filter(([K,se])=>M.some(be=>K.comparePositions(be,se)===1));if(!M.length)return;const x={tests:M.map(K=>O.unwrap(K.actual)),exclude:U.map(([,K])=>O.unwrap(K.actual)),debug:T.debug};await this.runQueue.enqueueRun({dto:b.fromInternal(T),token:N,extensionId:F.extensionId,req:x,doRun:()=>F.instance.runTests(x,N)})}$lookupTest(T){const N=this.ownedTests.getTestById(T.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:U,expandLevels:x}=F,K=Qt(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(K)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&N!==void 0?N:v.mapFind(this.testControllers.values(),M=>M.collection.getTestByReference(T)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(T)}};p=Ve([He(0,S.IExtHostRpcService),He(1,h.IExtHostDocumentsAndEditors),He(2,d.IExtHostWorkspace)],p),e.ExtHostTesting=p;class E{constructor(T){this.proxy=T,this.state=new Map}enqueueRun(T){let N=this.state.get(T.extensionId);N||(N={queue:[],current:void 0},this.state.set(T.extensionId,N));const F=new R.DeferredPromise,M=()=>{const U=[],x=new Set;N.current={publicReq:T.req,factory:K=>{const se=new l(K,T.dto,x,this.proxy);return U.push(se),T.token.onCancellationRequested(()=>se.end()),se}},this.invokeRunner(T.extensionId,T.dto.id,T.doRun,U).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(T,N,F,M){var U,x;const K=this.state.get(T);if((K==null?void 0:K.current.publicReq)===N)return K.current.factory(F);const se=b.fromPublic(N),be=new l(F,se,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(x=(U=N.exclude)===null||U===void 0?void 0:U.map(Te=>Te.id))!==null&&x!==void 0?x:[],id:se.id,tests:N.tests.map(Te=>Te.id),persist:M}),be.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(se.id)),be}invokeRunner(T,N,F,M){try{const U=F();return R.isThenable(U)?U.then(()=>this.handleInvokeResult(T,N,M,void 0)).catch(x=>this.handleInvokeResult(T,N,M,x)):this.handleInvokeResult(T,N,M,void 0)}catch(U){return this.handleInvokeResult(T,N,M,U)}}async handleInvokeResult(T,N,F,M){const U=this.state.get(T);!U||(U.queue.shift(),U.queue.length>0?U.queue[0]():this.state.delete(T),await Promise.all(F.map(x=>x.onEnd.wait())))}}class b{constructor(T,N,F){this.id=T,this.include=N,this.exclude=F}static fromPublic(T){var N,F;return new b(g.generateUuid(),new Set(T.tests.map(M=>M.id)),new Set((F=(N=T.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(T){return new b(T.runId,new Set(T.tests.map(N=>N.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let N=T;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class l{constructor(T,N,F,M){this.name=T,n.set(this,void 0),i.set(this,void 0),r.set(this,g.generateUuid()),o.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,M,"f"),nt(this,i,N,"f"),nt(this,o,F,"f"),M.$startedTestRunTask(N.id,{id:Be(this,r,"f"),name:T,running:!0})}setState(T,N,F){Be(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,n,"f").$updateTestStateInRun(Be(this,i,"f").id,Be(this,r,"f"),T.id,N,F))}appendMessage(T,N){Be(this,i,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),Be(this,n,"f").$appendTestMessageInRun(Be(this,i,"f").id,Be(this,r,"f"),T.id,_.TestMessage.from(N)))}appendOutput(T){Be(this,n,"f").$appendOutputToRun(Be(this,i,"f").id,Be(this,r,"f"),k.VSBuffer.fromString(T))}end(){Be(this,n,"f").$finishedTestRunTask(Be(this,i,"f").id,Be(this,r,"f")),this.onEnd.open()}ensureTestIsKnown(T){const N=Be(this,o,"f");if(N.has(T.id))return;const F=[];for(;F.unshift(_.TestItem.from(T)),!(N.has(T.id)||(N.add(T.id),!T.parent));)T=T.parent;Be(this,n,"f").$addTestsToRun(Be(this,i,"f").id,F)}}n=new WeakMap,i=new WeakMap,r=new WeakMap,o=new WeakMap;const L=async(j,T,N,F)=>{if(!N)return;const M=await j.createWorkspaceTestRoot(N,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(T)});const U=O.getWrapperForTestItem(M,T);return U.refreshMatch(),U};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(T,N,F){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=N,this.actualParent=F,!(T instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const M=w.getPrivateApiFor(this);w.getPrivateApiFor(T).bus.event(x=>{switch(x[0]){case 3:this[x[1]]=x[2];break;case 0:const K=O.getWrapperForTestItem(x[1],this.filterDocument,this);w.getPrivateApiFor(K).parent=T,K.refreshMatch();break;default:M.bus.fire(x)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(T))return M.get(T);M||(M=new WeakMap,this.wrapperMap.set(N,M));const U=new O(T,N,F);return M.set(T,U),U}static unwrap(T){return T instanceof O?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,N;const F=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const x=O.getWrapperForTestItem(U,this.filterDocument,this);x.hasNodeMatchingFilter?this.children.has(x.id)||this.addChild(x):x.dispose()}const M=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&w.getPrivateApiFor(this.actualParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,_.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:N,removed:F}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class Z extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let N=[];for(const F of T){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,N){return Object.assign(Object.assign({},T),{revived:_.TestItem.toPlain(T.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=Z;class oe{constructor(){this.resources=new Map}checkout(T){var N,F;const M=T.toString(),U=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(T);return(F=U.pendingDeletion)===null||F===void 0||F.dispose(),U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return U.tests.rootTestItems},dispose:C.once(()=>{--U.observers||(U.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(T);if(F)return F}}eventuallyDispose(T){return R.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const N=new Z,F=this.listen(T,U=>N.apply(U)),M={observers:0,tests:N,listener:F};return this.resources.set(T.toString(),M),M}unlisten(T){var N;const F=T.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class V extends oe{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){this.proxy.$subscribeToDiffs(0,T);const F=T.toString();return this.diffListeners.set(F,N),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(F)})}}class $ extends oe{constructor(T,N){super();this.proxy=T,this.documents=N,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){if(!this.documents.getDocument(T))return new u.Disposable(()=>{});const M=T.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,T),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(M)})}}}),define(pe[249],ve([0,1,17,68,30,76,23,10,9,24,8,13,2,140,168,82,57,201,247,31]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(E,b,l,L){this.configurationService=E,this.workspaceContextService=b,this.editorGroupsService=l,this.pathService=L}text(E,b,l={}){E=this.getContentPattern(E,l);const L=this.configurationService.getValue(),O=b&&b.some(Z=>!this.configurationService.getValue({resource:Z}).search.useRipgrep),W=this.commonQuery(b==null?void 0:b.map(S.toWorkspaceFolder),l);return Object.assign(Object.assign({},W),{type:2,contentPattern:E,previewOptions:l.previewOptions,maxFileSize:l.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:l.beforeContext,afterContext:l.afterContext,userDisabledExcludesAndIgnoreFiles:l.disregardExcludeSettings&&l.disregardIgnoreFiles})}getContentPattern(E,b){const l=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},E),{wordSeparators:l.editor.wordSeparators});return this.isCaseSensitive(E,b)&&(L.isCaseSensitive=!0),this.isMultiline(E)&&(L.isMultiline=!0),L}file(E,b={}){const l=this.commonQuery(E,b);return Object.assign(Object.assign({},l),{type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey})}handleIncludeExclude(E,b){return E?(E=Array.isArray(E)?E.map(r):r(E),b?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],b={}){const l=this.handleIncludeExclude(b.includePattern,b.expandPatterns),L=this.handleIncludeExclude(b.excludePattern,b.expandPatterns),O=E.length>1,W=(l.searchPaths&&l.searchPaths.length?l.searchPaths.map(V=>this.getFolderQueryForSearchPath(V,b,L)):E.map(V=>this.getFolderQueryForRoot(V,b,L,O))).filter(V=>!!V),Z={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(l.searchPaths&&l.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:L.pattern,includePattern:l.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const $=v.coalesce(v.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(N=>N.resource)))).filter(T=>u.pathIncludedInQuery(Z,T.fsPath)),j=this.commonQueryFromFileList($);return Object.assign(Object.assign({},Z),j)}const oe=b.extraFileResources&&b.extraFileResources.filter(V=>u.pathIncludedInQuery(Z,V.fsPath));return Z.extraFileResources=oe&&oe.length?oe:void 0,Z}commonQueryFromFileList(E){const b=[],l=new A.ResourceMap,L={};let O=!1;return E.forEach(W=>{var Z,oe;if(W.scheme===C.Schemas.walkThrough)return;if(P.isAbsolutePath(W)){const $=(oe=(Z=this.workspaceContextService.getWorkspaceFolder(W))===null||Z===void 0?void 0:Z.uri)!==null&&oe!==void 0?oe:W.with({path:D.dirname(W.fsPath)});let j=l.get($);j||(O=!0,j={folder:$,includePattern:{}},b.push(j),l.set($,j));const T=D.relative($.fsPath,W.fsPath);I.assertIsDefined(j.includePattern)[T.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:b,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(E,b){if(b.isSmartCase){if(E.isRegExp){if(s.containsUppercaseCharacter(E.pattern,!0))return!0}else if(s.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&g.isMultilineRegexSource(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const b=j=>D.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),L=(Array.isArray(E)?E:n(E)).map(j=>{const T=this.pathService.resolvedUserHome;return T?y.untildify(j,T.scheme===C.Schemas.file?T.fsPath:T.path):j}),O=R.groupBy(L,j=>b(j)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(j=>s.rtrim(j,"/")).map(j=>s.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),i(j))),Z={},oe=this.expandSearchPathPatterns(O.searchPaths||[]);oe&&oe.length&&(Z.searchPaths=oe);const V=v.flatten(W),$=t(...V);return $&&(Z.pattern=$),Z}getExcludesForFolder(E,b){return b.disregardExcludeSettings?void 0:u.getExcludes(E,!b.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const b=v.flatten(E.map(L=>{let{pathPortion:O,globPortion:W}=f(L);W&&(W=o(W));const Z=this.expandOneSearchPath(O);return v.flatten(Z.map(oe=>this.resolveOneSearchPathPattern(oe,W)))})),l=new Map;return b.forEach(L=>{const O=L.searchPath.toString(),W=l.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):l.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(l.values())}expandOneSearchPath(E){if(D.isAbsolute(E)){const b=this.workspaceContextService.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==C.Schemas.file?[{searchPath:b[0].uri.with({path:E})}]:[{searchPath:a.URI.file(D.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const b=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=r(E),E.startsWith("../")||E===".."){const L=D.posix.resolve(b.path,E);return[{searchPath:b.with({path:L})}]}const l=o(E);return[{searchPath:b,pattern:l}]}else{if(E==="./"||E===".\\")return[];{const b=E.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=b.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(I.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&o(W)}});{const O=E.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:E,Z=c.localize(0,null,W);throw new Error(Z)}}}}resolveOneSearchPathPattern(E,b){const l=E.pattern&&b?`${E.pattern}/${b}`:E.pattern||b,L=[{searchPath:E.searchPath,pattern:l}];return l&&!l.endsWith("**")&&L.push({searchPath:E.searchPath,pattern:l+"/**"}),L}getFolderQueryForSearchPath(E,b,l){const L=this.getFolderQueryForRoot(S.toWorkspaceFolder(E.searchPath),b,l,!1);return L?Object.assign(Object.assign({},L),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,b,l,L){let O;const W=a.URI.isUri(E)?E:E.uri;if(l.searchPaths){const j=l.searchPaths.filter(T=>P.isEqual(T.searchPath,W))[0];if(j&&!j.pattern)return null;j&&(O=j.pattern)}const Z=this.configurationService.getValue({resource:W}),oe=this.getExcludesForFolder(Z,b),V=Object.assign(Object.assign({},oe||{}),O||{}),$=a.URI.isUri(E)?P.basename(E):E.name;return{folder:W,folderName:L?$:void 0,excludePattern:Object.keys(V).length>0?V:void 0,fileEncoding:Z.files&&Z.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!Z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!Z.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!Z.search.followSymlinks}}};d=Ve([He(0,h.IConfigurationService),He(1,S.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,_.IPathService)],d),e.QueryBuilder=d;function f(p){const E=p.match(/[\*\{\}\(\)\[\]\?]/);if(E){const b=E.index,l=p.substr(0,b).match(/[/|\\][^/\\]*$/);if(l){let L=p.substr(0,l.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:p.substr((l.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((E,b)=>(E[b]=!0,E),Object.create(null)):void 0}function n(p){return k.splitGlobAware(p,",").map(E=>E.trim()).filter(E=>!!E.length)}function i(p){return[`**/${p}/**`,`**/${p}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(p){return p.replace(/\\/g,"/")}function o(p){return r(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function m(p,E){p=v.distinct(p,L=>L.toString());const b=[],l=E.getWorkspace();return p&&p.forEach(L=>{let O;if(E.getWorkbenchState()===2)O=P.relativePath(l.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=E.getWorkspaceFolder(L);if(W){const Z=W.name;if(l.folders.filter(V=>V.name===Z).length===1){const V=P.relativePath(W.uri,L);V===""?O=`./${W.name}`:O=`./${W.name}/${V}`}else O=L.fsPath}}O&&b.push(O)}),b}e.resolveResourcesForSearchIncludes=m}),define(pe[250],ve([0,1,24,2,21,16,4,249,31,57]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function I(h,S){const w=S.activationEvents;if(!w)return Promise.resolve(void 0);const _=[],u=[];for(const r of w)if(/^workspaceContains:/.test(r)){const o=r.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||h.forceUsingSearch?u.push(o):_.push(o)}if(_.length===0&&u.length===0)return Promise.resolve(void 0);let d;const f=new Promise((r,o)=>{d=r}),t=r=>d({activationEvent:r}),n=Promise.all(_.map(r=>a(h,r,t))).then(()=>{}),i=g(h,S.identifier,u,t);return Promise.all([n,i]).then(()=>{d(void 0)}),f}e.checkActivateWorkspaceContainsExtension=I;async function a(h,S,w){for(const _ of h.folders)if(await h.exists(v.joinPath(R.URI.revive(_),S))){w(`workspaceContains:${S}`);return}}async function g(h,S,w,_){if(w.length===0)return Promise.resolve(void 0);const u=new k.CancellationTokenSource,d=h.checkExists(h.folders,w,u.token),f=setTimeout(async()=>{u.cancel(),_(`workspaceContainsTimeout:${w.join(",")}`)},s);let t=!1;try{t=await d}catch(n){y.isPromiseCanceledError(n)||y.onUnexpectedError(n)}u.dispose(),clearTimeout(f),t&&_(`workspaceContains:${w.join(",")}`)}function c(h,S,w,_){const u=h.get(A.IInstantiationService),d=h.get(D.ISearchService),t=u.createInstance(C.QueryBuilder).file(S.map(n=>P.toWorkspaceFolder(R.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return d.fileSearch(t,_).then(n=>!!n.limitHit,n=>y.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=c});var nt=this&&this.__classPrivateFieldSet||function(Q,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(Q,v):k?k.value=v:e.set(Q,v),v},Be=this&&this.__classPrivateFieldGet||function(Q,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!R:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(Q):R?R.value:e.get(Q)};define(pe[40],ve([0,1,159,9,66,24,14,6,23,2,15,5,36,211,88,34,35,209,16,26,22,189,7,115,4,27,89,12,80,46,33,3,250,86,190]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d,f,t,n,i,r,o,m,p,E,b,l,L,O,W){"use strict";var Z,oe,V;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=i.createDecorator("IHostUtils");let $=class Bn extends C.Disposable{constructor(F,M,U,x,K,se,be,Te,Ce,Fe){super();this._onDidChangeRemoteConnectionData=this._register(new l.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=U,this._initData=be,this._extHostWorkspace=x,this._extHostConfiguration=K,this._logService=se,this._extHostTunnelService=Ce,this._extHostTerminalService=Fe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new p.ServiceCollection([c.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const qe=new Set;this._initData.hostExtensions.forEach(ze=>qe.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Ge,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,_.transformErrorForSerialization(Ge),q)},actualActivateExtension:async(ze,Ge)=>{if(qe.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Ge),new g.HostExtension;const q=this._registry.getExtensionDescription(ze);return this._activateExtension(q,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){_.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const U=this._activator.getActivatedExtension(F);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(x=>F.set(P.URI.file(x).fsPath,U))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const U=this._activator.getActivatedExtension(F);if(!U)return M;try{typeof U.module.deactivate=="function"&&(M=Promise.resolve(U.module.deactivate()).then(void 0,x=>(this._logService.error(x),Promise.resolve(void 0))))}catch(x){this._logService.error(x)}try{C.dispose(U.subscriptions)}catch(x){this._logService.error(x)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(U=>{const x=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,x.codeLoadingTime,x.activateCallTime,x.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",x),U},U=>{throw this._logExtensionActivationTimes(F,M,"failure"),U})}_logExtensionActivationTimes(F,M,U,x){const K=j(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},K),x||{}),{outcome:U}))}_doActivateExtension(F,M){const U=j(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const x=this._getEntryPoint(F);if(!x)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const K=new g.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,y.joinPath(F.extensionLocation,x),K),this._loadExtensionContext(F)]).then(se=>(k.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),Bn._callActivate(this._logService,F.identifier,se[0],se[1],K))).then(se=>(k.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),se))}_loadExtensionContext(F){const M=new f.ExtensionGlobalMemento(F,this._storage),U=new f.ExtensionMemento(F.identifier.value,!1,this._storage),x=new W.ExtensionSecrets(F,this._secretState),K=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const be=this;let Te;return Object.freeze({globalState:M,workspaceState:U,secrets:x,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(Ce){return R.join(F.extensionLocation.fsPath,Ce)},get storagePath(){var Ce;return(Ce=be._storagePath.workspaceValue(F))===null||Ce===void 0?void 0:Ce.fsPath},get globalStoragePath(){return be._storagePath.globalValue(F).fsPath},get logPath(){return R.join(be._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(be._initData.logsLocation,F.identifier.value)},get storageUri(){return be._storagePath.workspaceValue(F)},get globalStorageUri(){return be._storagePath.globalValue(F)},get extensionMode(){return K},get extension(){return Te===void 0&&(Te=new T(be,F.identifier,F,se)),Te},get extensionRuntime(){return S.checkProposedApiEnabled(F),be.extensionRuntime},get environmentVariableCollection(){return be._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,U,x,K){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,U,x,K).then(se=>new g.ActivatedExtension(!1,null,K.build(),U,se,x.subscriptions))}static _callActivateOptional(F,M,U,x,K){if(typeof U.activate=="function")try{K.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const se=typeof global=="object"?global:self,be=U.activate.apply(se,[x]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(be).then(Te=>(K.activateResolveStop(),Te))}catch(se){return Promise.reject(se)}else return Promise.resolve(U)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(M),x=Promise.all([F,U]).then(()=>{});return Promise.race([x,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),x}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,x={folders:F.map(se=>se.uri),forceUsingSearch:U,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,be,Te)=>this._mainThreadWorkspaceProxy.$checkExists(se,be,Te)},K=await L.checkActivateWorkspaceContainsExtension(x,M);if(!!K)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:K.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const U=await this._loadCommonJSModule(null,M,new g.ExtensionActivationTimesBuilder(!1));if(!U||typeof U.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise((x,K)=>{const se=(Ce,Fe)=>{Ce?K(Ce):x(typeof Fe=="number"&&Fe>0?1:0)},be=y.originalFSPath(M),Te=U.run(be,se);Te&&Te.then&&Te.then(()=>{x(0)}).catch(Ce=>{K(Ce.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,C.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const U=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this._resolvers[U]}}async $resolveAuthority(F,M){const{authorityPrefix:U,resolver:x}=await this._activateAndGetResolver(F);if(!x)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(x)),k.mark(`code/extHost/willResolveAuthority/${U}`);const K=await x.resolve(F,{resolveAttempt:M});k.mark(`code/extHost/didResolveAuthorityOK/${U}`);const se={authority:F,host:K.host,port:K.port,connectionToken:K.connectionToken},be={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:se,options:be,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${U}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(F,M){const{authorityPrefix:U,resolver:x}=await this._activateAndGetResolver(F);if(!x)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${U}`);const K=P.URI.revive(M);if(typeof x.getCanonicalURI=="undefined")return K;const se=await A.asPromise(()=>x.getCanonicalURI(K));return se||K}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(x=>x.extensionLocation=P.URI.revive(x.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(M.map(async x=>{const K=this._registry.getExtensionDescription(x);if(!K)return;const se=await this._hostUtils.realpath(K.extensionLocation.fsPath);U.delete(P.URI.file(se).fsPath)})),await Promise.all(F.map(async x=>{const K=await this._hostUtils.realpath(x.extensionLocation.fsPath);U.set(P.URI.file(K).fsPath,x)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=d.VSBuffer.alloc(F),U=Math.random()%256;for(let x=0;x<F;x++)M.writeUInt8(U,x);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};$=Ve([He(0,i.IInstantiationService),He(1,e.IHostUtils),He(2,m.IExtHostRpcService),He(3,h.IExtHostWorkspace),He(4,a.IExtHostConfiguration),He(5,s.ILogService),He(6,r.IExtHostInitDataService),He(7,o.IExtensionStoragePaths),He(8,E.IExtHostTunnelService),He(9,b.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function j(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=i.createDecorator("IExtHostExtensionService");class T{constructor(F,M,U,x){Z.set(this,void 0),oe.set(this,void 0),V.set(this,void 0),nt(this,Z,F,"f"),nt(this,oe,M,"f"),nt(this,V,U.identifier,"f"),this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=R.normalize(y.originalFSPath(U.extensionLocation)),this.packageJSON=U,this.extensionKind=x}get isActive(){return Be(this,Z,"f").isActivated(Be(this,V,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,Z,"f").getExtensionExports(Be(this,V,"f"))}activate(){return Be(this,Z,"f").activateByIdWithErrors(Be(this,V,"f"),{startup:!1,extensionId:Be(this,oe,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,Z=new WeakMap,oe=new WeakMap,V=new WeakMap}),define(pe[48],ve([0,1,9,2,3,14,5,7,119,34,40,39,200,36,195,12,4,13,37,45]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=S.createDecorator("IExtHostDebugService");let d=class{constructor(p,E,b,l,L,O){this._workspaceService=E,this._extensionService=b,this._editorsService=l,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=p.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(Z=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(p,E){const b=p;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let l=`debug:${encodeURIComponent(b.path||"")}`,L="?";return E&&(l+=`${L}session=${encodeURIComponent(E.id)}`,L="&"),l+=`${L}ref=${b.sourceReference}`,R.URI.parse(l)}else{if(b.path)return R.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(p){const E=[];for(const b of p.getAllExtensionDescriptions())if(b.contributes){const l=b.contributes.debuggers;if(l&&l.length>0)for(const L of l)c.isDebuggerMainContribution(L)&&E.push(L.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const p=[];return this._breakpoints.forEach(E=>p.push(E)),p}addBreakpoints(p){this.startBreakpoints();const E=p.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(E,[],[]);const b=[],l=new Map;for(const L of E)if(L instanceof C.SourceBreakpoint){let O=l.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},l.set(L.location.uri.toString(),O),b.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof C.FunctionBreakpoint&&b.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(b)}removeBreakpoints(p){this.startBreakpoints();const E=p.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const b=E.filter(O=>O instanceof C.SourceBreakpoint).map(O=>O.id),l=E.filter(O=>O instanceof C.FunctionBreakpoint).map(O=>O.id),L=E.filter(O=>O instanceof C.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(b,l,L)}startDebugging(p,E,b){return this._debugServiceProxy.$startDebugging(p?p.uri:void 0,E,{parentSessionID:b.parentSession?b.parentSession.id:void 0,repl:b.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact})}stopDebugging(p){return this._debugServiceProxy.$stopDebugging(p?p.id:void 0)}registerDebugConfigurationProvider(p,E,b){if(!E)return new C.Disposable(()=>{});const l=this._configProviderHandleCounter++;return this._configProviders.push({type:p,handle:l,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(p,b,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,l),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(p,E,b){if(!b)return new C.Disposable(()=>{});if(!this.definesDebugType(p,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:l,factory:b}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,l),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==b),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(p,E){if(!E)return new C.Disposable(()=>{});const b=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:p,handle:b,factory:E}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(l=>l.factory!==E)})}async $runInTerminal(p,E){return Promise.resolve(void 0)}async $substituteVariables(p,E){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let b;const l=await this.getFolder(p);return l&&(b={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(b,E)}createDebugAdapter(p,E){if(p.type==="implementation")return new r(p.implementation)}createSignService(){}async $startDASession(p,E){const b=this,l=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(l.type),l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,l);if(!W)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const Z=W;return this._debugAdapters.set(p,Z),this.getDebugAdapterTrackers(l).then(oe=>(oe&&this._debugAdaptersTrackers.set(p,oe),Z.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const $=V,j={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign($.arguments.value);j.body={signature:T},Z.sendResponse(j)}else throw new Error("no signer")}catch(T){j.success=!1,j.message=T.message,Z.sendResponse(j)}}else oe&&oe.onDidSendMessage&&oe.onDidSendMessage(V),V=c.convertToVSCPaths(V,!0),b._debugServiceProxy.$acceptDAMessage(p,V)}),Z.onError(V=>{oe&&oe.onError&&oe.onError(V),this._debugServiceProxy.$acceptDAError(p,V.name,V.message,V.stack)}),Z.onExit(V=>{oe&&oe.onExit&&oe.onExit(w.withNullAsUndefined(V),void 0),this._debugServiceProxy.$acceptDAExit(p,w.withNullAsUndefined(V),void 0)}),oe&&oe.onWillStartSession&&oe.onWillStartSession(),Z.startSession()))})}$sendDAMessage(p,E){E=c.convertToDAPaths(E,!1);const b=this._debugAdaptersTrackers.get(p);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(E);const l=this._debugAdapters.get(p);l&&l.sendMessage(E)}$stopDASession(p){const E=this._debugAdaptersTrackers.get(p);this._debugAdaptersTrackers.delete(p),E&&E.onWillStopSession&&E.onWillStopSession();const b=this._debugAdapters.get(p);return this._debugAdapters.delete(p),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(p){const E=[],b=[],l=[];if(p.added)for(const L of p.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new C.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new C.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const Z=R.URI.revive(L.uri);W=new C.SourceBreakpoint(new C.Location(Z,new C.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),E.push(W)}}if(p.removed)for(const L of p.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),b.push(O))}if(p.changed){for(const L of p.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof C.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof C.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new C.Location(R.URI.revive(L.uri),new C.Position(L.line,L.character))}l.push(O)}}}this.fireBreakpointChanges(E,b,l)}$provideDebugConfigurations(p,E,b){return y.asPromise(async()=>{const l=this.getConfigProviderByHandle(p);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(E);return l.provideDebugConfigurations(L,b)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(p,E,b,l){return y.asPromise(async()=>{const L=this.getConfigProviderByHandle(p);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return L.resolveDebugConfiguration(O,b,l)})}$resolveDebugConfigurationWithSubstitutedVariables(p,E,b,l){return y.asPromise(async()=>{const L=this.getConfigProviderByHandle(p);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return L.resolveDebugConfigurationWithSubstitutedVariables(O,b,l)})}async $provideDebugAdapter(p,E){const b=this.getAdapterDescriptorFactoryByHandle(p);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.getSession(E);return this.getAdapterDescriptor(b,l).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(p){const E=await this.getSession(p);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(p){const E=await this.getSession(p);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(p){this._activeDebugSession=p?await this.getSession(p):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(p,E){const b=await this.getSession(p);b&&b._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(p,E){const l={session:await this.getSession(p),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(l)}convertToDto(p){if(p instanceof C.DebugAdapterExecutable)return{type:"executable",command:p.command,args:p.args,options:p.options};if(p instanceof C.DebugAdapterServer)return{type:"server",port:p.port,host:p.host};if(p instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:p.path};if(p instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:p.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(p){const E=this._adapterFactories.filter(b=>b.type===p);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(p){const E=this._adapterFactories.filter(b=>b.handle===p);if(E.length>0)return E[0].factory}getConfigProviderByHandle(p){const E=this._configProviders.filter(b=>b.handle===p);if(E.length>0)return E[0].provider}definesDebugType(p,E){if(p.contributes){const b=p.contributes.debuggers;if(b&&b.length>0){for(const l of b)if(l.label&&l.type&&l.type===E)return!0}}return!1}getDebugAdapterTrackers(p){const b=p.configuration.type,l=this._trackerFactories.filter(L=>L.type===b||L.type==="*").map(L=>y.asPromise(()=>L.factory.createDebugAdapterTracker(p)).then(O=>O,O=>null));return Promise.race([Promise.all(l).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new i(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(p,E){const b=E.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new C.DebugAdapterServer(b));if(p){const L=await this._extensionService.getExtensionRegistry();return y.asPromise(()=>p.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,L))).then(O=>{if(O)return O})}const l=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,l))}daExecutableFromPackage(p,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(p,E,b){(p.length>0||E.length>0||b.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:p,removed:E,changed:b}))}async getSession(p){if(p)if(typeof p=="string"){const E=this._debugSessions.get(p);if(E)return E}else{let E=this._debugSessions.get(p.id);if(!E){const b=await this.getFolder(p.folderUri),l=p.parent?this._debugSessions.get(p.parent):void 0;E=new f(this._debugServiceProxy,p.id,p.type,p.name,b,p.configuration,l),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(p){if(p){const E=R.URI.revive(p);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};d=Ve([He(0,h.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class f{constructor(p,E,b,l,L,O,W){this._debugServiceProxy=p,this._id=E,this._type=b,this._name=l,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(p){this._name=p,this._debugServiceProxy.$setDebugSessionName(this._id,p)}get parentSession(){return this._parentSession}_acceptNameChanged(p){this._name=p}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(p,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,p,E)}getDebugProtocolBreakpoint(p){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,p.id)}}e.ExtHostDebugSession=f;class t{constructor(p){this.value=Object.freeze({append(E){p.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class n extends a.AbstractVariableResolverService{constructor(p,E,b,l,L){function O(){if(E){const W=E.activeEditor();if(W)return W.document.uri;const Z=l.tabs.filter(oe=>oe.isActive);if(Z.length>0)return Z[0].resource}}super({getFolderUri:W=>{const Z=p.filter(oe=>oe.name===W);if(Z&&Z.length>0)return Z[0].uri},getWorkspaceFolderCount:()=>p.length,getConfigurationValue:(W,Z)=>b.getConfiguration(void 0,W).get(Z),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const Z=L.getWorkspaceFolder(W);if(Z)return v.normalize(Z.uri.fsPath)}}},getSelectedText:()=>{if(E){const W=E.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(E){const W=E.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=n;class i{constructor(p){this.trackers=p}onWillStartSession(){this.trackers.forEach(p=>p.onWillStartSession?p.onWillStartSession():void 0)}onWillReceiveMessage(p){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(p):void 0)}onDidSendMessage(p){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(p):void 0)}onWillStopSession(){this.trackers.forEach(p=>p.onWillStopSession?p.onWillStopSession():void 0)}onError(p){this.trackers.forEach(E=>E.onError?E.onError(p):void 0)}onExit(p,E){this.trackers.forEach(b=>b.onExit?b.onExit(p,E):void 0)}}class r extends D.AbstractDebugAdapter{constructor(p){super();this.implementation=p,p.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(p){this.implementation.handleMessage(p)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends d{constructor(p,E,b,l,L,O){super(p,E,b,l,L,O)}createVariableResolver(p,E,b){return new n(p,E,b,this._editorTabs)}};o=Ve([He(0,h.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(pe[251],ve([0,1,66,2,5,36,35,26,12,27,4,40,37,15]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,d,f,t,n,i,r){this._apiFactory=u,this._extensionRegistry=d,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=i,this._logService=r,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,d,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(S)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,d,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let d of u.nodeModuleName)this._factories.set(d,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(d=>u.alternativeModuleName(d))}};c=Ve([He(2,s.IInstantiationService),He(3,y.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,g.ILogService)],c),e.RequireInterceptor=c;class h{constructor(u,d,f,t,n){this._apiFactory=u,this._extensionPaths=d,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,d){const f=this._extensionPaths.findSubstr(d.fsPath);if(f){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,i)=>t+=`	${i} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(u,d){this.nodeModuleName="keytar";const{environment:f}=d,t=u.getProxy(k.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;a.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,i)=>t.$getPassword(n,i),setPassword:(n,i,r)=>t.$setPassword(n,i,r),deletePassword:(n,i)=>t.$deletePassword(n,i),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(u,d){return this._impl}alternativeModuleName(u){const d=u.length;if(d<=7||!this.alternativeNames)return;const f=d-7;if((u.charAt(f)==="/"||u.charAt(f)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};S=Ve([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],S);let w=class{constructor(u,d,f){this._extensionPaths=u,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(k.MainContext.MainThreadTelemetry);const t=f.getProxy(k.MainContext.MainThreadWindow);this._impl=(n,i)=>{const r=R.URI.parse(n);return i?this.callOriginal(n,i):r.scheme==="http"||r.scheme==="https"?t.$openUri(r,n,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this._appUriScheme?t.$openUri(r,n,{}):this.callOriginal(n,i)}}load(u,d,f){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(u),this._impl}callOriginal(u,d){return this.sendNoForwardTelemetry(),this._original(u,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([He(2,D.IExtHostRpcService)],w)}),define(pe[252],ve([0,1,165,11,7,196,34,40,39,36,33,12,48,186,14,197,45]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends a.ExtHostDebugServiceBase{constructor(d,f,t,n,i,r,o){super(d,f,t,n,i,o);this._terminalService=r,this._integratedTerminalInstances=new _}createDebugAdapter(d,f){switch(d.type){case"server":return new y.SocketDebugAdapter(d);case"pipeServer":return new y.NamedPipeDebugAdapter(d);case"executable":return new y.ExecutableDebugAdapter(d,f.type)}return super.createDebugAdapter(d,f)}daExecutableFromPackage(d,f){const t=y.ExecutableDebugAdapter.platformAdapterExecutable(f.getAllExtensionDescriptions(),d.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new g.SignService}async $runInTerminal(d,f){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),n=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),r=JSON.stringify({shell:n,shellArgs:i});let o=await this._integratedTerminalInstances.checkout(r),m,p=!1;if(o)m=d.cwd;else{const L={shellPath:n,shellArgs:i,cwd:d.cwd,name:d.title||v.localize(0,null)};p=!0,o=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,r)}o.show(!0);const E=await o.processId;p?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(n.indexOf("powershell")>=0||n.indexOf("pwsh")>=0||n.indexOf("cmd.exe")>=0?o.sendText("cls"):n.indexOf("bash")>=0?o.sendText("clear"):R.isWindows?o.sendText("cls"):o.sendText("clear"));const b=h.prepareCommand(n,d.args,m,d.env);o.sendText(b);const l=this.onDidTerminateDebugSession(L=>{L.id===f&&(this._integratedTerminalInstances.free(o),l.dispose())});return E}else if(d.kind==="external")return h.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,f)}createVariableResolver(d,f,t){return new a.ExtHostVariableResolverService(d,f,t,this._editorTabs,this._workspaceService)}};w=Ve([He(0,I.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,s.IExtHostTerminalService),He(6,S.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class _{constructor(){this._terminalInstances=new Map}async checkout(d){const t=[...this._terminalInstances.entries()].map(([n,i])=>c.createCancelablePromise(async r=>{if(i.lastUsedAt!==-1&&await h.hasChildProcesses(await n.processId))return null;const o=Date.now();return i.lastUsedAt+_.minUseDelay>o||r.isCancellationRequested||i.config!==d?null:(i.lastUsedAt=o,n)}));return await c.firstParallel(t,n=>!!n)}insert(d,f){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:f})}free(d){const f=this._terminalInstances.get(d);f&&(f.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}_.minUseDelay=1e3}),define(pe[253],ve([0,1,9,2,109,34,48,39,36,33,12,27,65,10,15,61,45]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends a.ExtHostTaskBase{constructor(u,d,f,t,n,i,r,o,m){super(u,d,f,t,n,i,r,o);this.workspaceService=f,this.editorTabs=m,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,d){const f=d;if(!d.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const t=a.TaskHandleDTO.from(f,this.workspaceService),n=await this._proxy.$getTaskExecution(t);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const i=await this.getTaskExecution(n,d);return this._proxy.$executeTask(t).catch(()=>{}),i}else{const t=a.TaskDTO.from(d,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));a.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const n=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),n}}provideTasksInternal(u,d,f,t){const n=[];if(t)for(let i of t){this.checkDeprecation(i,f),(!i.definition||!u[i.definition.type])&&this._logService.warn(`The task [${i.source}, ${i.name}] uses an undefined task type. The task will be ignored in the future.`);const r=a.TaskDTO.from(i,f.extension);r&&(n.push(r),a.CustomExecutionDTO.is(r.execution)&&d.push(this.addCustomExecution(r,i,!0)))}return{tasks:n,extension:f.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,d){const f=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},n=await this._workspaceProvider.resolveWorkspaceFolder(f),i=await this._workspaceProvider.getWorkspaceFolders2();if(!i||!n)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const r=await this.getVariableResolver(i),o={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}};for(let m of d.variables)t.variables[m]=await r.resolveAsync(o,m);if(d.process!==void 0){let m;if(d.process.path!==void 0){m=d.process.path.split(v.delimiter);for(let p=0;p<m.length;p++)m[p]=await r.resolveAsync(o,m[p])}t.process=await k.win32.findExecutable(await r.resolveAsync(o,d.process.name),d.process.cwd!==void 0?await r.resolveAsync(o,d.process.cwd):void 0,m)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,d,f){return k.win32.findExecutable(u,d,f)}};w=Ve([He(0,s.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,y.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,c.ILogService),He(7,h.IExtHostApiDeprecationService),He(8,S.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(pe[254],ve([0,1,14,16,66,6,2,5,245,15,78,80,27,179,12,59,40,33]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(d,f,t,n){this._disposables=new y.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(d,null,n),f=_._transform(f,this._rpcProtocol);const i=new I.ServiceCollection(...s.getSingletonServiceDescriptors());i.set(a.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),i.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),i.set(h.IURITransformerService,new h.URITransformerService(n)),i.set(S.IHostUtils,t);const r=new g.InstantiationService(i,!0),o=r.invokeFunction(b=>b.get(w.IExtHostTerminalService));this._disposables.add(o),this._logService=r.invokeFunction(b=>b.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=r.invokeFunction(b=>b.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const m=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(l,L)=>{let O="",W,Z;for(const oe of L)O+=`
	at ${oe.toString()}`,Z=oe.getFileName(),!W&&Z&&(W=b.findSubstr(Z));return m.set(l,W),`${l.name||"Error"}: ${l.message||""}${O}`}});const p=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(b=>{const l=R.transformErrorForSerialization(b),L=m.get(b);L?p.$onExtensionRuntimeError(L.identifier,l):E.$onUnexpectedError(l)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([v.timeout(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,f){d.extensions.forEach(n=>n.extensionLocation=A.URI.revive(f.transformIncomingURIs(n.extensionLocation))),d.environment.appRoot=A.URI.revive(f.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(n=>A.URI.revive(f.transformIncomingURIs(n)))),d.environment.extensionTestsLocationURI=A.URI.revive(f.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=A.URI.revive(f.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=A.URI.revive(f.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=A.URI.revive(f.transformIncomingURIs(d.logsLocation)),d.logFile=A.URI.revive(f.transformIncomingURIs(d.logFile)),d.workspace=f.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=_}),define(pe[255],ve([0,1,9,21,55,30,24,43,31]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(a,g,c){this.config=a,this.provider=g,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=a.filePattern,this.includePattern=a.includePattern&&y.parse(a.includePattern),this.maxResults=a.maxResults||void 0,this.exists=a.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=a.excludePattern&&y.parse(a.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(a=>a.cancel()),this.activeCancellationTokens=new Set}search(a){const g=this.config.folderQueries||[];return new Promise((c,h)=>{const S=w=>{this.resultCount++,a(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const _=w.toString(),u=v.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,u)||this.matchFile(S,{base:w,basename:u})}),Promise.all(g.map(w=>this.searchInFolder(w,S))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{h(new Error(k.toErrorMessage(w)))})})}async searchInFolder(a,g){const c=new R.CancellationTokenSource,h=this.getSearchOptionsForFolder(a),S=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,a),_=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=C.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,c.token),f=u.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(n=>{const i=v.posix.relative(a.folder.path,n.path);if(_){const r=v.basename(n.path);this.matchFile(g,{base:a.folder,relativePath:i,basename:r});return}this.addDirectoryEntries(S,a.folder,i,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,w,g),{providerTime:f,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(a){const g=D.resolvePatternsForProvider(this.config.includePattern,a.includePattern),c=D.resolvePatternsForProvider(this.config.excludePattern,a.excludePattern);return{folder:a.folder,excludes:c,includes:g,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}addDirectoryEntries({pathToEntries:a},g,c,h){if(c===this.filePattern){const w=v.basename(this.filePattern);this.matchFile(h,{base:g,relativePath:this.filePattern,basename:w})}function S(w){const _=v.basename(w),u=v.dirname(w);let d=a[u];d||(d=a[u]=[],S(u)),d.push({base:g,relativePath:w,basename:_})}S(c)}matchDirectoryTree({rootEntries:a,pathToEntries:g},c,h){const S=this,w=this.filePattern;function _(u){const d=y.hasSiblingFn(()=>u.map(f=>f.basename));for(let f=0,t=u.length;f<t;f++){const n=u[f],{relativePath:i,basename:r}=n;if(!c.includedInQuerySync(i,r,w!==r?d:void 0))continue;const o=g[i];if(o)_(o);else{if(i===w)continue;S.matchFile(h,n)}if(S.isLimitHit)break}}_(a)}matchFile(a,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||a(g))}}class s{constructor(){this.sessions=new Map}fileSearch(a,g,c,h){const S=this.getSessionTokenSource(a.cacheKey),w=new P(a,g,S&&S.token);let _=0;const u=d=>{_+=d.length,c(d.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(w,s.BATCH_SIZE,u,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:d.stats}}))}clearCache(a){const g=this.getSessionTokenSource(a);g&&g.cancel()}getSessionTokenSource(a){if(!!a)return this.sessions.has(a)||this.sessions.set(a,new R.CancellationTokenSource),this.sessions.get(a)}rawMatchToSearchItem(a){return a.relativePath?{resource:A.joinPath(a.base,a.relativePath)}:{resource:a.base}}doSearch(a,g,c,h){h.onCancellationRequested(()=>{a.cancel()});const S=_=>{_&&(w.push(_),g>0&&w.length>=g&&(c(w),w=[]))};let w=[];return a.search(S).then(_=>(w.length&&c(w),_),_=>(w.length&&c(w),Promise.reject(_)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(pe[127],ve([0,1,9,17,21,55,24,30,2,31,10,13]),function(Q,e,v,R,k,y,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class a{constructor(u,d,f){this.query=u,this.provider=d,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,d){const f=this.query.folderQueries||[],t=new k.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((n,i)=>{this.collector=new c(u);let r=!1;const o=(m,p)=>{if(!r&&!this.isLimitHit){const E=this.resultSize(m);S(m)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,r=!0,t.cancel(),m=this.trimResultToSize(m,this.query.maxResults-this.resultCount));const b=this.resultSize(m);this.resultCount+=b,(b>0||!S(m))&&this.collector.add(m,p)}};Promise.all(f.map((m,p)=>this.searchInFolder(m,E=>o(E,p),t.token))).then(m=>{t.dispose(),this.collector.flush();const p=m.some(E=>!!E&&!!E.limitHit);n({limitHit:this.isLimitHit||p,messages:R.flatten(m.map(E=>(E==null?void 0:E.message)?I.isArray(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},m=>{t.dispose();const p=y.toErrorMessage(m);i(new Error(p))})})}resultSize(u){return S(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,d){const f=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:f.slice(0,d),preview:{matches:t.slice(0,d),text:u.preview.text},uri:u.uri}}async searchInFolder(u,d,f){const t=new P.QueryGlobTester(this.query,u),n=[],i={report:m=>{if(!this.validateProviderResult(m))return;const p=u.folder.scheme===s.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(m.uri))):void 0,E=A.relativePath(u.folder,m.uri);E&&n.push(t.includedInQuery(E,v.basename(E),p).then(b=>{b&&d(m)}))}},r=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,i,f);return await Promise.all(n),o}validateProviderResult(u){if(S(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const d=P.resolvePatternsForProvider(this.query.includePattern,u.includePattern),f=P.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:f,includes:d,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=a;function g(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,d=>this.sendItems(d))}add(u,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(h(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function h(_){return S(_)?{preview:{matches:R.mapArrayOrNot(_.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:_.preview.text},ranges:R.mapArrayOrNot(_.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function S(_){return!!_.preview}e.extensionResultIsMatch=S;class w{constructor(u,d){this.maxBatchSize=u,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,d){!u||this.addItemToBatch(u,d)}addItems(u,d){!u||this.addItemsToBatch(u,d)}addItemToBatch(u,d){this.batch.push(u),this.batchSize+=d,this.onUpdate()}addItemsToBatch(u,d){this.batch=this.batch.concat(u),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(pe[67],ve([0,1,6,5,4,255,12,59,15,2,127]),function(Q,e,v,R,k,y,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let I=class{constructor(h,S,w){this.extHostRpc=h,this._uriTransformer=S,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new y.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,S){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const w=this._handlePool++;return this._textSearchProvider.set(w,S),this._proxy.$registerTextSearchProvider(w,this._transformScheme(h)),v.toDisposable(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(h,S){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const w=this._handlePool++;return this._fileSearchProvider.set(w,S),this._proxy.$registerFileSearchProvider(w,this._transformScheme(h)),v.toDisposable(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(h,S,w,_){const u=a(w),d=this._fileSearchProvider.get(h);if(d)return this._fileSearchManager.fileSearch(u,d,f=>{this._proxy.$handleFileMatch(h,S,f.map(t=>t.resource))},_);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,S,w,_){const u=this._textSearchProvider.get(h);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const d=a(w);return this.createTextSearchManager(d,u).search(t=>this._proxy.$handleTextMatch(h,S,t),_)}createTextSearchManager(h,S){return new s.TextSearchManager(h,S,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([He(0,A.IExtHostRpcService),He(1,C.IURITransformerService),He(2,D.ILogService)],I),e.ExtHostSearch=I;function a(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(g),extraFileResources:c.extraFileResources&&c.extraFileResources.map(h=>P.URI.revive(h))})}e.reviveQuery=a;function g(c){return Object.assign(Object.assign({},c),{folder:P.URI.revive(c.folder)})}}),define(pe[256],ve([0,1,21,16,3,52,2,150,105,141,77,42,5,217,216,47,218,36,219,220,221,203,222,39,40,223,204,225,226,227,62,206,231,232,233,88,33,234,207,18,7,237,63,126,34,35,68,194,224,116,125,65,48,67,15,59,12,27,228,192,46,61,214,235,191,89,87,240,238,239,215,58,248,236,86,45,117,229,64,230,10,181]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d,f,t,n,i,r,o,m,p,E,b,l,L,O,W,Z,oe,V,$,j,T,N,F,M,U,x,K,se,be,Te,Ce,Fe,qe,ze,Ge,q,J,re,ae,Y,ce,ge,Re,we,je,G,ie,Ee,Ne,$e,We,Xe,De,ye,ke,le,he,H,ee,ue,Pe,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ue(xe){const Qe=xe.get(re.IExtHostInitDataService),rt=xe.get(Xe.IExtHostFileSystemInfo),tt=xe.get(ie.IExtHostConsumerFileSystem),Ye=xe.get(i.IExtHostExtensionService),ot=xe.get(U.IExtHostWorkspace),Et=xe.get(he.IExtHostTelemetry),bt=xe.get(w.IExtHostConfiguration),_e=xe.get(q.IURITransformerService),fe=xe.get(J.IExtHostRpcService),de=xe.get(Z.IExtHostStorage),X=xe.get(G.IExtensionStoragePaths),Oe=xe.get(Ge.ILogService),Le=xe.get(ce.IExtHostTunnelService),Ze=xe.get(ge.IExtHostApiDeprecationService),et=xe.get(M.IExtHostWindow),ft=xe.get(ke.IExtHostSecretState),ct=xe.get(le.IExtHostEditorTabs);fe.set(a.ExtHostContext.ExtHostFileSystemInfo,rt),fe.set(a.ExtHostContext.ExtHostLogService,Oe),fe.set(a.ExtHostContext.ExtHostWorkspace,ot),fe.set(a.ExtHostContext.ExtHostConfiguration,bt),fe.set(a.ExtHostContext.ExtHostExtensionService,Ye),fe.set(a.ExtHostContext.ExtHostStorage,de),fe.set(a.ExtHostContext.ExtHostTunnelService,Le),fe.set(a.ExtHostContext.ExtHostWindow,et),fe.set(a.ExtHostContext.ExtHostSecretState,ft),fe.set(a.ExtHostContext.ExtHostTelemetry,Et),fe.set(a.ExtHostContext.ExtHostEditorTabs,ct);const it=fe.set(a.ExtHostContext.ExtHostDecorations,xe.get(Ce.IExtHostDecorations)),vt=fe.set(a.ExtHostContext.ExtHostDocumentsAndEditors,xe.get(n.IExtHostDocumentsAndEditors)),ht=fe.set(a.ExtHostContext.ExtHostCommands,xe.get(h.IExtHostCommands)),lt=fe.set(a.ExtHostContext.ExtHostTerminalService,xe.get(oe.IExtHostTerminalService)),mt=fe.set(a.ExtHostContext.ExtHostDebugService,xe.get(qe.IExtHostDebugService)),It=fe.set(a.ExtHostContext.ExtHostSearch,xe.get(ze.IExtHostSearch)),Ct=fe.set(a.ExtHostContext.ExtHostTask,xe.get(Fe.IExtHostTask)),At=fe.set(a.ExtHostContext.ExtHostOutputService,xe.get(b.IExtHostOutputService)),Rt=fe.set(a.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(fe)),St=fe.set(a.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(fe,vt)),Xt=fe.set(a.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(fe,vt,Oe)),Yt=fe.set(a.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Oe,St,fe.getProxy(a.MainContext.MainThreadBulkEdits))),pt=fe.set(a.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(fe,ht,vt,St,Oe,X)),Jt=fe.set(a.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(fe,Qe,pt,Oe)),Zt=fe.set(a.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(fe,pt)),Dt=fe.set(a.ExtHostContext.ExtHostEditors,new V.ExtHostEditors(fe,vt)),hn=fe.set(a.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(fe.getProxy(a.MainContext.MainThreadTreeViews),ht,Oe)),en=fe.set(a.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(fe.getProxy(a.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=fe.set(a.ExtHostContext.ExtHostDiagnostics,new _.ExtHostDiagnostics(fe,Oe)),ut=fe.set(a.ExtHostContext.ExtHostLanguageFeatures,new m.ExtHostLanguageFeatures(fe,_e,St,ht,xt,Oe,Ze)),tn=fe.set(a.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(fe,ut)),Ft=fe.set(a.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(fe,Oe,vt)),Mt=fe.set(a.ExtHostContext.ExtHostQuickOpen,L.createExtHostQuickOpen(fe,ot,ht)),qt=fe.set(a.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(fe,ht,Oe)),En=fe.set(a.ExtHostContext.ExtHostComments,new S.ExtHostComments(fe,ht,St)),fn=fe.set(a.ExtHostContext.ExtHostProgress,new l.ExtHostProgress(fe.getProxy(a.MainContext.MainThreadProgress))),_n=fe.set(a.ExtHostContext.ExtHosLabelService,new be.ExtHostLabelService(fe)),mn=fe.set(a.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(fe)),Bt=fe.set(a.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(fe)),nn=fe.set(a.ExtHostContext.ExtHostTimeline,new we.ExtHostTimeline(fe,ht)),Ht=fe.set(a.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(fe,{remote:Qe.remote},ot,Oe,Ze)),rn=fe.set(a.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(fe,Ht,ot)),Sn=fe.set(a.ExtHostContext.ExtHostCustomEditors,new Ne.ExtHostCustomEditors(fe,St,X,Ht,rn)),yn=fe.set(a.ExtHostContext.ExtHostWebviewViews,new Ee.ExtHostWebviewViews(fe,Ht)),Ot=fe.set(a.ExtHostContext.ExtHostTesting,new De.ExtHostTesting(fe,vt,ot)),Gt=fe.set(a.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(fe)),Dn=K.values(a.ExtHostContext);fe.assertRegistered(Dn);const Cn=new We.ExtHostBulkEdits(fe,vt),sn=new c.ExtHostClipboard(fe),on=new E.ExtHostMessageService(fe,Oe),$t=new u.ExtHostDialogs(fe),Kt=new W.ExtHostStatusBar(fe,ht.converter),Wt=new p.ExtHostLanguages(fe,St);return g.ExtHostApiCommands.register(ht),function(Me,an,Pt){const gt=function(){let te=!Me.isUnderDevelopment;function me(Ae){te||(Oe.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")me(st);else{const wt=st;typeof wt.scheme=="undefined"&&me(st),!Me.enableProposedApi&&typeof wt.exclusive=="boolean"&&x.throwProposedApiError(Me)}return st}}(),kn={getSession(te,me,Ae){return Bt.getSession(Me,te,me,Ae)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(te,me,Ae,st){return Bt.registerAuthenticationProvider(te,me,Ae,st)},get onDidChangeAuthenticationProviders(){return x.checkProposedApiEnabled(Me),Bt.onDidChangeAuthenticationProviders},get providers(){return x.checkProposedApiEnabled(Me),Bt.providers},logout(te,me){return x.checkProposedApiEnabled(Me),Bt.removeSession(te,me)}},Pn={registerCommand(te,me,Ae){return ht.registerCommand(!0,te,me,Ae)},registerTextEditorCommand(te,me,Ae){return ht.registerCommand(!0,te,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Oe.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(_t=>{me.apply(Ae,[wt,_t,...st])}).then(_t=>{_t||Oe.warn("Edits from command "+te+" were not applied.")},_t=>{Oe.warn("An error occurred while running command "+te,_t)})})},registerDiffInformationCommand:(te,me,Ae)=>(x.checkProposedApiEnabled(Me),ht.registerCommand(!0,te,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Oe.warn("Cannot execute "+te+" because there is no active text editor.");return}const _t=await Dt.getDiffInformation(wt.id);me.apply(Ae,[_t,...st])})),executeCommand(te,...me){return ht.executeCommand(te,...me)},getCommands(te=!1){return ht.getCommands(te)}},gn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var te,me;return(me=(te=Qe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&me!==void 0?me:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return Et.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Et.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,me){return et.openUri(te,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:me==null?void 0:me.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Qe.environment.appUriScheme)return Rt.createAppUri(te);!Ie.matchesScheme(te,Pe.Schemas.http)&&!Ie.matchesScheme(te,Pe.Schemas.https)&&x.checkProposedApiEnabled(Me);try{return await et.asExternalUri(te,{allowTunneling:!!Qe.remote.authority})}catch(me){return te}},get remoteName(){return Te.getRemoteName(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=Qe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,ln={registerTestController(te){return x.checkProposedApiEnabled(Me),Ot.registerTestController(Me.identifier.value,te)},createDocumentTestObserver(te){return x.checkProposedApiEnabled(Me),Ot.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return x.checkProposedApiEnabled(Me),Ot.createWorkspaceTestObserver(te)},runTests(te){return x.checkProposedApiEnabled(Me),Ot.runTests(te)},createTestItem(te,me){return new T.TestItemImpl(te.id,te.label,te.uri,me)},createTestRun(te,me,Ae){return x.checkProposedApiEnabled(Me),Ot.createTestRun(Me.identifier.value,te,me,Ae)},get onDidChangeTestResults(){return x.checkProposedApiEnabled(Me),Ot.onResultsChanged},get testResults(){return x.checkProposedApiEnabled(Me),Ot.results}};ln.createTestRunTask=ln.createTestRun;const In={getExtension(te){const me=an.getExtensionDescription(te);if(me)return new i.Extension(Ye,Me.identifier,me,pn)},get all(){return an.getAllExtensionDescriptions().map(te=>new i.Extension(Ye,Me.identifier,te,pn))},get onDidChange(){return an.onDidChange}},An={createDiagnosticCollection(te){return xt.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:te=>xt.getDiagnostics(te),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(te,me){return Wt.changeLanguage(te.uri,me)},match(te,me){return s.score(j.LanguageSelector.from(te),me.uri,me.languageId,!0)},registerCodeActionsProvider(te,me,Ae){return ut.registerCodeActionProvider(Me,gt(te),me,Ae)},registerCodeLensProvider(te,me){return ut.registerCodeLensProvider(Me,gt(te),me)},registerDefinitionProvider(te,me){return ut.registerDefinitionProvider(Me,gt(te),me)},registerDeclarationProvider(te,me){return ut.registerDeclarationProvider(Me,gt(te),me)},registerImplementationProvider(te,me){return ut.registerImplementationProvider(Me,gt(te),me)},registerTypeDefinitionProvider(te,me){return ut.registerTypeDefinitionProvider(Me,gt(te),me)},registerHoverProvider(te,me){return ut.registerHoverProvider(Me,gt(te),me,Me.identifier)},registerEvaluatableExpressionProvider(te,me){return ut.registerEvaluatableExpressionProvider(Me,gt(te),me,Me.identifier)},registerInlineValuesProvider(te,me){return ut.registerInlineValuesProvider(Me,gt(te),me,Me.identifier)},registerDocumentHighlightProvider(te,me){return ut.registerDocumentHighlightProvider(Me,gt(te),me)},registerLinkedEditingRangeProvider(te,me){return ut.registerLinkedEditingRangeProvider(Me,gt(te),me)},registerReferenceProvider(te,me){return ut.registerReferenceProvider(Me,gt(te),me)},registerRenameProvider(te,me){return ut.registerRenameProvider(Me,gt(te),me)},registerDocumentSymbolProvider(te,me,Ae){return ut.registerDocumentSymbolProvider(Me,gt(te),me,Ae)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,me){return ut.registerDocumentFormattingEditProvider(Me,gt(te),me)},registerDocumentRangeFormattingEditProvider(te,me){return ut.registerDocumentRangeFormattingEditProvider(Me,gt(te),me)},registerOnTypeFormattingEditProvider(te,me,Ae,...st){return ut.registerOnTypeFormattingEditProvider(Me,gt(te),me,[Ae].concat(st))},registerDocumentSemanticTokensProvider(te,me,Ae){return ut.registerDocumentSemanticTokensProvider(Me,gt(te),me,Ae)},registerDocumentRangeSemanticTokensProvider(te,me,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Me,gt(te),me,Ae)},registerSignatureHelpProvider(te,me,Ae,...st){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Me,gt(te),me,Ae):ut.registerSignatureHelpProvider(Me,gt(te),me,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(te,me,...Ae){return ut.registerCompletionItemProvider(Me,gt(te),me,Ae)},registerInlineCompletionItemProvider(te,me){return x.checkProposedApiEnabled(Me),ut.registerInlineCompletionsProvider(Me,gt(te),me)},registerDocumentLinkProvider(te,me){return ut.registerDocumentLinkProvider(Me,gt(te),me)},registerColorProvider(te,me){return ut.registerColorProvider(Me,gt(te),me)},registerFoldingRangeProvider(te,me){return ut.registerFoldingRangeProvider(Me,gt(te),me)},registerSelectionRangeProvider(te,me){return ut.registerSelectionRangeProvider(Me,te,me)},registerCallHierarchyProvider(te,me){return ut.registerCallHierarchyProvider(Me,te,me)},setLanguageConfiguration:(te,me)=>ut.setLanguageConfiguration(Me,te,me),getTokenInformationAtPosition(te,me){return x.checkProposedApiEnabled(Me),Wt.tokenAtPosition(te,me)},registerInlayHintsProvider(te,me){return x.checkProposedApiEnabled(Me),ut.registerInlayHintsProvider(Me,te,me)}},cn={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(te,me,Ae){const st=await(A.URI.isUri(te)?Promise.resolve(vn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,me,Ae)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Me,te)},onDidChangeActiveTextEditor(te,me,Ae){return Dt.onDidChangeActiveTextEditor(te,me,Ae)},onDidChangeVisibleTextEditors(te,me,Ae){return Dt.onDidChangeVisibleTextEditors(te,me,Ae)},onDidChangeTextEditorSelection(te,me,Ae){return Dt.onDidChangeTextEditorSelection(te,me,Ae)},onDidChangeTextEditorOptions(te,me,Ae){return Dt.onDidChangeTextEditorOptions(te,me,Ae)},onDidChangeTextEditorVisibleRanges(te,me,Ae){return Dt.onDidChangeTextEditorVisibleRanges(te,me,Ae)},onDidChangeTextEditorViewColumn(te,me,Ae){return Dt.onDidChangeTextEditorViewColumn(te,me,Ae)},onDidCloseTerminal(te,me,Ae){return lt.onDidCloseTerminal(te,me,Ae)},onDidOpenTerminal(te,me,Ae){return lt.onDidOpenTerminal(te,me,Ae)},onDidChangeActiveTerminal(te,me,Ae){return lt.onDidChangeActiveTerminal(te,me,Ae)},onDidChangeTerminalDimensions(te,me,Ae){return x.checkProposedApiEnabled(Me),lt.onDidChangeTerminalDimensions(te,me,Ae)},onDidWriteTerminalData(te,me,Ae){return x.checkProposedApiEnabled(Me),lt.onDidWriteTerminalData(te,me,Ae)},get state(){return et.state},onDidChangeWindowState(te,me,Ae){return et.onDidChangeWindowState(te,me,Ae)},showInformationMessage(te,...me){return on.showMessage(Me,y.default.Info,te,me[0],me.slice(1))},showWarningMessage(te,...me){return on.showMessage(Me,y.default.Warning,te,me[0],me.slice(1))},showErrorMessage(te,...me){return on.showMessage(Me,y.default.Error,te,me[0],me.slice(1))},showQuickPick(te,me,Ae){return Mt.showQuickPick(te,!!Me.enableProposedApi,me,Ae)},showWorkspaceFolderPick(te){return Mt.showWorkspaceFolderPick(te)},showInputBox(te,me){return Mt.showInput(te,me)},showOpenDialog(te){return $t.showOpenDialog(te)},showSaveDialog(te){return $t.showSaveDialog(te)},createStatusBarItem(te,me,Ae){let st,wt,_t;return typeof te=="string"?(st=te,wt=me,_t=Ae):(wt=te,_t=me),Kt.createStatusBarEntry(Me,st,wt,_t)},setStatusBarMessage(te,me){return Kt.setStatusBarMessage(te,me)},withScmProgress(te){return Ze.report("window.withScmProgress",Me,"Use 'withProgress' instead."),fn.withProgress(Me,{location:T.ProgressLocation.SourceControl},(me,Ae)=>te({report(st){}}))},withProgress(te,me){return fn.withProgress(Me,te,me)},createOutputChannel(te){return At.createOutputChannel(te)},createWebviewPanel(te,me,Ae,st){return rn.createWebviewPanel(Me,te,me,Ae,st)},createWebviewTextEditorInset(te,me,Ae,st){return x.checkProposedApiEnabled(Me),en.createWebviewEditorInset(te,me,Ae,st,Me)},createTerminal(te,me,Ae){return typeof te=="object"?"pty"in te?lt.createExtensionTerminal(te):(te.iconPath&&x.checkProposedApiEnabled(Me),lt.createTerminalFromOptions(te)):lt.createTerminal(te,me,Ae)},registerTerminalLinkProvider(te){return lt.registerLinkProvider(te)},registerTerminalProfileProvider(te,me){return lt.registerProfileProvider(te,me)},registerTreeDataProvider(te,me){return hn.registerTreeDataProvider(te,me,Me)},createTreeView(te,me){return hn.createTreeView(te,me,Me)},registerWebviewPanelSerializer:(te,me)=>rn.registerWebviewPanelSerializer(Me,te,me),registerCustomEditorProvider:(te,me,Ae={})=>Sn.registerCustomEditorProvider(Me,te,me,Ae),registerFileDecorationProvider(te){return it.registerFileDecorationProvider(te,Me.identifier)},registerUriHandler(te){return Rt.registerUriHandler(Me.identifier,te)},createQuickPick(){return Mt.createQuickPick(Me.identifier,!!Me.enableProposedApi)},createInputBox(){return Mt.createInputBox(Me.identifier)},get activeColorTheme(){return mn.activeColorTheme},onDidChangeActiveColorTheme(te,me,Ae){return mn.onDidChangeActiveColorTheme(te,me,Ae)},registerWebviewViewProvider(te,me,Ae){return yn.registerWebviewViewProvider(Me,te,me,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return x.checkProposedApiEnabled(Me),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeActiveNotebookEditor(te,me,Ae)},get visibleNotebookEditors(){return x.checkProposedApiEnabled(Me),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return x.checkProposedApiEnabled(Me),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeNotebookEditorSelection(te,me,Ae)},onDidChangeNotebookEditorVisibleRanges(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeNotebookEditorVisibleRanges(te,me,Ae)},showNotebookDocument(te,me){return x.checkProposedApiEnabled(Me),pt.showNotebookDocument(te,me)},registerExternalUriOpener(te,me,Ae){return x.checkProposedApiEnabled(Me),Gt.registerExternalUriOpener(Me.identifier,te,me,Ae)},get openEditors(){return x.checkProposedApiEnabled(Me),ct.tabs},get onDidChangeOpenEditors(){return x.checkProposedApiEnabled(Me),ct.onDidChangeTabs},getInlineCompletionItemController(te){return x.checkProposedApiEnabled(Me),m.InlineCompletionController.get(te)}},vn={get rootPath(){return Ze.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,me,...Ae)=>ot.updateWorkspaceFolders(Me,te,me||0,...Ae),onDidChangeWorkspaceFolders:function(te,me,Ae){return ot.onDidChangeWorkspace(te,me,Ae)},asRelativePath:(te,me)=>ot.getRelativePath(te,me),findFiles:(te,me,Ae,st)=>ot.findFiles(j.GlobPattern.from(te),j.GlobPattern.from(me),Ae,Me.identifier,st),findTextInFiles:(te,me,Ae,st)=>{let wt,_t;return typeof me=="object"?(wt=me,_t=Ae):(wt={},_t=me,st=Ae),ot.findTextInFiles(te,wt||{},_t,Me.identifier,st)},saveAll:te=>ot.saveAll(te),applyEdit(te){return Cn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,me,Ae,st)=>Ft.createFileSystemWatcher(j.GlobPattern.from(te),me,Ae,st),get textDocuments(){return St.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let me;const Ae=te;if(typeof te=="string")me=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))me=Promise.resolve(te);else if(!Ae||typeof Ae=="object")me=St.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(st=>St.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(te,me,Ae)=>St.onDidAddDocument(te,me,Ae),onDidCloseTextDocument:(te,me,Ae)=>St.onDidRemoveDocument(te,me,Ae),onDidChangeTextDocument:(te,me,Ae)=>St.onDidChangeDocument(te,me,Ae),onDidSaveTextDocument:(te,me,Ae)=>St.onDidSaveDocument(te,me,Ae),onWillSaveTextDocument:(te,me,Ae)=>Yt.getOnWillSaveTextDocumentEvent(Me)(te,me,Ae),onDidChangeConfiguration:(te,me,Ae)=>Pt.onDidChangeConfiguration(te,me,Ae),getConfiguration(te,me){return me=arguments.length===1?void 0:me,Pt.getConfiguration(te,me,Me)},registerTextDocumentContentProvider(te,me){return Xt.registerTextDocumentContentProvider(te,me)},registerTaskProvider:(te,me)=>(Ze.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Me,te,me)),registerFileSystemProvider(te,me,Ae){return tn.registerFileSystemProvider(Me.identifier,te,me,Ae,Me.enableProposedApi)},get fs(){return tt.value},registerFileSearchProvider:(te,me)=>(x.checkProposedApiEnabled(Me),It.registerFileSearchProvider(te,me)),registerTextSearchProvider:(te,me)=>(x.checkProposedApiEnabled(Me),It.registerTextSearchProvider(te,me)),registerRemoteAuthorityResolver:(te,me)=>(x.checkProposedApiEnabled(Me),Ye.registerRemoteAuthorityResolver(te,me)),registerResourceLabelFormatter:te=>(x.checkProposedApiEnabled(Me),_n.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,me,Ae)=>Ft.onDidCreateFile(te,me,Ae),onDidDeleteFiles:(te,me,Ae)=>Ft.onDidDeleteFile(te,me,Ae),onDidRenameFiles:(te,me,Ae)=>Ft.onDidRenameFile(te,me,Ae),onWillCreateFiles:(te,me,Ae)=>Ft.getOnWillCreateFileEvent(Me)(te,me,Ae),onWillDeleteFiles:(te,me,Ae)=>Ft.getOnWillDeleteFileEvent(Me)(te,me,Ae),onWillRenameFiles:(te,me,Ae)=>Ft.getOnWillRenameFileEvent(Me)(te,me,Ae),openTunnel:te=>(x.checkProposedApiEnabled(Me),Le.openTunnel(Me,te).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return x.checkProposedApiEnabled(Me),Le.getTunnels()},onDidChangeTunnels:(te,me,Ae)=>(x.checkProposedApiEnabled(Me),Le.onDidChangeTunnels(te,me,Ae)),registerPortAttributesProvider:(te,me)=>(x.checkProposedApiEnabled(Me),Le.registerPortsAttributesProvider(te,me)),registerTimelineProvider:(te,me)=>(x.checkProposedApiEnabled(Me),nn.registerTimelineProvider(te,me,Me.identifier,ht.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>(x.checkProposedApiEnabled(Me),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,me,Ae)=>ot.onDidGrantWorkspaceTrust(te,me,Ae)},Tn={get inputBox(){return Ze.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),qt.getLastInputBox(Me)},createSourceControl(te,me,Ae){return qt.createSourceControl(Me,te,me,Ae)}},Rn={createCommentController(te,me){return En.createCommentController(Me,te,me)}},Ln={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(te,me,Ae){return mt.onDidStartDebugSession(te,me,Ae)},onDidTerminateDebugSession(te,me,Ae){return mt.onDidTerminateDebugSession(te,me,Ae)},onDidChangeActiveDebugSession(te,me,Ae){return mt.onDidChangeActiveDebugSession(te,me,Ae)},onDidReceiveDebugSessionCustomEvent(te,me,Ae){return mt.onDidReceiveDebugSessionCustomEvent(te,me,Ae)},onDidChangeBreakpoints(te,me,Ae){return mt.onDidChangeBreakpoints(te,me,Ae)},registerDebugConfigurationProvider(te,me,Ae){return mt.registerDebugConfigurationProvider(te,me,Ae||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,me){return mt.registerDebugAdapterDescriptorFactory(Me,te,me)},registerDebugAdapterTrackerFactory(te,me){return mt.registerDebugAdapterTrackerFactory(te,me)},startDebugging(te,me,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?mt.startDebugging(te,me,{parentSession:Ae}):mt.startDebugging(te,me,Ae||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,me){return mt.asDebugSourceUri(te,me)}},Fn={registerTaskProvider:(te,me)=>Ct.registerTaskProvider(Me,te,me),fetchTasks:te=>Ct.fetchTasks(te),executeTask:te=>Ct.executeTask(Me,te),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(te,me,Ae)=>Ct.onDidStartTask(te,me,Ae),onDidEndTask:(te,me,Ae)=>Ct.onDidEndTask(te,me,Ae),onDidStartTaskProcess:(te,me,Ae)=>Ct.onDidStartTaskProcess(te,me,Ae),onDidEndTaskProcess:(te,me,Ae)=>Ct.onDidEndTaskProcess(te,me,Ae)},wn={get notebookDocuments(){return pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,me){let Ae;if(A.URI.isUri(te))Ae=te,await pt.openNotebookDocument(te);else if(typeof te=="string")Ae=A.URI.revive(await pt.createNotebookDocument({viewType:te,content:me}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(te,me,Ae,st){return pt.registerNotebookSerializer(Me,te,me,Ae,Me.enableProposedApi?st:void 0)},createNotebookController(te,me,Ae,st,wt){return Jt.createNotebookController(Me,te,me,Ae,st,Me.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,me)=>pt.registerNotebookCellStatusBarItemProvider(Me,te,me),get onDidSaveNotebookDocument(){return x.checkProposedApiEnabled(Me),pt.onDidSaveNotebookDocument},registerNotebookContentProvider:(te,me,Ae,st)=>(x.checkProposedApiEnabled(Me),pt.registerNotebookContentProvider(Me,te,me,Ae,Me.enableProposedApi?st:void 0)),createNotebookEditorDecorationType(te){return x.checkProposedApiEnabled(Me),pt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return x.checkProposedApiEnabled(Me),Zt.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeNotebookDocumentMetadata(te,me,Ae)},onDidChangeNotebookCells(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeNotebookCells(te,me,Ae)},onDidChangeNotebookCellExecutionState(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeNotebookCellExecutionState(te,me,Ae)},onDidChangeCellOutputs(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeCellOutputs(te,me,Ae)},onDidChangeCellMetadata(te,me,Ae){return x.checkProposedApiEnabled(Me),pt.onDidChangeCellMetadata(te,me,Ae)},createConcatTextDocument(te,me){return x.checkProposedApiEnabled(Me),new je.ExtHostNotebookConcatDocument(pt,St,te,me)}};return{version:Qe.version,authentication:kn,commands:Pn,comments:Rn,debug:Ln,env:gn,extensions:In,languages:An,notebooks:wn,notebook:wn,scm:Tn,tasks:Fn,test:ln,window:cn,workspace:vn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:a.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:P.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:a.UIKind,Uri:A.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookDocumentMetadata:T.NotebookDocumentMetadata,NotebookCellMetadata:T.NotebookCellMetadata,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestItemStatus:T.TestItemStatus,TestResultState:T.TestResultState,TestMessage:T.TestMessage,TextSearchCompleteMessageType:ee.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ue}),define(pe[257],ve([0,1,78,62,34,125,36,47,39,33,65,48,67,89,88,46,61,126,87,58,86,117,45]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_,u,d,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(g.IExtensionStoragePaths,g.ExtensionStoragePaths),v.registerSingleton(S.IExtHostApiDeprecationService,S.ExtHostApiDeprecationService),v.registerSingleton(C.IExtHostCommands,C.ExtHostCommands),v.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),v.registerSingleton(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),v.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),v.registerSingleton(y.IExtHostDecorations,y.ExtHostDecorations),v.registerSingleton(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),v.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),v.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),v.registerSingleton(a.IExtHostSearch,a.ExtHostSearch),v.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),v.registerSingleton(s.IExtHostTask,s.WorkerExtHostTask),v.registerSingleton(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),v.registerSingleton(h.IExtHostTunnelService,h.ExtHostTunnelService),v.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),v.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),v.registerSingleton(d.IExtHostSecretState,d.ExtHostSecretState),v.registerSingleton(f.IExtHostTelemetry,f.ExtHostTelemetry),v.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(pe[90],ve([0,1,17,15,31,64]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function C(I,a,g,c){const h=v.mapArrayOrNot(g,D),S=new k.TextSearchMatch(a,h,c),w=S.preview.matches;return{ranges:v.mapArrayOrNot(h,P),uri:I,preview:{text:S.preview.text,matches:v.mapArrayOrNot(w,P)}}}e.createTextSearchResult=C;function D(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new y.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let s=class{constructor(a,g){this.prefix=a,this.logService=g}appendLine(a){this.logService.debug(`${this.prefix}#search`,a)}};s=Ve([He(1,R.ILogService)],s),e.OutputChannel=s}),define(pe[258],ve([0,1,92,22]),function(Q,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const y=512,A=512,C=512*8,D=512*128;class P{constructor(n){this.iconvLiteDecoder=n}static async create(n){let i;if(n!==e.UTF8)i=(await new Promise((o,m)=>{Q(["iconv-lite-umd"],o,m)})).getDecoder(g(n));else{const r=new TextDecoder;i={write(o){return r.decode(o,{stream:!0})},end(){return r.decode()}}}return new P(i)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function s(t,n){var i;const r=((i=n.minBytesRequiredForDetection)!==null&&i!==void 0?i:n.guessEncoding)?C:A;return new Promise((o,m)=>{const p=v.newWriteableStream(O=>O.join("")),E=[];let b=0,l;const L=async()=>{try{const O=await f({buffer:R.VSBuffer.concat(E),bytesRead:b},n.guessEncoding);O.encoding=await n.overwriteEncoding(O.encoding),l=await P.create(O.encoding);const W=l.write(R.VSBuffer.concat(E).buffer);p.write(W),E.length=0,b=0,o({stream:p,detected:O})}catch(O){m(O)}};v.listenStream(t,{onData:async O=>{l?p.write(l.write(O.buffer)):(E.push(O),b+=O.byteLength,b>=r&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>p.error(O),onEnd:async()=>{l||await L(),p.end(l==null?void 0:l.end())}})})}e.toDecodeStream=s;async function I(t,n,i){const o=(await new Promise((E,b)=>{Q(["iconv-lite-umd"],E,b)})).getEncoder(g(n),i);let m=!1,p=!1;return{read(){if(p)return null;const E=t.read();if(typeof E!="string"){if(p=!0,!m&&(i==null?void 0:i.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const b=o.end();return b&&b.length>0?(m=!0,R.VSBuffer.wrap(b)):null}return m=!0,R.VSBuffer.wrap(o.write(E))}}}e.toEncodeReadable=I;async function a(t){return(await new Promise((i,r)=>{Q(["iconv-lite-umd"],i,r)})).encodingExists(g(t))}e.encodingExists=a;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function c(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const i=t.readUInt8(0),r=t.readUInt8(1);if(i===e.UTF16be_BOM[0]&&r===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&r===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return i===e.UTF8_BOM[0]&&r===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const h=["ascii","utf-16","utf-32"];async function S(t){const n=await new Promise((p,E)=>{Q(["jschardet"],p,E)}),i=t.slice(0,D),r=u(i.buffer),o=n.detect(r);if(!o||!o.encoding)return null;const m=o.encoding.toLowerCase();return 0<=h.indexOf(m)?null:_(o.encoding)}const w={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function u(t){let n="";for(let i=0;i<t.length;i++)n+=String.fromCharCode(t[i]);return n}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=d;function f({buffer:t,bytesRead:n},i){let r=c(t,n),o=!1;if(r!==e.UTF16be&&r!==e.UTF16le&&t){let m=!0,p=!0,E=!1;for(let b=0;b<n&&b<y;b++){const l=b%2==1,L=t.readUInt8(b)===0;if(L&&(E=!0),m&&(l&&!L||!l&&L)&&(m=!1),p&&(l&&L||!l&&!L)&&(p=!1),L&&!m&&!p)break}E&&(m?r=e.UTF16le:p?r=e.UTF16be:o=!0)}return i&&!o&&!r&&t?S(t.slice(0,n)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:o,encoding:r}}e.detectEncodingFromBuffer=f,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[128],ve([0,1,258,28,127]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class y extends k.TextSearchManager{constructor(C,D,P=R){super(C,D,{readdir:s=>P.readdir(s.fsPath),toCanonicalName:s=>v.toCanonicalName(s)})}}e.NativeTextSearchManager=y}),define(pe[259],ve([0,1,260,274,275,2,276]),function(Q,e,v,R,k,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,a,g,c,h,S){const w=S.environment.useHostProxy,_=typeof w=="boolean"?w:!S.remote.isRemote,u=A.createProxyResolver({resolveProxy:f=>I.resolveProxy(f),getHttpProxySetting:()=>a.getConfiguration("http").get("proxy"),log:(f,t,...n)=>{switch(f){case A.LogLevel.Trace:c.trace(t,...n);break;case A.LogLevel.Debug:c.debug(t,...n);break;case A.LogLevel.Info:c.info(t,...n);break;case A.LogLevel.Warning:c.warn(t,...n);break;case A.LogLevel.Error:c.error(t,...n);break;case A.LogLevel.Critical:c.critical(t,...n);break;case A.LogLevel.Off:break;default:i(f,t,n);break}function i(r,o,...m){c.error("Unknown log level",r),c.error(o,...m)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:f=>{h.$publicLog2("resolveProxy",f)},useHostProxy:_,env:process.env}),d=D(a,u);return s(g,d)}e.connectProxyResolver=C;function D(I,a){const g={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(h=>{g.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(h=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,A.createHttpPatch(v,a,{config:"off"},c,!0)),on:Object.assign({},v,A.createHttpPatch(v,a,{config:"on"},c,!0)),override:Object.assign({},v,A.createHttpPatch(v,a,{config:"override"},c,!0)),onRequest:Object.assign({},v,A.createHttpPatch(v,a,g,c,!0)),default:Object.assign(v,A.createHttpPatch(v,a,g,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,a,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,a,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,a,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,a,g,c,!0)),default:Object.assign(R,A.createHttpPatch(R,a,g,c,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const P=new Map;function s(I,a){return I.getExtensionPathIndex().then(g=>{const c=Q.__$__nodeRequire("module"),h=c._load;c._load=function(w,_,u){if(w==="tls")return a.tls;if(w!=="http"&&w!=="https")return h.apply(this,arguments);const d=a[w],f=g.findSubstr(y.URI.file(_.filename).fsPath);let t=P.get(f);if(t||P.set(f,t={}),!t[w]){let n=d.default;f&&f.enableProposedApi&&(n=d[f.proxySupport]||d.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(pe[261],ve([0,1,38,9,75,29,11,8,90,262]),function(Q,e,v,R,k,y,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(u,d,f,t){const n=a(u,d,f,t),i=d.folder.fsPath;return{cmd:v.spawn(s,n.args,{cwd:i}),rgDiskPath:s,siblingClauses:n.siblingClauses,rgArgs:n,cwd:i}}e.spawnRipgrepCmd=I;function a(u,d,f,t){const n=["--files","--hidden","--case-sensitive"];c([d],f,!1).forEach(r=>{const o=D.anchorGlob(r);if(n.push("-g",o),A.isMacintosh){const m=k.normalizeNFD(o);m!==o&&n.push("-g",m)}});const i=g([d],t,void 0,!1);return i.globArgs.forEach(r=>{const o=`!${D.anchorGlob(r)}`;if(n.push("-g",o),A.isMacintosh){const m=k.normalizeNFD(o);m!==o&&n.push("-g",m)}}),d.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),d.ignoreSymlinks||n.push("--follow"),u.exists&&n.push("--quiet"),n.push("--no-config"),d.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:i.siblingClauses}}function g(u,d,f,t=!0){const n=[];let i={};return u.forEach(r=>{const o=Object.assign({},r.excludePattern||{},d||{}),m=h(o,t?r.folder.fsPath:void 0,f);n.push(...m.globArgs),m.siblingClauses&&(i=Object.assign(i,m.siblingClauses))}),{globArgs:n,siblingClauses:i}}e.foldersToRgExcludeGlobs=g;function c(u,d,f=!0){const t=[];return u.forEach(n=>{const i=Object.assign({},d||{},n.includePattern||{}),r=h(i,f?n.folder.fsPath:void 0);t.push(...r.globArgs)}),t}e.foldersToIncludeGlobs=c;function h(u,d,f){const t=[],n={};return Object.keys(u).forEach(i=>{if(f&&f.has(i)||!i)return;const r=u[i];i=w(d?S(d,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof r=="boolean"&&r?(i.startsWith("\\\\")&&(i+="**"),t.push(_(i))):r&&r.when&&(n[i]=r)}),{globArgs:t,siblingClauses:n}}function S(u,d){return R.isAbsolute(d)?d:R.join(u,d)}e.getAbsoluteGlob=S;function w(u){return u=C.rtrim(u,"\\"),C.rtrim(u,"/")}function _(u){return y.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=_}),define(pe[263],ve([0,1,38,54,9,99,17,55,30,75,29,11,43,8,13,28,31,261,97]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(i=>i())});class d{constructor(r){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=r,this.filePattern=r.filePattern||"",this.includePattern=r.includePattern&&D.parse(r.includePattern),this.maxResults=r.maxResults||null,this.exists=!!r.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=_.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=r.excludePattern&&D.parse(r.excludePattern),this.folderExcludePatterns=new Map,r.folderQueries.forEach(o=>{const m=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),p=o.folder.fsPath;r.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==p).forEach(E=>{s.isEqualOrParent(E,p)&&(m[k.relative(p,E)]=!0)}),this.folderExcludePatterns.set(p,new t(m,p))})}cancel(){this.isCanceled=!0}walk(r,o,m,p,E){if(this.fileWalkSW=a.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);o.forEach(b=>{const l=k.basename(b.fsPath);this.globalExcludePattern&&this.globalExcludePattern(b.fsPath,l)||this.matchFile(m,{relativePath:b.fsPath,searchPath:void 0})}),this.cmdSW=a.StopWatch.create(!1),this.parallel(r,(b,l)=>{this.call(this.cmdTraversal,this,b,m,p,L=>{if(L){const O=C.toErrorMessage(L);console.error(O),this.errors.push(O),l(L,void 0)}else l(null,void 0)})},(b,l)=>{this.fileWalkSW.stop();const L=b?A.coalesce(b)[0]:null;E(L,this.isLimitHit)})}parallel(r,o,m){const p=new Array(r.length),E=new Array(r.length);let b=!1,l=0;if(r.length===0)return m(null,[]);r.forEach((L,O)=>{o(L,(W,Z)=>{if(W?(b=!0,p[O]=null,E[O]=W):(p[O]=Z,E[O]=null),++l===r.length)return m(b?E:null,p)})})}call(r,o,...m){try{r.apply(o,m)}catch(p){m[m.length-1](p)}}cmdTraversal(r,o,m,p){const E=r.folder.fsPath,b=I.isMacintosh;let l;const L=()=>l&&l.kill();u.add(L);let O=T=>{u.delete(L),O=()=>{},p(T)},W="";const Z=this.initDirectoryTree();let oe;const V=w.spawnRipgrepCmd(this.config,r,this.config.includePattern,this.folderExcludePatterns.get(r.folder.fsPath).expression);l=V.cmd,oe=!Object.keys(V.siblingClauses).length;const $=V.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let j=`${V.rgDiskPath} ${$}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),m({message:j}),this.cmdResultCount=0,this.collectStdout(l,"utf8",m,(T,N,F)=>{if(T){O(T);return}if(this.isLimitHit){O();return}const U=(W+(b?P.normalizeNFC(N||""):N)).split(`
`);if(F){const x=U.length;U[x-1]=U[x-1].trim(),U[x-1]||U.pop()}else W=U.pop()||"";if(U.length&&U[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=U.length,oe){for(const x of U)if(this.matchFile(o,{base:E,relativePath:x,searchPath:this.getSearchPath(r,x)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(r,Z,E,U,o),F&&(this.matchDirectoryTree(Z,E,o),O())})}spawnFindCmd(r){const o=this.folderExcludePatterns.get(r.folder.fsPath),m=o.getBasenameTerms(),p=o.getPathTerms(),E=["-L","."];if(m.length||p.length){E.push("-not","(","(");for(const b of m)E.push("-name",b),E.push("-o");for(const b of p)E.push("-path",b),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),v.spawn("find",E,{cwd:r.folder.fsPath})}readStdout(r,o,m){let p="";this.collectStdout(r,o,()=>{},(E,b,l)=>{if(E){m(E);return}p+=b,l&&m(null,p)})}collectStdout(r,o,m,p){let E=(L,O,W)=>{(L||W)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),p(L,O,W)},b=!1;r.stdout?(this.forwardData(r.stdout,o,E),r.stdout.once("data",()=>b=!0)):m({message:"stdout is null"});let l;r.stderr?l=this.collectData(r.stderr):m({message:"stderr is null"}),r.on("error",L=>{E(L)}),r.on("close",L=>{let O;!b&&(O=this.decodeData(l,o))&&n(O)?E(new Error(`command failed with error code ${L}: ${this.decodeData(l,o)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(r,o,m){const p=new y.StringDecoder(o);return r.on("data",E=>{m(null,p.write(E))}),p}collectData(r){const o=[];return r.on("data",m=>{o.push(m)}),o}decodeData(r,o){const m=new y.StringDecoder(o);return r.map(p=>m.write(p)).join("")}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries(r,{pathToEntries:o},m,p,E){p.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:m,relativePath:this.filePattern,searchPath:this.getSearchPath(r,this.filePattern)});const b=l=>{const L=k.basename(l),O=k.dirname(l);let W=o[O];W||(W=o[O]=[],b(O)),W.push({base:m,relativePath:l,basename:L,searchPath:this.getSearchPath(r,l)})};p.forEach(b)}matchDirectoryTree({rootEntries:r,pathToEntries:o},m,p){const E=this,b=this.folderExcludePatterns.get(m),l=this.filePattern;function L(O){E.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(Z=>Z.basename));for(let Z=0,oe=O.length;Z<oe;Z++){const V=O[Z],{relativePath:$,basename:j}=V;if(b.test($,j,l!==j?W:void 0))continue;const T=o[$];if(T)L(T);else{if(E.filesWalked++,$===l)continue;E.matchFile(p,V)}if(E.isLimitHit)break}}L(r)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(r,o,m,p,E){const b=r.folder,l=D.hasSiblingFn(()=>m);this.parallel(m,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=o?[o,L].join(k.sep):L;if(this.folderExcludePatterns.get(r.folder.fsPath).test(W,L,this.config.filePattern!==L?l:void 0))return O(null);const Z=[b.fsPath,W].join(k.sep);R.lstat(Z,(oe,V)=>{if(oe||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(Z,V,($,j)=>$||this.isCanceled||this.isLimitHit?O(null):j.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(Z,V,(T,N)=>T||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,h.readdir(Z).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(r,W,F,p,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&c.isNumber(j.size)&&j.size>this.maxFilesize||this.matchFile(p,{base:b.fsPath,relativePath:W,searchPath:this.getSearchPath(r,W)}),O(null,void 0)))})},L=>{const O=L&&A.coalesce(L);return E(O&&O.length>0?O[0]:void 0)})}matchFile(r,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,k.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||r(o))}isFileMatch(r){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return S.isFilePatternMatch(r,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(r,o,m){return o.isSymbolicLink()?R.stat(r,m):m(null,o)}realPathIfNeeded(r,o,m){return o.isSymbolicLink()?R.realpath(r,(p,E)=>p?m(p):m(null,E)):m(null,r)}getSearchPath(r,o){return r.folderName?k.join(r.folderName,o):o}}e.FileWalker=d;class f{constructor(r){this.folderQueries=r.folderQueries,this.extraFiles=r.extraFileResources||[],this.walker=new d(r)}search(r,o,m){this.walker.walk(this.folderQueries,this.extraFiles,r,o,(p,E)=>{m(p,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class t{constructor(r,o){this.expression=r,this.root=o,this.init(r)}init(r){let o,m;Object.keys(r).filter(p=>r[p]).forEach(p=>{k.isAbsolute(p)?(o=o||D.getEmptyExpression(),o[p]=r[p]):(m=m||D.getEmptyExpression(),m[p]=r[p])}),this.absoluteParsedExpr=o&&D.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=m&&D.parse(m,{trimForExclusions:!0})}test(r,o,m){return this.relativeParsedExpr&&this.relativeParsedExpr(r,o,m)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,r),o,m)}getBasenameTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getBasenameTerms(this.relativeParsedExpr)),r}getPathTerms(){const r=[];return this.absoluteParsedExpr&&r.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&r.push(...D.getPathTerms(this.relativeParsedExpr)),r}}function n(i){const r=i.trim().split(`
`),o=r[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return g.uppercaseFirstLetter(r[r.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=n}),define(pe[129],ve([0,1,38,277,99,17,68,30,9,8,2,31,64,278,262,90]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(b){this.outputChannel=b}provideTextSearchResults(b,l,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify(Object.assign(Object.assign({},l),{folder:l.folder.toString()}))}`),new Promise((W,Z)=>{O.onCancellationRequested(()=>M());const oe=n(b,l),V=l.folder.fsPath,$=oe.map(be=>be.match(/^-/)?be:`'${be}'`).join(" ");this.outputChannel.appendLine(`${S} ${$}
 - cwd: ${V}`);let j=v.spawn(S,oe,{cwd:V});j.on("error",be=>{console.error(be),this.outputChannel.appendLine("Error: "+(be&&be.message)),Z(I.serializeSearchError(new I.SearchError(be&&be.message,I.SearchErrorCode.rgProcessError)))});let T=!1;const N=new d(l.maxResults,V,l.previewOptions);N.on("result",be=>{T=!0,x="",L.report(be)});let F=!1;const M=()=>{F=!0,j&&j.kill(),N&&N.cancel()};let U=!1;N.on("hitLimit",()=>{U=!0,M()});let x="";j.stdout.on("data",be=>{N.handleData(be),T||(x+=be)});let K=!1;j.stdout.once("data",()=>K=!0);let se="";j.stderr.on("data",be=>{const Te=be.toString();this.outputChannel.appendLine(Te),se+=Te}),j.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(T?"Got result from parser":"No result from parser"),x&&this.outputChannel.appendLine(`Got data without result: ${x}`),this.outputChannel.appendLine(""),F)W({limitHit:U});else{N.flush(),j=null;let be;se&&!K&&(be=_(se))?Z(I.serializeSearchError(new I.SearchError(be.message,be.code))):W({limitHit:U})}})})}}e.RipgrepTextSearchEngine=w;function _(E){const b=E.split(`
`),l=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new I.SearchError(u(b),I.SearchErrorCode.regexParseError);const L=l.match(/grep config error: unknown encoding: (.*)/);if(L)return new I.SearchError(`Unknown encoding: ${L[1]}`,I.SearchErrorCode.unknownEncoding);if(l.startsWith("error parsing glob"))return new I.SearchError(l.charAt(0).toUpperCase()+l.substr(1),I.SearchErrorCode.globParseError);if(l.startsWith("the literal"))return new I.SearchError(l.charAt(0).toUpperCase()+l.substr(1),I.SearchErrorCode.invalidLiteral);if(l.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(l,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function u(E){const b=["Regex parse error"],l=E.filter(L=>L.startsWith("PCRE2:"));if(l.length>=1){const L=l[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];b.push(":"+O)}}return b.join("")}e.buildRegexParseError=u;class d extends R.EventEmitter{constructor(b,l,L){super();this.maxResults=b,this.rootFolder=l,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(b,l){return super.on(b,l),this}handleData(b){if(this.isDone)return;const l=typeof b=="string"?b:this.stringDecoder.write(b);this.handleDecodedData(l)}handleDecodedData(b){let l=b.indexOf(`
`);const L=this.remainder+b;if(l>=0)l+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;l>=0;)this.handleLine(L.substring(O,l).trim()),O=l+1,l=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(b){if(this.isDone||!b)return;let l;try{l=JSON.parse(b)}catch(L){throw new Error(`malformed line from rg: ${b}`)}if(l.type==="match"){const L=f(l.data.path),O=s.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(l.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(l.type==="context"){const L=f(l.data.path),O=s.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(l.data,O).forEach(Z=>this.onResult(Z))}}createTextSearchMatch(b,l){const L=b.line_number-1;let O=!1,W=f(b.lines);L===0&&P.startsWithUTF8BOM(W)&&(O=!0,W=P.stripUTF8BOM(W));const Z=Buffer.from(W);let oe=0,V=0,$=L;b.submatches.length===0&&b.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const j=y.coalesce(b.submatches.map((T,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=f(T.match);L===0&&N===0&&O&&(F=P.stripUTF8BOM(F),T.start=T.start<=3?0:T.start-3,T.end=T.end<=3?0:T.end-3);const M=Z.slice(oe,T.start).toString().length,U=V+M,x=t(F),K=$,se=x.numLines+K,be=x.numLines>0?x.lastLineLength:x.lastLineLength+U;return oe=T.end,V=be,$=se,new a.Range(K,U,se,be)}));return h.createTextSearchResult(l,W,j,this.previewOptions)}createTextSearchContext(b,l){const L=f(b.lines),O=b.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,Z)=>({text:W,uri:l,lineNumber:O+Z}))}onResult(b){this.emit("result",b)}}e.RipgrepParser=d;function f(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const b=/\n/g;let l=0,L=-1,O;for(;O=b.exec(E);)l++,L=O.index;const W=L>=0?E.length-L-1:E.length;return{numLines:l,lastLineLength:W}}function n(E,b){const l=["--hidden"];l.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=A.groupBy(b.includes,Z=>Z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const Z=new Set;O.forEach(oe=>{Z.add(oe)}),l.push("-g","!*"),Z.forEach(oe=>{i(oe).map(h.anchorGlob).forEach(V=>{l.push("-g",V)})})}L&&L.length&&L.forEach(Z=>{l.push("-g",Z)}),b.excludes.map(h.anchorGlob).forEach(Z=>l.push("-g",`!${Z}`)),b.maxFileSize&&l.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?l.push("--no-ignore-parent"):l.push("--no-ignore"),b.followSymlinks&&l.push("--follow"),b.encoding&&b.encoding!=="utf8"&&l.push("--encoding",b.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=P.escapeRegExpCharacters(E.pattern),E.isRegExp=!0),b.usePCRE2&&l.push("--pcre2"),l.push("--crlf"),E.isRegExp&&(E.pattern=r(E.pattern),l.push("--auto-hybrid-regex"));let W;if(E.isWordMatch){const oe=P.createRegExp(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");l.push("--regexp",oe)}else if(E.isRegExp){let Z=m(E.pattern);Z=p(Z),l.push("--regexp",Z)}else W=E.pattern,l.push("--fixed-strings");return l.push("--no-config"),b.useGlobalIgnoreFiles||l.push("--no-ignore-global"),l.push("--json"),E.isMultiline&&l.push("--multiline"),b.beforeContext&&l.push("--before-context",b.beforeContext+""),b.afterContext&&l.push("--after-context",b.afterContext+""),l.push("--"),W&&l.push(W),l.push("."),l}function i(E){const b=C.splitGlobAware(E,"/");return b.map((l,L)=>b.slice(0,L+1).join("/"))}e.spreadGlobComponents=i;function r(E){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(b);)E=E.replace(b,"$1\\x{$2}");const l=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(l);)E=E.replace(l,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=r;const o=E=>E.type==="Assertion"&&E.kind==="lookbehind";function m(E){let b;try{b=new g.RegExpParser().parsePattern(E)}catch(oe){return E}let l="",L=0;const O=(oe,V,$)=>{l+=E.slice(L,oe)+$,L=V},W=[];return new g.RegExpVisitor({onCharacterEnter(oe){if(oe.raw!=="\\n")return;const V=W[0];if(!V)O(oe.start,oe.end,"\\r?\\n");else if(!W.some(o))if(V.type==="CharacterClass")if(V.negate){const $=E.slice(V.start+2,oe.start)+E.slice(oe.end,V.end-1);O(V.start,V.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=E.slice(V.start+1,oe.start)+E.slice(oe.end,V.end-1);O(V.start,V.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else V.type==="Quantifier"&&O(oe.start,oe.end,"(?:\\r?\\n)")},onQuantifierEnter(oe){W.unshift(oe)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(oe){W.unshift(oe)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(oe){W.unshift(oe)},onCharacterClassLeave(){W.shift()},onAssertionEnter(oe){o(oe)&&W.push(oe)},onAssertionLeave(oe){W[0]===oe&&W.shift()}}).visit(b),l+=E.slice(L),l}e.fixRegexNewline=m;function p(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(pe[264],ve([0,1,21,129,114,10]),function(Q,e,v,R,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,s,I,a){const g=new R.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===y.Schemas.userData){const c=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:y.Schemas.file})}),h=new k.Progress(S=>I.report(Object.assign(Object.assign({},S),{uri:S.uri.with({scheme:s.folder.scheme})})));return this.withToken(a,S=>g.provideTextSearchResults(P,c,h,S))}else return this.withToken(a,c=>g.provideTextSearchResults(P,s,I,c))}async withToken(P,s){const I=C(P);this.inProgress.add(I);const a=await s(I.token);return this.inProgress.delete(I),a}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function C(D){const P=new v.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(pe[265],ve([0,1,28,129,128]),function(Q,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class y{constructor(D){this.query=D}search(D,P,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(g){s({message:g})}},a=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),v);return new Promise((g,c)=>a.search(h=>{P(h.map(A))},D).then(h=>g({limitHit:h.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=y;function A(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,P)=>{if(P.ranges){const s=P;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(pe[266],ve([0,1,54,279,17,14,16,3,97,9,43,2,42,31,263,265]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class S{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const i=u(t),r=new C.Emitter({onFirstListenerDidAdd:()=>{n=y.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,i,m=>r.fire(m),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}textSearch(t){let n;const i=u(t),r=new C.Emitter({onFirstListenerDidAdd:()=>{n=y.createCancelablePromise(o=>this.ripgrepTextSearch(i,m=>r.fire(m),o)),n.then(o=>r.fire(o),o=>r.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return r.event}ripgrepTextSearch(t,n,i){return t.maxFileSize=a.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new h.TextSearchEngineAdapter(t).search(i,n,n)}doFileSearch(t,n,i){return this.doFileSearchWithEngine(c.Engine,t,n,i)}doFileSearchWithEngine(t,n,i,r,o=S.BATCH_SIZE){let m=0;const p=b=>{Array.isArray(b)?(m+=b.length,i(b.map(l=>this.rawMatchToSearchItem(l)))):b.relativePath?(m++,i(this.rawMatchToSearchItem(b))):i(b)};if(n.sortByScore){let b=this.trySortedSearchFromCache(n,p,r);if(!b){const l=n.maxResults?Object.assign({},n,{maxResults:null}):n,L=new t(l);b=this.doSortedSearch(L,n,i,p,r)}return new Promise((l,L)=>{b.then(([O,W])=>{const Z=W.map(oe=>this.rawMatchToSearchItem(oe));this.sendProgress(Z,i,o),l(O)},L)})}const E=new t(n);return this.doSearch(E,p,o,r).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:"searchProcess",fromCache:!1,resultCount:m,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?P.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,i,r,o){const m=new C.Emitter;let p=y.createCancelablePromise(b=>{let l=[];const L=O=>{Array.isArray(O)?l=O:(r(O),m.fire(O))};return this.doSearch(t,L,-1,b).then(O=>[O,l])}),E;if(n.cacheKey){E=this.getOrCreateCache(n.cacheKey);const b={promise:p,event:m.event,resolved:!1};E.resultsToSearchCache[n.filePattern||""]=b,p.then(()=>{b.resolved=!0},l=>{delete E.resultsToSearchCache[n.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([b,l])=>{const L=E?E.scorerCache:Object.create(null),O=(typeof n.maxResults!="number"||n.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(n,l,L,o).then(W=>{const Z=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:Z,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:W.length},messages:b.messages,limitHit:b.limitHit||typeof n.maxResults=="number"&&l.length>n.maxResults},W]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,i){const r=t.cacheKey&&this.caches[t.cacheKey];if(!r)return;const o=this.getResultsFromCache(r,t.filePattern||"",n,i);if(o)return o.then(([m,p,E])=>{const b=s.StopWatch.create(!1);return this.sortResults(t,p,r.scorerCache,i).then(l=>{const L=b.elapsed(),O={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:p.length,sortingTime:L};return[{type:"success",limitHit:m.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:O},l]})})}sortResults(t,n,i,r){const o=D.prepareQuery(t.filePattern||""),m=(E,b)=>D.compareItemsByFuzzyScore(E,b,o,!0,_,i),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(n,m,p,1e4,r)}sendProgress(t,n,i){if(i&&i>0)for(let r=0;r<t.length;r+=i)n(t.slice(r,r+i));else n(t)}getResultsFromCache(t,n,i,r){const o=s.StopWatch.create(!1),m=n.indexOf(P.sep)>=0;let p;for(const L in t.resultsToSearchCache)if(n.startsWith(L)){if(m&&L.indexOf(P.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];p={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!p)return null;const E=o.elapsed(),b=s.StopWatch.create(!1),l=p.event(i);return r&&r.onCancellationRequested(()=>{l.dispose()}),p.promise.then(([L,O])=>{if(r&&r.isCancellationRequested)throw A.canceled();const W=[],Z=D.prepareQuery(n).normalizedLowercase;for(const oe of O)!g.isFilePatternMatch(oe,Z)||W.push(oe);return[L,W,{cacheWasResolved:p.resolved,cacheLookupTime:E,cacheFilterTime:b.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,n,i,r){return new Promise((o,m)=>{let p=[];r&&r.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(i?(p.push(E),i>0&&p.length>=i&&(n(p),p=[])):n(E))},E=>{n(E)},(E,b)=>{p.length&&n(p),E?m(E):o(b)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,i){return t.then(n,i)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=S,S.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(f){return P.basename(f.relativePath)}getItemDescription(f){return P.dirname(f.relativePath)}getItemPath(f){return f.relativePath}};function u(f){return Object.assign(Object.assign({},f),{folderQueries:f.folderQueries&&f.folderQueries.map(d),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>I.URI.revive(t))})}function d(f){return Object.assign(Object.assign({},f),{folder:I.URI.revive(f.folder)})}}),define(pe[267],ve([0,1,6,2,28,15,31,266,264,90,12,59,27,67,10,128]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends g.ExtHostSearch{constructor(_,u,d,f){super(_,d,f);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(c.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(_,u){const d=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(_)),v.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(_,u,d,f){const t=g.reviveQuery(d);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,u,t,f):super.$provideFileSearchResults(_,u,d,f)}doInternalFileSearch(_,u,d,f){const t=n=>{if(A.isSerializedFileMatch(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,u,n.map(i=>R.URI.file(i.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,f)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,u){return new h.NativeTextSearchManager(_,u)}};S=Ve([He(0,s.IExtHostRpcService),He(1,a.IExtHostInitDataService),He(2,I.IURITransformerService),He(3,y.ILogService)],S),e.NativeExtHostSearch=S}),define(pe[130],ve([0,1,280,120,281,3,102,9,100,32,6,22,103,16,11]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(p){this.socket=p,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;g.onUnexpectedError(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const E=b=>p(I.VSBuffer.wrap(b));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;g.onUnexpectedError(E)}})}catch(E){if(E.code==="EPIPE")return;g.onUnexpectedError(E)}}end(){this.socket.end()}drain(){return new Promise((p,E)=>{if(this.socket.bufferSize===0){p();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),p()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=h;var S;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(w||(w={}));class _ extends s.Disposable{constructor(p,E,b,l){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=l,E?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new a.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(I.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,E){let b=2;p.byteLength<126?b+=0:p.byteLength<2**16?b+=2:b+=8;const l=I.VSBuffer.alloc(b);if(E?l.writeUInt8(194,0):l.writeUInt8(130,0),p.byteLength<126)l.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){l.writeUInt8(126,1);let L=1;l.writeUInt8(p.byteLength>>>8&255,++L),l.writeUInt8(p.byteLength>>>0&255,++L)}else{l.writeUInt8(127,1);let L=1;l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(0,++L),l.writeUInt8(p.byteLength>>>24&255,++L),l.writeUInt8(p.byteLength>>>16&255,++L),l.writeUInt8(p.byteLength>>>8&255,++L),l.writeUInt8(p.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=l.byteLength+p.byteLength,this.socket.write(I.VSBuffer.concat([l,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),l=(E.readUInt8(0)&128)>>>7,L=E.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=l,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),b=E.readUInt8(1),l=(b&128)>>>7;let L=b&127,O=1;L===126?L=E.readUInt8(++O)*2**8+E.readUInt8(++O):L===127&&(L=E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O));let W=0;l&&(W=E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);u(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(I.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function u(m,p){if(p===0)return;let E=m.byteLength>>>2;for(let Z=0;Z<E;Z++){const oe=m.readUInt32BE(Z*4);m.writeUInt32BE(oe^p,Z*4)}let b=E*4,l=m.byteLength-b;const L=p>>>24&255,O=p>>>16&255,W=p>>>8&255;l>=1&&m.writeUInt8(m.readUInt8(b)^L,b),l>=2&&m.writeUInt8(m.readUInt8(b+1)^O,b+1),l>=3&&m.writeUInt8(m.readUInt8(b+2)^W,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function f(){const m=P.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let p;return e.XDG_RUNTIME_DIR?p=C.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):p=C.join(D.tmpdir(),`vscode-ipc-${m}.sock`),n(p),p}e.createRandomIPCHandle=f;function t(m,p,E){const b=v.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${E}-${p}-sock`;let l;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?l=C.join(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${E}-${p}.sock`):l=C.join(m,`${E}-${p}.sock`),n(l),l}e.createStaticIPCHandle=t;function n(m){const p=d[c.platform];typeof p=="number"&&m.length>=p&&console.warn(`WARNING: IPC handle "${m}" is longer than ${p} chars, try a shorter --user-data-dir`)}class i extends A.IPCServer{constructor(p){super(i.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const E=y.Event.fromNodeEventEmitter(p,"connection");return y.Event.map(E,b=>({protocol:new a.Protocol(new h(b)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function r(m){return new Promise((p,E)=>{const b=R.createServer();b.on("error",E),b.listen(m,()=>{b.removeListener("error",E),p(new i(b))})})}e.serve=r;function o(m,p){return new Promise((E,b)=>{const l=R.createConnection(m,()=>{l.removeListener("error",b),E(a.Client.fromSocket(new h(l),p))});l.once("error",b)})}e.connect=o}),define(pe[268],ve([0,1,130,260,54,47,2,188,15]),function(Q,e,v,R,k,y,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(a,g,c){this._commands=a,this.logService=g,this._ipcHandlePath=c,this._server=R.createServer((h,S)=>this.onRequest(h,S)),this.setup().catch(h=>(g.error(h),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",a=>this.logService.error(a))}catch(a){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(a,g){const c=[];a.setEncoding("utf8"),a.on("data",h=>c.push(h)),a.on("end",()=>{const h=JSON.parse(c.join(""));switch(h.type){case"open":this.open(h,g);break;case"openExternal":this.openExternal(h,g);break;case"status":this.getStatus(h,g);break;case"extensionManagement":this.manageExtensions(h,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${h.type}`,S=>{S&&this.logService.error(S)}),g.end();break}})}open(a,g){let{fileURIs:c,folderURIs:h,forceNewWindow:S,diffMode:w,addMode:_,forceReuseWindow:u,gotoLineMode:d,waitMarkerFilePath:f}=a;const t=[];if(Array.isArray(h))for(const n of h)try{t.push({folderUri:A.URI.parse(n)})}catch(i){}if(Array.isArray(c))for(const n of c)try{C.hasWorkspaceFileExtension(n)?t.push({workspaceUri:A.URI.parse(n)}):t.push({fileUri:A.URI.parse(n)})}catch(i){}if(t.length){const n=f?A.URI.file(f):void 0,r={forceNewWindow:S,diffMode:w,addMode:_,gotoLineMode:d,forceReuseWindow:u,preferNewWindow:!u&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,r)}g.writeHead(200),g.end()}async openExternal(a,g){for(const c of a.uris){const h=A.URI.parse(c),S=h.scheme==="file"?h:c;await this._commands.executeCommand("_remoteCLI.openExternal",S)}g.writeHead(200),g.end()}async manageExtensions(a,g){try{const c=w=>w==null?void 0:w.map(_=>/\.vsix$/i.test(_)?A.URI.parse(_):_),h={list:a.list,install:c(a.install),uninstall:c(a.uninstall),force:a.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",h);g.writeHead(200),g.write(S)}catch(c){g.writeHead(500),g.write(String(c),h=>{h&&this.logService.error(h)})}g.end()}async getStatus(a,g){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(c),g.end()}catch(c){g.writeHead(500),g.write(String(c),h=>{h&&this.logService.error(h)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let s=class extends P{constructor(a,g){super(a,g,v.createRandomIPCHandle())}};s=Ve([He(0,y.IExtHostCommands),He(1,D.ILogService)],s),e.CLIServer=s}),define(pe[269],ve([0,1,66,256,251,5,259,40,241,2,10,7,268,101]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends k.RequireInterceptor{_installInterceptor(){const w=this,_=Q.__$__nodeRequire("module"),u=_._load;_._load=function(f,t,n){for(let i of w._alternatives){let r=i(f);if(r){f=r;break}}return w._factories.has(f)?w._factories.get(f).load(f,P.URI.file(g.realpathSync(t.filename)),i=>u.apply(this,[i,t,n])):u.apply(this,arguments)}}}class h extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(a.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const d=process.send,f=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(f.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,_,u){if(_.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let d=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{w&&v.mark(`code/extHost/willLoadExtensionCode/${w.value}`),d=Q.__$__nodeRequire(_.fsPath)}catch(f){return Promise.reject(f)}finally{w&&v.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const _ in w){const u=w[_];u===null?delete process.env[_]:process.env[_]=u}}}e.ExtHostExtensionService=h}),define(pe[270],ve([0,1,78,242,243,253,252,267,269,212,244,48,40,62,67,65,33,46,15]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h,S,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(a.IExtHostExtensionService,D.ExtHostExtensionService),v.registerSingleton(_.ILogService,P.ExtHostLogService),v.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),v.registerSingleton(g.IExtHostOutputService,R.ExtHostOutputService2),v.registerSingleton(c.IExtHostSearch,C.NativeExtHostSearch),v.registerSingleton(h.IExtHostTask,y.ExtHostTask),v.registerSingleton(S.IExtHostTerminalService,k.ExtHostTerminalService),v.registerSingleton(w.IExtHostTunnelService,s.ExtHostTunnelService)}),define(pe[271],ve([0,1,120,282,66,16,103,130,182,210,254,22,98,28,101,14,257,270]),function(Q,e,v,R,k,y,A,C,D,P,s,I,a,g,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const S=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const i=Q.__$__nodeRequire("module"),r=i._load;i._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const w=process.exit.bind(process);function _(i){process.exit=function(r){if(i)w(r);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let u=function(i){w()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let o=null,m=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const p=108e5,E=3e5,b=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),p),l=new h.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),E);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const Z=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let oe;if(O.skipWebSocketFrames)oe=new C.NodeSocket(W);else{const V=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));oe=new C.WebSocketNodeSocket(new C.NodeSocket(W),O.permessageDeflate,V,!1)}o?(b.cancel(),l.cancel(),o.beginAcceptReconnection(oe,Z),o.endAcceptReconnection()):(clearTimeout(m),o=new A.PersistentProtocol(oe,Z),o.onDidDispose(()=>u("renderer disconnected")),i(o),o.onSocketClose(()=>{b.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(l.isScheduled())return;b.isScheduled()&&l.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,o)=>{const m=v.createConnection(i,()=>{m.removeListener("error",o),r(new A.PersistentProtocol(new C.NodeSocket(m)))});m.once("error",o),m.on("close",()=>{u("renderer closed the socket")})})}}async function f(){const i=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{P.isMessageOfType(r,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function t(i){return new Promise(r=>{const o=i.onMessage(m=>{o.dispose();const p=JSON.parse(m.toString()),E=p.commit,b=D.default.commit;E&&b&&E!==b&&w(55);const l=[];process.on("unhandledRejection",(W,Z)=>{l.push(Z),setTimeout(()=>{const oe=l.indexOf(Z);oe>=0&&Z.catch(V=>{l.splice(oe,1),console.warn(`rejected promise not handled within 1 second: ${V}`),V&&V.stack&&console.warn(`stack trace: ${V.stack}`),y.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const Z=l.indexOf(W);Z>=0&&l.splice(Z,1)}),process.on("uncaughtException",function(W){y.onUnexpectedError(W)});let L=0;setInterval(function(){try{process.kill(p.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${p.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=Q.__$__nodeRequire("native-watchdog"),O.start(p.parentPid)}catch(W){y.onUnexpectedError(W)}i.send(P.createMessageOfType(0)),r({protocol:i,initData:p})});i.send(P.createMessageOfType(1))})}async function n(){k.mark("code/extHost/willConnectToRenderer");const i=await f();k.mark("code/extHost/didConnectToRenderer");const r=await t(i);k.mark("code/extHost/didWaitForInitData");const{initData:o}=r;_(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=S.useHostProxy!==void 0?S.useHostProxy!=="false":void 0;const m=new class{exit(l){w(l)}exists(l){return g.exists(l)}realpath(l){return c.realpath(l)}};let p=null;if(o.remote.authority&&S.uriTransformerPath)try{const l=Q.__$__nodeRequire(S.uriTransformerPath)(o.remote.authority);p=new a.URITransformer(l)}catch(b){console.error(b)}const E=new s.ExtensionHostMain(r.protocol,o,m,p);u=b=>E.terminate(b)}e.startExtensionHostProcess=n}),define(pe[283],ve([0,1,271]),function(Q,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1e446dfadf588ec28b3fdba7ac083bfa1d45df3c/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
