/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/network","vs/base/common/arrays","vs/platform/log/common/log","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Z){for(var e=[],g=0,T=Z.length;g<T;g++)e[g]=we[Z[g]];return e};define(we[39],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(we[76],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function T(i){const P=[];for(let o in i)g.call(i,o)&&P.push(i[o]);return P}e.values=T;function D(i,P){for(let o in i)if(g.call(i,o)&&P({key:o,value:i[o]},function(){delete i[o]})===!1)return}e.forEach=D;function E(i,P){const o=Object.create(null);for(const h of i){const d=P(h);let u=o[d];u||(u=o[d]=[]),u.push(h)}return o}e.groupBy=E;function k(i){const P=Object.create(null);return i&&i.forEach((o,h)=>{P[h]=o}),P}e.fromMap=k;function y(i,P){const o=[],h=[];for(let d of i)P.has(d)||o.push(d);for(let d of P)i.has(d)||h.push(d);return{removed:o,added:h}}e.diffSets=y;function _(i,P){const o=[],h=[];for(let[d,u]of i)P.has(d)||o.push(u);for(let[d,u]of P)i.has(d)||h.push(u);return{removed:o,added:h}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(P,o){let h=this.map.get(P);h||(h=new Set,this.map.set(P,h)),h.add(o)}delete(P,o){const h=this.map.get(P);!h||(h.delete(o),h.size===0&&this.map.delete(P))}forEach(P,o){const h=this.map.get(P);!h||h.forEach(o)}}e.SetMap=I}),define(we[47],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(k){return(y,_,I)=>{let i=null,P=null;if(typeof I.value=="function"?(i="value",P=I.value):typeof I.get=="function"&&(i="get",P=I.get),!P)throw new Error("not supported");I[i]=k(P,_)}}e.createDecorator=g;function T(k,y,_){let I=null,i=null;if(typeof _.value=="function"?(I="value",i=_.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",i=_.get),!i)throw new Error("not supported");const P=`$memoize$${y}`;_[I]=function(...o){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,o)}),this[P]}}e.memoize=T;function D(k,y,_){return g((I,i)=>{const P=`$debounce$${i}`,o=`$debounce$result$${i}`;return function(...h){this[o]||(this[o]=_?_():void 0),clearTimeout(this[P]),y&&(this[o]=y(this[o],...h),h=[this[o]]),this[P]=setTimeout(()=>{I.apply(this,h),this[o]=_?_():void 0},k)}})}e.debounce=D;function E(k,y,_){return g((I,i)=>{const P=`$throttle$timer$${i}`,o=`$throttle$result$${i}`,h=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...u){if(this[o]||(this[o]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),y&&(this[o]=y(this[o],...u)),this[d])return;const w=this[h]+k;w<=Date.now()?(this[h]=Date.now(),I.apply(this,[this[o]]),this[o]=_?_():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),I.apply(this,[this[o]]),this[o]=_?_():void 0},w-Date.now()))}})}e.throttle=E}),define(we[12],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function T(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=T;function D(f){_(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=D;function E(f){_(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=E;function k(f){if(f instanceof Error){let{name:t,message:n}=f;const r=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:r}}return f}e.transformErrorForSerialization=k;const y="Canceled";function _(f){return f instanceof Error&&f.name===y&&f.message===y}e.isPromiseCanceledError=_;class I extends Error{constructor(){super(y);this.name=this.message}}e.CancellationError=I;function i(){const f=new Error(y);return f.name=f.message,f}e.canceled=i;function P(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=P;function o(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=o;function h(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function u(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=u;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function c(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function m(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=m}),define(we[16],_e([0,1,12]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(B,M=0){return B[B.length-(1+M)]}e.tail=T;function D(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=D;function E(B,M,U=(j,z)=>j===z){if(B===M)return!0;if(!B||!M||B.length!==M.length)return!1;for(let j=0,z=B.length;j<z;j++)if(!U(B[j],M[j]))return!1;return!0}e.equals=E;function k(B,M,U){let j=0,z=B.length-1;for(;j<=z;){const oe=(j+z)/2|0,pe=U(B[oe],M);if(pe<0)j=oe+1;else if(pe>0)z=oe-1;else return oe}return-(j+1)}e.binarySearch=k;function y(B,M){let U=0,j=B.length;if(j===0)return 0;for(;U<j;){const z=Math.floor((U+j)/2);M(B[z])?j=z:U=z+1}return U}e.findFirstInSorted=y;function _(B,M,U){if(B=B|0,B>=M.length)throw new TypeError("invalid index");let j=M[Math.floor(M.length*Math.random())],z=[],oe=[],pe=[];for(let Te of M){const $e=U(Te,j);$e<0?z.push(Te):$e>0?oe.push(Te):pe.push(Te)}return B<z.length?_(B,z,U):B<z.length+pe.length?pe[0]:_(B-(z.length+pe.length),oe,U)}e.quickSelect=_;function I(B,M){const U=[];let j;for(const z of B.slice(0).sort(M))!j||M(j[0],z)!==0?(j=[z],U.push(j)):j.push(z);return U}e.groupBy=I;function i(B,M,U){const j=[];function z(Te,$e,Me){if($e===0&&Me.length===0)return;const ze=j[j.length-1];ze&&ze.start+ze.deleteCount===Te?(ze.deleteCount+=$e,ze.toInsert.push(...Me)):j.push({start:Te,deleteCount:$e,toInsert:Me})}let oe=0,pe=0;for(;;){if(oe===B.length){z(oe,0,M.slice(pe));break}if(pe===M.length){z(oe,B.length-oe,[]);break}const Te=B[oe],$e=M[pe],Me=U(Te,$e);Me===0?(oe+=1,pe+=1):Me<0?(z(oe,1,[]),oe+=1):Me>0&&(z(oe,0,[$e]),pe+=1)}return j}e.sortedDiff=i;function P(B,M,U){const j=i(B,M,U),z=[],oe=[];for(const pe of j)z.push(...B.slice(pe.start,pe.start+pe.deleteCount)),oe.push(...pe.toInsert);return{removed:z,added:oe}}e.delta=P;function o(B,M,U){if(U===0)return[];const j=B.slice(0,U).sort(M);return d(B,M,j,U,B.length),j}e.top=o;function h(B,M,U,j,z){return U===0?Promise.resolve([]):new Promise((oe,pe)=>{(async()=>{const Te=B.length,$e=B.slice(0,U).sort(M);for(let Me=U,ze=Math.min(U+j,Te);Me<Te;Me=ze,ze=Math.min(ze+j,Te)){if(Me>U&&await new Promise(Qe=>setTimeout(Qe)),z&&z.isCancellationRequested)throw g.canceled();d(B,M,$e,Me,ze)}return $e})().then(oe,pe)})}e.topAsync=h;function d(B,M,U,j,z){for(const oe=U.length;j<z;j++){const pe=B[j];if(M(pe,U[oe-1])<0){U.pop();const Te=y(U,$e=>M(pe,$e)<0);U.splice(Te,0,pe)}}}function u(B){return B.filter(M=>!!M)}e.coalesce=u;function w(B){let M=0;for(let U=0;U<B.length;U++)B[U]&&(B[M]=B[U],M+=1);B.length=M}e.coalesceInPlace=w;function p(B,M,U){B.splice(U,0,B.splice(M,1)[0])}e.move=p;function S(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=S;function c(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=c;function m(B,M){if(!M)return B.filter((j,z)=>B.indexOf(j)===z);const U=Object.create(null);return B.filter(j=>{const z=M(j);return U[z]?!1:(U[z]=!0,!0)})}e.distinct=m;function f(B){const M=new Set;return B.filter(U=>M.has(U)?!1:(M.add(U),!0))}e.distinctES6=f;function t(B){const M=Object.create(null);return U=>{const j=B(U);return M[j]?!1:(M[j]=!0,!0)}}e.uniqueFilter=t;function n(B,M){for(let U=B.length-1;U>=0;U--){const j=B[U];if(M(j))return U}return-1}e.lastIndex=n;function r(B,M){return B.length>0?B[0]:M}e.firstOrDefault=r;function s(B,M,U=(j,z)=>j===z){let j=0;for(let z=0,oe=Math.min(B.length,M.length);z<oe&&U(B[z],M[z]);z++)j++;return j}e.commonPrefixLength=s;function l(B){return[].concat(...B)}e.flatten=l;function v(B,M){let U=typeof M=="number"?B:0;typeof M=="number"?U=B:(U=0,M=B);const j=[];if(U<=M)for(let z=U;z<M;z++)j.push(z);else for(let z=U;z>M;z--)j.push(z);return j}e.range=v;function b(B,M,U){return B.reduce((j,z)=>(j[M(z)]=U?U(z):z,j),Object.create(null))}e.index=b;function A(B,M){return B.push(M),()=>C(B,M)}e.insert=A;function C(B,M){const U=B.indexOf(M);if(U>-1)return B.splice(U,1),M}e.remove=C;function a(B,M,U){const j=B.slice(0,M),z=B.slice(M);return j.concat(U,z)}e.arrayInsert=a;function F(B,M){let U;if(typeof M=="number"){let j=M;U=()=>{const z=Math.sin(j++)*179426549;return z-Math.floor(z)}}else U=Math.random;for(let j=B.length-1;j>0;j-=1){const z=Math.floor(U()*(j+1)),oe=B[j];B[j]=B[z],B[z]=oe}}e.shuffle=F;function N(B,M){const U=B.indexOf(M);U>-1&&(B.splice(U,1),B.unshift(M))}e.pushToStart=N;function W(B,M){const U=B.indexOf(M);U>-1&&(B.splice(U,1),B.push(M))}e.pushToEnd=W;function ce(B,M){return Array.isArray(B)?B.map(M):M(B)}e.mapArrayOrNot=ce;function me(B){return Array.isArray(B)?B:[B]}e.asArray=me;function G(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=G;function V(B,M){for(const U of B){const j=M(U);if(j!==void 0)return j}}e.mapFind=V;function J(B,M){let U=Number.MAX_SAFE_INTEGER,j=0;return B.forEach((z,oe)=>{const pe=M(z);pe<U&&(U=pe,j=oe)}),j}e.minIndex=J;function R(B,M){let U=Number.MIN_SAFE_INTEGER,j=0;return B.forEach((z,oe)=>{const pe=M(z);pe>U&&(U=pe,j=oe)}),j}e.maxIndex=R}),define(we[48],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(T){const D=this;let E=!1,k;return function(){return E||(E=!0,k=T.apply(D,arguments)),k}}e.once=g}),define(we[49],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(we[50],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(T){function D(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}T.is=D;const E=Object.freeze([]);function k(){return E}T.empty=k;function*y(f){yield f}T.single=y;function _(f){return f||E}T.from=_;function I(f){return!f||f[Symbol.iterator]().next().done===!0}T.isEmpty=I;function i(f){return f[Symbol.iterator]().next().value}T.first=i;function P(f,t){for(const n of f)if(t(n))return!0;return!1}T.some=P;function o(f,t){for(const n of f)if(t(n))return n}T.find=o;function*h(f,t){for(const n of f)t(n)&&(yield n)}T.filter=h;function*d(f,t){let n=0;for(const r of f)yield t(r,n++)}T.map=d;function*u(...f){for(const t of f)for(const n of t)yield n}T.concat=u;function*w(f){for(const t of f)for(const n of t)yield n}T.concatNested=w;function p(f,t,n){let r=n;for(const s of f)r=t(r,s);return r}T.reduce=p;function*S(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}T.slice=S;function c(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const r=f[Symbol.iterator]();for(let s=0;s<t;s++){const l=r.next();if(l.done)return[n,T.empty()];n.push(l.value)}return[n,{[Symbol.iterator](){return r}}]}T.consume=c;function m(f,t,n=(r,s)=>r===s){const r=f[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const l=r.next(),v=s.next();if(l.done!==v.done)return!1;if(l.done)return!0;if(!n(l.value,v.value))return!1}}T.equals=m})(g=e.Iterable||(e.Iterable={}))}),define(we[105],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function k(t,n=!1){let r=0,s=t.length,l="",v=0,b=16,A=0;function C(G){let V=0,J=0;for(;V<G;){const R=t.charCodeAt(r);if(R>=48&&R<=57)J=J*16+R-48;else if(R>=65&&R<=70)J=J*16+R-65+10;else if(R>=97&&R<=102)J=J*16+R-97+10;else break;r++,V++}return V<G&&(J=-1),J}function a(G){r=G,l="",v=0,b=16,A=0}function F(){const G=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&I(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&I(t.charCodeAt(r)))for(r++;r<t.length&&I(t.charCodeAt(r));)r++;else return A=3,t.substring(G,r);let V=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&I(t.charCodeAt(r))){for(r++;r<t.length&&I(t.charCodeAt(r));)r++;V=r}else A=3;return t.substring(G,V)}function N(){let G="",V=r;for(;;){if(r>=s){G+=t.substring(V,r),A=2;break}const J=t.charCodeAt(r);if(J===34){G+=t.substring(V,r),r++;break}if(J===92){if(G+=t.substring(V,r),r++,r>=s){A=2;break}switch(t.charCodeAt(r++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const B=C(4);B>=0?G+=String.fromCharCode(B):A=4;break;default:A=5}V=r;continue}if(J>=0&&J<=31)if(_(J)){G+=t.substring(V,r),A=2;break}else A=6;r++}return G}function W(){if(l="",A=0,v=r,r>=s)return v=s,b=17;let G=t.charCodeAt(r);if(y(G)){do r++,l+=String.fromCharCode(G),G=t.charCodeAt(r);while(y(G));return b=15}if(_(G))return r++,l+=String.fromCharCode(G),G===13&&t.charCodeAt(r)===10&&(r++,l+=`
`),b=14;switch(G){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,l=N(),b=10;case 47:const V=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!_(t.charCodeAt(r));)r++;return l=t.substring(V,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const J=s-1;let R=!1;for(;r<J;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,R=!0;break}r++}return R||(r++,A=1),l=t.substring(V,r),b=13}return l+=String.fromCharCode(G),r++,b=16;case 45:if(l+=String.fromCharCode(G),r++,r===s||!I(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),b=11;default:for(;r<s&&ce(G);)r++,G=t.charCodeAt(r);if(v!==r){switch(l=t.substring(v,r),l){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return l+=String.fromCharCode(G),r++,b=16}}function ce(G){if(y(G)||_(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function me(){let G;do G=W();while(G>=12&&G<=15);return G}return{setPosition:a,getPosition:()=>r,scan:n?me:W,getToken:()=>b,getTokenValue:()=>l,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>A}}e.createScanner=k;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function I(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,n){const r=[],s=new Object;let l;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function A(C,a,F,N){v.value=C,v.offset=a,v.length=F,v.type=N,v.colonOffset=void 0,l=v}try{c(t,{onObjectBegin:(C,a)=>{if(n<=C)throw s;l=void 0,b=n>C,r.push("")},onObjectProperty:(C,a,F)=>{if(n<a||(A(C,a,F,"property"),r[r.length-1]=C,n<=a+F))throw s},onObjectEnd:(C,a)=>{if(n<=C)throw s;l=void 0,r.pop()},onArrayBegin:(C,a)=>{if(n<=C)throw s;l=void 0,r.push(0)},onArrayEnd:(C,a)=>{if(n<=C)throw s;l=void 0,r.pop()},onLiteralValue:(C,a,F)=>{if(n<a||(A(C,a,F,f(C)),n<=a+F))throw s},onSeparator:(C,a,F)=>{if(n<=a)throw s;if(C===":"&&l&&l.type==="property")l.colonOffset=a,b=!1,l=void 0;else if(C===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(b=!0,r[r.length-1]=""),l=void 0}}})}catch(C){if(C!==s)throw C}return{path:r,previousNode:l,isAtPropertyKey:b,matches:C=>{let a=0;for(let F=0;a<C.length&&F<r.length;F++)if(C[a]===r[F]||C[a]==="*")a++;else if(C[a]!=="**")return!1;return a===C.length}}}e.getLocation=P;function o(t,n=[],r=E.DEFAULT){let s=null,l=[];const v=[];function b(C){Array.isArray(l)?l.push(C):s!==null&&(l[s]=C)}return c(t,{onObjectBegin:()=>{const C={};b(C),v.push(l),l=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{l=v.pop()},onArrayBegin:()=>{const C=[];b(C),v.push(l),l=C,s=null},onArrayEnd:()=>{l=v.pop()},onLiteralValue:b,onError:(C,a,F)=>{n.push({error:C,offset:a,length:F})}},r),l[0]}e.parse=o;function h(t,n=[],r=E.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(C){s.type==="property"&&(s.length=C-s.offset,s=s.parent)}function v(C){return s.children.push(C),C}c(t,{onObjectBegin:C=>{s=v({type:"object",offset:C,length:-1,parent:s,children:[]})},onObjectProperty:(C,a,F)=>{s=v({type:"property",offset:a,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:C,offset:a,length:F,parent:s})},onObjectEnd:(C,a)=>{s.length=C+a-s.offset,s=s.parent,l(C+a)},onArrayBegin:(C,a)=>{s=v({type:"array",offset:C,length:-1,parent:s,children:[]})},onArrayEnd:(C,a)=>{s.length=C+a-s.offset,s=s.parent,l(C+a)},onLiteralValue:(C,a,F)=>{v({type:f(C),offset:a,length:F,parent:s,value:C}),l(a+F)},onSeparator:(C,a,F)=>{s.type==="property"&&(C===":"?s.colonOffset=a:C===","&&l(a))},onError:(C,a,F)=>{n.push({error:C,offset:a,length:F})}},r);const A=s.children[0];return A&&delete A.parent,A}e.parseTree=h;function d(t,n){if(!t)return;let r=t;for(let s of n)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===s){r=v.children[1],l=!0;break}if(!l)return}else{const l=s;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=d;function u(t){if(!t.parent||!t.parent.children)return[];const n=u(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=u;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const n=Object.create(null);for(let r of t.children){const s=r.children[1];s&&(n[r.children[0].value]=w(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function p(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=p;function S(t,n,r=!1){if(p(t,n,r)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=n;l++){const v=S(s[l],n,r);if(v)return v}return t}}e.findNodeAtOffset=S;function c(t,n,r=E.DEFAULT){const s=k(t,!1);function l(pe){return pe?()=>pe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function v(pe){return pe?Te=>pe(Te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=l(n.onObjectBegin),A=v(n.onObjectProperty),C=l(n.onObjectEnd),a=l(n.onArrayBegin),F=l(n.onArrayEnd),N=v(n.onLiteralValue),W=v(n.onSeparator),ce=l(n.onComment),me=v(n.onError),G=r&&r.disallowComments,V=r&&r.allowTrailingComma;function J(){for(;;){const pe=s.scan();switch(s.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:G||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:G?R(10):ce();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Te=[],$e=[]){if(me(pe),Te.length+$e.length>0){let Me=s.getToken();for(;Me!==17;){if(Te.indexOf(Me)!==-1){J();break}else if($e.indexOf(Me)!==-1)break;Me=J()}}}function B(pe){const Te=s.getTokenValue();return pe?N(Te):A(Te),J(),!0}function M(){switch(s.getToken()){case 11:let pe=0;try{pe=JSON.parse(s.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Te){R(2)}N(pe);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return J(),!0}function U(){return s.getToken()!==10?(R(3,[],[2,5]),!1):(B(!1),s.getToken()===6?(W(":"),J(),oe()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function j(){b(),J();let pe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(pe||R(4,[],[]),W(","),J(),s.getToken()===2&&V)break}else pe&&R(6,[],[]);U()||R(4,[],[2,5]),pe=!0}return C(),s.getToken()!==2?R(7,[2],[]):J(),!0}function z(){a(),J();let pe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(pe||R(4,[],[]),W(","),J(),s.getToken()===4&&V)break}else pe&&R(6,[],[]);oe()||R(4,[],[4,5]),pe=!0}return F(),s.getToken()!==4?R(8,[4],[]):J(),!0}function oe(){switch(s.getToken()){case 3:return z();case 1:return j();case 10:return B(!0);default:return M()}}return J(),s.getToken()===17?r.allowEmptyContent?!0:(R(4,[],[]),!1):oe()?(s.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=c;function m(t,n){let r=k(t),s=[],l,v=0,b;do switch(b=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:v!==b&&s.push(t.substring(v,b)),n!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,n)),v=r.getPosition();break}while(l!==17);return s.join("")}e.stripComments=m;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(we[106],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(we[7],_e([0,1,48,50]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let E=null;function k(c){E=c}if(e.setDisposableTracker=k,D){const c="__is_disposable_tracked__";E=new class{trackDisposable(m){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[c]||console.log(f)},3e3)}markTracked(m){if(m&&m!==u.None)try{m[c]=!0}catch(f){}}}}function y(c){!E||E.markTracked(c)}function _(c){return E&&E.trackDisposable(c),c}e.trackDisposable=_;class I extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=I;function i(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=i;function P(c){if(T.Iterable.is(c)){let m=[];for(const f of c)if(f){y(f);try{f.dispose()}catch(t){m.push(t)}}if(m.length===1)throw m[0];if(m.length>1)throw new I(m);return Array.isArray(c)?[]:c}else if(c)return y(c),c.dispose(),c}e.dispose=P;function o(...c){return c.forEach(y),h(()=>P(c))}e.combinedDisposable=o;function h(c){const m=_({dispose:()=>{y(m),c()}});return m}e.toDisposable=h;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{P(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return y(m),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this._store=new d,_(this)}dispose(){y(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){var f;this._isDisposed||m===this._value||((f=this._value)===null||f===void 0||f.dispose(),m&&y(m),this._value=m)}clear(){this.value=void 0}dispose(){var m;this._isDisposed=!0,y(this),(m=this._value)===null||m===void 0||m.dispose(),this._value=void 0}}e.MutableDisposable=w;class p{constructor(){this.references=new Map}acquire(m,...f){let t=this.references.get(m);t||(t={counter:0,object:this.createReferencedObject(m,...f)},this.references.set(m,t));const{object:n}=t,r=g.once(()=>{--t.counter==0&&(this.destroyReferencedObject(m,t.object),this.references.delete(m))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=p;class S{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=S}),define(we[51],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class T{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const k=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=k}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,k){const y=new g(E);if(this._first===g.Undefined)this._first=y,this._last=y;else if(k){const I=this._last;this._last=y,y.prev=I,I.next=y}else{const I=this._first;this._first=y,y.next=I,I.prev=y}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(y))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const k=E.prev;k.next=E.next,E.next.prev=k}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=T}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,Z.marked=e())}(this,function(){"use strict";function Z(Se,ye){for(var De=0;De<ye.length;De++){var ie=ye[De];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Se,ie.key,ie)}}function e(Se,ye,De){return ye&&Z(Se.prototype,ye),De&&Z(Se,De),Se}function g(Se,ye){if(!!Se){if(typeof Se=="string")return T(Se,ye);var De=Object.prototype.toString.call(Se).slice(8,-1);if(De==="Object"&&Se.constructor&&(De=Se.constructor.name),De==="Map"||De==="Set")return Array.from(Se);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return T(Se,ye)}}function T(Se,ye){(ye==null||ye>Se.length)&&(ye=Se.length);for(var De=0,ie=new Array(ye);De<ye;De++)ie[De]=Se[De];return ie}function D(Se,ye){var De;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(De=g(Se))||ye&&Se&&typeof Se.length=="number"){De&&(Se=De);var ie=0;return function(){return ie>=Se.length?{done:!0}:{done:!1,value:Se[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return De=Se[Symbol.iterator](),De.next.bind(De)}function E(Se){var ye={exports:{}};return Se(ye,ye.exports),ye.exports}var k=E(function(Se){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function De(ie){Se.exports.defaults=ie}Se.exports={defaults:ye(),getDefaults:ye,changeDefaults:De}}),y=/[&<>"']/,_=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,P={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(ye){return P[ye]};function h(Se,ye){if(ye){if(y.test(Se))return Se.replace(_,o)}else if(I.test(Se))return Se.replace(i,o);return Se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Se){return Se.replace(d,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var w=/(^|[^\[])\^/g;function p(Se,ye){Se=Se.source||Se,ye=ye||"";var De={replace:function(ue,O){return O=O.source||O,O=O.replace(w,"$1"),Se=Se.replace(ue,O),De},getRegex:function(){return new RegExp(Se,ye)}};return De}var S=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Se,ye,De){if(Se){var ie;try{ie=decodeURIComponent(u(De)).replace(S,"").toLowerCase()}catch(ue){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}ye&&!c.test(De)&&(De=s(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Se,ye){f[" "+Se]||(t.test(Se)?f[" "+Se]=Se+"/":f[" "+Se]=A(Se,"/",!0)),Se=f[" "+Se];var De=Se.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Se.replace(n,"$1")+ye:ye.charAt(0)==="/"?De?ye:Se.replace(r,"$1")+ye:Se+ye}var l={exec:function(){}};function v(Se){for(var ye=1,De,ie;ye<arguments.length;ye++){De=arguments[ye];for(ie in De)Object.prototype.hasOwnProperty.call(De,ie)&&(Se[ie]=De[ie])}return Se}function b(Se,ye){var De=Se.replace(/\|/g,function(O,Y,ae){for(var Ce=!1,ke=Y;--ke>=0&&ae[ke]==="\\";)Ce=!Ce;return Ce?"|":" |"}),ie=De.split(/ \|/),ue=0;if(ie.length>ye)ie.splice(ye);else for(;ie.length<ye;)ie.push("");for(;ue<ie.length;ue++)ie[ue]=ie[ue].trim().replace(/\\\|/g,"|");return ie}function A(Se,ye,De){var ie=Se.length;if(ie===0)return"";for(var ue=0;ue<ie;){var O=Se.charAt(ie-ue-1);if(O===ye&&!De)ue++;else if(O!==ye&&De)ue++;else break}return Se.substr(0,ie-ue)}function C(Se,ye){if(Se.indexOf(ye[1])===-1)return-1;for(var De=Se.length,ie=0,ue=0;ue<De;ue++)if(Se[ue]==="\\")ue++;else if(Se[ue]===ye[0])ie++;else if(Se[ue]===ye[1]&&(ie--,ie<0))return ue;return-1}function a(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Se,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Se),ye>>=1,Se+=Se;return De+Se}var N={escape:h,unescape:u,edit:p,cleanUrl:m,resolveUrl:s,noopTest:l,merge:v,splitCells:b,rtrim:A,findClosingBracket:C,checkSanitizeDeprecation:a,repeatString:F},W=k.defaults,ce=N.rtrim,me=N.splitCells,G=N.escape,V=N.findClosingBracket;function J(Se,ye,De){var ie=ye.href,ue=ye.title?G(ye.title):null,O=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:De,href:ie,title:ue,text:O}:{type:"image",raw:De,href:ie,title:ue,text:G(O)}}function R(Se,ye){var De=Se.match(/^(\s+)(?:```)/);if(De===null)return ye;var ie=De[1];return ye.split(`
`).map(function(ue){var O=ue.match(/^\s+/);if(O===null)return ue;var Y=O[0];return Y.length>=ie.length?ue.slice(ie.length):ue}).join(`
`)}var B=function(){function Se(De){this.options=De||W}var ye=Se.prototype;return ye.space=function(ie){var ue=this.rules.block.newline.exec(ie);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(ie){var ue=this.rules.block.code.exec(ie);if(ue){var O=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?O:ce(O,`
`)}}},ye.fences=function(ie){var ue=this.rules.block.fences.exec(ie);if(ue){var O=ue[0],Y=R(O,ue[3]||"");return{type:"code",raw:O,lang:ue[2]?ue[2].trim():ue[2],text:Y}}},ye.heading=function(ie){var ue=this.rules.block.heading.exec(ie);if(ue){var O=ue[2].trim();if(/#$/.test(O)){var Y=ce(O,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(O=Y.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:O}}},ye.nptable=function(ie){var ue=this.rules.block.nptable.exec(ie);if(ue){var O={type:"table",header:me(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(O.header.length===O.align.length){var Y=O.align.length,ae;for(ae=0;ae<Y;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(Y=O.cells.length,ae=0;ae<Y;ae++)O.cells[ae]=me(O.cells[ae],O.header.length);return O}}},ye.hr=function(ie){var ue=this.rules.block.hr.exec(ie);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ie){var ue=this.rules.block.blockquote.exec(ie);if(ue){var O=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:O}}},ye.list=function(ie){var ue=this.rules.block.list.exec(ie);if(ue){var O=ue[0],Y=ue[2],ae=Y.length>1,Ce={type:"list",raw:O,ordered:ae,start:ae?+Y.slice(0,-1):"",loose:!1,items:[]},ke=ue[0].match(this.rules.block.item),Ne=!1,Oe,qe,rt,tt,Je,ot,_t,wt,be=ke.length;rt=this.rules.block.listItemStart.exec(ke[0]);for(var de=0;de<be;de++){if(Oe=ke[de],O=Oe,de!==be-1){if(tt=this.rules.block.listItemStart.exec(ke[de+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){ke.splice(de,2,ke[de]+`
`+ke[de+1]),de--,be--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Y[Y.length-1]:ae===(tt[2].length===1))&&(Je=ke.slice(de+1).join(`
`),Ce.raw=Ce.raw.substring(0,Ce.raw.length-Je.length),de=be-1);rt=tt}qe=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(qe-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+qe+"}","gm"),"")),ot=Ne||/\n\n(?!\s*$)/.test(Oe),de!==be-1&&(Ne=Oe.charAt(Oe.length-1)===`
`,ot||(ot=Ne)),ot&&(Ce.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Oe),wt=void 0,_t&&(wt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:O,task:_t,checked:wt,loose:ot,text:Oe})}return Ce}},ye.html=function(ie){var ue=this.rules.block.html.exec(ie);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):G(ue[0]):ue[0]}},ye.def=function(ie){var ue=this.rules.block.def.exec(ie);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var O=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ie){var ue=this.rules.block.table.exec(ie);if(ue){var O={type:"table",header:me(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=ue[0];var Y=O.align.length,ae;for(ae=0;ae<Y;ae++)/^ *-+: *$/.test(O.align[ae])?O.align[ae]="right":/^ *:-+: *$/.test(O.align[ae])?O.align[ae]="center":/^ *:-+ *$/.test(O.align[ae])?O.align[ae]="left":O.align[ae]=null;for(Y=O.cells.length,ae=0;ae<Y;ae++)O.cells[ae]=me(O.cells[ae].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},ye.lheading=function(ie){var ue=this.rules.block.lheading.exec(ie);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(ie){var ue=this.rules.block.paragraph.exec(ie);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(ie){var ue=this.rules.block.text.exec(ie);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(ie){var ue=this.rules.inline.escape.exec(ie);if(ue)return{type:"escape",raw:ue[0],text:G(ue[1])}},ye.tag=function(ie,ue,O){var Y=this.rules.inline.tag.exec(ie);if(Y)return!ue&&/^<a /i.test(Y[0])?ue=!0:ue&&/^<\/a>/i.test(Y[0])&&(ue=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:ue,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):G(Y[0]):Y[0]}},ye.link=function(ie){var ue=this.rules.inline.link.exec(ie);if(ue){var O=ue[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var Y=ce(O.slice(0,-1),"\\");if((O.length-Y.length)%2==0)return}else{var ae=V(ue[2],"()");if(ae>-1){var Ce=ue[0].indexOf("!")===0?5:4,ke=Ce+ue[1].length+ae;ue[2]=ue[2].substring(0,ae),ue[0]=ue[0].substring(0,ke).trim(),ue[3]=""}}var Ne=ue[2],Oe="";if(this.options.pedantic){var qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);qe&&(Ne=qe[1],Oe=qe[3])}else Oe=ue[3]?ue[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(O)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),J(ue,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(ie,ue){var O;if((O=this.rules.inline.reflink.exec(ie))||(O=this.rules.inline.nolink.exec(ie))){var Y=(O[2]||O[1]).replace(/\s+/g," ");if(Y=ue[Y.toLowerCase()],!Y||!Y.href){var ae=O[0].charAt(0);return{type:"text",raw:ae,text:ae}}return J(O,Y,O[0])}},ye.emStrong=function(ie,ue,O){O===void 0&&(O="");var Y=this.rules.inline.emStrong.lDelim.exec(ie);if(!!Y&&!(Y[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Y[1]||Y[2]||"";if(!ae||ae&&(O===""||this.rules.inline.punctuation.exec(O))){var Ce=Y[0].length-1,ke,Ne,Oe=Ce,qe=0,rt=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*ie.length+Ce);(Y=rt.exec(ue))!=null;)if(ke=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!ke){if(Ne=ke.length,Y[3]||Y[4]){Oe+=Ne;continue}else if((Y[5]||Y[6])&&Ce%3&&!((Ce+Ne)%3)){qe+=Ne;continue}if(Oe-=Ne,!(Oe>0)){if(Oe+qe-Ne<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Ne=Math.min(Ne,Ne+Oe+qe)),Math.min(Ce,Ne)%2)return{type:"em",raw:ie.slice(0,Ce+Y.index+Ne+1),text:ie.slice(1,Ce+Y.index+Ne)};if(Math.min(Ce,Ne)%2==0)return{type:"strong",raw:ie.slice(0,Ce+Y.index+Ne+1),text:ie.slice(2,Ce+Y.index+Ne-1)}}}}}},ye.codespan=function(ie){var ue=this.rules.inline.code.exec(ie);if(ue){var O=ue[2].replace(/\n/g," "),Y=/[^ ]/.test(O),ae=/^ /.test(O)&&/ $/.test(O);return Y&&ae&&(O=O.substring(1,O.length-1)),O=G(O,!0),{type:"codespan",raw:ue[0],text:O}}},ye.br=function(ie){var ue=this.rules.inline.br.exec(ie);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ie){var ue=this.rules.inline.del.exec(ie);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(ie,ue){var O=this.rules.inline.autolink.exec(ie);if(O){var Y,ae;return O[2]==="@"?(Y=G(this.options.mangle?ue(O[1]):O[1]),ae="mailto:"+Y):(Y=G(O[1]),ae=Y),{type:"link",raw:O[0],text:Y,href:ae,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.url=function(ie,ue){var O;if(O=this.rules.inline.url.exec(ie)){var Y,ae;if(O[2]==="@")Y=G(this.options.mangle?ue(O[0]):O[0]),ae="mailto:"+Y;else{var Ce;do Ce=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(Ce!==O[0]);Y=G(O[0]),O[1]==="www."?ae="http://"+Y:ae=Y}return{type:"link",raw:O[0],text:Y,href:ae,tokens:[{type:"text",raw:Y,text:Y}]}}},ye.inlineText=function(ie,ue,O){var Y=this.rules.inline.text.exec(ie);if(Y){var ae;return ue?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):G(Y[0]):Y[0]:ae=G(this.options.smartypants?O(Y[0]):Y[0]),{type:"text",raw:Y[0],text:ae}}},Se}(),M=N.noopTest,U=N.edit,j=N.merge,z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=U(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,z.item=U(z.item,"gm").replace(/bull/g,z.bullet).getRegex(),z.listItemStart=U(/^( *)(bull)/).replace("bull",z.bullet).getRegex(),z.list=U(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=U(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=U(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.blockquote=U(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=j({},z),z.gfm=j({},z.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.nptable=U(z.gfm.nptable).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.gfm.table=U(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",z._tag).getRegex(),z.pedantic=j({},z.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=U(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=U(z._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=U(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=U(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=U(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=U(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=U(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=U(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=U(oe.reflink).replace("label",oe._label).getRegex(),oe.reflinkSearch=U(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=j({},oe),oe.pedantic=j({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=j({},oe.normal,{escape:U(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),oe.gfm.url=U(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=j({},oe.gfm,{br:U(oe.br).replace("{2,}","*").getRegex(),text:U(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:z,inline:oe},Te=k.defaults,$e=pe.block,Me=pe.inline,ze=N.repeatString;function Qe(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ke(Se){var ye="",De,ie,ue=Se.length;for(De=0;De<ue;De++)ie=Se.charCodeAt(De),Math.random()>.5&&(ie="x"+ie.toString(16)),ye+="&#"+ie+";";return ye}var Ge=function(){function Se(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Te,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:$e.normal,inline:Me.normal};this.options.pedantic?(ie.block=$e.pedantic,ie.inline=Me.pedantic):this.options.gfm&&(ie.block=$e.gfm,this.options.breaks?ie.inline=Me.breaks:ie.inline=Me.gfm),this.tokenizer.rules=ie}Se.lex=function(ie,ue){var O=new Se(ue);return O.lex(ie)},Se.lexInline=function(ie,ue){var O=new Se(ue);return O.inlineTokens(ie)};var ye=Se.prototype;return ye.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(ie,ue,O){ue===void 0&&(ue=[]),O===void 0&&(O=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var Y,ae,Ce,ke;ie;){if(Y=this.tokenizer.space(ie)){ie=ie.substring(Y.raw.length),Y.type&&ue.push(Y);continue}if(Y=this.tokenizer.code(ie)){ie=ie.substring(Y.raw.length),ke=ue[ue.length-1],ke&&ke.type==="paragraph"?(ke.raw+=`
`+Y.raw,ke.text+=`
`+Y.text):ue.push(Y);continue}if(Y=this.tokenizer.fences(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.heading(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.nptable(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.hr(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.blockquote(ie)){ie=ie.substring(Y.raw.length),Y.tokens=this.blockTokens(Y.text,[],O),ue.push(Y);continue}if(Y=this.tokenizer.list(ie)){for(ie=ie.substring(Y.raw.length),Ce=Y.items.length,ae=0;ae<Ce;ae++)Y.items[ae].tokens=this.blockTokens(Y.items[ae].text,[],!1);ue.push(Y);continue}if(Y=this.tokenizer.html(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(O&&(Y=this.tokenizer.def(ie))){ie=ie.substring(Y.raw.length),this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.lheading(ie)){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(O&&(Y=this.tokenizer.paragraph(ie))){ie=ie.substring(Y.raw.length),ue.push(Y);continue}if(Y=this.tokenizer.text(ie)){ie=ie.substring(Y.raw.length),ke=ue[ue.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+Y.raw,ke.text+=`
`+Y.text):ue.push(Y);continue}if(ie){var Ne="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return ue},ye.inline=function(ie){var ue,O,Y,ae,Ce,ke,Ne=ie.length;for(ue=0;ue<Ne;ue++)switch(ke=ie[ue],ke.type){case"paragraph":case"text":case"heading":{ke.tokens=[],this.inlineTokens(ke.text,ke.tokens);break}case"table":{for(ke.tokens={header:[],cells:[]},ae=ke.header.length,O=0;O<ae;O++)ke.tokens.header[O]=[],this.inlineTokens(ke.header[O],ke.tokens.header[O]);for(ae=ke.cells.length,O=0;O<ae;O++)for(Ce=ke.cells[O],ke.tokens.cells[O]=[],Y=0;Y<Ce.length;Y++)ke.tokens.cells[O][Y]=[],this.inlineTokens(Ce[Y],ke.tokens.cells[O][Y]);break}case"blockquote":{this.inline(ke.tokens);break}case"list":{for(ae=ke.items.length,O=0;O<ae;O++)this.inline(ke.items[O].tokens);break}}return ie},ye.inlineTokens=function(ie,ue,O,Y){ue===void 0&&(ue=[]),O===void 0&&(O=!1),Y===void 0&&(Y=!1);var ae,Ce,ke=ie,Ne,Oe,qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)rt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ne.index)+"["+ze("a",Ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ne.index)+"["+ze("a",Ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ne.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Oe||(qe=""),Oe=!1,ae=this.tokenizer.escape(ie)){ie=ie.substring(ae.raw.length),ue.push(ae);continue}if(ae=this.tokenizer.tag(ie,O,Y)){ie=ie.substring(ae.raw.length),O=ae.inLink,Y=ae.inRawBlock;var tt=ue[ue.length-1];tt&&ae.type==="text"&&tt.type==="text"?(tt.raw+=ae.raw,tt.text+=ae.text):ue.push(ae);continue}if(ae=this.tokenizer.link(ie)){ie=ie.substring(ae.raw.length),ae.type==="link"&&(ae.tokens=this.inlineTokens(ae.text,[],!0,Y)),ue.push(ae);continue}if(ae=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(ae.raw.length);var Je=ue[ue.length-1];ae.type==="link"?(ae.tokens=this.inlineTokens(ae.text,[],!0,Y),ue.push(ae)):Je&&ae.type==="text"&&Je.type==="text"?(Je.raw+=ae.raw,Je.text+=ae.text):ue.push(ae);continue}if(ae=this.tokenizer.emStrong(ie,ke,qe)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,Y),ue.push(ae);continue}if(ae=this.tokenizer.codespan(ie)){ie=ie.substring(ae.raw.length),ue.push(ae);continue}if(ae=this.tokenizer.br(ie)){ie=ie.substring(ae.raw.length),ue.push(ae);continue}if(ae=this.tokenizer.del(ie)){ie=ie.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],O,Y),ue.push(ae);continue}if(ae=this.tokenizer.autolink(ie,Ke)){ie=ie.substring(ae.raw.length),ue.push(ae);continue}if(!O&&(ae=this.tokenizer.url(ie,Ke))){ie=ie.substring(ae.raw.length),ue.push(ae);continue}if(ae=this.tokenizer.inlineText(ie,Y,Qe)){ie=ie.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(qe=ae.raw.slice(-1)),Oe=!0,Ce=ue[ue.length-1],Ce&&Ce.type==="text"?(Ce.raw+=ae.raw,Ce.text+=ae.text):ue.push(ae);continue}if(ie){var ot="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return ue},e(Se,null,[{key:"rules",get:function(){return{block:$e,inline:Me}}}]),Se}(),$=k.defaults,Q=N.cleanUrl,ne=N.escape,re=function(){function Se(De){this.options=De||$}var ye=Se.prototype;return ye.code=function(ie,ue,O){var Y=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(ie,Y);ae!=null&&ae!==ie&&(O=!0,ie=ae)}return ie=ie.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+ne(Y,!0)+'">'+(O?ie:ne(ie,!0))+`</code></pre>
`:"<pre><code>"+(O?ie:ne(ie,!0))+`</code></pre>
`},ye.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},ye.html=function(ie){return ie},ye.heading=function(ie,ue,O,Y){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+Y.slug(O)+'">'+ie+"</h"+ue+`>
`:"<h"+ue+">"+ie+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ie,ue,O){var Y=ue?"ol":"ul",ae=ue&&O!==1?' start="'+O+'"':"";return"<"+Y+ae+`>
`+ie+"</"+Y+`>
`},ye.listitem=function(ie){return"<li>"+ie+`</li>
`},ye.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ie){return"<p>"+ie+`</p>
`},ye.table=function(ie,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},ye.tablecell=function(ie,ue){var O=ue.header?"th":"td",Y=ue.align?"<"+O+' align="'+ue.align+'">':"<"+O+">";return Y+ie+"</"+O+`>
`},ye.strong=function(ie){return"<strong>"+ie+"</strong>"},ye.em=function(ie){return"<em>"+ie+"</em>"},ye.codespan=function(ie){return"<code>"+ie+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ie){return"<del>"+ie+"</del>"},ye.link=function(ie,ue,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var Y='<a href="'+ne(ie)+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=">"+O+"</a>",Y},ye.image=function(ie,ue,O){if(ie=Q(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var Y='<img src="'+ie+'" alt="'+O+'"';return ue&&(Y+=' title="'+ue+'"'),Y+=this.options.xhtml?"/>":">",Y},ye.text=function(ie){return ie},Se}(),K=function(){function Se(){}var ye=Se.prototype;return ye.strong=function(ie){return ie},ye.em=function(ie){return ie},ye.codespan=function(ie){return ie},ye.del=function(ie){return ie},ye.html=function(ie){return ie},ye.text=function(ie){return ie},ye.link=function(ie,ue,O){return""+O},ye.image=function(ie,ue,O){return""+O},ye.br=function(){return""},Se}(),se=function(){function Se(){this.seen={}}var ye=Se.prototype;return ye.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ie,ue){var O=ie,Y=0;if(this.seen.hasOwnProperty(O)){Y=this.seen[ie];do Y++,O=ie+"-"+Y;while(this.seen.hasOwnProperty(O))}return ue||(this.seen[ie]=Y,this.seen[O]=0),O},ye.slug=function(ie,ue){ue===void 0&&(ue={});var O=this.serialize(ie);return this.getNextSafeSlug(O,ue.dryrun)},Se}(),fe=k.defaults,Ae=N.unescape,ge=function(){function Se(De){this.options=De||fe,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new se}Se.parse=function(ie,ue){var O=new Se(ue);return O.parse(ie)},Se.parseInline=function(ie,ue){var O=new Se(ue);return O.parseInline(ie)};var ye=Se.prototype;return ye.parse=function(ie,ue){ue===void 0&&(ue=!0);var O="",Y,ae,Ce,ke,Ne,Oe,qe,rt,tt,Je,ot,_t,wt,be,de,le,q,Fe,Pe=ie.length;for(Y=0;Y<Pe;Y++)switch(Je=ie[Y],Je.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Ae(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",qe="",ke=Je.header.length,ae=0;ae<ke;ae++)qe+=this.renderer.tablecell(this.parseInline(Je.tokens.header[ae]),{header:!0,align:Je.align[ae]});for(rt+=this.renderer.tablerow(qe),tt="",ke=Je.cells.length,ae=0;ae<ke;ae++){for(Oe=Je.tokens.cells[ae],qe="",Ne=Oe.length,Ce=0;Ce<Ne;Ce++)qe+=this.renderer.tablecell(this.parseInline(Oe[Ce]),{header:!1,align:Je.align[Ce]});tt+=this.renderer.tablerow(qe)}O+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Je.tokens),O+=this.renderer.blockquote(tt);continue}case"list":{for(ot=Je.ordered,_t=Je.start,wt=Je.loose,ke=Je.items.length,tt="",ae=0;ae<ke;ae++)de=Je.items[ae],le=de.checked,q=de.task,be="",de.task&&(Fe=this.renderer.checkbox(le),wt?de.tokens.length>0&&de.tokens[0].type==="text"?(de.tokens[0].text=Fe+" "+de.tokens[0].text,de.tokens[0].tokens&&de.tokens[0].tokens.length>0&&de.tokens[0].tokens[0].type==="text"&&(de.tokens[0].tokens[0].text=Fe+" "+de.tokens[0].tokens[0].text)):de.tokens.unshift({type:"text",text:Fe}):be+=Fe),be+=this.parse(de.tokens,wt),tt+=this.renderer.listitem(be,q,le);O+=this.renderer.list(tt,ot,_t);continue}case"html":{O+=this.renderer.html(Je.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(tt=Je.tokens?this.parseInline(Je.tokens):Je.text;Y+1<Pe&&ie[Y+1].type==="text";)Je=ie[++Y],tt+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);O+=ue?this.renderer.paragraph(tt):tt;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return O},ye.parseInline=function(ie,ue){ue=ue||this.renderer;var O="",Y,ae,Ce=ie.length;for(Y=0;Y<Ce;Y++)switch(ae=ie[Y],ae.type){case"escape":{O+=ue.text(ae.text);break}case"html":{O+=ue.html(ae.text);break}case"link":{O+=ue.link(ae.href,ae.title,this.parseInline(ae.tokens,ue));break}case"image":{O+=ue.image(ae.href,ae.title,ae.text);break}case"strong":{O+=ue.strong(this.parseInline(ae.tokens,ue));break}case"em":{O+=ue.em(this.parseInline(ae.tokens,ue));break}case"codespan":{O+=ue.codespan(ae.text);break}case"br":{O+=ue.br();break}case"del":{O+=ue.del(this.parseInline(ae.tokens,ue));break}case"text":{O+=ue.text(ae.text);break}default:{var ke='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}return O},Se}(),We=N.merge,H=N.checkSanitizeDeprecation,te=N.escape,ve=k.getDefaults,Le=k.changeDefaults,xe=k.defaults;function Be(Se,ye,De){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=We({},Be.defaults,ye||{}),H(ye),De){var ie=ye.highlight,ue;try{ue=Ge.lex(Se,ye)}catch(Ce){return De(Ce)}var O=function(ke){var Ne;if(!ke)try{Ne=ge.parse(ue,ye)}catch(Oe){ke=Oe}return ye.highlight=ie,ke?De(ke):De(null,Ne)};if(!ie||ie.length<3||(delete ye.highlight,!ue.length))return O();var Y=0;Be.walkTokens(ue,function(Ce){Ce.type==="code"&&(Y++,setTimeout(function(){ie(Ce.text,Ce.lang,function(ke,Ne){if(ke)return O(ke);Ne!=null&&Ne!==Ce.text&&(Ce.text=Ne,Ce.escaped=!0),Y--,Y===0&&O()})},0))}),Y===0&&O();return}try{var ae=Ge.lex(Se,ye);return ye.walkTokens&&Be.walkTokens(ae,ye.walkTokens),ge.parse(ae,ye)}catch(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(Ce.message+"",!0)+"</pre>";throw Ce}}Be.options=Be.setOptions=function(Se){return We(Be.defaults,Se),Le(Be.defaults),Be},Be.getDefaults=ve,Be.defaults=xe,Be.use=function(Se){var ye=We({},Se);if(Se.renderer&&function(){var ie=Be.defaults.renderer||new re,ue=function(ae){var Ce=ie[ae];ie[ae]=function(){for(var ke=arguments.length,Ne=new Array(ke),Oe=0;Oe<ke;Oe++)Ne[Oe]=arguments[Oe];var qe=Se.renderer[ae].apply(ie,Ne);return qe===!1&&(qe=Ce.apply(ie,Ne)),qe}};for(var O in Se.renderer)ue(O);ye.renderer=ie}(),Se.tokenizer&&function(){var ie=Be.defaults.tokenizer||new B,ue=function(ae){var Ce=ie[ae];ie[ae]=function(){for(var ke=arguments.length,Ne=new Array(ke),Oe=0;Oe<ke;Oe++)Ne[Oe]=arguments[Oe];var qe=Se.tokenizer[ae].apply(ie,Ne);return qe===!1&&(qe=Ce.apply(ie,Ne)),qe}};for(var O in Se.tokenizer)ue(O);ye.tokenizer=ie}(),Se.walkTokens){var De=Be.defaults.walkTokens;ye.walkTokens=function(ie){Se.walkTokens(ie),De&&De(ie)}}Be.setOptions(ye)},Be.walkTokens=function(Se,ye){for(var De=D(Se),ie;!(ie=De()).done;){var ue=ie.value;switch(ye(ue),ue.type){case"table":{for(var O=D(ue.tokens.header),Y;!(Y=O()).done;){var ae=Y.value;Be.walkTokens(ae,ye)}for(var Ce=D(ue.tokens.cells),ke;!(ke=Ce()).done;)for(var Ne=ke.value,Oe=D(Ne),qe;!(qe=Oe()).done;){var rt=qe.value;Be.walkTokens(rt,ye)}break}case"list":{Be.walkTokens(ue.items,ye);break}default:ue.tokens&&Be.walkTokens(ue.tokens,ye)}}},Be.parseInline=function(Se,ye){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ye=We({},Be.defaults,ye||{}),H(ye);try{var De=Ge.lexInline(Se,ye);return ye.walkTokens&&Be.walkTokens(De,ye.walkTokens),ge.parseInline(De,ye)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(ie.message+"",!0)+"</pre>";throw ie}},Be.Parser=ge,Be.parser=ge.parse,Be.Renderer=re,Be.TextRenderer=K,Be.Lexer=Ge,Be.lexer=Ge.lex,Be.Tokenizer=B,Be.Slugger=se,Be.parse=Be;var Ye=Be;return Ye}),define(we[77],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(k,y,_){return Math.min(Math.max(k,y),_)}e.clamp=g;function T(k,y){return(y+k%y)%y}e.rot=T;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class E{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function Z(D){const E=[];typeof D=="number"&&E.push("code/timeOrigin",D);function k(_){E.push(_,Date.now())}function y(){const _=[];for(let I=0;I<E.length;I+=2)_.push({name:E[I],startTime:E[I+1]});return _}return{mark:k,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(D+k.startTime)});return E}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=g(T))}(),define(we[21],_e([0,1]),function(Z,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let D=!1,E=!1,k=!1,y=!1,_=!1,I=!1,i=!1,P,o=T,h,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?u=e.globals.vscode.process:typeof process!="undefined"&&(u=process);const w=typeof((g=u==null?void 0:u.versions)===null||g===void 0?void 0:g.electron)=="string"&&u.type==="renderer";if(e.isElectronSandboxed=w&&(u==null?void 0:u.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=u==null?void 0:u.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)d=navigator.userAgent,D=d.indexOf("Windows")>=0,E=d.indexOf("Macintosh")>=0,i=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,I=!0,P=navigator.language,o=P;else if(typeof u=="object"){D=u.platform==="win32",E=u.platform==="darwin",k=u.platform==="linux",y=k&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,P=T,o=T;const s=u.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),v=l.availableLanguages["*"];P=l.locale,o=v||T,h=l._translationsConfigFile}catch(l){}_=!0}else console.error("Unable to resolve platform.");var p;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let c=0;E?c=1:D?c=3:k&&(c=2),e.isWindows=D,e.isMacintosh=E,e.isLinux=k,e.isLinuxSnap=y,e.isNative=_,e.isWeb=I,e.isIOS=i,e.platform=c,e.userAgent=d,e.language=o;var m;(function(s){function l(){return e.language}s.value=l;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=v;function b(){return e.language==="en"}s.isDefault=b})(m=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let C=0,a=v.length;C<a;C++){const F=v[C];if(F.id===A.data.vscodeSetImmediateId){v.splice(C,1),F.callback();return}}});let b=0;return A=>{const C=++b;v.push({id:C,callback:A}),e.globals.postMessage({vscodeSetImmediateId:C},"*")}}if(typeof(u==null?void 0:u.nextTick)=="function")return u.nextTick.bind(u);const l=Promise.resolve();return v=>l.then(v)}();var f;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=E||i?2:D?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(we[40],_e([0,1,21]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;T={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(E){return g.setImmediate(E)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(D){return g.setImmediate(D)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(we[13],_e([0,1,40]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,E=90,k=122,y=46,_=47,I=92,i=58,P=63;class o extends Error{constructor(m,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const r=m.indexOf(".")!==-1?"property":"argument";let s=`The "${m}" ${r} ${n} of type ${f}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function h(c,m){if(typeof c!="string")throw new o(m,"string",c)}function d(c){return c===_||c===I}function u(c){return c===_}function w(c){return c>=T&&c<=E||c>=D&&c<=k}function p(c,m,f,t){let n="",r=0,s=-1,l=0,v=0;for(let b=0;b<=c.length;++b){if(b<c.length)v=c.charCodeAt(b);else{if(t(v))break;v=_}if(t(v)){if(!(s===b-1||l===1))if(l===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==y||n.charCodeAt(n.length-2)!==y){if(n.length>2){const A=n.lastIndexOf(f);A===-1?(n="",r=0):(n=n.slice(0,A),r=n.length-1-n.lastIndexOf(f)),s=b,l=0;continue}else if(n.length!==0){n="",r=0,s=b,l=0;continue}}m&&(n+=n.length>0?`${f}..`:"..",r=2)}else n.length>0?n+=`${f}${c.slice(s+1,b)}`:n=c.slice(s+1,b),r=b-s-1;s=b,l=0}else v===y&&l!==-1?++l:l=-1}return n}function S(c,m){if(m===null||typeof m!="object")throw new o("pathObject","Object",m);const f=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return f?f===m.root?`${f}${t}`:`${f}${c}${t}`:t}e.win32={resolve(...c){let m="",f="",t=!1;for(let n=c.length-1;n>=-1;n--){let r;if(n>=0){if(r=c[n],h(r,"path"),r.length===0)continue}else m.length===0?r=g.cwd():(r=g.env[`=${m}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==m.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${m}\\`));const s=r.length;let l=0,v="",b=!1;const A=r.charCodeAt(0);if(s===1)d(A)&&(l=1,b=!0);else if(d(A))if(b=!0,d(r.charCodeAt(1))){let C=2,a=C;for(;C<s&&!d(r.charCodeAt(C));)C++;if(C<s&&C!==a){const F=r.slice(a,C);for(a=C;C<s&&d(r.charCodeAt(C));)C++;if(C<s&&C!==a){for(a=C;C<s&&!d(r.charCodeAt(C));)C++;(C===s||C!==a)&&(v=`\\\\${F}\\${r.slice(a,C)}`,l=C)}}}else l=1;else w(A)&&r.charCodeAt(1)===i&&(v=r.slice(0,2),l=2,s>2&&d(r.charCodeAt(2))&&(b=!0,l=3));if(v.length>0)if(m.length>0){if(v.toLowerCase()!==m.toLowerCase())continue}else m=v;if(t){if(m.length>0)break}else if(f=`${r.slice(l)}\\${f}`,t=b,b&&m.length>0)break}return f=p(f,!t,"\\",d),t?`${m}\\${f}`:`${m}${f}`||"."},normalize(c){h(c,"path");const m=c.length;if(m===0)return".";let f=0,t,n=!1;const r=c.charCodeAt(0);if(m===1)return u(r)?"\\":c;if(d(r))if(n=!0,d(c.charCodeAt(1))){let l=2,v=l;for(;l<m&&!d(c.charCodeAt(l));)l++;if(l<m&&l!==v){const b=c.slice(v,l);for(v=l;l<m&&d(c.charCodeAt(l));)l++;if(l<m&&l!==v){for(v=l;l<m&&!d(c.charCodeAt(l));)l++;if(l===m)return`\\\\${b}\\${c.slice(v)}\\`;l!==v&&(t=`\\\\${b}\\${c.slice(v,l)}`,f=l)}}}else f=1;else w(r)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),f=2,m>2&&d(c.charCodeAt(2))&&(n=!0,f=3));let s=f<m?p(c.slice(f),!n,"\\",d):"";return s.length===0&&!n&&(s="."),s.length>0&&d(c.charCodeAt(m-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(c){h(c,"path");const m=c.length;if(m===0)return!1;const f=c.charCodeAt(0);return d(f)||m>2&&w(f)&&c.charCodeAt(1)===i&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let m,f;for(let r=0;r<c.length;++r){const s=c[r];h(s,"path"),s.length>0&&(m===void 0?m=f=s:m+=`\\${s}`)}if(m===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++n;const r=f.length;r>1&&d(f.charCodeAt(1))&&(++n,r>2&&(d(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<m.length&&d(m.charCodeAt(n));)n++;n>=2&&(m=`\\${m.slice(n)}`)}return e.win32.normalize(m)},relative(c,m){if(h(c,"from"),h(m,"to"),c===m)return"";const f=e.win32.resolve(c),t=e.win32.resolve(m);if(f===t||(c=f.toLowerCase(),m=t.toLowerCase(),c===m))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===I;)n++;let r=c.length;for(;r-1>n&&c.charCodeAt(r-1)===I;)r--;const s=r-n;let l=0;for(;l<m.length&&m.charCodeAt(l)===I;)l++;let v=m.length;for(;v-1>l&&m.charCodeAt(v-1)===I;)v--;const b=v-l,A=s<b?s:b;let C=-1,a=0;for(;a<A;a++){const N=c.charCodeAt(n+a);if(N!==m.charCodeAt(l+a))break;N===I&&(C=a)}if(a!==A){if(C===-1)return t}else{if(b>A){if(m.charCodeAt(l+a)===I)return t.slice(l+a+1);if(a===2)return t.slice(l+a)}s>A&&(c.charCodeAt(n+a)===I?C=a:a===2&&(C=3)),C===-1&&(C=0)}let F="";for(a=n+C+1;a<=r;++a)(a===r||c.charCodeAt(a)===I)&&(F+=F.length===0?"..":"\\..");return l+=C,F.length>0?`${F}${t.slice(l,v)}`:(t.charCodeAt(l)===I&&++l,t.slice(l,v))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const m=e.win32.resolve(c);if(m.length<=2)return c;if(m.charCodeAt(0)===I){if(m.charCodeAt(1)===I){const f=m.charCodeAt(2);if(f!==P&&f!==y)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(w(m.charCodeAt(0))&&m.charCodeAt(1)===i&&m.charCodeAt(2)===I)return`\\\\?\\${m}`;return c},dirname(c){h(c,"path");const m=c.length;if(m===0)return".";let f=-1,t=0;const n=c.charCodeAt(0);if(m===1)return d(n)?c:".";if(d(n)){if(f=t=1,d(c.charCodeAt(1))){let l=2,v=l;for(;l<m&&!d(c.charCodeAt(l));)l++;if(l<m&&l!==v){for(v=l;l<m&&d(c.charCodeAt(l));)l++;if(l<m&&l!==v){for(v=l;l<m&&!d(c.charCodeAt(l));)l++;if(l===m)return c;l!==v&&(f=t=l+1)}}}}else w(n)&&c.charCodeAt(1)===i&&(f=m>2&&d(c.charCodeAt(2))?3:2,t=f);let r=-1,s=!0;for(let l=m-1;l>=t;--l)if(d(c.charCodeAt(l))){if(!s){r=l;break}}else s=!1;if(r===-1){if(f===-1)return".";r=f}return c.slice(0,r)},basename(c,m){m!==void 0&&h(m,"ext"),h(c,"path");let f=0,t=-1,n=!0,r;if(c.length>=2&&w(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(f=2),m!==void 0&&m.length>0&&m.length<=c.length){if(m===c)return"";let s=m.length-1,l=-1;for(r=c.length-1;r>=f;--r){const v=c.charCodeAt(r);if(d(v)){if(!n){f=r+1;break}}else l===-1&&(n=!1,l=r+1),s>=0&&(v===m.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=l))}return f===t?t=l:t===-1&&(t=c.length),c.slice(f,t)}for(r=c.length-1;r>=f;--r)if(d(c.charCodeAt(r))){if(!n){f=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":c.slice(f,t)},extname(c){h(c,"path");let m=0,f=-1,t=0,n=-1,r=!0,s=0;c.length>=2&&c.charCodeAt(1)===i&&w(c.charCodeAt(0))&&(m=t=2);for(let l=c.length-1;l>=m;--l){const v=c.charCodeAt(l);if(d(v)){if(!r){t=l+1;break}continue}n===-1&&(r=!1,n=l+1),v===y?f===-1?f=l:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||n===-1||s===0||s===1&&f===n-1&&f===t+1?"":c.slice(f,n)},format:S.bind(null,"\\"),parse(c){h(c,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return m;const f=c.length;let t=0,n=c.charCodeAt(0);if(f===1)return d(n)?(m.root=m.dir=c,m):(m.base=m.name=c,m);if(d(n)){if(t=1,d(c.charCodeAt(1))){let C=2,a=C;for(;C<f&&!d(c.charCodeAt(C));)C++;if(C<f&&C!==a){for(a=C;C<f&&d(c.charCodeAt(C));)C++;if(C<f&&C!==a){for(a=C;C<f&&!d(c.charCodeAt(C));)C++;C===f?t=C:C!==a&&(t=C+1)}}}}else if(w(n)&&c.charCodeAt(1)===i){if(f<=2)return m.root=m.dir=c,m;if(t=2,d(c.charCodeAt(2))){if(f===3)return m.root=m.dir=c,m;t=3}}t>0&&(m.root=c.slice(0,t));let r=-1,s=t,l=-1,v=!0,b=c.length-1,A=0;for(;b>=t;--b){if(n=c.charCodeAt(b),d(n)){if(!v){s=b+1;break}continue}l===-1&&(v=!1,l=b+1),n===y?r===-1?r=b:A!==1&&(A=1):r!==-1&&(A=-1)}return l!==-1&&(r===-1||A===0||A===1&&r===l-1&&r===s+1?m.base=m.name=c.slice(s,l):(m.name=c.slice(s,r),m.base=c.slice(s,l),m.ext=c.slice(r,l))),s>0&&s!==t?m.dir=c.slice(0,s-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let m="",f=!1;for(let t=c.length-1;t>=-1&&!f;t--){const n=t>=0?c[t]:g.cwd();h(n,"path"),n.length!==0&&(m=`${n}/${m}`,f=n.charCodeAt(0)===_)}return m=p(m,!f,"/",u),f?`/${m}`:m.length>0?m:"."},normalize(c){if(h(c,"path"),c.length===0)return".";const m=c.charCodeAt(0)===_,f=c.charCodeAt(c.length-1)===_;return c=p(c,!m,"/",u),c.length===0?m?"/":f?"./":".":(f&&(c+="/"),m?`/${c}`:c)},isAbsolute(c){return h(c,"path"),c.length>0&&c.charCodeAt(0)===_},join(...c){if(c.length===0)return".";let m;for(let f=0;f<c.length;++f){const t=c[f];h(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(c,m){if(h(c,"from"),h(m,"to"),c===m||(c=e.posix.resolve(c),m=e.posix.resolve(m),c===m))return"";const f=1,t=c.length,n=t-f,r=1,s=m.length-r,l=n<s?n:s;let v=-1,b=0;for(;b<l;b++){const C=c.charCodeAt(f+b);if(C!==m.charCodeAt(r+b))break;C===_&&(v=b)}if(b===l)if(s>l){if(m.charCodeAt(r+b)===_)return m.slice(r+b+1);if(b===0)return m.slice(r+b)}else n>l&&(c.charCodeAt(f+b)===_?v=b:b===0&&(v=0));let A="";for(b=f+v+1;b<=t;++b)(b===t||c.charCodeAt(b)===_)&&(A+=A.length===0?"..":"/..");return`${A}${m.slice(r+v)}`},toNamespacedPath(c){return c},dirname(c){if(h(c,"path"),c.length===0)return".";const m=c.charCodeAt(0)===_;let f=-1,t=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===_){if(!t){f=n;break}}else t=!1;return f===-1?m?"/":".":m&&f===1?"//":c.slice(0,f)},basename(c,m){m!==void 0&&h(m,"ext"),h(c,"path");let f=0,t=-1,n=!0,r;if(m!==void 0&&m.length>0&&m.length<=c.length){if(m===c)return"";let s=m.length-1,l=-1;for(r=c.length-1;r>=0;--r){const v=c.charCodeAt(r);if(v===_){if(!n){f=r+1;break}}else l===-1&&(n=!1,l=r+1),s>=0&&(v===m.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=l))}return f===t?t=l:t===-1&&(t=c.length),c.slice(f,t)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===_){if(!n){f=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":c.slice(f,t)},extname(c){h(c,"path");let m=-1,f=0,t=-1,n=!0,r=0;for(let s=c.length-1;s>=0;--s){const l=c.charCodeAt(s);if(l===_){if(!n){f=s+1;break}continue}t===-1&&(n=!1,t=s+1),l===y?m===-1?m=s:r!==1&&(r=1):m!==-1&&(r=-1)}return m===-1||t===-1||r===0||r===1&&m===t-1&&m===f+1?"":c.slice(m,t)},format:S.bind(null,"/"),parse(c){h(c,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return m;const f=c.charCodeAt(0)===_;let t;f?(m.root="/",t=1):t=0;let n=-1,r=0,s=-1,l=!0,v=c.length-1,b=0;for(;v>=t;--v){const A=c.charCodeAt(v);if(A===_){if(!l){r=v+1;break}continue}s===-1&&(l=!1,s=v+1),A===y?n===-1?n=v:b!==1&&(b=1):n!==-1&&(b=-1)}if(s!==-1){const A=r===0&&f?1:r;n===-1||b===0||b===1&&n===s-1&&n===r+1?m.base=m.name=c.slice(A,s):(m.name=c.slice(A,n),m.base=c.slice(A,s),m.ext=c.slice(n,s))}return r>0?m.dir=c.slice(0,r-1):f&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[52],_e([0,1,21]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(we[3],_e([0,1,12,48,7,51,52]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var y;(function(p){p.None=()=>D.Disposable.None;function S(G){return(V,J=null,R)=>{let B=!1,M;return M=G(U=>{if(!B)return M?M.dispose():B=!0,V.call(J,U)},null,R),B&&M.dispose(),M}}p.once=S;function c(G,V){return s((J,R=null,B)=>G(M=>J.call(R,V(M)),null,B))}p.map=c;function m(G,V){return s((J,R=null,B)=>G(M=>{V(M),J.call(R,M)},null,B))}p.forEach=m;function f(G,V){return s((J,R=null,B)=>G(M=>V(M)&&J.call(R,M),null,B))}p.filter=f;function t(G){return G}p.signal=t;function n(...G){return(V,J=null,R)=>D.combinedDisposable(...G.map(B=>B(M=>V.call(J,M),null,R)))}p.any=n;function r(G,V,J){let R=J;return c(G,B=>(R=V(R,B),R))}p.reduce=r;function s(G){let V;const J=new o({onFirstListenerAdd(){V=G(J.fire,J)},onLastListenerRemove(){V.dispose()}});return J.event}p.snapshot=s;function l(G,V,J=100,R=!1,B){let M,U,j,z=0;const oe=new o({leakWarningThreshold:B,onFirstListenerAdd(){M=G(pe=>{z++,U=V(U,pe),R&&!j&&(oe.fire(U),U=void 0),clearTimeout(j),j=setTimeout(()=>{const Te=U;U=void 0,j=void 0,(!R||z>1)&&oe.fire(Te),z=0},J)})},onLastListenerRemove(){M.dispose()}});return oe.event}p.debounce=l;function v(G){const V=new Date().getTime();return c(S(G),J=>new Date().getTime()-V)}p.stopwatch=v;function b(G,V=(J,R)=>J===R){let J=!0,R;return f(G,B=>{const M=J||!V(B,R);return J=!1,R=B,M})}p.latch=b;function A(G,V){return[p.filter(G,V),p.filter(G,J=>!V(J))]}p.split=A;function C(G,V=!1,J=[]){let R=J.slice(),B=G(j=>{R?R.push(j):U.fire(j)});const M=()=>{R&&R.forEach(j=>U.fire(j)),R=null},U=new o({onFirstListenerAdd(){B||(B=G(j=>U.fire(j)))},onFirstListenerDidAdd(){R&&(V?setTimeout(M):M())},onLastListenerRemove(){B&&B.dispose(),B=null}});return U.event}p.buffer=C;class a{constructor(V){this.event=V}map(V){return new a(c(this.event,V))}forEach(V){return new a(m(this.event,V))}filter(V){return new a(f(this.event,V))}reduce(V,J){return new a(r(this.event,V,J))}latch(){return new a(b(this.event))}debounce(V,J=100,R=!1,B){return new a(l(this.event,V,J,R,B))}on(V,J,R){return this.event(V,J,R)}once(V,J,R){return S(this.event)(V,J,R)}}function F(G){return new a(G)}p.chain=F;function N(G,V,J=R=>R){const R=(...j)=>U.fire(J(...j)),B=()=>G.on(V,R),M=()=>G.removeListener(V,R),U=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return U.event}p.fromNodeEventEmitter=N;function W(G,V,J=R=>R){const R=(...j)=>U.fire(J(...j)),B=()=>G.addEventListener(V,R),M=()=>G.removeEventListener(V,R),U=new o({onFirstListenerAdd:B,onLastListenerRemove:M});return U.event}p.fromDOMEventEmitter=W;function ce(G){const V=new o;let J=!1;return G.then(void 0,()=>null).then(()=>{J?V.fire(void 0):setTimeout(()=>V.fire(void 0),0)}),J=!0,V.event}p.fromPromise=ce;function me(G){return new Promise(V=>S(G)(V))}p.toPromise=me})(y=e.Event||(e.Event={}));class _{constructor(S){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${S}_${_._idPool++}`}start(S){this._stopWatch=new k.StopWatch(!0),this._listenerCount=S}stop(){if(this._stopWatch){const S=this._stopWatch.elapsed();this._elapsedOverall+=S,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${S.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let I=-1;function i(p){const S=I;return I=p,{dispose(){I=S}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(S,c=Math.random().toString(18).slice(2,5)){this.customThreshold=S,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(S){let c=I;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),c<=0||S<c)return;this._stacks||(this._stacks=new Map);const m=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(m)||0;if(this._stacks.set(m,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,n=0;for(const[r,s]of this._stacks)(!t||n<s)&&(t=r,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(m)||0;this._stacks.set(m,t-1)}}}class o{constructor(S){var c;this._disposed=!1,this._options=S,this._leakageMon=I>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(S,c,m)=>{var f;this._listeners||(this._listeners=new E.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[S,c]:S);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,S,c);const r=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let s;return s={dispose:()=>{r&&r(),s.dispose=o._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},m instanceof D.DisposableStore?m.add(s):Array.isArray(m)&&m.push(s),s}),this._event}fire(S){var c,m;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,S]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){g.onUnexpectedError(n)}}(m=this._perfMon)===null||m===void 0||m.stop()}}dispose(){var S,c,m,f,t;this._disposed||(this._disposed=!0,(S=this._listeners)===null||S===void 0||S.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(f=(m=this._options)===null||m===void 0?void 0:m.onLastListenerRemove)===null||f===void 0||f.call(m),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=o,o._noop=function(){};class h extends o{constructor(S){super(S);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=S==null?void 0:S.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const S=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(S))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(S){this._listeners&&(this._isPaused!==0?this._eventQueue.push(S):super.fire(S))}}e.PauseableEmitter=h;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(S){const c={event:S,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const m=()=>{this.hasListeners&&this.unhook(c);const f=this.events.indexOf(c);this.events.splice(f,1)};return D.toDisposable(T.once(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(S=>this.hook(S))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(S=>this.unhook(S))}hook(S){S.listener=S.event(c=>this.emitter.fire(c))}unhook(S){S.listener&&S.listener.dispose(),S.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class u{constructor(){this.buffers=[]}wrapEvent(S){return(c,m,f)=>S(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>c.call(m,t)):c.call(m,t)},void 0,f)}bufferEvents(S){const c=[];this.buffers.push(c);const m=S();return this.buffers.pop(),c.forEach(f=>f()),m}}e.EventBufferer=u;class w{constructor(){this.listening=!1,this.inputEvent=y.None,this.inputEventListener=D.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(S){this.inputEvent=S,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=S(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(we[18],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(y,_){const I=setTimeout(y.bind(_),0);return{dispose(){clearTimeout(I)}}});var D;(function(y){function _(I){return I===y.None||I===y.Cancelled||I instanceof E?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}y.isCancellationToken=_,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=D.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(we[78],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(P){const o=this._icons.get(P.id);o?P.description?o.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new T;e.iconRegistry=D;function E(i,P){return new y(i,P)}e.registerCodicon=E;function k(i){return i?i.replace(/\$\((.*?)\)/g,(P,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class y{constructor(P,o,h){this.id=P,this.definition=o,this.description=h,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=y;function _(i,P){const o=["codicon","codicon-"+i];return P&&o.push("codicon-modifier-"+P),o}e.getClassNamesArray=_;var I;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function o(u){if(u instanceof y)return["codicon","codicon-"+u.id];const w=P.exec(u.id);if(!w)return o(y.error);let[,p,S]=w;const c=["codicon","codicon-"+p];return S&&c.push("codicon-modifier-"+S.substr(1)),c}i.asClassNameArray=o;function h(u){return o(u).join(" ")}i.asClassName=h;function d(u){return"."+o(u).join(".")}i.asCSSSelector=d})(I=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(y=e.Codicon||(e.Codicon={}))}),define(we[107],_e([0,1,12,7]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const m=c;return m?[m.on,m.pause,m.resume,m.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=D;function E(c){const m=c;return m?D(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=E;function k(c,m){return new y(c,m)}e.newWriteableStream=k;class y{constructor(m,f){this.reducer=m,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(f=>f(m))}emitError(m){this.listeners.error.length===0?g.onUnexpectedError(m):this.listeners.error.slice(0).forEach(f=>f(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,f){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(m,f){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(c,m){const f=[];let t;for(;(t=c.read())!==null;)f.push(t);return m(f)}e.consumeReadable=_;function I(c,m,f){const t=[];let n;for(;(n=c.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const r=n;return n=void 0,r}return c.read()}}}e.peekReadable=I;function i(c,m){return new Promise((f,t)=>{const n=[];P(c,{onData:r=>{m&&n.push(r)},onError:r=>{m?t(r):f(void 0)},onEnd:()=>{f(m?m(n):void 0)}})})}e.consumeStream=i;function P(c,m){c.on("error",f=>m.onError(f)),c.on("end",()=>m.onEnd()),c.on("data",f=>m.onData(f))}e.listenStream=P;function o(c,m){return new Promise((f,t)=>{const n=new T.DisposableStore,r=[],s=b=>{if(r.push(b),r.length>m)return n.dispose(),c.pause(),f({stream:c,buffer:r,ended:!1})},l=b=>t(b),v=()=>f({stream:c,buffer:r,ended:!0});n.add(T.toDisposable(()=>c.removeListener("error",l))),c.on("error",l),n.add(T.toDisposable(()=>c.removeListener("end",v))),c.on("end",v),n.add(T.toDisposable(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=o;function h(c,m){const f=k(m);return f.end(c),f}e.toStream=h;function d(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=d;function u(c){let m=!1;return{read:()=>m?null:(m=!0,c)}}e.toReadable=u;function w(c,m,f){const t=k(f);return P(c,{onData:n=>t.write(m.data(n)),onError:n=>t.error(m.error?m.error(n):n),onEnd:()=>t.end()}),t}e.transform=w;function p(c,m,f){let t=!1;return{read:()=>{const n=m.read();return t?n:(t=!0,n!==null?f([c,n]):c)}}}e.prefixedReadable=p;function S(c,m,f){let t=!1;const n=k(f);return P(m,{onData:r=>t?n.write(r):(t=!0,n.write(f([c,r]))),onError:r=>n.error(r),onEnd:()=>{t||(t=!0,n.write(c)),n.end()}}),n}e.prefixedStream=S}),define(we[8],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function g(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=g;const T=/{(\d+)}/g;function D(O,...Y){return Y.length===0?O:O.replace(T,function(ae,Ce){const ke=parseInt(Ce,10);return isNaN(ke)||ke<0||ke>=Y.length?ae:Y[ke]})}e.format=D;function E(O){return O.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}e.escape=E;function k(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function y(O,Y){let ae=0;const Ce=Y.charCodeAt(0);for(let ke=O.length-1;ke>=0;ke--)O.charCodeAt(ke)===Ce&&ae++;return ae}e.count=y;function _(O,Y,ae="\u2026"){return O.length<=Y?O:`${O.substr(0,Y)}${ae}`}e.truncate=_;function I(O,Y=" "){const ae=i(O,Y);return P(ae,Y)}e.trim=I;function i(O,Y){if(!O||!Y)return O;const ae=Y.length;if(ae===0||O.length===0)return O;let Ce=0;for(;O.indexOf(Y,Ce)===Ce;)Ce=Ce+ae;return O.substring(Ce)}e.ltrim=i;function P(O,Y){if(!O||!Y)return O;const ae=Y.length,Ce=O.length;if(ae===0||Ce===0)return O;let ke=Ce,Ne=-1;for(;Ne=O.lastIndexOf(Y,ke-1),!(Ne===-1||Ne+ae!==ke);){if(Ne===0)return"";ke=Ne}return O.substring(0,ke)}e.rtrim=P;function o(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function h(O){return O.replace(/\*/g,"")}e.stripWildcards=h;function d(O,Y,ae={}){if(!O)throw new Error("Cannot create regex from empty string");Y||(O=k(O)),ae.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let Ce="";return ae.global&&(Ce+="g"),ae.matchCase||(Ce+="i"),ae.multiline&&(Ce+="m"),ae.unicode&&(Ce+="u"),new RegExp(O,Ce)}e.createRegExp=d;function u(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function w(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function p(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=p;function S(O){return O.split(/\r\n|\r|\n/)}e.splitLines=S;function c(O){for(let Y=0,ae=O.length;Y<ae;Y++){const Ce=O.charCodeAt(Y);if(Ce!==32&&Ce!==9)return Y}return-1}e.firstNonWhitespaceIndex=c;function m(O,Y=0,ae=O.length){for(let Ce=Y;Ce<ae;Ce++){const ke=O.charCodeAt(Ce);if(ke!==32&&ke!==9)return O.substring(Y,Ce)}return O.substring(Y,ae)}e.getLeadingWhitespace=m;function f(O,Y=O.length-1){for(let ae=Y;ae>=0;ae--){const Ce=O.charCodeAt(ae);if(Ce!==32&&Ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=f;function t(O,Y){return O<Y?-1:O>Y?1:0}e.compare=t;function n(O,Y,ae=0,Ce=O.length,ke=0,Ne=Y.length){for(;ae<Ce&&ke<Ne;ae++,ke++){let rt=O.charCodeAt(ae),tt=Y.charCodeAt(ke);if(rt<tt)return-1;if(rt>tt)return 1}const Oe=Ce-ae,qe=Ne-ke;return Oe<qe?-1:Oe>qe?1:0}e.compareSubstring=n;function r(O,Y){return s(O,Y,0,O.length,0,Y.length)}e.compareIgnoreCase=r;function s(O,Y,ae=0,Ce=O.length,ke=0,Ne=Y.length){for(;ae<Ce&&ke<Ne;ae++,ke++){let rt=O.charCodeAt(ae),tt=Y.charCodeAt(ke);if(rt===tt)continue;const Je=rt-tt;if(!(Je===32&&v(tt))&&!(Je===-32&&v(rt)))return l(rt)&&l(tt)?Je:n(O.toLowerCase(),Y.toLowerCase(),ae,Ce,ke,Ne)}const Oe=Ce-ae,qe=Ne-ke;return Oe<qe?-1:Oe>qe?1:0}e.compareSubstringIgnoreCase=s;function l(O){return O>=97&&O<=122}e.isLowerAsciiLetter=l;function v(O){return O>=65&&O<=90}e.isUpperAsciiLetter=v;function b(O){return l(O)||v(O)}function A(O,Y){return O.length===Y.length&&C(O,Y)}e.equalsIgnoreCase=A;function C(O,Y,ae=O.length){for(let Ce=0;Ce<ae;Ce++){const ke=O.charCodeAt(Ce),Ne=Y.charCodeAt(Ce);if(ke!==Ne){if(b(ke)&&b(Ne)){const Oe=Math.abs(ke-Ne);if(Oe!==0&&Oe!==32)return!1}else if(String.fromCharCode(ke).toLowerCase()!==String.fromCharCode(Ne).toLowerCase())return!1}}return!0}function a(O,Y){const ae=Y.length;return Y.length>O.length?!1:C(O,Y,ae)}e.startsWithIgnoreCase=a;function F(O,Y){let ae,Ce=Math.min(O.length,Y.length);for(ae=0;ae<Ce;ae++)if(O.charCodeAt(ae)!==Y.charCodeAt(ae))return ae;return Ce}e.commonPrefixLength=F;function N(O,Y){let ae,Ce=Math.min(O.length,Y.length);const ke=O.length-1,Ne=Y.length-1;for(ae=0;ae<Ce;ae++)if(O.charCodeAt(ke-ae)!==Y.charCodeAt(Ne-ae))return ae;return Ce}e.commonSuffixLength=N;function W(O){return 55296<=O&&O<=56319}e.isHighSurrogate=W;function ce(O){return 56320<=O&&O<=57343}e.isLowSurrogate=ce;function me(O,Y){return(O-55296<<10)+(Y-56320)+65536}e.computeCodePoint=me;function G(O,Y,ae){const Ce=O.charCodeAt(ae);if(W(Ce)&&ae+1<Y){const ke=O.charCodeAt(ae+1);if(ce(ke))return me(Ce,ke)}return Ce}e.getNextCodePoint=G;function V(O,Y){const ae=O.charCodeAt(Y-1);if(ce(ae)&&Y>1){const Ce=O.charCodeAt(Y-2);if(W(Ce))return me(Ce,ae)}return ae}function J(O,Y){const ae=Be.getInstance(),Ce=Y,ke=O.length,Ne=G(O,ke,Y);Y+=Ne>=65536?2:1;let Oe=ae.getGraphemeBreakType(Ne);for(;Y<ke;){const qe=G(O,ke,Y),rt=ae.getGraphemeBreakType(qe);if(Le(Oe,rt))break;Y+=qe>=65536?2:1,Oe=rt}return Y-Ce}e.nextCharLength=J;function R(O,Y){const ae=Be.getInstance(),Ce=Y,ke=V(O,Y);Y-=ke>=65536?2:1;let Ne=ae.getGraphemeBreakType(ke);for(;Y>0;){const Oe=V(O,Y),qe=ae.getGraphemeBreakType(Oe);if(Le(qe,Ne))break;Y-=Oe>=65536?2:1,Ne=qe}return Ce-Y}e.prevCharLength=R;function B(O,Y){const ae=Be.getInstance(),Ce=O.length,ke=Y,Ne=G(O,Ce,Y),Oe=ae.getGraphemeBreakType(Ne);Y+=Ne>=65536?2:1;let qe=Oe;for(;Y<Ce;){const tt=G(O,Ce,Y),Je=ae.getGraphemeBreakType(tt);if(Le(qe,Je))break;Y+=tt>=65536?2:1,qe=Je}const rt=Y;for(Y=ke,qe=Oe;Y>0;){const tt=V(O,Y),Je=ae.getGraphemeBreakType(tt);if(Le(Je,qe))break;Y-=tt>=65536?2:1,qe=Je}return[Y,rt]}function M(O,Y){return Y>0&&ce(O.charCodeAt(Y))?B(O,Y-1):B(O,Y)}e.getCharContainingOffset=M;function U(O){const Y=O.length;let ae=0,Ce=0;for(;Ce<Y;){const Oe=G(O,Y,Ce);Ce+=Oe>=65536?2:1,Oe<128?ae+=1:Oe<2048?ae+=2:Oe<65536?ae+=3:ae+=4}const ke=new Uint8Array(ae);Ce=0;let Ne=0;for(;Ce<Y;){const Oe=G(O,Y,Ce);Ce+=Oe>=65536?2:1,Oe<128?ke[Ne++]=Oe:Oe<2048?(ke[Ne++]=192|(Oe&1984)>>>6,ke[Ne++]=128|(Oe&63)>>>0):Oe<65536?(ke[Ne++]=224|(Oe&61440)>>>12,ke[Ne++]=128|(Oe&4032)>>>6,ke[Ne++]=128|(Oe&63)>>>0):(ke[Ne++]=240|(Oe&1835008)>>>18,ke[Ne++]=128|(Oe&258048)>>>12,ke[Ne++]=128|(Oe&4032)>>>6,ke[Ne++]=128|(Oe&63)>>>0)}return ke}e.encodeUTF8=U;function j(O){const Y=O.byteLength,ae=[];let Ce=0;for(;Ce<Y;){const ke=O[Ce];let Ne;if(ke>=240&&Ce+3<Y?Ne=(O[Ce++]&7)<<18>>>0|(O[Ce++]&63)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:ke>=224&&Ce+2<Y?Ne=(O[Ce++]&15)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:ke>=192&&Ce+1<Y?Ne=(O[Ce++]&31)<<6>>>0|(O[Ce++]&63)<<0>>>0:Ne=O[Ce++],Ne>=0&&Ne<=55295||Ne>=57344&&Ne<=65535)ae.push(String.fromCharCode(Ne));else if(Ne>=65536&&Ne<=1114111){const Oe=Ne-65536,qe=55296+((Oe&1047552)>>>10),rt=56320+((Oe&1023)>>>0);ae.push(String.fromCharCode(qe)),ae.push(String.fromCharCode(rt))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=j;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function oe(O){return z.test(O)}e.containsRTL=oe;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(O){return pe.test(O)}e.containsEmoji=Te;const $e=/^[\t\n\r\x20-\x7E]*$/;function Me(O){return $e.test(O)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=ze;function Qe(O){for(let Y=0,ae=O.length;Y<ae;Y++)if(Ke(O.charCodeAt(Y)))return!0;return!1}e.containsFullWidthCharacter=Qe;function Ke(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=Ke;function Ge(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Ge;function $(O,Y){if(O.length<Y)return O;const ae=/\b/g;let Ce=0;for(;ae.test(O)&&!(O.length-ae.lastIndex<Y);)Ce=ae.lastIndex,ae.lastIndex+=1;return O.substring(Ce).replace(/^\s/,"")}e.lcut=$;const Q=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function K(O){return O&&(O=O.replace(Q,""),O=O.replace(ne,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=K,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function fe(O){return se(O)?O.substr(1):O}e.stripUTF8BOM=fe;function Ae(O,Y){if(!O||!Y||O.length<Y.length)return!1;const ae=Y.length,Ce=O.toLowerCase();let ke=0,Ne=-1;for(;ke<ae;){const Oe=Ce.indexOf(Y[ke],Ne+1);if(Oe<0)return!1;Ne=Oe,ke++}return!0}e.fuzzyContains=Ae;function ge(O,Y=!1){return O?(Y&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=ge;function We(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=We;function H(O,Y=1){if(Y===0)return"";let ae=-1;do ae=O.indexOf(`
`,ae+1),Y--;while(Y>0&&ae>=0);return ae===-1?O:(O[ae-1]==="\r"&&ae--,O.substr(0,ae))}e.getNLines=H;function te(O){const Y=90-65+1;return O=O%(2*Y),O<Y?String.fromCharCode(97+O):String.fromCharCode(65+O-Y)}e.singleLetterHash=te;function ve(O){return Be.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=ve;function Le(O,Y){return O===0?Y!==5&&Y!==7:O===2&&Y===3?!1:O===4||O===2||O===3||Y===4||Y===2||Y===3?!0:!(O===8&&(Y===8||Y===9||Y===11||Y===12)||(O===11||O===9)&&(Y===9||Y===10)||(O===12||O===10)&&Y===10||Y===5||Y===13||Y===7||O===1||O===13&&Y===14||O===6&&Y===6)}e.breakBetweenGraphemeBreakType=Le;var xe;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ye()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(Y){if(Y<32)return Y===10?3:Y===13?2:4;if(Y<127)return 0;const ae=this._data,Ce=ae.length/3;let ke=1;for(;ke<=Ce;)if(Y<ae[3*ke])ke=2*ke;else if(Y>ae[3*ke+1])ke=2*ke+1;else return ae[3*ke+2];return 0}}Be._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(O,Y){if(O===0)return 0;const ae=ye(O,Y);if(ae!==void 0)return ae;const Ce=V(Y,O);return O-=De(Ce),O}e.getLeftDeleteOffset=Se;function ye(O,Y){let ae=V(Y,O);for(O-=De(ae);ie(ae)||ae===65039||ae===8419;){if(O===0)return;ae=V(Y,O),O-=De(ae)}if(!!Ge(ae)){if(O>=0){const Ce=V(Y,O);Ce===8205&&(O-=De(Ce))}return O}}function De(O){return O>=65536?2:1}function ie(O){return 127995<=O&&O<=127999}var ue;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(we[23],_e([0,1,8,107]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let y,_;class I{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return D?new I(Buffer.allocUnsafe(b)):new I(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new I(b)}static fromString(b,A){return!((A==null?void 0:A.dontUseNodeBuffer)||!1)&&D?new I(Buffer.from(b)):E?(y||(y=new TextEncoder),new I(y.encode(b))):new I(g.encodeUTF8(b))}static concat(b,A){if(typeof A=="undefined"){A=0;for(let F=0,N=b.length;F<N;F++)A+=b[F].byteLength}const C=I.alloc(A);let a=0;for(let F=0,N=b.length;F<N;F++){const W=b[F];C.set(W,a),a+=W.byteLength}return C}toString(){return D?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(b,A){return new I(this.buffer.subarray(b,A))}set(b,A){b instanceof I?this.buffer.set(b.buffer,A):this.buffer.set(b,A)}readUInt32BE(b){return o(this.buffer,b)}writeUInt32BE(b,A){h(this.buffer,b,A)}readUInt32LE(b){return d(this.buffer,b)}writeUInt32LE(b,A){u(this.buffer,b,A)}readUInt8(b){return w(this.buffer,b)}writeUInt8(b,A){p(this.buffer,b,A)}}e.VSBuffer=I;function i(v,b){return v[b+0]<<0>>>0|v[b+1]<<8>>>0}e.readUInt16LE=i;function P(v,b,A){v[A+0]=b&255,b=b>>>8,v[A+1]=b&255}e.writeUInt16LE=P;function o(v,b){return v[b]*2**24+v[b+1]*2**16+v[b+2]*2**8+v[b+3]}e.readUInt32BE=o;function h(v,b,A){v[A+3]=b,b=b>>>8,v[A+2]=b,b=b>>>8,v[A+1]=b,b=b>>>8,v[A]=b}e.writeUInt32BE=h;function d(v,b){return v[b+0]<<0>>>0|v[b+1]<<8>>>0|v[b+2]<<16>>>0|v[b+3]<<24>>>0}e.readUInt32LE=d;function u(v,b,A){v[A+0]=b&255,b=b>>>8,v[A+1]=b&255,b=b>>>8,v[A+2]=b&255,b=b>>>8,v[A+3]=b&255}e.writeUInt32LE=u;function w(v,b){return v[b]}e.readUInt8=w;function p(v,b,A){v[A]=b}e.writeUInt8=p;function S(v){return T.consumeReadable(v,b=>I.concat(b))}e.readableToBuffer=S;function c(v){return T.toReadable(v)}e.bufferToReadable=c;function m(v){return T.consumeStream(v,b=>I.concat(b))}e.streamToBuffer=m;async function f(v){return v.ended?I.concat(v.buffer):I.concat([...v.buffer,await m(v.stream)])}e.bufferedStreamToBuffer=f;function t(v){return T.toStream(v,b=>I.concat(b))}e.bufferToStream=t;function n(v){return T.transform(v,{data:b=>typeof b=="string"?I.fromString(b):I.wrap(b)},b=>I.concat(b))}e.streamToBufferReadableStream=n;function r(v){return T.newWriteableStream(b=>I.concat(b),v)}e.newWriteableBufferStream=r;function s(v,b){return T.prefixedReadable(v,b,A=>I.concat(A))}e.prefixedBufferReadable=s;function l(v,b){return T.prefixedStream(v,b,A=>I.concat(A))}e.prefixedBufferStream=l}),define(we[53],_e([0,1,8]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(p){return D(p,0)}e.hash=T;function D(p,S){switch(typeof p){case"object":return p===null?E(349,S):Array.isArray(p)?_(p,S):I(p,S);case"string":return y(p,S);case"boolean":return k(p,S);case"number":return E(p,S);case"undefined":return E(937,S);default:return E(617,S)}}e.doHash=D;function E(p,S){return(S<<5)-S+p|0}function k(p,S){return E(p?433:863,S)}function y(p,S){S=E(149417,S);for(let c=0,m=p.length;c<m;c++)S=E(p.charCodeAt(c),S);return S}e.stringHash=y;function _(p,S){return S=E(104579,S),p.reduce((c,m)=>D(m,c),S)}function I(p,S){return S=E(181387,S),Object.keys(p).sort().reduce((c,m)=>(c=y(m,c),D(p[m],c)),S)}class i{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=D(S,this._value),this._value}}e.Hasher=i;var P;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function o(p,S,c=32){const m=c-S,f=~((1<<m)-1);return(p<<S|(f&p)>>>m)>>>0}function h(p,S=0,c=p.byteLength,m=0){for(let f=0;f<c;f++)p[S+f]=m}function d(p,S,c="0"){for(;p.length<S;)p=c+p;return p}function u(p,S=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),S/4)}e.toHexString=u;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const c=S.length;if(c===0)return;const m=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,r;for(t!==0?(n=t,r=-1,t=0):(n=S.charCodeAt(0),r=0);;){let s=n;if(g.isHighSurrogate(n))if(r+1<c){const l=S.charCodeAt(r+1);g.isLowSurrogate(l)?(r++,s=g.computeCodePoint(n,l)):s=65533}else{t=n;break}else g.isLowSurrogate(n)&&(s=65533);if(f=this._push(m,f,s),r++,r<c)n=S.charCodeAt(r);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(S,c,m){return m<128?S[c++]=m:m<2048?(S[c++]=192|(m&1984)>>>6,S[c++]=128|(m&63)>>>0):m<65536?(S[c++]=224|(m&61440)>>>12,S[c++]=128|(m&4032)>>>6,S[c++]=128|(m&63)>>>0):(S[c++]=240|(m&1835008)>>>18,S[c++]=128|(m&258048)>>>12,S[c++]=128|(m&4032)>>>6,S[c++]=128|(m&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),u(this._h0)+u(this._h1)+u(this._h2)+u(this._h3)+u(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=w._bigBlock32,c=this._buffDV;for(let b=0;b<64;b+=4)S.setUint32(b,c.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)S.setUint32(b,o(S.getUint32(b-12,!1)^S.getUint32(b-32,!1)^S.getUint32(b-56,!1)^S.getUint32(b-64,!1),1),!1);let m=this._h0,f=this._h1,t=this._h2,n=this._h3,r=this._h4,s,l,v;for(let b=0;b<80;b++)b<20?(s=f&t|~f&n,l=1518500249):b<40?(s=f^t^n,l=1859775393):b<60?(s=f&t|f&n|t&n,l=2400959708):(s=f^t^n,l=3395469782),v=o(m,5)+s+r+l+S.getUint32(b*4,!1)&4294967295,r=n,n=t,t=o(f,30),f=m,m=v;this._h0=this._h0+m&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[41],_e([0,1,8]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const E="error",k="warning",y="warn",_="info",I="ignore";function i(o){return o?g.equalsIgnoreCase(E,o)?D.Error:g.equalsIgnoreCase(k,o)||g.equalsIgnoreCase(y,o)?D.Warning:g.equalsIgnoreCase(_,o)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function P(o){switch(o){case D.Error:return E;case D.Warning:return k;case D.Info:return _;default:return I}}D.toString=P}(T||(T={})),e.default=T}),define(we[10],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(b){return Array.isArray(b)}e.isArray=g;function T(b){return typeof b=="string"}e.isString=T;function D(b){return Array.isArray(b)&&b.every(A=>T(A))}e.isStringArray=D;function E(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=E;function k(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=k;function y(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=y;function _(b){return b===!0||b===!1}e.isBoolean=_;function I(b){return typeof b=="undefined"}e.isUndefined=I;function i(b){return!P(b)}e.isDefined=i;function P(b){return I(b)||b===null}e.isUndefinedOrNull=P;function o(b,A){if(!b)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=o;function h(b){if(P(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=h;function d(...b){const A=[];for(let C=0;C<b.length;C++){const a=b[C];if(P(a))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);A.push(a)}return A}e.assertAllDefined=d;const u=Object.prototype.hasOwnProperty;function w(b){if(!E(b))return!1;for(let A in b)if(u.call(b,A))return!1;return!0}e.isEmptyObject=w;function p(b){return typeof b=="function"}e.isFunction=p;function S(...b){return b.length>0&&b.every(p)}e.areFunctions=S;function c(b,A){const C=Math.min(b.length,A.length);for(let a=0;a<C;a++)m(b[a],A[a])}e.validateConstraints=c;function m(b,A){if(T(A)){if(typeof b!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(b instanceof A)return}catch(C){}if(!P(b)&&b.constructor===A||A.length===1&&A.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function f(b){let A=[],C=Object.getPrototypeOf(b);for(;Object.prototype!==C;)A=A.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return A}e.getAllPropertyNames=f;function t(b){const A=[];for(const C of f(b))typeof b[C]=="function"&&A.push(C);return A}e.getAllMethodNames=t;function n(b,A){const C=F=>function(){const N=Array.prototype.slice.call(arguments,0);return A(F,N)};let a={};for(const F of b)a[F]=C(F);return a}e.createProxyObject=n;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function s(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=s;function l(b){return class{constructor(){return new Proxy({},{get(A,C){if(A[C])return A[C];throw new Error(`Not Implemented: ${b}->${String(C)}`)}})}}}e.NotImplementedProxy=l;function v(b){throw new Error("Unreachable")}e.assertNever=v}),define(we[42],_e([0,1,21,8,13,10]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function y(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=y;function _(r){return r.indexOf("/")===-1&&(r=y(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=_;function I(r,s=D.posix.sep){if(!r)return"";const l=r.length,v=r.charCodeAt(0);if(k(v)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let A=3;const C=A;for(;A<l&&!k(r.charCodeAt(A));A++);if(C!==A&&!k(r.charCodeAt(A+1))){for(A+=1;A<l;A++)if(k(r.charCodeAt(A)))return r.slice(0,A+1).replace(/[\\/]/g,s)}}return s}else if(p(v)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let b=r.indexOf("://");if(b!==-1){for(b+=3;b<l;b++)if(k(r.charCodeAt(b)))return r.slice(0,b+1)}return""}e.getRoot=I;function i(r){if(!g.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let l=2;const v=l;for(;l<r.length&&(s=r.charCodeAt(l),s!==92);l++);return!(v===l||(s=r.charCodeAt(l+1),isNaN(s)||s===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,s=g.isWindows){const l=s?P:o;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||s&&h.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function u(r,s,l){const v=r===s;return!l||v?v:!r||!s?!1:T.equalsIgnoreCase(r,s)}e.isEqual=u;function w(r,s,l,v=D.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(l){if(!T.startsWithIgnoreCase(r,s))return!1;if(s.length===r.length)return!0;let A=s.length;return s.charAt(s.length-1)===v&&A--,r.charAt(A)===v}return s.charAt(s.length-1)!==v&&(s+=v),r.indexOf(s)===0}e.isEqualOrParent=w;function p(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=p;function S(r,s){return g.isWindows&&r.endsWith(":")&&(r+=D.sep),D.isAbsolute(r)||(r=D.join(s,r)),r=D.normalize(r),g.isWindows?(r=T.rtrim(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=T.rtrim(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=S;function c(r){const s=D.normalize(r);return g.isWindows?r.length>3?!1:m(s)&&(r.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=c;function m(r){return g.isWindows?p(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function f(r){return m(r)?r[0]:void 0}e.getDriveLetter=f;function t(r,s,l){return s.length>r.length?-1:r===s?0:(l&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=t;function n(r){const s=r.split(":");let l,v,b;if(s.forEach(A=>{const C=Number(A);E.isNumber(C)?v===void 0?v=C:b===void 0&&(b=C):l=l?[l,A].join(":"):A}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:v!==void 0?v:void 0,column:b!==void 0?b:v!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(we[24],_e([0,1,10]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(p=>{u[p]&&typeof u[p]=="object"?w[p]=T(u[p]):w[p]=u[p]}),w}e.deepClone=T;function D(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const S in p)if(E.call(p,S)){const c=p[S];typeof c=="object"&&!Object.isFrozen(c)&&w.push(c)}}return u}e.deepFreeze=D;const E=Object.prototype.hasOwnProperty;function k(u,w){return y(u,w,new Set)}e.cloneAndChange=k;function y(u,w,p){if(g.isUndefinedOrNull(u))return u;const S=w(u);if(typeof S!="undefined")return S;if(g.isArray(u)){const c=[];for(const m of u)c.push(y(m,w,p));return c}if(g.isObject(u)){if(p.has(u))throw new Error("Cannot clone recursive data-structure");p.add(u);const c={};for(let m in u)E.call(u,m)&&(c[m]=y(u[m],w,p));return p.delete(u),c}return u}function _(u,w,p=!0){return g.isObject(u)?(g.isObject(w)&&Object.keys(w).forEach(S=>{S in u?p&&(g.isObject(u[S])&&g.isObject(w[S])?_(u[S],w[S],p):u[S]=w[S]):u[S]=w[S]}),u):w}e.mixin=_;function I(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let p,S;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(p=0;p<u.length;p++)if(!I(u[p],w[p]))return!1}else{const c=[];for(S in u)c.push(S);c.sort();const m=[];for(S in w)m.push(S);if(m.sort(),!I(c,m))return!1;for(p=0;p<c.length;p++)if(!I(u[c[p]],w[c[p]]))return!1}return!0}e.equals=I;function i(u){const w=new Set;return JSON.stringify(u,(p,S)=>{if(g.isObject(S)||Array.isArray(S)){if(w.has(S))return"[Circular]";w.add(S)}return S})}e.safeStringify=i;function P(u,w,p){const S=w(u);return typeof S=="undefined"?p:S}e.getOrDefault=P;function o(u,w){const p=Object.create(null);return!u||!w||Object.keys(w).forEach(c=>{const m=u[c],f=w[c];I(m,f)||(p[c]=f)}),p}e.distinct=o;function h(u,w){const p=w.toLowerCase(),S=Object.keys(u).find(c=>c.toLowerCase()===p);return S?u[S]:u[w]}e.getCaseInsensitive=h;function d(u,w){const p=Object.create(null);for(const S of Object.keys(u))w(S,u[S])&&(p[S]=u[S]);return p}e.filter=d}),define(we[79],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function T(E){return E<0?0:E>255?255:E|0}e.toUint8=T;function D(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=D}),define(we[2],_e([0,1,21,13]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,E=/^\//,k=/^\/\//;function y(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!E.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(r,s){return!r&&!s?"file":r}function I(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==P&&(s=P+s):s=P;break}return s}const i="",P="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(s,l,v,b,A,C=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=_(s,C),this.authority=l||i,this.path=I(this.scheme,v||i),this.query=b||i,this.fragment=A||i,y(this,C))}static isUri(s){return s instanceof h?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return c(this,!1)}with(s){if(!s)return this;let{scheme:l,authority:v,path:b,query:A,fragment:C}=s;return l===void 0?l=this.scheme:l===null&&(l=i),v===void 0?v=this.authority:v===null&&(v=i),b===void 0?b=this.path:b===null&&(b=i),A===void 0?A=this.query:A===null&&(A=i),C===void 0?C=this.fragment:C===null&&(C=i),l===this.scheme&&v===this.authority&&b===this.path&&A===this.query&&C===this.fragment?this:new u(l,v,b,A,C)}static parse(s,l=!1){const v=o.exec(s);return v?new u(v[2]||i,n(v[4]||i),n(v[5]||i),n(v[7]||i),n(v[9]||i),l):new u(i,i,i,i,i)}static file(s){let l=i;if(g.isWindows&&(s=s.replace(/\\/g,P)),s[0]===P&&s[1]===P){const v=s.indexOf(P,2);v===-1?(l=s.substring(2),s=P):(l=s.substring(2,v),s=s.substring(v)||P)}return new u("file",l,s,i,i)}static from(s){const l=new u(s.scheme,s.authority,s.path,s.query,s.fragment);return y(l,!0),l}static joinPath(s,...l){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return g.isWindows&&s.scheme==="file"?v=h.file(T.win32.join(c(s,!0),...l)).path:v=T.posix.join(s.path,...l),s.with({path:v})}toString(s=!1){return m(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof h)return s;{const l=new u(s);return l._formatted=s.external,l._fsPath=s._sep===d?s.fsPath:null,l}}else return s}}e.URI=h;const d=g.isWindows?1:void 0;class u extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(s=!1){return s?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=d),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(r,s){let l,v=-1;for(let b=0;b<r.length;b++){const A=r.charCodeAt(b);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||s&&A===47)v!==-1&&(l+=encodeURIComponent(r.substring(v,b)),v=-1),l!==void 0&&(l+=r.charAt(b));else{l===void 0&&(l=r.substr(0,b));const C=w[A];C!==void 0?(v!==-1&&(l+=encodeURIComponent(r.substring(v,b)),v=-1),l+=C):v===-1&&(v=b)}}return v!==-1&&(l+=encodeURIComponent(r.substring(v))),l!==void 0?l:r}function S(r){let s;for(let l=0;l<r.length;l++){const v=r.charCodeAt(l);v===35||v===63?(s===void 0&&(s=r.substr(0,l)),s+=w[v]):s!==void 0&&(s+=r[l])}return s!==void 0?s:r}function c(r,s){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,g.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=c;function m(r,s){const l=s?S:p;let v="",{scheme:b,authority:A,path:C,query:a,fragment:F}=r;if(b&&(v+=b,v+=":"),(A||b==="file")&&(v+=P,v+=P),A){let N=A.indexOf("@");if(N!==-1){const W=A.substr(0,N);A=A.substr(N+1),N=W.indexOf(":"),N===-1?v+=l(W,!1):(v+=l(W.substr(0,N),!1),v+=":",v+=l(W.substr(N+1),!1)),v+="@"}A=A.toLowerCase(),N=A.indexOf(":"),N===-1?v+=l(A,!1):(v+=l(A.substr(0,N),!1),v+=A.substr(N))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const N=C.charCodeAt(1);N>=65&&N<=90&&(C=`/${String.fromCharCode(N+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const N=C.charCodeAt(0);N>=65&&N<=90&&(C=`${String.fromCharCode(N+32)}:${C.substr(2)}`)}v+=l(C,!0)}return a&&(v+="?",v+=l(a,!1)),F&&(v+="#",v+=s?F:p(F,!1)),v}function f(r){try{return decodeURIComponent(r)}catch(s){return r.length>3?r.substr(0,3)+f(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,s=>f(s)):r}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[22],_e([0,1,2,8]),function(Z,e,g,T){"use strict";var D,E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function y(t,n,r){let s=t.get(n);return s===void 0&&(s=r,t.set(n,s)),s}e.getOrSet=y;function _(t){const n=[];return t.forEach((r,s)=>{n.push(`${s} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=_;function I(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=I;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=i;class P{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?T.compareSubstring(n,this._value,0,n.length,this._from,this._to):T.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class o{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?T.compareSubstring(n,this._value,0,n.length,this._from,this._to):T.compareSubstringIgnoreCase(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class d{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(n,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return T.compare(n,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class u{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(n){this._iter=n}static forUris(n=()=>!1){return new w(new d(n))}static forPaths(){return new w(new o)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new P)}clear(){this._root=void 0}set(n,r){const s=this._iter.reset(n);let l;for(this._root||(this._root=new u,this._root.segment=s.value()),l=this._root;;){const b=s.cmp(l.segment);if(b>0)l.left||(l.left=new u,l.left.segment=s.value()),l=l.left;else if(b<0)l.right||(l.right=new u,l.right.segment=s.value()),l=l.right;else if(s.hasNext())s.next(),l.mid||(l.mid=new u,l.mid.segment=s.value()),l=l.mid;else break}const v=l.value;return l.value=r,l.key=n,v}get(n){var r;return(r=this._getNode(n))===null||r===void 0?void 0:r.value}_getNode(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(n){const r=this._getNode(n);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const s=this._iter.reset(n),l=[];let v=this._root;for(;v;){const b=s.cmp(v.segment);if(b>0)l.push([1,v]),v=v.left;else if(b<0)l.push([-1,v]),v=v.right;else if(s.hasNext())s.next(),l.push([0,v]),v=v.mid;else{for(r?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;l.length>0&&v.isEmpty();){let[A,C]=l.pop();switch(A){case 1:C.left=void 0;break;case 0:C.mid=void 0;break;case-1:C.right=void 0;break}v=C}break}}}findSubstr(n){const r=this._iter.reset(n);let s=this._root,l;for(;s;){const v=r.cmp(s.segment);if(v>0)s=s.left;else if(v<0)s=s.right;else if(r.hasNext())r.next(),l=s.value||l,s=s.mid;else break}return s&&s.value||l}findSuperstr(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[r,s]of this)n(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n,r=0){if(r>5e3){console.log("potential CYCLE detected",new Error().stack);return}n&&(yield*this._entries(n.left,r++),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid,r++),yield*this._entries(n.right,r++))}}e.TernarySearchTree=w;class p{constructor(n,r){this[D]="ResourceMap",n instanceof p?(this.map=new Map(n.map),this.toKey=r??p.defaultToKey):(this.map=new Map,this.toKey=n??p.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[s,l]of this.map)n(l,g.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield g.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[g.URI.parse(n[0]),n[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[g.URI.parse(n[0]),n[1]]}}e.ResourceMap=p,p.defaultToKey=t=>t.toString();var S;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class c{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,r=0){const s=this._map.get(n);if(!!s)return r!==0&&this.touch(s,r),s.value}set(n,r,s=0){let l=this._map.get(n);if(l)l.value=r,s!==0&&this.touch(l,s);else{switch(l={key:n,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(n,l),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const s=this._state;let l=this._head;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this._state;let s=this._head;const l={[Symbol.iterator](){return l},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return l}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>n;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,s=n.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const s=n.next,l=n.previous;n===this._tail?(l.next=void 0,this._tail=l):(s.previous=l,l.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const s=n.next,l=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=l,l.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,s)=>{n.push([s,r])}),n}fromJSON(n){this.clear();for(const[r,s]of n)this.set(r,s)}}e.LinkedMap=c;class m extends c{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class f{constructor(n){k.set(this,void 0),nt(this,k,n,"f")}get size(){return Ue(this,k,"f").size}forEach(n,r){Ue(this,k,"f").forEach(n,r)}get(n){return Ue(this,k,"f").get(n)}has(n){return Ue(this,k,"f").has(n)}entries(){return Ue(this,k,"f").entries()}keys(){return Ue(this,k,"f").keys()}values(){return Ue(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ue(this,k,"f").entries()}}e.ReadonlyMapView=f}),define(we[108],_e([0,1,22,8]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...K){return function(se,fe){for(let Ae=0,ge=K.length;Ae<ge;Ae++){const We=K[Ae](se,fe);if(We)return We}return null}}e.or=D,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(K,se,fe){if(!fe||fe.length<se.length)return null;let Ae;return K?Ae=T.startsWithIgnoreCase(fe,se):Ae=fe.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function k(K,se){const fe=se.toLowerCase().indexOf(K.toLowerCase());return fe===-1?null:[{start:fe,end:fe+K.length}]}e.matchesContiguousSubString=k;function y(K,se){return _(K.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=y;function _(K,se,fe,Ae){if(fe===K.length)return[];if(Ae===se.length)return null;if(K[fe]===se[Ae]){let ge=null;return(ge=_(K,se,fe+1,Ae+1))?p({start:Ae,end:Ae+1},ge):null}return _(K,se,fe,Ae+1)}function I(K){return 97<=K&&K<=122}function i(K){return 65<=K&&K<=90}e.isUpper=i;function P(K){return 48<=K&&K<=57}function o(K){return K===32||K===9||K===10||K===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>h.add(K.charCodeAt(0)));function d(K){return o(K)||h.has(K)}function u(K,se){return K===se||d(K)&&d(se)}function w(K){return I(K)||i(K)||P(K)}function p(K,se){return se.length===0?se=[K]:K.end===se[0].start?se[0].start=K.start:se.unshift(K),se}function S(K,se){for(let fe=se;fe<K.length;fe++){const Ae=K.charCodeAt(fe);if(i(Ae)||P(Ae)||fe>0&&!w(K.charCodeAt(fe-1)))return fe}return K.length}function c(K,se,fe,Ae){if(fe===K.length)return[];if(Ae===se.length)return null;if(K[fe]!==se[Ae].toLowerCase())return null;{let ge=null,We=Ae+1;for(ge=c(K,se,fe+1,Ae+1);!ge&&(We=S(se,We))<se.length;)ge=c(K,se,fe+1,We),We++;return ge===null?null:p({start:Ae,end:Ae+1},ge)}}function m(K){let se=0,fe=0,Ae=0,ge=0,We=0;for(let xe=0;xe<K.length;xe++)We=K.charCodeAt(xe),i(We)&&se++,I(We)&&fe++,w(We)&&Ae++,P(We)&&ge++;const H=se/K.length,te=fe/K.length,ve=Ae/K.length,Le=ge/K.length;return{upperPercent:H,lowerPercent:te,alphaPercent:ve,numericPercent:Le}}function f(K){const{upperPercent:se,lowerPercent:fe}=K;return fe===0&&se>.6}function t(K){const{upperPercent:se,lowerPercent:fe,alphaPercent:Ae,numericPercent:ge}=K;return fe>.2&&se<.8&&Ae>.6&&ge<.2}function n(K){let se=0,fe=0,Ae=0,ge=0;for(let We=0;We<K.length;We++)Ae=K.charCodeAt(We),i(Ae)&&se++,I(Ae)&&fe++,o(Ae)&&ge++;return(se===0||fe===0)&&ge===0?K.length<=30:se<=5}function r(K,se){if(!se||(se=se.trim(),se.length===0)||!n(K)||se.length>60)return null;const fe=m(se);if(!t(fe)){if(!f(fe))return null;se=se.toLowerCase()}let Ae=null,ge=0;for(K=K.toLowerCase();ge<se.length&&(Ae=c(K,se,0,ge))===null;)ge=S(se,ge+1);return Ae}e.matchesCamelCase=r;function s(K,se,fe=!1){if(!se||se.length===0)return null;let Ae=null,ge=0;for(K=K.toLowerCase(),se=se.toLowerCase();ge<se.length&&(Ae=l(K,se,0,ge,fe))===null;)ge=v(se,ge+1);return Ae}e.matchesWords=s;function l(K,se,fe,Ae,ge){if(fe===K.length)return[];if(Ae===se.length)return null;if(u(K.charCodeAt(fe),se.charCodeAt(Ae))){let We=null,H=Ae+1;if(We=l(K,se,fe+1,Ae+1,ge),!ge)for(;!We&&(H=v(se,H))<se.length;)We=l(K,se,fe+1,H,ge),H++;return We===null?null:p({start:Ae,end:Ae+1},We)}else return null}function v(K,se){for(let fe=se;fe<K.length;fe++)if(d(K.charCodeAt(fe))||fe>0&&d(K.charCodeAt(fe-1)))return fe;return K.length}const b=D(e.matchesPrefix,r,k),A=D(e.matchesPrefix,r,y),C=new g.LRUCache(1e4);function a(K,se,fe=!1){if(typeof K!="string"||typeof se!="string")return null;let Ae=C.get(K);Ae||(Ae=new RegExp(T.convertSimple2RegExpPattern(K),"i"),C.set(K,Ae));const ge=Ae.exec(se);return ge?[{start:ge.index,end:ge.index+ge[0].length}]:fe?A(K,se):b(K,se)}e.matchesFuzzy=a;function F(K,se){const fe=Qe(K,K.toLowerCase(),0,se,se.toLowerCase(),0,!0);return fe?W(fe):null}e.matchesFuzzy2=F;function N(K,se,fe,Ae,ge,We){const H=Math.min(13,K.length);for(;fe<H;fe++){const te=Qe(K,se,fe,Ae,ge,We,!1);if(te)return te}return[0,We]}e.anyScore=N;function W(K){if(typeof K=="undefined")return[];const se=[],fe=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const ge=K[Ae]+fe,We=se[se.length-1];We&&We.end===ge?We.end=ge+1:se.push({start:ge,end:ge+1})}return se}e.createMatches=W;const ce=128;function me(){const K=[],se=[];for(let fe=0;fe<=ce;fe++)se[fe]=0;for(let fe=0;fe<=ce;fe++)K.push(se.slice(0));return K}function G(K){const se=[];for(let fe=0;fe<=K;fe++)se[fe]=0;return se}const V=G(2*ce),J=G(2*ce),R=me(),B=me(),M=me(),U=!1;function j(K,se,fe,Ae,ge){function We(te,ve,Le=" "){for(;te.length<ve;)te=Le+te;return te}let H=` |   |${Ae.split("").map(te=>We(te,3)).join("|")}
`;for(let te=0;te<=fe;te++)te===0?H+=" |":H+=`${se[te-1]}|`,H+=K[te].slice(0,ge+1).map(ve=>We(ve.toString(),3)).join("|")+`
`;return H}function z(K,se,fe,Ae){K=K.substr(se),fe=fe.substr(Ae),console.log(j(B,K,K.length,fe,fe.length)),console.log(j(M,K,K.length,fe,fe.length)),console.log(j(R,K,K.length,fe,fe.length))}function oe(K,se){if(se<0||se>=K.length)return!1;const fe=K.codePointAt(se);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(fe)}}function pe(K,se){if(se<0||se>=K.length)return!1;switch(K.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Te(K,se,fe){return se[K]!==fe[K]}function $e(K,se,fe,Ae,ge,We,H=!1){for(;se<fe&&ge<We;)K[se]===Ae[ge]&&(H&&(V[se]=ge),se+=1),ge+=1;return se===fe}e.isPatternInWord=$e;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var ze;(function(K){K.Default=[-100,0];function se(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}K.isDefault=se})(ze=e.FuzzyScore||(e.FuzzyScore={}));function Qe(K,se,fe,Ae,ge,We,H){const te=K.length>ce?ce:K.length,ve=Ae.length>ce?ce:Ae.length;if(fe>=te||We>=ve||te-fe>ve-We||!$e(se,fe,te,ge,We,ve,!0))return;Ke(te,ve,fe,We,se,ge);let Le=1,xe=1,Be=fe,Ye=We;const Se=[!1];for(Le=1,Be=fe;Be<te;Le++,Be++){const O=V[Be],Y=J[Be],ae=Be+1<te?J[Be+1]:ve;for(xe=O-We+1,Ye=O;Ye<ae;xe++,Ye++){let Ce=Number.MIN_SAFE_INTEGER,ke=!1;Ye<=Y&&(Ce=Ge(K,se,Be,fe,Ae,ge,Ye,ve,We,R[Le-1][xe-1]===0,Se));let Ne=0;Ce!==Number.MAX_SAFE_INTEGER&&(ke=!0,Ne=Ce+B[Le-1][xe-1]);const Oe=Ye>O,qe=Oe?B[Le][xe-1]+(R[Le][xe-1]>0?-5:0):0,rt=Ye>O+1&&R[Le][xe-1]>0,tt=rt?B[Le][xe-2]+(R[Le][xe-2]>0?-5:0):0;if(rt&&(!Oe||tt>=qe)&&(!ke||tt>=Ne))B[Le][xe]=tt,M[Le][xe]=3,R[Le][xe]=0;else if(Oe&&(!ke||qe>=Ne))B[Le][xe]=qe,M[Le][xe]=2,R[Le][xe]=0;else if(ke)B[Le][xe]=Ne,M[Le][xe]=1,R[Le][xe]=R[Le-1][xe-1]+1;else throw new Error("not possible")}}if(U&&z(K,fe,Ae,We),!Se[0]&&!H)return;Le--,xe--;const ye=[B[Le][xe],We];let De=0,ie=0;for(;Le>=1;){let O=xe;do{const Y=M[Le][O];if(Y===3)O=O-2;else if(Y===2)O=O-1;else break}while(O>=1);De>1&&se[fe+Le-1]===ge[We+xe-1]&&!Te(O+We-1,Ae,ge)&&De+1>R[Le][O]&&(O=xe),O===xe?De++:De=1,ie||(ie=O),Le--,xe=O-1,ye.push(xe)}ve===te&&(ye[0]+=2);const ue=ie-te;return ye[0]-=ue,ye}e.fuzzyScore=Qe;function Ke(K,se,fe,Ae,ge,We){let H=K-1,te=se-1;for(;H>=fe&&te>=Ae;)ge[H]===We[te]&&(J[H]=te,H--),te--}function Ge(K,se,fe,Ae,ge,We,H,te,ve,Le,xe){if(se[fe]!==We[H])return Number.MIN_SAFE_INTEGER;let Be=1,Ye=!1;return H===fe-Ae?Be=K[fe]===ge[H]?7:5:Te(H,ge,We)&&(H===0||!Te(H-1,ge,We))?(Be=K[fe]===ge[H]?7:5,Ye=!0):oe(We,H)&&(H===0||!oe(We,H-1))?Be=5:(oe(We,H-1)||pe(We,H-1))&&(Be=5,Ye=!0),Be>1&&fe===Ae&&(xe[0]=!0),Ye||(Ye=Te(H,ge,We)||oe(We,H-1)||pe(We,H-1)),fe===Ae?H>ve&&(Be-=Ye?3:5):Le?Be+=Ye?2:0:Be+=Ye?0:1,H+1===te&&(Be-=Ye?3:5),Be}function $(K,se,fe,Ae,ge,We,H){return ne(K,se,fe,Ae,ge,We,!0,H)}e.fuzzyScoreGracefulAggressive=$;function Q(K,se,fe,Ae,ge,We,H){return ne(K,se,fe,Ae,ge,We,!1,H)}e.fuzzyScoreGraceful=Q;function ne(K,se,fe,Ae,ge,We,H,te){let ve=Qe(K,se,fe,Ae,ge,We,te);if(ve&&!H)return ve;if(K.length>=3){const Le=Math.min(7,K.length-1);for(let xe=fe+1;xe<Le;xe++){const Be=re(K,xe);if(Be){const Ye=Qe(Be,Be.toLowerCase(),fe,Ae,ge,We,te);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function re(K,se){if(se+1>=K.length)return;const fe=K[se],Ae=K[se+1];if(fe!==Ae)return K.slice(0,se)+Ae+fe+K.slice(se+2)}}),define(we[109],_e([0,1,78,108,8]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function y(u){return u.replace(k,(w,p)=>p?w:`\\${w}`)}e.escapeIcons=y;const _=new RegExp(`\\\\${E.source}`,"g");function I(u){return u.replace(_,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=I;const i=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function P(u){return u.indexOf(e.iconStartMarker)===-1?u:u.replace(i,(w,p,S,c)=>S?w:p||c||"")}e.stripIcons=P;function o(u){const w=u.indexOf(e.iconStartMarker);return w===-1?{text:u}:h(u,w)}e.parseLabelWithIcons=o;function h(u,w){const p=[];let S="";function c(v){if(v){S+=v;for(const b of v)p.push(t)}}let m=-1,f="",t=0,n,r,s=w;const l=u.length;for(c(u.substr(0,w));s<l;)n=u[s],r=u[s+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(m=s,c(f),f=e.iconStartMarker,s++):n===")"&&m!==-1?(t+=s-m+1,m=-1,f=""):m!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(c(f),m=-1,f=""):c(n),s++;return c(f),{text:S,iconOffsets:p}}function d(u,w,p=!1){const{text:S,iconOffsets:c}=w;if(!c||c.length===0)return T.matchesFuzzy(u,S,p);const m=D.ltrim(S," "),f=S.length-m.length,t=T.matchesFuzzy(u,m,p);if(t)for(const n of t){const r=c[n.start+f]+f;n.start+=r,n.end+=r}return t}e.matchesFuzzyIconAware=d}),define(we[80],_e([0,1,109,12]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(h="",d=!1){var u,w;if(this.value=h,typeof this.value!="string")throw T.illegalArgument("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1):(this.isTrusted=(u=d.isTrusted)!==null&&u!==void 0?u:void 0,this.supportThemeIcons=(w=d.supportThemeIcons)!==null&&w!==void 0?w:!1)}appendText(h,d=0){return this.value+=I(this.supportThemeIcons?g.escapeIcons(h):h).replace(/([ \t]+)/g,(u,w)=>"&nbsp;".repeat(w.length)).replace(/^>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,d){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}}e.MarkdownString=E;function k(o){return y(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function y(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function _(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function I(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function i(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function P(o){const h=[],d=o.split("|").map(w=>w.trim());o=d[0];const u=d[1];if(u){const w=/height=(\d+)/.exec(u),p=/width=(\d+)/.exec(u),S=w?w[1]:"",c=p?p[1]:"",m=isFinite(parseInt(c)),f=isFinite(parseInt(S));m&&h.push(`width="${c}"`),f&&h.push(`height="${S}"`)}return{href:o,dimensions:h}}e.parseHrefAndDimensions=P}),define(we[54],_e([0,1,23,8,2]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function E(I){return JSON.stringify(I,y)}e.stringify=E;function k(I){let i=JSON.parse(I);return i=_(i),i}e.parse=k;function y(I,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:T.regExpFlags(i)}:i}function _(I,i=0){if(!I||i>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof g.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=_(I[P],i+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=_(I[P],i+1))}return I}e.revive=_}),define(we[15],_e([0,1,2,21]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.userData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,i){this._hosts[_]=I,this._ports[_]=i}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let i=this._hosts[I];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[I],o=this._connectionTokens[I];let h=`path=${encodeURIComponent(_.path)}`;return typeof o=="string"&&(h+=`&tkn=${encodeURIComponent(o)}`),g.URI.from({scheme:T.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new E;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,I,i){const P=this.toUri(_,I);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):T.isNative&&(i||T.isPreferringBrowserCodeLoad)&&P.scheme===D.file?P.with({scheme:D.vscodeFileResource,authority:P.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(_,I){const i=this.toUri(_,I);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(_,I){return g.URI.isUri(_)?_:g.URI.parse(I.toUrl(_))}}e.FileAccess=new k}),define(we[25],_e([0,1,42,13,2,8,15,21]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return D.uriToFsPath(h,!0)}e.originalFSPath=_;class I{constructor(d){this._ignorePathCasing=d}compare(d,u,w=!1){return d===u?0:E.compare(this.getComparisonKey(d,w),this.getComparisonKey(u,w))}isEqual(d,u,w=!1){return d===u?!0:!d||!u?!1:this.getComparisonKey(d,w)===this.getComparisonKey(u,w)}getComparisonKey(d,u=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,u,w=!1){if(d.scheme===u.scheme){if(d.scheme===k.Schemas.file)return g.isEqualOrParent(_(d),_(u),this._ignorePathCasing(d))&&d.query===u.query&&(w||d.fragment===u.fragment);if(e.isEqualAuthority(d.authority,u.authority))return g.isEqualOrParent(d.path,u.path,this._ignorePathCasing(d),"/")&&d.query===u.query&&(w||d.fragment===u.fragment)}return!1}joinPath(d,...u){return D.URI.joinPath(d,...u)}basenameOrAuthority(d){return e.basename(d)||d.authority}basename(d){return T.posix.basename(d.path)}extname(d){return T.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let u;return d.scheme===k.Schemas.file?u=D.URI.file(T.dirname(_(d))).path:(u=T.posix.dirname(d.path),d.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),u="/")),d.with({path:u})}normalizePath(d){if(!d.path.length)return d;let u;return d.scheme===k.Schemas.file?u=D.URI.file(T.normalize(_(d))).path:u=T.posix.normalize(d.path),d.with({path:u})}relativePath(d,u){if(d.scheme!==u.scheme||!e.isEqualAuthority(d.authority,u.authority))return;if(d.scheme===k.Schemas.file){const S=T.relative(_(d),_(u));return y.isWindows?g.toSlashes(S):S}let w=d.path||"/",p=u.path||"/";if(this._ignorePathCasing(d)){let S=0;for(const c=Math.min(w.length,p.length);S<c&&!(w.charCodeAt(S)!==p.charCodeAt(S)&&w.charAt(S).toLowerCase()!==p.charAt(S).toLowerCase());S++);w=p.substr(0,S)+w.substr(S)}return T.posix.relative(w,p)}resolvePath(d,u){if(d.scheme===k.Schemas.file){const w=D.URI.file(T.resolve(_(d),u));return d.with({authority:w.authority,path:w.path})}return u=g.toPosixPath(u),d.with({path:T.posix.resolve(d.path,u)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,u){return d===u||E.equalsIgnoreCase(d,u)}hasTrailingPathSeparator(d,u=T.sep){if(d.scheme===k.Schemas.file){const w=_(d);return w.length>g.getRoot(w).length&&w[w.length-1]===u}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,u=T.sep){return e.hasTrailingPathSeparator(d,u)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,u=T.sep){let w=!1;if(d.scheme===k.Schemas.file){const p=_(d);w=p!==void 0&&p.length===g.getRoot(p).length&&p[p.length-1]===u}else{u="/";const p=d.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!e.hasTrailingPathSeparator(d,u)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(h=>h.scheme===k.Schemas.file?!y.isLinux:!0),e.extUriIgnorePathCase=new I(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(h,d){const u=[];for(let w=0;w<h.length;w++){const p=d(h[w]);h.some((S,c)=>c===w?!1:e.isEqualOrParent(p,d(S)))||u.push(h[w])}return u}e.distinctParents=i;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(u){const w=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(c=>{const[m,f]=c.split(":");m&&f&&w.set(m,f)});const S=u.path.substring(0,u.path.indexOf(";"));return S&&w.set(h.META_DATA_MIME,S),w}h.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function o(h,d,u){if(d){let w=h.path;return w&&w[0]!==T.posix.sep&&(w=T.posix.sep+w),h.with({scheme:u,authority:d,path:w})}return h.with({scheme:u})}e.toLocalResource=o}),define(we[11],_e([0,1,18,12,3,7,51,25]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(B){return!!B&&typeof B.then=="function"}e.isThenable=_;function I(B){const M=new g.CancellationTokenSource,U=B(M.token),j=new Promise((z,oe)=>{M.token.onCancellationRequested(()=>{oe(T.canceled())}),Promise.resolve(U).then(pe=>{M.dispose(),z(pe)},pe=>{M.dispose(),oe(pe)})});return new class{cancel(){M.cancel()}then(z,oe){return j.then(z,oe)}catch(z){return this.then(void 0,z)}finally(z){return j.finally(z)}}}e.createCancelablePromise=I;function i(B,M,U){return Promise.race([B,new Promise(j=>M.onCancellationRequested(()=>j(U)))])}e.raceCancellation=i;async function P(B){let M=-1;const U=B.map((z,oe)=>z.then(pe=>(M=oe,pe))),j=await Promise.race(U);return B.forEach((z,oe)=>{oe!==M&&z.cancel()}),j}e.raceCancellablePromises=P;function o(B,M,U){let j;const z=setTimeout(()=>{j==null||j(void 0),U==null||U()},M);return Promise.race([B.finally(()=>clearTimeout(z)),new Promise(oe=>j=oe)])}e.raceTimeout=o;function h(B){return new Promise((M,U)=>{const j=B();_(j)?j.then(M,U):M(j)})}e.asPromise=h;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(U,U).then(j)})}return new Promise((U,j)=>{this.queuedPromise.then(U,j)})}return this.activePromise=M(),new Promise((U,j)=>{this.activePromise.then(z=>{this.activePromise=null,U(z)},z=>{this.activePromise=null,j(z)})})}}e.Throttler=d;class u{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=u;class w{constructor(){this.promiseMap=new Map}queue(M,U){var j;const oe=((j=this.promiseMap.get(M))!==null&&j!==void 0?j:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===oe&&this.promiseMap.delete(M)});return this.promiseMap.set(M,oe),oe}}e.SequencerByKey=w;class p{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,z)=>{this.doResolve=j,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class S{constructor(M){this.delayer=new p(M),this.throttler=new d}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class c{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class m extends c{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=m;function f(B,M){return M?new Promise((U,j)=>{const z=setTimeout(U,B);M.onCancellationRequested(()=>{clearTimeout(z),j(T.canceled())})}):I(U=>f(B,U))}e.timeout=f;function t(B,M=0){const U=setTimeout(B,M);return E.toDisposable(()=>clearTimeout(U))}e.disposableTimeout=t;function n(B){return B.then(void 0,M=>{})}e.ignoreErrors=n;function r(B){const M=[];let U=0;const j=B.length;function z(){return U<j?B[U++]():null}function oe(pe){pe!=null&&M.push(pe);const Te=z();return Te?Te.then(oe):Promise.resolve(M)}return Promise.resolve(null).then(oe)}e.sequence=r;function s(B,M=j=>!!j,U=null){let j=0;const z=B.length,oe=()=>{if(j>=z)return Promise.resolve(U);const pe=B[j++];return Promise.resolve(pe()).then($e=>M($e)?Promise.resolve($e):oe())};return oe()}e.first=s;function l(B,M=j=>!!j,U=null){if(B.length===0)return Promise.resolve(U);let j=B.length;const z=()=>{var oe,pe;j=-1;for(const Te of B)(pe=(oe=Te).cancel)===null||pe===void 0||pe.call(oe)};return new Promise((oe,pe)=>{for(const Te of B)Te.then($e=>{--j>=0&&M($e)?(z(),oe($e)):j===0&&oe(U)}).catch($e=>{--j>=0&&(z(),pe($e))})})}e.firstParallel=l;class v{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,j)=>{this.outstandingPromises.push({factory:M,c:U,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class b extends v{constructor(){super(1)}}e.Queue=b;class A{constructor(){this.queues=new Map}queueFor(M,U=y.extUri){const j=U.getComparisonKey(M);let z=this.queues.get(j);return z||(z=new b,D.Event.once(z.onFinished)(()=>{z==null||z.dispose(),this.queues.delete(j)}),this.queues.set(j,z)),z}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=A;class C{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=C;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=a;class F{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const B=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(B));let j=!1;return{dispose(){j||(j=!0,clearTimeout(U))}}}}else e.runWhenIdle=(B,M)=>{const U=requestIdleCallback(B,typeof M=="number"?{timeout:M}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(U))}}}}();class W{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function ce(B,M,U){let j;for(let z=0;z<U;z++)try{return await B()}catch(oe){j=oe,await f(M)}throw j}e.retry=ce;class me{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,j){return this._pending={taskId:M,cancel:()=>j==null?void 0:j(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,j;const z=new Promise((oe,pe)=>{U=oe,j=pe});this._next={run:M,promise:z,promiseResolve:U,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=me;class G{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class V{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback(T.canceled()),this.rejected=!0,M()})}}e.DeferredPromise=V;class J extends D.Emitter{async fireAsync(M,U,j){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const z of this._listeners)this._asyncDeliveryQueue.push([z,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[z,oe]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},oe),{waitUntil:$e=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");j&&($e=j($e,typeof z=="function"?z:z[0])),pe.push($e)}});try{typeof z=="function"?z.call(void 0,Te):z[0].call(z[1],Te)}catch($e){T.onUnexpectedError($e);continue}Object.freeze(pe),await R.settled(pe).catch($e=>T.onUnexpectedError($e))}}}}e.AsyncEmitter=J;var R;(function(B){async function M(oe){return typeof Promise.allSettled=="function"?U(oe):j(oe)}B.allSettled=M;async function U(oe){return Promise.allSettled(oe)}async function j(oe){return Promise.all(oe.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function z(oe){let pe;const Te=await Promise.all(oe.map($e=>$e.then(Me=>Me,Me=>{pe||(pe=Me)})));if(typeof pe!="undefined")throw pe;return Te}B.settled=z})(R=e.Promises||(e.Promises={}))}),define(we[110],_e([0,1,13,11]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new T.IdleValue(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),E=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function y(C,a,F=!1){const N=C||"",W=a||"",ce=D.value.collator.compare(N,W);return D.value.collatorIsNumeric&&ce===0&&N!==W?N<W?-1:1:ce}e.compareFileNames=y;function _(C,a){const F=E.value.collator;return C=C||"",a=a||"",f(F,C,a)}e.compareFileNamesDefault=_;function I(C,a){const F=E.value.collator;return C=C||"",a=a||"",s(C,a)||f(F,C,a)}e.compareFileNamesUpper=I;function i(C,a){const F=E.value.collator;return C=C||"",a=a||"",r(C,a)||f(F,C,a)}e.compareFileNamesLower=i;function P(C,a){return C=C||"",a=a||"",C===a?0:C<a?-1:1}e.compareFileNamesUnicode=P;function o(C,a,F=!1){F||(C=C&&C.toLowerCase(),a=a&&a.toLowerCase());const[N,W]=c(C),[ce,me]=c(a);return N!==ce?N<ce?-1:1:W===me?0:W<me?-1:1}e.noIntlCompareFileNames=o;function h(C,a){const[F,N]=c(C),[W,ce]=c(a);let me=D.value.collator.compare(N,ce);if(me===0){if(D.value.collatorIsNumeric&&N!==ce)return N<ce?-1:1;if(me=D.value.collator.compare(F,W),D.value.collatorIsNumeric&&me===0&&F!==W)return F<W?-1:1}return me}e.compareFileExtensions=h;function d(C,a){C=C||"",a=a||"";const F=m(C),N=m(a),W=E.value.collator,ce=k.value.collator;return f(ce,F,N)||f(W,C,a)}e.compareFileExtensionsDefault=d;function u(C,a){C=C||"",a=a||"";const F=m(C),N=m(a),W=E.value.collator,ce=k.value.collator;return f(ce,F,N)||s(C,a)||f(W,C,a)}e.compareFileExtensionsUpper=u;function w(C,a){C=C||"",a=a||"";const F=m(C),N=m(a),W=E.value.collator,ce=k.value.collator;return f(ce,F,N)||r(C,a)||f(W,C,a)}e.compareFileExtensionsLower=w;function p(C,a){C=C||"",a=a||"";const F=m(C).toLowerCase(),N=m(a).toLowerCase();return F!==N?F<N?-1:1:C!==a?C<a?-1:1:0}e.compareFileExtensionsUnicode=p;const S=/^(.*?)(\.([^.]*))?$/;function c(C,a=!1){const F=C?S.exec(C):[];let N=[F&&F[1]||"",F&&F[3]||""];return a&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function m(C){const a=C?S.exec(C):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function f(C,a,F){let N=C.compare(a,F);return N!==0?N:a.length!==F.length?a.length<F.length?-1:1:0}function t(C){const a=C.charAt(0);return a.toLocaleUpperCase()!==a}function n(C){const a=C.charAt(0);return a.toLocaleLowerCase()!==a}function r(C,a){return t(C)&&n(a)?-1:n(C)&&t(a)?1:0}function s(C,a){return n(C)&&t(a)?-1:t(C)&&n(a)?1:0}function l(C,a,F=!1){return F||(C=C&&C.toLowerCase(),a=a&&a.toLowerCase()),C===a?0:C<a?-1:1}function v(C,a,F=!1){const N=C.split(g.sep),W=a.split(g.sep),ce=N.length-1,me=W.length-1;let G,V;for(let J=0;;J++){if(G=ce===J,V=me===J,G&&V)return y(N[J],W[J],F);if(G)return-1;if(V)return 1;const R=l(N[J],W[J],F);if(R!==0)return R}}e.comparePaths=v;function b(C,a,F){const N=C.toLowerCase(),W=a.toLowerCase(),ce=A(C,a,F);if(ce)return ce;const me=N.endsWith(F),G=W.endsWith(F);if(me!==G)return me?-1:1;const V=y(N,W);return V!==0?V:N.localeCompare(W)}e.compareAnything=b;function A(C,a,F){const N=C.toLowerCase(),W=a.toLowerCase(),ce=N.startsWith(F),me=W.startsWith(F);if(ce!==me)return ce?-1:1;if(ce&&me){if(N.length<W.length)return-1;if(N.length>W.length)return 1}return 0}e.compareByPrefix=A}),define(we[27],_e([0,1,8,42,13,22,11]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y;const _="**",I="/",i="[/\\\\]",P="[^/\\\\]",o=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function d(U,j){if(!U)return[];const z=[];let oe=!1,pe=!1,Te="";for(const $e of U){switch($e){case j:if(!oe&&!pe){z.push(Te),Te="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=$e}return Te&&z.push(Te),z}e.splitGlobAware=d;function u(U){if(!U)return"";let j="";const z=d(U,I);if(z.every(oe=>oe===_))j=".*";else{let oe=!1;z.forEach((pe,Te)=>{if(pe===_){oe||(j+=h(2),oe=!0);return}let $e=!1,Me="",ze=!1,Qe="";for(const Ke of pe){if(Ke!=="}"&&$e){Me+=Ke;continue}if(ze&&(Ke!=="]"||!Qe)){let Ge;Ke==="-"?Ge=Ke:(Ke==="^"||Ke==="!")&&!Qe?Ge="^":Ke===I?Ge="":Ge=g.escapeRegExpCharacters(Ke),Qe+=Ge;continue}switch(Ke){case"{":$e=!0;continue;case"[":ze=!0;continue;case"}":j+=`(?:${d(Me,",").map(Q=>u(Q)).join("|")})`,$e=!1,Me="";break;case"]":j+="["+Qe+"]",ze=!1,Qe="";break;case"?":j+=P;continue;case"*":j+=h(1);continue;default:j+=g.escapeRegExpCharacters(Ke)}}Te<z.length-1&&(z[Te+1]!==_||Te+2<z.length)&&(j+=i),oe=!1})}return j}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),n=function(){return!1},r=function(){return null};function s(U,j){if(!U)return r;let z;typeof U!="string"?z=U.pattern:z=U,z=z.trim();const oe=`${z}_${!!j.trimForExclusions}`;let pe=t.get(oe);if(pe)return l(pe,U);let Te;if(w.test(z)){const $e=z.substr(4);pe=function(Me,ze){return typeof Me=="string"&&Me.endsWith($e)?z:null}}else(Te=p.exec(v(z,j)))?pe=b(Te[1],z):(j.trimForExclusions?c:S).test(z)?pe=A(z,j):(Te=m.exec(v(z,j)))?pe=C(Te[1].substr(1),z,!0):(Te=f.exec(v(z,j)))?pe=C(Te[1],z,!1):pe=a(z);return t.set(oe,pe),l(pe,U)}function l(U,j){return typeof j=="string"?U:function(z,oe){return T.isEqualOrParent(z,j.base)?U(D.relative(j.base,z),oe):null}}function v(U,j){return j.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function b(U,j){const z=`/${U}`,oe=`\\${U}`,pe=function($e,Me){return typeof $e!="string"?null:Me?Me===U?j:null:$e===U||$e.endsWith(z)||$e.endsWith(oe)?j:null},Te=[U];return pe.basenames=Te,pe.patterns=[j],pe.allBasenames=Te,pe}function A(U,j){const z=M(U.slice(1,-1).split(",").map(Me=>s(Me,j)).filter(Me=>Me!==r),U),oe=z.length;if(!oe)return r;if(oe===1)return z[0];const pe=function(Me,ze){for(let Qe=0,Ke=z.length;Qe<Ke;Qe++)if(z[Qe](Me,ze))return U;return null},Te=z.find(Me=>!!Me.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const $e=z.reduce((Me,ze)=>ze.allPaths?Me.concat(ze.allPaths):Me,[]);return $e.length&&(pe.allPaths=$e),pe}function C(U,j,z){const oe=D.sep===D.posix.sep,pe=oe?U:U.replace(o,D.sep),Te=D.sep+pe,$e=D.posix.sep+U,Me=z?function(ze,Qe){return typeof ze=="string"&&(ze===pe||ze.endsWith(Te)||!oe&&(ze===U||ze.endsWith($e)))?j:null}:function(ze,Qe){return typeof ze=="string"&&(ze===pe||!oe&&ze===U)?j:null};return Me.allPaths=[(z?"*/":"./")+U],Me}function a(U){try{const j=new RegExp(`^${u(U)}$`);return function(z){return j.lastIndex=0,typeof z=="string"&&j.test(z)?U:null}}catch(j){return r}}function F(U,j,z){return!U||typeof j!="string"?!1:N(U)(j,void 0,z)}e.match=F;function N(U,j={}){if(!U)return n;if(typeof U=="string"||G(U)){const z=s(U,j);if(z===r)return n;const oe=function(pe,Te){return!!z(pe,Te)};return z.allBasenames&&(oe.allBasenames=z.allBasenames),z.allPaths&&(oe.allPaths=z.allPaths),oe}return R(U,j)}e.parse=N;function W(U){if(!U)return;let j;return z=>(j||(j=(U()||Promise.resolve([])).then(oe=>oe?me(oe):{})),j.then(oe=>!!oe[z]))}e.hasSiblingPromiseFn=W;function ce(U){if(!U)return;let j;return z=>{if(!j){const oe=U();j=oe?me(oe):{}}return!!j[z]}}e.hasSiblingFn=ce;function me(U){const j={};for(const z of U)j[z]=!0;return j}function G(U){const j=U;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=G;function V(U){return U.allBasenames||[]}e.getBasenameTerms=V;function J(U){return U.allPaths||[]}e.getPathTerms=J;function R(U,j){const z=M(Object.getOwnPropertyNames(U).map(Me=>B(Me,U[Me],j)).filter(Me=>Me!==r)),oe=z.length;if(!oe)return r;if(!z.some(Me=>!!Me.requiresSiblings)){if(oe===1)return z[0];const Me=function(Ke,Ge){for(let $=0,Q=z.length;$<Q;$++){const ne=z[$](Ke,Ge);if(ne)return ne}return null},ze=z.find(Ke=>!!Ke.allBasenames);ze&&(Me.allBasenames=ze.allBasenames);const Qe=z.reduce((Ke,Ge)=>Ge.allPaths?Ke.concat(Ge.allPaths):Ke,[]);return Qe.length&&(Me.allPaths=Qe),Me}const pe=function(Me,ze,Qe){let Ke;for(let Ge=0,$=z.length;Ge<$;Ge++){const Q=z[Ge];Q.requiresSiblings&&Qe&&(ze||(ze=D.basename(Me)),Ke||(Ke=ze.substr(0,ze.length-D.extname(Me).length)));const ne=Q(Me,ze,Ke,Qe);if(ne)return ne}return null},Te=z.find(Me=>!!Me.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const $e=z.reduce((Me,ze)=>ze.allPaths?Me.concat(ze.allPaths):Me,[]);return $e.length&&(pe.allPaths=$e),pe}function B(U,j,z){if(j===!1)return r;const oe=s(U,z);if(oe===r)return r;if(typeof j=="boolean")return oe;if(j){const pe=j.when;if(typeof pe=="string"){const Te=($e,Me,ze,Qe)=>{if(!Qe||!oe($e,Me))return null;const Ke=pe.replace("$(basename)",ze),Ge=Qe(Ke);return k.isThenable(Ge)?Ge.then($=>$?U:null):Ge?U:null};return Te.requiresSiblings=!0,Te}}return oe}function M(U,j){const z=U.filter(Me=>!!Me.basenames);if(z.length<2)return U;const oe=z.reduce((Me,ze)=>{const Qe=ze.basenames;return Qe?Me.concat(Qe):Me},[]);let pe;if(j){pe=[];for(let Me=0,ze=oe.length;Me<ze;Me++)pe.push(j)}else pe=z.reduce((Me,ze)=>{const Qe=ze.patterns;return Qe?Me.concat(Qe):Me},[]);const Te=function(Me,ze){if(typeof Me!="string")return null;if(!ze){let Ke;for(Ke=Me.length;Ke>0;Ke--){const Ge=Me.charCodeAt(Ke-1);if(Ge===47||Ge===92)break}ze=Me.substr(Ke)}const Qe=oe.indexOf(ze);return Qe!==-1?pe[Qe]:null};Te.basenames=oe,Te.patterns=pe,Te.allBasenames=oe;const $e=U.filter(Me=>!Me.basenames);return $e.push(Te),$e}}),define(we[81],_e([0,1,2,13,8,15,21,25,42]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(s,l,v){if(typeof s=="string"&&(s=g.URI.file(s)),v){const A=v.getWorkspaceFolder(s);if(A){const C=v.getWorkspace().folders.length>1;let a;if(y.isEqual(A.uri,s)?a="":a=y.relativePath(A.uri,s),C){const F=A.name?A.name:y.basename(A.uri);a=a?F+" \u2022 "+a:F}return a}}if(s.scheme!==E.Schemas.file&&s.scheme!==E.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(s.fsPath))return T.normalize(P(s.fsPath));let b=T.normalize(s.fsPath);return!k.isWindows&&(l==null?void 0:l.userHome)&&(b=h(b,l.userHome.fsPath)),b}e.getPathLabel=I;function i(s){if(!s)return;typeof s=="string"&&(s=g.URI.file(s));const l=y.basename(s)||(s.scheme===E.Schemas.file?s.fsPath:s.path);return k.isWindows&&_.isRootOrDriveLetter(l)?P(l):l}e.getBaseLabel=i;function P(s){return _.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=P;let o=Object.create(null);function h(s,l){if(k.isWindows||!s||!l)return s;let v=o.original===l?o.normalized:void 0;return v||(v=`${D.rtrim(l,T.posix.sep)}${T.posix.sep}`,o={original:l,normalized:v}),(k.isLinux?s.startsWith(v):D.startsWithIgnoreCase(s,v))&&(s=`~/${s.substr(v.length)}`),s}e.tildify=h;function d(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=d;const u="\u2026",w="\\\\",p="~";function S(s,l=T.sep){const v=new Array(s.length);let b=!1;for(let A=0;A<s.length;A++){let C=s[A];if(C===""){v[A]=`.${l}`;continue}if(!C){v[A]=C;continue}b=!0;let a="";C.indexOf(w)===0?(a=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(l)===0?(a=C.substr(0,C.indexOf(l)+l.length),C=C.substr(C.indexOf(l)+l.length)):C.indexOf(p)===0&&(a=C.substr(0,C.indexOf(p)+p.length),C=C.substr(C.indexOf(p)+p.length));const F=C.split(l);for(let N=1;b&&N<=F.length;N++)for(let W=F.length-N;b&&W>=0;W--){b=!1;let ce=F.slice(W,W+N).join(l);for(let me=0;!b&&me<s.length;me++)if(me!==A&&s[me]&&s[me].indexOf(ce)>-1){const G=W+N===F.length,V=W>0&&s[me].indexOf(l)>-1?l+ce:ce,J=s[me].endsWith(V);b=!G||J}if(!b){let me="";(F[0].endsWith(":")||a!=="")&&(W===1&&(W=0,N++,ce=F[0]+l+ce),W>0&&(me=F[0]+l),me=a+me),W>0&&(me=me+u+l),me=me+ce,W+N<F.length&&(me=me+l+u),v[A]=me}}b&&(v[A]=C)}return v}e.shorten=S;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function m(s,l=Object.create(null)){const v=[];let b=!1,A="";for(const C of s)if(C==="$"||b&&C==="{")A&&v.push({value:A,type:c.TEXT}),A="",b=!0;else if(C==="}"&&b){const a=l[A];if(typeof a=="string")a.length&&v.push({value:a,type:c.VARIABLE});else if(a){const F=v[v.length-1];(!F||F.type!==c.SEPARATOR)&&v.push({value:a.label,type:c.SEPARATOR})}A="",b=!1}else A+=C;return A&&!b&&v.push({value:A,type:c.TEXT}),v.filter((C,a)=>{if(C.type===c.SEPARATOR){const F=v[a-1],N=v[a+1];return[F,N].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=m;function f(s,l){return k.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):s.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(s,l){return k.isMacintosh||l?s.replace(/\(&&\w\)|&&/g,""):k.isWindows?s.replace(/&&|&/g,v=>v==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(s){const l=s.indexOf("/")!==-1?T.posix:T.win32,v=l.basename(s),b=l.dirname(s);return v.length?{name:v,parentPath:b}:{name:b,parentPath:""}}e.splitName=r}),define(we[111],_e([0,1,13,8,27,15,25]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let y=[],_=[],I=[];function i(t,n=!1){const r=P(t);y.push(r),r.userConfigured?I.push(r):_.push(r),n&&!r.userConfigured&&y.forEach(s=>{s.mime===r.mime||s.userConfigured||(r.extension&&s.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&s.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&s.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&s.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=i;function P(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(g.posix.sep)>=0:!1}}function o(t){t?(y=y.filter(n=>!n.userConfigured),I=[]):(y=[],_=[],I=[])}e.clearTextMimes=o;function h(t,n){let r;if(t)switch(t.scheme){case E.Schemas.file:r=t.fsPath;break;case E.Schemas.data:r=k.DataUri.parseMetaData(t).get(k.DataUri.META_DATA_LABEL);break;default:r=t.path}if(!r)return[e.MIME_UNKNOWN];r=r.toLowerCase();const s=g.basename(r),l=d(r,s,I);if(l)return[l,e.MIME_TEXT];const v=d(r,s,_);if(v)return[v,e.MIME_TEXT];if(n){const b=u(n);if(b)return[b,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=h;function d(t,n,r){let s=null,l=null,v=null;for(let b=r.length-1;b>=0;b--){const A=r[b];if(n===A.filenameLowercase){s=A;break}if(A.filepattern&&(!l||A.filepattern.length>l.filepattern.length)){const C=A.filepatternOnPath?t:n;D.match(A.filepatternLowercase,C)&&(l=A)}A.extension&&(!v||A.extension.length>v.extension.length)&&n.endsWith(A.extensionLowercase)&&(v=A)}return s?s.mime:l?l.mime:v?v.mime:null}function u(t){if(T.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let n=y.length-1;n>=0;n--){const r=y[n];if(!r.firstline)continue;const s=t.match(r.firstline);if(s&&s.length>0)return r.mime}return null}function w(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&w(t[0]):!0}e.isUnspecific=w;const p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(t){const n=g.extname(t);return p[n.toLowerCase()]}e.getMediaMime=S;function c(t){for(const n in p)if(p[n]===t)return n}e.getExtensionForMimeType=c;const m=/^(.+)\/(.+?)(;.+)?$/;function f(t,n){var r;const s=m.exec(t);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${(r=s[3])!==null&&r!==void 0?r:""}`:n?void 0:t}e.normalizeMimeType=f}),define(we[112],_e([0,1,2]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(i){return i.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const o=this._uriTransformer.transformIncoming(P);return o===P?P:T(g.URI.from(o))}transformOutgoing(P){const o=this._uriTransformer.transformOutgoing(P);return o===P?P:T(g.URI.from(o))}transformOutgoingURI(P){const o=this._uriTransformer.transformOutgoing(P);return o===P?P:g.URI.from(o)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function E(i,P,o){if(!i||o>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return P.transformOutgoing(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const d=E(i[h],P,o+1);d!==null&&(i[h]=d)}}return null}function k(i,P){const o=E(i,P,0);return o===null?i:o}e.transformOutgoingURIs=k;function y(i,P,o,h){if(!i||h>200)return null;if(typeof i=="object"){if(i.$mid===1)return o?g.URI.revive(P.transformIncoming(i)):P.transformIncoming(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const u=y(i[d],P,o,h+1);u!==null&&(i[d]=u)}}return null}function _(i,P){const o=y(i,P,!1,0);return o===null?i:o}e.transformIncomingURIs=_;function I(i,P){const o=y(i,P,!0,0);return o===null?i:o}e.transformAndReviveIncomingURIs=I}),define(we[34],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(_){return g.test(_)}e.isUUID=T;const D=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function y(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let _=0,I="";return I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I+="-",I+=E[D[_++]],I+=E[D[_++]],I+="-",I+=E[D[_++]],I+=E[D[_++]],I+="-",I+=E[D[_++]],I+=E[D[_++]],I+="-",I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I+=E[D[_++]],I}e.generateUuid=y}),define(we[82],_e([0,1,79]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(y){let _=g.toUint8(y);this._defaultValue=_,this._asciiMap=T._createAsciiMap(_),this._map=new Map}static _createAsciiMap(y){let _=new Uint8Array(256);for(let I=0;I<256;I++)_[I]=y;return _}set(y,_){let I=g.toUint8(_);y>=0&&y<256?this._asciiMap[y]=I:this._map.set(y,I)}get(y){return y>=0&&y<256?this._asciiMap[y]:this._map.get(y)||this._defaultValue}}e.CharacterClassifier=T;var D;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(D||(D={}));class E{constructor(){this._actual=new T(0)}add(y){this._actual.set(y,1)}has(y){return this._actual.get(y)===1}}e.CharacterSet=E}),define(we[113],_e([0,1,82]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(y){super(0);for(let _=0,I=y.length;_<I;_++)this.set(y.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function E(k){let y={};return _=>(y.hasOwnProperty(_)||(y[_]=k(_)),y[_])}e.getMapForWordSeparators=E(k=>new D(k))}),define(we[35],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,E){this.lineNumber=D,this.column=E}with(D=this.lineNumber,E=this.column){return D===this.lineNumber&&E===this.column?this:new g(D,E)}delta(D=0,E=0){return this.with(this.lineNumber+D,this.column+E)}equals(D){return g.equals(this,D)}static equals(D,E){return!D&&!E?!0:!!D&&!!E&&D.lineNumber===E.lineNumber&&D.column===E.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,E){return D.lineNumber<E.lineNumber?!0:E.lineNumber<D.lineNumber?!1:D.column<E.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,E){return D.lineNumber<E.lineNumber?!0:E.lineNumber<D.lineNumber?!1:D.column<=E.column}static compare(D,E){let k=D.lineNumber|0,y=E.lineNumber|0;if(k===y){let _=D.column|0,I=E.column|0;return _-I}return k-y}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(we[31],_e([0,1,35]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(E,k,y,_){E>y||E===y&&k>_?(this.startLineNumber=y,this.startColumn=_,this.endLineNumber=E,this.endColumn=k):(this.startLineNumber=E,this.startColumn=k,this.endLineNumber=y,this.endColumn=_)}isEmpty(){return T.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return T.containsPosition(this,E)}static containsPosition(E,k){return!(k.lineNumber<E.startLineNumber||k.lineNumber>E.endLineNumber||k.lineNumber===E.startLineNumber&&k.column<E.startColumn||k.lineNumber===E.endLineNumber&&k.column>E.endColumn)}containsRange(E){return T.containsRange(this,E)}static containsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>E.endColumn)}strictContainsRange(E){return T.strictContainsRange(this,E)}static strictContainsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<=E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>=E.endColumn)}plusRange(E){return T.plusRange(this,E)}static plusRange(E,k){let y,_,I,i;return k.startLineNumber<E.startLineNumber?(y=k.startLineNumber,_=k.startColumn):k.startLineNumber===E.startLineNumber?(y=k.startLineNumber,_=Math.min(k.startColumn,E.startColumn)):(y=E.startLineNumber,_=E.startColumn),k.endLineNumber>E.endLineNumber?(I=k.endLineNumber,i=k.endColumn):k.endLineNumber===E.endLineNumber?(I=k.endLineNumber,i=Math.max(k.endColumn,E.endColumn)):(I=E.endLineNumber,i=E.endColumn),new T(y,_,I,i)}intersectRanges(E){return T.intersectRanges(this,E)}static intersectRanges(E,k){let y=E.startLineNumber,_=E.startColumn,I=E.endLineNumber,i=E.endColumn,P=k.startLineNumber,o=k.startColumn,h=k.endLineNumber,d=k.endColumn;return y<P?(y=P,_=o):y===P&&(_=Math.max(_,o)),I>h?(I=h,i=d):I===h&&(i=Math.min(i,d)),y>I||y===I&&_>i?null:new T(y,_,I,i)}equalsRange(E){return T.equalsRange(this,E)}static equalsRange(E,k){return!!E&&!!k&&E.startLineNumber===k.startLineNumber&&E.startColumn===k.startColumn&&E.endLineNumber===k.endLineNumber&&E.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,k){return new T(this.startLineNumber,this.startColumn,E,k)}setStartPosition(E,k){return new T(E,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(E){return new T(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,k=E){return new T(E.lineNumber,E.column,k.lineNumber,k.column)}static lift(E){return E?new T(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<E.startColumn)}static areIntersecting(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<=k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,k){if(E&&k){const I=E.startLineNumber|0,i=k.startLineNumber|0;if(I===i){const P=E.startColumn|0,o=k.startColumn|0;if(P===o){const h=E.endLineNumber|0,d=k.endLineNumber|0;if(h===d){const u=E.endColumn|0,w=k.endColumn|0;return u-w}return h-d}return P-o}return I-i}return(E?1:0)-(k?1:0)}static compareRangesUsingEnds(E,k){return E.endLineNumber===k.endLineNumber?E.endColumn===k.endColumn?E.startLineNumber===k.startLineNumber?E.startColumn-k.startColumn:E.startLineNumber-k.startLineNumber:E.endColumn-k.endColumn:E.endLineNumber-k.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=T}),define(we[114],_e([0,1,35,31]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class E extends T.Range{constructor(y,_,I,i){super(y,_,I,i);this.selectionStartLineNumber=y,this.selectionStartColumn=_,this.positionLineNumber=I,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(y){return E.selectionsEqual(this,y)}static selectionsEqual(y,_){return y.selectionStartLineNumber===_.selectionStartLineNumber&&y.selectionStartColumn===_.selectionStartColumn&&y.positionLineNumber===_.positionLineNumber&&y.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(y,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,y,_):new E(y,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(y,_){return this.getDirection()===0?new E(y,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,y,_)}static fromPositions(y,_=y){return new E(y.lineNumber,y.column,_.lineNumber,_.column)}static liftSelection(y){return new E(y.selectionStartLineNumber,y.selectionStartColumn,y.positionLineNumber,y.positionColumn)}static selectionsArrEqual(y,_){if(y&&!_||!y&&_)return!1;if(!y&&!_)return!0;if(y.length!==_.length)return!1;for(let I=0,i=y.length;I<i;I++)if(!this.selectionsEqual(y[I],_[I]))return!1;return!0}static isISelection(y){return y&&typeof y.selectionStartLineNumber=="number"&&typeof y.selectionStartColumn=="number"&&typeof y.positionLineNumber=="number"&&typeof y.positionColumn=="number"}static createWithDirection(y,_,I,i,P){return P===0?new E(y,_,I,i):new E(I,i,y,_)}}e.Selection=E}),define(we[83],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(u){this.tabSize=Math.max(1,u.tabSize|0),this.indentSize=u.tabSize|0,this.insertSpaces=Boolean(u.insertSpaces),this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=Boolean(u.trimAutoWhitespace)}equals(u){return this.tabSize===u.tabSize&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class _{constructor(u,w){this.range=u,this.matches=w}}e.FindMatch=_;var I;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(I=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(d){d[d.Left=0]="Left",d[d.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var P;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(P=e.ModelConstants||(e.ModelConstants={}));class o{constructor(u,w,p,S,c,m){this.identifier=u,this.range=w,this.text=p,this.forceMoveMarkers=S,this.isAutoWhitespaceEdit=c,this._isTracked=m}}e.ValidAnnotatedEditOperation=o;class h{constructor(u,w,p){this.reverseEdits=u,this.changes=w,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=h}),define(we[115],_e([0,1,8,113,35,31,83]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const y=999;class _{constructor(c,m,f,t){this.searchString=c,this.isRegex=m,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=I(this.searchString):c=this.searchString.indexOf(`
`)>=0;let m=null;try{m=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!m)return null;let f=!this.isRegex&&!c;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new i(m,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=_;function I(S){if(!S||S.length===0)return!1;for(let c=0,m=S.length;c<m;c++)if(S.charCodeAt(c)===92){if(c++,c>=m)break;const t=S.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=I;class i{constructor(c,m,f){this.regex=c,this.wordSeparators=m,this.simpleSearch=f}}e.SearchData=i;function P(S,c,m){if(!m)return new k.FindMatch(S,null);let f=[];for(let t=0,n=c.length;t<n;t++)f[t]=c[t];return new k.FindMatch(S,f)}e.createFindMatch=P;class o{constructor(c){let m=[],f=0;for(let t=0,n=c.length;t<n;t++)c.charCodeAt(t)===10&&(m[f++]=t);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(c){const m=this._lineFeedsOffsets;let f=0,t=m.length-1;if(t===-1||c<=m[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);m[n]>=c?t=n-1:m[n+1]>=c?(f=n,t=n):f=n+1}return f+1}}class h{static findMatches(c,m,f,t,n){const r=m.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(c,f,new p(r.wordSeparators,r.regex),t,n):this._doFindMatchesLineByLine(c,f,r,t,n):[]}static _getMultilineMatchRange(c,m,f,t,n,r){let s,l=0;t?(l=t.findLineFeedCountBeforeOffset(n),s=m+n+l):s=m+n;let v;if(t){let a=t.findLineFeedCountBeforeOffset(n+r.length)-l;v=s+r.length+a}else v=s+r.length;const b=c.getPositionAt(s),A=c.getPositionAt(v);return new E.Range(b.lineNumber,b.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(c,m,f,t,n){const r=c.getOffsetAt(m.getStartPosition()),s=c.getValueInRange(m,1),l=c.getEOL()===`\r
`?new o(s):null,v=[];let b=0,A;for(f.reset(0);A=f.next(s);)if(v[b++]=P(this._getMultilineMatchRange(c,r,s,l,A.index,A[0]),A,t),b>=n)return v;return v}static _doFindMatchesLineByLine(c,m,f,t,n){const r=[];let s=0;if(m.startLineNumber===m.endLineNumber){const v=c.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(f,v,m.startLineNumber,m.startColumn-1,s,r,t,n),r}const l=c.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(f,l,m.startLineNumber,m.startColumn-1,s,r,t,n);for(let v=m.startLineNumber+1;v<m.endLineNumber&&s<n;v++)s=this._findMatchesInLine(f,c.getLineContent(v),v,0,s,r,t,n);if(s<n){const v=c.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(f,v,m.endLineNumber,0,s,r,t,n)}return r}static _findMatchesInLine(c,m,f,t,n,r,s,l){const v=c.wordSeparators;if(!s&&c.simpleSearch){const C=c.simpleSearch,a=C.length,F=m.length;let N=-a;for(;(N=m.indexOf(C,N+a))!==-1;)if((!v||w(v,m,F,N,a))&&(r[n++]=new k.FindMatch(new E.Range(f,N+1+t,f,N+1+a+t),null),n>=l))return n;return n}const b=new p(c.wordSeparators,c.regex);let A;b.reset(0);do if(A=b.next(m),A&&(r[n++]=P(new E.Range(f,A.index+1+t,f,A.index+1+A[0].length+t),A,s),n>=l))return n;while(A);return n}static findNextMatch(c,m,f,t){const n=m.parseSearchRequest();if(!n)return null;const r=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(c,f,r,t):this._doFindNextMatchLineByLine(c,f,r,t)}static _doFindNextMatchMultiline(c,m,f,t){const n=new D.Position(m.lineNumber,1),r=c.getOffsetAt(n),s=c.getLineCount(),l=c.getValueInRange(new E.Range(n.lineNumber,n.column,s,c.getLineMaxColumn(s)),1),v=c.getEOL()===`\r
`?new o(l):null;f.reset(m.column-1);let b=f.next(l);return b?P(this._getMultilineMatchRange(c,r,l,v,b.index,b[0]),b,t):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(c,new D.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(c,m,f,t){const n=c.getLineCount(),r=m.lineNumber,s=c.getLineContent(r),l=this._findFirstMatchInLine(f,s,r,m.column,t);if(l)return l;for(let v=1;v<=n;v++){const b=(r+v-1)%n,A=c.getLineContent(b+1),C=this._findFirstMatchInLine(f,A,b+1,1,t);if(C)return C}return null}static _findFirstMatchInLine(c,m,f,t,n){c.reset(t-1);const r=c.next(m);return r?P(new E.Range(f,r.index+1,f,r.index+1+r[0].length),r,n):null}static findPreviousMatch(c,m,f,t){const n=m.parseSearchRequest();if(!n)return null;const r=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(c,f,r,t):this._doFindPreviousMatchLineByLine(c,f,r,t)}static _doFindPreviousMatchMultiline(c,m,f,t){const n=this._doFindMatchesMultiline(c,new E.Range(1,1,m.lineNumber,m.column),f,t,10*y);if(n.length>0)return n[n.length-1];const r=c.getLineCount();return m.lineNumber!==r||m.column!==c.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(c,new D.Position(r,c.getLineMaxColumn(r)),f,t):null}static _doFindPreviousMatchLineByLine(c,m,f,t){const n=c.getLineCount(),r=m.lineNumber,s=c.getLineContent(r).substring(0,m.column-1),l=this._findLastMatchInLine(f,s,r,t);if(l)return l;for(let v=1;v<=n;v++){const b=(n+r-v-1)%n,A=c.getLineContent(b+1),C=this._findLastMatchInLine(f,A,b+1,t);if(C)return C}return null}static _findLastMatchInLine(c,m,f,t){let n=null,r;for(c.reset(0);r=c.next(m);)n=P(new E.Range(f,r.index+1,f,r.index+1+r[0].length),r,t);return n}}e.TextModelSearch=h;function d(S,c,m,f,t){if(f===0)return!0;const n=c.charCodeAt(f-1);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=c.charCodeAt(f);if(S.get(r)!==0)return!0}return!1}function u(S,c,m,f,t){if(f+t===m)return!0;const n=c.charCodeAt(f+t);if(S.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=c.charCodeAt(f+t-1);if(S.get(r)!==0)return!0}return!1}function w(S,c,m,f,t){return d(S,c,m,f,t)&&u(S,c,m,f,t)}e.isValidMatch=w;class p{constructor(c,m){this._wordSeparators=c,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const m=c.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(f=this._searchRegex.exec(c),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){g.getNextCodePoint(c,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||w(this._wordSeparators,c,m,t,n))return f}while(f);return null}}e.Searcher=p}),define(we[84],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(y=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)y.indexOf(I)>=0||(_+="\\"+I);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function T(y){let _=e.DEFAULT_WORD_REGEXP;if(y&&y instanceof RegExp)if(y.global)_=y;else{let I="g";y.ignoreCase&&(I+="i"),y.multiline&&(I+="m"),y.unicode&&(I+="u"),_=new RegExp(y.source,I)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const D={maxLen:1e3,windowSize:15,timeBudget:150};function E(y,_,I,i,P=D){if(I.length>P.maxLen){let w=y-P.maxLen/2;return w<0?w=0:i+=w,I=I.substring(w,y+P.maxLen/2),E(y,_,I,i,P)}const o=Date.now(),h=y-1-i;let d=-1,u=null;for(let w=1;!(Date.now()-o>=P.timeBudget);w++){const p=h-P.windowSize*w;_.lastIndex=Math.max(0,p);const S=k(_,I,h,d);if(!S&&u||(u=S,p<=0))break;d=p}if(u){let w={word:u[0],startColumn:i+1+u.index,endColumn:i+1+u.index+u[0].length};return _.lastIndex=0,w}return null}e.getWordAtText=E;function k(y,_,I,i){let P;for(;P=y.exec(_);){const o=P.index||0;if(o<=I&&y.lastIndex>=I)return P;if(i>0&&o>i)return null}return null}}),define(we[116],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class T{constructor(y){if(this.open=y.open,this.close=y.close,this._standardTokenMask=0,Array.isArray(y.notIn))for(let _=0,I=y.notIn.length;_<I;_++)switch(y.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(y){return(this._standardTokenMask&y)==0}}e.StandardAutoClosingPairConditional=T;class D{constructor(y){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of y)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=D;function E(k,y,_){k.has(y)?k.get(y).push(_):k.set(y,[_])}}),define(we[55],_e([0,1,27,13]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(E,k,y,_){if(Array.isArray(E)){let I=0;for(const i of E){const P=D(i,k,y,_);if(P===10)return P;P>I&&(I=P)}return I}else{if(typeof E=="string")return _?E==="*"?5:E===y?10:0:0;if(E){const{language:I,pattern:i,scheme:P,hasAccessToAllModels:o}=E;if(!_&&!o)return 0;let h=0;if(P)if(P===k.scheme)h=10;else if(P==="*")h=5;else return 0;if(I)if(I===y)h=10;else if(I==="*")h=Math.max(h,5);else return 0;if(i){let d;if(typeof i=="string"?d=i:d=Object.assign(Object.assign({},i),{base:T.normalize(i.base)}),d===k.fsPath||g.match(d,k.fsPath))h=10;else return 0}return h}else return 0}}e.score=D}),define(we[117],_e([0,1,82]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class D{constructor(d,u,w){const p=new Uint8Array(d*u);for(let S=0,c=d*u;S<c;S++)p[S]=w;this._data=p,this.rows=d,this.cols=u}get(d,u){return this._data[d*this.cols+u]}set(d,u,w){this._data[d*this.cols+u]=w}}e.Uint8Matrix=D;class E{constructor(d){let u=0,w=0;for(let S=0,c=d.length;S<c;S++){let[m,f,t]=d[S];f>u&&(u=f),m>w&&(w=m),t>w&&(w=t)}u++,w++;let p=new D(w,u,0);for(let S=0,c=d.length;S<c;S++){let[m,f,t]=d[S];p.set(m,f,t)}this._states=p,this._maxCharCode=u}nextState(d,u){return u<0||u>=this._maxCharCode?0:this._states.get(d,u)}}e.StateMachine=E;let k=null;function y(){return k===null&&(k=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let I=null;function i(){if(I===null){I=new g.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<h.length;u++)I.set(h.charCodeAt(u),1);const d=".,;";for(let u=0;u<d.length;u++)I.set(d.charCodeAt(u),2)}return I}class P{static _createLink(d,u,w,p,S){let c=S-1;do{const m=u.charCodeAt(c);if(d.get(m)!==2)break;c--}while(c>p);if(p>0){const m=u.charCodeAt(p-1),f=u.charCodeAt(c);(m===40&&f===41||m===91&&f===93||m===123&&f===125)&&c--}return{range:{startLineNumber:w,startColumn:p+1,endLineNumber:w,endColumn:c+2},url:u.substring(p,c+1)}}static computeLinks(d,u=y()){const w=i();let p=[];for(let S=1,c=d.getLineCount();S<=c;S++){const m=d.getLineContent(S),f=m.length;let t=0,n=0,r=0,s=1,l=!1,v=!1,b=!1,A=!1;for(;t<f;){let C=!1;const a=m.charCodeAt(t);if(s===13){let F;switch(a){case 40:l=!0,F=0;break;case 41:F=l?0:1;break;case 91:b=!0,v=!0,F=0;break;case 93:b=!1,F=v?0:1;break;case 123:A=!0,F=0;break;case 125:F=A?0:1;break;case 39:F=r===34||r===96?0:1;break;case 34:F=r===39||r===96?0:1;break;case 96:F=r===39||r===34?0:1;break;case 42:F=r===42?1:0;break;case 124:F=r===124?1:0;break;case 32:F=b?0:1;break;default:F=w.get(a)}F===1&&(p.push(P._createLink(w,m,S,n,t)),C=!0)}else if(s===12){let F;a===91?(v=!0,F=0):F=w.get(a),F===1?C=!0:s=13}else s=u.nextState(s,a),s===0&&(C=!0);C&&(s=1,l=!1,v=!1,A=!1,n=t+1,r=a),t++}s===13&&p.push(P._createLink(w,m,S,n,f))}return p}}e.LinkComputer=P;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:P.computeLinks(h)}e.computeLinks=o}),define(we[118],_e([0,1,3,7]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,y){return this._map.set(k,y),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===y&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,y){let _=null,I=!1;return this._promises.set(k,y.then(i=>{this._promises.delete(k),!(I||!i)&&(_=this.register(k,i))})),T.toDisposable(()=>{I=!0,_&&_.dispose()})}getPromise(k){const y=this.get(k);if(y)return Promise.resolve(y);const _=this._promises.get(k);return _?_.then(I=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(we[85],_e([0,1,23,21]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(D||(D={}));function E(P){for(let o=0,h=P.length;o<h;o+=4){const d=P[o+0],u=P[o+1],w=P[o+2],p=P[o+3];P[o+0]=p,P[o+1]=w,P[o+2]=u,P[o+3]=d}}function k(P){const o=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return T.isLittleEndian()||E(o),g.VSBuffer.wrap(o)}function y(P){const o=P.buffer;if(T.isLittleEndian()||E(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const h=new Uint8Array(o.byteLength);return h.set(o),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(P){const o=new Uint32Array(I(P));let h=0;if(o[h++]=P.id,P.type==="full")o[h++]=1,o[h++]=P.data.length,o.set(P.data,h),h+=P.data.length;else{o[h++]=2,o[h++]=P.deltas.length;for(const d of P.deltas)o[h++]=d.start,o[h++]=d.deleteCount,d.data?(o[h++]=d.data.length,o.set(d.data,h),h+=d.data.length):o[h++]=0}return k(o)}e.encodeSemanticTokensDto=_;function I(P){let o=0;if(o+=1+1,P.type==="full")o+=1+P.data.length;else{o+=1,o+=(1+1+1)*P.deltas.length;for(const h of P.deltas)h.data&&(o+=h.data.length)}return o}function i(P){const o=y(P);let h=0;const d=o[h++];if(o[h++]===1){const S=o[h++],c=o.subarray(h,h+S);return h+=S,{id:d,type:"full",data:c}}const w=o[h++];let p=[];for(let S=0;S<w;S++){const c=o[h++],m=o[h++],f=o[h++];let t;f>0&&(t=o.subarray(h,h+f),h+=f),p[S]={start:c,deleteCount:m,data:t}}return{id:d,type:"delta",deltas:p}}e.decodeSemanticTokensDto=i}),define(we[86],_e([0,1,79]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,y){this.index=k,this.remainder=y}}e.PrefixSumIndexOfResult=T;class D{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,y){k=g.toUint32(k);const _=this.values,I=this.prefixSum,i=y.length;return i===0?!1:(this.values=new Uint32Array(_.length+i),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+i),this.values.set(y,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,y){return k=g.toUint32(k),y=g.toUint32(y),this.values[k]===y?!1:(this.values[k]=y,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,y){k=g.toUint32(k),y=g.toUint32(y);const _=this.values,I=this.prefixSum;if(k>=_.length)return!1;let i=_.length-k;return y>=i&&(y=i),y===0?!1:(this.values=new Uint32Array(_.length-y),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+y),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(k){return k<0?0:(k=g.toUint32(k),this._getAccumulatedValue(k))}_getAccumulatedValue(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let y=this.prefixSumValidIndex[0]+1;y===0&&(this.prefixSum[0]=this.values[0],y++),k>=this.values.length&&(k=this.values.length-1);for(let _=y;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalValue();let y=0,_=this.values.length-1,I=0,i=0,P=0;for(;y<=_;)if(I=y+(_-y)/2|0,i=this.prefixSum[I],P=i-this.values[I],k<P)_=I-1;else if(k>=i)y=I+1;else break;return new T(I,k-P)}}e.PrefixSumComputer=D}),define(we[119],_e([0,1,8,35,86]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(y,_,I,i){this._uri=y,this._lines=_,this._eol=I,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const _=y.changes;for(const I of _)this._acceptDeleteRange(I.range),this._acceptInsertText(new T.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,_=this._lines.length,I=new Uint32Array(_);for(let i=0;i<_;i++)I[i]=this._lines[i].length+y;this._lineStarts=new D.PrefixSumComputer(I)}}_setLineText(y,_){this._lines[y]=_,this._lineStarts&&this._lineStarts.changeValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,_){if(_.length===0)return;let I=g.splitLines(_);if(I.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}I[I.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+I[0]);let i=new Uint32Array(I.length-1);for(let P=1;P<I.length;P++)this._lines.splice(y.lineNumber+P-1,0,I[P]),i[P-1]=I[P].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,i)}}e.MirrorTextModel=E}),define(we[120],_e([19,20]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(we[56],_e([0,1,120,10,16]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(I,i){return i&&(I.stack||I.stacktrace)?g.localize(0,null,y(I),k(I.stack)||k(I.stacktrace)):y(I)}function k(I){return Array.isArray(I)?I.join(`
`):I}function y(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?g.localize(1,null,I.message):I.message||g.localize(2,null)}function _(I=null,i=!1){if(!I)return g.localize(3,null);if(Array.isArray(I)){const P=D.coalesce(I),o=_(P[0],i);return P.length>1?g.localize(4,null,o,P.length):o}if(T.isString(I))return I;if(I.detail){const P=I.detail;if(P.error)return E(P.error,i);if(P.exception)return E(P.exception,i)}return I.stack?E(I,i):I.message?I.message:g.localize(5,null)}e.toErrorMessage=_}),define(we[121],_e([19,20]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(we[122],_e([0,1,121,21,84]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=k;class y{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,ve){this._values[te]=ve}}e.ValidatedEditorOptions=y;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class I{constructor(te,ve,Le,xe){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=xe}compute(te,ve,Le){return Le}}class i{constructor(te,ve=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(te){return this.defaultValue}}class P{constructor(te,ve,Le,xe){this.id=te,this.name=ve,this.defaultValue=Le,this.schema=xe}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,ve,Le){return Le}}function o(H,te){return typeof H=="undefined"?te:H==="false"?!1:Boolean(H)}e.boolean=o;class h extends P{constructor(te,ve,Le,xe=void 0){typeof xe!="undefined"&&(xe.type="boolean",xe.default=Le),super(te,ve,Le,xe)}validate(te){return o(te,this.defaultValue)}}class d extends P{constructor(te,ve,Le,xe,Be,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Le,Ye.minimum=xe,Ye.maximum=Be),super(te,ve,Le,Ye),this.minimum=xe,this.maximum=Be}static clampedInt(te,ve,Le,xe){if(typeof te=="undefined")return ve;let Be=parseInt(te,10);return isNaN(Be)?ve:(Be=Math.max(Le,Be),Be=Math.min(xe,Be),Be|0)}validate(te){return d.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class u extends P{constructor(te,ve,Le,xe,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Le),super(te,ve,Le,Be),this.validationFn=xe}static clamp(te,ve,Le){return te<ve?ve:te>Le?Le:te}static float(te,ve){if(typeof te=="number")return te;if(typeof te=="undefined")return ve;const Le=parseFloat(te);return isNaN(Le)?ve:Le}validate(te){return this.validationFn(u.float(te,this.defaultValue))}}class w extends P{static string(te,ve){return typeof te!="string"?ve:te}constructor(te,ve,Le,xe=void 0){typeof xe!="undefined"&&(xe.type="string",xe.default=Le),super(te,ve,Le,xe)}validate(te){return w.string(te,this.defaultValue)}}function p(H,te,ve){return typeof H!="string"||ve.indexOf(H)===-1?te:H}e.stringSet=p;class S extends P{constructor(te,ve,Le,xe,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=xe,Be.default=Le),super(te,ve,Le,Be),this._allowedValues=xe}validate(te){return p(te,this.defaultValue,this._allowedValues)}}class c extends I{constructor(te,ve,Le,xe,Be,Ye,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Be,Se.default=xe),super(te,ve,Le,Se),this._allowedValues=Be,this._convert=Ye}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function m(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,ve,Le){return Le===0?te.accessibilitySupport:Le}}class t extends I{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:g.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertSpace:o(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function l(H){switch(H){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=l;function v(H){switch(H){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class b extends i{constructor(){super(124,[62,31])}compute(te,ve,Le){const xe=["monaco-editor"];return ve.get(31)&&xe.push(ve.get(31)),te.extraEditorClassName&&xe.push(te.extraEditorClassName),ve.get(62)==="default"?xe.push("mouse-default"):ve.get(62)==="copy"&&xe.push("mouse-copy"),ve.get(97)&&xe.push("showUnused"),ve.get(122)&&xe.push("showDeprecated"),xe.join(" ")}}class A extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(te,ve,Le){return Le&&te.emptySelectionClipboard}}class C extends I{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:g.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:g.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{cursorMoveOnType:o(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":p(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ve.loop,this.defaultValue.loop)}}}class a extends I{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?a.OFF:te==="true"?a.ON:te:Boolean(te)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(te,ve,Le){return te.fontInfo}}class N extends P{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(te){let ve=u.float(te,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ve,6,100)}compute(te,ve,Le){return te.fontInfo.fontSize}}class W extends I{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(d.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ce extends I{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:g.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:g.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:g.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:g.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:g.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Le,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Le,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Le,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Le,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Le,description:g.localize(35,null)}})}validate(te){var ve,Le,xe,Be,Ye;if(!te||typeof te!="object")return this.defaultValue;const Se=te;return{multiple:p(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=Se.multipleDefinitions)!==null&&ve!==void 0?ve:p(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=Se.multipleTypeDefinitions)!==null&&Le!==void 0?Le:p(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(xe=Se.multipleDeclarations)!==null&&xe!==void 0?xe:p(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=Se.multipleImplementations)!==null&&Be!==void 0?Be:p(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=Se.multipleReferences)!==null&&Ye!==void 0?Ye:p(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class me extends I{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:g.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:o(ve.enabled,this.defaultValue.enabled),delay:d.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:o(ve.sticky,this.defaultValue.sticky)}}}var G;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class V extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(te,ve,Le){return V.computeLayout(ve,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const ve=te.height/te.lineHeight,Le=te.scrollBeyondLastLine?ve-1:0,xe=(te.viewLineCount+Le)/(te.pixelRatio*te.height),Be=Math.floor(te.viewLineCount/xe);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:xe,minimapLineCount:Be}}static _computeMinimapLayout(te,ve){const Le=te.outerWidth,xe=te.outerHeight,Be=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Ye=ve.stableMinimapLayoutInput,Se=Ye&&te.outerHeight===Ye.outerHeight&&te.lineHeight===Ye.lineHeight&&te.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ye.pixelRatio&&te.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&te.minimap.enabled===Ye.minimap.enabled&&te.minimap.side===Ye.minimap.side&&te.minimap.size===Ye.minimap.size&&te.minimap.showSlider===Ye.minimap.showSlider&&te.minimap.renderCharacters===Ye.minimap.renderCharacters&&te.minimap.maxColumn===Ye.minimap.maxColumn&&te.minimap.scale===Ye.minimap.scale&&te.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&te.isViewportWrapping===Ye.isViewportWrapping,ye=te.lineHeight,De=te.typicalHalfwidthCharacterWidth,ie=te.scrollBeyondLastLine,ue=te.minimap.renderCharacters;let O=Be>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const Y=te.minimap.maxColumn,ae=te.minimap.size,Ce=te.minimap.side,ke=te.verticalScrollbarWidth,Ne=te.viewLineCount,Oe=te.remainingWidth,qe=te.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Be*xe);const Je=tt/Be;let ot=!1,_t=!1,wt=rt*O,be=O/Be,de=1;if(ae==="fill"||ae==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:ut,desiredRatio:it,minimapLineCount:vt}=V.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:ie,height:xe,lineHeight:ye,pixelRatio:Be});if(Ne/vt>1)ot=!0,_t=!0,O=1,wt=1,be=O/Be;else{let lt=!1,mt=O+1;if(ae==="fit"){const Pt=Math.ceil((Ne+ut)*wt);qe&&Se&&Oe<=ve.stableFitRemainingWidth?(lt=!0,mt=ve.stableFitMaxMinimapScale):(lt=Pt>tt,qe&&lt?(ve.stableMinimapLayoutInput=te,ve.stableFitRemainingWidth=Oe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ae==="fill"||lt){ot=!0;const Pt=O;wt=Math.min(ye*Be,Math.max(1,Math.floor(1/it))),O=Math.min(mt,Math.max(1,Math.floor(wt/rt))),O>Pt&&(de=Math.min(2,O/Pt)),be=O/Be/de,tt=Math.ceil(Math.max(ft,Ne+ut)*wt),qe&&lt&&(ve.stableFitMaxMinimapScale=O)}}}const le=Math.floor(Y*be),q=Math.min(le,Math.max(0,Math.floor((Oe-ke-2)*be/(De+be)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Be*q);const Pe=Fe/Be;Fe=Math.floor(Fe*de);const Ze=ue?1:2,et=Ce==="left"?0:Le-q-ke;return{renderMinimap:Ze,minimapLeft:et,minimapWidth:q,minimapHeightIsEditorHeight:ot,minimapIsSampling:_t,minimapScale:O,minimapLineHeight:wt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Pe,minimapCanvasOuterHeight:Je}}static computeLayout(te,ve){const Le=ve.outerWidth|0,xe=ve.outerHeight|0,Be=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,Se=ve.typicalHalfwidthCharacterWidth,ye=ve.maxDigitWidth,De=ve.pixelRatio,ie=ve.viewLineCount,ue=te.get(119),O=ue==="inherit"?te.get(118):ue,Y=O==="inherit"?te.get(114):O,ae=te.get(117),Ce=te.get(2),ke=ve.isDominatedByLongLines,Ne=te.get(46),Oe=te.get(56).renderType!==0,qe=te.get(57),rt=te.get(91),tt=te.get(61),Je=te.get(89),ot=Je.verticalScrollbarSize,_t=Je.verticalHasArrows,wt=Je.arrowSize,be=Je.horizontalScrollbarSize,de=te.get(54),le=te.get(35);let q;if(typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)){const Rt=parseFloat(de.substr(0,de.length-2));q=d.clampedInt(Rt*Se,0,0,1e3)}else q=d.clampedInt(de,0,0,1e3);le&&(q+=16);let Fe=0;if(Oe){const Rt=Math.max(Ye,qe);Fe=Math.round(Rt*ye)}let Pe=0;Ne&&(Pe=Be);let Ze=0,et=Ze+Pe,ft=et+Fe,ut=ft+q;const it=Le-Pe-Fe-q;let vt=!1,ht=!1,lt=-1;Ce!==2&&(O==="inherit"&&ke?(vt=!0,ht=!0):Y==="on"||Y==="bounded"?ht=!0:Y==="wordWrapColumn"&&(lt=ae));const mt=V._computeMinimapLayout({outerWidth:Le,outerHeight:xe,lineHeight:Be,typicalHalfwidthCharacterWidth:Se,pixelRatio:De,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:ot,viewLineCount:ie,remainingWidth:it,isViewportWrapping:ht},ve.memory||new _);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ze+=mt.minimapWidth,et+=mt.minimapWidth,ft+=mt.minimapWidth,ut+=mt.minimapWidth);const Pt=it-mt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/Se)),At=_t?wt:0;return ht&&(lt=Math.max(1,Ct),Y==="bounded"&&(lt=Math.min(lt,ae))),{width:Le,height:xe,glyphMarginLeft:Ze,glyphMarginWidth:Pe,lineNumbersLeft:et,lineNumbersWidth:Fe,decorationsLeft:ft,decorationsWidth:q,contentLeft:ut,contentWidth:Pt,minimap:mt,viewportColumn:Ct,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:lt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:be,overviewRuler:{top:At,width:ot,height:xe-2*At,right:0}}}}e.EditorLayoutInfoComputer=V;class J extends I{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:g.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:o(te.enabled,this.defaultValue.enabled)}}}class R extends I{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,description:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:g.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:o(ve.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class B extends d{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:g.localize(43,null)})}compute(te,ve,Le){return te.fontInfo.lineHeight}}class M extends I{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:te.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:g.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:o(ve.enabled,this.defaultValue.enabled),size:p(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(ve.side,this.defaultValue.side,["right","left"]),showSlider:p(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ve.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(ve.scale,1,1,3),maxColumn:d.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends I{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{top:d.clampedInt(ve.top,0,0,1e3),bottom:d.clampedInt(ve.bottom,0,0,1e3)}}}class z extends I{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:g.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{enabled:o(ve.enabled,this.defaultValue.enabled),cycle:o(ve.cycle,this.defaultValue.cycle)}}}class oe extends i{constructor(){super(125)}compute(te,ve,Le){return te.pixelRatio}}class pe extends I{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:g.localize(58,null)},comments:{type:"boolean",default:te.comments,description:g.localize(59,null)},other:{type:"boolean",default:te.other,description:g.localize(60,null)}}}],default:te,description:g.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const ve=te,Le={other:o(ve.other,this.defaultValue.other),comments:o(ve.comments,this.defaultValue.comments),strings:o(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Te;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class $e extends I{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(te){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(ve=4,Le=te):te==="interval"?ve=3:te==="relative"?ve=2:te==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Me(H){const te=H.get(84);return te==="editable"?H.get(77):te!=="on"}e.filterValidationDecorations=Me;class ze extends I{constructor(){const te=[],ve={type:"number",description:g.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:te,description:g.localize(69,null)})}validate(te){if(Array.isArray(te)){let ve=[];for(let Le of te)if(typeof Le=="number")ve.push({column:d.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const xe=Le;ve.push({column:d.clampedInt(xe.column,0,0,1e4),color:xe.color})}return ve.sort((Le,xe)=>Le.column-xe.column),ve}return this.defaultValue}}function Qe(H,te){if(typeof H!="string")return te;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends I{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te,Le=d.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=d.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(ve.vertical,this.defaultValue.vertical),horizontal:Qe(ve.horizontal,this.defaultValue.horizontal),useShadows:o(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:d.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:d.clampedInt(ve.verticalSliderSize,xe,0,1e3),scrollByPage:o(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends I{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,ghostTextExpanded:!0,showInlineCompletions:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(70,null),g.localize(71,null)],default:te.insertMode,description:g.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:g.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:g.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:g.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:g.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:g.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:g.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:te.showSuggestionPreview,description:g.localize(79,null)},"editor.suggest.showInlineCompletions":{type:"boolean",default:te.showInlineCompletions,description:g.localize(80,null)},"editor.suggest.ghostTextExpanded":{type:"boolean",default:te.ghostTextExpanded,description:g.localize(81,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:g.localize(82,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(83,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(84,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(85,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(86,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(87,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(88,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(89,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(90,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(91,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(92,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(93,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(94,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(95,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(96,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(97,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(98,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(99,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(100,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(101,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(102,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const ve=te;return{insertMode:p(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(ve.showIcons,this.defaultValue.showIcons),showStatusBar:o(ve.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:o(ve.showSuggestionPreview,this.defaultValue.showSuggestionPreview),ghostTextExpanded:o(ve.ghostTextExpanded,this.defaultValue.ghostTextExpanded),showInlineCompletions:o(ve.showInlineCompletions,this.defaultValue.showInlineCompletions),showInlineDetails:o(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ve.showMethods,this.defaultValue.showMethods),showFunctions:o(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:o(ve.showFields,this.defaultValue.showFields),showVariables:o(ve.showVariables,this.defaultValue.showVariables),showClasses:o(ve.showClasses,this.defaultValue.showClasses),showStructs:o(ve.showStructs,this.defaultValue.showStructs),showInterfaces:o(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ve.showModules,this.defaultValue.showModules),showProperties:o(ve.showProperties,this.defaultValue.showProperties),showEvents:o(ve.showEvents,this.defaultValue.showEvents),showOperators:o(ve.showOperators,this.defaultValue.showOperators),showUnits:o(ve.showUnits,this.defaultValue.showUnits),showValues:o(ve.showValues,this.defaultValue.showValues),showConstants:o(ve.showConstants,this.defaultValue.showConstants),showEnums:o(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ve.showKeywords,this.defaultValue.showKeywords),showWords:o(ve.showWords,this.defaultValue.showWords),showColors:o(ve.showColors,this.defaultValue.showColors),showFiles:o(ve.showFiles,this.defaultValue.showFiles),showReferences:o(ve.showReferences,this.defaultValue.showReferences),showFolders:o(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ve.showSnippets,this.defaultValue.showSnippets),showUsers:o(ve.showUsers,this.defaultValue.showUsers),showIssues:o(ve.showIssues,this.defaultValue.showIssues)}}}class $ extends I{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(114,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Q extends i{constructor(){super(126,[77])}compute(te,ve,Le){return ve.get(77)?!0:te.tabFocusMode}}var ne;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(ne=e.WrappingIndent||(e.WrappingIndent={}));function re(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class K extends i{constructor(){super(128,[127])}compute(te,ve,Le){const xe=ve.get(127);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}const se="Consolas, 'Courier New', monospace",fe="Menlo, Monaco, 'Courier New', monospace",Ae="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?fe:T.isLinux?Ae:se,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ge(H){return e.editorOptionsRegistry[H.id]=H,H}var We;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.letterSpacing=52]="letterSpacing",H[H.lightbulb=53]="lightbulb",H[H.lineDecorationsWidth=54]="lineDecorationsWidth",H[H.lineHeight=55]="lineHeight",H[H.lineNumbers=56]="lineNumbers",H[H.lineNumbersMinChars=57]="lineNumbersMinChars",H[H.linkedEditing=58]="linkedEditing",H[H.links=59]="links",H[H.matchBrackets=60]="matchBrackets",H[H.minimap=61]="minimap",H[H.mouseStyle=62]="mouseStyle",H[H.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=64]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",H[H.multiCursorModifier=66]="multiCursorModifier",H[H.multiCursorPaste=67]="multiCursorPaste",H[H.occurrencesHighlight=68]="occurrencesHighlight",H[H.overviewRulerBorder=69]="overviewRulerBorder",H[H.overviewRulerLanes=70]="overviewRulerLanes",H[H.padding=71]="padding",H[H.parameterHints=72]="parameterHints",H[H.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",H[H.quickSuggestions=75]="quickSuggestions",H[H.quickSuggestionsDelay=76]="quickSuggestionsDelay",H[H.readOnly=77]="readOnly",H[H.renameOnType=78]="renameOnType",H[H.renderControlCharacters=79]="renderControlCharacters",H[H.renderIndentGuides=80]="renderIndentGuides",H[H.renderFinalNewline=81]="renderFinalNewline",H[H.renderLineHighlight=82]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=84]="renderValidationDecorations",H[H.renderWhitespace=85]="renderWhitespace",H[H.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",H[H.roundedSelection=87]="roundedSelection",H[H.rulers=88]="rulers",H[H.scrollbar=89]="scrollbar",H[H.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=91]="scrollBeyondLastLine",H[H.scrollPredominantAxis=92]="scrollPredominantAxis",H[H.selectionClipboard=93]="selectionClipboard",H[H.selectionHighlight=94]="selectionHighlight",H[H.selectOnLineNumbers=95]="selectOnLineNumbers",H[H.showFoldingControls=96]="showFoldingControls",H[H.showUnused=97]="showUnused",H[H.snippetSuggestions=98]="snippetSuggestions",H[H.smartSelect=99]="smartSelect",H[H.smoothScrolling=100]="smoothScrolling",H[H.stickyTabStops=101]="stickyTabStops",H[H.stopRenderingLineAfter=102]="stopRenderingLineAfter",H[H.suggest=103]="suggest",H[H.suggestFontSize=104]="suggestFontSize",H[H.suggestLineHeight=105]="suggestLineHeight",H[H.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",H[H.suggestSelection=107]="suggestSelection",H[H.tabCompletion=108]="tabCompletion",H[H.tabIndex=109]="tabIndex",H[H.unusualLineTerminators=110]="unusualLineTerminators",H[H.useShadowDOM=111]="useShadowDOM",H[H.useTabStops=112]="useTabStops",H[H.wordSeparators=113]="wordSeparators",H[H.wordWrap=114]="wordWrap",H[H.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=117]="wordWrapColumn",H[H.wordWrapOverride1=118]="wordWrapOverride1",H[H.wordWrapOverride2=119]="wordWrapOverride2",H[H.wrappingIndent=120]="wrappingIndent",H[H.wrappingStrategy=121]="wrappingStrategy",H[H.showDeprecated=122]="showDeprecated",H[H.inlayHints=123]="inlayHints",H[H.editorClassName=124]="editorClassName",H[H.pixelRatio=125]="pixelRatio",H[H.tabFocusMode=126]="tabFocusMode",H[H.layoutInfo=127]="layoutInfo",H[H.wrappingInfo=128]="wrappingInfo"})(We=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ge(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(115,null)})),acceptSuggestionOnEnter:ge(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(116,null),""],markdownDescription:g.localize(117,null)})),accessibilitySupport:ge(new f),accessibilityPageSize:ge(new d(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(118,null)})),ariaLabel:ge(new w(4,"ariaLabel",g.localize(119,null))),autoClosingBrackets:ge(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(120,null),g.localize(121,null),""],description:g.localize(122,null)})),autoClosingDelete:ge(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(123,null),""],description:g.localize(124,null)})),autoClosingOvertype:ge(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(125,null),""],description:g.localize(126,null)})),autoClosingQuotes:ge(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(127,null),g.localize(128,null),""],description:g.localize(129,null)})),autoIndent:ge(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[g.localize(130,null),g.localize(131,null),g.localize(132,null),g.localize(133,null),g.localize(134,null)],description:g.localize(135,null)})),automaticLayout:ge(new h(10,"automaticLayout",!1)),autoSurround:ge(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(136,null),g.localize(137,null),g.localize(138,null),""],description:g.localize(139,null)})),stickyTabStops:ge(new h(101,"stickyTabStops",!1,{description:g.localize(140,null)})),codeLens:ge(new h(12,"codeLens",!0,{description:g.localize(141,null)})),codeLensFontFamily:ge(new w(13,"codeLensFontFamily","",{description:g.localize(142,null)})),codeLensFontSize:ge(new d(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:g.localize(143,null)})),colorDecorators:ge(new h(15,"colorDecorators",!0,{description:g.localize(144,null)})),columnSelection:ge(new h(16,"columnSelection",!1,{description:g.localize(145,null)})),comments:ge(new t),contextmenu:ge(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ge(new h(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(146,null)})),cursorBlinking:ge(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:g.localize(147,null)})),cursorSmoothCaretAnimation:ge(new h(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(148,null)})),cursorStyle:ge(new c(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:g.localize(149,null)})),cursorSurroundingLines:ge(new d(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(150,null)})),cursorSurroundingLinesStyle:ge(new S(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(151,null),g.localize(152,null)],description:g.localize(153,null)})),cursorWidth:ge(new d(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(154,null)})),disableLayerHinting:ge(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ge(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:ge(new h(28,"domReadOnly",!1)),dragAndDrop:ge(new h(29,"dragAndDrop",!0,{description:g.localize(155,null)})),emptySelectionClipboard:ge(new A),extraEditorClassName:ge(new w(31,"extraEditorClassName","")),fastScrollSensitivity:ge(new u(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:g.localize(156,null)})),find:ge(new C),fixedOverflowWidgets:ge(new h(34,"fixedOverflowWidgets",!1)),folding:ge(new h(35,"folding",!0,{description:g.localize(157,null)})),foldingStrategy:ge(new S(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(158,null),g.localize(159,null)],description:g.localize(160,null)})),foldingHighlight:ge(new h(37,"foldingHighlight",!0,{description:g.localize(161,null)})),unfoldOnClickAfterEndOfLine:ge(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(162,null)})),fontFamily:ge(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(163,null)})),fontInfo:ge(new F),fontLigatures2:ge(new a),fontSize:ge(new N),fontWeight:ge(new W),formatOnPaste:ge(new h(44,"formatOnPaste",!1,{description:g.localize(164,null)})),formatOnType:ge(new h(45,"formatOnType",!1,{description:g.localize(165,null)})),glyphMargin:ge(new h(46,"glyphMargin",!0,{description:g.localize(166,null)})),gotoLocation:ge(new ce),hideCursorInOverviewRuler:ge(new h(48,"hideCursorInOverviewRuler",!1,{description:g.localize(167,null)})),highlightActiveIndentGuide:ge(new h(49,"highlightActiveIndentGuide",!0,{description:g.localize(168,null)})),hover:ge(new me),inDiffEditor:ge(new h(51,"inDiffEditor",!1)),letterSpacing:ge(new u(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>u.clamp(H,-5,20),{description:g.localize(169,null)})),lightbulb:ge(new J),lineDecorationsWidth:ge(new P(54,"lineDecorationsWidth",10)),lineHeight:ge(new B),lineNumbers:ge(new $e),lineNumbersMinChars:ge(new d(57,"lineNumbersMinChars",5,1,300)),linkedEditing:ge(new h(58,"linkedEditing",!1,{description:g.localize(170,null)})),links:ge(new h(59,"links",!0,{description:g.localize(171,null)})),matchBrackets:ge(new S(60,"matchBrackets","always",["always","near","never"],{description:g.localize(172,null)})),minimap:ge(new M),mouseStyle:ge(new S(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ge(new u(63,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:g.localize(173,null)})),mouseWheelZoom:ge(new h(64,"mouseWheelZoom",!1,{markdownDescription:g.localize(174,null)})),multiCursorMergeOverlapping:ge(new h(65,"multiCursorMergeOverlapping",!0,{description:g.localize(175,null)})),multiCursorModifier:ge(new c(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[g.localize(176,null),g.localize(177,null)],markdownDescription:g.localize(178,null)})),multiCursorPaste:ge(new S(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(179,null),g.localize(180,null)],markdownDescription:g.localize(181,null)})),occurrencesHighlight:ge(new h(68,"occurrencesHighlight",!0,{description:g.localize(182,null)})),overviewRulerBorder:ge(new h(69,"overviewRulerBorder",!0,{description:g.localize(183,null)})),overviewRulerLanes:ge(new d(70,"overviewRulerLanes",3,0,3)),padding:ge(new j),parameterHints:ge(new z),peekWidgetDefaultFocus:ge(new S(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),definitionLinkOpensInPeek:ge(new h(74,"definitionLinkOpensInPeek",!1,{description:g.localize(187,null)})),quickSuggestions:ge(new pe),quickSuggestionsDelay:ge(new d(76,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(188,null)})),readOnly:ge(new h(77,"readOnly",!1)),renameOnType:ge(new h(78,"renameOnType",!1,{description:g.localize(189,null),markdownDeprecationMessage:g.localize(190,null)})),renderControlCharacters:ge(new h(79,"renderControlCharacters",!1,{description:g.localize(191,null)})),renderIndentGuides:ge(new h(80,"renderIndentGuides",!0,{description:g.localize(192,null)})),renderFinalNewline:ge(new h(81,"renderFinalNewline",!0,{description:g.localize(193,null)})),renderLineHighlight:ge(new S(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(194,null)],description:g.localize(195,null)})),renderLineHighlightOnlyWhenFocus:ge(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(196,null)})),renderValidationDecorations:ge(new S(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ge(new S(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(197,null),g.localize(198,null),g.localize(199,null),""],description:g.localize(200,null)})),revealHorizontalRightPadding:ge(new d(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ge(new h(87,"roundedSelection",!0,{description:g.localize(201,null)})),rulers:ge(new ze),scrollbar:ge(new Ke),scrollBeyondLastColumn:ge(new d(90,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(202,null)})),scrollBeyondLastLine:ge(new h(91,"scrollBeyondLastLine",!0,{description:g.localize(203,null)})),scrollPredominantAxis:ge(new h(92,"scrollPredominantAxis",!0,{description:g.localize(204,null)})),selectionClipboard:ge(new h(93,"selectionClipboard",!0,{description:g.localize(205,null),included:T.isLinux})),selectionHighlight:ge(new h(94,"selectionHighlight",!0,{description:g.localize(206,null)})),selectOnLineNumbers:ge(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:ge(new S(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(207,null),g.localize(208,null)],description:g.localize(209,null)})),showUnused:ge(new h(97,"showUnused",!0,{description:g.localize(210,null)})),showDeprecated:ge(new h(122,"showDeprecated",!0,{description:g.localize(211,null)})),inlayHints:ge(new R),snippetSuggestions:ge(new S(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(212,null),g.localize(213,null),g.localize(214,null),g.localize(215,null)],description:g.localize(216,null)})),smartSelect:ge(new $),smoothScrolling:ge(new h(100,"smoothScrolling",!1,{description:g.localize(217,null)})),stopRenderingLineAfter:ge(new d(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ge(new Ge),suggestFontSize:ge(new d(104,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(218,null)})),suggestLineHeight:ge(new d(105,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(219,null)})),suggestOnTriggerCharacters:ge(new h(106,"suggestOnTriggerCharacters",!0,{description:g.localize(220,null)})),suggestSelection:ge(new S(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null)],description:g.localize(224,null)})),tabCompletion:ge(new S(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(225,null),g.localize(226,null),g.localize(227,null)],description:g.localize(228,null)})),tabIndex:ge(new d(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ge(new S(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(229,null),g.localize(230,null),g.localize(231,null)],description:g.localize(232,null)})),useShadowDOM:ge(new h(111,"useShadowDOM",!0)),useTabStops:ge(new h(112,"useTabStops",!0,{description:g.localize(233,null)})),wordSeparators:ge(new w(113,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(234,null)})),wordWrap:ge(new S(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(235,null),g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),wordWrapBreakAfterCharacters:ge(new w(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ge(new w(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ge(new d(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(240,null)})),wordWrapOverride1:ge(new S(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ge(new S(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ge(new c(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],re,{enumDescriptions:[g.localize(241,null),g.localize(242,null),g.localize(243,null),g.localize(244,null)],description:g.localize(245,null)})),wrappingStrategy:ge(new S(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(246,null),g.localize(247,null)],description:g.localize(248,null)})),editorClassName:ge(new b),pixelRatio:ge(new oe),tabFocusMode:ge(new Q),layoutInfo:ge(new V),wrappingInfo:ge(new K)}}),define(we[123],_e([19,20]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[124],_e([19,20]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[125],_e([19,20]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(we[126],_e([19,20]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(we[127],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[129],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(we[130],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[131],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[132],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[133],_e([19,20]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[134],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[135],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[136],_e([19,20]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[137],_e([19,20]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[138],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var g;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var T;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var D;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[139],_e([0,1,124]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=E;function k(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=o.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=k;function y(o){if(!o)return null;let h=o.majorBase,d=o.majorMustEqual,u=o.minorBase,w=o.minorMustEqual,p=o.patchBase,S=o.patchMustEqual;o.hasCaret&&(h===0||(w=!1),S=!1);let c=0;if(o.preRelease){const m=D.exec(o.preRelease);if(m){const[,f,t,n]=m;c=Date.UTC(Number(f),Number(t)-1,Number(n))}}return{majorBase:h,majorMustEqual:d,minorBase:u,minorMustEqual:w,patchBase:p,patchMustEqual:S,isMinimum:o.hasGreaterEquals,notBefore:c}}e.normalizeVersion=y;function _(o,h,d){let u;typeof o=="string"?u=y(k(o)):u=o;let w;h instanceof Date?w=h.getTime():typeof h=="string"&&(w=new Date(h).getTime());let p;if(typeof d=="string"?p=y(k(d)):p=d,!u||!p)return!1;let S=u.majorBase,c=u.minorBase,m=u.patchBase,f=p.majorBase,t=p.minorBase,n=p.patchBase,r=p.notBefore,s=p.majorMustEqual,l=p.minorMustEqual,v=p.patchMustEqual;return p.isMinimum?S>f?!0:S<f?!1:c>t?!0:c<t||w&&w<r?!1:m>=n:(S===1&&f===0&&(!s||!l||!v)&&(f=1,t=0,n=0,s=!0,l=!1,v=!1),S<f?!1:S>f?!s:c<t?!1:c>t?!l:m<n?!1:m>n?!v:!(w&&w<r))}e.isValidVersion=_;function I(o,h,d,u){return d.isBuiltin||typeof d.main=="undefined"?!0:P(o,h,d.engines.vscode,u)}e.isValidExtensionVersion=I;function i(o,h,d){return o==="*"||P(h,d,o)}e.isEngineValid=i;function P(o,h,d,u=[]){let w=y(k(d));if(!w)return u.push(g.localize(0,null,d)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return u.push(g.localize(1,null,d)),!1}else if(!w.majorMustEqual)return u.push(g.localize(2,null,d)),!1;return _(o,h,w)?!0:(u.push(g.localize(3,null,o,d)),!1)}}),define(we[87],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class g{constructor(E,k=[],y=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=g;const T=(D,...E)=>new g(D,E);e.createSyncDescriptor=T}),define(we[57],_e([0,1,87]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function D(k,y,_){y instanceof g.SyncDescriptor||(y=new g.SyncDescriptor(y,[],_)),T.push([k,y])}e.registerSingleton=D;function E(){return T}e.getSingletonServiceDescriptors=E}),define(we[140],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class T{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const y=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(k);y.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(E),y)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let y of this._nodes.values())y.outgoing.delete(k),y.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let y=this._nodes.get(k);return y||(y=new g(E),this._nodes.set(k,y)),y}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,y]of this._nodes)E.push(`${k}, (incoming)[${[...y.incoming.keys()].join(", ")}], (outgoing)[${[...y.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,k]of this._nodes){const y=new Set([E]),_=this._findCycle(k,y);if(_)return _}}_findCycle(E,k){for(let[y,_]of E.outgoing){if(k.has(y))return[...k,y].join(" -> ");k.add(y);const I=this._findCycle(_,k);if(I)return I;k.delete(y)}}}e.Graph=T}),define(we[5],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function _(I){return I[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(y,_,I,i){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:y,index:I,optional:i}):(_[g.DI_DEPENDENCIES]=[{id:y,index:I,optional:i}],_[g.DI_TARGET]=_)}function D(y){if(g.serviceIds.has(y))return g.serviceIds.get(y);const _=function(I,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(_,I,P,!1)};return _.toString=()=>y,g.serviceIds.set(y,_),_}e.createDecorator=D;function E(y){return y}e.refineServiceDecorator=E;function k(y){return function(_,I,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(y,_,i,!0)}}e.optional=k}),define(we[141],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=g.createDecorator("modelService");function T(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(we[142],_e([0,1,3,53,7,22,77,55,141]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(I):!!o.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(h,d){let u={selector:h,provider:d,_score:-1,_time:this._clock++};return this._entries.push(u),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),D.toDisposable(()=>{if(u){let w=this._entries.indexOf(u);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),u=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const d=[];for(let u of this._entries)u._score>0&&d.push(u.provider);return d}ordered(h){const d=[];return this._orderedForEach(h,u=>d.push(u.provider)),d}orderedGroups(h){const d=[];let u,w;return this._orderedForEach(h,p=>{u&&w===p._score?u.push(p.provider):(w=p._score,u=[p.provider],d.push(u))}),d}_orderedForEach(h,d){if(!!h){this._updateScores(h);for(const u of this._entries)u._score>0&&d(u)}}_updateScores(h){let d={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===d.language&&this._lastCandidate.uri===d.uri)){this._lastCandidate=d;for(let u of this._entries)if(u._score=y.score(u.selector,h.uri,h.getLanguageIdentifier().language,_.shouldSynchronizeModel(h)),I(u.selector)&&u._score>0){for(let w of this._entries)w._score=0;u._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(h,d){return h._score<d._score?1:h._score>d._score?-1:h._time<d._time?1:h._time>d._time?-1:0}}e.LanguageFeatureRegistry=i;class P{constructor(h,d,u=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=d,this.max=u,this._cache=new E.LRUCache(50,.7)}_key(h){return h.id+T.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const d=this._key(h),u=this._cache.get(d);return this._clamp(u==null?void 0:u.value)}update(h,d){const u=this._key(h);let w=this._cache.get(u);return w||(w=new k.MovingAverage,this._cache.set(u,w)),w.update(d),this.get(h)}}e.LanguageFeatureRequestDelays=P}),define(we[58],_e([0,1,2,31,142,118,78]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var y;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(y=e.LanguageId||(e.LanguageId={}));class _{constructor(F,N){this.language=F,this.id=N}}e.LanguageIdentifier=_;var I;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(I=e.FontStyle||(e.FontStyle={}));var i;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var P;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let N=this.getForeground(F),W="mtk"+N,ce=this.getFontStyle(F);return ce&1&&(W+=" mtki"),ce&2&&(W+=" mtkb"),ce&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(F,N){const W=this.getForeground(F),ce=this.getFontStyle(F);let me=`color: ${N[W]};`;return ce&1&&(me+="font-style: italic;"),ce&2&&(me+="font-weight: bold;"),ce&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=h;var d;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(F){const N=a[F];let W=N&&k.iconRegistry.get(N);return W||(console.info("No codicon found for CompletionItemKind "+F),W=k.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(F,N){let W=a[F];return typeof W=="undefined"&&!N&&(W=9),W}}();var u;(function(a){a[a.Deprecated=1]="Deprecated"})(u=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&g.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var n;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var r;(function(a){a[a.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(a){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function W(G){return F.get(G)}a.fromString=W;function ce(G){return N.get(G)}a.toString=ce;function me(G,V){const J=N.get(G);let R=J&&k.iconRegistry.get("symbol-"+J);return R||(console.info("No codicon found for SymbolKind "+G),R=k.Codicon.symbolProperty),`${V?"inline":"block"} ${R.classNames}`}a.toCssClassName=me})(s=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(F){this.value=F}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var v;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var b;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(b=e.CommentMode||(e.CommentMode={}));var A;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(A=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var C;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[88],_e([0,1,8,5,21]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",E.indexOf("Edg/")>=0),k.set("isFirefox",E.indexOf("Firefox")>=0),k.set("isChrome",E.indexOf("Chrome")>=0),k.set("isSafari",E.indexOf("Safari")>=0);const y=Object.prototype.hasOwnProperty;var _;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return P.INSTANCE}static true(){return o.INSTANCE}static has(a){return h.create(a)}static equals(a,F){return d.create(a,F)}static notEquals(a,F){return p.create(a,F)}static regex(a,F){return n.create(a,F)}static in(a,F){return u.create(a,F)}static not(a){return S.create(a)}static and(...a){return s.create(a)}static or(...a){return l.create(a)}static greater(a,F){return c.create(a,F)}static less(a,F){return f.create(a,F)}static deserialize(a,F=!1){if(!!a)return this._deserializeOrExpression(a,F)}static _deserializeOrExpression(a,F){let N=a.split("||");return l.create(N.map(W=>this._deserializeAndExpression(W,F)))}static _deserializeAndExpression(a,F){let N=a.split("&&");return s.create(N.map(W=>this._deserializeOne(W,F)))}static _deserializeOne(a,F){if(a=a.trim(),a.indexOf("!=")>=0){let N=a.split("!=");return p.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("==")>=0){let N=a.split("==");return d.create(N[0].trim(),this._deserializeValue(N[1],F))}if(a.indexOf("=~")>=0){let N=a.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(a.indexOf(" in ")>=0){let N=a.split(" in ");return u.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const N=a.split(">=");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const N=a.split(">");return c.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const N=a.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const N=a.split("<");return f.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(a)?S.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,F){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let N=/^'([^']*)'$/.exec(a);return N?N[1].trim():a}static _deserializeRegexValue(a,F){if(g.isFalsyOrWhitespace(a)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=a.indexOf("/"),W=a.lastIndexOf("/");if(N===W||N<0){if(F)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let ce=a.slice(N+1,W),me=a[W+1]==="i"?"i":"";try{return new RegExp(ce,me)}catch(G){if(F)throw new Error(`bad regexp-value '${a}', parse error: ${G}`);return console.warn(`bad regexp-value '${a}', parse error: ${G}`),null}}}e.ContextKeyExpr=I;function i(C,a){return C.cmp(a)}class P{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class h{constructor(a){this.key=a,this.type=2}static create(a){const F=k.get(a);return typeof F=="boolean"?F?o.INSTANCE:P.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:b(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return S.create(this.key)}}e.ContextKeyDefinedExpr=h;class d{constructor(a,F){this.key=a,this.value=F,this.type=4}static create(a,F){if(typeof F=="boolean")return F?h.create(a):S.create(a);const N=k.get(a);return typeof N=="boolean"?F===(N?"true":"false")?o.INSTANCE:P.INSTANCE:new d(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=d;class u{constructor(a,F){this.key=a,this.valueKey=F,this.type=10}static create(a,F){return new u(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const F=a.getValue(this.valueKey),N=a.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?y.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=u;class w{constructor(a){this._actual=a,this.type=11}static create(a){return new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new w(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class p{constructor(a,F){this.key=a,this.value=F,this.type=5}static create(a,F){if(typeof F=="boolean")return F?S.create(a):h.create(a);const N=k.get(a);return typeof N=="boolean"?F===(N?"true":"false")?P.INSTANCE:o.INSTANCE:new p(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class S{constructor(a){this.key=a,this.type=3}static create(a){const F=k.get(a);return typeof F=="boolean"?F?P.INSTANCE:o.INSTANCE:new S(a)}cmp(a){return a.type!==this.type?this.type-a.type:b(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=S;class c{constructor(a,F){this.key=a,this.value=F,this.type=12}static create(a,F){return new c(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class m{constructor(a,F){this.key=a,this.value=F,this.type=13}static create(a,F){return new m(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=m;class f{constructor(a,F){this.key=a,this.value=F,this.type=14}static create(a,F){return new f(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(a,F){this.key=a,this.value=F,this.type=15}static create(a,F){return new t(a,F)}cmp(a){return a.type!==this.type?this.type-a.type:A(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(a,F){this.key=a,this.regexp=F,this.type=7}static create(a,F){return new n(a,F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return F<N?-1:F>N?1:0}equals(a){if(a.type===this.type){const F=this.regexp?this.regexp.source:"",N=a.regexp?a.regexp.source:"";return this.key===a.key&&F===N}return!1}evaluate(a){let F=a.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(a){this._actual=a,this.type=8}static create(a){return new r(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new r(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(a){this.expr=a,this.type=6}static create(a){return s._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const W=i(this.expr[F],a.expr[F]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(a))return!1;return!0}static _normalizeArr(a){const F=[];let N=!1;for(const W of a)if(!!W){if(W.type===1){N=!0;continue}if(W.type===0)return P.INSTANCE;if(W.type===6){F.push(...W.expr);continue}F.push(W)}if(F.length===0&&N)return o.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const W=F[F.length-1];if(W.type!==9)break;F.pop();const ce=F.pop(),me=l.create(W.expr.map(G=>s.create([G,ce])));me&&(F.push(me),F.sort(i))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new s(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let F of this.expr)a.push(F.negate());return l.create(a)}}e.ContextKeyAndExpr=s;class l{constructor(a){this.expr=a,this.type=9}static create(a){const F=l._normalizeArr(a);if(F.length!==0)return F.length===1?F[0]:new l(F)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const W=i(this.expr[F],a.expr[F]);if(W!==0)return W}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(a.expr[F]))return!1;return!0}return!1}evaluate(a){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(a))return!0;return!1}static _normalizeArr(a){let F=[],N=!1;if(a){for(let W=0,ce=a.length;W<ce;W++){const me=a[W];if(!!me){if(me.type===0){N=!0;continue}if(me.type===1)return[o.INSTANCE];if(me.type===9){F=F.concat(me.expr);continue}F.push(me)}}if(F.length===0&&N)return[P.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let F of this.expr)a.push(...F.keys());return a}map(a){return new l(this.expr.map(F=>F.map(a)))}negate(){let a=[];for(let N of this.expr)a.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;a.length>1;){const N=a.shift(),W=a.shift(),ce=[];for(const me of F(N))for(const G of F(W))ce.push(I.and(me,G));a.unshift(I.or(...ce))}return a[0]}}e.ContextKeyOrExpr=l;class v extends h{constructor(a,F,N){super(a);this._defaultValue=F,typeof N=="object"?v._info.push(Object.assign(Object.assign({},N),{key:a})):N!==!0&&v._info.push({key:a,description:N,type:F!=null?typeof F:void 0})}static all(){return v._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return I.not(this.key)}isEqualTo(a){return I.equals(this.key,a)}notEqualsTo(a){return I.notEquals(this.key,a)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(C,a){return C<a?-1:C>a?1:0}function A(C,a,F,N){return C<F?-1:C>F?1:a<N?-1:a>N?1:0}}),define(we[26],_e([0,1,8,5]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=D;function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class y{constructor(P){this.value=P,this._lower=P.toLowerCase()}static equals(P,o){if(typeof P=="undefined"||P===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof P=="string"||typeof o=="string"){let h=typeof P=="string"?P:P.value,d=typeof o=="string"?o:o.value;return g.equalsIgnoreCase(h,d)}return P._lower===o._lower}static toKey(P){return typeof P=="string"?P.toLowerCase():P._lower}}e.ExtensionIdentifier=y;function _(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function I(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=I,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(we[143],_e([0,1,8,26]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,d){return h.uuid&&d.uuid?h.uuid===d.uuid:h.id===d.id?!0:g.compareIgnoreCase(h.id,d.id)===0}e.areSameExtensions=D;class E{constructor(d,u){this.version=u,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof E?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=E;function k(h,d){return`${h}.${d}`}e.getExtensionId=k;function y(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function _(h,d){return y(k(h,d))}e.getGalleryExtensionId=_;function I(h,d){const u=[],w=p=>{for(const S of u)if(S.some(c=>D(d(c),d(p))))return S;return null};for(const p of h){const S=w(p);S?S.push(p):u.push([p])}return u}e.groupByExtension=I;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(h){const d=new Set;for(const u of h)u.malicious&&d.add(u.id.id);return d}e.getMaliciousExtensionsSet=o}),define(we[59],_e([0,1,125,13,2,5,8,10,22]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=E.createDecorator("fileService");function I(V){return V.create===!0}e.isFileOpenForWriteOptions=I;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(V){V[V.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var o;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function d(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=d;function u(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function w(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=w;var p;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(J,R){super(J);this.code=R}}e.FileSystemProviderError=S;function c(V,J){const R=new S(V.toString(),J);return f(R,J),R}e.createFileSystemProviderError=c;function m(V){return V||c(g.localize(0,null),p.Unknown)}e.ensureFileSystemProviderError=m;function f(V,J){return V.name=J?`${J} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=f;function t(V){if(!V)return p.Unknown;if(V instanceof S)return V.code;const J=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!J)return p.Unknown;switch(J[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=t;function n(V){if(V instanceof A)return V.fileOperationResult;switch(t(V)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(J,R,B){this.resource=J,this.operation=R,this.target=B}isOperation(J){return this.operation===J}}e.FileOperationEvent=s;var l;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class v{constructor(J,R){this.ignorePathCasing=R,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=J;for(const B of J)switch(B.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(B.resource,B);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(B.resource,B);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(B.resource,B);break}}contains(J,...R){return this.doContains(J,{includeChildren:!1},...R)}affects(J,...R){return this.doContains(J,{includeChildren:!0},...R)}doContains(J,R,...B){var M,U,j,z,oe,pe;if(!J)return!1;const Te=B.length>0;return!!((!Te||B.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(J))||R.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(J)))||(!Te||B.includes(0))&&(((j=this.updated)===null||j===void 0?void 0:j.get(J))||R.includeChildren&&((z=this.updated)===null||z===void 0?void 0:z.findSuperstr(J)))||(!Te||B.includes(2))&&(((oe=this.deleted)===null||oe===void 0?void 0:oe.findSubstr(J))||R.includeChildren&&((pe=this.deleted)===null||pe===void 0?void 0:pe.findSuperstr(J))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(J){const R=[],B=J===1?this.added:J===0?this.updated:this.deleted;if(B)for(const[,M]of B)R.push(M);return R}filter(J){return new v(this.changes.filter(R=>J(R)),this.ignorePathCasing)}}e.FileChangesEvent=v;function b(V,J,R){return!V||!J||V===J||J.length>V.length?!1:(J.charAt(J.length-1)!==T.sep&&(J+=T.sep),R?k.startsWithIgnoreCase(V,J):V.indexOf(J)===0)}e.isParent=b;class A extends Error{constructor(J,R,B){super(J);this.fileOperationResult=R,this.options=B}}e.FileOperationError=A;class C extends A{constructor(J,R,B){super(J,2,B);this.stat=R}}e.NotModifiedSinceFileOperationError=C;var a;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=N;async function W(V,J){if(!J.canHandleResource(D.URI.from({scheme:V.scheme})))return new Promise(R=>{const B=J.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===V.scheme&&M.added&&(B.dispose(),R())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ce{static formatSize(J){return y.isNumber(J)||(J=0),J<ce.KB?g.localize(1,null,J.toFixed(0)):J<ce.MB?g.localize(2,null,(J/ce.KB).toFixed(2)):J<ce.GB?g.localize(3,null,(J/ce.MB).toFixed(2)):J<ce.TB?g.localize(4,null,(J/ce.GB).toFixed(2)):g.localize(5,null,(J/ce.TB).toFixed(2))}}e.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;var me;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function G(V){return{maxFileSize:V===0?300*ce.MB:16*ce.GB,maxHeapSize:V===0?700*ce.MB:2*700*ce.MB}}e.getPlatformLimits=G}),define(we[60],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[E,k]of D)this.set(E,k)}set(D,E){const k=this._entries.get(D);return this._entries.set(D,E),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(we[144],_e([0,1,12,140,87,5,60,11]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(d){var u;super("cyclic dependency between services");this.message=(u=d.findCycleSlow())!==null&&u!==void 0?u:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new k.ServiceCollection,u=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=u,this._parent=w,this._services.set(E.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...u){let w=o.traceInvocation(d),p=!1;try{return d({get:(c,m)=>{if(p)throw g.illegalState("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(c,w);if(!f&&m!==E.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return f}},...u)}finally{p=!0,w.stop()}}createInstance(d,...u){let w,p;return d instanceof D.SyncDescriptor?(w=o.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(u),w)):(w=o.traceCreation(d),p=this._createInstance(d,u,w)),w.stop(),p}_createInstance(d,u=[],w){let p=E._util.getServiceDependencies(d).sort((m,f)=>m.index-f.index),S=[];for(const m of p){let f=this._getOrCreateServiceInstance(m.id,w);if(!f&&this._strict&&!m.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${m.id}.`);S.push(f)}let c=p.length>0?p[0].index:u.length;if(u.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${u.length} static arguments`);let m=c-u.length;m>0?u=u.concat(new Array(m)):u=u.slice(0,c)}return new d(...[...u,...S])}_setServiceInstance(d,u){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,u);else if(this._parent)this._parent._setServiceInstance(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let u=this._services.get(d);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):u}_getOrCreateServiceInstance(d,u){let w=this._getServiceInstanceOrDescriptor(d);return w instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,u.branch(d,!0)):(u.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,u,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,u,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,u,w){const p=new T.Graph(m=>m.id.toString());let S=0;const c=[{id:d,desc:u,_trace:w}];for(;c.length;){const m=c.pop();if(p.lookupOrInsertNode(m),S++>1e3)throw new I(p);for(let f of E._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${d} depends on ${f.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const n={id:f.id,desc:t,_trace:m._trace.branch(f.id,!0)};p.insertEdge(m,n),c.push(n)}}}for(;;){const m=p.roots();if(m.length===0){if(!p.isEmpty())throw new I(p);break}for(const{data:f}of m){if(this._getServiceInstanceOrDescriptor(f.id)instanceof D.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}p.removeNode(f)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,u,w=[],p,S){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(u,w,p,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,u,w,p,S);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(d,u=[],w,p){if(w){const S=new y.IdleValue(()=>this._createInstance(d,u,p));return new Proxy(Object.create(null),{get(c,m){if(m in c)return c[m];let f=S.value,t=f[m];return typeof t!="function"||(t=t.bind(f),c[m]=t),t},set(c,m,f){return S.value[m]=f,!0}})}else return this._createInstance(d,u,p)}}e.InstantiationService=i;var P;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(P||(P={}));class o{constructor(d,u){this.type=d,this.name=u,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return _?new o(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(d){return _?new o(0,d.name):o._None}branch(d,u){let w=new o(2,d.toString());return this._dep.push([d,u,w]),w}stop(){let d=Date.now()-this._start;o._totals+=d;let u=!1;function w(S,c){let m=[],f=new Array(S+1).join("	");for(const[t,n,r]of c._dep)if(n&&r){u=!0,m.push(`${f}CREATES -> ${t}`);let s=w(S+1,r);s&&m.push(s)}else m.push(`${f}uses -> ${t}`);return m.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(d>2||u)&&console.log(p.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(we[17],_e([0,1,5,7,21,3,56]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=g.createDecorator("logService"),e.ILoggerService=g.createDecorator("loggerService");function y(){return new Date().toISOString()}var _;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class I extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class i extends I{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(_.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(_.Error,this.format(r))}else this.log(_.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let r=0;r<t.length;r++){let s=t[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(l){}n+=(r>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class P extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...n){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...n):console.log(`[main ${y()}]`,t,...n))}debug(t,...n){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...n):console.log(`[main ${y()}]`,t,...n))}info(t,...n){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${y()}][0m`,t,...n):console.log(`[main ${y()}]`,t,...n))}warn(t,...n){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${y()}][0m`,t,...n):console.warn(`[main ${y()}]`,t,...n))}error(t,...n){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${y()}][0m`,t,...n):console.error(`[main ${y()}]`,t,...n))}critical(t,...n){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${y()}][0m`,t,...n):console.error(`[main ${y()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class o extends I{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=o;class h extends I{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends I{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const r of this.logServices)r.trace(t,...n)}debug(t,...n){for(const r of this.logServices)r.debug(t,...n)}info(t,...n){for(const r of this.logServices)r.info(t,...n)}warn(t,...n){for(const r of this.logServices)r.warn(t,...n)}error(t,...n){for(const r of this.logServices)r.error(t,...n)}critical(t,...n){for(const r of this.logServices)r.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class u extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=u;class w extends T.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}createLogger(t,n){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(n==null?void 0:n.always)?_.Trace:this.logLevel,n),this.loggers.set(t.toString(),r),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class p{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=p;function S(f){if(f.verbose)return _.Trace;if(typeof f.logLevel=="string"){const t=c(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function c(f){switch(f){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=c;function m(f){switch(f){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=m}),define(we[89],_e([0,1,5,126,41]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(d,u){return u-d}_.compare=I;const i=Object.create(null);i[_.Error]=T.localize(0,null),i[_.Warning]=T.localize(1,null),i[_.Info]=T.localize(2,null);function P(d){return i[d]||""}_.toString=P;function o(d){switch(d){case D.default.Error:return _.Error;case D.default.Warning:return _.Warning;case D.default.Info:return _.Info;case D.default.Ignore:return _.Hint}}_.fromSeverity=o;function h(d){switch(d){case _.Error:return D.default.Error;case _.Warning:return D.default.Warning;case _.Info:return D.default.Info;case _.Hint:return D.default.Ignore}}_.toSeverity=h}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var y;(function(_){const I="";function i(o){return P(o,!0)}_.makeKey=i;function P(o,h){let d=[I];return o.source?d.push(o.source.replace("\xA6","\\\xA6")):d.push(I),o.code?typeof o.code=="string"?d.push(o.code.replace("\xA6","\\\xA6")):d.push(o.code.value.replace("\xA6","\\\xA6")):d.push(I),o.severity!==void 0&&o.severity!==null?d.push(k.toString(o.severity)):d.push(I),o.message&&h?d.push(o.message.replace("\xA6","\\\xA6")):d.push(I),o.startLineNumber!==void 0&&o.startLineNumber!==null?d.push(o.startLineNumber.toString()):d.push(I),o.startColumn!==void 0&&o.startColumn!==null?d.push(o.startColumn.toString()):d.push(I),o.endLineNumber!==void 0&&o.endLineNumber!==null?d.push(o.endLineNumber.toString()):d.push(I),o.endColumn!==void 0&&o.endColumn!==null?d.push(o.endColumn.toString()):d.push(I),d.push(I),d.join("\xA6")}_.makeKeyOptionalMessage=P})(y=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=g.createDecorator("markerService")}),define(we[145],_e([0,1,41,5,3]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=T.createDecorator("notificationService");var E;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class y{constructor(){this.progress=new _,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=y;class _{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=_}),define(we[146],_e([0,1,7,8,2,5]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=E.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(y){return{resolved:y,dispose(){}}}});function k(y,_){return D.URI.isUri(y)?T.equalsIgnoreCase(y.scheme,_):T.startsWithIgnoreCase(y,_+":")}e.matchesScheme=k});var Ve=this&&this.__decorate||function(Z,e,g,T){var D=arguments.length,E=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,g):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(Z,e,g,T);else for(var y=Z.length-1;y>=0;y--)(k=Z[y])&&(E=(D<3?k(E):D>3?k(e,g,E):k(e,g))||E);return D>3&&E&&Object.defineProperty(e,g,E),E},je=this&&this.__param||function(Z,e){return function(g,T){e(g,T,Z)}};define(we[147],_e([0,1,5,18,7,11]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=g.createDecorator("progressService");var k;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class y{constructor(P){this.callback=P}get value(){return this._value}report(P){this._value=P,this.callback(this._value)}}e.Progress=y,y.None=Object.freeze({report(){}});let _=class extends D.Disposable{constructor(P,o){super();this.deferred=new E.DeferredPromise,o.withProgress(P,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(D.toDisposable(()=>this.deferred.complete()))}report(P){this.reporter?this.reporter.report(P):this.lastStep=P}};_=Ve([je(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends D.Disposable{constructor(P){super();this.progressIndicator=P,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(P){this.stop();const o=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},P),this.currentOperationDisposables.add(D.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(D.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(D.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:h.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(P){this.currentOperationId===P&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=g.createDecorator("editorProgressService")}),define(we[43],_e([0,1,10,39]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,y){T.ok(g.isString(k)),T.ok(g.isObject(y)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,y)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(we[148],_e([0,1,43,3]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class E{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[D(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;g.Registry.add(e.Extensions.JSONContribution,k)}),define(we[61],_e([0,1,123,3,43,10,148]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=D.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,S=!0){this.registerConfigurations([p],S)}registerConfigurations(p,S=!0){const c=[];p.forEach(m=>{c.push(...this.validateAndRegisterProperties(m,S,m.extensionInfo)),this.configurationContributors.push(m),this.registerJSONConfiguration(m)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(p){const S=[],c=m=>{if(m.properties)for(const f in m.properties)S.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,m.properties[f]);m.allOf&&m.allOf.forEach(f=>c(f))};for(const m of p){c(m);const f=this.configurationContributors.indexOf(m);f!==-1&&this.configurationContributors.splice(f,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}registerDefaultConfigurations(p){const S=[],c=[];for(const m of p)for(const f in m)if(S.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),m[f]);const t={type:"object",default:this.defaultValues[f],description:g.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};c.push(P(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=m[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}deregisterDefaultConfigurations(p){const S=[];for(const c of p)for(const m in c)if(S.push(m),delete this.defaultValues[m],e.OVERRIDE_PROPERTY_PATTERN.test(m))delete this.configurationProperties[m],delete this.defaultLanguageConfigurationOverridesNode.properties[m];else{const f=this.configurationProperties[m];f&&(this.updatePropertyDefaultValue(m,f),this.updateSchema(m,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(S)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const S of p)this.overrideIdentifiers.add(S);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,S=!0,c,m=3){var f;m=E.isUndefinedOrNull(p.scope)?m:p.scope;let t=[],n=p.properties;if(n)for(let s in n){if(S&&d(s)){delete n[s];continue}const l=n[s];if(this.updatePropertyDefaultValue(s,l),e.OVERRIDE_PROPERTY_PATTERN.test(s)?l.scope=void 0:(l.scope=E.isUndefinedOrNull(l.scope)?m:l.scope,l.restricted=E.isUndefinedOrNull(l.restricted)?!!((f=c==null?void 0:c.restrictedConfigurations)===null||f===void 0?void 0:f.includes(s)):l.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let r=p.allOf;if(r)for(let s of r)t.push(...this.validateAndRegisterProperties(s,S,c,m));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const S=c=>{let m=c.properties;if(m)for(const t in m)this.updateSchema(t,m[t]);let f=c.allOf;f&&f.forEach(S)};S(p)}updateSchema(p,S){switch(e.allSettings.properties[p]=S,S.scope){case 1:e.applicationSettings.properties[p]=S;break;case 2:e.machineSettings.properties[p]=S;break;case 6:e.machineOverridableSettings.properties[p]=S;break;case 3:e.windowSettings.properties[p]=S;break;case 4:e.resourceSettings.properties[p]=S;break;case 5:e.resourceSettings.properties[p]=S,this.resourceLanguageSettingsSchema.properties[p]=S;break}}removeFromSchema(p,S){switch(delete e.allSettings.properties[p],S.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const S=`[${p}]`,c={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(S,c),e.allSettings.properties[S]=c,e.applicationSettings.properties[S]=c,e.machineSettings.properties[S]=c,e.machineOverridableSettings.properties[S]=c,e.windowSettings.properties[S]=c,e.resourceSettings.properties[S]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,S){let c=this.defaultValues[p];E.isUndefined(c)&&(c=S.default),E.isUndefined(c)&&(c=o(S.type)),S.default=c}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function P(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=P;function o(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const h=new I;D.Registry.add(e.Extensions.Configuration,h);function d(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?g.localize(5,null,w):h.getConfigurationProperties()[w]!==void 0?g.localize(6,null,w):null:g.localize(4,null)}e.validateProperty=d;function u(){const w=[],p=h.getConfigurationProperties();for(const S of Object.keys(p))w.push([S,p[S].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=u}),define(we[90],_e([0,1,24,10,2,43,5,61]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function _(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof D.URI)}e.isConfigurationOverrides=_;var I;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(n,r){const s=r?n?r.keys.filter(F=>n.keys.indexOf(F)===-1):[...r.keys]:[],l=n?r?n.keys.filter(F=>r.keys.indexOf(F)===-1):[...n.keys]:[],v=[];if(r&&n){for(const F of n.keys)if(r.keys.indexOf(F)!==-1){const N=p(n.contents,F),W=p(r.contents,F);g.equals(N,W)||v.push(F)}}const b=[],A=F=>{const N={};for(const W of F)for(const ce of W.identifiers)N[f(ce)]=W;return N},C=r?A(r.overrides):{},a=n?A(n.overrides):{};if(Object.keys(C).length)for(const F of s){const N=C[F];N&&b.push([y.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(a).length)for(const F of l){const N=a[F];N&&b.push([y.overrideIdentifierFromKey(F),N.keys])}if(Object.keys(C).length&&Object.keys(a).length)for(const F of v){const N=a[F],W=C[F];if(N&&W){const ce=P({contents:N.contents,keys:N.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});b.push([y.overrideIdentifierFromKey(F),[...ce.added,...ce.removed,...ce.updated]])}}return{added:s,removed:l,updated:v,overrides:b}}e.compare=P;function o(n,r){const s=[];for(const l of Object.keys(n))if(y.OVERRIDE_PROPERTY_PATTERN.test(l)){const v={};for(const b in n[l])v[b]=n[l][b];s.push({identifiers:[y.overrideIdentifierFromKey(l).trim()],keys:Object.keys(v),contents:h(v,r)})}return s}e.toOverrides=o;function h(n,r){const s=Object.create(null);for(let l in n)d(s,l,n[l],r);return s}e.toValuesTree=h;function d(n,r,s,l){const v=r.split("."),b=v.pop();let A=n;for(let C=0;C<v.length;C++){let a=v[C],F=A[a];switch(typeof F){case"undefined":F=A[a]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${v.slice(0,C+1).join(".")} is ${JSON.stringify(F)}`);return}A=F}if(typeof A=="object"&&A!==null)try{A[b]=s}catch(C){l(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(A)}`)}else l(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function u(n,r){const s=r.split(".");w(n,s)}e.removeFromValueTree=u;function w(n,r){const s=r.shift();if(r.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const l=n[s];typeof l=="object"&&!Array.isArray(l)&&(w(l,r),Object.keys(l).length===0&&delete n[s])}}function p(n,r,s){function l(A,C){let a=A;for(const F of C){if(typeof a!="object"||a===null)return;a=a[F]}return a}const v=r.split("."),b=l(n,v);return typeof b=="undefined"?s:b}e.getConfigurationValue=p;function S(n,r,s){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in n?T.isObject(n[l])&&T.isObject(r[l])?S(n[l],r[l],s):s&&(n[l]=r[l]):n[l]=r[l])})}e.merge=S;function c(){const n=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=c;function m(){const n=Object.create(null),r=E.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let s in r){let l=r[s].default;d(n,s,l,v=>console.error(`Conflict in default settings: ${v}`))}return n}e.getDefaultValues=m;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,r,s){const l=n.inspect(r),v=n.inspect(s);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:l.defaultValue}e.getMigratedSettingValue=t}),define(we[149],_e([0,1,105,22,16,10,24,2,61,90,43,7,3]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?I.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?I.getConfigurationValue(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[s],v=n[s];v&&(typeof l=="object"&&typeof v=="object"?(l=k.deepClone(l),this.mergeContents(l,v)):l=v),r[s]=l}return new h(r,this.keys,this.overrides)}merge(...t){const n=k.deepClone(this.contents),r=k.deepClone(this.overrides),s=[...this.keys];for(const l of t){this.mergeContents(n,l.contents);for(const v of l.overrides){const[b]=r.filter(A=>D.equals(A.identifiers,v.identifiers));b?this.mergeContents(b.contents,v.contents):r.push(k.deepClone(v))}for(const v of l.keys)s.indexOf(v)===-1&&s.push(v)}return new h(n,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&E.isObject(t[r])&&E.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=k.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),I.addToValueTree(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&I.removeFromValueTree(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class d extends h{constructor(){const t=I.getDefaultValues(),n=I.getConfigurationKeys(),r=[];for(const s of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[_.overrideIdentifierFromKey(s).trim()],keys:Object.keys(t[s]),contents:I.toValuesTree(t[s],l=>console.error(`Conflict in default settings file: ${l}`))});super(t,n,r)}}e.DefaultConfigurationModel=d;class u{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!E.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:s,overrides:l,restricted:v}=this.doParseRaw(t,n);this._configurationModel=new h(r,s,l),this._restrictedConfigurations=v||[]}doParseContent(t){let n={},r=null,s=[],l=[],v=[];function b(C){Array.isArray(s)?s.push(C):r&&(s[r]=C)}let A={onObjectBegin:()=>{let C={};b(C),l.push(s),s=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{let C=[];b(C),l.push(s),s=C,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:b,onError:(C,a,F)=>{v.push({error:C,offset:a,length:F})}};if(t)try{g.visit(t,A),n=s[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(t,n){const r=i.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,r,!0,n);t=s.raw;const l=I.toValuesTree(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),v=Object.keys(t),b=I.toOverrides(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:l,keys:v,overrides:b,restricted:s.restricted}}filter(t,n,r,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const l={},v=[];for(let b in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(b)&&r){const A=this.filter(t[b],n,!1,s);l[b]=A.raw,v.push(...A.restricted)}else{const A=n[b],C=A?typeof A.scope!="undefined"?A.scope:3:void 0;(A==null?void 0:A.restricted)&&v.push(b),(C===void 0||s.scopes===void 0||s.scopes.includes(C))&&(s.skipRestricted&&(A==null?void 0:A.restricted)||(l[b]=t[b]))}return{raw:l,restricted:v}}}e.ConfigurationModelParser=u;class w extends P.Disposable{constructor(t,n,r,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class p{constructor(t,n,r=new h,s=new h,l=new T.ResourceMap,v=new h,b=new T.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=b,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new h,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const s=this.getConsolidateConfigurationModel(n,r),l=this.getFolderConfigurationModelForResource(n.resource,r),v=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),C=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=l?n.overrideIdentifier?l.freeze().override(n.overrideIdentifier).getValue(t):l.freeze().getValue(t):void 0,W=n.overrideIdentifier?v.override(n.overrideIdentifier).getValue(t):v.getValue(t),ce=s.getValue(t),me=D.distinct(D.flatten(s.overrides.map(G=>G.identifiers))).filter(G=>s.getOverrideValue(t,G)!==void 0);return{defaultValue:b,userValue:A,userLocalValue:C,userRemoteValue:a,workspaceValue:F,workspaceFolderValue:N,memoryValue:W,value:ce,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l==null?void 0:l.freeze().getValue(t),override:n.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:v.getValue(t),override:n.overrideIdentifier?v.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:me.length?me:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(s=>_.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const l=_.overrideIdentifierFromKey(s),v=this._defaultConfiguration.getKeysForOverrideIdentifier(l),b=t.getKeysForOverrideIdentifier(l),A=[...b.filter(C=>v.indexOf(C)===-1),...v.filter(C=>b.indexOf(C)===-1),...v.filter(C=>!k.equals(this._defaultConfiguration.override(l).getValue(C),t.override(l).getValue(C)))];return[l,A]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:l}=I.compare(this.localUserConfiguration,t),v=[...n,...r,...s];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:l}=I.compare(this.remoteUserConfiguration,t);let v=[...n,...r,...s];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:s,overrides:l}=I.compare(this.workspaceConfiguration,t);let v=[...n,...r,...s];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:s,updated:l,removed:v,overrides:b}=I.compare(r,n);let A=[...s,...l,...v];return(A.length||!r)&&this.updateFolderConfiguration(t,n),{keys:A,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:s,removed:l,overrides:v}=I.compare(n,void 0);return{keys:[...r,...s,...l],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(t);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=r.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:s,keys:l}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),l=t.folders.reduce((v,b)=>(v.set(y.URI.revive(b[0]),this.parseConfigurationModel(b[1])),v),new T.ResourceMap);return new p(n,r,new h,s,l,new h,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function S(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const s of f)s.keys.forEach(l=>t.add(l)),s.overrides.forEach(([l,v])=>{const b=T.getOrSet(n,l,new Set);v.forEach(A=>b.add(A))});const r=[];return n.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=S;class c{constructor(t,n,r,s){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;t.keys.forEach(b=>l.add(b)),t.overrides.forEach(([,b])=>b.forEach(A=>l.add(A))),this.affectedKeys=[...l.values()];const v=new h;this.affectedKeys.forEach(b=>v.setValue(b,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,l=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!k.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=I.toValuesTree({[n]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(t=t[s],!t)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=c;class m extends c{constructor(t,n,r,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=m}),define(we[91],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=g.createDecorator("remoteAuthorityResolverService");var T;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,y=T.Unknown,_){super(k);this._message=k,this._code=y,this._detail=_,this.isHandled=y===T.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(we[150],_e([0,1,15]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function T(I){return I.scheme===g.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=T;function D(I){if(!I)return;const i=I.indexOf("+");return i<0?I:I.substr(0,i)}e.getRemoteName=D;function E(I){return I.scheme!==g.Schemas.file&&I.scheme!==g.Schemas.vscodeRemote}function k(I){if(I.folders.length)return I.folders.every(i=>E(i.uri))?I.folders[0].uri:void 0;if(I.configuration&&E(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=k;function y(I){var i;return(i=k(I))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=y;function _(I){return k(I)!==void 0}e.isVirtualWorkspace=_}),define(we[151],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,E,k=5){let y;return y=E(_=>{const I=typeof _=="string"?_:_.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(I);return}const P=setTimeout(()=>this.flushBuffer(D),k);i={data:[I],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(D),y.dispose()}},this._terminalBufferMap.set(D,i)}),y}stopBuffering(D){const E=this._terminalBufferMap.get(D);E&&E.dispose()}flushBuffer(D){const E=this._terminalBufferMap.get(D);E&&(this._terminalBufferMap.delete(D),this._callback(D,E.data.join("")))}}e.TerminalDataBufferer=g}),define(we[62],_e([0,1,2,25,5,22]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=D.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function y(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=y;function _(o){const h=o;return!!(h&&typeof h=="object"&&g.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(h,d,u,w){this._id=h,this._configuration=u,this._ignorePathCasing=w,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=I;class i{constructor(h,d){this.raw=d,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return T.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(o){return new i({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=P}),define(we[63],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const E=this._idPool++;return this._data.set(E,D),this.logDebugInfo(),E}get(D,E){return this._data.has(D)?this._data.get(D)[E]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(we[64],_e([0,1,2,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=D.createDecorator("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(we[44],_e([0,1,15,5]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,y){y===null?this._providerInfo.delete(k):this._providerInfo.set(k,y)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(we[28],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=g.createDecorator("IExtHostInitDataService")}),define(we[152],_e([0,1,11]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,y,_){this._deferredPromises=new Map,this._id=k,this._shared=y,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of I.values())i.complete()}catch(i){for(const P of I.values())P.error(i)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(k,y){let _=this._value[k];return typeof _=="undefined"&&(_=y),_}update(k,y){this._value[k]=y;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const I=new g.DeferredPromise;return this._deferredPromises.set(k,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class D extends T{constructor(k,y){super(k.identifier.value,!0,y);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=D}),define(we[14],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=g.createDecorator("IExtHostRpcService");class T{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=T});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[153],_e([0,1,26,3]),function(Z,e,g,T){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(y,_){D.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(y.identifier),nt(this,D,_,"f"),Ue(this,D,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(y){return Ue(this,D,"f").get(this._id,y)}store(y,_){return Ue(this,D,"f").store(this._id,y,_)}delete(y){return Ue(this,D,"f").delete(this._id,y)}}e.ExtensionSecrets=E,D=new WeakMap}),define(we[92],_e([0,1,5,3]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=g.createDecorator("IExtHostTelemetry")}),define(we[65],_e([0,1,3]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,E=k=>{let y=D.get(k);return y||(y={children:new Map,bus:new g.Emitter},D.set(k,y)),y};e.getPrivateApiFor=E}),define(we[66],_e([0,1,5,3,14]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(y){function _(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}y.fromApiTunnel=_;function I(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}y.fromServiceTunnel=I})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=g.createDecorator("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,I){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,I){return{dispose:()=>{}}}async $providePortAttributes(_,I,i,P,o){return[]}async $forwardPort(_,I){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([je(0,D.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)},Kt=this&&this.__rest||function(Z,e){var g={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(g[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Z);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[D])&&(g[T[D]]=Z[T[D]]);return g};define(we[6],_e([0,1,16,12,80,22,111,10,2,34,59,91,65]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o){"use strict";var h,d,u,w,p,S,c,m,f,t,n,r,s,l,v,b,A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(x){function L(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(L,x),Object.setPrototypeOf(L.prototype,x.prototype),L}let F=p=class{constructor(L){h.set(this,void 0),nt(this,h,L,"f")}static from(...L){let ee=L;return new p(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof Ue(this,h,"f")=="function"&&(Ue(this,h,"f").call(this),nt(this,h,void 0,"f"))}};h=new WeakMap,F=p=Ve([a],F),e.Disposable=F;let N=S=class{constructor(L,ee){if(L<0)throw T.illegalArgument("line must be non-negative");if(ee<0)throw T.illegalArgument("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isBefore(ee)&&(ee=He)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof S)return!0;let{line:ee,character:Ee}=L;return typeof ee=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw T.illegalArgument();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&ee===0?this:new S(this.line+Ee,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw T.illegalArgument();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),Ee===this.line&&ee===this.character?this:new S(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};N=S=Ve([a],N),e.Position=N;let W=c=class{constructor(L,ee,Ee,He){let Xe,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new N(L,ee),at=new N(Ee,He)):L instanceof N&&ee instanceof N&&(Xe=L,at=ee),!Xe||!at)throw new Error("Invalid arguments");Xe.isBefore(at)?(this._start=Xe,this._end=at):(this._start=at,this._end=Xe)}static isRange(L){return L instanceof c?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof c?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=N.Max(L.start,this._start),Ee=N.Min(L.end,this._end);if(!ee.isAfter(Ee))return new c(ee,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=N.Min(L.start,this._start),Ee=N.Max(L.end,this.end);return new c(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw T.illegalArgument();let Ee;return L?N.isPosition(L)?Ee=L:(Ee=L.start||this.start,ee=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new c(Ee,ee)}toJSON(){return[this.start,this.end]}};W=c=Ve([a],W),e.Range=W;let ce=m=class extends W{constructor(L,ee,Ee,He){let Xe,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new N(L,ee),at=new N(Ee,He)):L instanceof N&&ee instanceof N&&(Xe=L,at=ee),!Xe||!at)throw new Error("Invalid arguments");super(Xe,at);this._anchor=Xe,this._active=at}static isSelection(L){return L instanceof m?!0:L?W.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ce=m=Ve([a],ce),e.Selection=ce;class me{constructor(L,ee,Ee){if(typeof L!="string"||L.length===0)throw T.illegalArgument("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw T.illegalArgument("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw T.illegalArgument("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=me;class G extends Error{constructor(L,ee=P.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable(L,ee){return new G(L,P.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new G(L,P.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var V;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var J;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(J=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let R=f=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof f?!0:L?W.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new f(L,ee)}static insert(L,ee){return f.replace(new W(L,L),ee)}static delete(L){return f.replace(L,"")}static setEndOfLine(L){const ee=new f(new W(new N(0,0),new N(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!W.isRange(L))throw T.illegalArgument("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw T.illegalArgument("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw T.illegalArgument("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};R=f=Ve([a],R),e.TextEdit=R;var B;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellOutput=4]="CellOutput",x[x.CellReplace=5]="CellReplace",x[x.CellOutputItem=6]="CellOutputItem"})(B=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,Ee,He){this._edits.push({_type:1,from:L,to:ee,options:Ee,metadata:He})}createFile(L,ee,Ee){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:Ee})}deleteFile(L,ee,Ee){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(L,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,Ee,He,Xe){let at,dt,St=[],kt;if($t.isNotebookRange(ee)&&Re.isNotebookCellDataArray(Ee)&&!Re.isNotebookCellDataArray(He)?(at=ee.start,dt=ee.end,St=Ee,kt=He):typeof ee=="number"&&typeof Ee=="number"&&Re.isNotebookCellDataArray(He)&&(at=ee,dt=Ee,St=He,kt=Xe),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||St.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:St,metadata:kt})}replaceNotebookCellMetadata(L,ee,Ee,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ee,metadata:Ee}})}replace(L,ee,Ee,He){this._edits.push({_type:2,uri:L,edit:new R(ee,Ee),metadata:He})}insert(L,ee,Ee,He){this.replace(L,new W(ee,ee),Ee,He)}delete(L,ee,Ee){this.replace(L,ee,"",Ee)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const Ee of ee)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const He=this._edits[Ee];He._type===2&&He.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}g.coalesceInPlace(this._edits)}}get(L){const ee=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&ee.push(Ee.edit);return ee}entries(){const L=new E.ResourceMap;for(let ee of this._edits)if(ee._type===2){let Ee=L.get(ee.uri);Ee||(Ee=[ee.uri,[]],L.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=Ve([a],M),e.WorkspaceEdit=M;let U=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const Ee=new t;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=t._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const Ee=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const Ee=new t;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};U=t=Ve([a],U),e.SnippetString=U;var j;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var z;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(z=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let oe=n=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof W)this.range=ee;else if(ee instanceof N)this.range=new W(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof n?!0:L?W.isRange(L.range)&&_.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};oe=n=Ve([a],oe),e.Location=oe;let pe=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&W.isRange(L.location.range)&&_.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};pe=Ve([a],pe),e.DiagnosticRelatedInformation=pe;let Te=class{constructor(L,ee,Ee=z.Error){if(!W.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=Ee}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&g.equals(L.tags,ee.tags)&&g.equals(L.relatedInformation,ee.relatedInformation,pe.isEqual)}};Te=Ve([a],Te),e.Diagnostic=Te;let $e=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:D.isMarkdownString(L)?this.contents=[L]:this.contents=[L],this.range=ee}};$e=Ve([a],$e),e.Hover=$e;var Me;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ze=class{constructor(L,ee=Me.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Me[this.kind]}}};ze=Ve([a],ze),e.DocumentHighlight=ze;var Qe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(x){x[x.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let Ge=r=class{constructor(L,ee,Ee,He,Xe){this.name=L,this.kind=ee,this.containerName=Xe,typeof Ee=="string"&&(this.containerName=Ee),He instanceof oe?this.location=He:Ee instanceof W&&(this.location=new oe(He,Ee)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};Ge=r=Ve([a],Ge),e.SymbolInformation=Ge;let $=s=class{constructor(L,ee,Ee,He,Xe){this.name=L,this.detail=ee,this.kind=Ee,this.range=He,this.selectionRange=Xe,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};$=s=Ve([a],$),e.DocumentSymbol=$;var Q;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Q=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(L,ee){this.title=L,this.kind=ee}};ne=Ve([a],ne),e.CodeAction=ne;let re=l=class{constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.sep)}};re.sep=".",re=l=Ve([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let K=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=Ve([a],K),e.SelectionRange=K;class se{constructor(L,ee,Ee,He,Xe,at){this.kind=L,this.name=ee,this.detail=Ee,this.uri=He,this.range=Xe,this.selectionRange=at}}e.CallHierarchyItem=se;class fe{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=fe;class Ae{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=Ae;let ge=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};ge=Ve([a],ge),e.CodeLens=ge;let We=v=class{constructor(L,ee=!1){d.set(this,void 0),nt(this,d,new D.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof v?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,d,"f").value}set value(L){Ue(this,d,"f").value=L}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(L){Ue(this,d,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}appendText(L){return Ue(this,d,"f").appendText(L),this}appendMarkdown(L){return Ue(this,d,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Ue(this,d,"f").appendCodeblock(ee??"",L),this}};d=new WeakMap,We=v=Ve([a],We),e.MarkdownString=We;let H=class{constructor(L,ee){this.label=L,this.documentation=ee}};H=Ve([a],H),e.ParameterInformation=H;let te=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};te=Ve([a],te),e.SignatureInformation=te;let ve=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ve=Ve([a],ve),e.SignatureHelp=ve;var Le;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var xe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(xe=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(L,ee,Ee){this.text=L,this.position=ee,this.kind=Ee}};Be=Ve([a],Be),e.InlayHint=Be;var Ye;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(x){x[x.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=Ve([a],De),e.CompletionItem=De;let ie=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};ie=Ve([a],ie),e.CompletionList=ie;let ue=class{constructor(L,ee,Ee){this.text=L,this.range=ee,this.command=Ee}};ue=Ve([a],ue),e.InlineSuggestion=ue;let O=class{constructor(L){this.items=L}};O=Ve([a],O),e.InlineSuggestions=O;var Y;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Y=e.ViewColumn||(e.ViewColumn={}));var ae;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ce;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ke;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Oe;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function L(ee){switch(ee){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=L}(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(L,ee){if(ee&&!_.URI.isUri(ee))throw T.illegalArgument("target");if(!W.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.target=ee}};rt=Ve([a],rt),e.DocumentLink=rt;let tt=class{constructor(L,ee,Ee,He){this.red=L,this.green=ee,this.blue=Ee,this.alpha=He}};tt=Ve([a],tt),e.Color=tt;let Je=class{constructor(L,ee){if(ee&&!(ee instanceof tt))throw T.illegalArgument("color");if(!W.isRange(L)||L.isEmpty)throw T.illegalArgument("range");this.range=L,this.color=ee}};Je=Ve([a],Je),e.ColorInformation=Je;let ot=class{constructor(L){if(!L||typeof L!="string")throw T.illegalArgument("label");this.label=L}};ot=Ve([a],ot),e.ColorPresentation=ot;var _t;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var wt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var be;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(be=e.TaskRevealKind||(e.TaskRevealKind={}));var de;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(de=e.TaskPanelKind||(e.TaskPanelKind={}));let le=b=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw T.illegalArgument("name");this._id=L}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}get id(){return this._id}};le.Clean=new b("clean","Clean"),le.Build=new b("build","Build"),le.Rebuild=new b("rebuild","Rebuild"),le.Test=new b("test","Test"),le=b=Ve([a],le),e.TaskGroup=le;function q(x){let L="";for(let ee=0;ee<x.length;ee++)L+=x[ee].replace(/,/g,",,")+",";return L}let Fe=class{constructor(L,ee,Ee){if(typeof L!="string")throw T.illegalArgument("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw T.illegalArgument("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return q(L)}};Fe=Ve([a],Fe),e.ProcessExecution=Fe;let Pe=class{constructor(L,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!L)throw T.illegalArgument("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L,this._args=ee,this._options=Ee}else{if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw T.illegalArgument("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw T.illegalArgument("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return q(L)}};Pe=Ve([a],Pe),e.ShellExecution=Pe;var Ze;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(et=e.TaskScope||(e.TaskScope={}));class ft{constructor(L){this._callback=L}computeId(){return"customExecution"+I.generateUuid()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ft;let ut=A=class{constructor(L,ee,Ee,He,Xe,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=He,dt=Xe,this.__deprecated=!0):ee===et.Global||ee===et.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=Xe,dt=at):(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=Xe,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Fe?this._definition={type:A.ProcessType,id:this._execution.computeId()}:this._execution instanceof Pe?this._definition={type:A.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:A.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:A.EmptyType,id:I.generateUuid()}}get definition(){return this._definition}set definition(L){if(L==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw T.illegalArgument("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(A.EmptyType===ee||A.ProcessType===ee||A.ShellType===ee||A.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=A=Ve([a],ut),e.Task=ut;var it;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(L,ee=ht.None){this.collapsibleState=ee,_.URI.isUri(L)?this.resourceUri=L:this.label=L}};vt=Ve([a],vt),e.TreeItem=vt;var ht;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let lt=class{constructor(L,ee){this.id=L,this.color=ee}};lt=Ve([a],lt),e.ThemeIcon=lt,lt.File=new lt("file"),lt.Folder=new lt("folder");let mt=class{constructor(L){this.id=L}};mt=Ve([a],mt),e.ThemeColor=mt;var Pt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(L,ee){if(typeof L!="string"&&(!L||!_.URI.isUri(L)&&!_.URI.isUri(L.uri)))throw T.illegalArgument("base");if(typeof ee!="string")throw T.illegalArgument("pattern");typeof L=="string"?(this.baseFolder=_.URI.file(L),this.base=L):_.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};Ct=Ve([a],Ct),e.RelativePattern=Ct;let At=class{constructor(L,ee,Ee,He){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=I.generateUuid()),this._id}};At=Ve([a],At),e.Breakpoint=At;let Rt=class extends At{constructor(L,ee,Ee,He,Xe){super(ee,Ee,He,Xe);if(L===null)throw T.illegalArgument("location");this.location=L}};Rt=Ve([a],Rt),e.SourceBreakpoint=Rt;let yt=class extends At{constructor(L,ee,Ee,He,Xe){super(ee,Ee,He,Xe);this.functionName=L}};yt=Ve([a],yt),e.FunctionBreakpoint=yt;let Gt=class extends At{constructor(L,ee,Ee,He,Xe,at,dt){super(He,Xe,at,dt);if(!ee)throw T.illegalArgument("dataId");this.label=L,this.dataId=ee,this.canPersist=Ee}};Gt=Ve([a],Gt),e.DataBreakpoint=Gt;let Qt=class{constructor(L,ee,Ee){this.command=L,this.args=ee||[],this.options=Ee}};Qt=Ve([a],Qt),e.DebugAdapterExecutable=Qt;let pt=class{constructor(L,ee){this.port=L,this.host=ee}};pt=Ve([a],pt),e.DebugAdapterServer=pt;let Yt=class{constructor(L){this.path=L}};Yt=Ve([a],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(L){this.implementation=L}};Jt=Ve([a],Jt),e.DebugAdapterInlineImplementation=Jt;let Dt=class{constructor(L,ee){this.range=L,this.expression=ee}};Dt=Ve([a],Dt),e.EvaluatableExpression=Dt;var cn;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Xt=class{constructor(L,ee){this.range=L,this.text=ee}};Xt=Ve([a],Xt),e.InlineValueText=Xt;let xt=class{constructor(L,ee,Ee=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=Ee}};xt=Ve([a],xt),e.InlineValueVariableLookup=xt;let ct=class{constructor(L,ee){this.range=L,this.expression=ee}};ct=Ve([a],ct),e.InlineValueEvaluatableExpression=ct;let Zt=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};Zt=Ve([a],Zt),e.InlineValueContext=Zt;var Mt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Lt=C=class extends Error{constructor(L,ee=i.FileSystemProviderErrorCode.Unknown,Ee){var He;super(_.URI.isUri(L)?L.toString(!0):L);this.code=(He=Ee==null?void 0:Ee.name)!==null&&He!==void 0?He:"Unknown",i.markAsFileSystemProviderError(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new C(L,i.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,i.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,i.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,i.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,i.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,i.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Lt=C=Ve([a],Lt),e.FileSystemError=Lt;let Vt=class{constructor(L,ee,Ee){this.start=L,this.end=ee,this.kind=Ee}};Vt=Ve([a],Vt),e.FoldingRange=Vt;var bn;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var wn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(wn=e.CommentMode||(e.CommentMode={}));class hn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=hn;function Bt(x){return typeof x=="undefined"||y.isStringArray(x)}class en{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,Ee=L.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,Ee=L.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,Ee,He,Xe){if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(L,ee,Ee,He,Xe);if(W.isRange(L)&&typeof ee=="string"&&Bt(Ee))return this._push(L,ee,Ee);throw T.illegalArgument()}_push(L,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Xe=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(ee);let St=0;if(Ee)for(const kt of Ee){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);St|=1<<Tt>>>0}this._pushEncoded(He,Xe,at,dt,St)}_pushEncoded(L,ee,Ee,He,Xe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,Tt=0;for(let Ft=0;Ft<St;Ft++){let Ot=this._data[5*Ft],ln=this._data[5*Ft+1];Ot===0?(Ot=kt,ln+=Tt):Ot+=kt,this._data[5*Ft]=Ot,this._data[5*Ft+1]=ln,kt=Ot,Tt=ln}}let at=L,dt=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Xe,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const Ee=L.length/5|0;for(let dt=0;dt<Ee;dt++)ee[dt]=dt;ee.sort((dt,St)=>{const kt=L[5*dt],Tt=L[5*St];if(kt===Tt){const Ft=L[5*dt+1],Ot=L[5*St+1];return Ft-Ot}return kt-Tt});const He=new Uint32Array(L.length);let Xe=0,at=0;for(let dt=0;dt<Ee;dt++){const St=5*ee[dt],kt=L[St+0],Tt=L[St+1],Ft=L[St+2],Ot=L[St+3],ln=L[St+4],Mn=kt-Xe,$n=Mn===0?Tt-at:Tt,un=5*dt;He[un+0]=Mn,He[un+1]=$n,He[un+2]=Ft,He[un+3]=Ot,He[un+4]=ln,Xe=kt,at=Tt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(en._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=en;class Ht{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=Ht;class tn{constructor(L,ee,Ee){this.start=L,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=tn;class _n{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=_n;var En;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(En=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Nt;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Nt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new lt("arrow-left")},jt=Ve([a],jt),e.QuickInputButtons=jt;var yn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Sn{constructor(L,ee,Ee){this.badge=L,this.tooltip=ee,this.color=Ee}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Sn;let nn=class{constructor(L){this.kind=L}};nn=Ve([a],nn),e.ColorTheme=nn;var rn;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(rn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(L,ee){if(L<0)throw T.illegalArgument("start must be positive");if(ee<0)throw T.illegalArgument("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof $t?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,Ee=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(Ee=L.end),ee===this._start&&Ee===this._end?this:new $t(ee,Ee)}}e.NotebookRange=$t;class qt{constructor(L,ee){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=ee)}with(L){let{inputCollapsed:ee,outputCollapsed:Ee}=L,He=Kt(L,["inputCollapsed","outputCollapsed"]);return ee===void 0?ee=this.inputCollapsed:ee===null&&(ee=void 0),Ee===void 0?Ee=this.outputCollapsed:Ee===null&&(Ee=void 0),ee===this.inputCollapsed&&Ee===this.outputCollapsed&&Object.keys(He).length===0?this:new qt(Object.assign({inputCollapsed:ee,outputCollapsed:Ee},He))}}e.NotebookCellMetadata=qt;class Wt{constructor(L={}){Object.assign(this,L)}with(L){return new Wt(L)}}e.NotebookDocumentMetadata=Wt;class Re{constructor(L,ee,Ee,He,Xe,at){this.kind=L,this.value=ee,this.languageId=Ee,this.outputs=He??[],this.metadata=Xe,this.executionSummary=at,Re.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Re.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Re;class sn{constructor(L,ee){this.cells=L,this.metadata=ee??new Wt}}e.NotebookData=sn;class It{constructor(L,ee,Ee){this.data=L,this.mime=ee,this.metadata=Ee;const He=k.normalizeMimeType(ee,!0);if(!He)throw new Error("INVALID mime type, must not be empty or falsy: "+ee);this.mime=He}static isNotebookCellOutputItem(L){return L instanceof It?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L,ee){const Ee={name:L.name,message:L.message,stack:L.stack};return It.json(Ee,"application/vnd.code.notebook.error",ee)}static stdout(L,ee){return It.text(L,"application/vnd.code.notebook.stdout",ee)}static stderr(L,ee){return It.text(L,"application/vnd.code.notebook.stderr",ee)}static bytes(L,ee="application/octet-stream",Ee){return new It(L,ee,Ee)}static text(L,ee="text/plain",Ee){const He=Ue(It,u,"f",w).encode(String(L));return new It(He,ee,Ee)}static json(L,ee="application/json",Ee){const He=JSON.stringify(L,void 0,"	");return It.text(He,ee,Ee)}}e.NotebookCellOutputItem=It,u=It,w={value:new TextEncoder};class gt{constructor(L,ee,Ee){this.items=gt.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=I.generateUuid(),this.metadata=ee??Ee)}static isNotebookCellOutput(L){return L instanceof gt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&y.isArray(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const Ee=new Set,He=new Set;for(let Xe=0;Xe<L.length;Xe++){const at=L[Xe],dt=k.normalizeMimeType(at.mime);if(!Ee.has(dt)){Ee.add(dt);continue}He.add(Xe),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return He.size===0?L:L.filter((Xe,at)=>!He.has(at))}get outputs(){return this.items}set outputs(L){this.items=L}}e.NotebookCellOutput=gt;var Dn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Cn;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Cn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var fn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(fn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class on{constructor(L,ee,Ee,He,Xe,at){this.text=L,this.alignment=ee,this.command=Ee,this.tooltip=He,this.priority=Xe,this.accessibilityInformation=at}}e.NotebookCellStatusBarItem=on;var kn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(kn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class In{constructor(L,ee=[]){this.uri=L,this.provides=g.asArray(ee)}}e.NotebookRendererScript=In;let an=class{constructor(L,ee){this.label=L,this.timestamp=ee}};an=Ve([a],an),e.TimelineItem=an;var gn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(gn=e.ExtensionMode||(e.ExtensionMode={}));var Pn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Pn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var An;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(An=e.StandardTokenType||(e.StandardTokenType={}));class Tn{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=Tn;class Rn{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Rn;var pn;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(pn=e.TestResultState||(e.TestResultState={}));var X;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(X=e.TestMessageSeverity||(e.TestMessageSeverity={}));var he;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(he=e.TestItemStatus||(e.TestItemStatus={}));const Ie=(x,L,ee,Ee)=>{let He=ee;return{enumerable:!0,configurable:!1,get(){return He},set(Xe){Ee(He,Xe)||(He=Xe,x.bus.fire([3,L,Xe]))}}},st=(x,L)=>x===L,bt=(x,L)=>x===L?!0:!x||!L?!1:x.isEqual(L);class Et{constructor(L,ee,Ee,He){this.label=ee,this.data=He;const Xe=o.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Xe.parent},children:{value:new E.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:Ie(Xe,"range",void 0,bt),description:Ie(Xe,"description",void 0,st),runnable:Ie(Xe,"runnable",!0,st),debuggable:Ie(Xe,"debuggable",!1,st),status:Ie(Xe,"status",he.Resolved,st),error:Ie(Xe,"error",void 0,st)})}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){const L=o.getPrivateApiFor(this);L.parent&&o.getPrivateApiFor(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof Et))throw new Error("Test child must be created through vscode.test.createTestItem()");const ee=o.getPrivateApiFor(this);if(ee.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);ee.children.set(L.id,L),ee.bus.fire([0,L])}}e.TestItemImpl=Et;class Fn{constructor(L){this.message=L,this.severity=X.Error}static diff(L,ee,Ee){const He=new Fn(L);return He.expectedOutput=ee,He.actualOutput=Ee,He}}e.TestMessage=Fn;var Un;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var xn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(xn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Bn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore"})(Bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[93],_e([0,1,39,15,8,119,84,6,16]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function i(d,u){u?I.set(d,u):I.delete(d)}e.setWordDefinitionFor=i;function P(d){return I.get(d)}e.getWordDefinitionFor=P;class o extends E.MirrorTextModel{constructor(u,w,p,S,c,m,f,t){super(w,p,S,c);this._proxy=u,this._languageId=m,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){g.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(u){return _.equals(this._lines,u)}get document(){if(!this._document){const u=this;this._document={get uri(){return u._uri},get fileName(){return u._uri.fsPath},get isUntitled(){return u._uri.scheme===T.Schemas.untitled},get languageId(){return u._languageId},get version(){return u._versionId},get isClosed(){return u._isDisposed},get isDirty(){return u._isDirty},get notebook(){return u._notebook},save(){return u._save()},getText(w){return w?u._getTextInRange(w):u.getText()},get eol(){return u._eol===`
`?y.EndOfLine.LF:y.EndOfLine.CRLF},get lineCount(){return u._lines.length},lineAt(w){return u._lineAt(w)},offsetAt(w){return u._offsetAt(w)},positionAt(w){return u._positionAt(w)},validateRange(w){return u._validateRange(w)},validatePosition(w){return u._validatePosition(w)},getWordRangeAtPosition(w,p){return u._getWordRangeAtPosition(w,p)}}}return Object.freeze(this._document)}_acceptLanguageId(u){g.ok(!this._isDisposed),this._languageId=u}_acceptIsDirty(u){g.ok(!this._isDisposed),this._isDirty=u}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(u){const w=this._validateRange(u);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const p=this._eol,S=w.start.line,c=w.end.line,m=[];m.push(this._lines[S].substring(w.start.character));for(let f=S+1;f<c;f++)m.push(this._lines[f]);return m.push(this._lines[c].substring(0,w.end.character)),m.join(p)}_lineAt(u){let w;if(u instanceof y.Position?w=u.line:typeof u=="number"&&(w=u),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new h(w,this._lines[w],w===this._lines.length-1)}_offsetAt(u){return u=this._validatePosition(u),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(u.line-1)+u.character}_positionAt(u){u=Math.floor(u),u=Math.max(0,u),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(u),p=this._lines[w.index].length;return new y.Position(w.index,Math.min(w.remainder,p))}_validateRange(u){if(!(u instanceof y.Range))throw new Error("Invalid argument");const w=this._validatePosition(u.start),p=this._validatePosition(u.end);return w===u.start&&p===u.end?u:new y.Range(w.line,w.character,p.line,p.character)}_validatePosition(u){if(!(u instanceof y.Position))throw new Error("Invalid argument");if(this._lines.length===0)return u.with(0,0);let{line:w,character:p}=u,S=!1;if(w<0)w=0,p=0,S=!0;else if(w>=this._lines.length)w=this._lines.length-1,p=this._lines[w].length,S=!0;else{const c=this._lines[w].length;p<0?(p=0,S=!0):p>c&&(p=c,S=!0)}return S?new y.Position(w,p):u}_getWordRangeAtPosition(u,w){const p=this._validatePosition(u);if(!w)w=P(this._languageId);else if(D.regExpLeadsToEndlessLoop(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const S=k.getWordAtText(p.character+1,k.ensureValidWordDefinition(w),this._lines[p.line],0);if(S)return new y.Range(p.line,S.startColumn-1,p.line,S.endColumn-1)}}e.ExtHostDocumentData=o;class h{constructor(u,w,p){this._line=u,this._text=w,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new y.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new y.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[154],_e([0,1,6,3,86,7,55,22,2,34]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(o,h,d,u){this._notebook=d,this._selector=u,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:I.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(p=>{const S=this._cellUris.get(p.document.uri);S!==void 0&&(this._cellLengths.changeValue(S,this._cells[S].document.getText().length+1),this._cellLines.changeValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=p=>{p===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(p=>w(p.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new y.ResourceMap;const o=[],h=[];for(const d of this._notebook.getCells())d.kind===g.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,d.document.uri,d.document.languageId,!0))&&(this._cellUris.set(d.document.uri,this._cells.length),this._cells.push(d),o.push(d.document.getText().length+1),h.push(d.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(o){var h,d;if(!o){let c="";for(const m of this._cells)c+=m.document.getText()+`
`;return c=c.slice(0,-1),c}if(o.isEmpty)return"";const u=this.locationAt(o.start),w=this.locationAt(o.end),p=this._cells[(h=this._cellUris.get(u.uri))!==null&&h!==void 0?h:-1],S=this._cells[(d=this._cellUris.get(w.uri))!==null&&d!==void 0?d:-1];if(!p||!S)return"";if(p===S)return p.document.getText(new g.Range(u.range.start,w.range.end));{const c=p.document.getText(new g.Range(u.range.start,new g.Position(p.document.lineCount,0))),m=S.document.getText(new g.Range(new g.Position(0,0),w.range.end));return c+`
`+m}}offsetAt(o){const h=this._cellLines.getIndexOf(o.line),d=this._cellLengths.getAccumulatedValue(h.index-1),u=this._cells[h.index].document.offsetAt(o.with(h.remainder));return d+u}positionAt(o){if(typeof o=="number"){const d=this._cellLengths.getIndexOf(o),u=this._cellLines.getAccumulatedValue(d.index-1);return this._cells[d.index].document.positionAt(d.remainder).translate(u)}const h=this._cellUris.get(o.uri);if(h!==void 0){const d=this._cellLines.getAccumulatedValue(h-1);return new g.Position(d+o.range.start.line,o.range.start.character)}return new g.Position(0,0)}locationAt(o){g.Range.isRange(o)||(o=new g.Range(o,o));const h=this._cellLines.getIndexOf(o.start.line);let d=h;o.isEmpty||(d=this._cellLines.getIndexOf(o.end.line));const u=new g.Position(h.remainder,o.start.character),w=new g.Position(d.remainder,o.end.character),p=new g.Range(u,w),S=this._cells[h.index];return new g.Location(S.document.uri,S.document.validateRange(p))}contains(o){return this._cellUris.has(o)}validateRange(o){const h=this.validatePosition(o.start),d=this.validatePosition(o.end);return o.with(h,d)}validatePosition(o){const h=this._cellLines.getIndexOf(o.line),d=new g.Position(h.remainder,o.character),u=this._cells[h.index].document.validatePosition(d),w=this._cellLines.getAccumulatedValue(h.index-1);return new g.Position(w+u.line,u.character)}}e.ExtHostNotebookConcatDocument=i}),define(we[155],_e([0,1,6,14,3]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(y){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(y){let _=y==="light"?g.ColorThemeKind.Light:y==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=Ve([je(0,T.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(we[67],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=g.createDecorator("IURITransformerService");class T{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(we[156],_e([0,1,23]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function D(y,_){if(_.serializeBuffersForPostMessage){const I=new T,i=(h,d)=>{if(d instanceof ArrayBuffer){const u=I.add(d);return{$$vscode_array_buffer_reference$$:!0,index:u}}else if(ArrayBuffer.isView(d)){const u=E(d);if(u){const w=I.add(d.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:u,byteLength:d.byteLength,byteOffset:d.byteOffset}}}}return d},P=JSON.stringify(y,i),o=I.buffers.map(h=>{const d=new Uint8Array(h);return g.VSBuffer.wrap(d)});return{message:P,buffers:o}}else return{message:JSON.stringify(y),buffers:[]}}e.serializeWebviewMessage=D;function E(y){switch(y.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(y,_){const I=_.map(o=>{const h=new ArrayBuffer(o.byteLength);return new Uint8Array(h).set(o.buffer),h}),i=_.length?(o,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const d=h,{index:u}=d,w=I[u];if(d.view)switch(d.view.type){case 1:return new Int8Array(w,d.view.byteOffset,d.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,d.view.byteOffset,d.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,d.view.byteOffset,d.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,d.view.byteOffset,d.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,d.view.byteOffset,d.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,d.view.byteOffset,d.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,d.view.byteOffset,d.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,d.view.byteOffset,d.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,d.view.byteOffset,d.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,d.view.byteOffset,d.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,d.view.byteOffset,d.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return h}:void 0;return{message:JSON.parse(y,i),arrayBuffers:I}}e.deserializeWebviewMessage=k}),define(we[68],_e([0,1,15,2]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(E,k){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(k&&k.authority&&k.isRemote&&E.scheme===g.Schemas.file&&(E=T.URI.from({scheme:g.Schemas.vscodeRemote,authority:k.authority,path:E.path})),T.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=D}),define(we[157],_e([0,1,3,7,68]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(y,_,I){this._proxy=y,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const i=_.getVisibleTextEditors();for(const P of this._insets.values())i.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,_,I,i,P){let o;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){o=c;break}if(!o)throw new Error("not a visible editor");const h=this,d=this._handlePool++,u=new g.Emitter,w=new g.Emitter,p=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return D.asWebviewUri(c,h._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(c){this._options=c,h._proxy.$setOptions(d,c)}get options(){return this._options}set html(c){this._html=c,h._proxy.$setHtml(d,c)}get html(){return this._html}get onDidReceiveMessage(){return u.event}postMessage(c){return h._proxy.$postMessage(d,c)}},S=new class{constructor(){this.editor=y,this.line=_,this.height=I,this.webview=p,this.onDidDispose=w.event}dispose(){h._insets.has(d)&&(h._insets.delete(d),h._proxy.$disposeEditorInset(d),w.fire(),w.dispose(),u.dispose())}};return this._proxy.$createEditorInset(d,o.id,o.value.document.uri,_+1,I,i||{},P.identifier,P.extensionLocation),this._insets.set(d,{editor:y,inset:S,onDidReceiveMessage:u}),S}$onDidDispose(y){const _=this._insets.get(y);_&&_.inset.dispose()}$onDidReceiveMessage(y,_){const I=this._insets.get(y);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(we[158],_e([0,1,3,11,134]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(y){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=y}onEvent(y){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=y}onRequest(y){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=y}sendResponse(y){y.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${y.command}`)):this.internalSend("response",y)}sendRequest(y,_,I,i){const P={command:y};if(_&&Object.keys(_).length>0&&(P.arguments=_),this.internalSend("request",P),typeof i=="number"){const o=setTimeout(()=>{clearTimeout(o);const h=this.pendingRequests.get(P.seq);if(h){this.pendingRequests.delete(P.seq);const d={type:"response",seq:0,request_seq:P.seq,success:!1,command:y,message:D.localize(0,null,i,y)};h(d)}},i)}return I&&this.pendingRequests.set(P.seq,I),P.seq}acceptMessage(y){this.messageCallback?this.messageCallback(y):(this.queue.push(y),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(y,_){return y.type!=="event"||_.type!=="event"}async processQueue(){let y;for(;this.queue.length;){if((!y||this.needsTaskBoundaryBetween(this.queue[0],y))&&await T.timeout(0),y=this.queue.shift(),!y)return;switch(y.type){case"event":this.eventCallback&&this.eventCallback(y);break;case"request":this.requestCallback&&this.requestCallback(y);break;case"response":const _=y,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}internalSend(y,_){_.type=y,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const y=new Map;this.pendingRequests.forEach((_,I)=>y.set(I,_)),await T.timeout(500),y.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(we[159],_e([0,1,8,2,13,24,15]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const y=/{([^}]+)}/g;function _(n,r,s){return n.replace(y,function(l,v){return r&&v.length>0&&v[0]!=="_"?l:s&&s.hasOwnProperty(v)?s[v]:l})}e.formatPII=_;function I(n){const r={};for(const s of Object.keys(n))s.startsWith("!")||(r[s]=n[s]);return r}e.filterExceptionsFromTelemetry=I;function i(n){return n.configuration.request==="attach"&&!P(n)}e.isSessionAttach=i;function P(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),g.equalsIgnoreCase(r,"extensionhost")||g.equalsIgnoreCase(r,"pwa-extensionhost")?n:n.parentSession?P(n.parentSession):void 0}e.getExtensionHostDebugSession=P;function o(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=o;function h(n,r,s){let l,v=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=b.exec(n);){let C=A.index+1,a=C+A[0].length;if(C<=r&&a>=s){l=A[0],v=C;break}}if(l){let C=/\w+/g,a=null;for(;(a=C.exec(l))&&!(a.index+1+v+a[0].length>=s););a&&(l=l.substring(0,C.lastIndex))}return l?{start:v,end:v+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(n){return!!(n&&n.match(d))}e.isUri=u;function w(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(u(n.path))return T.URI.parse(n.path);if(D.isAbsolute(n.path))return T.URI.file(n.path)}return n.path}function p(n){if(typeof n.path=="object"){const r=T.URI.revive(n.path);if(r)return r.scheme===k.Schemas.file?r.fsPath:r.toString()}return n.path}function S(n,r){const s=r?w:p,l=E.deepClone(n);return m(l,(v,b)=>{v&&b&&(b.path=s(b))}),l}e.convertToDAPaths=S;function c(n,r){const s=r?w:p,l=E.deepClone(n);return m(l,(v,b)=>{!v&&b&&(b.path=s(b))}),l}e.convertToVSCPaths=c;function m(n,r){switch(n.type){case"event":const s=n;switch(s.event){case"output":r(!1,s.body.source);break;case"loadedSource":r(!1,s.body.source);break;case"breakpoint":r(!1,s.body.breakpoint.source);break;default:break}break;case"request":const l=n;switch(l.command){case"setBreakpoints":r(!0,l.arguments.source);break;case"breakpointLocations":r(!0,l.arguments.source);break;case"source":r(!0,l.arguments.source);break;case"gotoTargets":r(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const v=n;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":v.body.sources.forEach(b=>r(!1,b));break;case"scopes":v.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":v.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function f(n){return n.filter(r=>{var s;return!((s=r.presentation)===null||s===void 0?void 0:s.hidden)}).sort((r,s)=>r.presentation?s.presentation?r.presentation.group?s.presentation.group?r.presentation.group!==s.presentation.group?r.presentation.group.localeCompare(s.presentation.group):t(r.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(r.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}}),define(we[45],_e([0,1,27,15,13,21,88]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var _;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(_=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var I;(function(C){C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var P;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.Unknown=100]="Unknown"})(P=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var o;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(o=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));function d(C,a){if(a)return C.toString();const F=u.parse(C);return F?F.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=d;var u;(function(C){C.scheme=T.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function F(G,V){return G.with({scheme:C.scheme,fragment:`ch${V.toString().padStart(7,"0")}${G.scheme!==T.Schemas.file?G.scheme:""}`})}C.generate=F;function N(G){if(G.scheme!==C.scheme)return;const V=a.exec(G.fragment);return V?{handle:Number(V[1]),notebook:G.with({scheme:G.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}C.parse=N;function W(G){if(G.scheme!==T.Schemas.vscodeNotebookCellMetadata)return;const V=a.exec(G.fragment);return V?{handle:Number(V[1]),notebook:G.with({scheme:G.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}C.parseCellMetadataUri=W;function ce(G,V,J){return G.with({scheme:J,fragment:`ch${V.toString().padStart(7,"0")}${G.scheme!==T.Schemas.file?G.scheme:""}`})}C.generateCellUri=ce;function me(G,V){if(G.scheme!==V)return;const J=a.exec(G.fragment);return J?{handle:Number(J[1]),notebook:G.with({scheme:G.fragment.substr(J[0].length)||T.Schemas.file,fragment:null})}:void 0}C.parseCellUri=me})(u=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(C){var a,F;return(F=(a=w.get(C))===null||a===void 0?void 0:a.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=p;function S(C){var a,F;return(F=(a=w.get(C))===null||a===void 0?void 0:a.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=S;function c(C){var a,F;return(F=(a=w.get(C))===null||a===void 0?void 0:a.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=c;function m(C,a){return E.isWindows&&(C=C.replace(/\//g,"\\"),a=a.replace(/\//g,"\\")),g.match(C,a)}function f(C,a,F){let N=0;for(let W=0;W<a.length;W++){if(m(a[W],C))return N;N++}for(let W=0;W<F.length;W++){if(m(F[W],C))return N;N++}return N}function t(C,a,F){return C.sort((N,W)=>f(N,a,F)-f(W,a,F))}e.sortMimeTypes=t;function n(C,a,F,N=(W,ce)=>W===ce){const W=[];function ce(V,J,R){if(J===0&&R.length===0)return;const B=W[W.length-1];B&&B.start+B.deleteCount===V?(B.deleteCount+=J,B.toInsert.push(...R)):W.push({start:V,deleteCount:J,toInsert:R})}let me=0,G=0;for(;;){if(me===C.length){ce(me,0,a.slice(G));break}if(G===a.length){ce(me,C.length-me,[]);break}const V=C[me],J=a[G];if(N(V,J)){me+=1,G+=1;continue}F(J)?(ce(me,1,[]),me+=1):(ce(me,0,[J]),G+=1)}return W}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(C){C.default="default",C.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(C){const a=C;return!!((typeof a.include=="string"||g.isRelativePattern(a.include))&&(typeof a.exclude=="string"||g.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=s;function l(C,a,F){if(Array.isArray(C.viewType)&&C.viewType.indexOf(a)>=0||C.viewType===a)return!0;if(C.filenamePattern){let N=s(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,W=s(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(g.match(N,D.basename(F.fsPath).toLowerCase()))return!(W&&g.match(W,D.basename(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class v{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)a[F]=this.textModel.cells[F].getHashValue();return a}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var b;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(a){return`${A._prefix}${a}`}static parse(a){if(a.startsWith(A._prefix))return a.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(we[160],_e([0,1,136,5,88]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[161],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function T(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=T}),define(we[94],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var g;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(_,I)=>{I.expand!==void 0&&(_.expand=I.expand),I.item!==void 0&&(_.item=_.item?Object.assign(_.item,I.item):I.item)};e.applyTestItemUpdate=T;var D;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const E=(_,I)=>`${_}:${I.toString()}`;e.getTestSubscriptionKey=E;class k{add(I){}update(I){}remove(I,i){}complete(){}}e.IncrementalChangeCollector=k;class y{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(I){const i=this.createChangeCollector();for(const P of I)switch(P[0]){case 0:{const o=P[1];if(o.parent){if(this.items.has(o.parent)){const h=this.items.get(o.parent);h.children.add(o.item.extId);const d=this.createItem(o,h);this.items.set(o.item.extId,d),i.add(d)}}else{this.roots.add(o.item.extId);const h=this.createItem(o);this.items.set(o.item.extId,h),i.add(h)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=P[1],h=this.items.get(o.extId);if(!h)break;o.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,o),i.update(h);break}case 2:{const o=this.items.get(P[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o.item.extId);const h=[[P[1]]];for(;h.length;)for(const d of h.pop()){const u=this.items.get(d);u&&(h.push(u.children),this.items.delete(d),i.remove(u,u!==o),u.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(P[1]);break;case 3:this.updatePendingRoots(P[1]);break}i.complete()}retireTest(I){}updatePendingRoots(I){this.pendingRootCount+=I}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=y}),define(we[162],_e([0,1,13,40,10,24,21,81,137]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(P,o,h){this._contributedVariables=new Map,this._context=P,this._labelService=o,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(P){if(k.isWindows){const o=Object.create(null);return Object.keys(P).forEach(h=>{o[h.toLowerCase()]=P[h]}),o}return P}resolveWithEnvironment(P,o,h){return this.recursiveResolve(this.prepareEnv(P),o?o.uri:void 0,h)}async resolveAsync(P,o){return this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,o)}async resolveAnyBase(P,o,h,d){const u=E.deepClone(o);return k.isWindows&&u.windows?Object.keys(u.windows).forEach(w=>u[w]=u.windows[w]):k.isMacintosh&&u.osx?Object.keys(u.osx).forEach(w=>u[w]=u.osx[w]):k.isLinux&&u.linux&&Object.keys(u.linux).forEach(w=>u[w]=u.linux[w]),delete u.windows,delete u.osx,delete u.linux,this.recursiveResolve(await this._envVariablesPromise,P?P.uri:void 0,u,h,d)}async resolveAnyAsync(P,o,h){return this.resolveAnyBase(P,o,h)}async resolveAnyMap(P,o,h){const d=new Map;return{newConfig:await this.resolveAnyBase(P,o,h,d),resolvedVariables:d}}resolveWithInteractionReplace(P,o,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(P,o,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(P,o){if(this._contributedVariables.has(P))throw new Error("Variable "+P+" is contributed twice.");this._contributedVariables.set(P,o)}recursiveResolve(P,o,h,d,u){if(D.isString(h))return this.resolveString(P,o,h,d,u);if(D.isArray(h))return h.map(w=>this.recursiveResolve(P,o,w,d,u));if(D.isObject(h)){let w=Object.create(null);return Object.keys(h).forEach(p=>{const S=this.resolveString(P,o,p,d,u);w[S]=this.recursiveResolve(P,o,h[p],d,u)}),w}return h}resolveString(P,o,h,d,u){return h.replace(I.VARIABLE_REGEXP,(p,S)=>{if(S.includes(I.VARIABLE_LHS))return p;let c=this.evaluateSingleVariable(P,p,S,o,d);return u&&u.set(S,c),c!==p&&D.isString(c)&&c.match(I.VARIABLE_REGEXP)&&(c=this.resolveString(P,o,c,d,u)),c})}fsPath(P){return this._labelService?this._labelService.getUriLabel(P,{noPrefix:!0}):P.fsPath}evaluateSingleVariable(P,o,h,d,u){let w;const p=h.split(":");p.length>1&&(h=p[0],w=p[1]);const S=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error(_.localize(0,null,o))},c=()=>{const f=S();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,o,g.basename(f)))},m=()=>{if(w){const f=this._context.getFolderUri(w);if(f)return f;throw new Error(_.localize(2,null,o,w))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,o)):new Error(_.localize(4,null,o))};switch(h){case"env":if(w){if(P){const f=P[k.isWindows?w.toLowerCase():w];if(D.isString(f))return f}return""}throw new Error(_.localize(5,null,o));case"config":if(w){const f=this._context.getConfigurationValue(d,w);if(D.isUndefinedOrNull(f))throw new Error(_.localize(6,null,o,w));if(D.isObject(f))throw new Error(_.localize(7,null,o,w));return f}throw new Error(_.localize(8,null,o));case"command":return this.resolveFromMap(o,w,u,"command");case"input":return this.resolveFromMap(o,w,u,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return y.normalizeDriveLetter(this.fsPath(m()));case"cwd":return d||w?y.normalizeDriveLetter(this.fsPath(m())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(m()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error(_.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,o));case"file":return S();case"fileWorkspaceFolder":return c();case"relativeFile":return d||w?g.relative(this.fsPath(m()),S()):S();case"relativeFileDirname":const n=g.dirname(S());if(d||w){const v=g.relative(this.fsPath(m()),n);return v.length===0?".":v}return n;case"fileDirname":return g.dirname(S());case"fileExtname":return g.extname(S());case"fileBasename":return g.basename(S());case"fileBasenameNoExtension":const r=g.basename(S());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(S()));case"execPath":const s=this._context.getExecPath();return s||o;case"execInstallFolder":const l=this._context.getAppRoot();return l||o;case"pathSeparator":return g.sep;default:try{const v=w?`${h}:${w}`:h;return this.resolveFromMap(o,v,u,void 0)}catch(v){return o}}}}resolveFromMap(P,o,h,d){if(o&&h){const u=d===void 0?h[o]:h[d+":"+o];if(typeof u=="string")return u;throw new Error(_.localize(11,null,P))}return P}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[163],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=g.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var D;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function P(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=P}),define(we[164],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=g.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,16,80,218,54,24,10,2,31,58,138,89,45,164,6]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(be){function de(q){const{selectionStartLineNumber:Fe,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:et}=q,ft=new u.Position(Fe-1,Pe-1),ut=new u.Position(Ze-1,et-1);return new u.Selection(ft,ut)}be.to=de;function le(q){const{anchor:Fe,active:Pe}=q;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}be.from=le})(w=e.Selection||(e.Selection={}));var p;(function(be){function de(q){if(!q)return;const{start:Fe,end:Pe}=q;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}be.from=de;function le(q){if(!q)return;const{startLineNumber:Fe,startColumn:Pe,endLineNumber:Ze,endColumn:et}=q;return new u.Range(Fe-1,Pe-1,Ze-1,et-1)}be.to=le})(p=e.Range||(e.Range={}));var S;(function(be){function de(le){switch(le){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 4:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}be.to=de})(S=e.TokenType||(e.TokenType={}));var c;(function(be){function de(q){return new u.Position(q.lineNumber-1,q.column-1)}be.to=de;function le(q){return{lineNumber:q.line+1,column:q.character+1}}be.from=le})(c=e.Position||(e.Position={}));var m;(function(be){function de(q){switch(q){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}be.from=de;function le(q){switch(q){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}be.to=le})(m=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(be){function de(q){let Fe;return q.code&&(y.isString(q.code)||y.isNumber(q.code)?Fe=String(q.code):Fe={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},p.from(q.range)),{message:q.message,source:q.source,code:Fe,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?g.coalesce(q.tags.map(m.from)):void 0})}be.from=de;function le(q){var Fe;const Pe=new u.Diagnostic(p.to(q),q.message,n.to(q.severity));return Pe.source=q.source,Pe.code=y.isString(q.code)?q.code:(Fe=q.code)===null||Fe===void 0?void 0:Fe.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Pe.tags=q.tags&&g.coalesce(q.tags.map(m.to)),Pe}be.to=le})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function de(q){return Object.assign(Object.assign({},p.from(q.location.range)),{message:q.message,resource:q.location.uri})}be.from=de;function le(q){return new u.DiagnosticRelatedInformation(new u.Location(q.resource,p.to(q)),q.message)}be.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function de(q){switch(q){case u.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}be.from=de;function le(q){switch(q){case o.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}be.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(be){function de(q){return typeof q=="number"&&q>=u.ViewColumn.One?q-1:q===u.ViewColumn.Beside?d.SIDE_GROUP:d.ACTIVE_GROUP}be.from=de;function le(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=le})(r=e.ViewColumn||(e.ViewColumn={}));function s(be){return typeof be.range!="undefined"}function l(be){return be.length===0?!0:!!s(be[0])}e.isDecorationOptionsArr=l;var v;(function(be){function de(et){return et.map(be.from)}be.fromMany=de;function le(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ft;if(le(et)){const{language:ht,value:lt}=et;ft={value:"```"+ht+`
`+lt+"\n```\n"}}else u.MarkdownString.isMarkdownString(et)?ft={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ft={value:et}:ft={value:""};const ut=Object.create(null);ft.uris=ut;const it=ht=>{try{let lt=_.URI.parse(ht,!0);lt=lt.with({query:Fe(lt.query,ut)}),ut[ht]=lt}catch(lt){}return""},vt=new D.Renderer;return vt.link=it,vt.image=ht=>it(T.parseHrefAndDimensions(ht).href),D(ft.value,{renderer:vt}),ft}be.from=q;function Fe(et,ft){if(!et)return et;let ut;try{ut=E.parse(et)}catch(vt){}if(!ut)return et;let it=!1;return ut=k.cloneAndChange(ut,vt=>{if(_.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ht]=vt,it=!0,ht}else return}),it?JSON.stringify(ut):et}function Pe(et){const ft=new u.MarkdownString(et.value,et.supportThemeIcons);return ft.isTrusted=et.isTrusted,ft}be.to=Pe;function Ze(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Ze})(v=e.MarkdownString||(e.MarkdownString={}));function b(be){return l(be)?be.map(de=>({range:p.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?v.fromMany(de.hoverMessage):de.hoverMessage?v.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):be.map(de=>({range:p.from(de)}))}e.fromRangeOrRangeWithMessage=b;function A(be){return typeof be=="undefined"?be:typeof be=="string"?_.URI.file(be):be}e.pathOrURIToURI=A;var C;(function(be){function de(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?A(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}be.from=de})(C=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(be){function de(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?A(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?C.from(le.before):void 0,after:le.after?C.from(le.after):void 0}}be.from=de})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function de(le){if(typeof le=="undefined")return le;switch(le){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=de})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(be){function de(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?F.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?a.from(le.light):void 0,dark:le.dark?a.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?A(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?C.from(le.before):void 0,after:le.after?C.from(le.after):void 0}}be.from=de})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(be){function de(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:p.from(q.range)}}be.from=de;function le(q){const Fe=new u.TextEdit(p.to(q.range),q.text);return Fe.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Fe}be.to=le})(W=e.TextEdit||(e.TextEdit={}));var ce;(function(be){function de(q,Fe,Pe){var Ze,et,ft;const ut={edits:[]};if(q instanceof u.WorkspaceEdit)for(let it of q._allEntries())if(it._type===1)ut.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const vt=Fe==null?void 0:Fe.getDocument(it.uri);ut.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:vt==null?void 0:vt.version,metadata:it.metadata})}else it._type===3?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ze=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):it._type===4?(it.newOutputs&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(ke.from)}}),it.newMetadata&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(et=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(ae.from)}}):it._type===6&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ft=it.newOutputItems)===null||ft===void 0?void 0:ft.map(Ce.from))||[],append:it.append}});return ut}be.from=de;function le(q){const Fe=new u.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Fe.replace(_.URI.revive(Pe.resource),p.to(Pe.edit.range),Pe.edit.text):Fe.renameFile(_.URI.revive(Pe.oldUri),_.URI.revive(Pe.newUri),Pe.options);return Fe}be.to=le})(ce=e.WorkspaceEdit||(e.WorkspaceEdit={}));var me;(function(be){const de=Object.create(null);de[u.SymbolKind.File]=0,de[u.SymbolKind.Module]=1,de[u.SymbolKind.Namespace]=2,de[u.SymbolKind.Package]=3,de[u.SymbolKind.Class]=4,de[u.SymbolKind.Method]=5,de[u.SymbolKind.Property]=6,de[u.SymbolKind.Field]=7,de[u.SymbolKind.Constructor]=8,de[u.SymbolKind.Enum]=9,de[u.SymbolKind.Interface]=10,de[u.SymbolKind.Function]=11,de[u.SymbolKind.Variable]=12,de[u.SymbolKind.Constant]=13,de[u.SymbolKind.String]=14,de[u.SymbolKind.Number]=15,de[u.SymbolKind.Boolean]=16,de[u.SymbolKind.Array]=17,de[u.SymbolKind.Object]=18,de[u.SymbolKind.Key]=19,de[u.SymbolKind.Null]=20,de[u.SymbolKind.EnumMember]=21,de[u.SymbolKind.Struct]=22,de[u.SymbolKind.Event]=23,de[u.SymbolKind.Operator]=24,de[u.SymbolKind.TypeParameter]=25;function le(Fe){return typeof de[Fe]=="number"?de[Fe]:6}be.from=le;function q(Fe){for(const Pe in de)if(de[Pe]===Fe)return Number(Pe);return u.SymbolKind.Property}be.to=q})(me=e.SymbolKind||(e.SymbolKind={}));var G;(function(be){function de(q){switch(q){case u.SymbolTag.Deprecated:return 1}}be.from=de;function le(q){switch(q){case 1:return u.SymbolTag.Deprecated}}be.to=le})(G=e.SymbolTag||(e.SymbolTag={}));var V;(function(be){function de(q){return{name:q.name,kind:me.from(q.kind),tags:q.tags&&q.tags.map(G.from),containerName:q.containerName,location:U.from(q.location)}}be.from=de;function le(q){const Fe=new u.SymbolInformation(q.name,me.to(q.kind),q.containerName,U.to(q.location));return Fe.tags=q.tags&&q.tags.map(G.to),Fe}be.to=le})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var J;(function(be){function de(q){var Fe,Pe;const Ze={name:q.name||"!!MISSING: name!!",detail:q.detail,range:p.from(q.range),selectionRange:p.from(q.selectionRange),kind:me.from(q.kind),tags:(Pe=(Fe=q.tags)===null||Fe===void 0?void 0:Fe.map(G.from))!==null&&Pe!==void 0?Pe:[]};return q.children&&(Ze.children=q.children.map(de)),Ze}be.from=de;function le(q){const Fe=new u.DocumentSymbol(q.name,q.detail,me.to(q.kind),p.to(q.range),p.to(q.selectionRange));return g.isNonEmptyArray(q.tags)&&(Fe.tags=q.tags.map(G.to)),q.children&&(Fe.children=q.children.map(le)),Fe}be.to=le})(J=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(be){function de(le){const q=new u.CallHierarchyItem(me.to(le.kind),le.name,le.detail||"",_.URI.revive(le.uri),p.to(le.range),p.to(le.selectionRange));return q._sessionId=le._sessionId,q._itemId=le._itemId,q}be.to=de})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var B;(function(be){function de(le){return new u.CallHierarchyIncomingCall(R.to(le.from),le.fromRanges.map(q=>p.to(q)))}be.to=de})(B=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function de(le){return new u.CallHierarchyOutgoingCall(R.to(le.to),le.fromRanges.map(q=>p.to(q)))}be.to=de})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(be){function de(q){return{range:q.range&&p.from(q.range),uri:q.uri}}be.from=de;function le(q){return new u.Location(_.URI.revive(q.uri),p.to(q.range))}be.to=le})(U=e.location||(e.location={}));var j;(function(be){function de(q){const Fe=q,Pe=q;return{originSelectionRange:Fe.originSelectionRange?p.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Pe.uri,range:p.from(Fe.targetRange?Fe.targetRange:Pe.range),targetSelectionRange:Fe.targetSelectionRange?p.from(Fe.targetSelectionRange):void 0}}be.from=de;function le(q){return{targetUri:_.URI.revive(q.uri),targetRange:p.to(q.range),targetSelectionRange:q.targetSelectionRange?p.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?p.to(q.originSelectionRange):void 0}}be.to=le})(j=e.DefinitionLink||(e.DefinitionLink={}));var z;(function(be){function de(q){return{range:p.from(q.range),contents:v.fromMany(q.contents)}}be.from=de;function le(q){return new u.Hover(q.contents.map(v.to),p.to(q.range))}be.to=le})(z=e.Hover||(e.Hover={}));var oe;(function(be){function de(q){return{range:p.from(q.range),expression:q.expression}}be.from=de;function le(q){return new u.EvaluatableExpression(p.to(q.range),q.expression)}be.to=le})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(be){function de(q){if(q instanceof u.InlineValueText)return{type:"text",range:p.from(q.range),text:q.text};if(q instanceof u.InlineValueVariableLookup)return{type:"variable",range:p.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}be.from=de;function le(q){switch(q.type){case"text":return{range:p.to(q.range),text:q.text};case"variable":return{range:p.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:p.to(q.range),expression:q.expression}}}be.to=le})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(be){function de(q){return{frameId:q.frameId,stoppedLocation:p.from(q.stoppedLocation)}}be.from=de;function le(q){return new u.InlineValueContext(q.frameId,p.to(q.stoppedLocation))}be.to=le})(Te=e.InlineValueContext||(e.InlineValueContext={}));var $e;(function(be){function de(q){return{range:p.from(q.range),kind:q.kind}}be.from=de;function le(q){return new u.DocumentHighlight(p.to(q.range),q.kind)}be.to=le})($e=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(be){function de(le){switch(le){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}be.to=de})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(be){function de(le){return{triggerKind:Me.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}be.to=de})(ze=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(be){function de(q){switch(q){case u.CompletionItemTag.Deprecated:return 1}}be.from=de;function le(q){switch(q){case 1:return u.CompletionItemTag.Deprecated}}be.to=le})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var Ke;(function(be){const de=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function le(Pe){var Ze;return(Ze=de.get(Pe))!==null&&Ze!==void 0?Ze:9}be.from=le;const q=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Fe(Pe){var Ze;return(Ze=q.get(Pe))!==null&&Ze!==void 0?Ze:u.CompletionItemKind.Property}be.to=Fe})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(be){function de(le,q){var Fe;const Pe=new u.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Pe.label2=le.label),Pe.insertText=le.insertText,Pe.kind=Ke.to(le.kind),Pe.tags=(Fe=le.tags)===null||Fe===void 0?void 0:Fe.map(Qe.to),Pe.detail=le.detail,Pe.documentation=T.isMarkdownString(le.documentation)?v.to(le.documentation):le.documentation,Pe.sortText=le.sortText,Pe.filterText=le.filterText,Pe.preselect=le.preselect,Pe.commitCharacters=le.commitCharacters,I.Range.isIRange(le.range)?Pe.range=p.to(le.range):typeof le.range=="object"&&(Pe.range={inserting:p.to(le.range.insert),replacing:p.to(le.range.replace)}),Pe.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Pe.insertText=new u.SnippetString(le.insertText):(Pe.insertText=le.insertText,Pe.textEdit=Pe.range instanceof u.Range?new u.TextEdit(Pe.range,Pe.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Pe.additionalTextEdits=le.additionalTextEdits.map(Ze=>W.to(Ze))),Pe.command=q&&le.command?q.fromInternal(le.command):void 0,Pe}be.to=de})(Ge=e.CompletionItem||(e.CompletionItem={}));var $;(function(be){function de(q){return{label:q.label,documentation:q.documentation?v.fromStrict(q.documentation):void 0}}be.from=de;function le(q){return{label:q.label,documentation:T.isMarkdownString(q.documentation)?v.to(q.documentation):q.documentation}}be.to=le})($=e.ParameterInformation||(e.ParameterInformation={}));var Q;(function(be){function de(q){return{label:q.label,documentation:q.documentation?v.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map($.from):[],activeParameter:q.activeParameter}}be.from=de;function le(q){return{label:q.label,documentation:T.isMarkdownString(q.documentation)?v.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map($.to):[],activeParameter:q.activeParameter}}be.to=le})(Q=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(be){function de(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Q.from):[]}}be.from=de;function le(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Q.to):[]}}be.to=le})(ne=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(be){function de(q){var Fe;return{text:q.text,position:c.from(q.position),kind:K.from((Fe=q.kind)!==null&&Fe!==void 0?Fe:u.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}be.from=de;function le(q){const Fe=new u.InlayHint(q.text,c.to(q.position),K.to(q.kind));return Fe.whitespaceAfter=q.whitespaceAfter,Fe.whitespaceBefore=q.whitespaceBefore,Fe}be.to=le})(re=e.InlayHint||(e.InlayHint={}));var K;(function(be){function de(q){return q}be.from=de;function le(q){return q}be.to=le})(K=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(be){function de(q){return{range:p.from(q.range),url:q.target,tooltip:q.tooltip}}be.from=de;function le(q){let Fe;if(q.url)try{Fe=typeof q.url=="string"?_.URI.parse(q.url,!0):_.URI.revive(q.url)}catch(Pe){}return new u.DocumentLink(p.to(q.range),Fe)}be.to=le})(se=e.DocumentLink||(e.DocumentLink={}));var fe;(function(be){function de(q){const Fe=new u.ColorPresentation(q.label);return q.textEdit&&(Fe.textEdit=W.to(q.textEdit)),q.additionalTextEdits&&(Fe.additionalTextEdits=q.additionalTextEdits.map(Pe=>W.to(Pe))),Fe}be.to=de;function le(q){return{label:q.label,textEdit:q.textEdit?W.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Fe=>W.from(Fe)):void 0}}be.from=le})(fe=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(be){function de(q){return new u.Color(q[0],q[1],q[2],q[3])}be.to=de;function le(q){return[q.red,q.green,q.blue,q.alpha]}be.from=le})(Ae=e.Color||(e.Color={}));var ge;(function(be){function de(q){return{range:p.from(q.range)}}be.from=de;function le(q){return new u.SelectionRange(p.to(q.range))}be.to=le})(ge=e.SelectionRange||(e.SelectionRange={}));var We;(function(be){function de(le){switch(le){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}be.to=de})(We=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(be){function de(q){switch(q){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}be.from=de;function le(q){switch(q){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}be.to=le})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(be){function de(q){if(q===u.EndOfLine.CRLF)return 1;if(q===u.EndOfLine.LF)return 0}be.from=de;function le(q){if(q===1)return u.EndOfLine.CRLF;if(q===0)return u.EndOfLine.LF}be.to=le})(te=e.EndOfLine||(e.EndOfLine={}));var ve;(function(be){function de(le){if(typeof le=="object")return le.viewId;switch(le){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(be){function de(le){const q={start:le.start+1,end:le.end+1};return le.kind&&(q.kind=xe.from(le.kind)),q}be.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var xe;(function(be){function de(le){if(le)switch(le){case u.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=de})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(be){function de(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?p.from(le.selection):void 0,override:typeof le.override=="boolean"?P.EditorOverride.DISABLED:void 0}}be.from=de})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(be){function de(q){return q instanceof u.RelativePattern||typeof q=="string"?q:le(q)?new u.RelativePattern(q.base,q.pattern):q}be.from=de;function le(q){const Fe=q;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var Se;(function(be){function de(le){if(le){if(Array.isArray(le))return le.map(de);if(typeof le=="string")return le;{const q=le;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ye.from(q.pattern),exclusive:q.exclusive}}}else return}be.from=de})(Se=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(be){function de(q){return{start:q.start,end:q.end}}be.from=de;function le(q){return new u.NotebookRange(q.start,q.end)}be.to=le})(ye=e.NotebookRange||(e.NotebookRange={}));var De;(function(be){function de(le){return new u.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=de})(De=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ie;(function(be){function de(q){return q}be.from=de;function le(q){return new u.NotebookDocumentMetadata().with(q)}be.to=le})(ie=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(be){function de(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}be.to=de;function le(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}be.from=le})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var O;(function(be){function de(q){switch(q){case u.NotebookCellKind.Markup:return h.CellKind.Markup;case u.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=de;function le(q){switch(q){case h.CellKind.Markup:return u.NotebookCellKind.Markup;case h.CellKind.Code:default:return u.NotebookCellKind.Code}}be.to=le})(O=e.NotebookCellKind||(e.NotebookCellKind={}));var Y;(function(be){function de(q){const Fe={metadata:ie.from(q.metadata),cells:[]};for(let Pe of q.cells)u.NotebookCellData.validate(Pe),Fe.cells.push(ae.from(Pe));return Fe}be.from=de;function le(q){return{metadata:ie.to(q.metadata),cells:q.cells.map(ae.to)}}be.to=le})(Y=e.NotebookData||(e.NotebookData={}));var ae;(function(be){function de(q){var Fe;return{cellKind:O.from(q.kind),language:q.languageId,source:q.value,metadata:q.metadata,internalMetadata:ue.from((Fe=q.executionSummary)!==null&&Fe!==void 0?Fe:{}),outputs:q.outputs?q.outputs.map(ke.from):[]}}be.from=de;function le(q){return new u.NotebookCellData(O.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ke.to):void 0,q.metadata?De.to(q.metadata):void 0,q.internalMetadata?ue.to(q.internalMetadata):void 0)}be.to=le})(ae=e.NotebookCellData||(e.NotebookCellData={}));var Ce;(function(be){function de(q){return{metadata:q.metadata,mime:q.mime,valueBytes:Array.from(q.data)}}be.from=de;function le(q){return new u.NotebookCellOutputItem(new Uint8Array(q.valueBytes),q.mime,q.metadata)}be.to=le})(Ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(be){function de(q){return{outputId:q.id,outputs:q.items.map(Ce.from),metadata:q.metadata}}be.from=de;function le(q){const Fe=q.outputs.map(Ce.to);return new u.NotebookCellOutput(Fe,q.outputId,q.metadata)}be.to=le})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(be){function de(Pe){if(Pe!=null){if(Pe instanceof u.RelativePattern||typeof Pe=="string")return Pe;if(Fe(Pe))return new u.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:Ye.from(Pe.include)||void 0,exclude:Ye.from(Pe.exclude)||void 0}}}be.from=de;function le(Pe){return typeof Pe=="string"?Pe:Fe(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}be.to=le;function q(Pe){const Ze=Pe,et=Ye.from(Ze.include);if(!(et&&et instanceof u.RelativePattern||typeof et=="string"))return!1;const ft=Ye.from(Ze.exclude);return!!(ft&&ft instanceof u.RelativePattern||typeof ft=="string")}function Fe(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(be){function de(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?C.from(le.top):void 0}}be.from=de})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var qe;(function(be){function de(le,q,Fe){const Pe=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Fe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}be.from=de})(qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(be){function de(le){var q,Fe,Pe;return{transientOutputs:(q=le==null?void 0:le.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:(Fe=le==null?void 0:le.transientCellMetadata)!==null&&Fe!==void 0?Fe:{},transientDocumentMetadata:(Pe=le==null?void 0:le.transientDocumentMetadata)!==null&&Pe!==void 0?Pe:{}}}be.from=de})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(be){function de(q){return{uri:q.uri,provides:q.provides}}be.from=de;function le(q){return new u.NotebookRendererScript(_.URI.revive(q.uri),q.provides)}be.to=le})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(be){function de(q){return{message:v.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?U.from(q.location):void 0}}be.from=de;function le(q){const Fe=new u.TestMessage(typeof q.message=="string"?q.message:v.to(q.message));return Fe.severity=q.severity,Fe.actualOutput=q.actualOutput,Fe.expectedOutput=q.expectedOutput,Fe}be.to=le})(Je=e.TestMessage||(e.TestMessage={}));var ot;(function(be){function de(Pe){var Ze,et;return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:p.from(Pe.range)||null,debuggable:(Ze=Pe.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Pe.description||null,runnable:(et=Pe.runnable)!==null&&et!==void 0?et:!0,error:Pe.error&&v.fromStrict(Pe.error)||null}}be.from=de;function le(Pe){return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:p.from(Pe.range)||null,debuggable:!1,description:Pe.description||null,error:null,runnable:!0}}be.fromResultSnapshot=le;function q(Pe){return{id:Pe.extId,label:Pe.label,uri:_.URI.revive(Pe.uri),range:p.to(Pe.range||void 0),addChild:()=>{},dispose:()=>{},status:u.TestItemStatus.Pending,data:void 0,debuggable:Pe.debuggable,description:Pe.description||void 0,runnable:Pe.runnable}}be.toPlain=q;function Fe(Pe){const Ze=new u.TestItemImpl(Pe.extId,Pe.label,_.URI.revive(Pe.uri),void 0);return Ze.range=p.to(Pe.range||void 0),Ze.debuggable=Pe.debuggable,Ze.description=Pe.description||void 0,Ze.runnable=Pe.runnable,Ze}be.to=Fe})(ot=e.TestItem||(e.TestItem={}));var _t;(function(be){const de=(q,Fe)=>Object.assign(Object.assign({},ot.toPlain(q.item)),{taskStates:q.tasks.map(Pe=>({state:Pe.state,duration:Pe.duration,messages:Pe.messages.map(Je.to)})),children:q.children.map(Pe=>Fe.get(Pe)).filter(y.isDefined).map(Pe=>de(Pe,Fe))});function le(q){const Fe=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),Ze.direct&&Fe.push(Ze);return{completedAt:q.completedAt,results:Fe.map(Ze=>de(Ze,Pe))}}be.to=le})(_t=e.TestResults||(e.TestResults={}));var wt;(function(be){function de(le){switch(le){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}be.to=de})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[165],_e([0,1,2,12,6,9,51]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class y{constructor(I,i,P,o={timeout:1500,errors:3}){this._logService=I,this._documents=i,this._mainThreadBulkEdits=P,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(i,P,o)=>{const d={dispose:this._callbacks.push([i,P,I])};return Array.isArray(o)&&o.push(d),d}}async $participateInSave(I,i){const P=g.URI.revive(I);let o=!1;const h=setTimeout(()=>o=!0,this._thresholds.timeout),d=[];try{for(let u of[...this._callbacks]){if(o)break;const w=this._documents.getDocument(P),p=await this._deliverEventAsyncAndBlameBadListeners(u,{document:w,reason:E.TextDocumentSaveReason.to(i)});d.push(p)}}finally{clearTimeout(h)}return d}_deliverEventAsyncAndBlameBadListeners([I,i,P],o){const h=this._badListeners.get(I);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(P,I,i,o).then(()=>!0,d=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this._logService.error(d),!(d instanceof Error)||d.message!=="concurrent_edits"){const u=this._badListeners.get(I);this._badListeners.set(I,u?u+1:1),typeof u=="number"&&u>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,i,P,o){const h=[],d=Date.now(),{document:u,reason:w}=o,{version:p}=u,S=Object.freeze({document:u,reason:w,waitUntil(c){if(Object.isFrozen(h))throw T.illegalState("waitUntil can not be called async");h.push(Promise.resolve(c))}});try{i.apply(P,[S])}catch(c){return Promise.reject(c)}return Object.freeze(h),new Promise((c,m)=>{const f=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-d}ms`),clearTimeout(f),c(t)}).catch(t=>{clearTimeout(f),m(t)})}).then(c=>{const m={edits:[]};for(const f of c)if(Array.isArray(f)&&f.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:n,range:r}of f)m.edits.push({_type:2,resource:u.uri,edit:{range:r&&E.Range.from(r),text:t,eol:n&&E.EndOfLine.from(n)}});if(m.edits.length!==0)return p===u.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=y}),define(we[166],_e([0,1,3,11,27,2,9,6]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(P,o,h,d,u){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,h&&(this._config+=1),d&&(this._config+=2),u&&(this._config+=4);const w=D.parse(o),p=P(S=>{if(!h)for(let c of S.created){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidCreate.fire(m)}if(!d)for(let c of S.changed){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidChange.fire(m)}if(!u)for(let c of S.deleted){const m=E.URI.revive(c);w(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=y.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class I{constructor(P,o,h){this._logService=o,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,o,h,d){return new _(this._onFileSystemEvent.event,P,o,h,d)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,o){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(h=>({oldUri:E.URI.revive(h.source),newUri:E.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,o){return(h,d,u)=>{const w=function(S){h.call(d,S)};return w.extension=P,o.event(w,void 0,u)}}async $onWillRunFileOperation(P,o,h,d){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(u=>({oldUri:E.URI.revive(u.source),newUri:E.URI.revive(u.target)}))},h,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(u=>E.URI.revive(u.target))},h,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(u=>E.URI.revive(u.target))},h,d)}}async _fireWillEvent(P,o,h,d){const u=new Set,w=[];if(await P.fireAsync(o,d,async(S,c)=>{var m;const f=Date.now(),t=await Promise.resolve(S);t instanceof y.WorkspaceEdit&&(w.push(t),u.add((m=c.extension.displayName)!==null&&m!==void 0?m:c.extension.identifier.value)),Date.now()-f>h&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),d.isCancellationRequested||w.length===0)return;const p={edits:[]};for(let S of w){let{edits:c}=k.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(c)}return{edit:p,extensionNames:Array.from(u)}}}e.ExtHostFileSystemEventService=I}),define(we[167],_e([0,1,15,24,2,9,6,45]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(o,h,d,u){this.start=o,this.deletedCount=h,this.deletedItems=d,this.items=u}static asApiEvents(o){return o.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(d=>d.apiCell)}))}}class I{constructor(o,h,d){var u,w,p;this.notebook=o,this._extHostDocument=h,this._cellData=d,this.handle=d.handle,this.uri=D.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=(u=d.internalMetadata)!==null&&u!==void 0?u:{},this._metadata=E.NotebookCellMetadata.to((w=d.metadata)!==null&&w!==void 0?w:{}),this._previousResult=E.NotebookCellExecutionSummary.to((p=d.internalMetadata)!==null&&p!==void 0?p:{})}static asModelAddData(o,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(E.NotebookCellOutput.to)}setOutputItems(o,h,d){const u=d.map(E.NotebookCellOutputItem.to),w=this._outputs.find(p=>p.id===o);w&&(h||(w.items.length=0),w.items.push(...u))}setMetadata(o){this._metadata=E.NotebookCellMetadata.to(o)}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=E.NotebookCellExecutionSummary.to(o)}}e.ExtHostCell=I;class i{constructor(o,h,d,u,w,p,S){this._proxy=o,this._textDocumentsAndEditors=h,this._textDocuments=d,this._emitter=u,this._notebookType=w,this._metadata=p,this.uri=S,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get viewType(){return o._notebookType},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===g.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(h){return h=o._validateIndex(h),o._cells[h].apiCell},getCells(h){return(h?o._getCells(h):o._cells).map(u=>u.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=this._metadata.with(o.metadata))}acceptModelChanged(o,h){this._versionId=o.versionId,this._isDirty=h;for(const d of o.rawEvents)d.kind===y.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(d.changes,!0),d.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===y.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===y.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let h=o.start|0,d=o.end|0;return h<0&&(h=0),d>this._cells.length&&(d=this._cells.length),o.with({start:h,end:d})}_getCells(o){o=this._validateRange(o);const h=[];for(let d=o.start;d<o.end;d++)h.push(this._cells[d]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,h){if(this._disposed)return;const d=[],u=[],w=[];o.reverse().forEach(p=>{const c=p[2].map(t=>{const n=new I(this,this._textDocumentsAndEditors,t);return h||u.push(I.asModelAddData(this.apiNotebook,t)),n}),m=new _(p[0],p[1],[],c),f=this._cells.splice(p[0],p[1],...c);for(const t of f)w.push(t.uri),m.deletedItems.push(t.apiCell);d.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:w}),h||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_moveCell(o,h){const d=this._cells.splice(o,1);this._cells.splice(h,0,...d);const u=[new _(o,1,d.map(w=>w.apiCell),[]),new _(h,0,[],d)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(u)}))}_setCellOutputs(o,h){const d=this._cells[o];d.setOutputs(h),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(o,h,d,u){const w=this._cells[o];w.setOutputItems(h,d,u),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(o,h){const d=this._cells[o];d.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(d.uri,h)}_changeCellMetadata(o,h){const d=this._cells[o],u=d.apiCell.metadata;d.setMetadata(h);const w=d.apiCell.metadata;T.equals(u,w)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(o,h){var d;const u=this._cells[o],w=u.internalMetadata;if(u.setInternalMetadata(h),w.runState!==h.runState){const p=(d=h.runState)!==null&&d!==void 0?d:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:u.apiCell,state:p}))}}getCellFromApiCell(o){return this._cells.find(h=>h.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(h=>h.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(we[95],_e([0,1,6,9]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,_){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:_})}replaceCells(y,_,I){this._throwIfFinalized(),!(y===_&&I.length===0)&&this._collectedEdits.push({editType:1,index:y,count:_-y,cells:I.map(T.NotebookCellData.from)})}}class E{constructor(y,_,I,i,P,o){this.id=y,this._proxy=_,this.notebookData=I,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=P,this._visibleRanges=i,this._viewColumn=o}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(_,I){y._proxy.$tryRevealRange(y.id,T.NotebookRange.from(_),I??g.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(_){const I=new D(this.document.version);return _(I),y._applyEdit(I.finalize())},setDecorations(_,I){return y.setDecorations(_,I)}},E.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const _=[];let I=-1;for(let i=0;i<y.cellEdits.length;i++){if(I<0){_.push(y.cellEdits[i]),I++;continue}const o=_[I],h=y.cellEdits[i];if(o.editType===1&&h.editType===1&&o.index===h.index){o.cells.push(...y.cellEdits[i].cells),o.count+=y.cellEdits[i].count;continue}_.push(y.cellEdits[i]),I++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,_)}setDecorations(y,_){if(!(_.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return _.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(_),y.key)}}e.ExtHostNotebookEditor=E,E.apiEditorsToExtHost=new WeakMap}),define(we[168],_e([0,1,9,147,129,18,47]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(P){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=P}withProgress(P,o,h){const d=this._handles++,{title:u,location:w,cancellable:p}=o,S={label:D.localize(0,null,P.displayName||P.name),id:P.identifier.value};return this._proxy.$startProgress(d,{location:g.ProgressLocation.from(w),title:u,source:S,cancellable:p},P),this._withProgress(d,h,!!p)}_withProgress(P,o,h){let d;h&&(d=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(P,d));const u=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),d&&d.dispose()};let w;try{w=o(new I(this._proxy,P),h&&d?d.token:E.CancellationToken.None)}catch(p){throw u(P),p}return w.then(p=>u(P),p=>u(P)),w}$acceptProgressCanceled(P){const o=this._mapHandleToCancellationSource.get(P);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(P))}}e.ExtHostProgress=y;function _(i,P){return i.message=P.message,typeof P.increment=="number"&&(typeof i.increment=="number"?i.increment+=P.increment:i.increment=P.increment),i}class I extends T.Progress{constructor(P,o){super(h=>this.throttledReport(h));this._proxy=P,this._handle=o}throttledReport(P){this._proxy.$progressReport(this._handle,P)}}Ve([k.throttle(100,(i,P)=>_(i,P),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(we[96],_e([0,1,39,12,49,9,6]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class y{constructor(o,h,d){const u=y._Keys.nextId();o.$registerTextEditorDecorationType(h.identifier,u,E.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:u,dispose(){o.$removeTextEditorDecorationType(u)}})}}e.TextEditorDecorationType=y,y._Keys=new D.IdGenerator("TextEditorDecorationType");class _{constructor(o,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,h){this._throwIfFinalized();let d=null;if(o instanceof k.Position)d=new k.Range(o,o);else if(o instanceof k.Range)d=o;else throw new Error("Unrecognized location");this._pushEdit(d,h,!1)}insert(o,h){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),h,!0)}delete(o){this._throwIfFinalized();let h=null;if(o instanceof k.Range)h=o;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(o,h,d){const u=this._document.validateRange(o);this._collectedEdits.push({range:u,text:h,forceMoveMarkers:d})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=_;class I{constructor(o,h,d,u){this._proxy=o,this._id=h,this._accept(d),this._logService=u;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(p){w._setTabSize(p)},get insertSpaces(){return w._insertSpaces},set insertSpaces(p){w._setInsertSpaces(p)},get cursorStyle(){return w._cursorStyle},set cursorStyle(p){w._setCursorStyle(p)},get lineNumbers(){return w._lineNumbers},set lineNumbers(p){w._setLineNumbers(p)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const h=Math.floor(o);return h>0?h:null}if(typeof o=="string"){const h=parseInt(o,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(o){const h=this._validateTabSize(o);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const h=this._validateInsertSpaces(o);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(o)})))}assign(o){const h={};let d=!1;if(typeof o.tabSize!="undefined"){const u=this._validateTabSize(o.tabSize);u==="auto"?(d=!0,h.tabSize=u):typeof u=="number"&&this._tabSize!==u&&(this._tabSize=u,d=!0,h.tabSize=u)}if(typeof o.insertSpaces!="undefined"){const u=this._validateInsertSpaces(o.insertSpaces);u==="auto"?(d=!0,h.insertSpaces=u):this._insertSpaces!==u&&(this._insertSpaces=u,d=!0,h.insertSpaces=u)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,d=!0,h.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,d=!0,h.lineNumbers=E.TextEditorLineNumbersStyle.from(o.lineNumbers)),d&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(o){o.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=I;class i{constructor(o,h,d,u,w,p,S,c){this.id=o,this._proxy=h,this._logService=d,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new I(this._proxy,this.id,p,d),this._visibleRanges=S,this._viewColumn=c;const m=this;this.value=Object.freeze({get document(){return u.getValue()},set document(f){throw T.readonly("document")},get selection(){return m._selections&&m._selections[0]},set selection(f){if(!(f instanceof k.Selection))throw T.illegalArgument("selection");m._selections=[f],m._trySetSelection()},get selections(){return m._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");m._selections=f,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(f){throw T.readonly("visibleRanges")},get options(){return m._options.value},set options(f){m._disposed||m._options.assign(f)},get viewColumn(){return m._viewColumn},set viewColumn(f){throw T.readonly("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new _(u.getValue(),t);return f(n),m._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=m._selections.map(s=>E.Range.from(s));else if(t instanceof k.Position){const{lineNumber:s,column:l}=E.Position.from(t);r=[{startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l}]}else if(t instanceof k.Range)r=[E.Range.from(t)];else{r=[];for(const s of t)if(s instanceof k.Range)r.push(E.Range.from(s));else{const{lineNumber:l,column:v}=E.Position.from(s);r.push({startLineNumber:l,startColumn:v,endLineNumber:l,endColumn:v})}}return h.$tryInsertSnippet(o,f.value,r,n)},setDecorations(f,t){const n=t.length===0;n&&!m._hasDecorationsForKey.has(f.key)||(n?m._hasDecorationsForKey.delete(f.key):m._hasDecorationsForKey.add(f.key),m._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return h.$trySetDecorations(o,f.key,E.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let s=0,l=t.length;s<l;s++){const v=t[s];r[4*s]=v.start.line+1,r[4*s+1]=v.start.character+1,r[4*s+2]=v.end.line+1,r[4*s+3]=v.end.character+1}return h.$trySetDecorationsFast(o,f.key,r)}}))},revealRange(f,t){m._runOnProxy(()=>h.$tryRevealRange(o,E.Range.from(f),t||k.TextEditorRevealType.Default))},show(f){h.$tryShowEditor(o,E.ViewColumn.from(f))},hide(){h.$tryHideEditor(o)}})}dispose(){g.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){g.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){g.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){g.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){g.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const h=o.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const d=h.edits.map(w=>w.range);d.sort((w,p)=>w.end.line===p.end.line?w.end.character===p.end.character?w.start.line===p.start.line?w.start.character-p.start.character:w.start.line-p.start.line:w.end.character-p.end.character:w.end.line-p.end.line);for(let w=0,p=d.length-1;w<p;w++){const S=d[w].end;if(d[w+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=h.edits.map(w=>({range:E.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,u,{setEndOfLine:typeof h.setEndOfLine=="number"?E.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=i}),define(we[169],_e([0,1,132,25,2,3,7,11,6,10,16,9,18]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(w,p){if(I.isString(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let S;return Array.isArray(w.highlights)&&(S=w.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),S=S.length?S:void 0),{label:w.label,highlights:S}}}class d{constructor(p,S,c){this._proxy=p,this.commands=S,this.logService=c,this.treeViews=new Map;function m(f){return f&&f.$treeViewId&&f.$treeItemHandle}S.registerArgumentProcessor({processArgument:f=>m(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>m(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(p,S,c){const m=this.createTreeView(p,{treeDataProvider:S},c);return{dispose:()=>m.dispose()}}createTreeView(p,S,c){if(!S||!S.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=S.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!S.showCollapseAll,canSelectMany:!!S.canSelectMany,canDragAndDrop:m}),t=this.createExtHostTreeView(p,S,c);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,r)=>t.reveal(n,r),dispose:async()=>{await f,this.treeViews.delete(p),t.dispose()}}}$getChildren(p,S){const c=this.treeViews.get(p);return c?c.getChildren(S):Promise.reject(new Error(g.localize(0,null,p)))}$onDrop(p,S,c){const m=this.treeViews.get(p);return m?m.onDrop(S,c):Promise.reject(new Error(g.localize(1,null,p)))}async $hasResolve(p){const S=this.treeViews.get(p);if(!S)throw new Error(g.localize(2,null,p));return S.hasResolve}$resolve(p,S,c){const m=this.treeViews.get(p);if(!m)throw new Error(g.localize(3,null,p));return m.resolveTreeItem(S,c)}$setExpanded(p,S,c){const m=this.treeViews.get(p);if(!m)throw new Error(g.localize(4,null,p));m.setExpanded(S,c)}$setSelection(p,S){const c=this.treeViews.get(p);if(!c)throw new Error(g.localize(5,null,p));c.setSelection(S)}$setVisible(p,S){const c=this.treeViews.get(p);if(!c)throw new Error(g.localize(6,null,p));c.setVisible(S)}createExtHostTreeView(p,S,c){const m=new u(p,S,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(p,m),m}convertArgument(p){const S=this.treeViews.get(p.$treeViewId);return S?S.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=d;class u extends k.Disposable{constructor(p,S,c,m,f,t){super();if(this.viewId=p,this.proxy=c,this.commands=m,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const l of t.contributes.views[s])l.id===p&&(this._title=l.name);this.dataProvider=S.treeDataProvider,this.dndController=S.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,r;this._register(E.Event.debounce(this._onDidChangeData.event,(s,l)=>(s||(s={message:!1,elements:[]}),l.element!==!1&&(n||(n=new Promise(v=>r=v),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(l.element)),l.message&&(s.message=!0),s),200,!0)(({message:s,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=r;return n=null,this.refresh(l).then(()=>v())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!I.isUndefinedOrNull(p))}getChildren(p){const S=p?this.getExtensionElement(p):void 0;if(p&&!S)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(p);return(c?Promise.resolve(c):this.fetchChildrenNodes(S)).then(m=>m.map(f=>f.item))}getExtensionElement(p){return this.elements.get(p)}reveal(p,S){S=S||{select:!0,focus:!1};const c=I.isUndefinedOrNull(S.select)?!0:S.select,m=I.isUndefinedOrNull(S.focus)?!1:S.focus,f=I.isUndefinedOrNull(S.expand)?!1:S.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(t=>this.resolveTreeNode(p,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(r=>r.item)},{select:c,focus:m,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:m,expand:f})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,S){const c=this.getExtensionElement(p);c&&(S?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(p){i.equals(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(p,S){const c=p.map(f=>this.getExtensionElement(f)).filter(f=>!I.isUndefinedOrNull(f)),m=this.getExtensionElement(S);return c&&m?y.asPromise(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(c,m)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,S){var c;if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(p);if(m){const f=this.nodes.get(m);if(f){const t=(c=await this.dataProvider.resolveTreeItem(f.extensionItem,m,S))!==null&&c!==void 0?c:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(S=>S?this.resolveUnknownParentChain(S).then(c=>this.resolveTreeNode(S,c[c.length-1]).then(m=>(c.push(m),c))):Promise.resolve([]))}resolveParent(p){const S=this.nodes.get(p);return S?Promise.resolve(S.parent?this.elements.get(S.parent.item.handle):void 0):y.asPromise(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,S){const c=this.nodes.get(p);return c?Promise.resolve(c):y.asPromise(()=>this.dataProvider.getTreeItem(p)).then(m=>this.createHandle(p,m,S,!0)).then(m=>this.getChildren(S?S.item.handle:void 0).then(()=>{const f=this.getExtensionElement(m);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${m}`)}))}getChildrenNodes(p){if(p){let S;if(typeof p=="string"){const c=this.getExtensionElement(p);S=c?this.nodes.get(c):void 0}else S=p;return S&&S.children||null}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const S=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=p?this.nodes.get(p):void 0,m=await this.dataProvider.getChildren(p);if(S.token.isCancellationRequested)return[];const f=await Promise.all(i.coalesce(m||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!S.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,c):null}));return S.token.isCancellationRequested?[]:i.coalesce(f)}finally{S.dispose()}}refresh(p){if(p.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(p);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const S=new Set,c=p.map(f=>this.nodes.get(f));for(const f of c)if(f&&!S.has(f.item.handle)){let t=f;for(;t&&t.parent&&c.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&S.add(f.item.handle)}const m=[];return S.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!S.has(n.parent.item.handle))&&m.push(f)}}),m}refreshHandles(p){const S={};return Promise.all(p.map(c=>this.refreshNode(c).then(m=>{m&&(S[c]=m.item)}))).then(()=>Object.keys(S).length?this.proxy.$refresh(this.viewId,S):void 0)}refreshNode(p){const S=this.getExtensionElement(p);if(S){const c=this.nodes.get(S);if(c)return this.clearChildren(S),y.asPromise(()=>this.dataProvider.getTreeItem(S)).then(m=>{if(m){const f=this.createTreeNode(S,m,c.parent);return this.updateNodeCache(S,f,c,c.parent),c.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,S,c){const m=this.createTreeNode(p,S,c);if(S.id&&this.elements.has(m.item.handle))throw new Error(g.localize(7,null,S.id));return this.addNodeToCache(p,m),this.addNodeToParentCache(m,c),m}getTooltip(p){return _.MarkdownString.isMarkdownString(p)?P.MarkdownString.from(p):p}getCommand(p,S){return S?this.commands.toInternal(S,p):void 0}createTreeNode(p,S,c){const m=new k.DisposableStore,f=this.createHandle(p,S,c),t=this.getLightIconPath(S);return{item:{handle:f,parentHandle:c?c.item.handle:void 0,label:h(S.label,this.extension),description:S.description,resourceUri:S.resourceUri,tooltip:this.getTooltip(S.tooltip),command:this.getCommand(m,S.command),contextValue:S.contextValue,icon:t,iconDark:this.getDarkIconPath(S)||t,themeIcon:this.getThemeIcon(S),collapsibleState:I.isUndefinedOrNull(S.collapsibleState)?_.TreeItemCollapsibleState.None:S.collapsibleState,accessibilityInformation:S.accessibilityInformation},extensionItem:S,parent:c,children:void 0,disposableStore:m,dispose(){m.dispose()}}}getThemeIcon(p){return p.iconPath instanceof _.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:S,label:c,resourceUri:m},f,t){if(S)return`${u.ID_HANDLE_PREFIX}/${S}`;const n=h(c,this.extension),r=f?f.item.handle:u.LABEL_HANDLE_PREFIX;let s=n?n.label:m?T.basename(m):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const l=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,v=this.getChildrenNodes(f)||[];let b,A=0;do{if(b=`${r}/${A}:${s}`,t||!this.elements.has(b)||l===b)break;A++}while(A<=v.length);return b}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon))return typeof p.iconPath=="string"||D.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return D.URI.isUri(p)?p:D.URI.file(p)}addNodeToCache(p,S){this.elements.set(S.item.handle,p),this.nodes.set(p,S)}updateNodeCache(p,S,c,m){this.elements.delete(S.item.handle),this.nodes.delete(p),S.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(p,S);const f=this.getChildrenNodes(m)||[],t=f.filter(n=>n.item.handle===c.item.handle)[0];t&&f.splice(f.indexOf(t),1,S)}addNodeToParentCache(p,S){S?(S.children||(S.children=[]),S.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const S=this.nodes.get(p);if(S){if(S.children)for(const c of S.children){const m=this.elements.get(c.item.handle);m&&this.clear(m)}S.children=void 0}}else this.clearAll()}clear(p){const S=this.nodes.get(p);if(S){if(S.children)for(const c of S.children){const m=this.elements.get(c.item.handle);m&&this.clear(m)}this.nodes.delete(p),this.elements.delete(S.item.handle),S.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}u.LABEL_HANDLE_PREFIX="0",u.ID_HANDLE_PREFIX="1"}),define(we[170],_e([0,1,16,11,18,10,65,9,6,94]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(w,p){if(p!==void 0){const S=this.testIdsToInternal.get(p),c=S==null?void 0:S.get(w);if(c)return[S,c]}return g.mapFind(this.testIdsToInternal.values(),S=>{const c=S.get(w);return c&&[S,c]})}createForHierarchy(w=()=>{}){return new d(this.createIdMap(o++),w)}createIdMap(w){const p=new h(w);return this.testIdsToInternal.set(p.id,p),{object:p,dispose:()=>this.testIdsToInternal.delete(p.id)}}}e.OwnedTestCollection=i;var P;(function(u){u[u.Disconnected=0]="Disconnected",u[u.IsChild=1]="IsChild",u[u.IsParent=2]="IsParent",u[u.IsSame=3]="IsSame"})(P=e.TestPosition||(e.TestPosition={}));let o=0;class h{constructor(w){this.id=w,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(w){if(this.map.has(w.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${w.item.extId}`);this.map.set(w.item.extId,w),w.parent||this._roots.add(w)}has(w){return this.map.has(w)}delete(w){const p=this.map.get(w);return p?(this.map.delete(w),this._roots.delete(p),!0):!1}get(w){return this.map.get(w)}comparePositions(w,p){const S=typeof w=="string"?this.map.get(w):w,c=typeof p=="string"?this.map.get(p):p;if(!S||!c)return 0;if(S===c)return 3;for(let m=this.map.get(c.parent);m;m=this.map.get(m.parent))if(m===S)return 1;for(let m=this.map.get(S.parent);m;m=this.map.get(m.parent))if(m===c)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class d{constructor(w,p){this.testIdToInternal=w,this.publishDiff=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(w,p){this.addItem(w,p,null)}getTestByReference(w){return this.testItemToInternal.get(w)}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){const p=this.diff[this.diff.length-1];if(p&&w[0]===1){if(p[0]===1&&p[1].extId===w[1].extId){I.applyTestItemUpdate(p[1],w[1]);return}if(p[0]===0&&p[1].item.extId===w[1].extId){I.applyTestItemUpdate(p[1],w[1]);return}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,p){var S;const c=this.testIdToInternal.object.get(w);if(!!c){if((c.expandLevels===void 0||p>c.expandLevels)&&(c.expandLevels=p),c.expand===1){const m=this.refreshChildren(c);return m.isSettled?this.expandChildren(c,p-1):m.p.then(()=>this.expandChildren(c,p-1))}else if(c.expand===3)return((S=c.initialExpand)===null||S===void 0?void 0:S.isSettled)===!1?c.initialExpand.p.then(()=>this.expandChildren(c,p-1)):this.expandChildren(c,p-1)}}dispose(){var w;for(const p of this.testItemToInternal.values())(w=p.discoverCts)===null||w===void 0||w.dispose(!0),k.getPrivateApiFor(p.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(w,p){const S=w==null?void 0:w.actual.id;switch(p[0]){case 2:this.pushDiff([4,S]);break;case 1:this.removeItem(w);break;case 0:this.addItem(p[1],w.src.controller,w);break;case 3:const[c,m,f]=p;switch(m){case"status":this.updateExpandability(w);break;case"range":this.pushDiff([1,{extId:S,item:{range:y.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:y.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[m]:f??null}}]);break}break;default:E.assertNever(p[0])}}addItem(w,p,S){if(!(w instanceof _.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${w.id} did not`);if(this.testItemToInternal.has(w))throw new Error(`Attempted to add a single TestItem ${w.id} multiple times to the tree`);if(this.testIdToInternal.object.has(w.id))throw new Error(`Attempted to insert a duplicate test item ID ${w.id}`);const c=S?S.item.extId:null,m=w.resolveHandler?1:0,f=S?S.expandLevels:1,t={controller:p,tree:this.testIdToInternal.object.id},n={actual:w,parent:c,item:y.TestItem.from(w),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(w,n),this.pushDiff([0,{parent:c,src:t,expand:m,item:n.item}]);const r=k.getPrivateApiFor(w);r.parent=S==null?void 0:S.actual,r.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of r.children.values())this.testItemToInternal.has(s)||this.addItem(s,p,n)}updateExpandability(w){var p;let S;w.actual.resolveHandler?w.actual.status===_.TestItemStatus.Pending?S=w.discoverCts?2:1:((p=w.initialExpand)===null||p===void 0||p.complete(),S=3):S=0,S!==w.expand&&(w.expand=S,this.pushDiff([1,{extId:w.actual.id,expand:S}]),S===1&&w.expandLevels!==void 0&&this.refreshChildren(w))}expandChildren(w,p){if(p<0)return;const S=[...w.actual.children.values()].map(c=>this.expand(c.id,p)).filter(T.isThenable);if(S.length)return Promise.all(S).then(()=>{})}refreshChildren(w){if(w.discoverCts&&w.discoverCts.dispose(!0),!w.actual.resolveHandler){const p=new T.DeferredPromise;return p.complete(),p}return w.expand=2,w.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(w),w.initialExpand=new T.DeferredPromise,w.actual.resolveHandler(w.discoverCts.token),w.initialExpand}pushExpandStateUpdate(w){this.pushDiff([1,{extId:w.actual.id,expand:w.expand}])}removeItem(w){var p;this.pushDiff([2,w.actual.id]);const S=[w];for(;S.length;){const c=S.pop();if(!!c){(p=c.discoverCts)===null||p===void 0||p.dispose(!0),this.testIdToInternal.object.delete(c.item.extId),this.testItemToInternal.delete(c.actual);for(const m of c.actual.children.values())S.push(this.testIdToInternal.object.get(m.id))}}}flushDiff(){const w=this.collectDiff();w.length&&this.publishDiff(w)}}e.SingleUseTestCollection=d}),define(we[171],_e([0,1,26,3,13]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=E;class k{constructor(i){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let P of i.activationEvents)P==="onUri"&&(P=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(P)||this._activationMap.set(P,[]),this._activationMap.get(P).push(i)}}keepOnly(i){const P=new Set;i.forEach(o=>P.add(g.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>P.has(g.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,P){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const o=k._findLoopingExtensions(this._extensionDescriptions);if(P=P.concat(o.map(h=>h.identifier)),P.length>0){const h=new Set;P.forEach(d=>h.add(g.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>!h.has(g.ExtensionIdentifier.toKey(d.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(o)}static _findLoopingExtensions(i){const P=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,p){this.addNode(w),this.addNode(p),this._arcs.has(w)?this._arcs.get(w).push(p):this._arcs.set(w,[p])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,p){const S=P.getArcs(w);for(let c=0;c<S.length;c++)if(!p.has(S[c]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let w of i){const p=g.ExtensionIdentifier.toKey(w.identifier);if(o.set(p,w),w.extensionDependencies)for(let S of w.extensionDependencies){const c=g.ExtensionIdentifier.toKey(S);P.addArc(p,c)}}let h=new Set;P.getNodes().filter(w=>P.getArcs(w).length===0).forEach(w=>h.add(w));let d=P.getNodes().filter(w=>!h.has(w)),u;do{u=!1;for(let w=0;w<d.length;w++){const p=d[w];P.hasOnlyGoodArcs(p,h)&&(d.splice(w,1),w--,h.add(p),u=!0)}}while(u);return d.map(w=>o.get(w))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const P=this._activationMap.get(i);return P?P.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const P=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return P||void 0}}e.ExtensionDescriptionRegistry=k;var y;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(y||(y={}));function _(I,i){const P=I.isBuiltin?0:I.isUnderDevelopment?2:1,o=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(P!==o)return P-o;const h=D.posix.basename(I.extensionLocation.path),d=D.posix.basename(i.extensionLocation.path);return h<d?-1:h>d?1:0}}),define(we[172],_e([0,1,23]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function E(y){const _=g.VSBuffer.alloc(1);switch(y){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function k(y,_){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(we[29],_e([0,1,3,2,5,26,143]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=D.createDecorator("extensionService");class y{constructor(S){this.dependency=S}}e.MissingExtensionDependency=y;var _;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class I{constructor(S,c,m,f){this.codeLoadingTime=S,this.activateCallTime=c,this.activateResolvedTime=m,this.activationReason=f}}e.ActivationTimes=I;class i{constructor(S,c){this.description=S,this.value=c}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var P;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(P=e.ActivationKind||(e.ActivationKind={}));function o(p){p.enableProposedApi||h(p)}e.checkProposedApiEnabled=o;function h(p){throw new Error(`[${p.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.throwProposedApiError=h;function d(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=d;function u(p){return Object.assign(Object.assign({identifier:new E.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!1,extensionLocation:p.location},p.manifest),{uuid:p.identifier.uuid})}e.toExtensionDescription=u;class w{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(S){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(S){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(S){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(S){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(S,c){return Promise.resolve()}_onWillActivateExtension(S){}_onDidActivateExtension(S,c,m,f,t){}_onDidActivateExtensionError(S,c){}_onExtensionRuntimeError(S,c){}_onExtensionHostExit(S){}}e.NullExtensionService=w}),define(we[173],_e([0,1,26,29,17]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(d,u,w,p){this.startup=d,this.codeLoadingTime=u,this.activateCallTime=w,this.activateResolvedTime=p}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class y{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,u){return d===-1||u===-1?-1:u-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class _{constructor(d,u,w,p,S,c){this.activationFailed=d,this.activationFailedError=u,this.activationTimes=w,this.module=p,this.exports=S,this.subscriptions=c}}e.ActivatedExtension=_;class I extends _{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class i extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class P extends _{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=P;let o=class{constructor(d,u,w,p,S){this._logService=S,this._registry=d,this._resolvedExtensionsSet=new Set,u.forEach(c=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,w.forEach(c=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(c),c)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(d){const u=g.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(u)}getActivatedExtension(d){const u=g.ExtensionIdentifier.toKey(d),w=this._activatedExtensions.get(u);if(!w)throw new Error("Extension `"+d.value+"` is not known or not activated");return w}activateByEvent(d,u){if(this._alreadyActivatedEvents[d])return E;const w=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(w.map(p=>({id:p.identifier,reason:{startup:u,extensionId:p.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,u){const w=this._registry.getExtensionDescription(d);if(!w)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:w.identifier,reason:u}])}_handleActivateRequest(d,u,w){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(d.id))){u[g.ExtensionIdentifier.toKey(d.id)]=d;return}const p=this._registry.getExtensionDescription(d.id);if(!p){const m=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,m,new T.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(d.id),new P(m));return}const S=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let c=!0;for(let m=0,f=S.length;m<f;m++){const t=S[m];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const v=p.displayName||p.identifier.value,b=this._registry.getExtensionDescription(t),A=b&&b.displayName||t,C=new Error(`Cannot activate the '${v}' extension because its dependency '${A}' failed to activate`);C.detail=n.activationFailedError,this._host.onExtensionActivationError(p.identifier,C,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(p.identifier),new P(C));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){c=!1,u[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:d.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){c=!1,u[g.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:d.reason};continue}const s=p.displayName||p.identifier.value,l=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(p.identifier,l,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(p.identifier),new P(l));return}c?u[g.ExtensionIdentifier.toKey(p.identifier)]=d:w.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(S=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(S.id))),d.length===0))return Promise.resolve(void 0);const u=Object.create(null),w=[];for(let S=0,c=d.length;S<c;S++)this._handleActivateRequest(d[S],u,w);for(let S=0,c=w.length;S<c;S++){const m=g.ExtensionIdentifier.toKey(w[S].id);u[m]&&delete u[m]}const p=Object.keys(u).map(S=>u[S]);return w.length===0?Promise.all(p.map(S=>this._activateExtension(S.id,S.reason))).then(S=>{}):this._activateExtensions(p).then(S=>this._activateExtensions(w))}_activateExtension(d,u){const w=g.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const p=this._activatingExtensions.get(w);if(p)return p;const S=this._host.actualActivateExtension(d,u).then(void 0,c=>{const m=new Error;return c&&c.name&&(m.name=c.name),c&&c.message?m.message=`Activating extension '${d.value}' failed: ${c.message}.`:m.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(m.stack=c.stack),this._host.onExtensionActivationError(d,m,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new P(c)}).then(c=>{this._activatedExtensions.set(w,c),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,S),S}};o=Ve([je(4,D.ILogService)],o),e.ExtensionsActivator=o}),define(we[174],_e([0,1,12]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,k)=>{this._actualOk=E,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):g.onUnexpectedError(E))}then(E,k){return this._ensureActual().then(E,k)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=T}),define(we[97],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,I){this.isMain=_,this.sid=I,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const T=[];function D(y){const _=new g(!0,y);return T[_.nid]=_,_}e.createMainContextProxyIdentifier=D;function E(y){const _=new g(!1,y);return T[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function k(y){return T[y].sid}e.getStringIdentifierForProxy=k}),define(we[4],_e([0,1,54,2,97]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(y=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var P;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(P=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(c){c.name="$ident";function m(t,n){return Object.defineProperty(t,c.name,{value:n,enumerable:!0}),t}c.mixin=m;function f(t){return t[c.name]}c.of=f})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(m){return m._id=h._n++,m}}e.IdObject=h,h._n=0;var d;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n",c.label2="o"})(d=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var u;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(u=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function p(c){if(c&&c.edits)for(const m of c.edits)typeof m.resource=="object"?m.resource=T.URI.revive(m.resource):(m.newUri=T.URI.revive(m.newUri),m.oldUri=T.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=g.revive(m.metadata));return c}e.reviveWorkspaceEditDto=p;var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:D.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:D.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:D.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:D.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:D.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:D.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:D.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:D.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:D.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:D.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:D.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:D.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:D.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:D.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:D.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:D.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:D.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:D.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:D.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:D.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:D.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:D.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:D.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:D.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:D.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:D.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:D.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:D.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:D.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:D.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:D.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:D.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:D.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:D.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:D.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:D.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:D.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:D.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:D.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:D.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:D.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:D.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:D.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:D.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:D.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:D.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:D.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:D.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:D.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:D.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:D.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:D.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:D.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:D.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:D.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:D.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:D.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:D.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:D.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:D.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:D.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:D.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:D.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:D.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:D.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:D.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:D.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:D.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:D.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:D.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:D.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:D.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:D.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:D.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:D.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:D.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:D.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:D.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:D.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:D.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:D.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:D.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:D.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:D.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:D.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:D.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:D.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:D.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:D.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:D.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:D.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:D.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:D.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:D.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:D.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:D.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:D.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:D.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:D.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:D.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:D.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:D.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(we[69],_e([0,1,4,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(y){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=y.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(y){this._onDidChangePassword.fire(y)}get(y,_){return this._proxy.$getPassword(y,_)}store(y,_,I){return this._proxy.$setPassword(y,_,I)}delete(y,_){return this._proxy.$deletePassword(y,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=D.createDecorator("IExtHostSecretState")}),define(we[70],_e([0,1,5,17,4,14]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=g.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(D.MainContext.MainThreadTelemetry)}report(_,I,i){const P=this.getUsageKey(_,I);this._reportedUsages.has(P)||(this._reportedUsages.add(P),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};k=Ve([je(0,E.IExtHostRpcService),je(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(y,_,I){}})}),define(we[175],_e([0,1,3,4,6,26]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new g.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,I,i,P={}){const o=E.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(o)||[],d=[...i].sort().join(" ");let u=h.find(w=>w.scopes===d);if(u)return u.result;{const w=this._getSession(_,o,I,i,P);u={scopes:d,result:w},h.push(u),this._inFlightRequests.set(o,h);try{await w}finally{const p=h.findIndex(S=>S.scopes===d);p>-1&&(h.splice(p),this._inFlightRequests.set(o,h))}return w}}async _getSession(_,I,i,P,o={}){await this._proxy.$ensureProvider(i);const h=_.displayName||_.name;return this._proxy.$getSession(i,P,I,h,o)}async removeSession(_,I){const i=this._authenticationProviders.get(_);return i?i.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,i,P){var o;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:i,options:P??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===_)||this._providers.push({id:_,label:I});const h=i.onDidChangeSessions(d=>{var u,w,p;this._proxy.$sendDidChangeSessions(_,{added:(u=d.added)!==null&&u!==void 0?u:[],changed:(w=d.changed)!==null&&w!==void 0?w:[],removed:(p=d.removed)!==null&&p!==void 0?p:[]})});return this._proxy.$registerAuthenticationProvider(_,I,(o=P==null?void 0:P.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new D.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const d=this._providers.findIndex(u=>u.id===_);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const i=this._authenticationProviders.get(_);if(i)return Promise.resolve(i.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,I){return _.forEach(i=>{this._providers.some(P=>P.id===i.id)||this._providers.push(i)}),I.forEach(i=>{const P=this._providers.findIndex(o=>o.id===i.id);P>-1&&this._providers.splice(P)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:I}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(we[176],_e([0,1,4,14,9]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(y,_){this._extHostDocumentsAndEditors=_,this._proxy=y.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(y){const _=D.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=Ve([je(0,T.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(we[177],_e([0,1,4]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(E){const k=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(y){return k.$writeText(y)}})}}e.ExtHostClipboard=T}),define(we[71],_e([0,1,10,6,9,24,4,16,17,54,31,35,2,7,5,14]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=n,this.converter=new p(this,r=>{const s=this._apiCommands.get(r);return(s==null?void 0:s.result)===c.Void?s:void 0},n),this._argumentProcessors=[{processArgument(r){return I.revive(r)}},{processArgument(r){return E.cloneAndChange(r,function(s){if(i.Range.isIRange(s))return D.Range.to(s);if(P.Position.isIPosition(s))return D.Position.to(s);if(i.Range.isIRange(s.range)&&o.URI.isUri(s.uri))return D.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...r)=>{const s=t.args.map((v,b)=>{if(!v.validate(r[b]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${r[b]}`);return v.convert(r[b])}),l=await this.executeCommand(t.internalId,...s);return t.result.convert(l,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,r,s,l){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:r,thisArg:s,description:l}),t&&this._proxy.$registerCommand(n),new T.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,r){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=E.cloneAndChange(n,function(l){if(l instanceof T.Position)return D.Position.from(l);if(l instanceof T.Range)return D.Range.from(l);if(l instanceof T.Location)return D.location.from(l);if(T.NotebookRange.isNotebookRange(l))return D.NotebookRange.from(l);if(!Array.isArray(l))return l});try{const l=await this._proxy.$executeCommand(t,s,r);return I.revive(l)}catch(l){if(l instanceof Error&&l.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw l}}}async _executeContributedCommand(t,n){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:s,thisArg:l,description:v}=r;if(v)for(let b=0;b<v.args.length;b++)try{g.validateConstraint(n[b],v.args[b].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[b].name}' - ${v.args[b].description}`)}try{return await s.apply(l,n)}catch(b){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...n);A&&(t=A.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(r=>this._argumentProcessors.reduce((s,l)=>l.processArgument(s),r)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(r=>r[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,r]of this._commands){let{description:s}=r;s&&(t[n]=s)}return Promise.resolve(t)}};w=Ve([je(0,u.IExtHostRpcService),je(1,_.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=d.createDecorator("IExtHostCommands");class p{constructor(t,n,r){this._commands=t,this._lookupApiCommand=n,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const s=this._lookupApiCommand(t.command);if(s)r.id=s.internalId,r.arguments=s.args.map((l,v)=>l.convert(t.arguments&&t.arguments[v]));else if(y.isNonEmptyArray(t.arguments)){const l=++this._cachIdPool;this._cache.set(l,t),n.add(h.toDisposable(()=>{this._cache.delete(l),this._logService.trace("CommandsConverter#DISPOSE",l)})),r.$ident=l,r.id=this.delegatingCommandId,r.arguments=[l],this._logService.trace("CommandsConverter#CREATE",t.command,l)}return r}fromInternal(t){const n=k.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class S{constructor(t,n,r,s){this.name=t,this.description=n,this.validate=r,this.convert=s}optional(){return new S(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new S(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=S,S.Uri=new S("uri","Uri of a text document",f=>o.URI.isUri(f),f=>f),S.Position=new S("position","A position in a text document",f=>T.Position.isPosition(f),D.Position.from),S.Range=new S("range","A range in a text document",f=>T.Range.isRange(f),D.Range.from),S.Selection=new S("selection","A selection in a text document",f=>T.Selection.isSelection(f),D.Selection.from),S.Number=new S("number","",f=>typeof f=="number",f=>f),S.String=new S("string","",f=>typeof f=="string",f=>f),S.CallHierarchyItem=new S("item","A call hierarchy item",f=>f instanceof T.CallHierarchyItem,D.CallHierarchyItem.to);class c{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=c,c.Void=new c("no result",f=>f);class m{constructor(t,n,r,s,l){this.id=t,this.internalId=n,this.description=r,this.args=s,this.result=l}}e.ApiCommand=m}),define(we[178],_e([0,1,9,6,58,71,16,85]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,h)=>{if(k.isFalsyOrEmpty(o))return;class d extends T.SymbolInformation{static to(w){const p=new d(w.name,g.SymbolKind.to(w.kind),w.containerName||"",new T.Location(h[0],g.Range.to(w.range)));return p.detail=w.detail,p.range=p.location.range,p.selectionRange=g.Range.to(w.selectionRange),p.children=w.children?w.children.map(d.to):[],p}}return o.map(d.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",P)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(h=>T.Position.isPosition(h)),o=>o.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(h=>{let d;for(const u of h.reverse())d=new T.SelectionRange(g.Range.to(u),d);return d}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const h=[];if(Array.isArray(o))for(let d of o)h.push(...d[1].map(g.WorkspaceSymbol.to));return h})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return g.WorkspaceEdit.to(o)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=y.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=y.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,h,d)=>{if(!o)return new T.CompletionList([]);const u=o.suggestions.map(w=>g.CompletionItem.to(w,d));return new T.CompletionList(u,o.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return g.SignatureHelp.to(o)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,h,d)=>i(u=>new T.CodeLens(g.Range.to(u.range),u.command&&d.fromInternal(u.command)))(o))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?g.Selection.from(o):g.Range.from(o)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,h,d)=>i(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(u.command)}else{const w=new T.CodeAction(u.title,u.kind?new T.CodeActionKind(u.kind):void 0);return u.edit&&(w.edit=g.WorkspaceEdit.to(u.edit)),u.command&&(w.command=d.fromInternal(u.command)),w.isPreferred=u.isPreferred,w}})(o))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(h=>new T.ColorInformation(g.Range.to(h.range),g.Color.to(h.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:g.Range.from(o.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(h=>g.NotebookExclusiveDocumentPattern.to(h))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)]).optional()],E.ApiCommandResult.Void)];class I{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=I;function i(o){return h=>{if(Array.isArray(h))return h.map(o)}}function P(o){if(!Array.isArray(o))return;const h=[];for(const d of o)D.isLocationLink(d)?h.push(g.DefinitionLink.to(d)):h.push(g.location.to(d));return h}}),define(we[179],_e([0,1,11,47,3,7,2,58,26,9,6,4]),function(Z,e,g,T,D,E,k,y,_,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(m,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=m.getProxy(P.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r||n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let l=n.commentUniqueId,v=s.getCommentByUniqueId(l);return v||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let l=n.text,v=n.commentUniqueId,b=s.getCommentByUniqueId(v);return b?(b.body=l,b):n}return n}})}createCommentController(m,f,t){const n=o.handlePool++,r=new d(m,n,this._proxy,f,t);this._commentControllers.set(r.handle,r);const s=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(m.identifier))||[];return s.push(r),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(m.identifier),s),r}$createCommentThreadTemplate(m,f,t){const n=this._commentControllers.get(m);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(m,f,t){const n=this._commentControllers.get(m);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(m,f){const t=this._commentControllers.get(m);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(m,f,t){const n=this._commentControllers.get(m);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(k.URI.revive(f));return g.asPromise(()=>n.commentingRangeProvider.provideCommentingRanges(r,t)).then(s=>s?s.map(l=>I.Range.from(l)):void 0)}$toggleReaction(m,f,t,n,r){const s=this._commentControllers.get(m);return!s||!s.reactionHandler?Promise.resolve(void 0):g.asPromise(()=>{const l=s.getCommentThread(f);if(l){const v=l.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&v&&s.reactionHandler)return s.reactionHandler(v,p(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class h{constructor(m,f,t,n,r,s,l){this._proxy=m,this._commentController=f,this._id=t,this._uri=n,this._range=r,this._comments=s,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,I.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(m){this._id=m}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(m){m.isEqual(this._range)||(this._range=m,this.modifications.range=m,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(m){this._canReply!==m&&(this._canReply=m,this.modifications.canReply=m,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(m){this._label=m,this.modifications.label=m,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(m){this._contextValue=m,this.modifications.contextValue=m,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(m){this._comments=m,this.modifications.comments=m,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(m){this._collapseState=m,this.modifications.collapsibleState=m,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const m=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};m("range")&&(f.range=I.Range.from(this._range)),m("label")&&(f.label=this.label),m("contextValue")&&(f.contextValue=this.contextValue),m("comments")&&(f.comments=this._comments.map(t=>u(this,this._commentController,t,this._commentsMap))),m("collapsibleState")&&(f.collapseState=S(this._collapseState)),m("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(m){for(let f of this._commentsMap){let t=f[0],n=f[1];if(m===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(m=>m.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([T.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class d{constructor(m,f,t,n,r){this._extension=m,this._handle=f,this._proxy=t,this._id=n,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(m){this._reactionHandler=m,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this._options}set options(m){this._options=m,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(m,f,t,n){if(typeof m=="string"){const r=new h(this._proxy,this,m,f,t,n,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new h(this._proxy,this,void 0,m,f,t,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(m,f){const t=new h(this._proxy,this,void 0,k.URI.revive(m),I.Range.to(f),[],this._extension.identifier);return t.collapsibleState=y.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(m,f){let t=this._threads.get(m);t&&(t.range=I.Range.to(f))}$deleteCommentThread(m){let f=this._threads.get(m);f&&f.dispose(),this._threads.delete(m)}getCommentThread(m){return this._threads.get(m)}dispose(){this._threads.forEach(m=>{m.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function u(c,m,f,t){let n=t.get(f);n||(n=++c.commentHandle,t.set(f,n));const r=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:I.MarkdownString.from(f.body),userName:f.author.name,userIconPath:r,label:f.label,commentReactions:f.reactions?f.reactions.map(s=>w(s)):void 0}}function w(c){return{label:c.label,iconPath:c.iconPath?I.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function p(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?k.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function S(c){if(c!==void 0)switch(c){case i.CommentThreadCollapsibleState.Expanded:return y.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return y.CommentThreadCollapsibleState.Collapsed}return y.CommentThreadCollapsibleState.Collapsed}}),define(we[98],_e([0,1,2,4,6,5,14,17,16,8,13]),function(Z,e,g,T,D,E,k,y,_,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let P=class vn{constructor(h,d){this._logService=d,this._provider=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,d){const u=vn._handlePool++;this._provider.set(u,{provider:h,extensionId:d}),this._proxy.$registerDecorationProvider(u,d.value);const w=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(u,null);return}let S=_.asArray(p);if(S.length<=vn._maxEventSize){this._proxy.$onDidChange(u,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",d.value,S.length);const c=S.map(t=>({uri:t,rank:I.count(t.path,"/")})),m=_.groupBy(c,(t,n)=>t.rank-n.rank||I.compare(t.uri.path,n.uri.path));let f=[];e:for(let t of m){let n;for(let r of t){let s=i.dirname(r.uri.path);if(n!==s&&(n=s,f.push(r.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(u,f)});return new D.Disposable(()=>{w==null||w.dispose(),this._proxy.$unregisterDecorationProvider(u),this._provider.delete(u)})}async $provideDecorations(h,d,u){if(!this._provider.has(h))return Object.create(null);const w=Object.create(null),{provider:p,extensionId:S}=this._provider.get(h);return await Promise.all(d.map(async c=>{try{const{uri:m,id:f}=c,t=await Promise.resolve(p.provideFileDecoration(g.URI.revive(m),u));if(!t)return;try{D.FileDecoration.validate(t),w[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${S.value}': ${n}`)}}catch(m){this._logService.error(m)}})),w}};P._handlePool=0,P._maxEventSize=250,P=Ve([je(0,k.IExtHostRpcService),je(1,y.ILogService)],P),e.ExtHostDecorations=P,e.IExtHostDecorations=E.createDecorator("IExtHostDecorations")}),define(we[180],_e([0,1,127,89,2,4,6,9,3,17,22]),function(Z,e,g,T,D,E,k,y,_,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class P{constructor(d,u,w,p,S){this._name=d,this._owner=u,this._maxDiagnosticsPerFile=w,this._proxy=p,this._onDidChangeDiagnostics=S,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(d,u){if(!d){this.clear();return}this._checkDisposed();let w=[];if(D.URI.isUri(d)){if(!u){this.delete(d);return}this._data.set(d,u.slice()),w=[d]}else if(Array.isArray(d)){w=[];let S;d=[...d].sort(P._compareIndexedTuplesByUri);for(const c of d){const[m,f]=c;if((!S||m.toString()!==S.toString())&&(S&&this._data.get(S).length===0&&this._data.delete(S),S=m,w.push(m),this._data.set(m,[])),f){const t=this._data.get(m);t&&t.push(...f)}else{const t=this._data.get(m);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const p=[];for(let S of w){let c=[];const m=this._data.get(S);if(m)if(m.length>this._maxDiagnosticsPerFile){c=[];const f=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of m)if(n.severity===f[t]&&c.push(y.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;c.push({severity:T.MarkerSeverity.Info,message:g.localize(0,null,m.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=m.map(f=>y.Diagnostic.from(f));p.push([S,c])}this._proxy.$changeMany(this._owner,p)}delete(d){this._checkDisposed(),this._onDidChangeDiagnostics.fire([d]),this._data.delete(d),this._proxy&&this._proxy.$changeMany(this._owner,[[d,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(d,u){this._checkDisposed();for(let w of this._data.keys())d.apply(u,[w,this.get(w),this])}get(d){this._checkDisposed();const u=this._data.get(d);return Array.isArray(u)?Object.freeze(u.slice(0)):[]}has(d){return this._checkDisposed(),Array.isArray(this._data.get(d))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(d,u){return d[0].toString()<u[0].toString()?-1:d[0].toString()>u[0].toString()?1:0}}e.DiagnosticCollection=P;let o=class zt{constructor(d,u){this._logService=u,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=d.getProxy(E.MainContext.MainThreadDiagnostics)}static _debouncer(d,u){return d?d.concat(u):u}static _mapper(d){const u=new i.ResourceMap;for(const w of d)u.set(w,w);return{uris:Object.freeze(Array.from(u.values()))}}createDiagnosticCollection(d,u){const{_collections:w,_proxy:p,_onDidChangeDiagnostics:S,_logService:c}=this,m=new class{$changeMany(n,r){p.$changeMany(n,r),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,n,r.length===0?"CLEARING":r)}$clear(n){p.$clear(n),c.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,n)}dispose(){p.dispose()}};let f;if(!u)u="_generated_diagnostic_collection_name_#"+zt._idPool++,f=u;else if(!w.has(u))f=u;else{this._logService.warn(`DiagnosticCollection with name '${u}' does already exist.`);do f=u+zt._idPool++;while(w.has(f))}return new class extends P{constructor(){super(u,f,zt._maxDiagnosticsPerFile,m,S);w.set(f,this)}dispose(){super.dispose(),w.delete(f)}}}getDiagnostics(d){if(d)return this._getDiagnostics(d);{const u=new Map,w=[];for(const p of this._collections.values())p.forEach((S,c)=>{let m=u.get(S.toString());typeof m=="undefined"&&(m=w.length,u.set(S.toString(),m),w.push([S,[]])),w[m][1]=w[m][1].concat(...c)});return w}}_getDiagnostics(d){let u=[];for(let w of this._collections.values())w.has(d)&&(u=u.concat(w.get(d)));return u}$acceptMarkersChange(d){if(!this._mirrorCollection){const u="_generated_mirror",w=new P(u,u,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(u,w),this._mirrorCollection=w}for(const[u,w]of d)this._mirrorCollection.set(D.URI.revive(u),w.map(y.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([je(1,I.ILogService)],o),e.ExtHostDiagnostics=o}),define(we[181],_e([0,1,2,4]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(y=>y?y.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(y=>y?g.URI.revive(y):void 0)}}e.ExtHostDialogs=D}),define(we[182],_e([0,1,12,2,6,4,15,18,8]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(P,o,h){this._documentsAndEditors=o,this._logService=h,this._documentContentProviders=new Map,this._proxy=P.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,o){if(Object.keys(k.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const h=I._handlePool++;this._documentContentProviders.set(h,o),this._proxy.$registerTextContentProvider(h,P);let d;return typeof o.onDidChange=="function"&&(d=o.onDidChange(u=>{if(u.scheme!==P){this._logService.warn(`Provider for scheme '${P}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(u)&&this.$provideTextDocumentContent(h,u).then(w=>{if(!w&&typeof w!="string")return;const p=this._documentsAndEditors.getDocument(u);if(!p)return;const S=_.splitLines(w);if(!p.equalLines(S))return this._proxy.$onVirtualDocumentChange(u,w)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(P,o){const h=this._documentContentProviders.get(P);return h?Promise.resolve(h.provideTextDocumentContent(T.URI.revive(o),y.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(we[183],_e([0,1,3,7,2,4,93,9,10,24]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(o,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const u of d)this._onDidRemoveDocument.fire(u.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const u of d)this._onDidAddDocument.fire(u.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const h=this._documentsAndEditors.getDocument(o);if(h)return h}getDocument(o){const h=this.getDocumentData(o);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return h.document}ensureDocumentData(o){const h=this._documentsAndEditors.getDocument(o);if(h)return Promise.resolve(h);let d=this._documentLoader.get(o.toString());return d||(d=this._proxy.$tryOpenDocument(o).then(u=>{this._documentLoader.delete(o.toString());const w=D.URI.revive(u);return _.assertIsDefined(this._documentsAndEditors.getDocument(w))},u=>(this._documentLoader.delete(o.toString()),Promise.reject(u))),this._documentLoader.set(o.toString(),d)),d}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(h=>D.URI.revive(h))}$acceptModelModeChanged(o,h){const d=D.URI.revive(o),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");this._onDidRemoveDocument.fire(u.document),u._acceptLanguageId(h),this._onDidAddDocument.fire(u.document)}$acceptModelSaved(o){const h=D.URI.revive(o),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(o,h){const d=D.URI.revive(o),u=this._documentsAndEditors.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(h),this._onDidChangeDocument.fire({document:u.document,contentChanges:[]})}$acceptModelChanged(o,h,d){const u=D.URI.revive(o),w=this._documentsAndEditors.getDocument(u);if(!w)throw new Error("unknown document");w._acceptIsDirty(d),w.onEvents(h),this._onDidChangeDocument.fire(I.deepFreeze({document:w.document,contentChanges:h.changes.map(p=>({range:y.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text}))}))}setWordDefinitionFor(o,h){k.setWordDefinitionFor(o,h)}}e.ExtHostDocuments=i}),define(we[36],_e([0,1,39,3,7,2,5,4,93,14,96,9,17,22,15,50,106]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(m,f){this._extHostRpc=m,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const f=[],t=[],n=[];if(m.removedDocuments)for(const r of m.removedDocuments){const s=E.URI.revive(r),l=this._documents.get(s);(l==null?void 0:l.unref())&&(this._documents.delete(s),f.push(l.value))}if(m.addedDocuments)for(const r of m.addedDocuments){const s=E.URI.revive(r.uri);let l=this._documents.get(s);if(l&&s.scheme!==d.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);l||(l=new p(new _.ExtHostDocumentData(this._extHostRpc.getProxy(y.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,l),t.push(l.value)),l.ref()}if(m.removedEditors)for(const r of m.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&n.push(s)}if(m.addedEditors)for(const r of m.addedEditors){const s=E.URI.revive(r.documentUri);g.ok(this._documents.has(s),`document '${s}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(s).value,v=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(y.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>l.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(b=>P.Range.to(b)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,v)}m.newActiveEditor!==void 0&&(g.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),D.dispose(f),D.dispose(n),m.removedDocuments&&this._onDidRemoveDocuments.fire(f),m.addedDocuments&&this._onDidAddDocuments.fire(t),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){var f;return(f=this._documents.get(m))===null||f===void 0?void 0:f.value}allDocuments(){return u.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return m?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};S=Ve([je(0,I.IExtHostRpcService),je(1,o.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(we[184],_e([0,1,2,4,7,6,9,117,8,23]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const d=this._schemes.indexOf(h);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),d=[];let u,w,p=14,S=14;for(const c of h){let m=u?_.commonPrefixLength(u,c):0;for(m===0?w=1:w=S;m<c.length;m++)m+1===c.length?(p=S,S=9):S+=1,d.push([w,c.toUpperCase().charCodeAt(m),S]),d.push([w,c.toLowerCase().charCodeAt(m),S]),w=S;u=c,S=p}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new y.StateMachine(d)}}provideDocumentLinks(h){this._initStateMachine();const d=[],u=y.LinkComputer.computeLinks({getLineContent(w){return h.lineAt(w-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const w of u){const p=k.DocumentLink.to(w);p.target&&d.push(p)}return d}}class P{constructor(h,d){this._extHostLanguageFeatures=d,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,d,u,w={},p){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const S=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(S,u),this._enableProposedApi.set(S,p??!1);let c=2;w.isCaseSensitive&&(c+=1024),w.isReadonly&&(c+=2048),typeof u.copy=="function"&&(c+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(S,d,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${d}`),console.error(f)});const m=u.onDidChangeFile(f=>{const t=[];for(const n of f){let{uri:r,type:s}=n;if(r.scheme!==d)continue;let l;switch(s){case E.FileChangeType.Changed:l=0;break;case E.FileChangeType.Created:l=1;break;case E.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:l})}this._proxy.$onFileSystemChange(S,t)});return D.toDisposable(()=>{m.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(S),this._enableProposedApi.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(h,d){const{type:u,ctime:w,mtime:p,size:S,permissions:c}=h;return d?{type:u,ctime:w,mtime:p,size:S,permissions:c}:{type:u,ctime:w,mtime:p,size:S}}$stat(h,d){return Promise.resolve(this._getFsProvider(h).stat(g.URI.revive(d))).then(u=>{var w;return P._asIStat(u,(w=this._enableProposedApi.get(h))!==null&&w!==void 0?w:!1)})}$readdir(h,d){return Promise.resolve(this._getFsProvider(h).readDirectory(g.URI.revive(d)))}$readFile(h,d){return Promise.resolve(this._getFsProvider(h).readFile(g.URI.revive(d))).then(u=>I.VSBuffer.wrap(u))}$writeFile(h,d,u,w){return Promise.resolve(this._getFsProvider(h).writeFile(g.URI.revive(d),u.buffer,w))}$delete(h,d,u){return Promise.resolve(this._getFsProvider(h).delete(g.URI.revive(d),u))}$rename(h,d,u,w){return Promise.resolve(this._getFsProvider(h).rename(g.URI.revive(d),g.URI.revive(u),w))}$copy(h,d,u,w){const p=this._getFsProvider(h);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(g.URI.revive(d),g.URI.revive(u),w))}$mkdir(h,d){return Promise.resolve(this._getFsProvider(h).createDirectory(g.URI.revive(d)))}$watch(h,d,u,w){const p=this._getFsProvider(h).watch(g.URI.revive(u),w);this._watches.set(d,p)}$unwatch(h,d){const u=this._watches.get(d);u&&(u.dispose(),this._watches.delete(d))}$open(h,d,u){const w=this._getFsProvider(h);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(g.URI.revive(d),u))}$close(h,d){const u=this._getFsProvider(h);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(d))}$read(h,d,u,w){const p=this._getFsProvider(h);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const S=I.VSBuffer.alloc(w);return Promise.resolve(p.read(d,u,S.buffer,0,w)).then(c=>S.slice(0,c))}$write(h,d,u,w){const p=this._getFsProvider(h);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(d,u,w.buffer,0,w.byteLength))}_getFsProvider(h){const d=this._fsProvider.get(h);if(!d){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return d}}e.ExtHostFileSystem=P}),define(we[72],_e([0,1,4,59,6,23,5,14,44]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Ut{constructor(P,o){const h=P.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(d){return h.$stat(d).catch(Ut._handleError)},readDirectory(d){return h.$readdir(d).catch(Ut._handleError)},createDirectory(d){return h.$mkdir(d).catch(Ut._handleError)},async readFile(d){return h.$readFile(d).then(u=>u.buffer).catch(Ut._handleError)},writeFile(d,u){return h.$writeFile(d,E.VSBuffer.wrap(u)).catch(Ut._handleError)},delete(d,u){return h.$delete(d,Object.assign({recursive:!1,useTrash:!1},u)).catch(Ut._handleError)},rename(d,u,w){return h.$rename(d,u,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},copy(d,u,w){return h.$copy(d,u,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},isWritableFileSystem(d){const u=o.getCapabilities(d);if(typeof u=="number")return!(u&2048)}})}static _handleError(P){if(!(P instanceof Error))throw new D.FileSystemError(String(P));if(P.name==="ENOPRO")throw D.FileSystemError.Unavailable(P.message);switch(P.name){case T.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(P.message);case T.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(P.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(P.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(P.message);case T.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(P.message);case T.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(P.message);default:throw new D.FileSystemError(P.message,P.name)}}};I=Ve([je(0,y.IExtHostRpcService),je(1,_.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(we[185],_e([0,1,7,4]),function(Z,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const y=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(y,k),g.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(y)})}}e.ExtHostLabelService=D}),define(we[186],_e([0,1,2,24,9,6,11,4,8,31,16,10,114,7,85,49,63,52,12,3]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentSymbols($,Q){const ne=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentSymbols(ne,Q)).then(re=>{if(!i.isFalsyOrEmpty(re))return re[0]instanceof E.DocumentSymbol?re.map(D.DocumentSymbol.from):m._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree($){var Q;$=$.slice(0).sort((K,se)=>{let fe=K.location.range.start.compareTo(se.location.range.start);return fe===0&&(fe=se.location.range.end.compareTo(K.location.range.end)),fe});const ne=[],re=[];for(const K of $){const se={name:K.name||"!!MISSING: name!!",kind:D.SymbolKind.from(K.kind),tags:((Q=K.tags)===null||Q===void 0?void 0:Q.map(D.SymbolTag.from))||[],detail:"",containerName:K.containerName,range:D.Range.from(K.location.range),selectionRange:D.Range.from(K.location.range),children:[]};for(;;){if(re.length===0){re.push(se),ne.push(se);break}const fe=re[re.length-1];if(I.Range.containsRange(fe.range,se.range)&&!I.Range.equalsRange(fe.range,se.range)){fe.children&&fe.children.push(se),re.push(se);break}re.pop()}}return ne}}class f{constructor($,Q,ne){this._documents=$,this._commands=Q,this._provider=ne,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,Q){const ne=this._documents.getDocument($),re=await this._provider.provideCodeLenses(ne,Q);if(!re||Q.isCancellationRequested)return;const K=this._cache.add(re),se=new h.DisposableStore;this._disposables.set(K,se);const fe={cacheId:K,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)fe.lenses.push({cacheId:[K,Ae],range:D.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,se)});return fe}async resolveCodeLens($,Q){var ne;const re=$.cacheId&&this._cache.get(...$.cacheId);if(!re)return;let K;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?K=re:K=await this._provider.resolveCodeLens(re,Q),K||(K=re),Q.isCancellationRequested)return;const se=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!se)return $.command=this._commands.toInternal((ne=K.command)!==null&&ne!==void 0?ne:f._badCmd,se),$}releaseCodeLenses($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ge){return Array.isArray(Ge)?Ge.map(D.DefinitionLink.from):Ge?[D.DefinitionLink.from(Ge)]:[]}class n{constructor($,Q){this._documents=$,this._provider=Q}provideDefinition($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideDefinition(re,K,ne)).then(t)}}class r{constructor($,Q){this._documents=$,this._provider=Q}provideDeclaration($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideDeclaration(re,K,ne)).then(t)}}class s{constructor($,Q){this._documents=$,this._provider=Q}provideImplementation($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideImplementation(re,K,ne)).then(t)}}class l{constructor($,Q){this._documents=$,this._provider=Q}provideTypeDefinition($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideTypeDefinition(re,K,ne)).then(t)}}class v{constructor($,Q){this._documents=$,this._provider=Q}provideHover($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideHover(re,K,ne)).then(se=>{if(!(!se||i.isFalsyOrEmpty(se.contents)))return se.range||(se.range=re.getWordRangeAtPosition(K)),se.range||(se.range=new E.Range(K,K)),D.Hover.from(se)})}}class b{constructor($,Q){this._documents=$,this._provider=Q}provideEvaluatableExpression($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideEvaluatableExpression(re,K,ne)).then(se=>{if(se)return D.EvaluatableExpression.from(se)})}}class A{constructor($,Q){this._documents=$,this._provider=Q}provideInlineValues($,Q,ne,re){const K=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlineValues(K,D.Range.to(Q),D.InlineValueContext.to(ne),re)).then(se=>{if(Array.isArray(se))return se.map(fe=>D.InlineValue.from(fe))})}}class C{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentHighlights($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideDocumentHighlights(re,K,ne)).then(se=>{if(Array.isArray(se))return se.map(D.DocumentHighlight.from)})}}class a{constructor($,Q){this._documents=$,this._provider=Q}provideLinkedEditingRanges($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(re,K,ne)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:i.coalesce(se.ranges.map(D.Range.from)),wordPattern:se.wordPattern}})}}class F{constructor($,Q){this._documents=$,this._provider=Q}provideReferences($,Q,ne,re){const K=this._documents.getDocument($),se=D.Position.to(Q);return k.asPromise(()=>this._provider.provideReferences(K,se,ne,re)).then(fe=>{if(Array.isArray(fe))return fe.map(D.location.from)})}}class N{constructor($,Q,ne,re,K,se,fe){this._documents=$,this._commands=Q,this._diagnostics=ne,this._provider=re,this._logService=K,this._extension=se,this._apiDeprecation=fe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,Q,ne,re){const K=this._documents.getDocument($),se=o.Selection.isISelection(Q)?D.Selection.to(Q):D.Range.to(Q),fe=[];for(const ge of this._diagnostics.getDiagnostics($))if(se.intersection(ge.range)&&fe.push(ge)>N._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ne.only?new E.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(K,se,Ae,re)).then(ge=>{var We;if(!i.isNonEmptyArray(ge)||re.isCancellationRequested)return;const H=this._cache.add(ge),te=new h.DisposableStore;this._disposables.set(H,te);const ve=[];for(let Le=0;Le<ge.length;Le++){const xe=ge[Le];!xe||(N._isCommand(xe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ve.push({_isSynthetic:!0,title:xe.title,command:this._commands.toInternal(xe,te)})):(Ae.only&&(xe.kind?Ae.only.contains(xe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ve.push({cacheId:[H,Le],title:xe.title,command:xe.command&&this._commands.toInternal(xe.command,te),diagnostics:xe.diagnostics&&xe.diagnostics.map(D.Diagnostic.from),edit:xe.edit&&D.WorkspaceEdit.from(xe.edit),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:(We=xe.disabled)===null||We===void 0?void 0:We.reason})))}return{cacheId:H,actions:ve}})}async resolveCodeAction($,Q){var ne;const[re,K]=$,se=this._cache.get(re,K);if(!se||N._isCommand(se)||!this._provider.resolveCodeAction)return;const fe=(ne=await this._provider.resolveCodeAction(se,Q))!==null&&ne!==void 0?ne:se;return(fe==null?void 0:fe.edit)?D.WorkspaceEdit.from(fe.edit):void 0}releaseCodeActions($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}N._maxCodeActionsPerFile=1e3;class W{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentFormattingEdits($,Q,ne){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,Q,ne)).then(K=>{if(Array.isArray(K))return K.map(D.TextEdit.from)})}}class ce{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentRangeFormattingEdits($,Q,ne,re){const K=this._documents.getDocument($),se=D.Range.to(Q);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(K,se,ne,re)).then(fe=>{if(Array.isArray(fe))return fe.map(D.TextEdit.from)})}}class me{constructor($,Q){this._documents=$,this._provider=Q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,Q,ne,re,K){const se=this._documents.getDocument($),fe=D.Position.to(Q);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(se,fe,ne,re,K)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(D.TextEdit.from)})}}class G{constructor($,Q){this._provider=$,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,Q){const ne=y.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols($,Q)).then(re=>{if(i.isNonEmptyArray(re))for(const K of re){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const se=y.IdObject.mixin(D.WorkspaceSymbol.from(K));this._symbolCache.set(se._id,K),ne.symbols.push(se)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol($,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const ne=this._symbolCache.get($._id);if(ne){const re=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,Q));return re&&T.mixin($,D.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols($){const Q=this._resultCache.get($);if(Q){for(let[ne,re]=Q;ne<=re;ne++)this._symbolCache.delete(ne);this._resultCache.delete($)}}}class V{constructor($,Q,ne){this._documents=$,this._provider=Q,this._logService=ne}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,Q,ne,re){const K=this._documents.getDocument($),se=D.Position.to(Q);return k.asPromise(()=>this._provider.provideRenameEdits(K,se,ne,re)).then(fe=>{if(!!fe)return D.WorkspaceEdit.from(fe)},fe=>{const Ae=V._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)})}resolveRenameLocation($,Q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument($),K=D.Position.to(Q);return k.asPromise(()=>this._provider.prepareRename(re,K,ne)).then(se=>{let fe,Ae;if(E.Range.isRange(se)?(fe=se,Ae=re.getText(se)):P.isObject(se)&&(fe=se.range,Ae=se.placeholder),!!fe){if(fe.start.line>K.line||fe.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(fe),text:Ae}}},se=>{const fe=V._asMessage(se);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class J{constructor($,Q){this.resultId=$,this.tokens=Q}}class R{constructor($,Q){this._documents=$,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,Q,ne){const re=this._documents.getDocument($),K=Q!==0?this._previousResults.get(Q):null;return k.asPromise(()=>K&&typeof K.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,K.resultId,ne):this._provider.provideDocumentSemanticTokens(re,ne)).then(se=>(K&&this._previousResults.delete(Q),se?(se=R._fixProvidedSemanticTokens(se),this._send(R._convertToEdits(K,se),se)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return R._isSemanticTokens($)?R._isCorrectSemanticTokens($)?$:new E.SemanticTokens(new Uint32Array($.data),$.resultId):R._isSemanticTokensEdits($)?R._isCorrectSemanticTokensEdits($)?$:new E.SemanticTokensEdits($.edits.map(Q=>new E.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const Q of $.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,Q){if(!R._isSemanticTokens(Q)||!$||!$.tokens)return Q;const ne=$.tokens,re=ne.length,K=Q.data,se=K.length;let fe=0;const Ae=Math.min(re,se);for(;fe<Ae&&ne[fe]===K[fe];)fe++;if(fe===re&&fe===se)return new E.SemanticTokensEdits([],Q.resultId);let ge=0;const We=Ae-fe;for(;ge<We&&ne[re-ge-1]===K[se-ge-1];)ge++;return new E.SemanticTokensEdits([{start:fe,deleteCount:re-fe-ge,data:K.subarray(fe,se-ge)}],Q.resultId)}_send($,Q){if(R._isSemanticTokens($)){const ne=this._nextResultId++;return this._previousResults.set(ne,new J($.resultId,$.data)),d.encodeSemanticTokensDto({id:ne,type:"full",data:$.data})}if(R._isSemanticTokensEdits($)){const ne=this._nextResultId++;return R._isSemanticTokens(Q)?this._previousResults.set(ne,new J(Q.resultId,Q.data)):this._previousResults.set(ne,new J($.resultId)),d.encodeSemanticTokensDto({id:ne,type:"delta",deltas:($.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=R;class B{constructor($,Q){this._documents=$,this._provider=Q}provideDocumentRangeSemanticTokens($,Q,ne){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,D.Range.to(Q),ne)).then(K=>K?this._send(K):null)}_send($){return d.encodeSemanticTokensDto({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=B;class M{constructor($,Q,ne,re,K){this._documents=$,this._commands=Q,this._provider=ne,this._apiDeprecation=re,this._extension=K,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,Q,ne,re){const K=this._documents.getDocument($),se=D.Position.to(Q),fe=K.getWordRangeAtPosition(se)||new E.Range(se,se),Ae=fe.with({end:se}),ge=new p.StopWatch(!0),We=await k.asPromise(()=>this._provider.provideCompletionItems(K,se,re,D.CompletionContext.to(ne)));if(!We||re.isCancellationRequested)return;const H=Array.isArray(We)?new E.CompletionList(We):We,te=M.supportsResolving(this._provider)?this._cache.add(H.items):this._cache.add([]),ve=new h.DisposableStore;this._disposables.set(te,ve);const Le=[],xe={x:te,b:Le,a:{replace:D.Range.from(fe),insert:D.Range.from(Ae)},c:H.isIncomplete||void 0,d:ge.elapsed()};for(let Be=0;Be<H.items.length;Be++){const Ye=H.items[Be],Se=this._convertCompletionItem(Ye,[te,Be],Ae,fe);Le.push(Se)}return xe}async resolveCompletionItem($,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...$);if(!ne)return;const re=await k.asPromise(()=>this._provider.resolveCompletionItem(ne,Q));if(!!re)return this._convertCompletionItem(re,$)}releaseCompletionItems($){var Q;(Q=this._disposables.get($))===null||Q===void 0||Q.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,Q,ne,re){var K;const se=this._disposables.get(Q[0]);if(!se)throw Error("DisposableStore is missing...");const fe={x:Q,a:(K=$.label)!==null&&K!==void 0?K:"",o:$.label2,b:$.kind!==void 0?D.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(D.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:D.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal($.command,se)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),fe.h=$.textEdit.newText):typeof $.insertText=="string"?fe.h=$.insertText:$.insertText instanceof E.SnippetString&&(fe.h=$.insertText.value,fe.i|=4);let Ae;return $.textEdit?Ae=$.textEdit.range:$.range&&(Ae=$.range),E.Range.isRange(Ae)?fe.j=D.Range.from(Ae):Ae&&(!(ne==null?void 0:ne.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(fe.j={insert:D.Range.from(Ae.inserting),replace:D.Range.from(Ae.replacing)}),fe}}class U{constructor($,Q,ne){this._documents=$,this._provider=Q,this._commands=ne,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,Q,ne,re){const K=this._documents.getDocument($),se=D.Position.to(Q),fe=await k.asPromise(()=>this._provider.provideInlineCompletionItems(K,se,ne,re));if(!fe||re.isCancellationRequested)return;const Ae=this._cache.add(fe.items);let ge;return{pid:Ae,items:fe.items.map((We,H)=>{let te;return We.command&&(ge||(ge=new h.DisposableStore,this._disposables.set(Ae,ge)),te=this._commands.toInternal(We.command,ge)),{text:We.text,range:We.range?D.Range.from(We.range):void 0,command:te,idx:H}})}}disposeCompletions($){this._cache.delete($);const Q=this._disposables.get($);Q&&Q.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,Q){const ne=this._cache.get($,Q);ne&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new c.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let Q=j.map.get($);return Q||(Q=new j,j.map.set($,Q)),Q}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=j,j.map=new WeakMap;class z{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new w.Cache("SignatureHelp")}provideSignatureHelp($,Q,ne,re){const K=this._documents.getDocument($),se=D.Position.to(Q),fe=this.reviveContext(ne);return k.asPromise(()=>this._provider.provideSignatureHelp(K,se,re,fe)).then(Ae=>{if(Ae){const ge=this._cache.add([Ae]);return Object.assign(Object.assign({},D.SignatureHelp.from(Ae)),{id:ge})}})}reviveContext($){let Q;if($.activeSignatureHelp){const ne=D.SignatureHelp.to($.activeSignatureHelp),re=this._cache.get($.activeSignatureHelp.id,0);re?(Q=re,Q.activeSignature=ne.activeSignature,Q.activeParameter=ne.activeParameter):Q=ne}return Object.assign(Object.assign({},$),{activeSignatureHelp:Q})}releaseSignatureHelp($){this._cache.delete($)}}class oe{constructor($,Q){this._documents=$,this._provider=Q}provideInlayHints($,Q,ne){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlayHints(re,D.Range.to(Q),ne)).then(K=>K?{hints:K.map(D.InlayHint.from)}:void 0)}}class pe{constructor($,Q){this._documents=$,this._provider=Q,this._cache=new w.Cache("DocumentLink")}provideLinks($,Q){const ne=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentLinks(ne,Q)).then(re=>{if(!(!Array.isArray(re)||re.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.map(D.DocumentLink.from)};{const K=this._cache.add(re),se={links:[],id:K};for(let fe=0;fe<re.length;fe++){const Ae=D.DocumentLink.from(re[fe]);Ae.cacheId=[K,fe],se.links.push(Ae)}return se}}})}resolveLink($,Q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...$);return ne?k.asPromise(()=>this._provider.resolveDocumentLink(ne,Q)).then(re=>re&&D.DocumentLink.from(re)||void 0):Promise.resolve(void 0)}releaseLinks($){this._cache.delete($)}}class Te{constructor($,Q){this._documents=$,this._provider=Q}provideColors($,Q){const ne=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentColors(ne,Q)).then(re=>Array.isArray(re)?re.map(se=>({color:D.Color.from(se.color),range:D.Range.from(se.range)})):[])}provideColorPresentations($,Q,ne){const re=this._documents.getDocument($),K=D.Range.to(Q.range),se=D.Color.to(Q.color);return k.asPromise(()=>this._provider.provideColorPresentations(se,{document:re,range:K},ne)).then(fe=>{if(!!Array.isArray(fe))return fe.map(D.ColorPresentation.from)})}}class $e{constructor($,Q){this._documents=$,this._provider=Q}provideFoldingRanges($,Q,ne){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideFoldingRanges(re,Q,ne)).then(K=>{if(!!Array.isArray(K))return K.map(D.FoldingRange.from)})}}class Me{constructor($,Q,ne){this._documents=$,this._provider=Q,this._logService=ne}provideSelectionRanges($,Q,ne){const re=this._documents.getDocument($),K=Q.map(D.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(re,K,ne)).then(se=>{if(!i.isNonEmptyArray(se))return[];if(se.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<K.length;Ae++){const ge=[];fe.push(ge);let We=K[Ae],H=se[Ae];for(;;){if(!H.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(D.SelectionRange.from(H)),!H.parent)break;We=H.range,H=H.parent}}return fe})}}class ze{constructor($,Q){this._documents=$,this._provider=Q,this._idPool=new u.IdGenerator(""),this._cache=new Map}async prepareSession($,Q,ne){const re=this._documents.getDocument($),K=D.Position.to(Q),se=await this._provider.prepareCallHierarchy(re,K,ne);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideCallsTo($,Q,ne){const re=this._itemFromCache($,Q);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(re,ne);if(!!K)return K.map(se=>({from:this._cacheAndConvertItem($,se.from),fromRanges:se.fromRanges.map(fe=>D.Range.from(fe))}))}async provideCallsFrom($,Q,ne){const re=this._itemFromCache($,Q);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(re,ne);if(!!K)return K.map(se=>({to:this._cacheAndConvertItem($,se.to),fromRanges:se.fromRanges.map(fe=>D.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,Q){var ne;const re=this._cache.get($),K={_sessionId:$,_itemId:re.size.toString(36),name:Q.name,detail:Q.detail,kind:D.SymbolKind.from(Q.kind),uri:Q.uri,range:D.Range.from(Q.range),selectionRange:D.Range.from(Q.selectionRange),tags:(ne=Q.tags)===null||ne===void 0?void 0:ne.map(D.SymbolTag.from)};return re.set(K._itemId,Q),K}_itemFromCache($,Q){const ne=this._cache.get($);return ne==null?void 0:ne.get(Q)}}class Qe{constructor($,Q){this.adapter=$,this.extension=Q}}class Ke{constructor($,Q,ne,re,K,se,fe){this._adapter=new Map,this._uriTransformer=Q,this._proxy=$.getProxy(y.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=re,this._diagnostics=K,this._logService=se,this._apiDeprecation=fe}_transformDocumentSelector($){return i.coalesce(i.asArray($).map(Q=>this._doTransformDocumentSelector(Q)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:D.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new E.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ke._handlePool++}_withAdapter($,Q,ne,re,K=!1){const se=this._adapter.get($);if(!se)return Promise.resolve(re);if(se.adapter instanceof Q){let fe;se.extension&&(fe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Ae=ne(se.adapter,se.extension),ge=se.extension;return ge&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${ge.identifier.value}] provider DONE after ${Date.now()-fe}ms`),We=>{K&&We instanceof S.CancellationError||(this._logService.error(`[${ge.identifier.value}] provider FAILED`),this._logService.error(We))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,Q){const ne=this._nextHandle();return this._adapter.set(ne,new Qe($,Q)),ne}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,Q,ne,re){const K=this._addNewAdapter(new m(this._documents,ne),$),se=re&&re.label||Ke._extLabel($);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentSymbols($,Q,ne){return this._withAdapter($,m,re=>re.provideDocumentSymbols(g.URI.revive(Q),ne),void 0)}registerCodeLensProvider($,Q,ne){const re=this._nextHandle(),K=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new f(this._documents,this._commands.converter,ne),$)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Q),K);let se=this._createDisposable(re);if(K!==void 0){const fe=ne.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));se=E.Disposable.from(se,fe)}return se}$provideCodeLenses($,Q,ne){return this._withAdapter($,f,re=>re.provideCodeLenses(g.URI.revive(Q),ne),void 0)}$resolveCodeLens($,Q,ne){return this._withAdapter($,f,re=>re.resolveCodeLens(Q,ne),void 0)}$releaseCodeLenses($,Q){this._withAdapter($,f,ne=>Promise.resolve(ne.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider($,Q,ne){const re=this._addNewAdapter(new n(this._documents,ne),$);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDefinition($,Q,ne,re){return this._withAdapter($,n,K=>K.provideDefinition(g.URI.revive(Q),ne,re),[])}registerDeclarationProvider($,Q,ne){const re=this._addNewAdapter(new r(this._documents,ne),$);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDeclaration($,Q,ne,re){return this._withAdapter($,r,K=>K.provideDeclaration(g.URI.revive(Q),ne,re),[])}registerImplementationProvider($,Q,ne){const re=this._addNewAdapter(new s(this._documents,ne),$);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideImplementation($,Q,ne,re){return this._withAdapter($,s,K=>K.provideImplementation(g.URI.revive(Q),ne,re),[])}registerTypeDefinitionProvider($,Q,ne){const re=this._addNewAdapter(new l(this._documents,ne),$);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideTypeDefinition($,Q,ne,re){return this._withAdapter($,l,K=>K.provideTypeDefinition(g.URI.revive(Q),ne,re),[])}registerHoverProvider($,Q,ne,re){const K=this._addNewAdapter(new v(this._documents,ne),$);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover($,Q,ne,re){return this._withAdapter($,v,K=>K.provideHover(g.URI.revive(Q),ne,re),void 0)}registerEvaluatableExpressionProvider($,Q,ne,re){const K=this._addNewAdapter(new b(this._documents,ne),$);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression($,Q,ne,re){return this._withAdapter($,b,K=>K.provideEvaluatableExpression(g.URI.revive(Q),ne,re),void 0)}registerInlineValuesProvider($,Q,ne,re){const K=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new A(this._documents,ne),$);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Q),K);let fe=this._createDisposable(se);if(K!==void 0){const Ae=ne.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(K));fe=E.Disposable.from(fe,Ae)}return fe}$provideInlineValues($,Q,ne,re,K){return this._withAdapter($,A,se=>se.provideInlineValues(g.URI.revive(Q),ne,re,K),void 0)}registerDocumentHighlightProvider($,Q,ne){const re=this._addNewAdapter(new C(this._documents,ne),$);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentHighlights($,Q,ne,re){return this._withAdapter($,C,K=>K.provideDocumentHighlights(g.URI.revive(Q),ne,re),void 0)}registerLinkedEditingRangeProvider($,Q,ne){const re=this._addNewAdapter(new a(this._documents,ne),$);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideLinkedEditingRanges($,Q,ne,re){return this._withAdapter($,a,async K=>{const se=await K.provideLinkedEditingRanges(g.URI.revive(Q),ne,re);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ke._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider($,Q,ne){const re=this._addNewAdapter(new F(this._documents,ne),$);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideReferences($,Q,ne,re,K){return this._withAdapter($,F,se=>se.provideReferences(g.URI.revive(Q),ne,re,K),void 0)}registerCodeActionProvider($,Q,ne,re){var K,se;const fe=new h.DisposableStore,Ae=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(Q),{providedKinds:(K=re==null?void 0:re.providedCodeActionKinds)===null||K===void 0?void 0:K.map(ge=>ge.value),documentation:(se=re==null?void 0:re.documentation)===null||se===void 0?void 0:se.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,fe)}))},Ke._extLabel($),Boolean(ne.resolveCodeAction)),fe.add(this._createDisposable(Ae)),fe}$provideCodeActions($,Q,ne,re,K){return this._withAdapter($,N,se=>se.provideCodeActions(g.URI.revive(Q),ne,re,K),void 0)}$resolveCodeAction($,Q,ne){return this._withAdapter($,N,re=>re.resolveCodeAction(Q,ne),void 0)}$releaseCodeActions($,Q){this._withAdapter($,N,ne=>Promise.resolve(ne.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider($,Q,ne){const re=this._addNewAdapter(new W(this._documents,ne),$);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentFormattingEdits($,Q,ne,re){return this._withAdapter($,W,K=>K.provideDocumentFormattingEdits(g.URI.revive(Q),ne,re),void 0)}registerDocumentRangeFormattingEditProvider($,Q,ne){const re=this._addNewAdapter(new ce(this._documents,ne),$);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Q),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits($,Q,ne,re,K){return this._withAdapter($,ce,se=>se.provideDocumentRangeFormattingEdits(g.URI.revive(Q),ne,re,K),void 0)}registerOnTypeFormattingEditProvider($,Q,ne,re){const K=this._addNewAdapter(new me(this._documents,ne),$);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),re,$.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits($,Q,ne,re,K,se){return this._withAdapter($,me,fe=>fe.provideOnTypeFormattingEdits(g.URI.revive(Q),ne,re,K,se),void 0)}registerWorkspaceSymbolProvider($,Q){const ne=this._addNewAdapter(new G(Q,this._logService),$);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols($,Q,ne){return this._withAdapter($,G,re=>re.provideWorkspaceSymbols(Q,ne),{symbols:[]})}$resolveWorkspaceSymbol($,Q,ne){return this._withAdapter($,G,re=>re.resolveWorkspaceSymbol(Q,ne),void 0)}$releaseWorkspaceSymbols($,Q){this._withAdapter($,G,ne=>ne.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider($,Q,ne){const re=this._addNewAdapter(new V(this._documents,ne,this._logService),$);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Q),V.supportsResolving(ne)),this._createDisposable(re)}$provideRenameEdits($,Q,ne,re,K){return this._withAdapter($,V,se=>se.provideRenameEdits(g.URI.revive(Q),ne,re,K),void 0)}$resolveRenameLocation($,Q,ne,re){return this._withAdapter($,V,K=>K.resolveRenameLocation(g.URI.revive(Q),ne,re),void 0)}registerDocumentSemanticTokensProvider($,Q,ne,re){const K=this._nextHandle(),se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Qe(new R(this._documents,ne),$)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),re,se);let fe=this._createDisposable(K);if(se){const Ae=ne.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(se));fe=E.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens($,Q,ne,re){return this._withAdapter($,R,K=>K.provideDocumentSemanticTokens(g.URI.revive(Q),ne,re),null,!0)}$releaseDocumentSemanticTokens($,Q){this._withAdapter($,R,ne=>ne.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider($,Q,ne,re){const K=this._addNewAdapter(new B(this._documents,ne),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),re),this._createDisposable(K)}$provideDocumentRangeSemanticTokens($,Q,ne,re){return this._withAdapter($,B,K=>K.provideDocumentRangeSemanticTokens(g.URI.revive(Q),ne,re),null,!0)}registerCompletionItemProvider($,Q,ne,re){const K=this._addNewAdapter(new M(this._documents,this._commands.converter,ne,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),re,M.supportsResolving(ne),`${$.identifier.value}(${re.join("")})`),this._createDisposable(K)}$provideCompletionItems($,Q,ne,re,K){return this._withAdapter($,M,se=>se.provideCompletionItems(g.URI.revive(Q),ne,re,K),void 0)}$resolveCompletionItem($,Q,ne){return this._withAdapter($,M,re=>re.resolveCompletionItem(Q,ne),void 0)}$releaseCompletionItems($,Q){this._withAdapter($,M,ne=>ne.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider($,Q,ne){const re=this._addNewAdapter(new U(this._documents,ne,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideInlineCompletions($,Q,ne,re,K){return this._withAdapter($,U,se=>se.provideInlineCompletions(g.URI.revive(Q),ne,re,K),void 0)}$handleInlineCompletionDidShow($,Q,ne){this._withAdapter($,U,async re=>{re.handleDidShowCompletionItem(Q,ne)},void 0)}$freeInlineCompletionsList($,Q){this._withAdapter($,U,async ne=>{ne.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider($,Q,ne,re){const K=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,se=this._addNewAdapter(new z(this._documents,ne),$);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Q),K),this._createDisposable(se)}$provideSignatureHelp($,Q,ne,re,K){return this._withAdapter($,z,se=>se.provideSignatureHelp(g.URI.revive(Q),ne,re,K),void 0)}$releaseSignatureHelp($,Q){this._withAdapter($,z,ne=>ne.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider($,Q,ne){const re=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new oe(this._documents,ne),$);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),re);let se=this._createDisposable(K);if(re!==void 0){const fe=ne.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));se=E.Disposable.from(se,fe)}return se}$provideInlayHints($,Q,ne,re){return this._withAdapter($,oe,K=>K.provideInlayHints(g.URI.revive(Q),ne,re),void 0)}registerDocumentLinkProvider($,Q,ne){const re=this._addNewAdapter(new pe(this._documents,ne),$);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks($,Q,ne){return this._withAdapter($,pe,re=>re.provideLinks(g.URI.revive(Q),ne),void 0)}$resolveDocumentLink($,Q,ne){return this._withAdapter($,pe,re=>re.resolveLink(Q,ne),void 0)}$releaseDocumentLinks($,Q){this._withAdapter($,pe,ne=>ne.releaseLinks(Q),void 0)}registerColorProvider($,Q,ne){const re=this._addNewAdapter(new Te(this._documents,ne),$);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideDocumentColors($,Q,ne){return this._withAdapter($,Te,re=>re.provideColors(g.URI.revive(Q),ne),[])}$provideColorPresentations($,Q,ne,re){return this._withAdapter($,Te,K=>K.provideColorPresentations(g.URI.revive(Q),ne,re),void 0)}registerFoldingRangeProvider($,Q,ne){const re=this._nextHandle(),K=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new $e(this._documents,ne),$)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Q),K);let se=this._createDisposable(re);if(K!==void 0){const fe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));se=E.Disposable.from(se,fe)}return se}$provideFoldingRanges($,Q,ne,re){return this._withAdapter($,$e,K=>K.provideFoldingRanges(g.URI.revive(Q),ne,re),void 0)}registerSelectionRangeProvider($,Q,ne){const re=this._addNewAdapter(new Me(this._documents,ne,this._logService),$);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$provideSelectionRanges($,Q,ne,re){return this._withAdapter($,Me,K=>K.provideSelectionRanges(g.URI.revive(Q),ne,re),[])}registerCallHierarchyProvider($,Q,ne){const re=this._addNewAdapter(new ze(this._documents,ne),$);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Q)),this._createDisposable(re)}$prepareCallHierarchy($,Q,ne,re){return this._withAdapter($,ze,K=>Promise.resolve(K.prepareSession(g.URI.revive(Q),ne,re)),void 0)}$provideCallHierarchyIncomingCalls($,Q,ne,re){return this._withAdapter($,ze,K=>K.provideCallsTo(Q,ne,re),void 0)}$provideCallHierarchyOutgoingCalls($,Q,ne,re){return this._withAdapter($,ze,K=>K.provideCallsFrom(Q,ne,re),void 0)}$releaseCallHierarchy($,Q){this._withAdapter($,ze,ne=>Promise.resolve(ne.releaseSession(Q)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:_.regExpFlags($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ke._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ke._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ke._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ke._serializeRegExp($.beforeText),afterText:$.afterText?Ke._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ke._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ke._serializeOnEnterRule)}setLanguageConfiguration($,Q,ne){let{wordPattern:re}=ne;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Q,re):this._documents.setWordDefinitionFor(Q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const K=this._nextHandle(),se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ke._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ke._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ke._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,se),this._createDisposable(K)}$setWordDefinitions($){for(const Q of $)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(we[187],_e([0,1,4,9,6]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(y,_){this._proxy=y.getProxy(g.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(y,_){await this._proxy.$changeLanguage(y,_);const I=this._documents.getDocumentData(y);if(!I)throw new Error(`document '${y.toString}' NOT found`);return I.document}async tokenAtPosition(y,_){var I;const i=y.version,P=T.Position.from(_),o=await this._proxy.$tokensAtPosition(y.uri,P),h={type:D.StandardTokenType.Other,range:(I=y.getWordRangeAtPosition(_))!==null&&I!==void 0?I:new D.Range(_.line,_.character,_.line,_.character)};if(!o)return h;const d={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!d.range.contains(_)||i!==y.version?h:d}}e.ExtHostLanguages=E}),define(we[188],_e([0,1,4,17,29]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(y){return y&&y.title}let k=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,I,i,P,o){const h={extension:_};let d;typeof P=="string"||E(P)?d=[P,...o]:(h.modal=P&&P.modal,h.useCustom=P&&P.useCustom,d=o),h.useCustom&&D.checkProposedApiEnabled(_);const u=[];for(let w=0;w<d.length;w++){const p=d[w];if(typeof p=="string")u.push({title:p,handle:w,isCloseAffordance:!1});else if(typeof p=="object"){let{title:S,isCloseAffordance:c}=p;u.push({title:S,isCloseAffordance:!!c,handle:w})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(I,i,h,u).then(w=>{if(typeof w=="number")return d[w]})}};k=Ve([je(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(we[189],_e([0,1,23,3,53,49,7,22,8,10,2,63,4,9,6,45,167,95]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class S{constructor(f,t){const n=S._Keys.nextId();f.$registerNotebookEditorDecorationType(n,h.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){f.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=S,S._Keys=new E.IdGenerator("NotebookEditorDecorationType");class c{constructor(f,t,n,r,s,l){this._textDocumentsAndEditors=n,this._textDocuments=r,this.logService=s,this._extensionStoragePaths=l,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(o.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(o.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(o.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:v=>{var b;if(v&&v.$mid===12){const A=(b=v.notebookEditor)===null||b===void 0?void 0:b.notebookUri,C=v.cell.handle,a=this._documents.get(A),F=a==null?void 0:a.getCell(C);if(F)return F.apiCell}return v}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,n]of this._editors)if(n.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const n=this._documents.get(f);if(!n&&!t)throw new Error(`NO notebook document for '${f}'`);return n}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,n,r,s){if(_.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:n});let l;return n.onDidChangeNotebookContentOptions&&(l=n.onDidChangeNotebookContentOptions(()=>{const v=h.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,v)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,h.NotebookDocumentContentOptions.from(r),c._convertNotebookRegistrationData(f,s)),new d.Disposable(()=>{l==null||l.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const n=t.filenamePattern.map(r=>h.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,n){const r=c._notebookStatusBarItemProviderHandlePool++,s=typeof n.onDidChangeCellStatusBarItems=="function"?c._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,s,t);let l;return s!==void 0&&(l=n.onDidChangeCellStatusBarItems(v=>this._notebookProxy.$emitCellStatusBarEvent(s))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,s),l&&l.dispose()})}createNotebookEditorDecorationType(f){return new S(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&h.NotebookData.from(f.content)});return i.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(f),r=this._documents.get(i.URI.revive(n));return I.assertIsDefined(r==null?void 0:r.apiNotebook)}async showNotebookDocument(f,t){var n;i.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let r;typeof t=="object"?r={position:h.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(h.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:r={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,r),l=s&&((n=this._editors.get(s))===null||n===void 0?void 0:n.apiEditor);if(l)return l;throw s?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,n,r){var s;const l=this._notebookStatusBarItemProviders.get(f),v=i.URI.revive(t),b=this._documents.get(v);if(!b||!l)return;const A=b.getCellFromIndex(n);if(!A)return;const C=await l.provideCellStatusBarItems(A.apiCell,r);if(!C)return;const a=new k.DisposableStore,F=this._statusBarCache.add([a]),N=(s=C&&C.map(W=>h.NotebookStatusBarItem.from(W,this._commandsConverter,a)))!==null&&s!==void 0?s:void 0;return{cacheId:F,items:N}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,n,r,s){if(_.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const l=this._handlePool++;return this._notebookSerializer.set(l,n),this._notebookProxy.$registerNotebookSerializer(l,{id:f.identifier,location:f.extensionLocation},t,h.NotebookDocumentContentOptions.from(r),c._convertNotebookRegistrationData(f,s)),k.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(l)})}async $dataToNotebook(f,t,n){const r=this._notebookSerializer.get(f);if(!r)throw new Error("NO serializer found");const s=await r.deserializeNotebook(t.buffer,n);return h.NotebookData.from(s)}async $notebookToData(f,t,n){const r=this._notebookSerializer.get(f);if(!r)throw new Error("NO serializer found");const s=await r.serializeNotebook(h.NotebookData.to(t),n);return g.VSBuffer.wrap(s)}async $openNotebook(f,t,n,r,s){const{provider:l}=this._getProviderData(f),v=await l.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:r==null?void 0:r.buffer},s);return{metadata:h.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(h.NotebookCellData.from)}}async $saveNotebook(f,t,n){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:s}=this._getProviderData(f);return await s.saveNotebook(r.apiNotebook,n),!0}async $saveNotebookAs(f,t,n,r){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:l}=this._getProviderData(f);return await l.saveNotebookAs(i.URI.revive(n),s.apiNotebook,r),!0}async $backupNotebook(f,t,n){var r;const s=this.getNotebookDocument(i.URI.revive(t)),l=this._getProviderData(f),v=(r=this._extensionStoragePaths.workspaceValue(l.extension))!==null&&r!==void 0?r:this._extensionStoragePaths.globalValue(l.extension),b=String(D.hash([s.uri.toString(),this._backupIdPool++])),A=i.URI.joinPath(v,b),C=await l.provider.backupNotebook(s.apiNotebook,{destination:A},n);return s.updateBackup(C),C.id}$acceptModelChanged(f,t,n){this.getNotebookDocument(i.URI.revive(f)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(f,t){const n=this.getNotebookDocument(i.URI.revive(f));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(i.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const n=this._editors.get(f);if(!n)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(h.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(h.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(h.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const n=this.getNotebookDocument(i.URI.revive(f));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(f,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const r=new p.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,n.visibleRanges.map(h.NotebookRange.to),n.selections.map(h.NotebookRange.to),typeof n.viewColumn=="number"?h.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,r)}$acceptDocumentAndEditorsDelta(f){var t,n,r;if(f.removedDocuments)for(const l of f.removedDocuments){const v=i.URI.revive(l),b=this._documents.get(v);b&&(b.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(A=>A.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const A of this._editors.values())A.notebookData.uri.toString()===v.toString()&&this._editors.delete(A.id)}if(f.addedDocuments){const l=[];for(const v of f.addedDocuments){const b=i.URI.revive(v.uri),A=v.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const C=this,a=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){C._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){C._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){C._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){C._onDidChangeCellExecutionState.fire(F)}},A,v.metadata?h.NotebookDocumentMetadata.to(v.metadata):new d.NotebookDocumentMetadata,b);a.acceptModelChanged({versionId:v.versionId,rawEvents:[{kind:u.NotebookCellsChangeType.Initialize,changes:[[0,0,v.cells]]}]},!1),l.push(...v.cells.map(F=>w.ExtHostCell.asModelAddData(a.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:l}),this._onDidOpenNotebookDocument.fire(a.apiNotebook)}}if(f.addedEditors)for(const l of f.addedEditors){if(this._editors.has(l.id))return;const v=i.URI.revive(l.documentUri),b=this._documents.get(v);b&&this._createExtHostEditor(b,l.id,l)}const s=[];if(f.removedEditors)for(const l of f.removedEditors){const v=this._editors.get(l);v&&(this._editors.delete(l),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===v.id&&(this._activeNotebookEditor=void 0),s.push(v))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const l=new Set;this._visibleNotebookEditors.forEach(v=>l.add(v.id));for(const v of this._editors.values()){const b=l.has(v.id);v._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((r=this._activeNotebookEditor)===null||r===void 0?void 0:r.apiEditor)}}e.ExtHostNotebookController=c,c._notebookStatusBarItemProviderHandlePool=0}),define(we[190],_e([0,1,3,7,4,26,2,9,68,22,11,45,18,16,17,6,29]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let p=class{constructor(t,n,r,s){this._mainContext=t,this._initData=n,this._extHostNotebook=r,this._logService=s,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(t,n,r,s,l,v){for(let M of this._kernelData.values())if(M.controller.id===n&&E.ExtensionIdentifier.equals(t.identifier,M.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const b=this._handlePool++,A=this;this._logService.trace(`NotebookController[${b}], CREATED by ${t.identifier.value}, ${n}`);const C=()=>console.warn(`NO execute handler from notebook controller '${ce.id}' of extension: '${t.identifier}'`);let a=!1;const F=new T.DisposableStore,N=new g.Emitter,W=new g.Emitter,ce={id:`${t.identifier.value}/${n}`,notebookType:r,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:s||t.identifier.value,preloads:v?v.map(y.NotebookRendererScript.from):[]};let me=l??C,G;this._proxy.$addKernel(b,ce).catch(M=>{console.log(M),a=!0});let V=0;const J=()=>{if(a)return;const M=++V;Promise.resolve().then(()=>{M===V&&this._proxy.$updateKernel(b,ce)})},R=new I.ResourceMap,B={get id(){return n},get viewType(){return ce.notebookType},get notebookType(){return ce.notebookType},onDidChangeNotebookAssociation:N.event,get label(){return ce.label},set label(M){var U;ce.label=(U=M??t.displayName)!==null&&U!==void 0?U:t.name,J()},get detail(){var M;return(M=ce.detail)!==null&&M!==void 0?M:""},set detail(M){ce.detail=M,J()},get description(){var M;return(M=ce.description)!==null&&M!==void 0?M:""},set description(M){ce.description=M,J()},get supportedLanguages(){return ce.supportedLanguages},set supportedLanguages(M){ce.supportedLanguages=M,J()},get hasExecutionOrder(){var M;return(M=ce.supportsExecutionOrder)!==null&&M!==void 0?M:!1},set hasExecutionOrder(M){ce.supportsExecutionOrder=M,J()},get supportsExecutionOrder(){var M;return(M=ce.supportsExecutionOrder)!==null&&M!==void 0?M:!1},set supportsExecutionOrder(M){ce.supportsExecutionOrder=M,J()},get rendererScripts(){return ce.preloads?ce.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return me},set executeHandler(M){me=M??C},get interruptHandler(){return G},set interruptHandler(M){G=M,ce.supportsInterrupt=Boolean(M),J()},createNotebookCellExecution(M){if(a)throw new Error("notebook controller is DISPOSED");if(!R.has(M.notebook.uri))throw A._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(R.keys()).map(U=>U.toString())),new Error(`notebook controller is NOT associated to notebook: ${M.notebook.uri.toString()}`);return A._createNotebookCellExecution(M)},dispose:()=>{a||(this._logService.trace(`NotebookController[${b}], DISPOSED`),a=!0,this._kernelData.delete(b),F.dispose(),N.dispose(),W.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(M,U){A._proxy.$updateNotebookPriority(b,M.uri,U)},onDidReceiveMessage:W.event,postMessage(M,U){return w.checkProposedApiEnabled(t),A._proxy.$postMessage(b,U&&A._extHostNotebook.getIdByEditor(U),M)},asWebviewUri(M){return w.checkProposedApiEnabled(t),_.asWebviewUri(M,A._initData.remote)}};return this._kernelData.set(b,{extensionId:t.identifier,controller:B,onDidReceiveMessage:W,onDidChangeSelection:N,associatedNotebooks:R}),B}$acceptNotebookAssociation(t,n,r){const s=this._kernelData.get(t);if(s){const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(n));r?s.associatedNotebooks.set(l.uri,!0):s.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,l.uri.toString(),r),s.onDidChangeSelection.fire({selected:r,notebook:l.apiNotebook})}}async $executeCells(t,n,r){const s=this._kernelData.get(t);if(!s)return;const l=this._extHostNotebook.getNotebookDocument(k.URI.revive(n)),v=[];for(let b of r){const A=l.getCell(b);A&&v.push(A.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,l.uri.toString(),v.length),await s.controller.executeHandler.call(s.controller,v,l.apiNotebook,s.controller)}catch(b){this._logService.error(`NotebookController[${t}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(t,n,r){var s;const l=this._kernelData.get(t);if(!l)return;const v=this._extHostNotebook.getNotebookDocument(k.URI.revive(n));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,v.apiNotebook);else for(let b of r){const A=v.getCell(b);A&&((s=this._activeExecutions.get(A.uri))===null||s===void 0||s.cancel())}}$acceptKernelMessageFromRenderer(t,n,r){const s=this._kernelData.get(t);if(!s)return;const l=this._extHostNotebook.getEditorById(n);if(!l)throw new Error(`send message for UNKNOWN editor: ${n}`);s.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:r}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const s=new c(r.notebook,r,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(r.uri,s);const l=s.onDidChangeState(()=>{s.state===S.Resolved&&(s.dispose(),l.dispose(),this._activeExecutions.delete(r.uri))});return s.asApiObject()}};p=Ve([je(3,d.ILogService)],p),e.ExtHostNotebookKernels=p;var S;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(S||(S={}));class c extends T.Disposable{constructor(t,n,r){super();this._document=t,this._cell=n,this._proxy=r,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=S.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new m(10,s=>this.applyEdits(s)),this._executionOrder=n.internalMetadata.executionOrder,this.mixinMetadata({runState:P.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyEdits(this._document.uri,t,!1)}verifyStateForOutput(){if(this._state===S.Init)throw new Error("Must call start before modifying cell output");if(this._state===S.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const n={editType:9,handle:this._cell.handle,internalMetadata:t};this.applyEdits([n])}cellIndexToHandle(t){let n=this._cell;if(typeof t=="number"?n=this._document.getCellFromIndex(t):t&&(n=this._document.getCellFromApiCell(t)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(t){return t.map(n=>{const r=u.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return r===n.items?y.NotebookCellOutput.from(n):y.NotebookCellOutput.from({items:r,id:n.id,metadata:n.metadata})})}async updateOutputs(t,n,r){const s=this.cellIndexToHandle(n),l=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:s,append:r,outputs:l})}async updateOutputItems(t,n,r){return u.NotebookCellOutput.isNotebookCellOutput(n)&&(n=n.id),t=u.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(y.NotebookCellOutputItem.from),outputId:n,append:r})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(r){t._executionOrder=r,t.mixinMetadata({executionOrder:r})},start(r){var s;if(t._state===S.Resolved||t._state===S.Started)throw new Error("Cannot call start again");t._state=S.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:P.NotebookCellExecutionState.Executing,runStartTime:(s=r==null?void 0:r.startTime)!==null&&s!==void 0?s:null})},end(r){var s,l;if(t._state===S.Resolved)throw new Error("Cannot call resolve twice");t._state=S.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:(s=r==null?void 0:r.success)!==null&&s!==void 0?s:null,runEndTime:(l=r==null?void 0:r.endTime)!==null&&l!==void 0?l:null})},clearOutput(r){return t.verifyStateForOutput(),t.updateOutputs([],r,!1)},async appendOutput(r,s){return t.verifyStateForOutput(),t.updateOutputs(r,s,!0)},async replaceOutput(r,s){return t.verifyStateForOutput(),t.updateOutputs(r,s,!1)},async appendOutputItems(r,s){t.verifyStateForOutput(),t.updateOutputItems(r,s,!0)},async replaceOutputItems(r,s){t.verifyStateForOutput(),t.updateOutputItems(r,s,!1)}})}}class m{constructor(t,n){this.delay=t,this.callback=n,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=i.timeout(this.delay).then(()=>{this.waitPromise=void 0;const n=this.batch;return this.batch=[],this.callback(n)})),this.waitPromise}}}),define(we[191],_e([0,1,3,4,95]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(y,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=y.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(y,_,I){var i;const P=this._extHostNotebook.getEditorById(y);!P||(i=this._rendererMessageEmitters.get(_))===null||i===void 0||i.fire({editor:P.apiEditor,message:I})}createRendererMessaging(y){return{onDidReceiveMessage:(...I)=>this.getOrCreateEmitterFor(y).event(...I),postMessage:(I,i)=>{const P=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(I);if(!P)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(P.id,y,i)}}}getOrCreateEmitterFor(y){let _=this._rendererMessageEmitters.get(y);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(y)}}),this._rendererMessageEmitters.set(y,_),_)}}e.ExtHostNotebookRenderers=E}),define(we[99],_e([0,1,4,3,7,23,5,14]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends D.Disposable{constructor(d,u,w,p){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=d,this._proxy=p,this._id=p.$register(this.name,u,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(d){this.validate(),this._offset+=d?E.VSBuffer.fromString(d).byteLength:0}update(){this._id.then(d=>this._proxy.$update(d))}appendLine(d){this.validate(),this.append(d+`
`)}clear(){this.validate();const d=this._offset;this._id.then(u=>this._proxy.$clear(u,d))}show(d,u){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof d=="boolean"?d:u)))}hide(){this.validate(),this._id.then(d=>this._proxy.$close(d))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(d=>this._proxy.$dispose(d)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class I extends _{constructor(d,u){super(d,!1,void 0,u)}append(d){super.append(d),this._id.then(u=>this._proxy.$append(u,d)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=I;class i extends _{constructor(d,u,w){super(d,!0,u,w)}append(d){throw new Error("Not supported")}}class P{constructor(d,u){this.name=d,this._channel=u}append(d){this._channel.then(u=>u.append(d))}appendLine(d){this._channel.then(u=>u.appendLine(d))}clear(){this._channel.then(d=>d.clear())}show(d,u){this._channel.then(w=>w.show(d,u))}hide(){this._channel.then(d=>d.hide())}dispose(){this._channel.then(d=>d.dispose())}}e.LazyOutputChannel=P;let o=class{constructor(d){this._proxy=d.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(d){}createOutputChannel(d){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");return new I(d,this._proxy)}createOutputChannelFromLogFile(d,u){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");if(!u)throw new Error("illegal argument `file`. must not be falsy");return new i(d,u,this._proxy)}};o=Ve([je(0,y.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(we[192],_e([0,1,11,18,3,7,4,2,6,12,16,41]),function(Z,e,g,T,D,E,k,y,_,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(h,d,u){const w=h.getProxy(k.MainContext.MainThreadQuickOpen);class p{constructor(s,l){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=l}showQuickPick(s,l,v,b=T.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(s),C=++this._instances,a=w.$show(C,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},b),F={},N=a.then(()=>F);return Promise.race([N,A]).then(W=>{if(W!==F)return A.then(ce=>{const me=[];for(let G=0;G<ce.length;G++){const V=ce[G];let J,R,B,M,U;typeof V=="string"?J=V:(J=V.label,R=V.description,B=V.detail,M=V.picked,U=V.alwaysShow),me.push({label:J,description:R,handle:G,detail:B,picked:M,alwaysShow:U})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{v.onDidSelectItem(ce[G])}),w.$setItems(C,me),a.then(G=>{if(typeof G=="number")return ce[G];if(Array.isArray(G))return G.map(V=>ce[V])})})}).then(void 0,W=>{if(!I.isPromiseCanceledError(W))return w.$setError(C,W),Promise.reject(W)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,l=T.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,w.$input(s,typeof this._validateInput=="function",l).then(void 0,v=>{if(!I.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(s){return this._validateInput?g.asPromise(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,l=T.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!v)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(A=>A.uri.toString()===v.uri.toString())}createQuickPick(s,l){const v=new t(s,l,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const l=new n(s,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(s,l){const v=this._sessions.get(s);v&&v._fireDidChangeValue(l)}$onDidAccept(s){const l=this._sessions.get(s);l&&l._fireDidAccept()}$onDidChangeActive(s,l){const v=this._sessions.get(s);v instanceof t&&v._fireDidChangeActive(l)}$onDidChangeSelection(s,l){const v=this._sessions.get(s);v instanceof t&&v._fireDidChangeSelection(l)}$onDidTriggerButton(s,l){const v=this._sessions.get(s);v&&v._fireDidTriggerButton(l)}$onDidHide(s){const l=this._sessions.get(s);l&&l._fireDidHide()}}class S{constructor(s,l){this._extensionId=s,this._onDidDispose=l,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((l,v)=>{const b=l===_.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(b,l)}),this.update({buttons:s.map((l,v)=>({iconPath:c(l.iconPath),tooltip:l.tooltip,handle:l===_.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const l=this._handlesToButtons.get(s);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=E.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(s){if(!this._disposed){for(const l of Object.keys(s)){const v=s[l];this._pendingUpdate[l]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}S._nextId=1;function c(r){if(r instanceof _.ThemeIcon)return{id:r.id};const s=f(r),l=m(r);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof l=="string"?y.URI.file(l):l}}function m(r){return typeof r=="object"&&"light"in r?r.light:r}function f(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends S{constructor(s,l,v){super(s,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((l,v)=>{this._handlesToItems.set(v,l),this._itemsToHandles.set(l,v)}),this.update({items:s.map((l,v)=>({label:l.label,description:l.description,handle:v,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(s){const l=i.coalesce(s.map(v=>this._handlesToItems.get(v)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(s){const l=i.coalesce(s.map(v=>this._handlesToItems.get(v)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}}class n extends S{constructor(s,l){super(s,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?P.default.Error:P.default.Ignore})}}return new p(d,u)}e.createExtHostQuickOpen=o}),define(we[193],_e([0,1,2,3,47,7,11,4,16,110,17,26,29]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(s){if(s)return typeof s.iconPath=="string"?g.URI.file(s.iconPath):s.iconPath}function d(s,l){if(!s.iconPath&&!l.iconPath)return 0;if(s.iconPath){if(!l.iconPath)return 1}else return-1;const v=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,b=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath;return I.comparePaths(v,b)}function u(s,l){let v=0;if(s.strikeThrough!==l.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==l.faded)return s.faded?1:-1;if(s.tooltip!==l.tooltip)return(s.tooltip||"").localeCompare(l.tooltip||"");if(v=d(s,l),v!==0)return v;if(s.light&&l.light)v=d(s.light,l.light);else{if(s.light)return 1;if(l.light)return-1}if(v!==0)return v;if(s.dark&&l.dark)v=d(s.dark,l.dark);else{if(s.dark)return 1;if(l.dark)return-1}return v}function w(s,l){if(s.command!==l.command)return s.command<l.command?-1:1;if(s.title!==l.title)return s.title<l.title?-1:1;if(s.tooltip!==l.tooltip){if(s.tooltip!==void 0&&l.tooltip!==void 0)return s.tooltip<l.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(s.arguments===l.arguments)return 0;if(s.arguments)if(l.arguments){if(s.arguments.length!==l.arguments.length)return s.arguments.length-l.arguments.length}else return 1;else return-1;for(let v=0;v<s.arguments.length;v++){const b=s.arguments[v],A=l.arguments[v];if(b!==A)return b<A?-1:1}return 0}function p(s,l){let v=I.comparePaths(s.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(v!==0)return v;if(s.command&&l.command)v=w(s.command,l.command);else{if(s.command)return 1;if(l.command)return-1}if(v!==0)return v;if(s.decorations&&l.decorations)v=u(s.decorations,l.decorations);else{if(s.decorations)return 1;if(l.decorations)return-1}return v}function S(s,l){for(let v=0;v<s.length;v++)if(s[v]!==l[v])return!1;return!0}function c(s,l){return s.command===l.command&&s.title===l.title&&s.tooltip===l.tooltip&&(s.arguments&&l.arguments?S(s.arguments,l.arguments):s.arguments===l.arguments)}function m(s,l){return _.equals(s,l,c)}class f{constructor(l,v,b){this._extension=l,this._proxy=v,this._sourceControlHandle=b,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(l){if(o.checkProposedApiEnabled(this._extension),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(l,v){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,l,v)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=f;class t{constructor(l,v,b,A,C){this._proxy=l,this._commands=v,this._sourceControlHandle=b,this._id=A,this._label=C,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,v){const b=this._resourceStatesCommandsMap.get(l);return b?k.asPromise(()=>this._commands.executeCommand(b.command,...b.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var l;const v=[...this._resourceStates].sort(p),A=_.sortedDiff(this._resourceSnapshot,v,p).map(F=>{const N=F.toInsert.map(W=>{const ce=this._resourceHandlePool++;this._resourceStatesMap.set(ce,W);const me=W.resourceUri,G=h(W.decorations),V=W.decorations&&h(W.decorations.light)||G,J=W.decorations&&h(W.decorations.dark)||G,R=[];let B;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const pe=new E.DisposableStore;B=this._commands.converter.toInternal(W.command,pe),this._resourceStatesDisposablesMap.set(ce,pe)}else this._resourceStatesCommandsMap.set(ce,W.command);V&&R.push(V),J&&J.toString()!==(V==null?void 0:V.toString())&&R.push(J);const M=W.decorations&&W.decorations.tooltip||"",U=W.decorations&&!!W.decorations.strikeThrough,j=W.decorations&&!!W.decorations.faded,z=W.contextValue||"";return{rawResource:[ce,me,R,M,U,j,z,B],handle:ce}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),C=A.map(({start:F,deleteCount:N,toInsert:W})=>[F,N,W.map(ce=>ce.rawResource)]),a=A.reverse();for(const{start:F,deleteCount:N,toInsert:W}of a){const ce=W.map(G=>G.handle),me=this._handlesSnapshot.splice(F,N,...ce);for(const G of me)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),(l=this._resourceStatesDisposablesMap.get(G))===null||l===void 0||l.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=v,C}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(l,v,b,A,C,a){this._proxy=v,this._commands=b,this._id=A,this._label=C,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,C,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=l;const v=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&m(this._statusBarCommands,l))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=l;const v=(l||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(l,v){const b=new t(this._proxy,this._commands,this.handle,l,v),A=T.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,A),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const l=[],v=[];for(const[b,A]of this.createdResourceGroups){A.dispose();const C=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});T.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),C.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),l.push([b.handle,b.id,b.label,b.features]);const a=b._takeResourceStateSnapshot();a.length>0&&v.push([b.handle,a]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,l,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(v=>{const b=v._takeResourceStateSnapshot();b.length!==0&&l.push([v.handle,b])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([D.debounce(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([D.debounce(100)],n.prototype,"eventuallyUpdateResourceStates",null);let r=class Ln{constructor(l,v,b){this._commands=v,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=l.getProxy(y.MainContext.MainThreadSCM),this._telemetry=l.getProxy(y.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const C=this._sourceControls.get(A.sourceControlHandle);if(!C)return A;const a=C.getResourceGroup(A.groupHandle);return a?a.getResourceState(A.handle):A}else if(A&&A.$mid===4){const C=this._sourceControls.get(A.sourceControlHandle);return C?C.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const C=this._sourceControls.get(A.handle);return C||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,v,b,A){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,v,b,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const C=Ln._handlePool++,a=new n(l,this._proxy,this._commands,v,b,A);this._sourceControls.set(C,a);const F=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(l.identifier))||[];return F.push(a),this._sourceControlsByExtension.set(P.ExtensionIdentifier.toKey(l.identifier),F),a}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const v=this._sourceControlsByExtension.get(P.ExtensionIdentifier.toKey(l.identifier)),b=v&&v[v.length-1];return b&&b.inputBox}$provideOriginalResource(l,v,b){const A=g.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,A.toString());const C=this._sourceControls.get(l);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>C.quickDiffProvider.provideOriginalResource(A,b)).then(a=>a||null)}$onInputBoxValueChange(l,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const b=this._sourceControls.get(l);return b&&b.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(l,v,b,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,v,b);const C=this._sourceControls.get(l);if(!C)return Promise.resolve(void 0);const a=C.getResourceGroup(v);return a?a.$executeResourceCommand(b,A):Promise.resolve(void 0)}$validateInput(l,v,b){this.logService.trace("ExtHostSCM#$validateInput",l);const A=this._sourceControls.get(l);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>A.inputBox.validateInput(v,b)).then(C=>C?Promise.resolve([C.message,C.type]):Promise.resolve(void 0))}$setSelectedSourceControl(l){var v,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&((v=this._sourceControls.get(l))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};r._handlePool=0,r=Ve([je(2,i.ILogService)],r),e.ExtHostSCM=r});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[194],_e([0,1,6,4,130,7]),function(Z,e,g,T,D,E){"use strict";var k,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class _{constructor(o,h,d,u,w=g.StatusBarAlignment.Left,p){k.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,nt(this,k,o,"f"),nt(this,y,h,"f"),this._entryId=_.ID_GEN++,this._extension=d,this._id=u,this._alignment=w,this._priority=p}get id(){var o;return(o=this._id)!==null&&o!==void 0?o:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var o;return(o=this._command)===null||o===void 0?void 0:o.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!_.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ue(this,y,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ue(this,y,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,k,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var o;this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let d;this._name?d=this._name:d=D.localize(0,null,this._extension.displayName||this._extension.name);let u=this._color;this._backgroundColor&&(u=_.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,k,"f").$setEntry(this._entryId,h,d,this._text,this._tooltip,(o=this._command)===null||o===void 0?void 0:o.internal,u,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=_,k=new WeakMap,y=new WeakMap,_.ID_GEN=0,_.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class I{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=D.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const h={message:o};return this._messages.unshift(h),this._update(),new g.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(o,h){this._proxy=o.getProxy(T.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new I(this)}createStatusBarEntry(o,h,d,u){return new _(this._proxy,this._commands,o,h,d,u)}setStatusBarMessage(o,h){const d=this._statusMessage.setMessage(o);let u;return typeof h=="number"?u=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new g.Disposable(()=>{d.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=i}),define(we[73],_e([0,1,4,3,5]),function(Z,e,g,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(y){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=y.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(y,_){this._proxy.$registerExtensionStorageKeysToSync(y,_)}getValue(y,_,I){return this._proxy.$getValue(y,_).then(i=>i||I)}setValue(y,_,I){return this._proxy.$setValue(y,_,I)}$acceptValue(y,_,I){this._onDidChangeStorage.fire({shared:y,key:_,value:I})}}e.ExtHostStorage=E,e.IExtHostStorage=D.createDecorator("IExtHostStorage")}),define(we[74],_e([0,1,5,28,17,72,2]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=g.createDecorator("IExtensionStoragePaths");let y=class{constructor(I,i,P){var o;this._logService=i,this._extHostFileSystem=P,this._workspace=(o=I.workspace)!==null&&o!==void 0?o:void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var I;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,P=k.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(I=k.URI.revive(this._workspace.configuration))===null||I===void 0?void 0:I.toString(),name:this._workspace.name},void 0,2))),P}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(I){if(this._value)return k.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return k.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}};y=Ve([je(0,T.IExtHostInitDataService),je(1,D.ILogService),je(2,E.IExtHostConsumerFileSystem)],y),e.ExtensionStoragePaths=y}),define(we[37],_e([0,1,3,4,5,2,14,7,6,131,12,161,18,34,151,10]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=D.createDecorator("IExtHostTerminalService");class w{constructor(n,r,s,l){this._proxy=n,this._id=r,this._creationOptions=s,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(b,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,b,A)},show(b){v._checkDisposed(),v._proxy.$show(v._id,b)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:u.withNullAsUndefined(n.shellPath),shellArgs:u.withNullAsUndefined(n.shellArgs),cwd:u.withNullAsUndefined(n.cwd),env:u.withNullAsUndefined(n.env),icon:u.withNullAsUndefined(n.iconPath),initialText:u.withNullAsUndefined(n.message),strictEnv:u.withNullAsUndefined(n.strictEnv),hideFromUser:u.withNullAsUndefined(n.hideFromUser),isFeatureTerminal:u.withNullAsUndefined(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:u.withNullAsUndefined(r==null?void 0:r.useShellEnvironment),isSplitTerminal:u.withNullAsUndefined(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,r){return n===this._cols&&r===this._rows||n===0||r===0?!1:(this._cols=n,this._rows=r,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=w;class p{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,r){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let S=1,c=class extends y.Disposable{constructor(n,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=r.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[s,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){const r=n?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(n){const r=n?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(n,r){const s=new w(this._proxy,h.generateUuid(),n,n.name),l=new p(n.pty);return s.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,n.iconPath).then(v=>{const b=this._setupExtHostProcessListeners(v,l);this._terminalProcessDisposables[v]=b}),this._terminals.push(s),s.value}attachPtyToTerminal(n,r){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const l=new p(r),v=this._setupExtHostProcessListeners(n,l);this._terminalProcessDisposables[n]=v}async $acceptActiveTerminalChanged(n){const r=this._activeTerminal;if(n===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(n);s&&(this._activeTerminal=s,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,r){const s=this._getTerminalById(n);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:r})}async $acceptTerminalDimensions(n,r,s){const l=this._getTerminalById(n);l&&l.setDimensions(r,s)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,s){var l;(l=this._terminalProcesses.get(n))===null||l===void 0||l.resize(r,s)}async $acceptTerminalTitleChange(n,r){const s=this._getTerminalById(n);s&&(s.name=r)}async $acceptTerminalClosed(n,r){const s=this._getTerminalObjectIndexById(this._terminals,n);if(s!==null){const l=this._terminals.splice(s,1)[0];l.setExitCode(r),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(n,r,s,l){if(r){const A=this._getTerminalObjectIndexById(this._terminals,r);if(A!==null){this._terminals[A]._id=n,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:E.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},b=new w(this._proxy,n,v,s);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(n,r){const s=this._getTerminalById(n);s&&s._setProcessId(r)}async $startExtensionTerminal(n,r){const s=this._getTerminalById(n);if(!s)return{message:I.localize(0,null,n)};s.isOpen||await new Promise(v=>{const b=this.onDidOpenTerminal(async A=>{A===s.value&&(b.dispose(),v())})});const l=this._terminalProcesses.get(n);l?l.startSendingEvents(r):this._extensionTerminalAwaitingStart[n]={initialDimensions:r}}_setupExtHostProcessListeners(n,r){const s=new y.DisposableStore;s.add(r.onProcessReady(v=>this._proxy.$sendProcessReady(n,v.pid,v.cwd))),s.add(r.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(n,v))),this._bufferer.startBuffering(n,r.onProcessData),s.add(r.onProcessExit(v=>this._onProcessExit(n,v))),r.onProcessOverrideDimensions&&s.add(r.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(n,v))),this._terminalProcesses.set(n,r);const l=this._extensionTerminalAwaitingStart[n];return l&&r instanceof p&&(r.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),s}$acceptProcessAckDataEvent(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.input(r)}$acceptProcessResize(n,r,s){var l;try{(l=this._terminalProcesses.get(n))===null||l===void 0||l.resize(r,s)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.shutdown(r)}$acceptProcessRequestInitialCwd(n){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(n,s))}$acceptProcessRequestCwd(n){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.getCwd().then(s=>this._proxy.$sendProcessCwd(n,s))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,r){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,r),this._proxy.$registerProfileProvider(n),new _.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(n,r){var s;const l=new o.CancellationTokenSource().token,v=await((s=this._profileProviders.get(n))===null||s===void 0?void 0:s.provideProfileOptions(l));if(!l.isCancellationRequested){if(!v)throw new Error(`No terminal profile options provided for id "${n}"`);"pty"in v&&this.createExtensionTerminal(v,{isSplitTerminal:r}),this.createTerminalFromOptions(v,{isSplitTerminal:r})}}async $provideLinks(n,r){const s=this._getTerminalById(n);if(!s)return[];this._terminalLinkCache.delete(n);const l=this._terminalLinkCancellationSource.get(n);l&&l.dispose(!0);const v=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,v);const b=[],A={terminal:s.value,line:r},C=[];for(const N of this._linkProviders)C.push(new Promise(async W=>{v.token.onCancellationRequested(()=>W({provider:N,links:[]}));const ce=await N.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||W({provider:N,links:ce})}));const a=await Promise.all(C);if(v.token.isCancellationRequested)return[];const F=new Map;for(const N of a)N&&N.links.length>0&&b.push(...N.links.map(W=>{const ce={id:S++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return F.set(ce.id,{provider:N.provider,link:W}),ce}));return this._terminalLinkCache.set(n,F),b}$activateLink(n,r){var s;const l=(s=this._terminalLinkCache.get(n))===null||s===void 0?void 0:s.get(r);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(n,r){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const s=this._terminalProcessDisposables[n];s&&(s.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,r)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,r){const s=this._getTerminalObjectIndexById(n,r);return s!==null?n[s]:null}_getTerminalObjectIndexById(n,r){let s=null;return n.some((l,v)=>l._id===r?(s=v,!0):!1),s}getEnvironmentVariableCollection(n){let r=this._environmentVariableCollections.get(n.identifier.value);return r||(r=new m,this._setEnvironmentVariableCollection(n.identifier.value,r)),r}_syncEnvironmentVariableCollection(n,r){const s=P.serializeEnvironmentVariableCollection(r.map);this._proxy.$setEnvironmentVariableCollection(n,r.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const s=r[0],l=new m(r[1]);this._setEnvironmentVariableCollection(s,l)})}$acceptDefaultProfile(n,r){this._defaultProfile=n,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(n,r){this._environmentVariableCollections.set(n,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,r)})}};c=Ve([je(1,k.IExtHostRpcService)],c),e.BaseExtHostTerminalService=c;class m{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,r){this._setIfDiffers(n,{value:r,type:_.EnvironmentVariableMutatorType.Replace})}append(n,r){this._setIfDiffers(n,{value:r,type:_.EnvironmentVariableMutatorType.Append})}prepend(n,r){this._setIfDiffers(n,{value:r,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,r){const s=this.map.get(n);(!s||s.value!==r.value||s.type!==r.type)&&(this.map.set(n,r),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((s,l)=>n.call(r,l,s,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let f=class extends c{constructor(n){super(!1,n)}createTerminal(n,r,s){throw new i.NotSupportedError}createTerminalFromOptions(n,r){throw new i.NotSupportedError}};f=Ve([je(0,k.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f}),define(we[195],_e([0,1,3,16,4,96,9,6]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(i,P){this._extHostDocumentsAndEditors=P,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const P=this._extHostDocumentsAndEditors.allEditors();return i?P:P.map(o=>o.value)}async showTextDocument(i,P,o){let h;typeof P=="number"?h={position:k.ViewColumn.from(P),preserveFocus:o}:typeof P=="object"?h={position:k.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?k.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:h={preserveFocus:!1};const d=await this._proxy.$tryShowTextDocument(i.uri,h),u=d&&this._extHostDocumentsAndEditors.getEditor(d);if(u)return u.value;throw d?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,P){return new E.TextEditorDecorationType(this._proxy,i,P).value}$acceptEditorPropertiesChanged(i,P){const o=this._extHostDocumentsAndEditors.getEditor(i);if(!o)throw new Error("unknown text editor");if(P.options&&o._acceptOptions(P.options),P.selections){const h=P.selections.selections.map(k.Selection.to);o._acceptSelections(h)}if(P.visibleRanges){const h=T.coalesce(P.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(h)}if(P.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},P.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(P.options.lineNumbers)})}),P.selections){const h=y.TextEditorSelectionChangeKind.fromValue(P.selections.source),d=P.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:d,kind:h})}if(P.visibleRanges){const h=T.coalesce(P.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:h})}}$acceptEditorPositionData(i){for(const P in i){const o=this._extHostDocumentsAndEditors.getEditor(P);if(!o)throw new Error("Unknown text editor");const h=k.ViewColumn.to(i[P]);o.value.viewColumn!==h&&(o._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:h}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=_});var Kt=this&&this.__rest||function(Z,e){var g={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(g[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Z);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[D])&&(g[T[D]]=Z[T[D]]);return g};define(we[196],_e([0,1,2,5,4,7,6]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class y{constructor(i,P){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),P.registerArgumentProcessor({processArgument:o=>{var h,d;if(o&&o.$mid===11){const u=o.uri===void 0?void 0:g.URI.revive(o.uri);return(d=(h=this._itemsBySourceAndUriMap.get(o.source))===null||h===void 0?void 0:h.get(_(u)))===null||d===void 0?void 0:d.get(o.handle)}return o}})}async $getTimeline(i,P,o,h,d){const u=this._providers.get(i);return u==null?void 0:u.provideTimeline(g.URI.revive(P),o,h,d)}registerTimelineProvider(i,P,o,h){const d=new E.DisposableStore,u=this.convertTimelineItem(P.id,h,d).bind(this);let w;P.onDidChange&&(w=P.onDidChange(S=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},S),{id:P.id})),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},P),{scheme:i,onDidChange:void 0,async provideTimeline(S,c,m,f){var t;(f==null?void 0:f.resetCache)&&(d.clear(),(t=p.get(P.id))===null||t===void 0||t.clear());const n=await P.provideTimeline(S,c,m);if(n==null)return;const r=u(S,f);return Object.assign(Object.assign({},n),{source:P.id,items:n.items.map(r)})},dispose(){var S;for(const c of p.values())(S=c.get(P.id))===null||S===void 0||S.clear();w==null||w.dispose(),d.dispose()}}))}convertTimelineItem(i,P,o){return(h,d)=>{let u;if(d==null?void 0:d.cacheResults){let w=this._itemsBySourceAndUriMap.get(i);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(i,w));const p=_(h);u=w.get(p),u===void 0&&(u=new Map,w.set(p,u))}return w=>{var p,S;const{iconPath:c}=w,m=Kt(w,["iconPath"]),f=`${i}|${(p=w.id)!==null&&p!==void 0?p:w.timestamp}`;u==null||u.set(f,w);let t,n,r;return w.iconPath&&(c instanceof k.ThemeIcon?r={id:c.id}:g.URI.isUri(c)?(t=c,n=c):{light:t,dark:n}=c),Object.assign(Object.assign({},m),{id:(S=m.id)!==null&&S!==void 0?S:void 0,handle:f,source:i,command:w.command?P.toInternal(w.command,o):void 0,icon:t,iconDark:n,themeIcon:r,accessibilityInformation:w.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),E.toDisposable(()=>{var o;for(const h of this._itemsBySourceAndUriMap.values())(o=h.get(i.id))===null||o===void 0||o.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=y;function _(I){return I==null?void 0:I.toString()}}),define(we[197],_e([0,1,7,15,2,4]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,i,P){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const o=P.schemes.find(h=>!k.supportedSchemes.has(h));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,i),this._proxy.$registerUriOpener(I,P.schemes,_,P.label),g.toDisposable(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,i){const P=this._openers.get(_);if(!P)throw new Error(`Unknown opener with id: ${_}`);const o=D.URI.revive(I);return P.canOpenExternalUri(o,i)}async $openUri(_,I,i){const P=this._openers.get(_);if(!P)throw new Error(`Unknown opener id: '${_}'`);return P.openExternalUri(D.URI.revive(I.resolvedUri),{sourceUri:D.URI.revive(I.sourceUri)},i)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(we[198],_e([0,1,4,2,7,12,26]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class y{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(I,i){if(this.handles.has(k.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const P=y.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(I)),this.handlers.set(P,i),this._proxy.$registerUriHandler(P,I),D.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(I)),this.handlers.delete(P),this._proxy.$unregisterUriHandler(P)})}$handleExternalUri(I,i){const P=this.handlers.get(I);if(!P)return Promise.resolve(void 0);try{P.handleUri(T.URI.revive(i))}catch(o){E.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(I){return T.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=y,y.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[46],_e([0,1,3,2,139,156,68,4]),function(Z,e,g,T,D,E,k,y){"use strict";var _,I,i,P,o,h,d,u,w,p,S,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(b,A,C,a,F,N,W){_.set(this,void 0),I.set(this,void 0),i.set(this,void 0),P.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,""),u.set(this,void 0),w.set(this,!1),p.set(this,!1),S.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new g.Emitter),this._onDidDispose=Ue(this,c,"f").event,nt(this,_,b,"f"),nt(this,I,A,"f"),nt(this,u,C,"f"),nt(this,P,a,"f"),nt(this,o,F,"f"),nt(this,h,N,"f"),nt(this,S,f(N),"f"),nt(this,i,W,"f")}dispose(){nt(this,w,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return nt(this,p,!0,"f"),k.asWebviewUri(b,Ue(this,P,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,d,"f")}set html(b){this.assertNotDisposed(),Ue(this,d,"f")!==b&&(nt(this,d,b,"f"),!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(nt(this,p,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,I,"f").$setHtml(Ue(this,_,"f"),b))}get options(){return this.assertNotDisposed(),Ue(this,u,"f")}set options(b){this.assertNotDisposed(),Ue(this,I,"f").$setOptions(Ue(this,_,"f"),r(Ue(this,h,"f"),Ue(this,o,"f"),b)),nt(this,u,b,"f")}async postMessage(b){if(Ue(this,w,"f"))return!1;const A=E.serializeWebviewMessage(b,{serializeBuffersForPostMessage:Ue(this,S,"f")});return Ue(this,I,"f").$postMessage(Ue(this,_,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,_=new WeakMap,I=new WeakMap,i=new WeakMap,P=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap,p=new WeakMap,S=new WeakMap,c=new WeakMap;function f(v){try{const b=D.normalizeVersion(D.parseVersion(v.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(b,A,C,a,F){this.initData=A,this.workspace=C,this._logService=a,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(y.MainContext.MainThreadWebviews)}$onMessage(b,A,...C){const a=this.getWebview(b);if(a){const{message:F}=E.deserializeWebviewMessage(A,C);a._onMessageEmitter.fire(F)}}$onMissingCsp(b,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,A,C){const a=new m(b,this._webviewProxy,s(A),this.initData,this.workspace,C,this._deprecationService);return this._webviews.set(b,a),a._onDidDispose(()=>{this._webviews.delete(b)}),a}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function n(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=n;function r(v,b,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||l(v,b)}}e.serializeWebviewOptions=r;function s(v){var b;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(b=v.localResourceRoots)===null||b===void 0?void 0:b.map(A=>T.URI.from(A))}}e.reviveOptions=s;function l(v,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(A=>A.uri),v.extensionLocation]}}),define(we[199],_e([0,1,18,53,7,15,25,2,9,46,63,4,6]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=m(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class d{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,r){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const l=new h(n,r);return this._documents.set(s,l),l}delete(t,n){const r=this.key(t,n.uri);this._documents.delete(r)}key(t,n){return`${t}@@@${n}`}}var u;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(u||(u={}));class w{constructor(){this._providers=new Map}addTextProvider(t,n,r){return this.add(0,t,n,r)}addCustomProvider(t,n,r){return this.add(1,t,n,r)}get(t){return this._providers.get(t)}add(t,n,r,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:r,provider:s}),new o.Disposable(()=>this._providers.delete(n))}}class p{constructor(t,n,r,s,l){this._extHostDocuments=n,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=l,this._editorProviders=new w,this._documents=new d,this._proxy=t.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,r,s){const l=new D.DisposableStore;return S(r)?(l.add(this._editorProviders.addTextProvider(n,t,r)),this._proxy.$registerTextEditorProvider(I.toExtensionData(t),n,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},I.shouldSerializeBuffersForPostMessage(t))):(l.add(this._editorProviders.addCustomProvider(n,t,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(v=>{const b=this.getCustomDocumentEntry(n,v.document.uri);if(c(v)){const A=b.addEdit(v);this._proxy.$onDidEdit(v.document.uri,n,A,v.label)}else this._proxy.$onContentChange(v.document.uri,n)})),this._proxy.$registerCustomEditorProvider(I.toExtensionData(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,I.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(l,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,r,s,l){var v;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const A=y.URI.revive(t),C=await b.provider.openCustomDocument(A,{backupId:r,untitledDocumentData:s==null?void 0:s.buffer},l);let a;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(a=(v=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,C,a),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=y.URI.revive(t),{document:l}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,l),l.dispose()}async $resolveWebviewEditor(t,n,r,s,l,v){const b=this._editorProviders.get(r);if(!b)throw new Error(`No provider found for '${r}'`);const A=_.ViewColumn.to(l),C=this._extHostWebview.createNewWebview(n,s.webviewOptions,b.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(n,r,s.title,A,s.panelOptions,C),F=y.URI.revive(t);switch(b.type){case 1:{const{document:N}=this.getCustomDocumentEntry(r,F);return b.provider.resolveCustomEditor(N,a,v)}case 0:{const N=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(N,a,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,r){this.getCustomDocumentEntry(n,t).disposeEdits(r)}async $onMoveCustomEditor(t,n,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(t);if(!l)throw new Error("No webview found");const v=y.URI.revive(n),b=this._extHostDocuments.getDocument(v);await s.provider.moveCustomTextEditor(b,l,g.CancellationToken.None)}async $undo(t,n,r,s){return this.getCustomDocumentEntry(n,t).undo(r,s)}async $redo(t,n,r,s){return this.getCustomDocumentEntry(n,t).redo(r,s)}async $revert(t,n,r){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(t,n,r){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(t,n,r,s){const l=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(l.document,y.URI.revive(r),s)}async $backup(t,n,r){const s=this.getCustomDocumentEntry(n,t),v=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(v),v.id}getCustomDocumentEntry(t,n){const r=this._documents.get(t,y.URI.revive(n));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const n=this._editorProviders.get(t),r=n==null?void 0:n.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function S(f){return typeof f.resolveCustomTextEditor=="function"}function c(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function m(f){const t=f.scheme===E.Schemas.file||f.scheme===E.Schemas.untitled?f.fsPath:f.toString();return T.hash(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[200],_e([0,1,3,7,2,34,9,46,4,6]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";var i,P,o,h,d,u,w,p,S,c,m,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends T.Disposable{constructor(v,b,A,C,a,F,N){super();i.set(this,void 0),P.set(this,void 0),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,void 0),w.set(this,void 0),p.set(this,void 0),S.set(this,!0),c.set(this,!0),m.set(this,!1),f.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,f,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,i,v,"f"),nt(this,P,b,"f"),nt(this,o,A,"f"),nt(this,d,F,"f"),nt(this,p,a,"f"),nt(this,u,C,"f"),nt(this,h,N,"f")}dispose(){Ue(this,m,"f")||(nt(this,m,!0,"f"),Ue(this,f,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,h,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,o,"f")}get title(){return this.assertNotDisposed(),Ue(this,u,"f")}set title(v){this.assertNotDisposed(),Ue(this,u,"f")!==v&&(nt(this,u,v,"f"),Ue(this,P,"f").$setTitle(Ue(this,i,"f"),v))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(v){this.assertNotDisposed(),Ue(this,w,"f")!==v&&(nt(this,w,v,"f"),Ue(this,P,"f").$setIconPath(Ue(this,i,"f"),D.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Ue(this,d,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,p,"f")=="number"&&Ue(this,p,"f")<0))return Ue(this,p,"f")}get active(){return this.assertNotDisposed(),Ue(this,c,"f")}get visible(){return this.assertNotDisposed(),Ue(this,S,"f")}_updateViewState(v){Ue(this,m,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(nt(this,c,v.active,"f"),nt(this,S,v.visible,"f"),nt(this,p,v.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(v,b){this.assertNotDisposed(),Ue(this,P,"f").$reveal(Ue(this,i,"f"),{viewColumn:v?k.ViewColumn.from(v):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,m,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,P=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap,p=new WeakMap,S=new WeakMap,c=new WeakMap,m=new WeakMap,f=new WeakMap,t=new WeakMap;class r{constructor(v,b,A){this.webviews=b,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return E.generateUuid()}createWebviewPanel(v,b,A,C,a={}){const F=typeof C=="object"?C.viewColumn:C,N={viewColumn:k.ViewColumn.from(F),preserveFocus:typeof C=="object"&&!!C.preserveFocus},W=y.shouldSerializeBuffersForPostMessage(v),ce=r.newHandle();this._proxy.$createWebviewPanel(y.toExtensionData(v),ce,b,{title:A,panelOptions:s(a),webviewOptions:y.serializeWebviewOptions(v,this.workspace,a),serializeBuffersForPostMessage:W},N);const me=this.webviews.createNewWebview(ce,a,v);return this.createNewWebviewPanel(ce,b,A,F,a,me)}$onDidChangeWebviewPanelViewStates(v){const b=Object.keys(v);b.sort((A,C)=>{const a=v[A],F=v[C];return a.active?1:F.active?-1:+a.visible-+F.visible});for(const A of b){const C=this.getWebviewPanel(A);if(!C)continue;const a=v[A];C._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(v){const b=this.getWebviewPanel(v);b==null||b.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,b,A){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:A,extension:v}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:y.shouldSerializeBuffersForPostMessage(v)}),new I.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(v,b,A,C){const a=this._serializers.get(b);if(!a)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:N}=a,W=this.webviews.createNewWebview(v,A.webviewOptions,N),ce=this.createNewWebviewPanel(v,b,A.title,C,A.panelOptions,W);await F.deserializeWebviewPanel(ce,A.state)}createNewWebviewPanel(v,b,A,C,a,F){const N=new n(v,this._proxy,b,A,C,a,F);return this._webviewPanels.set(v,N),N}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=r;function s(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[201],_e([0,1,3,7,46,4,6]),function(Z,e,g,T,D,E,k){"use strict";var y,_,I,i,P,o,h,d,u,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends T.Disposable{constructor(m,f,t,n,r,s){super();y.set(this,void 0),_.set(this,void 0),I.set(this,void 0),i.set(this,void 0),P.set(this,!1),o.set(this,void 0),h.set(this,void 0),d.set(this,void 0),u.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,w.set(this,this._register(new g.Emitter)),this.onDidDispose=Ue(this,w,"f").event,nt(this,I,t,"f"),nt(this,h,n,"f"),nt(this,y,m,"f"),nt(this,_,f,"f"),nt(this,i,r,"f"),nt(this,o,s,"f")}dispose(){Ue(this,P,"f")||(nt(this,P,!0,"f"),Ue(this,w,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,h,"f")}set title(m){this.assertNotDisposed(),Ue(this,h,"f")!==m&&(nt(this,h,m,"f"),Ue(this,_,"f").$setWebviewViewTitle(Ue(this,y,"f"),m))}get description(){return this.assertNotDisposed(),Ue(this,d,"f")}set description(m){this.assertNotDisposed(),Ue(this,d,"f")!==m&&(nt(this,d,m,"f"),Ue(this,_,"f").$setWebviewViewDescription(Ue(this,y,"f"),m))}get visible(){return Ue(this,o,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,I,"f")}_setVisible(m){m===Ue(this,o,"f")||Ue(this,P,"f")||(nt(this,o,m,"f"),Ue(this,u,"f").fire())}show(m){this.assertNotDisposed(),Ue(this,_,"f").$show(Ue(this,y,"f"),!!m)}assertNotDisposed(){if(Ue(this,P,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,_=new WeakMap,I=new WeakMap,i=new WeakMap,P=new WeakMap,o=new WeakMap,h=new WeakMap,d=new WeakMap,u=new WeakMap,w=new WeakMap;class S{constructor(m,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:m}),this._proxy.$registerWebviewViewProvider(D.toExtensionData(m),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(m,f,t,n,r){const s=this._viewProviders.get(f);if(!s)throw new Error(`No view provider found for '${f}'`);const{provider:l,extension:v}=s,b=this._extHostWebview.createNewWebview(m,{},v),A=new p(m,this._proxy,f,t,b,!0);this._webviewViews.set(m,A),await l.resolveWebviewView(A,{state:n},r)}async $onDidChangeWebviewViewVisibility(m,f){this.getWebviewView(m)._setVisible(f)}async $disposeWebviewView(m){const f=this.getWebviewView(m);this._webviewViews.delete(m),f.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const f=this._webviewViews.get(m);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=S}),define(we[100],_e([0,1,3,4,2,15,8,5,14]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class Nn{constructor(P){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Nn.InitialState,this._proxy=P.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(P){P!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:P}),this._onDidChangeWindowState.fire(this._state))}openUri(P,o){let h;if(typeof P=="string"){h=P;try{P=D.URI.parse(P)}catch(d){return Promise.reject(`Invalid uri - '${P}'`)}}return k.isFalsyOrWhitespace(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this._proxy.$openUri(P,h,o)}async asExternalUri(P,o){if(k.isFalsyOrWhitespace(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(P,o);return D.URI.from(h)}};I.InitialState={focused:!0},I=Ve([je(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=y.createDecorator("IExtHostWindow")}),define(we[202],_e([0,1,17,4,28,14]),function(Z,e,g,T,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends g.AbstractLogger{constructor(_,I){super();this._proxy=_.getProxy(T.MainContext.MainThreadLog),this._logFile=I.logFile.toJSON(),this.setLevel(I.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...I){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...I){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...I){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...I){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...I){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...I){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};k=Ve([je(0,E.IExtHostRpcService),je(1,D.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(we[203],_e([0,1,11,18,12,3,7,112,174,97,23]),function(Z,e,g,T,D,E,k,y,_,I,i){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(s,l){try{return JSON.stringify(s,l)}catch(v){return"null"}}function h(s,l){return JSON.stringify(s,l)}function d(s){return s?(l,v)=>v&&v.$mid===1?s.transformOutgoing(v):v:null}var u;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const p=()=>{},S=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class m extends k.Disposable{constructor(l,v=null,b=null){super();this[P]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=l,this._logger=v,this._uriTransformer=b,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,C=I.ProxyIdentifier.count;A<C;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(l=>{this._pendingRPCReplies[l].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(l){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(l){this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(l){this._responsiveState!==l&&(this._responsiveState=l,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(l){return this._uriTransformer?y.transformIncomingURIs(l,this._uriTransformer):l}getProxy(l){const{nid:v,sid:b}=l;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,b)),this._proxies[v]}_createProxy(l,v){let b={get:(A,C)=>(typeof C=="string"&&!A[C]&&C.charCodeAt(0)===36&&(A[C]=(...a)=>this._remoteCall(l,C,a)),C===c?v:A[C])};return new Proxy(Object.create(null),b)}set(l,v){return this._locals[l.nid]=v,v}assertRegistered(l){for(let v=0,b=l.length;v<b;v++){const A=l[v];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(l){if(this._isDisposed)return;const v=l.byteLength,b=f.read(l,0),A=b.readUInt8(),C=b.readUInt32();switch(A){case 1:case 2:{let{rpcId:a,method:F,args:N}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(N=y.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(v,C,a,F,N,A===2);break}case 3:case 4:{let{rpcId:a,method:F,args:N}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(N=y.transformIncomingURIs(N,this._uriTransformer)),this._receiveRequest(v,C,a,F,N,A===4);break}case 5:{this._logger&&this._logger.logIncoming(v,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(v,C);break}case 7:{this._receiveReply(v,C,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(b);this._uriTransformer&&(a=y.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(v,C,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(b);this._receiveReply(v,C,a);break}case 10:{let a=t.deserializeReplyErrError(b);this._uriTransformer&&(a=y.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(v,C,a);break}case 11:{this._receiveReplyErr(v,C,void 0);break}default:console.error("received unexpected message"),console.error(l)}}_receiveRequest(l,v,b,A,C,a){this._logger&&this._logger.logIncoming(l,v,1,`receiveRequest ${I.getStringIdentifierForProxy(b)}.${A}(`,C);const F=String(v);let N,W;if(a){const me=new T.CancellationTokenSource;C.push(me.token),N=this._invokeHandler(b,A,C),W=()=>me.cancel()}else N=this._invokeHandler(b,A,C),W=p;this._cancelInvokedHandlers[F]=W;const ce=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(ce.byteLength,v,1,"ack"),this._protocol.send(ce),N.then(me=>{delete this._cancelInvokedHandlers[F];const G=t.serializeReplyOK(v,me,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,v,1,"reply:",me),this._protocol.send(G)},me=>{delete this._cancelInvokedHandlers[F];const G=t.serializeReplyErr(v,me);this._logger&&this._logger.logOutgoing(G.byteLength,v,1,"replyErr:",me),this._protocol.send(G)})}_receiveCancel(l,v){this._logger&&this._logger.logIncoming(l,v,1,"receiveCancel");const b=String(v);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(l,v,b){this._logger&&this._logger.logIncoming(l,v,0,"receiveReply:",b);const A=String(v);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],C.resolveOk(b)}_receiveReplyErr(l,v,b){this._logger&&this._logger.logIncoming(l,v,0,"receiveReplyErr:",b);const A=String(v);if(!this._pendingRPCReplies.hasOwnProperty(A))return;const C=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let a;b&&(b.$isError?(a=new Error,a.name=b.name,a.message=b.message,a.stack=b.stack):a=b),C.resolveErr(a)}_invokeHandler(l,v,b){try{return Promise.resolve(this._doInvokeHandler(l,v,b))}catch(A){return Promise.reject(A)}}_doInvokeHandler(l,v,b){const A=this._locals[l];if(!A)throw new Error("Unknown actor "+I.getStringIdentifierForProxy(l));let C=A[v];if(typeof C!="function")throw new Error("Unknown method "+v+" on actor "+I.getStringIdentifierForProxy(l));return C.apply(A,b)}_remoteCall(l,v,b){if(this._isDisposed)return Promise.reject(D.canceled());let A=null;if(b.length>0&&T.CancellationToken.isCancellationToken(b[b.length-1])&&(A=b.pop()),A&&A.isCancellationRequested)return Promise.reject(D.canceled());const C=t.serializeRequestArguments(b,this._uriReplacer),a=++this._lastMessageId,F=String(a),N=new _.LazyPromise;A&&A.onCancellationRequested(()=>{const ce=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(ce.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(a);const W=t.serializeRequest(a,l,v,C,!!A);return this._logger&&this._logger.logOutgoing(W.byteLength,a,0,`request: ${I.getStringIdentifierForProxy(l)}.${v}(`,b),this._protocol.send(W),N}}e.RPCProtocol=m,P=S,m.UNRESPONSIVE_TIME=3*1e3;class f{constructor(l,v){this._buff=l,this._offset=v}static alloc(l,v,b){let A=new f(i.VSBuffer.alloc(b+1+4),0);return A.writeUInt8(l),A.writeUInt32(v),A}static read(l,v){return new f(l,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(l){this._buff.writeUInt8(l,this._offset),this._offset+=1}readUInt8(){const l=this._buff.readUInt8(this._offset);return this._offset+=1,l}writeUInt32(l){this._buff.writeUInt32BE(l,this._offset),this._offset+=4}readUInt32(){const l=this._buff.readUInt32BE(this._offset);return this._offset+=4,l}static sizeShortString(l){return 1+l.byteLength}writeShortString(l){this._buff.writeUInt8(l.byteLength,this._offset),this._offset+=1,this._buff.set(l,this._offset),this._offset+=l.byteLength}readShortString(){const l=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,b}static sizeLongString(l){return 4+l.byteLength}writeLongString(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readLongString(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+l).toString();return this._offset+=l,b}writeBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}static sizeVSBuffer(l){return 4+l.byteLength}writeVSBuffer(l){this._buff.writeUInt32BE(l.byteLength,this._offset),this._offset+=4,this._buff.set(l,this._offset),this._offset+=l.byteLength}readVSBuffer(){const l=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+l);return this._offset+=l,v}static sizeMixedArray(l,v){let b=0;b+=1;for(let A=0,C=l.length;A<C;A++){const a=l[A],F=v[A];switch(b+=1,F){case 1:b+=this.sizeLongString(a);break;case 2:b+=this.sizeVSBuffer(a);break;case 3:break}}return b}writeMixedArray(l,v){this._buff.writeUInt8(l.length,this._offset),this._offset+=1;for(let b=0,A=l.length;b<A;b++){const C=l[b];switch(v[b]){case 1:this.writeUInt8(1),this.writeLongString(C);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const l=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(l);for(let b=0;b<l;b++)switch(this.readUInt8()){case 1:v[b]=this.readLongString();break;case 2:v[b]=this.readVSBuffer();break;case 3:v[b]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(l){for(let v=0,b=l.length;v<b;v++)if(l[v]instanceof i.VSBuffer||typeof l[v]=="undefined")return!0;return!1}static serializeRequestArguments(l,v){if(this._arrayContainsBufferOrUndefined(l)){let b=[],A=[];for(let C=0,a=l.length;C<a;C++){const F=l[C];F instanceof i.VSBuffer?(b[C]=F,A[C]=2):typeof F=="undefined"?(b[C]=i.VSBuffer.alloc(0),A[C]=3):(b[C]=i.VSBuffer.fromString(h(F,v)),A[C]=1)}return{type:"mixed",args:b,argsType:A}}return{type:"simple",args:h(l,v)}}static serializeRequest(l,v,b,A,C){return A.type==="mixed"?this._requestMixedArgs(l,v,b,A.args,A.argsType,C):this._requestJSONArgs(l,v,b,A.args,C)}static _requestJSONArgs(l,v,b,A,C){const a=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(A);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(a),N+=f.sizeLongString(F);let W=f.alloc(C?2:1,l,N);return W.writeUInt8(v),W.writeShortString(a),W.writeLongString(F),W.buffer}static deserializeRequestJSONArgs(l){const v=l.readUInt8(),b=l.readShortString(),A=l.readLongString();return{rpcId:v,method:b,args:JSON.parse(A)}}static _requestMixedArgs(l,v,b,A,C,a){const F=i.VSBuffer.fromString(b);let N=0;N+=f.sizeUInt8(),N+=f.sizeShortString(F),N+=f.sizeMixedArray(A,C);let W=f.alloc(a?4:3,l,N);return W.writeUInt8(v),W.writeShortString(F),W.writeMixedArray(A,C),W.buffer}static deserializeRequestMixedArgs(l){const v=l.readUInt8(),b=l.readShortString(),A=l.readMixedArray(),C=new Array(A.length);for(let a=0,F=A.length;a<F;a++){const N=A[a];typeof N=="string"?C[a]=JSON.parse(N):C[a]=N}return{rpcId:v,method:b,args:C}}static serializeAcknowledged(l){return f.alloc(5,l,0).buffer}static serializeCancel(l){return f.alloc(6,l,0).buffer}static serializeReplyOK(l,v,b){return typeof v=="undefined"?this._serializeReplyOKEmpty(l):v instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(l,v):this._serializeReplyOKJSON(l,o(v,b))}static _serializeReplyOKEmpty(l){return f.alloc(7,l,0).buffer}static _serializeReplyOKVSBuffer(l,v){let b=0;b+=f.sizeVSBuffer(v);let A=f.alloc(8,l,b);return A.writeVSBuffer(v),A.buffer}static deserializeReplyOKVSBuffer(l){return l.readVSBuffer()}static _serializeReplyOKJSON(l,v){const b=i.VSBuffer.fromString(v);let A=0;A+=f.sizeLongString(b);let C=f.alloc(9,l,A);return C.writeLongString(b),C.buffer}static deserializeReplyOKJSON(l){const v=l.readLongString();return JSON.parse(v)}static serializeReplyErr(l,v){return v?this._serializeReplyErrEror(l,v):this._serializeReplyErrEmpty(l)}static _serializeReplyErrEror(l,v){const b=i.VSBuffer.fromString(o(D.transformErrorForSerialization(v),null));let A=0;A+=f.sizeLongString(b);let C=f.alloc(10,l,A);return C.writeLongString(b),C.buffer}static deserializeReplyErrError(l){const v=l.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(l){return f.alloc(11,l,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var r;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(r||(r={}))}),define(we[204],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const k=y=>{self.removeEventListener("message",k);const _=y.data;Object.defineProperties(self,{postMessage:{value(I,i){_.postMessage(I,i)}},onmessage:{get(){return _.onmessage},set(I){_.onmessage=I}}}),_.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(E,k,y){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${k}'))`,I=new Blob([_],{type:"application/javascript"}),i=URL.createObjectURL(I),P=new MessageChannel,o=i,h={type:"_newWorker",id:o,port:P.port2,url:i,options:y};E(h,[P.port2]),this.postMessage=P.port1.postMessage.bind(P.port1),this.terminate=()=>{const d={type:"_terminateWorker",id:o};P.port1.postMessage(d),URL.revokeObjectURL(i),P.port1.close(),P.port2.close()},Object.defineProperties(this,{onmessage:{get(){return P.port1.onmessage},set(d){P.port1.onmessage=d}},onmessageerror:{get(){return P.port1.onmessageerror},set(d){P.port1.onmessageerror=d}}}),P.port1.addEventListener("messageerror",d=>{const u=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(u)}),P.port1.addEventListener("message",d=>{const u=new MessageEvent("message",{data:d.data});this.dispatchEvent(u)}),P.port1.start()}}e.NestedWorker=T}),define(we[205],_e([0,1,5]),function(Z,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=g.createDecorator("remoteAgentService")}),define(we[206],_e([0,1,15,13,21,2,5,205]),function(Z,e,g,T,D,E,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let _=class{constructor(i,P){this.localUserHome=i,this.remoteAgentService=P,this.resolveOS=(async()=>{const o=await this.remoteAgentService.getEnvironment();return(o==null?void 0:o.os)||D.OS})(),this.resolveUserHome=(async()=>{const o=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(o==null?void 0:o.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?T.win32:T.posix)}async fileURI(i){let P="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const h=i.indexOf("/",2);h===-1?(P=i.substring(2),i="/"):(P=i.substring(2,h),i=i.substring(h)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:P,path:i,query:"",fragment:""})}};_=Ve([je(1,y.IRemoteAgentService)],_),e.AbstractPathService=_}),define(we[101],_e([0,1]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(k,y){this.line=k,this.character=y}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,y){return new g(0,0)}with(k){return new g(0,0)}}e.Position=g;class T{constructor(k,y,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(k,y),this.end=new g(_,I)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var D;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],_e([0,1,16,27,24,42,8,5,13,12,101]),function(Z,e,g,T,D,E,k,y,_,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const P="\u27EA ",o=" characters skipped \u27EB",h=(P.length+o.length+5)*2;e.ISearchService=y.createDecorator("searchService");var d;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function w(R){return!!R.preview}e.resultIsMatch=w;function p(R){return!!R.resource}e.isFileMatch=p;function S(R){return!!R.message}e.isProgressMessage=S;var c;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(B){this.resource=B,this.results=[]}}e.FileMatch=m;class f{constructor(B,M,U){this.ranges=M;const j=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(j)){B=k.getNLines(B,U.matchLines);let z="",oe=0,pe=0;const Te=Math.floor(U.charsPerLine/5),$e=[];for(const Me of j){const ze=Math.max(Me.startColumn-Te,0),Qe=Me.startColumn+U.charsPerLine;if(ze>pe+Te+h){const Ke=P+(ze-pe)+o;z+=Ke+B.slice(ze,Qe),oe+=ze-(pe+Ke.length)}else z+=B.slice(pe,Qe);$e.push(new r(0,Me.startColumn-oe,Me.endColumn-oe)),pe=Qe}this.preview={text:z,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const z=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:B,matches:g.mapArrayOrNot(M,oe=>new n(oe.startLineNumber-z,oe.startColumn,oe.endLineNumber-z,oe.endColumn))}}}}e.TextSearchMatch=f;function t(R){const B=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==B||M.endLineNumber!==B)return!1;return!0}class n{constructor(B,M,U,j){this.startLineNumber=B,this.startColumn=M,this.endLineNumber=U,this.endColumn=j}}e.SearchRange=n;class r extends n{constructor(B,M,U){super(B,M,B,U)}}e.OneLineRange=r;var s;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function l(R,B=!0){const M=R&&R.files&&R.files.exclude,U=B&&R&&R.search&&R.search.exclude;if(!M&&!U)return;if(!M||!U)return M||U;let j=Object.create(null);return j=D.mixin(j,D.deepClone(M)),j=D.mixin(j,D.deepClone(U),!0),j}e.getExcludes=l;function v(R,B){return R.excludePattern&&T.match(R.excludePattern,B)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&T.match(R.includePattern,B)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const U=M.folder.fsPath;if(E.isEqualOrParent(B,U)){const j=_.relative(U,B);return!M.includePattern||!!T.match(M.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var b;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(B,M){super(B);this.code=M}}e.SearchError=A;function C(R){const B=R.message;if(I.isPromiseCanceledError(R))return new A(B,b.canceled);try{const M=JSON.parse(B);return new A(M.message,M.code)}catch(M){return new A(B,b.other)}}e.deserializeSearchError=C;function a(R){const B={message:R.message,code:R.code};return new Error(JSON.stringify(B))}e.serializeSearchError=a;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function N(R){return R.type==="success"}e.isSerializedSearchSuccess=N;function W(R){return!!R.path}e.isSerializedFileMatch=W;function ce(R,B){const M=R.searchPath?R.searchPath:R.relativePath;return k.fuzzyContains(M,B)}e.isFilePatternMatch=ce;class me{constructor(B){this.path=B,this.results=[]}addMatch(B){this.results.push(B)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=me;function G(R,B){const M=Object.assign(Object.assign({},R||{}),B||{});return Object.keys(M).filter(U=>{const j=M[U];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=G;class V{constructor(B,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},B.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let U=B.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=T.parse(U))}includedInQuerySync(B,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(B,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(B,M,U))}includedInQuery(B,M,U){return Promise.resolve(this._parsedExcludeExpression(B,M,U)).then(z=>!!z).then(z=>z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(B,M,U)).then(oe=>!!oe):Promise.resolve(!0)).then(z=>z)}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=V;function J(R){for(const B in R)if(typeof R[B]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,16,11,18,3,22,15,77,25,8,10,2,133,5,17,145,62,44,28,14,6,38,4]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(F,N,W){return new I.ExtUri(ce=>b(ce,W)).isEqual(F,N)}function s(F,N,W){return r(F.uri,N.uri,W)?0:i.compare(F.uri.toString(),N.uri.toString())}function l(F,N,W){return F.index!==N.index?F.index<N.index?-1:1:r(F.uri,N.uri,W)?i.compare(F.name,N.name):i.compare(F.uri.toString(),N.uri.toString())}function v(F,N,W,ce){const me=F.slice(0).sort((V,J)=>W(V,J,ce)),G=N.slice(0).sort((V,J)=>W(V,J,ce));return g.delta(me,G,(V,J)=>W(V,J,ce))}function b(F,N){const W=N.getCapabilities(F.scheme);return!(W&&W&1024)}class A extends p.Workspace{constructor(N,W,ce,me,G,V){super(N,ce.map(J=>new p.WorkspaceFolder(J)),me,V);this._name=W,this._isUntitled=G,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(V),ce.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}static toExtHostWorkspace(N,W,ce,me){if(!N)return{workspace:null,added:[],removed:[]};const{id:G,name:V,folders:J,configuration:R,isUntitled:B}=N,M=[],U=W;W?J.forEach((pe,Te)=>{const $e=o.URI.revive(pe.uri),Me=A._findFolder(ce||W,$e,me);Me?(Me.name=pe.name,Me.index=pe.index,M.push(Me)):M.push({uri:$e,name:pe.name,index:Te})}):M.push(...J.map(({uri:pe,name:Te,index:$e})=>({uri:o.URI.revive(pe),name:Te,index:$e}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const j=new A(G,V,M,R?o.URI.revive(R):null,!!B,pe=>b(pe,me)),{added:z,removed:oe}=v(U?U.workspaceFolders:[],j.workspaceFolders,s,me);return{workspace:j,added:z,removed:oe}}static _findFolder(N,W,ce){for(let me=0;me<N.folders.length;me++){const G=N.workspaceFolders[me];if(r(G.uri,W,ce))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,W){return W&&this._structure.get(N)&&(N=I.dirname(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let C=class{constructor(N,W,ce,me){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=me,this._extHostFileSystemInfo=ce,this._requestIdProvider=new _.Counter,this._barrier=new T.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const G=W.workspace;this._confirmedWorkspace=G?new A(G.id,G.name,[],G.configuration?o.URI.revive(G.configuration):null,!!G.isUntitled,V=>b(V,ce)):void 0}$initializeWorkspace(N,W){this._trusted=W,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:y.Schemas.untitled,path:I.basename(I.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,W,ce,...me){const G=[];if(Array.isArray(me)&&me.forEach(M=>{o.URI.isUri(M.uri)&&!G.some(U=>r(U.uri,M.uri,this._extHostFileSystemInfo))&&G.push({uri:M.uri,name:M.name||I.basenameOrAuthority(M.uri)})}),this._unconfirmedWorkspace||[W,ce].some(M=>typeof M!="number"||M<0)||ce===0&&G.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+ce>V.length)return!1;const J=V.slice(0);J.splice(W,ce,...G.map(M=>({uri:M.uri,name:M.name||I.basenameOrAuthority(M.uri),index:void 0})));for(let M=0;M<J.length;M++){const U=J[M];if(J.some((j,z)=>z!==M&&r(U.uri,j.uri,this._extHostFileSystemInfo)))return!1}J.forEach((M,U)=>M.index=U);const{added:R,removed:B}=v(V,J,l,this._extHostFileSystemInfo);if(R.length===0&&B.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,W,ce,G).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,h.localize(0,null,M,U.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder(N,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,W)}async getWorkspaceFolder2(N,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,W)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,W){let ce,me="";if(typeof N=="string"?(ce=o.URI.file(N),me=N):typeof N!="undefined"&&(ce=N,me=N.fsPath),!ce)return me;const G=this.getWorkspaceFolder(ce,!0);if(!G)return me;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let V=I.relativePath(G.uri,ce);return W&&G.name&&(V=`${G.name}/${V}`),V}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:W,added:ce,removed:me}=A.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ce,removed:me}))}findFiles(N,W,ce,me,G=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${me.value}, entryPoint: findFiles`);let V;if(W===null?V=!1:W&&(typeof W=="string"?V=W:V=W.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:R}=a(N);return this._proxy.$startFileSearch(P.withUndefinedAsNull(J),P.withUndefinedAsNull(R),P.withUndefinedAsNull(V),P.withUndefinedAsNull(ce),G).then(B=>Array.isArray(B)?B.map(M=>o.URI.revive(M)):[])}async findTextInFiles(N,W,ce,me,G=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${me.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),J=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:R,folder:B}=a(W.include),M=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,U={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:J,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:R,excludePattern:M},j=!1;if(this._activeSearchCallbacks[V]=z=>{if(j)return;const oe=o.URI.revive(z.resource);z.results.forEach(pe=>{t.resultIsMatch(pe)?ce({uri:oe,preview:{text:pe.preview.text,matches:g.mapArrayOrNot(pe.preview.matches,Te=>new f.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:g.mapArrayOrNot(pe.ranges,Te=>new f.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):ce({uri:oe,text:pe.text,lineNumber:pe.lineNumber})})},G.isCancellationRequested)return{};try{const z=await this._proxy.$startTextSearch(N,P.withUndefinedAsNull(B),U,V,G);return delete this._activeSearchCallbacks[V],z||{}}catch(z){throw delete this._activeSearchCallbacks[V],z}}$handleTextSearchResult(N,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=Ve([je(0,m.IExtHostRpcService),je(1,c.IExtHostInitDataService),je(2,S.IExtHostFileSystemInfo),je(3,u.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=d.createDecorator("IExtHostWorkspace");function a(F){let N,W;return F&&(typeof F=="string"?N=F:(N=F.pattern,W=F.baseFolder||o.URI.file(F.base))),{includePattern:N,folder:W}}}),define(we[32],_e([0,1,24,3,30,4,6,149,61,10,11,5,14,17,2]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function u(n,r){if(r){const s=r.split(".");let l=n;for(let v=0;l&&v<s.length;v++)l=l[s[v]];return l}}function w(n){return n instanceof d.URI}function p(n){return n&&n.uri instanceof d.URI&&n.languageId&&typeof n.languageId=="string"}function S(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof d.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(w(n))return{resource:n};if(p(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(S(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(r,s,l){this._proxy=r.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=l,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,s))}};f=Ve([je(0,o.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,h.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(r,s,l,v){this._onDidChangeConfiguration=new T.Emitter,this._proxy=r,this._logService=v,this._extHostWorkspace=s,this._configuration=y.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=y.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,l))}getConfiguration(r,s,l){const v=m(s)||{},b=this._toReadonlyValue(r?u(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,v,l==null?void 0:l.identifier);function A(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const C={has(a){return typeof u(b,a)!="undefined"},get:(a,F)=>{this._validateConfigurationAccess(r?`${r}.${a}`:a,v,l==null?void 0:l.identifier);let N=u(b,a);if(typeof N=="undefined")N=F;else{let W;const ce=(me,G)=>{let V;const J=()=>{W=W||g.deepClone(b),V=V||u(W,G)};return I.isObject(me)?new Proxy(me,{get:(R,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return J(),()=>V;if(W)return V=V||u(W,G),V[B];const M=R[B];return typeof B=="string"?ce(M,`${G}.${B}`):M},set:(R,B,M)=>(J(),V&&(V[B]=M),!0),deleteProperty:(R,B)=>(J(),V&&delete V[B],!0),defineProperty:(R,B,M)=>(J(),V&&Object.defineProperty(V,B,M),!0)}):me};N=ce(N,a)}return N},update:(a,F,N,W)=>{a=r?`${r}.${a}`:a;const ce=A(N);return F!==void 0?this._proxy.$updateConfigurationOption(ce,a,F,v,W):this._proxy.$removeConfigurationOption(ce,a,v,W)},inspect:a=>{var F,N,W,ce,me,G,V,J;a=r?`${r}.${a}`:a;const R=g.deepClone(this._configuration.inspect(a,v,this._extHostWorkspace.workspace));if(R)return{key:a,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(N=R.user)===null||N===void 0?void 0:N.value,workspaceValue:(W=R.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(ce=R.workspaceFolder)===null||ce===void 0?void 0:ce.value,defaultLanguageValue:(me=R.default)===null||me===void 0?void 0:me.override,globalLanguageValue:(G=R.user)===null||G===void 0?void 0:G.override,workspaceLanguageValue:(V=R.workspace)===null||V===void 0?void 0:V.override,workspaceFolderLanguageValue:(J=R.workspaceFolder)===null||J===void 0?void 0:J.override,languageIds:R.overrideIdentifiers}}};return typeof b=="object"&&g.mixin(C,b,!1),Object.freeze(C)}_toReadonlyValue(r){const s=l=>I.isObject(l)?new Proxy(l,{get:(v,b)=>s(v[b]),set:(v,b,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(v,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(v,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return s(r)}_validateConfigurationAccess(r,s,l){const v=_.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),b=l?`[${l.value}] `:"";if(v===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(s==null?void 0:s.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const l=new y.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,b)=>l.affectsConfiguration(v,m(b))})}_toMap(r){return r.reduce((s,l)=>(s.set(l[0],l[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=P.createDecorator("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[102],_e([0,1,2,11,3,4,6,30,36,32,18,37,14,28,5,15,21,17,70,160,12]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(me){function G(J){if(J!=null)return J}me.from=G;function V(J){if(J!=null)return J}me.to=V})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(me){function G(J){if(J!=null)return J}me.from=G;function V(J){if(J!=null)return J}me.to=V})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(me){function G(J){if(J!=null)return J}me.from=G;function V(J){if(J!=null)return J}me.to=V})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(me){function G(R){if(R){const B=R;return B&&!!B.process}else return!1}me.is=G;function V(R){if(R==null)return;const B={process:R.process,args:R.args};return R.options&&(B.options=r.from(R.options)),B}me.from=V;function J(R){if(R!=null)return new k.ProcessExecution(R.process,R.args,R.options)}me.to=J})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(me){function G(J){if(J!=null)return J}me.from=G;function V(J){if(J!=null)return J}me.to=V})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(me){function G(R){if(R){const B=R;return B&&(!!B.commandLine||!!B.command)}else return!1}me.is=G;function V(R){if(R==null)return;const B={};return R.commandLine!==void 0?B.commandLine=R.commandLine:(B.command=R.command,B.args=R.args),R.options&&(B.options=l.from(R.options)),B}me.from=V;function J(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new k.ShellExecution(R.commandLine,R.options):new k.ShellExecution(R.command,R.args?R.args:[],R.options)}me.to=J})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(me){function G(R){if(R){let B=R;return B&&B.customExecution==="customExecution"}else return!1}me.is=G;function V(R){return{customExecution:"customExecution"}}me.from=V;function J(R,B){return B.get(R)}me.to=J})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(me){function G(V,J){let R;return V.scope!==void 0&&typeof V.scope!="number"?R=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===k.TaskScope.Workspace&&J&&J.workspaceFile?R=J.workspaceFile:R=c.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:R}}me.from=G})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var C;(function(me){function G(R,B){if(R==null)return[];const M=[];for(let U of R){const j=V(U,B);j&&M.push(j)}return M}me.fromMany=G;function V(R,B){if(R==null)return;let M;R.execution instanceof k.ProcessExecution?M=s.from(R.execution):R.execution instanceof k.ShellExecution?M=v.from(R.execution):R.execution&&R.execution instanceof k.CustomExecution&&(M=b.from(R.execution));const U=t.from(R.definition);let j;if(R.scope?typeof R.scope=="number"?j=R.scope:j=R.scope.uri:j=k.TaskScope.Workspace,!U||!j)return;const z=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:B.identifier.value,label:R.source,scope:j},execution:M,isBackground:R.isBackground,group:z,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}me.from=V;async function J(R,B,M){if(R==null)return;let U;s.is(R.execution)?U=s.to(R.execution):v.is(R.execution)?U=v.to(R.execution):b.is(R.execution)&&(U=b.to(R._id,M));const j=t.to(R.definition);let z;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?z=R.source.scope:z=await B.resolveWorkspaceFolder(g.URI.revive(R.source.scope)):z=k.TaskScope.Workspace),!j||!z)return;const oe=new k.Task(j,z,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(oe.isBackground=R.isBackground),R.group!==void 0&&(oe.group=k.TaskGroup.from(R.group)),R.presentationOptions&&(oe.presentationOptions=n.to(R.presentationOptions)),R._id&&(oe._id=R._id),R.detail&&(oe.detail=R.detail),oe}me.to=J})(C=e.TaskDTO||(e.TaskDTO={}));var a;(function(me){function G(J){return J}me.from=G;function V(J){if(!!J)return Object.assign(Object.create(null),J)}me.to=V})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(G,V,J){this._id=V,this._task=J,f.set(this,void 0),nt(this,f,G,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}f=new WeakMap;var N;(function(me){function G(V){return{id:V._id,task:void 0}}me.from=G})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(G,V,J,R,B,M,U,j){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=G.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=J,this._editorService=R,this._configurationService=B,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(G,V,J){if(!J)return new k.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:V,provider:J,extension:G}),this._proxy.$registerTaskProvider(R,V),new k.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(G,V){this._proxy.$registerTaskSystem(G,V)}fetchTasks(G){return this._proxy.$fetchTasks(a.from(G)).then(async V=>{const J=[];for(let R of V){const B=await C.to(R,this._workspaceProvider,this._providedCustomExecutions2);B&&J.push(B)}return J})}get taskExecutions(){const G=[];return this._taskExecutions.forEach(V=>G.push(V)),G}terminateTask(G){if(!(G instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(G._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(G,V,J){const R=this._providedCustomExecutions2.get(G.id);if(R){if(this._activeCustomExecutions2.get(G.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(G.id,R),this._terminalService.attachPtyToTerminal(V,await R.callback(J))}this._lastStartedTask=G.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(G)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(G){const V=await this.getTaskExecution(G);this._taskExecutionPromises.delete(G.id),this._taskExecutions.delete(G.id),this.customExecutionComplete(G),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(G){const V=await this.getTaskExecution(G.id);this._onDidTaskProcessStarted.fire({execution:V,processId:G.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(G){const V=await this.getTaskExecution(G.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:G.exitCode})}$provideTasks(G,V){const J=this._handlers.get(G);if(!J)return Promise.reject(new Error("no handler found"));const R=[],B=T.asPromise(()=>J.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(V,R,J,M));return new Promise(M=>{B.then(U=>{Promise.all(R).then(()=>{M(U)})})})}async $resolveTask(G,V){const J=this._handlers.get(G);if(!J)return Promise.reject(new Error("no handler found"));if(V.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${J.type}].`);const R=await C.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const B=await J.provider.resolveTask(R,i.CancellationToken.None);if(!B)return;this.checkDeprecation(B,J);const M=C.from(B,J.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,B,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(G,V,J){const R=await this._proxy.$createTaskId(G);!J&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,V.execution)}async getTaskExecution(G,V){if(typeof G=="string"){const B=this._taskExecutionPromises.get(G);if(!B)throw new Error("Unexpected: The specified task is missing an execution");return B}let J=this._taskExecutionPromises.get(G.id);if(J)return J;const R=new Promise(async(B,M)=>{const U=V||await C.to(G.task,this._workspaceProvider,this._providedCustomExecutions2);U?B(new F(this,G.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(G.id,R),R.then(B=>(this._taskExecutions.set(G.id,B),B),B=>Promise.reject(B))}checkDeprecation(G,V){G._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(G){this._activeCustomExecutions2.get(G.id)&&this._activeCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.has(G.id)&&this._lastStartedTask!==G.id&&(this._providedCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.delete(G.id));let J=this._notProvidedCustomExecutions.values(),R=J.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=J.next()}};W=Ve([je(0,o.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,y.IExtHostWorkspace),je(3,_.IExtHostDocumentsAndEditors),je(4,I.IExtHostConfiguration),je(5,P.IExtHostTerminalService),je(6,p.ILogService),je(7,S.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let ce=class extends W{constructor(G,V,J,R,B,M,U,j){super(G,V,J,R,B,M,U,j);this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(G,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const J=C.from(V,G);if(J===void 0)throw new Error("Task is not valid");if(b.is(J.execution))await this.addCustomExecution(J,V,!1);else throw new m.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution(J),V);return this._proxy.$executeTask(J).catch(B=>{throw new Error(B)}),R}provideTasksInternal(G,V,J,R){const B=[];if(R)for(let M of R){this.checkDeprecation(M,J),(!M.definition||!G[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=C.from(M,J.extension);U&&b.is(U.execution)?(B.push(U),V.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:B,extension:J.extension}}async resolveTaskInternal(G){if(b.is(G.execution))return G;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(G,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,V,J){}};ce=Ve([je(0,o.IExtHostRpcService),je(1,h.IExtHostInitDataService),je(2,y.IExtHostWorkspace),je(3,_.IExtHostDocumentsAndEditors),je(4,I.IExtHostConfiguration),je(5,P.IExtHostTerminalService),je(6,p.ILogService),je(7,S.IExtHostApiDeprecationService)],ce),e.WorkerExtHostTask=ce,e.IExtHostTask=d.createDecorator("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)},Kt=this&&this.__rest||function(Z,e){var g={};for(var T in Z)Object.prototype.hasOwnProperty.call(Z,T)&&e.indexOf(T)<0&&(g[T]=Z[T]);if(Z!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,T=Object.getOwnPropertySymbols(Z);D<T.length;D++)e.indexOf(T[D])<0&&Object.prototype.propertyIsEnumerable.call(Z,T[D])&&(g[T[D]]=Z[T[D]]);return g};define(we[207],_e([0,1,16,11,23,18,3,48,50,7,24,10,2,34,4,36,14,65,9,6,30,170,94]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m,f,t){"use strict";var n,r,s,l;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const v=(J,R)=>`${J}:${R.toString()}`;let b=class{constructor(R,B,M){this.documents=B,this.workspace=M,this.resultsChangedEmitter=new k.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(d.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new G(this.proxy),this.textDocumentObservers=new V(this.proxy,B)}registerTestController(R,B){const M=h.generateUuid();this.controllers.set(M,{instance:B,extensionId:R}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var j;for(const z of U)(j=this.testControllers.get(z))===null||j===void 0||j.subscribeFn(M,B)},0),new c.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,B=E.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(P.isDefined).map(j=>({src:j.src,testId:j.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(U=>U.testId):void 0,tests:M(R.tests),debug:R.debug},B)}createTestRun(R,B,M,U=!0){return this.runQueue.createTestRun(R,B,M,U)}$publishTestResults(R){this.results=Object.freeze(R.map(B=>i.deepFreeze(S.TestResults.to(B))).concat(this.results).sort((B,M)=>M.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,B){const M=o.URI.revive(B),U=v(R,M);if(this.testControllers.has(U))return;const j=new E.CancellationTokenSource;let z;if(R===1){let Me=this.documents.getDocument(M);if(!Me){const ze=new I.DisposableStore;Me=await new Promise(Qe=>{ze.add(T.disposableTimeout(()=>Qe(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(Ke=>{const Ge=Ke.find($=>$.document.uri.toString()===M.toString());Ge&&Qe(Ge)}))}).finally(()=>ze.dispose())}if(Me){const ze=await this.workspace.getWorkspaceFolder2(M,!1);z=Qe=>Qe.createDocumentTestRoot?Qe.createDocumentTestRoot(Me.document,j.token):e.createDefaultDocumentTestRoot(Qe,Me.document,ze,j.token)}}else{const Me=await this.workspace.getWorkspaceFolder2(M,!1);Me&&(z=ze=>ze.createWorkspaceTestRoot(Me,j.token))}if(!z)return;const oe=async(Me,ze)=>{try{const Qe=await z(ze);Qe&&Te.addRoot(Qe,Me)}catch(Qe){console.error(Qe)}},pe=new I.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Me=>this.proxy.$publishDiff(R,B,Me)));pe.add(I.toDisposable(()=>j.dispose(!0)));const $e=[];for(const[Me,ze]of this.controllers)$e.push(oe(Me,ze.instance));Promise.all($e).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(U,{store:pe,collection:Te,subscribeFn:oe})}async $expandTest(R,B){const M=g.mapFind(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(R.testId,B<0?Infinity:B)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,B){var M;const U=o.URI.revive(B),j=v(R,U);(M=this.testControllers.get(j))===null||M===void 0||M.store.dispose(),this.testControllers.delete(j)}$acceptDiff(R,B,M){R===1?this.textDocumentObservers.acceptDiff(o.URI.revive(B),M):this.workspaceObservers.acceptDiff(o.URI.revive(B),M)}async $runTestsForProvider(R,B){const M=this.controllers.get(R.tests[0].src.controller);if(!M)return;const U=R.tests.map(({testId:oe,src:pe})=>this.ownedTests.getTestById(oe,pe==null?void 0:pe.tree)).filter(P.isDefined).map(([oe,pe])=>pe),j=R.excludeExtIds.map(oe=>this.ownedTests.getTestById(oe)).filter(P.isDefined).filter(([oe,pe])=>U.some(Te=>oe.comparePositions(Te,pe)===1));if(!U.length)return;const z={tests:U.map(oe=>N.unwrap(oe.actual)),exclude:j.map(([,oe])=>N.unwrap(oe.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:C.fromInternal(R),token:B,extensionId:M.extensionId,req:z,doRun:()=>M.instance.runTests(z,B)})}$lookupTest(R){const B=this.ownedTests.getTestById(R.testId);if(!B)return Promise.resolve(void 0);const M=B[1],{actual:U,discoverCts:j,expandLevels:z}=M,oe=Kt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(oe)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var B,M;return(M=(B=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&B!==void 0?B:g.mapFind(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};b=Ve([je(0,w.IExtHostRpcService),je(1,u.IExtHostDocumentsAndEditors),je(2,m.IExtHostWorkspace)],b),e.ExtHostTesting=b;class A{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let B=this.state.get(R.extensionId);B||(B={queue:[],current:void 0},this.state.set(R.extensionId,B));const M=new T.DeferredPromise,U=()=>{const j=[],z=new Set;B.current={publicReq:R.req,factory:oe=>{const pe=new a(oe,R.dto,z,this.proxy);return j.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,j).finally(()=>M.complete())};return B.queue.push(U),B.queue.length===1&&U(),M.p}createTestRun(R,B,M,U){var j,z;const oe=this.state.get(R);if((oe==null?void 0:oe.current.publicReq)===B)return oe.current.factory(M);const pe=C.fromPublic(B),Te=new a(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:B.debug,exclude:(z=(j=B.exclude)===null||j===void 0?void 0:j.map($e=>$e.id))!==null&&z!==void 0?z:[],id:pe.id,tests:B.tests.map($e=>$e.id),persist:U}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(R,B,M,U){try{const j=M();return T.isThenable(j)?j.then(()=>this.handleInvokeResult(R,B,U,void 0)).catch(z=>this.handleInvokeResult(R,B,U,z)):this.handleInvokeResult(R,B,U,void 0)}catch(j){return this.handleInvokeResult(R,B,U,j)}}async handleInvokeResult(R,B,M,U){const j=this.state.get(R);!j||(j.queue.shift(),j.queue.length>0?j.queue[0]():this.state.delete(R),await Promise.all(M.map(z=>z.onEnd.wait())))}}class C{constructor(R,B,M){this.id=R,this.include=B,this.exclude=M}static fromPublic(R){var B,M;return new C(h.generateUuid(),new Set(R.tests.map(U=>U.id)),new Set((M=(B=R.exclude)===null||B===void 0?void 0:B.map(U=>U.id))!==null&&M!==void 0?M:_.Iterable.empty()))}static fromInternal(R){return new C(R.runId,new Set(R.tests.map(B=>B.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let B=R;B;B=B.parent){if(this.include.has(B.id))return!0;if(this.exclude.has(B.id))return!1}return!0}}class a{constructor(R,B,M,U){this.name=R,n.set(this,void 0),r.set(this,void 0),s.set(this,h.generateUuid()),l.set(this,void 0),this.onEnd=new T.Barrier,nt(this,n,U,"f"),nt(this,r,B,"f"),nt(this,l,M,"f"),U.$startedTestRunTask(B.id,{id:Ue(this,s,"f"),name:R,running:!0})}setState(R,B,M){Ue(this,r,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,n,"f").$updateTestStateInRun(Ue(this,r,"f").id,Ue(this,s,"f"),R.id,B,M))}appendMessage(R,B){Ue(this,r,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,r,"f").id,Ue(this,s,"f"),R.id,S.TestMessage.from(B)))}appendOutput(R){Ue(this,n,"f").$appendOutputToRun(Ue(this,r,"f").id,Ue(this,s,"f"),D.VSBuffer.fromString(R))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,r,"f").id,Ue(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(R){const B=Ue(this,l,"f");if(B.has(R.id))return;const M=[];for(;M.unshift(S.TestItem.from(R)),!(B.has(R.id)||(B.add(R.id),!R.parent));)R=R.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,r,"f").id,M)}}n=new WeakMap,r=new WeakMap,s=new WeakMap,l=new WeakMap;const F=async(J,R,B,M)=>{if(!B)return;const U=await J.createWorkspaceTestRoot(B,M);if(!U)return;M.onCancellationRequested(()=>{N.removeFilter(R)});const j=N.getWrapperForTestItem(U,R);return j.refreshMatch(),j};e.createDefaultDocumentTestRoot=F;class N extends c.TestItemImpl{constructor(R,B,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=B,this.actualParent=M,!(R instanceof c.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const U=p.getPrivateApiFor(this);p.getPrivateApiFor(R).bus.event(z=>{switch(z[0]){case 3:this[z[1]]=z[2];break;case 0:const oe=N.getWrapperForTestItem(z[1],this.filterDocument,this);p.getPrivateApiFor(oe).parent=R,oe.refreshMatch();break;default:U.bus.fire(z)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,B,M){let U=this.wrapperMap.get(B);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(B,U));const j=new N(R,B,M);return U.set(R,j),j}static unwrap(R){return R instanceof N?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R,B;const M=this._cachedMatchesFilter;for(const j of this.actual.children.values()){const z=N.getWrapperForTestItem(j,this.filterDocument,this);z.hasNodeMatchingFilter?this.children.has(z.id)||this.addChild(z):z.dispose()}const U=this.children.size>0||((R=this.actual.uri)===null||R===void 0?void 0:R.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=U,U!==M&&((B=this.actualParent)===null||B===void 0||B.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&p.getPrivateApiFor(this.actualParent).children.delete(this.id),p.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,S.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:M}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...B].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ce extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let B=[];for(const M of R){const U=this.items.get(M);U&&B.push(U.revived)}return B}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return Object.assign(Object.assign({},R),{revived:S.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=ce;class me{constructor(){this.resources=new Map}checkout(R){var B,M;const U=R.toString(),j=(B=this.resources.get(U))!==null&&B!==void 0?B:this.createObserverData(R);return(M=j.pendingDeletion)===null||M===void 0||M.dispose(),j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,onDidDiscoverInitialTests:new k.Emitter().event,get tests(){return j.tests.rootTestItems},dispose:y.once(()=>{--j.observers||(j.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:B}of this.resources.values()){const M=B.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return T.disposableTimeout(()=>this.unlisten(R),10*1e3)}createObserverData(R){const B=new ce,M=this.listen(R,j=>B.apply(j)),U={observers:0,tests:B,listener:M};return this.resources.set(R.toString(),U),U}unlisten(R){var B;const M=R.toString(),U=this.resources.get(M);U&&(U.observers=-1,(B=U.pendingDeletion)===null||B===void 0||B.dispose(),U.listener.dispose(),this.resources.delete(M))}}class G extends me{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,B),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class V extends me{constructor(R,B){super();this.proxy=R,this.documents=B,this.diffListeners=new Map}acceptDiff(R,B){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(B)}listen(R,B){if(!this.documents.getDocument(R))return new c.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,B),this.proxy.$subscribeToDiffs(1,R),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(we[208],_e([0,1,16,76,27,81,22,15,13,25,8,10,2,115,135,90,62,163,206,38]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(A,C,a,F){this.configurationService=A,this.workspaceContextService=C,this.editorGroupsService=a,this.pathService=F}text(A,C,a={}){A=this.getContentPattern(A,a);const F=this.configurationService.getValue(),N=C&&C.some(ce=>!this.configurationService.getValue({resource:ce}).search.useRipgrep),W=this.commonQuery(C==null?void 0:C.map(w.toWorkspaceFolder),a);return Object.assign(Object.assign({},W),{type:2,contentPattern:A,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(A,C){const a=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},A),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(A,C)&&(F.isCaseSensitive=!0),this.isMultiline(A)&&(F.isMultiline=!0),F}file(A,C={}){const a=this.commonQuery(A,C);return Object.assign(Object.assign({},a),{type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey})}handleIncludeExclude(A,C){return A?(A=Array.isArray(A)?A.map(s):s(A),C?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],C={}){const a=this.handleIncludeExclude(C.includePattern,C.expandPatterns),F=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),N=A.length>1,W=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,C,F)):A.map(G=>this.getFolderQueryForRoot(G,C,F,N))).filter(G=>!!G),ce={_reason:C._reason,folderQueries:W,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:F.pattern,includePattern:a.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const V=g.coalesce(g.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(B=>B.resource)))).filter(R=>c.pathIncludedInQuery(ce,R.fsPath)),J=this.commonQueryFromFileList(V);return Object.assign(Object.assign({},ce),J)}const me=C.extraFileResources&&C.extraFileResources.filter(G=>c.pathIncludedInQuery(ce,G.fsPath));return ce.extraFileResources=me&&me.length?me:void 0,ce}commonQueryFromFileList(A){const C=[],a=new k.ResourceMap,F={};let N=!1;return A.forEach(W=>{var ce,me;if(W.scheme===y.Schemas.walkThrough)return;if(I.isAbsolutePath(W)){const V=(me=(ce=this.workspaceContextService.getWorkspaceFolder(W))===null||ce===void 0?void 0:ce.uri)!==null&&me!==void 0?me:W.with({path:_.dirname(W.fsPath)});let J=a.get(V);J||(N=!0,J={folder:V,includePattern:{}},C.push(J),a.set(V,J));const R=_.relative(V.fsPath,W.fsPath);P.assertIsDefined(J.includePattern)[R.replace(/\\/g,"/")]=!0}else W.fsPath&&(N=!0,F[W.fsPath]=!0)}),{folderQueries:C,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(A,C){if(C.isSmartCase){if(A.isRegExp){if(i.containsUppercaseCharacter(A.pattern,!0))return!0}else if(i.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&h.isMultilineRegexSource(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const C=J=>_.isAbsolute(J)||/^\.\.?([\/\\]|$)/.test(J),F=(Array.isArray(A)?A:n(A)).map(J=>{const R=this.pathService.resolvedUserHome;return R?E.untildify(J,R.scheme===y.Schemas.file?R.fsPath:R.path):J}),N=T.groupBy(F,J=>C(J)?"searchPaths":"exprSegments"),W=(N.exprSegments||[]).map(J=>i.rtrim(J,"/")).map(J=>i.rtrim(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),r(J))),ce={},me=this.expandSearchPathPatterns(N.searchPaths||[]);me&&me.length&&(ce.searchPaths=me);const G=g.flatten(W),V=t(...G);return V&&(ce.pattern=V),ce}getExcludesForFolder(A,C){return C.disregardExcludeSettings?void 0:c.getExcludes(A,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const C=g.flatten(A.map(F=>{let{pathPortion:N,globPortion:W}=f(F);W&&(W=l(W));const ce=this.expandOneSearchPath(N);return g.flatten(ce.map(me=>this.resolveOneSearchPathPattern(me,W)))})),a=new Map;return C.forEach(F=>{const N=F.searchPath.toString(),W=a.get(N);W?F.pattern&&(W.pattern=W.pattern||{},W.pattern[F.pattern]=!0):a.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(A){if(_.isAbsolute(A)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==y.Schemas.file?[{searchPath:C[0].uri.with({path:A})}]:[{searchPath:o.URI.file(_.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=s(A),A.startsWith("../")||A===".."){const F=_.posix.resolve(C.path,A);return[{searchPath:C.with({path:F})}]}const a=l(A);return[{searchPath:C,pattern:a}]}else{if(A==="./"||A===".\\")return[];{const C=A.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const W=C.match(new RegExp(`^${N.name}(?:/(.*))?`));return W?{match:W,folder:N}:null}).filter(P.isDefined);if(F.length)return F.map(N=>{const W=N.match[1];return{searchPath:N.folder.uri,pattern:W&&l(W)}});{const N=A.match(/\.[\/\\](.+)[\/\\]?/),W=N?N[1]:A,ce=d.localize(0,null,W);throw new Error(ce)}}}}resolveOneSearchPathPattern(A,C){const a=A.pattern&&C?`${A.pattern}/${C}`:A.pattern||C,F=[{searchPath:A.searchPath,pattern:a}];return a&&!a.endsWith("**")&&F.push({searchPath:A.searchPath,pattern:a+"/**"}),F}getFolderQueryForSearchPath(A,C,a){const F=this.getFolderQueryForRoot(w.toWorkspaceFolder(A.searchPath),C,a,!1);return F?Object.assign(Object.assign({},F),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,C,a,F){let N;const W=o.URI.isUri(A)?A:A.uri;if(a.searchPaths){const J=a.searchPaths.filter(R=>I.isEqual(R.searchPath,W))[0];if(J&&!J.pattern)return null;J&&(N=J.pattern)}const ce=this.configurationService.getValue({resource:W}),me=this.getExcludesForFolder(ce,C),G=Object.assign(Object.assign({},me||{}),N||{}),V=o.URI.isUri(A)?I.basename(A):A.name;return{folder:W,folderName:F?V:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:ce.files&&ce.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!ce.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!ce.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!ce.search.followSymlinks}}};m=Ve([je(0,u.IConfigurationService),je(1,w.IWorkspaceContextService),je(2,p.IEditorGroupsService),je(3,S.IPathService)],m),e.QueryBuilder=m;function f(b){const A=b.match(/[\*\{\}\(\)\[\]\?]/);if(A){const C=A.index,a=b.substr(0,C).match(/[/|\\][^/\\]*$/);if(a){let F=b.substr(0,a.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((a.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((A,C)=>(A[C]=!0,A),Object.create(null)):void 0}function n(b){return D.splitGlobAware(b,",").map(A=>A.trim()).filter(A=>!!A.length)}function r(b){return[`**/${b}/**`,`**/${b}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function l(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(b,A){b=g.distinct(b,F=>F.toString());const C=[],a=A.getWorkspace();return b&&b.forEach(F=>{let N;if(A.getWorkbenchState()===2)N=I.relativePath(a.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const W=A.getWorkspaceFolder(F);if(W){const ce=W.name;if(a.folders.filter(G=>G.name===ce).length===1){const G=I.relativePath(W.uri,F);G===""?N=`./${W.name}`:N=`./${W.name}/${G}`}else N=F.fsPath}}N&&C.push(N)}),C}e.resolveResourcesForSearchIncludes=v}),define(we[209],_e([0,1,25,2,18,12,5,208,38,62]),function(Z,e,g,T,D,E,k,y,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function P(u,w){const p=w.activationEvents;if(!p)return Promise.resolve(void 0);const S=[],c=[];for(const s of p)if(/^workspaceContains:/.test(s)){const l=s.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||u.forceUsingSearch?c.push(l):S.push(l)}if(S.length===0&&c.length===0)return Promise.resolve(void 0);let m;const f=new Promise((s,l)=>{m=s}),t=s=>m({activationEvent:s}),n=Promise.all(S.map(s=>o(u,s,t))).then(()=>{}),r=h(u,w.identifier,c,t);return Promise.all([n,r]).then(()=>{m(void 0)}),f}e.checkActivateWorkspaceContainsExtension=P;async function o(u,w,p){for(const S of u.folders)if(await u.exists(g.joinPath(T.URI.revive(S),w))){p(`workspaceContains:${w}`);return}}async function h(u,w,p,S){if(p.length===0)return Promise.resolve(void 0);const c=new D.CancellationTokenSource,m=u.checkExists(u.folders,p,c.token),f=setTimeout(async()=>{c.cancel(),S(`workspaceContainsTimeout:${p.join(",")}`)},i);let t=!1;try{t=await m}catch(n){E.isPromiseCanceledError(n)||E.onUnexpectedError(n)}c.dispose(),clearTimeout(f),t&&S(`workspaceContains:${p.join(",")}`)}function d(u,w,p,S){const c=u.get(k.IInstantiationService),m=u.get(_.ISearchService),t=c.createInstance(y.QueryBuilder).file(w.map(n=>I.toWorkspaceFolder(T.URI.revive(n))),{_reason:"checkExists",includePattern:p,exists:!0});return m.fileSearch(t,S).then(n=>!!n.limitHit,n=>E.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=d});var nt=this&&this.__classPrivateFieldSet||function(Z,e,g,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!D:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(Z,g):D?D.value=g:e.set(Z,g),g},Ue=this&&this.__classPrivateFieldGet||function(Z,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!T:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(Z):T?T.value:e.get(Z)};define(we[33],_e([0,1,128,13,75,25,11,7,22,2,17,4,32,173,73,30,29,171,12,26,23,152,6,91,5,28,74,14,60,66,37,3,209,69,153]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m,f,t,n,r,s,l,v,b,A,C,a,F,N,W){"use strict";var ce,me,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=r.createDecorator("IHostUtils");let V=class On extends y.Disposable{constructor(M,U,j,z,oe,pe,Te,$e,Me,ze){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=j,this._initData=Te,this._extHostWorkspace=z,this._extHostConfiguration=oe,this._logService=pe,this._extHostTunnelService=Me,this._extHostTerminalService=ze,this._disposables=new y.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(P.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(P.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(P.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new d.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=M.createChild(new b.ServiceCollection([d.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(Ke=>Qe.add(c.ExtensionIdentifier.toKey(Ke))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ke,Ge,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ke,S.transformErrorForSerialization(Ge),$)},actualActivateExtension:async(Ke,Ge)=>{if(Qe.has(c.ExtensionIdentifier.toKey(Ke)))return await this._mainThreadExtensionsProxy.$activateExtension(Ke,Ge),new h.HostExtension;const $=this._registry.getExtensionDescription(Ke);return this._activateExtension($,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){S.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(oe=>oe.identifier).filter(oe=>this.isActivated(oe)).map(oe=>this._deactivate(oe))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const j=this._activator.getActivatedExtension(M);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=_.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(j=>{if(!!this._getEntryPoint(j))return this._hostUtils.realpath(j.extensionLocation.fsPath).then(z=>M.set(I.URI.file(z).fsPath,j))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const j=this._activator.getActivatedExtension(M);if(!j)return U;try{typeof j.module.deactivate=="function"&&(U=Promise.resolve(j.module.deactivate()).then(void 0,z=>(this._logService.error(z),Promise.resolve(void 0))))}catch(z){this._logService.error(z)}try{y.dispose(j.subscriptions)}catch(z){this._logService.error(z)}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(j=>{const z=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,z.codeLoadingTime,z.activateCallTime,z.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",z),j},j=>{throw this._logExtensionActivationTimes(M,U,"failure"),j})}_logExtensionActivationTimes(M,U,j,z){const oe=J(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},oe),z||{}),{outcome:j}))}_doActivateExtension(M,U){const j=J(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const z=this._getEntryPoint(M);if(!z)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const oe=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,E.joinPath(M.extensionLocation,z),oe),this._loadExtensionContext(M)]).then(pe=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),On._callActivate(this._logService,M.identifier,pe[0],pe[1],oe))).then(pe=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const U=new f.ExtensionGlobalMemento(M,this._storage),j=new f.ExtensionMemento(M.identifier.value,!1,this._storage),z=new W.ExtensionSecrets(M,this._secretState),oe=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let $e;return Object.freeze({globalState:U,workspaceState:j,secrets:z,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Me){return T.join(M.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=Te._storagePath.workspaceValue(M))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return T.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return I.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return oe},get extension(){return $e===void 0&&($e=new R(Te,M.identifier,M,pe)),$e},get extensionRuntime(){return w.checkProposedApiEnabled(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,j,z,oe){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,j,z,oe).then(pe=>new h.ActivatedExtension(!1,null,oe.build(),j,pe,z.subscriptions))}static _callActivateOptional(M,U,j,z,oe){if(typeof j.activate=="function")try{oe.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const pe=typeof global=="object"?global:self,Te=j.activate.apply(pe,[z]);return oe.activateCallStop(),oe.activateResolveStart(),Promise.resolve(Te).then($e=>(oe.activateResolveStop(),$e))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(j)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,oe=>{this._logService.error(oe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(oe=>this._handleWorkspaceContainsEagerExtensions(oe.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(U),z=Promise.all([M,j]).then(()=>{});return Promise.race([z,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),z}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(this.isActivated(U.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,z={folders:M.map(pe=>pe.uri),forceUsingSearch:j,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,$e)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,$e)},oe=await F.checkActivateWorkspaceContainsExtension(z,U);if(!!oe)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:oe.activationEvent}).then(void 0,pe=>this._logService.error(pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(g.localize(0,null));const j=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(g.localize(1,null,U.toString()));return new Promise((z,oe)=>{const pe=(Me,ze)=>{Me?oe(Me):z(typeof ze=="number"&&ze>0?1:0)},Te=E.originalFSPath(U),$e=j.run(Te,pe);$e&&$e.then&&$e.then(()=>{z(0)}).catch(Me=>{oe(Me.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,y.toDisposable(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const U=M.indexOf("+");if(U===-1)throw new Error("Not an authority that can be resolved!");const j=M.substr(0,U);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(M,U){const{authorityPrefix:j,resolver:z}=await this._activateAndGetResolver(M);if(!z)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(z)),D.mark(`code/extHost/willResolveAuthority/${j}`);const oe=await z.resolve(M,{resolveAttempt:U});D.mark(`code/extHost/didResolveAuthorityOK/${j}`);const pe={authority:M,host:oe.host,port:oe.port,connectionToken:oe.connectionToken},Te={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted};return{type:"ok",value:{authority:pe,options:Te,tunnelInformation:{environmentTunnels:oe.environmentTunnels}}}}catch(oe){if(D.mark(`code/extHost/didResolveAuthorityError/${j}`),oe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe}}async $getCanonicalURI(M,U){const{authorityPrefix:j,resolver:z}=await this._activateAndGetResolver(M);if(!z)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const oe=I.URI.revive(U);if(typeof z.getCanonicalURI=="undefined")return oe;const pe=await k.asPromise(()=>z.getCanonicalURI(oe));return pe||oe}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(z=>z.extensionLocation=I.URI.revive(z.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(U.map(async z=>{const oe=this._registry.getExtensionDescription(z);if(!oe)return;const pe=await this._hostUtils.realpath(oe.extensionLocation.fsPath);j.delete(I.URI.file(pe).fsPath)})),await Promise.all(M.map(async z=>{const oe=await this._hostUtils.realpath(z.extensionLocation.fsPath);j.set(I.URI.file(oe).fsPath,z)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=m.VSBuffer.alloc(M),j=Math.random()%256;for(let z=0;z<M;z++)U.writeUInt8(j,z);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};V=Ve([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,v.IExtHostRpcService),je(3,u.IExtHostWorkspace),je(4,o.IExtHostConfiguration),je(5,i.ILogService),je(6,s.IExtHostInitDataService),je(7,l.IExtensionStoragePaths),je(8,A.IExtHostTunnelService),je(9,C.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function J(B,M){return{id:B.identifier.value,name:B.name,extensionVersion:B.version,publisherDisplayName:B.publisher,activationEvents:B.activationEvents?B.activationEvents.join(","):null,isBuiltin:B.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=r.createDecorator("IExtHostExtensionService");class R{constructor(M,U,j,z){ce.set(this,void 0),me.set(this,void 0),G.set(this,void 0),nt(this,ce,M,"f"),nt(this,me,U,"f"),nt(this,G,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=T.normalize(E.originalFSPath(j.extensionLocation)),this.packageJSON=j,this.extensionKind=z}get isActive(){return Ue(this,ce,"f").isActivated(Ue(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,ce,"f").getExtensionExports(Ue(this,G,"f"))}activate(){return Ue(this,ce,"f").activateByIdWithErrors(Ue(this,G,"f"),{startup:!1,extensionId:Ue(this,me,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,ce=new WeakMap,me=new WeakMap,G=new WeakMap}),define(we[103],_e([0,1,13,2,3,11,4,6,158,30,33,36,162,32,159,14,5,10,40,64]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=w.createDecorator("IExtHostDebugService");let m=class{constructor(b,A,C,a,F,N){this._workspaceService=A,this._extensionService=C,this._editorsService=a,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=b.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(ce=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,A){const C=b;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let a=`debug:${encodeURIComponent(C.path||"")}`,F="?";return A&&(a+=`${F}session=${encodeURIComponent(A.id)}`,F="&"),a+=`${F}ref=${C.sourceReference}`,T.URI.parse(a)}else{if(C.path)return T.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const A=[];for(const C of b.getAllExtensionDescriptions())if(C.contributes){const a=C.contributes.debuggers;if(a&&a.length>0)for(const F of a)d.isDebuggerMainContribution(F)&&A.push(F.type)}this._debugServiceProxy.$registerDebugTypes(A)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(A=>b.push(A)),b}addBreakpoints(b){this.startBreakpoints();const A=b.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(A,[],[]);const C=[],a=new Map;for(const F of A)if(F instanceof y.SourceBreakpoint){let N=a.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},a.set(F.location.uri.toString(),N),C.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof y.FunctionBreakpoint&&C.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(b){this.startBreakpoints();const A=b.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],A,[]);const C=A.filter(N=>N instanceof y.SourceBreakpoint).map(N=>N.id),a=A.filter(N=>N instanceof y.FunctionBreakpoint).map(N=>N.id),F=A.filter(N=>N instanceof y.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(C,a,F)}startDebugging(b,A,C){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,A,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,A,C){if(!A)return new y.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:a,provider:A}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,C,!!A.provideDebugConfigurations,!!A.resolveDebugConfiguration,!!A.resolveDebugConfigurationWithSubstitutedVariables,a),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==A),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(b,A,C){if(!C)return new y.Disposable(()=>{});if(!this.definesDebugType(b,A))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${A}' debugger.`);if(this.getAdapterDescriptorFactoryByType(A))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:A,handle:a,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(A,a),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(b,A){if(!A)return new y.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:C,factory:A}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==A)})}async $runInTerminal(b,A){return Promise.resolve(void 0)}async $substituteVariables(b,A){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let C;const a=await this.getFolder(b);return a&&(C={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(C,A)}createDebugAdapter(b,A){if(b.type==="implementation")return new s(b.implementation)}createSignService(){}async $startDASession(b,A){const C=this,a=await this.getSession(A);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),W=this.createDebugAdapter(N,a);if(!W)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const ce=W;return this._debugAdapters.set(b,ce),this.getDebugAdapterTrackers(a).then(me=>(me&&this._debugAdaptersTrackers.set(b,me),ce.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const V=G,J={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const R=await this._signService.sign(V.arguments.value);J.body={signature:R},ce.sendResponse(J)}else throw new Error("no signer")}catch(R){J.success=!1,J.message=R.message,ce.sendResponse(J)}}else me&&me.onDidSendMessage&&me.onDidSendMessage(G),G=d.convertToVSCPaths(G,!0),C._debugServiceProxy.$acceptDAMessage(b,G)}),ce.onError(G=>{me&&me.onError&&me.onError(G),this._debugServiceProxy.$acceptDAError(b,G.name,G.message,G.stack)}),ce.onExit(G=>{me&&me.onExit&&me.onExit(p.withNullAsUndefined(G),void 0),this._debugServiceProxy.$acceptDAExit(b,p.withNullAsUndefined(G),void 0)}),me&&me.onWillStartSession&&me.onWillStartSession(),ce.startSession()))})}$sendDAMessage(b,A){A=d.convertToDAPaths(A,!1);const C=this._debugAdaptersTrackers.get(b);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(A);const a=this._debugAdapters.get(b);a&&a.sendMessage(A)}$stopDASession(b){const A=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),A&&A.onWillStopSession&&A.onWillStopSession();const C=this._debugAdapters.get(b);return this._debugAdapters.delete(b),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const A=[],C=[],a=[];if(b.added)for(const F of b.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let W;if(F.type==="function")W=new y.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")W=new y.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const ce=T.URI.revive(F.uri);W=new y.SourceBreakpoint(new y.Location(ce,new y.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}W._id=N,this._breakpoints.set(N,W),A.push(W)}}if(b.removed)for(const F of b.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),C.push(N))}if(b.changed){for(const F of b.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof y.FunctionBreakpoint&&F.type==="function"){const W=N;W.enabled=F.enabled,W.condition=F.condition,W.hitCondition=F.hitCondition,W.logMessage=F.logMessage,W.functionName=F.functionName}else if(N instanceof y.SourceBreakpoint&&F.type==="source"){const W=N;W.enabled=F.enabled,W.condition=F.condition,W.hitCondition=F.hitCondition,W.logMessage=F.logMessage,W.location=new y.Location(T.URI.revive(F.uri),new y.Position(F.line,F.character))}a.push(N)}}}this.fireBreakpointChanges(A,C,a)}$provideDebugConfigurations(b,A,C){return E.asPromise(async()=>{const a=this.getConfigProviderByHandle(b);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(A);return a.provideDebugConfigurations(F,C)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(b,A,C,a){return E.asPromise(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(A);return F.resolveDebugConfiguration(N,C,a)})}$resolveDebugConfigurationWithSubstitutedVariables(b,A,C,a){return E.asPromise(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(A);return F.resolveDebugConfigurationWithSubstitutedVariables(N,C,a)})}async $provideDebugAdapter(b,A){const C=this.getAdapterDescriptorFactoryByHandle(b);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(A);return this.getAdapterDescriptor(C,a).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const A=await this.getSession(b);this._onDidStartDebugSession.fire(A)}async $acceptDebugSessionTerminated(b){const A=await this.getSession(b);A&&(this._onDidTerminateDebugSession.fire(A),this._debugSessions.delete(A.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,A){const C=await this.getSession(b);C&&C._acceptNameChanged(A)}async $acceptDebugSessionCustomEvent(b,A){const a={session:await this.getSession(b),event:A.event,body:A.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(b){if(b instanceof y.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof y.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const A=this._adapterFactories.filter(C=>C.type===b);if(A.length>0)return A[0].factory}getAdapterDescriptorFactoryByHandle(b){const A=this._adapterFactories.filter(C=>C.handle===b);if(A.length>0)return A[0].factory}getConfigProviderByHandle(b){const A=this._configProviders.filter(C=>C.handle===b);if(A.length>0)return A[0].provider}definesDebugType(b,A){if(b.contributes){const C=b.contributes.debuggers;if(C&&C.length>0){for(const a of C)if(a.label&&a.type&&a.type===A)return!0}}return!1}getDebugAdapterTrackers(b){const C=b.configuration.type,a=this._trackerFactories.filter(F=>F.type===C||F.type==="*").map(F=>E.asPromise(()=>F.factory.createDebugAdapterTracker(b)).then(N=>N,N=>null));return Promise.race([Promise.all(a).then(F=>{const N=F.filter(W=>!!W);if(N.length>0)return new r(N)}),new Promise((F,N)=>{const W=setTimeout(()=>{clearTimeout(W),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,A){const C=A.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new y.DebugAdapterServer(C));if(b){const F=await this._extensionService.getExtensionRegistry();return E.asPromise(()=>b.createDebugAdapterDescriptor(A,this.daExecutableFromPackage(A,F))).then(N=>{if(N)return N})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(A,a))}daExecutableFromPackage(b,A){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,A,C){(b.length>0||A.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:A,changed:C}))}async getSession(b){if(b)if(typeof b=="string"){const A=this._debugSessions.get(b);if(A)return A}else{let A=this._debugSessions.get(b.id);if(!A){const C=await this.getFolder(b.folderUri),a=b.parent?this._debugSessions.get(b.parent):void 0;A=new f(this._debugServiceProxy,b.id,b.type,b.name,C,b.configuration,a),this._debugSessions.set(A.id,A),this._debugServiceProxy.$sessionCached(A.id)}return A}throw new Error("cannot find session")}getFolder(b){if(b){const A=T.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(A)}return Promise.resolve(void 0)}};m=Ve([je(0,u.IExtHostRpcService),je(1,I.IExtHostWorkspace),je(2,i.IExtHostExtensionService),je(3,P.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,c.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class f{constructor(b,A,C,a,F,N,W){this._debugServiceProxy=b,this._id=A,this._type=C,this._name=a,this._workspaceFolder=F,this._configuration=N,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}get parentSession(){return this._parentSession}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,A){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,A)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=f;class t{constructor(b){this.value=Object.freeze({append(A){b.$appendDebugConsole(A)},appendLine(A){this.append(A+`
`)}})}}e.ExtHostDebugConsole=t;class n extends o.AbstractVariableResolverService{constructor(b,A,C,a,F){function N(){if(A){const W=A.activeEditor();if(W)return W.document.uri;const ce=a.tabs.filter(me=>me.isActive);if(ce.length>0)return ce[0].resource}}super({getFolderUri:W=>{const ce=b.filter(me=>me.name===W);if(ce&&ce.length>0)return ce[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(W,ce)=>C.getConfiguration(void 0,W).get(ce),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=N();if(W)return g.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const W=N();if(W){const ce=F.getWorkspaceFolder(W);if(ce)return g.normalize(ce.uri.fsPath)}}},getSelectedText:()=>{if(A){const W=A.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(A){const W=A.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=n;class r{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(A=>A.onWillReceiveMessage?A.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(A=>A.onDidSendMessage?A.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(A=>A.onError?A.onError(b):void 0)}onExit(b,A){this.trackers.forEach(C=>C.onExit?C.onExit(b,A):void 0)}}class s extends _.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(A=>{this.acceptMessage(A)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends m{constructor(b,A,C,a,F,N){super(b,A,C,a,F,N)}createVariableResolver(b,A,C){return new n(b,A,C,this._editorTabs)}};l=Ve([je(0,u.IExtHostRpcService),je(1,I.IExtHostWorkspace),je(2,i.IExtHostExtensionService),je(3,P.IExtHostDocumentsAndEditors),je(4,h.IExtHostConfiguration),je(5,c.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(we[210],_e([0,1,75,2,4,32,29,26,14,28,5,33,40,17]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(c,m,f,t,n,r,s){this._apiFactory=c,this._extensionRegistry=m,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,m,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,m,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let m of c.nodeModuleName)this._factories.set(m,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(m=>c.alternativeModuleName(m))}};d=Ve([je(2,i.IInstantiationService),je(3,E.IExtHostConfiguration),je(4,P.IExtHostExtensionService),je(5,I.IExtHostInitDataService),je(6,h.ILogService)],d),e.RequireInterceptor=d;class u{constructor(c,m,f,t,n){this._apiFactory=c,this._extensionPaths=m,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,m){const f=this._extensionPaths.findSubstr(m.fsPath);if(f){let t=this._extApiImpl.get(y.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(y.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,r)=>t+=`	${r} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(c,m){this.nodeModuleName="keytar";const{environment:f}=m,t=c.getProxy(D.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;o.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,r)=>t.$getPassword(n,r),setPassword:(n,r,s)=>t.$setPassword(n,r,s),deletePassword:(n,r)=>t.$deletePassword(n,r),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(c,m){return this._impl}alternativeModuleName(c){const m=c.length;if(m<=7||!this.alternativeNames)return;const f=m-7;if((c.charAt(f)==="/"||c.charAt(f)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};w=Ve([je(0,_.IExtHostRpcService),je(1,I.IExtHostInitDataService)],w);let p=class{constructor(c,m,f){this._extensionPaths=c,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(D.MainContext.MainThreadTelemetry);const t=f.getProxy(D.MainContext.MainThreadWindow);this._impl=(n,r)=>{const s=T.URI.parse(n);return r?this.callOriginal(n,r):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,r)}}load(c,m,f){const t=this._extensionPaths.findSubstr(m.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(c),this._impl}callOriginal(c,m){return this.sendNoForwardTelemetry(),this._original(c,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=Ve([je(2,_.IExtHostRpcService)],p)}),define(we[211],_e([0,1,11,12,75,7,2,4,203,17,57,60,28,144,14,67,33,37]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(m,f,t,n){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(m,null,n),f=S._transform(f,this._rpcProtocol);const r=new P.ServiceCollection(...i.getSingletonServiceDescriptors());r.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),r.set(d.IExtHostRpcService,new d.ExtHostRpcService(this._rpcProtocol)),r.set(u.IURITransformerService,new u.URITransformerService(n)),r.set(w.IHostUtils,t);const s=new h.InstantiationService(r,!0),l=s.invokeFunction(C=>C.get(p.IExtHostTerminalService));this._disposables.add(l),this._logService=s.invokeFunction(C=>C.get(I.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=s.invokeFunction(C=>C.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(C=>{Error.prepareStackTrace=(a,F)=>{let N="",W,ce;for(const me of F)N+=`
	at ${me.toString()}`,ce=me.getFileName(),!W&&ce&&(W=C.findSubstr(ce));return v.set(a,W),`${a.name||"Error"}: ${a.message||""}${N}`}});const b=this._rpcProtocol.getProxy(y.MainContext.MainThreadExtensionService),A=this._rpcProtocol.getProxy(y.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(C=>{const a=T.transformErrorForSerialization(C),F=v.get(C);F?b.$onExtensionRuntimeError(F.identifier,a):A.$onUnexpectedError(a)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([g.timeout(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,f){m.extensions.forEach(n=>n.extensionLocation=k.URI.revive(f.transformIncomingURIs(n.extensionLocation))),m.environment.appRoot=k.URI.revive(f.transformIncomingURIs(m.environment.appRoot));const t=m.environment.extensionDevelopmentLocationURI;return t&&(m.environment.extensionDevelopmentLocationURI=t.map(n=>k.URI.revive(f.transformIncomingURIs(n)))),m.environment.extensionTestsLocationURI=k.URI.revive(f.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=k.URI.revive(f.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=k.URI.revive(f.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=k.URI.revive(f.transformIncomingURIs(m.logsLocation)),m.logFile=k.URI.revive(f.transformIncomingURIs(m.logFile)),m.workspace=f.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=S}),define(we[212],_e([0,1,13,18,56,27,25,52,38]),function(Z,e,g,T,D,E,k,y,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(o,h,d){this.config=o,this.provider=h,this.sessionToken=d,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&E.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&E.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const h=this.config.folderQueries||[];return new Promise((d,u)=>{const w=p=>{this.resultCount++,o(p)};if(this.isCanceled)return d({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const S=p.toString(),c=g.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,c)||this.matchFile(w,{base:p,basename:c})}),Promise.all(h.map(p=>this.searchInFolder(p,w))).then(p=>{d({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{u(new Error(D.toErrorMessage(p)))})})}async searchInFolder(o,h){const d=new T.CancellationTokenSource,u=this.getSearchOptionsForFolder(o),w=this.initDirectoryTree(),p=new _.QueryGlobTester(this.config,o),S=!p.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(d),c=y.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},u,d.token),f=c.elapsed(),t=y.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(n=>{const r=g.posix.relative(o.folder.path,n.path);if(S){const s=g.basename(n.path);this.matchFile(h,{base:o.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,o.folder,r,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,p,h),{providerTime:f,postProcessTime:t.elapsed()})}finally{d.dispose(),this.activeCancellationTokens.delete(d)}}getSearchOptionsForFolder(o){const h=_.resolvePatternsForProvider(this.config.includePattern,o.includePattern),d=_.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:d,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},h,d,u){if(d===this.filePattern){const p=g.basename(this.filePattern);this.matchFile(u,{base:h,relativePath:this.filePattern,basename:p})}function w(p){const S=g.basename(p),c=g.dirname(p);let m=o[c];m||(m=o[c]=[],w(c)),m.push({base:h,relativePath:p,basename:S})}w(d)}matchDirectoryTree({rootEntries:o,pathToEntries:h},d,u){const w=this,p=this.filePattern;function S(c){const m=E.hasSiblingFn(()=>c.map(f=>f.basename));for(let f=0,t=c.length;f<t;f++){const n=c[f],{relativePath:r,basename:s}=n;if(!d.includedInQuerySync(r,s,p!==s?m:void 0))continue;const l=h[r];if(l)S(l);else{if(r===p)continue;w.matchFile(u,n)}if(w.isLimitHit)break}}S(o)}matchFile(o,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(h))}}class i{constructor(){this.sessions=new Map}fileSearch(o,h,d,u){const w=this.getSessionTokenSource(o.cacheKey),p=new I(o,h,w&&w.token);let S=0;const c=m=>{S+=m.length,d(m.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(p,i.BATCH_SIZE,c,u).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:m.stats}}))}clearCache(o){const h=this.getSessionTokenSource(o);h&&h.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,h,d,u){u.onCancellationRequested(()=>{o.cancel()});const w=S=>{S&&(p.push(S),h>0&&p.length>=h&&(d(p),p=[]))};let p=[];return o.search(w).then(S=>(p.length&&d(p),S),S=>(p.length&&d(p),Promise.reject(S)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(we[213],_e([0,1,13,16,18,56,25,27,2,38,15,10]),function(Z,e,g,T,D,E,k,y,_,I,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(c,m,f){this.query=c,this.provider=m,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,m){const f=this.query.folderQueries||[],t=new D.CancellationTokenSource;return m.onCancellationRequested(()=>t.cancel()),new Promise((n,r)=>{this.collector=new d(c);let s=!1;const l=(v,b)=>{if(!s&&!this.isLimitHit){const A=this.resultSize(v);w(v)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const C=this.resultSize(v);this.resultCount+=C,(C>0||!w(v))&&this.collector.add(v,b)}};Promise.all(f.map((v,b)=>this.searchInFolder(v,A=>l(A,b),t.token))).then(v=>{t.dispose(),this.collector.flush();const b=v.some(A=>!!A&&!!A.limitHit);n({limitHit:this.isLimitHit||b,messages:T.flatten(v.map(A=>(A==null?void 0:A.message)?P.isArray(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const b=E.toErrorMessage(v);r(new Error(b))})})}resultSize(c){return w(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,m){const f=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:f.slice(0,m),preview:{matches:t.slice(0,m),text:c.preview.text},uri:c.uri}}async searchInFolder(c,m,f){const t=new I.QueryGlobTester(this.query,c),n=[],r={report:v=>{if(!this.validateProviderResult(v))return;const b=c.folder.scheme===i.Schemas.file?y.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(v.uri))):void 0,A=k.relativePath(c.folder,v.uri);A&&n.push(t.includedInQuery(A,g.basename(A),b).then(C=>{C&&m(v)}))}},s=this.getSearchOptionsForFolder(c),l=await this.provider.provideTextSearchResults(h(this.query.contentPattern),s,r,f);return await Promise.all(n),l}validateProviderResult(c){if(w(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const m=I.resolvePatternsForProvider(this.query.includePattern,c.includePattern),f=I.resolvePatternsForProvider(this.query.excludePattern,c.excludePattern),t={folder:_.URI.from(c.folder),excludes:f,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function h(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,m=>this.sendItems(m))}add(c,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!k.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(u(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function u(S){return w(S)?{preview:{matches:T.mapArrayOrNot(S.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:S.preview.text},ranges:T.mapArrayOrNot(S.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function w(S){return!!S.preview}e.extensionResultIsMatch=w;class p{constructor(c,m){this.maxBatchSize=c,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,m){!c||this.addItemToBatch(c,m)}addItems(c,m){!c||this.addItemsToBatch(c,m)}addItemToBatch(c,m){this.batch.push(c),this.batchSize+=m,this.onUpdate()}addItemsToBatch(c,m){this.batch=this.batch.concat(c),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(we[104],_e([0,1,7,4,5,212,14,67,17,2,213]),function(Z,e,g,T,D,E,k,y,_,I,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=D.createDecorator("IExtHostSearch");let P=class{constructor(u,w,p){this.extHostRpc=u,this._uriTransformer=w,this._logService=p,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(u){return this._uriTransformer.transformOutgoingScheme(u)}registerTextSearchProvider(u,w){if(this._textSearchUsedSchemes.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this._textSearchUsedSchemes.add(u);const p=this._handlePool++;return this._textSearchProvider.set(p,w),this._proxy.$registerTextSearchProvider(p,this._transformScheme(u)),g.toDisposable(()=>{this._textSearchUsedSchemes.delete(u),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(u,w){if(this._fileSearchUsedSchemes.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this._fileSearchUsedSchemes.add(u);const p=this._handlePool++;return this._fileSearchProvider.set(p,w),this._proxy.$registerFileSearchProvider(p,this._transformScheme(u)),g.toDisposable(()=>{this._fileSearchUsedSchemes.delete(u),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(u,w,p,S){const c=o(p),m=this._fileSearchProvider.get(u);if(m)return this._fileSearchManager.fileSearch(c,m,f=>{this._proxy.$handleFileMatch(u,w,f.map(t=>t.resource))},S);throw new Error("unknown provider: "+u)}$clearCache(u){return this._fileSearchManager.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,w,p,S){const c=this._textSearchProvider.get(u);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const m=o(p);return this.createTextSearchManager(m,c).search(t=>this._proxy.$handleTextMatch(u,w,t),S)}createTextSearchManager(u,w){return new i.TextSearchManager(u,w,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p})}};P=Ve([je(0,k.IExtHostRpcService),je(1,y.IURITransformerService),je(2,_.ILogService)],P),e.ExtHostSearch=P;function o(d){return Object.assign(Object.assign({},d),{folderQueries:d.folderQueries&&d.folderQueries.map(h),extraFileResources:d.extraFileResources&&d.extraFileResources.map(u=>I.URI.revive(u))})}e.reviveQuery=o;function h(d){return Object.assign(Object.assign({},d),{folder:I.URI.revive(d.folder)})}}),define(we[214],_e([0,1,18,12,3,41,2,122,83,116,55,59,4,178,177,71,179,32,180,181,182,165,183,36,33,184,166,186,187,188,99,168,192,193,194,73,37,195,169,9,6,198,46,100,30,29,76,157,185,150,98,102,103,104,17,67,14,28,189,155,66,70,175,196,154,74,72,201,199,200,176,44,207,197,69,64,92,190,101,191,15,146]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m,f,t,n,r,s,l,v,b,A,C,a,F,N,W,ce,me,G,V,J,R,B,M,U,j,z,oe,pe,Te,$e,Me,ze,Qe,Ke,Ge,$,Q,ne,re,K,se,fe,Ae,ge,We,H,te,ve,Le,xe,Be,Ye,Se,ye,De,ie,ue,O,Y,ae,Ce,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ne(Oe){const qe=Oe.get(ne.IExtHostInitDataService),rt=Oe.get(Ye.IExtHostFileSystemInfo),tt=Oe.get(te.IExtHostConsumerFileSystem),Je=Oe.get(r.IExtHostExtensionService),ot=Oe.get(j.IExtHostWorkspace),_t=Oe.get(ue.IExtHostTelemetry),wt=Oe.get(p.IExtHostConfiguration),be=Oe.get($.IURITransformerService),de=Oe.get(Q.IExtHostRpcService),le=Oe.get(ce.IExtHostStorage),q=Oe.get(H.IExtensionStoragePaths),Fe=Oe.get(Ge.ILogService),Pe=Oe.get(se.IExtHostTunnelService),Ze=Oe.get(fe.IExtHostApiDeprecationService),et=Oe.get(U.IExtHostWindow),ft=Oe.get(De.IExtHostSecretState),ut=Oe.get(ie.IExtHostEditorTabs);de.set(o.ExtHostContext.ExtHostFileSystemInfo,rt),de.set(o.ExtHostContext.ExtHostLogService,Fe),de.set(o.ExtHostContext.ExtHostWorkspace,ot),de.set(o.ExtHostContext.ExtHostConfiguration,wt),de.set(o.ExtHostContext.ExtHostExtensionService,Je),de.set(o.ExtHostContext.ExtHostStorage,le),de.set(o.ExtHostContext.ExtHostTunnelService,Pe),de.set(o.ExtHostContext.ExtHostWindow,et),de.set(o.ExtHostContext.ExtHostSecretState,ft),de.set(o.ExtHostContext.ExtHostTelemetry,_t),de.set(o.ExtHostContext.ExtHostEditorTabs,ut);const it=de.set(o.ExtHostContext.ExtHostDecorations,Oe.get(Me.IExtHostDecorations)),vt=de.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Oe.get(n.IExtHostDocumentsAndEditors)),ht=de.set(o.ExtHostContext.ExtHostCommands,Oe.get(u.IExtHostCommands)),lt=de.set(o.ExtHostContext.ExtHostTerminalService,Oe.get(me.IExtHostTerminalService)),mt=de.set(o.ExtHostContext.ExtHostDebugService,Oe.get(Qe.IExtHostDebugService)),Pt=de.set(o.ExtHostContext.ExtHostSearch,Oe.get(Ke.IExtHostSearch)),Ct=de.set(o.ExtHostContext.ExtHostTask,Oe.get(ze.IExtHostTask)),At=de.set(o.ExtHostContext.ExtHostOutputService,Oe.get(C.IExtHostOutputService)),Rt=de.set(o.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(de)),yt=de.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(de,vt)),Gt=de.set(o.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(de,vt,Fe)),Qt=de.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Fe,yt,de.getProxy(o.MainContext.MainThreadBulkEdits))),pt=de.set(o.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(de,ht,vt,yt,Fe,q)),Yt=de.set(o.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(de,qe,pt,Fe)),Jt=de.set(o.ExtHostContext.ExtHostNotebookRenderers,new ae.ExtHostNotebookRenderers(de,pt)),Dt=de.set(o.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(de,vt)),cn=de.set(o.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(de.getProxy(o.MainContext.MainThreadTreeViews),ht,Fe)),Xt=de.set(o.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(de.getProxy(o.MainContext.MainThreadEditorInsets),Dt,qe)),xt=de.set(o.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(de,Fe)),ct=de.set(o.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(de,be,yt,ht,xt,Fe,Ze)),Zt=de.set(o.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(de,ct)),Mt=de.set(o.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(de,Fe,vt)),Lt=de.set(o.ExtHostContext.ExtHostQuickOpen,F.createExtHostQuickOpen(de,ot,ht)),Vt=de.set(o.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(de,ht,Fe)),bn=de.set(o.ExtHostContext.ExtHostComments,new w.ExtHostComments(de,ht,yt)),dn=de.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(de.getProxy(o.MainContext.MainThreadProgress))),wn=de.set(o.ExtHostContext.ExtHosLabelService,new Te.ExtHostLabelService(de)),hn=de.set(o.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(de)),Bt=de.set(o.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(de)),en=de.set(o.ExtHostContext.ExtHostTimeline,new ge.ExtHostTimeline(de,ht)),Ht=de.set(o.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(de,{remote:qe.remote},ot,Fe,Ze)),tn=de.set(o.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(de,Ht,ot)),_n=de.set(o.ExtHostContext.ExtHostCustomEditors,new Le.ExtHostCustomEditors(de,yt,q,Ht,tn)),En=de.set(o.ExtHostContext.ExtHostWebviewViews,new ve.ExtHostWebviewViews(de,Ht)),Nt=de.set(o.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(de,vt,ot)),jt=de.set(o.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(de)),yn=oe.values(o.ExtHostContext);de.assertRegistered(yn);const Sn=new Be.ExtHostBulkEdits(de,vt),nn=new d.ExtHostClipboard(de),rn=new A.ExtHostMessageService(de,Fe),$t=new c.ExtHostDialogs(de),qt=new W.ExtHostStatusBar(de,ht.converter),Wt=new b.ExtHostLanguages(de,yt);return h.ExtHostApiCommands.register(ht),function(Re,sn,It){const gt=function(){let X=!Re.isUnderDevelopment;function he(Ie){X||(Fe.info(`Extension '${Re.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")he(st);else{const bt=st;typeof bt.scheme=="undefined"&&he(st),!Re.enableProposedApi&&typeof bt.exclusive=="boolean"&&z.throwProposedApiError(Re)}return st}}(),Dn={getSession(X,he,Ie){return Bt.getSession(Re,X,he,Ie)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(X,he,Ie,st){return Bt.registerAuthenticationProvider(X,he,Ie,st)},get onDidChangeAuthenticationProviders(){return z.checkProposedApiEnabled(Re),Bt.onDidChangeAuthenticationProviders},get providers(){return z.checkProposedApiEnabled(Re),Bt.providers},logout(X,he){return z.checkProposedApiEnabled(Re),Bt.removeSession(X,he)}},Cn={registerCommand(X,he,Ie){return ht.registerCommand(!0,X,he,Ie)},registerTextEditorCommand(X,he,Ie){return ht.registerCommand(!0,X,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Fe.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(Et=>{he.apply(Ie,[bt,Et,...st])}).then(Et=>{Et||Fe.warn("Edits from command "+X+" were not applied.")},Et=>{Fe.warn("An error occurred while running command "+X,Et)})})},registerDiffInformationCommand:(X,he,Ie)=>(z.checkProposedApiEnabled(Re),ht.registerCommand(!0,X,async(...st)=>{const bt=vt.activeEditor(!0);if(!bt){Fe.warn("Cannot execute "+X+" because there is no active text editor.");return}const Et=await Dt.getDiffInformation(bt.id);he.apply(Ie,[Et,...st])})),executeCommand(X,...he){return ht.executeCommand(X,...he)},getCommands(X=!1){return ht.getCommands(X)}},fn={get machineId(){return qe.telemetryInfo.machineId},get sessionId(){return qe.telemetryInfo.sessionId},get language(){return qe.environment.appLanguage},get appName(){return qe.environment.appName},get appRoot(){var X,he;return(he=(X=qe.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return qe.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return _t.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(qe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,he){return et.openUri(X,{allowTunneling:!!qe.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===qe.environment.appUriScheme)return Rt.createAppUri(X);!ke.matchesScheme(X,Ce.Schemas.http)&&!ke.matchesScheme(X,Ce.Schemas.https)&&z.checkProposedApiEnabled(Re);try{return await et.asExternalUri(X,{allowTunneling:!!qe.remote.authority})}catch(he){return X}},get remoteName(){return $e.getRemoteName(qe.remote.authority)},get uiKind(){return qe.uiKind}};qe.environment.extensionTestsLocationURI||Object.freeze(fn);const mn=qe.remote.isRemote?R.ExtensionKind.Workspace:R.ExtensionKind.UI,on={registerTestController(X){return z.checkProposedApiEnabled(Re),Nt.registerTestController(Re.identifier.value,X)},createDocumentTestObserver(X){return z.checkProposedApiEnabled(Re),Nt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return z.checkProposedApiEnabled(Re),Nt.createWorkspaceTestObserver(X)},runTests(X){return z.checkProposedApiEnabled(Re),Nt.runTests(X)},createTestItem(X,he){return new R.TestItemImpl(X.id,X.label,X.uri,he)},createTestRun(X,he,Ie){return z.checkProposedApiEnabled(Re),Nt.createTestRun(Re.identifier.value,X,he,Ie)},get onDidChangeTestResults(){return z.checkProposedApiEnabled(Re),Nt.onResultsChanged},get testResults(){return z.checkProposedApiEnabled(Re),Nt.results}};on.createTestRunTask=on.createTestRun;const kn={getExtension(X){const he=sn.getExtensionDescription(X);if(he)return new r.Extension(Je,Re.identifier,he,mn)},get all(){return sn.getAllExtensionDescriptions().map(X=>new r.Extension(Je,Re.identifier,X,mn))},get onDidChange(){return sn.onDidChange}},In={createDiagnosticCollection(X){return xt.createDiagnosticCollection(Re.identifier,X)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:X=>xt.getDiagnostics(X),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(X,he){return Wt.changeLanguage(X.uri,he)},match(X,he){return i.score(J.LanguageSelector.from(X),he.uri,he.languageId,!0)},registerCodeActionsProvider(X,he,Ie){return ct.registerCodeActionProvider(Re,gt(X),he,Ie)},registerCodeLensProvider(X,he){return ct.registerCodeLensProvider(Re,gt(X),he)},registerDefinitionProvider(X,he){return ct.registerDefinitionProvider(Re,gt(X),he)},registerDeclarationProvider(X,he){return ct.registerDeclarationProvider(Re,gt(X),he)},registerImplementationProvider(X,he){return ct.registerImplementationProvider(Re,gt(X),he)},registerTypeDefinitionProvider(X,he){return ct.registerTypeDefinitionProvider(Re,gt(X),he)},registerHoverProvider(X,he){return ct.registerHoverProvider(Re,gt(X),he,Re.identifier)},registerEvaluatableExpressionProvider(X,he){return ct.registerEvaluatableExpressionProvider(Re,gt(X),he,Re.identifier)},registerInlineValuesProvider(X,he){return ct.registerInlineValuesProvider(Re,gt(X),he,Re.identifier)},registerDocumentHighlightProvider(X,he){return ct.registerDocumentHighlightProvider(Re,gt(X),he)},registerLinkedEditingRangeProvider(X,he){return ct.registerLinkedEditingRangeProvider(Re,gt(X),he)},registerReferenceProvider(X,he){return ct.registerReferenceProvider(Re,gt(X),he)},registerRenameProvider(X,he){return ct.registerRenameProvider(Re,gt(X),he)},registerDocumentSymbolProvider(X,he,Ie){return ct.registerDocumentSymbolProvider(Re,gt(X),he,Ie)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Re,X)},registerDocumentFormattingEditProvider(X,he){return ct.registerDocumentFormattingEditProvider(Re,gt(X),he)},registerDocumentRangeFormattingEditProvider(X,he){return ct.registerDocumentRangeFormattingEditProvider(Re,gt(X),he)},registerOnTypeFormattingEditProvider(X,he,Ie,...st){return ct.registerOnTypeFormattingEditProvider(Re,gt(X),he,[Ie].concat(st))},registerDocumentSemanticTokensProvider(X,he,Ie){return ct.registerDocumentSemanticTokensProvider(Re,gt(X),he,Ie)},registerDocumentRangeSemanticTokensProvider(X,he,Ie){return ct.registerDocumentRangeSemanticTokensProvider(Re,gt(X),he,Ie)},registerSignatureHelpProvider(X,he,Ie,...st){return typeof Ie=="object"?ct.registerSignatureHelpProvider(Re,gt(X),he,Ie):ct.registerSignatureHelpProvider(Re,gt(X),he,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(X,he,...Ie){return ct.registerCompletionItemProvider(Re,gt(X),he,Ie)},registerInlineCompletionItemProvider(X,he){return z.checkProposedApiEnabled(Re),ct.registerInlineCompletionsProvider(Re,gt(X),he)},registerDocumentLinkProvider(X,he){return ct.registerDocumentLinkProvider(Re,gt(X),he)},registerColorProvider(X,he){return ct.registerColorProvider(Re,gt(X),he)},registerFoldingRangeProvider(X,he){return ct.registerFoldingRangeProvider(Re,gt(X),he)},registerSelectionRangeProvider(X,he){return ct.registerSelectionRangeProvider(Re,X,he)},registerCallHierarchyProvider(X,he){return ct.registerCallHierarchyProvider(Re,X,he)},setLanguageConfiguration:(X,he)=>ct.setLanguageConfiguration(Re,X,he),getTokenInformationAtPosition(X,he){return z.checkProposedApiEnabled(Re),Wt.tokenAtPosition(X,he)},registerInlayHintsProvider(X,he){return z.checkProposedApiEnabled(Re),ct.registerInlayHintsProvider(Re,X,he)}},an={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(X,he,Ie){const st=await(k.URI.isUri(X)?Promise.resolve(gn.openTextDocument(X)):Promise.resolve(X));return Dt.showTextDocument(st,he,Ie)},createTextEditorDecorationType(X){return Dt.createTextEditorDecorationType(Re,X)},onDidChangeActiveTextEditor(X,he,Ie){return Dt.onDidChangeActiveTextEditor(X,he,Ie)},onDidChangeVisibleTextEditors(X,he,Ie){return Dt.onDidChangeVisibleTextEditors(X,he,Ie)},onDidChangeTextEditorSelection(X,he,Ie){return Dt.onDidChangeTextEditorSelection(X,he,Ie)},onDidChangeTextEditorOptions(X,he,Ie){return Dt.onDidChangeTextEditorOptions(X,he,Ie)},onDidChangeTextEditorVisibleRanges(X,he,Ie){return Dt.onDidChangeTextEditorVisibleRanges(X,he,Ie)},onDidChangeTextEditorViewColumn(X,he,Ie){return Dt.onDidChangeTextEditorViewColumn(X,he,Ie)},onDidCloseTerminal(X,he,Ie){return lt.onDidCloseTerminal(X,he,Ie)},onDidOpenTerminal(X,he,Ie){return lt.onDidOpenTerminal(X,he,Ie)},onDidChangeActiveTerminal(X,he,Ie){return lt.onDidChangeActiveTerminal(X,he,Ie)},onDidChangeTerminalDimensions(X,he,Ie){return z.checkProposedApiEnabled(Re),lt.onDidChangeTerminalDimensions(X,he,Ie)},onDidWriteTerminalData(X,he,Ie){return z.checkProposedApiEnabled(Re),lt.onDidWriteTerminalData(X,he,Ie)},get state(){return et.state},onDidChangeWindowState(X,he,Ie){return et.onDidChangeWindowState(X,he,Ie)},showInformationMessage(X,...he){return rn.showMessage(Re,E.default.Info,X,he[0],he.slice(1))},showWarningMessage(X,...he){return rn.showMessage(Re,E.default.Warning,X,he[0],he.slice(1))},showErrorMessage(X,...he){return rn.showMessage(Re,E.default.Error,X,he[0],he.slice(1))},showQuickPick(X,he,Ie){return Lt.showQuickPick(X,!!Re.enableProposedApi,he,Ie)},showWorkspaceFolderPick(X){return Lt.showWorkspaceFolderPick(X)},showInputBox(X,he){return Lt.showInput(X,he)},showOpenDialog(X){return $t.showOpenDialog(X)},showSaveDialog(X){return $t.showSaveDialog(X)},createStatusBarItem(X,he,Ie){let st,bt,Et;return typeof X=="string"?(st=X,bt=he,Et=Ie):(bt=X,Et=he),qt.createStatusBarEntry(Re,st,bt,Et)},setStatusBarMessage(X,he){return qt.setStatusBarMessage(X,he)},withScmProgress(X){return Ze.report("window.withScmProgress",Re,"Use 'withProgress' instead."),dn.withProgress(Re,{location:R.ProgressLocation.SourceControl},(he,Ie)=>X({report(st){}}))},withProgress(X,he){return dn.withProgress(Re,X,he)},createOutputChannel(X){return At.createOutputChannel(X)},createWebviewPanel(X,he,Ie,st){return tn.createWebviewPanel(Re,X,he,Ie,st)},createWebviewTextEditorInset(X,he,Ie,st){return z.checkProposedApiEnabled(Re),Xt.createWebviewEditorInset(X,he,Ie,st,Re)},createTerminal(X,he,Ie){return typeof X=="object"?"pty"in X?lt.createExtensionTerminal(X):(X.iconPath&&z.checkProposedApiEnabled(Re),lt.createTerminalFromOptions(X)):lt.createTerminal(X,he,Ie)},registerTerminalLinkProvider(X){return lt.registerLinkProvider(X)},registerTerminalProfileProvider(X,he){return lt.registerProfileProvider(X,he)},registerTreeDataProvider(X,he){return cn.registerTreeDataProvider(X,he,Re)},createTreeView(X,he){return cn.createTreeView(X,he,Re)},registerWebviewPanelSerializer:(X,he)=>tn.registerWebviewPanelSerializer(Re,X,he),registerCustomEditorProvider:(X,he,Ie={})=>_n.registerCustomEditorProvider(Re,X,he,Ie),registerFileDecorationProvider(X){return it.registerFileDecorationProvider(X,Re.identifier)},registerUriHandler(X){return Rt.registerUriHandler(Re.identifier,X)},createQuickPick(){return Lt.createQuickPick(Re.identifier,!!Re.enableProposedApi)},createInputBox(){return Lt.createInputBox(Re.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(X,he,Ie){return hn.onDidChangeActiveColorTheme(X,he,Ie)},registerWebviewViewProvider(X,he,Ie){return En.registerWebviewViewProvider(Re,X,he,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return z.checkProposedApiEnabled(Re),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeActiveNotebookEditor(X,he,Ie)},get visibleNotebookEditors(){return z.checkProposedApiEnabled(Re),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return z.checkProposedApiEnabled(Re),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeNotebookEditorSelection(X,he,Ie)},onDidChangeNotebookEditorVisibleRanges(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeNotebookEditorVisibleRanges(X,he,Ie)},showNotebookDocument(X,he){return z.checkProposedApiEnabled(Re),pt.showNotebookDocument(X,he)},registerExternalUriOpener(X,he,Ie){return z.checkProposedApiEnabled(Re),jt.registerExternalUriOpener(Re.identifier,X,he,Ie)},get openEditors(){return z.checkProposedApiEnabled(Re),ut.tabs},get onDidChangeOpenEditors(){return z.checkProposedApiEnabled(Re),ut.onDidChangeTabs},getInlineCompletionItemController(X){return z.checkProposedApiEnabled(Re),v.InlineCompletionController.get(X)}},gn={get rootPath(){return Ze.report("workspace.rootPath",Re,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(X){throw T.readonly()},getWorkspaceFolder(X){return ot.getWorkspaceFolder(X)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(X){throw T.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(X){throw T.readonly()},updateWorkspaceFolders:(X,he,...Ie)=>ot.updateWorkspaceFolders(Re,X,he||0,...Ie),onDidChangeWorkspaceFolders:function(X,he,Ie){return ot.onDidChangeWorkspace(X,he,Ie)},asRelativePath:(X,he)=>ot.getRelativePath(X,he),findFiles:(X,he,Ie,st)=>ot.findFiles(J.GlobPattern.from(X),J.GlobPattern.from(he),Ie,Re.identifier,st),findTextInFiles:(X,he,Ie,st)=>{let bt,Et;return typeof he=="object"?(bt=he,Et=Ie):(bt={},Et=he,st=Ie),ot.findTextInFiles(X,bt||{},Et,Re.identifier,st)},saveAll:X=>ot.saveAll(X),applyEdit(X){return Sn.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,he,Ie,st)=>Mt.createFileSystemWatcher(J.GlobPattern.from(X),he,Ie,st),get textDocuments(){return yt.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw T.readonly()},openTextDocument(X){let he;const Ie=X;if(typeof X=="string")he=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))he=Promise.resolve(X);else if(!Ie||typeof Ie=="object")he=yt.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>yt.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(X,he,Ie)=>yt.onDidAddDocument(X,he,Ie),onDidCloseTextDocument:(X,he,Ie)=>yt.onDidRemoveDocument(X,he,Ie),onDidChangeTextDocument:(X,he,Ie)=>yt.onDidChangeDocument(X,he,Ie),onDidSaveTextDocument:(X,he,Ie)=>yt.onDidSaveDocument(X,he,Ie),onWillSaveTextDocument:(X,he,Ie)=>Qt.getOnWillSaveTextDocumentEvent(Re)(X,he,Ie),onDidChangeConfiguration:(X,he,Ie)=>It.onDidChangeConfiguration(X,he,Ie),getConfiguration(X,he){return he=arguments.length===1?void 0:he,It.getConfiguration(X,he,Re)},registerTextDocumentContentProvider(X,he){return Gt.registerTextDocumentContentProvider(X,he)},registerTaskProvider:(X,he)=>(Ze.report("window.registerTaskProvider",Re,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Re,X,he)),registerFileSystemProvider(X,he,Ie){return Zt.registerFileSystemProvider(Re.identifier,X,he,Ie,Re.enableProposedApi)},get fs(){return tt.value},registerFileSearchProvider:(X,he)=>(z.checkProposedApiEnabled(Re),Pt.registerFileSearchProvider(X,he)),registerTextSearchProvider:(X,he)=>(z.checkProposedApiEnabled(Re),Pt.registerTextSearchProvider(X,he)),registerRemoteAuthorityResolver:(X,he)=>(z.checkProposedApiEnabled(Re),Je.registerRemoteAuthorityResolver(X,he)),registerResourceLabelFormatter:X=>(z.checkProposedApiEnabled(Re),wn.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,he,Ie)=>Mt.onDidCreateFile(X,he,Ie),onDidDeleteFiles:(X,he,Ie)=>Mt.onDidDeleteFile(X,he,Ie),onDidRenameFiles:(X,he,Ie)=>Mt.onDidRenameFile(X,he,Ie),onWillCreateFiles:(X,he,Ie)=>Mt.getOnWillCreateFileEvent(Re)(X,he,Ie),onWillDeleteFiles:(X,he,Ie)=>Mt.getOnWillDeleteFileEvent(Re)(X,he,Ie),onWillRenameFiles:(X,he,Ie)=>Mt.getOnWillRenameFileEvent(Re)(X,he,Ie),openTunnel:X=>(z.checkProposedApiEnabled(Re),Pe.openTunnel(Re,X).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return z.checkProposedApiEnabled(Re),Pe.getTunnels()},onDidChangeTunnels:(X,he,Ie)=>(z.checkProposedApiEnabled(Re),Pe.onDidChangeTunnels(X,he,Ie)),registerPortAttributesProvider:(X,he)=>(z.checkProposedApiEnabled(Re),Pe.registerPortsAttributesProvider(X,he)),registerTimelineProvider:(X,he)=>(z.checkProposedApiEnabled(Re),en.registerTimelineProvider(X,he,Re.identifier,ht.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:X=>(z.checkProposedApiEnabled(Re),ot.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,he,Ie)=>ot.onDidGrantWorkspaceTrust(X,he,Ie)},Pn={get inputBox(){return Ze.report("scm.inputBox",Re,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Re)},createSourceControl(X,he,Ie){return Vt.createSourceControl(Re,X,he,Ie)}},An={createCommentController(X,he){return bn.createCommentController(Re,X,he)}},Tn={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(X,he,Ie){return mt.onDidStartDebugSession(X,he,Ie)},onDidTerminateDebugSession(X,he,Ie){return mt.onDidTerminateDebugSession(X,he,Ie)},onDidChangeActiveDebugSession(X,he,Ie){return mt.onDidChangeActiveDebugSession(X,he,Ie)},onDidReceiveDebugSessionCustomEvent(X,he,Ie){return mt.onDidReceiveDebugSessionCustomEvent(X,he,Ie)},onDidChangeBreakpoints(X,he,Ie){return mt.onDidChangeBreakpoints(X,he,Ie)},registerDebugConfigurationProvider(X,he,Ie){return mt.registerDebugConfigurationProvider(X,he,Ie||R.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,he){return mt.registerDebugAdapterDescriptorFactory(Re,X,he)},registerDebugAdapterTrackerFactory(X,he){return mt.registerDebugAdapterTrackerFactory(X,he)},startDebugging(X,he,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?mt.startDebugging(X,he,{parentSession:Ie}):mt.startDebugging(X,he,Ie||{})},stopDebugging(X){return mt.stopDebugging(X)},addBreakpoints(X){return mt.addBreakpoints(X)},removeBreakpoints(X){return mt.removeBreakpoints(X)},asDebugSourceUri(X,he){return mt.asDebugSourceUri(X,he)}},Rn={registerTaskProvider:(X,he)=>Ct.registerTaskProvider(Re,X,he),fetchTasks:X=>Ct.fetchTasks(X),executeTask:X=>Ct.executeTask(Re,X),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(X,he,Ie)=>Ct.onDidStartTask(X,he,Ie),onDidEndTask:(X,he,Ie)=>Ct.onDidEndTask(X,he,Ie),onDidStartTaskProcess:(X,he,Ie)=>Ct.onDidStartTaskProcess(X,he,Ie),onDidEndTaskProcess:(X,he,Ie)=>Ct.onDidEndTaskProcess(X,he,Ie)},pn={get notebookDocuments(){return pt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,he){let Ie;if(k.URI.isUri(X))Ie=X,await pt.openNotebookDocument(X);else if(typeof X=="string")Ie=k.URI.revive(await pt.createNotebookDocument({viewType:X,content:he}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(X,he,Ie,st){return pt.registerNotebookSerializer(Re,X,he,Ie,Re.enableProposedApi?st:void 0)},createNotebookController(X,he,Ie,st,bt){return Yt.createNotebookController(Re,X,he,Ie,st,Re.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,he)=>pt.registerNotebookCellStatusBarItemProvider(Re,X,he),get onDidSaveNotebookDocument(){return z.checkProposedApiEnabled(Re),pt.onDidSaveNotebookDocument},registerNotebookContentProvider:(X,he,Ie,st)=>(z.checkProposedApiEnabled(Re),pt.registerNotebookContentProvider(Re,X,he,Ie,Re.enableProposedApi?st:void 0)),createNotebookEditorDecorationType(X){return z.checkProposedApiEnabled(Re),pt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return z.checkProposedApiEnabled(Re),Jt.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeNotebookDocumentMetadata(X,he,Ie)},onDidChangeNotebookCells(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeNotebookCells(X,he,Ie)},onDidChangeNotebookCellExecutionState(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeNotebookCellExecutionState(X,he,Ie)},onDidChangeCellOutputs(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeCellOutputs(X,he,Ie)},onDidChangeCellMetadata(X,he,Ie){return z.checkProposedApiEnabled(Re),pt.onDidChangeCellMetadata(X,he,Ie)},createConcatTextDocument(X,he){return z.checkProposedApiEnabled(Re),new We.ExtHostNotebookConcatDocument(pt,yt,X,he)}};return{version:qe.version,authentication:Dn,commands:Cn,comments:An,debug:Tn,env:fn,extensions:kn,languages:In,notebooks:pn,notebook:pn,scm:Pn,tasks:Rn,test:on,window:an,workspace:gn,Breakpoint:R.Breakpoint,CallHierarchyIncomingCall:R.CallHierarchyIncomingCall,CallHierarchyItem:R.CallHierarchyItem,CallHierarchyOutgoingCall:R.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:R.CodeAction,CodeActionKind:R.CodeActionKind,CodeActionTriggerKind:R.CodeActionTriggerKind,CodeLens:R.CodeLens,Color:R.Color,ColorInformation:R.ColorInformation,ColorPresentation:R.ColorPresentation,ColorThemeKind:R.ColorThemeKind,CommentMode:R.CommentMode,CommentThreadCollapsibleState:R.CommentThreadCollapsibleState,CompletionItem:R.CompletionItem,CompletionItemKind:R.CompletionItemKind,CompletionItemTag:R.CompletionItemTag,CompletionList:R.CompletionList,CompletionTriggerKind:R.CompletionTriggerKind,ConfigurationTarget:R.ConfigurationTarget,CustomExecution:R.CustomExecution,DebugAdapterExecutable:R.DebugAdapterExecutable,DebugAdapterInlineImplementation:R.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:R.DebugAdapterNamedPipeServer,DebugAdapterServer:R.DebugAdapterServer,DebugConfigurationProviderTriggerKind:R.DebugConfigurationProviderTriggerKind,DebugConsoleMode:R.DebugConsoleMode,DecorationRangeBehavior:R.DecorationRangeBehavior,Diagnostic:R.Diagnostic,DiagnosticRelatedInformation:R.DiagnosticRelatedInformation,DiagnosticSeverity:R.DiagnosticSeverity,DiagnosticTag:R.DiagnosticTag,Disposable:R.Disposable,DocumentHighlight:R.DocumentHighlight,DocumentHighlightKind:R.DocumentHighlightKind,DocumentLink:R.DocumentLink,DocumentSymbol:R.DocumentSymbol,EndOfLine:R.EndOfLine,EnvironmentVariableMutatorType:R.EnvironmentVariableMutatorType,EvaluatableExpression:R.EvaluatableExpression,InlineValueText:R.InlineValueText,InlineValueVariableLookup:R.InlineValueVariableLookup,InlineValueEvaluatableExpression:R.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:R.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:R.ExtensionKind,ExtensionMode:R.ExtensionMode,ExternalUriOpenerPriority:R.ExternalUriOpenerPriority,FileChangeType:R.FileChangeType,FileDecoration:R.FileDecoration,FileSystemError:R.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:R.FoldingRange,FoldingRangeKind:R.FoldingRangeKind,FunctionBreakpoint:R.FunctionBreakpoint,InlineCompletionItem:R.InlineSuggestion,InlineCompletionList:R.InlineSuggestions,Hover:R.Hover,IndentAction:I.IndentAction,Location:R.Location,MarkdownString:R.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:R.ParameterInformation,PortAutoForwardAction:R.PortAutoForwardAction,Position:R.Position,ProcessExecution:R.ProcessExecution,ProgressLocation:R.ProgressLocation,QuickInputButtons:R.QuickInputButtons,Range:R.Range,RelativePattern:R.RelativePattern,Selection:R.Selection,SelectionRange:R.SelectionRange,SemanticTokens:R.SemanticTokens,SemanticTokensBuilder:R.SemanticTokensBuilder,SemanticTokensEdit:R.SemanticTokensEdit,SemanticTokensEdits:R.SemanticTokensEdits,SemanticTokensLegend:R.SemanticTokensLegend,ShellExecution:R.ShellExecution,ShellQuoting:R.ShellQuoting,SignatureHelp:R.SignatureHelp,SignatureHelpTriggerKind:R.SignatureHelpTriggerKind,SignatureInformation:R.SignatureInformation,SnippetString:R.SnippetString,SourceBreakpoint:R.SourceBreakpoint,StandardTokenType:R.StandardTokenType,StatusBarAlignment:R.StatusBarAlignment,SymbolInformation:R.SymbolInformation,SymbolKind:R.SymbolKind,SymbolTag:R.SymbolTag,Task:R.Task,TaskGroup:R.TaskGroup,TaskPanelKind:R.TaskPanelKind,TaskRevealKind:R.TaskRevealKind,TaskScope:R.TaskScope,TextDocumentSaveReason:R.TextDocumentSaveReason,TextEdit:R.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:R.TextEditorLineNumbersStyle,TextEditorRevealType:R.TextEditorRevealType,TextEditorSelectionChangeKind:R.TextEditorSelectionChangeKind,ThemeColor:R.ThemeColor,ThemeIcon:R.ThemeIcon,TreeItem:R.TreeItem,TreeItemCollapsibleState:R.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:R.ViewColumn,WorkspaceEdit:R.WorkspaceEdit,InlayHint:R.InlayHint,InlayHintKind:R.InlayHintKind,RemoteAuthorityResolverError:R.RemoteAuthorityResolverError,ResolvedAuthority:R.ResolvedAuthority,SourceControlInputBoxValidationType:R.SourceControlInputBoxValidationType,ExtensionRuntime:R.ExtensionRuntime,TimelineItem:R.TimelineItem,NotebookRange:R.NotebookRange,NotebookCellKind:R.NotebookCellKind,NotebookCellExecutionState:R.NotebookCellExecutionState,NotebookDocumentMetadata:R.NotebookDocumentMetadata,NotebookCellMetadata:R.NotebookCellMetadata,NotebookCellData:R.NotebookCellData,NotebookData:R.NotebookData,NotebookRendererScript:R.NotebookRendererScript,NotebookCellStatusBarAlignment:R.NotebookCellStatusBarAlignment,NotebookEditorRevealType:R.NotebookEditorRevealType,NotebookCellOutput:R.NotebookCellOutput,NotebookCellOutputItem:R.NotebookCellOutputItem,NotebookCellStatusBarItem:R.NotebookCellStatusBarItem,NotebookControllerAffinity:R.NotebookControllerAffinity,PortAttributes:R.PortAttributes,LinkedEditingRanges:R.LinkedEditingRanges,TestItemStatus:R.TestItemStatus,TestResultState:R.TestResultState,TestMessage:R.TestMessage,TextSearchCompleteMessageType:Y.TextSearchCompleteMessageType,TestMessageSeverity:R.TestMessageSeverity,WorkspaceTrustState:R.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ne}),define(we[215],_e([0,1,57,99,30,98,32,71,36,37,102,103,104,74,73,66,70,100,72,44,69,92,64]),function(Z,e,g,T,D,E,k,y,_,I,i,P,o,h,d,u,w,p,S,c,m,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),g.registerSingleton(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),g.registerSingleton(y.IExtHostCommands,y.ExtHostCommands),g.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),g.registerSingleton(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),g.registerSingleton(P.IExtHostDebugService,P.WorkerExtHostDebugService),g.registerSingleton(E.IExtHostDecorations,E.ExtHostDecorations),g.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),g.registerSingleton(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),g.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),g.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),g.registerSingleton(d.IExtHostStorage,d.ExtHostStorage),g.registerSingleton(i.IExtHostTask,i.WorkerExtHostTask),g.registerSingleton(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),g.registerSingleton(u.IExtHostTunnelService,u.ExtHostTunnelService),g.registerSingleton(p.IExtHostWindow,p.ExtHostWindow),g.registerSingleton(D.IExtHostWorkspace,D.ExtHostWorkspace),g.registerSingleton(m.IExtHostSecretState,m.ExtHostSecretState),g.registerSingleton(f.IExtHostTelemetry,f.ExtHostTelemetry),g.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(we[216],_e([0,1,214,33,210,6,11,4]),function(Z,e,g,T,D,E,k,y){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(d){var u;const w=(u=self.trustedTypes)===null||u===void 0?void 0:u.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...c)=>{c.forEach(n=>{var r;if(!((r=self.trustedTypes)===null||r===void 0?void 0:r.isScript(n)))throw new Error("TrustedScripts only, please")});const m=c.slice(0,-1).join(","),f=c.pop().toString();return`(function anonymous(${m}) {
${f}
})`}});function p(...S){return w?self.eval(w.createScript("",...S)):new Function(...S)}d.create=p})(I||(I={}));class i extends D.RequireInterceptor{_installInterceptor(){}getModule(u,w){for(let p of this._alternatives){let S=p(u);if(S){u=S;break}}if(this._factories.has(u))return this._factories.get(u).load(u,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const u=this._extHostContext.getProxy(y.MainContext.MainThreadConsole);h(u,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(u){return u.browser}async _loadCommonJSModule(u,w,p){var S,c,m,f,t,n,r,s;w=w.with({path:o(w.path,".js")}),u&&performance.mark(`code/extHost/willFetchExtensionCode/${u.value}`);const l=await fetch(w.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u.value}`),l.status!==200)throw new Error(l.statusText);const v=await l.text(),b=`${w.toString(!0)}#vscode-extension`,A=`${v}
//# sourceURL=${b}`;let C;try{C=I.create((c=(S=P._ttpExtensionScripts)===null||S===void 0?void 0:S.createScript("module"))!==null&&c!==void 0?c:"module",(f=(m=P._ttpExtensionScripts)===null||m===void 0?void 0:m.createScript("exports"))!==null&&f!==void 0?f:"exports",(n=(t=P._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(r=P._ttpExtensionScripts)===null||r===void 0?void 0:r.createScript(A))!==null&&s!==void 0?s:A)}catch(W){throw console.error(u?`Loading code for extension ${u.value} failed: ${W.message}`:`Loading code failed: ${W.message}`),console.error(`${w.toString(!0)}${typeof W.line=="number"?` line ${W.line}`:""}${typeof W.column=="number"?` column ${W.column}`:""}`),console.error(W),W}const a={},F={exports:a},N=W=>{const ce=this._fakeModules.getModule(W,w);if(ce===void 0)throw new Error(`Cannot load module '${W}'`);return ce};try{return p.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u.value}`),C(F,a,N),F.exports!==a?F.exports:a}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u.value}`),p.codeLoadingStop()}}async $setRemoteEnvironment(u){throw new Error("Not supported")}async _waitForDebuggerAttachment(u=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+u;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=P,P._ttpExtensionScripts=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("ExtensionScripts",{createScript:d=>d});function o(d,u){return d.endsWith(u)?d:d+u}function h(d,u){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(c,m){const f=console[c];console[c]=function(){d.$logExtensionHostMessage({type:"__$console",severity:m,arguments:S(arguments)}),u&&f.apply(console,arguments)}}const p=1e5;function S(c){const m=[],f=[];if(c.length)for(let t=0;t<c.length;t++){if(typeof c[t]=="undefined")c[t]="undefined";else if(c[t]instanceof Error){const n=c[t];n.stack?c[t]=n.stack:c[t]=n.toString()}f.push(c[t])}try{const t=JSON.stringify(f,function(n,r){if(r&&typeof r=="object"){if(m.indexOf(r)!==-1)return"[Circular]";m.push(r)}return r});return t.length>p?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[217],_e([0,1,57,17,33,216,202]),function(Z,e,g,T,D,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(D.IExtHostExtensionService,E.ExtHostExtensionService),g.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(we[219],_e([0,1,23,3,172,211,204,13,75,215,217]),function(Z,e,g,T,D,E,k,y,_){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const P=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=(I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy("extensionHostWorker",{createScriptURL:S=>S}),p=self.Worker;Worker=function(S,c){const m=`importScripts('${S}');`;c=c||{},c.name=c.name||y.basename(S.toString());const f=new Blob([m],{type:"application/javascript"}),t=URL.createObjectURL(f);return new p(w?w.createScriptURL(t):t,c)}}else self.Worker=class extends k.NestedWorker{constructor(w,p){super(P,w,Object.assign({name:y.basename(w.toString())},p))}};const o=new class{exit(w){i()}async exists(w){return!0}async realpath(w){return w}};class h{constructor(){const p=new MessageChannel,S=new T.Emitter;let c=!1;P(p.port2,[p.port2]),p.port1.onmessage=m=>{const{data:f}=m;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=g.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if(D.isMessageOfType(t,2)){c=!0,u("received terminate message from renderer");return}S.fire(t)},this.protocol={onMessage:S.event,send:m=>{if(!c){const f=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);p.port1.postMessage(f,[f])}}}}}function d(w){return new Promise(p=>{const S=w.onMessage(c=>{S.dispose();const m=JSON.parse(c.toString());w.send(D.createMessageOfType(0)),p({protocol:w,initData:m})});w.send(D.createMessageOfType(1))})}let u=w=>i();(function(){const p=new h;_.mark("code/extHost/willConnectToRenderer"),d(p.protocol).then(S=>{_.mark("code/extHost/didWaitForInitData");const c=new E.ExtensionHostMain(S.protocol,S.initData,o,null);u=m=>c.terminate(m)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1e446dfadf588ec28b3fdba7ac083bfa1d45df3c/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
